<?php
/**
 * Popup menu from edit pencil
 *
 * Most menus from edit pencil are generated by this file: setting genera,
 * edit text etc. For altering the menu see {@link  html::menubar()}.
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @package chirokey_adults
 * @subpackage program
 */
/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
$currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/session.inc.php');
include($currentServerPath.'structure/functions.php');
include($currentServerPath.'structure/classes/filemanage.php');
include($currentServerPath.'structure/classes/tools.php');
include($currentServerPath.'structure/classes/sql.php');
include($currentServerPath.'structure/config.php');
header('content-type: text/html; charset=utf-8');
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
// header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header ("Pragma: no-cache"); // HTTP/1.0

/**
 * for content
 *
 * @global string $content
 */
$content = '';

/**
 * for menus
 *
 * @global string $menu
 */
$menu = '';

/**
 * for header
 *
 * @global string $headerinput
 */
$headerinput ='';

/**
 * some messages
 *
 * @global string $message
 */
$message ='';

/**
 * form elements
 *
 * @global string $inputelement
 */
$inputelement = '';

/**
 * form action
 *
 * @global string $onsubmit
 */
$onsubmit = '';
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>
  <?php
  if(!empty($_POST) && isset($_GET['section'])){
    # check section level
    if(!preg_match("/^([=]+[^=]+[=]+)/m", htmlentities($_POST['textarea'],ENT_NOQUOTES,'UTF-8'))){
        --$_GET['section']; # substract 1
        $isSectionDeleted = true;
      if($_GET['section'] > 0){
        $_SERVER['REQUEST_URI'] = preg_replace("#section=[1-9]*#", "section=".$_GET['section'] ,$_SERVER['REQUEST_URI']);
      } else {
        $isSectionDeleted = true;
        $_SERVER['REQUEST_URI'] = preg_replace("#&section=[1-9]*#", "" ,$_SERVER['REQUEST_URI']);
      }
    }# end check section level
    else
      $isSectionDeleted = false;
  }# end isset POST
  # @annotation cases title
    switch ($_GET['edit']) {
      case 'specimen':
        echo "Browse for ".$_GET['edit']."s (adults) ...";
      break; # end GET[edit] 'specimen'
      default:
        echo $_GET['genus'].": ".(($_GET['section'] > 0)?" sectionwise " :"")." editing ".$_GET['edit'].(($_GET['section'] > 0) ?" (section ".$_GET['section'].")" :"");
    }// end switch title
  ?>
  </title>
  <link rel="stylesheet" type="text/css" href="../structure/css/basic.css">
  <link rel='shortcut icon' href='structure/img/favicon.ico'>
  <script type='text/javascript' src='../structure/js/functions.js'></script>
  <script type='text/javascript' src='../structure/js/overlib.js'></script>
  <?
  switch($_GET['edit']){
    case 'ecology':
    case 'notes':
    echo "\n<script type=\"text/javascript\">
        var tableFeatures = {
        // features table sorting or filtering
          'sort' : 'none',  // none auto
          'filter' : 'none', // none auto manual
          'image' : 'none' // none auto manual [i.e. 90°]
        }
        </script>\n";
    }
  ?>
</head>
<body class="popup"  onload="javascript:self.focus();">
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
<!--  page content  -->
<div class="content">
<?php
//  print_r($_GET);
//  print_r($_POST);
$objMysql = new db_mysql;//class db_mysql
$objHtml  = new html;    //class html

# @annotation: save/update (POST)
if(isset($_POST))
  foreach ($_POST as $key => $value) {
    switch ($key) {
    # @annotation save/update notesOrEcology (= from notes & ecology)
      case 'notesOrEcology':
    # @annotation ____ notesOrEcology (sectionwise)
        if(isset($_GET['section'])){
          switch ($_GET['show']) {
            case "specimen":
              $result = $objMysql->queryObjectArray($MysqlSelect['SpecimenCharactersSingle']);
              break;
            default:
              $result = $objMysql->queryObjectArray($MysqlSelect['GenusCharacters']);
          }// end switch $_GET['show']
          foreach($result as $value){
            $savetextBefore.= $_GET['edit']=='notes'? $value->notes : '';
            $savetextBefore.= $_GET['edit']=='ecology'? $value->ecology : '';
          }
        # mark sections and split
          $savetextBefore=preg_replace("/^([=]+[^=]+[=]+)/m", "###section mark###\\1", $savetextBefore);
          $arrSavetextBefore = preg_split("/^###section mark###/m", $savetextBefore);
          foreach($arrSavetextBefore as $key => $value){
            # take care of $_GET['section'] value
            if($isSectionDeleted)
              $savetext.= $key==$_GET['section']+1? htmlentities($_POST['textarea'],ENT_NOQUOTES,'UTF-8') : $value; /* no need for htmlentities($value) here causes damage*/
            else
              $savetext.= $key==$_GET['section']? htmlentities($_POST['textarea'],ENT_NOQUOTES,'UTF-8') : $value; /* no need for htmlentities($value) here causes damage*/
          }# run through splitted content array
        # delete variables
          unset($arrSavetextBefore,$savetextBefore);
        }# end sectionwise editing
        else{ # entire notesOrEcology
          $savetext=htmlentities($_POST['textarea'],ENT_NOQUOTES,'UTF-8');
        }
        # add an empty last line (D: recognise dollar at the very end of string)
        $savetext=preg_match("#[\\n\\r]$#D",$savetext)?$savetext:$savetext."\n";
        $objMysql->queryObjectArray("
        UPDATE `characters`
          SET `".$_GET['edit']."`='".addslashes($savetext)."'
          WHERE `id`=".$_GET['id_characters']." LIMIT 1 ;");
      break;// end notesOrEcology update (notes & ecology)
    # @annotation ____ similar (POST)
      case 'similar':
        if($result=$objMysql->queryObjectArray($MysqlSelect['GeneraValidIdDescPreg'])){
          foreach($result as  $value){
            $genera_names[] = $value->genus_name;
            $valid_id[]     = $value->valid_id;
          }
        }
        $search=$genera_names;
        array_push(
          $search,
          "/[a-z]/i",//  a-z and caseless
          "/\s+/",// multiple spaces
          "/^\s+/"// multiple spaces at line beginning
        );
        $replace=$valid_id;
        array_push(
          $replace,
          "",// a-z and caseless
          " ",// multiple spaces
          ""// multiple spaces at line beginning
        );
        // Smittia Pseudosmittia Antillocladius Eukiefferiella
        // Chaetocladius: Hydrobaenus Metriocnemus Thienemannia Paraphaenocladius Trissocladius
        $savetext=preg_replace( $search, $replace,$_POST['textarea']);
        $objMysql->queryObjectArray("UPDATE `characters` SET `similar` = '".$savetext."' WHERE `names_valid_id` = ".$_GET['genus_valid_id']." LIMIT 1;");
      break;// end similar
    # @annotation ____ subfamily: update DB
      case 'subfamily':
        $sql_add = $_POST['whole_genus']==1 ? "" : "AND `names_valid`.`species_name_id` = 192 ";
        $objMysql->queryObjectArray("UPDATE `names_valid`
        SET  `names_valid`.`subfamily_name_id` = ".$_POST['subfamily_id']."
        WHERE `names_valid`.`genus_name_id` = ".$_POST['genus_valid_id']." ".$sql_add.";");
        // some message text
        $message = $_POST['whole_genus']==1 ? "Note: Only entey for  <em>".$_GET['genus']."</em> sp. was updated!<br>\n" :"Note: The whole genus <em>".$_GET['genus']."</em> with all entries in table 'names_valid' was updated!<br>\n";
        $message = info_start($title="Info", 'info').$message.info_end();
      break;
    }// end switch
  }// end foreach $_POST key

# @annotation cases in $_GET['edit'] (HTML)
switch ($_GET['edit']) {
# @annotation ____ notes || ecology: (fetch data)
  case 'notes':
  case 'ecology':
    switch ($_GET['show']) {
      case "specimen": $result=$objMysql->queryObjectArray($MysqlSelect['SpecimenCharactersSingle']);#{
        break;
      default: $result=$objMysql->queryObjectArray($MysqlSelect['GenusCharacters']);
    }// end switch $_GET['show']
    foreach($result as $value){
      $contenttxt.= $_GET['edit']=='notes'? $value->notes : '';
      $contenttxt.= $_GET['edit']=='ecology'? $value->ecology : '';
    }
    if($_GET['section'] > 0){
      $contenttxt=preg_replace("/^([=]+[^=]+[=]+)/m", "###section mark###\\1", $contenttxt);
      $arrContent = preg_split("/^###section mark###/m", $contenttxt);
      //$contenttxt=preg_replace("/^\§\\$\%\&/m", "", $contenttxt);
      $contenttxt = $arrContent[$_GET['section']];
      #print_pre($arrContent);
    }
  # @annotation ____ notes || ecology: query for genera
    if($result=$objMysql->queryObjectArray($MysqlSelect['GeneraValidId'])){
      foreach($result as $value)
        $generaMenu[$value->valid_id]=$value->genus_name;
      $default=array("" => "-- select genus -- ");
      $generaMenu= $default + $generaMenu;
    }
  # @annotation ____ notes || ecology: query for References
    if($result=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
    foreach($result as $value)
        $referenceMenu[$value->id]=$value->authors_short;
      $default=array("" => "-- select reference -- ");
      $referenceMenu= $default + $referenceMenu;
    }
    if($result=$objMysql->queryObjectArray($MysqlSelect['ReferencesCompleteString'])){
    echo "<script type='text/javascript' >
    // references for citation
      var references = new Array();
    ";
    $search = array('#"([^"]+)"#','#"#',"#'#");
    $replace = array("«\\1»","&#034;", "&#180;");
    foreach($result as $value){
        echo "       references[".$value->id."] = \"".preg_replace($search, $replace, $value->reference)."\";\n";
      }
    echo "</script>";
    }

  #  @annotation ____ notes || ecology: query for Images
    if($result=$objMysql->queryObjectArray($MysqlSelect['SpeciesImages'])){
      foreach($result as $value){
        $imageMenu     [$value->imagefile]      = $value->species;
        $imageMenuShort[$value->imagefileshort] = $value->species;
      }
      $default=array("" => "-- select long image string -- ");
      $imageMenu= $default + $imageMenu;
      $default=array("" => "-- select short image string -- ");
      $imageMenuShort= $default + $imageMenuShort;
    }// end query images
  #  @annotation ____ notes || ecology: fetch Templates
    include($currentServerPath.'structure/templates.php');
      foreach($templates as $key => $value){
        if(!preg_match("/^internal:/",$key))
        $templateMenu     ["Template:".$key]      = "Template:".$key;
      }
      $default=array("" => "-- select a template -- ");
      $templateMenu= $default + $templateMenu;
  #  @annotation ____ notes || ecology: compose <form> elements
  # genera
    $selection.=$objHtml->select($generaMenu,"genus_valid_id","-- select genus -- ","style=\"margin:0px;border:0px;\" onchange=\"javascript:insert(this.options[selectedIndex].text,'','".$_GET['edit']."','textarea');\" title=\"select genus string\" ");
  # templates
    $selection.="".$objHtml->select($templateMenu,"templates","-- select a template -- ","style=\"margin:0px;border:0px;\" onchange=\"javascript:insert(this.options[selectedIndex].value,'','".$_GET['edit']."','textarea');\" title=\"select a template as a string (will be replaced; see file structure/templates.php)\" ");
  # references
//     $selection.=$objHtml->select($referenceMenu,"author_id","-- select reference -- ","style=\"margin:0px;border:0px;\" onchange=\"javascript:insert('{citeID|' + this.options[selectedIndex].value+'|'+this.options[selectedIndex].text+'}','','".$_GET['edit']."','textarea');alert('{nociteID|...|..}\\n  creates only a reference entry but no citation\\n{numciteID|...|..}\\n  creates a numeric citation\\n{citeyearID|...|..}\\n  cites only the year\\n{citeauthorID|...|..}\\n  cites only the abbreviated authors.\\n\\nNote that references are created from their ID and hence they might be not compatible with the other CHIP.');\" title=\"select reference\" ");
  # references
    $search = array("#[\n\r]#ms", "#'#", '#"#');
    $replace = array("", "\'", "\'");
    $referenceMenu = preg_replace($search, $replace, $objHtml->select($referenceMenu,"scrollReference","-- select reference -- "," onchange=\"javascript:putContentToID(references[this.options[selectedIndex].value], \&#034;referenceOutput\&#034;);\" title=\"select reference\" id=\"scrollReference\""));
    # references: overlib ;
    $selection.=" <button type=\"button\" onclick=\"return overlib('<form > ".$referenceMenu."<div style=\'text-align:right;\'> <input type=\'button\' value=\'insert\' onclick=\'javascript:insert(parseCiteToSyntax(\&#034;cite\&#034;, \&#034;scrollReference\&#034;),\&#034;\&#034;, \&#034;".$_GET['edit']."\&#034;, \&#034;textarea\&#034;);\'></div>  <input type=\'radio\' checked value=\'textcite\' id=\'textcite\' name=\'cite\'>author (date)<br> <input type=\'radio\'  value=\'cite\' id=\'cite\' name=\'cite\'>author date<br> <input type=\'radio\' value=\'citeauthor\' id=\'cite\' name=\'cite\'>author<br><input type=\'radio\'  id=\'cite\' name=\'cite\' value=\'citeyear\'> year <br><input type=\'radio\' id=\'cite\'  name=\'cite\' value=\'citenum\'> numeric (ID) <div id=\'referenceOutput\' style=\'text-align:left;\'>&nbsp;</div> </form>',BELOW, STICKY , CAPTION, 'Insert a reference' );\" onmouseout=\"return nd();\">Insert references &nbsp;<img src=\"../structure/img/book.png\" width=20 height=20 border=0  style='vertical-align : middle;'></button>";
  # images short
    $selection.="<br>".$objHtml->select($imageMenuShort,"imagefile","-- select short image string -- ","style=\"margin:0px;border:0px;\" onchange=\"javascript:insert(this.options[selectedIndex].value,'','".$_GET['edit']."','textarea');\" title=\"select short image string\" ");
  # images long
    $selection.=" ".$objHtml->select($imageMenu,"imagefile","-- select long image string -- ","style=\"margin:0px;border:0px;\" onchange=\"javascript:insert(this.options[selectedIndex].value,'','".$_GET['edit']."','textarea');\" title=\"select long image string\" ");
  #  @annotation ____ notes || ecology: Edit ...
    $headerinput="<h3>Edit ".(($_GET['section'] > 0)?" sectionwise " :" whole ").$_GET['edit'].(($_GET['section'] > 0)?" (section ".$_GET['section'].")" :"")." for adults of <em>".$_GET['genus']."</em> </h3>".(($_GET['section'] > 0)?" <div class='info' style='font-size:smaller;'>Sectionwise editing edits only ONE section until the next (subsub)section. Note that deleting a section causes to get another section, and inserting a section causes to disappear sections left. But no information should get lost.</div>" :"");
    $headerinput.=$selection;

  #  @annotation ____ notes || ecology: hidden <form> elements
    $hiddenElements="\n<input type='hidden' value='1' name='notesOrEcology'>";
    $hiddenElements.=isset($_GET['section'])? "\n<input type='hidden' value='".$_GET['section']."' name='section'>" : "";
  #  @annotation ____ notes || ecology: textarea
    $wrap= $_POST['wrap']=='off' ? 'off' : 'on';
    # add an empty last line (D: recognise dollar at the very end of string)
    $contenttxt=preg_match("#[\\n\\r]$#D",$contenttxt)?$contenttxt:$contenttxt."\n";
    $inputelement="\n<textarea tabindex='1' style='width:".$config['popup']['TextareaWidth']."px; height:".$config['popup']['TextareaHeight']."px;' name='textarea' wrap='".$wrap."'>$contenttxt</textarea>\n";
  #  @annotation ____ notes || ecology: menus
    $menu =$objHtml->menubar($_GET['edit'],'sections');
    $menu.=$objHtml->menubar($_GET['edit'],'font');
    $menu.=$objHtml->menubar($_GET['edit'],'tools');
    $menu.=$objHtml->menubar($_GET['edit'],'table');
    $menu.=$objHtml->menubar($_GET['edit'],'list');
    $menu.=$objHtml->menubar($_GET['edit'],'timestamp');
    $menu.=$objHtml->menubar($_GET['edit'],'image');
    $menu.=$objHtml->menubar($_GET['edit'],'openlayermap');
    $menu.=$objHtml->menubar($_GET['edit'],'wrapmodus','soft wrapping');
    $menu.=$objHtml->menubar($_GET['edit'],'languages');
# @annotation ____ notes || ecology: cases $_POST['language']
  $_POST['language'] = isset($_POST['language']) ? $_POST['language'] : $config['languages']['default'];
    $languageCharacters = split(" +",$config['languages'][$_POST['language']]);
    foreach ($languageCharacters as $key => $character) {
      if($key==0) unset($languageCharacters);
      $languageCharacters['lower'].= "\n <a href=\"javascript:void(0);\" title=\"insert character: ".$character."\" onclick=\"insert('".$character."','','".$_GET['edit']."','textarea')\">".$character."</a>&nbsp; ";
      $languageCharacters['upper'].= strcasecmp(mb_strtoupper($character,UTF8), $character)? "\n <a href=\"javascript:void(0);\" title=\"insert character: ".mb_strtoupper($character,UTF8)."\" onclick=\"insert('".mb_strtoupper($character,UTF8)."','','".$_GET['edit']."','textarea')\">".mb_strtoupper($character,UTF8)."</a>&nbsp; " : "";
    }// end foreach

    $notes="\n<div style=\"max-width:".$config['popup']['TextareaWidth']."px;\">".$languageCharacters['lower']."<br>".$languageCharacters['upper']."\n</div>";
    $notes.="Note: syntax should be like <a class='external' href='http://en.wikipedia.org/wiki/index.php/Main_Page' target='_blank'>Wikipedia's</a>'s. Use icons to edit or see <a target='chirokey_adults' href='../doc/readme.html#Special_syntax_in_textarea_fields' >documentation</a>";
  break;
# @annotation case 'similar'
  case 'similar':
    if($resultsub=$objMysql->queryObjectArray($MysqlSelect['GeneraValidId'])){
      foreach($resultsub as $value)
        $generaMenu[$value->valid_id]=$value->genus_name;
      $default=array("" => "-- select genus -- ");
      $generaMenu= $default + $generaMenu;
    }
    #  @annotation ____ similar: replace valid id's to genera
    if($result=$objMysql->queryObjectArray($MysqlSelect['GenusCharacters'])){
      foreach($result as $value){
        if($resultsub=$objMysql->queryObjectArray($MysqlSelect['GeneraValidIdDesc'])){
          foreach($resultsub as $gen)
            $replacetext[$gen->valid_id]=$gen->genus_name;
        }
      $contenttxt = $objHtml->emphase($value->similar,$replacetext,"idtogenustext");
      }
    }
  #  @annotation ____ similar: genera selection, form elements
    $selection=$objHtml->select($generaMenu,"genus_valid_id","-- select genus -- ","style=\"margin:0px;border:0px;\" onchange=\"javascript:textarea.value+=' '+ this.options[selectedIndex].text;\"");
    $hiddenElements="\n<input type='hidden' value='1' name='similar'>\n";
    $inputelement="\n<textarea cols='55' rows='18' name='textarea' wrap='on'>$contenttxt</textarea>\n";
    $headerinput="<h3>Add similar genera to <em>".$_GET['genus']."</em> </h3>";
    $headerinput.=$selection;
  break; # end GET[edit] 'similar'
# @annotation case 'subfamily'
  case 'subfamily':
    if($result=$objMysql->queryObjectArray($MysqlSelect['SubfamilyNames'])){
      foreach($result as $value)
        $subfamilyMenu[$value->id]=$value->name;
    }
    if($resultsub=$objMysql->querySingleItem($MysqlSelect['SubfamilyToGenus']))

  #  @annotation ____ subfamily: selection, form elements
    $default = array("" => "-- select subfamily -- ");
    $subfamilyMenu = $default + $subfamilyMenu;
    $inputelement = $objHtml->select($subfamilyMenu,"subfamily_id",$resultsub);
    $headerinput="\n<h3>Edit ".$_GET['edit']." from <em>".$_GET['genus']."</em> </h3>";
    $hiddenElements="<input type='hidden' name='genus_valid_id' value='".$_GET['genus_valid_id']."'>\n<input type='hidden' name='subfamily' value='1'>\n";
    $notes = "Update whole genus?<br>\n"."no:<input type='radio' name='whole_genus' value=0 ><br>\n"."yes:<input type='radio'  checked=true name='whole_genus' value=1 >";
  break; # end GET[edit] 'subfamily'
# @annotation case 'specimen' (list for browse specimens)
  case 'specimen':
    if($result=$objMysql->queryObjectArray("
          SELECT STRAIGHT_JOIN
            `characters`.`id`
              AS 'id_characters',
            `names_valid`.`id`
              AS 'names_valid_id',
            CONCAT(
              `names_genera`.`name`, ' ',
                IFNULL(CONCAT('(', `names_subgenus`.`name`, ') '),''),  `names_species`.`name`
            )
              AS 'specimen',
            IFNULL(`names_subfamily`.`name`, 'no subfamily name given')
              AS 'subfamily',
            IFNULL(`names_authors`.`authors_short`, 'no special author')
              AS 'author',
            CONCAT(
              IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
              `tempb`.`authors_short`,
              IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
            )
              AS 'descriptor'
          FROM (
            (
              SELECT
                CONCAT(`authors_short`,`literal`) AS 'authors_short',
                `id`
                FROM `names_authors`
            ) AS `tempb`,
          `characters`
          )
          LEFT JOIN `names_authors`   ON `characters`.`names_authors_id`   = `names_authors`.`id`
          LEFT JOIN `names_valid`     ON `characters`.`names_valid_id`     = `names_valid`.`id`
          LEFT JOIN `names_genera`    ON `names_valid`.`genus_name_id`     = `names_genera`.`id`
          LEFT JOIN `names_species`   ON `names_valid`.`species_name_id`   = `names_species`.`id`
          LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id` = `names_subfamily`.`id`
          LEFT JOIN `names_subgenus`  ON `names_valid`.`subgenus_name_id`  = `names_subgenus`.`id`
          WHERE (
            `names_valid`.`species_name_id` != 192 AND
            `characters`.`names_valid_id` = `names_valid`.`id` AND
            `names_valid`.`descriptor_name_id` = `tempb`.`id`
          )
          ORDER BY CONCAT(`names_genera`.`name`, `names_species`.`name`) ASC;
      ")){
      $objHtml->doOptionGroup=TRUE;
      foreach($result as $value)
        $selectSpecimens["chirokey.php?id_characters=".$value->id_characters."&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=".$value->names_valid_id] = $value->specimen." ".$value->descriptor." from ".$value->author.", ".$value->subfamily;
      }// end query specimens
      $selection.=$objHtml->select($selectSpecimens,$_GET['edit'],"-- select genus -- ","style=\"margin:0px;border:0px;\" tabindex=\"1\" size=\"25\" title=\"Select a specimen and browse to...\" ");
      $inputelement=$selection;
      $headerinput = "Select a specimen and browse to...";
  break; # end GET[edit] 'specimen'
}# end switch GET[edit]

# @annotation <form> action cases $_GET['edit']
switch ($_GET['edit']) {
# @annotation ____ 'specimen'
  case 'specimen':
    $onsubmit = "if(document.".$_GET['edit'].".".$_GET['edit'].".selectedIndex!=-1) {check = confirm('Go to  '+document.".$_GET['edit'].".".$_GET['edit'].".options[document.".$_GET['edit'].".".$_GET['edit'].".selectedIndex].text + ' in the former frame?'); if(check) {document.".$_GET['edit'].".target='chirokey_adults';  document.".$_GET['edit'].".action = document.".$_GET['edit'].".".$_GET['edit'].".options[document.".$_GET['edit'].".".$_GET['edit'].".selectedIndex].value;  } else return false; } else {alert('Select a specimen please.'); document.".$_GET['edit'].".".$_GET['edit'].".selectedIndex=0;return false; }";
  break; # end form action case: GET[edit] 'specimen'
  # @annotation ____ default
  default:
    $onsubmit = '';
}// end switch $_GET['edit']

  $content.="\n<form method='POST' action='".$_SERVER['REQUEST_URI']."' onSubmit=\"".(empty($onsubmit)?"":$onsubmit.";")."\" name='".$_GET['edit']."'>\n".$hiddenElements;
echo $content.$headerinput.$message;
?>

  <table border=0>
    <tr>
      <td>
      <?= $inputelement;?>
      </td>
      <td valign="top" ><!--col 2-->
      <?= $menu; ?>
      </td>
    </tr>
    <tr>
      <td>
       <?= $notes;?>
      </td>
      <td>
        <button <?=$_GET['edit']!="specimen"? 'onmouseover="return overlib(\'To save: (1) update (2) refresh+close\', OFFSETY, 20, CENTER );" onmouseout="return nd();"': 'title="Show specimen"'?>  onSubmit=""  type="submit" tabindex="2" name="update" value="1"><?=$_GET['edit']!="specimen"? 'Update': 'Show'?></button>
        <?
          if($_GET['edit'] !='specimen'):
        ?>
        <button  onclick="refresh_close();" onmouseover="return overlib('To save: (1) update (2) refresh+close', OFFSETY, 20, CENTER );" onmouseout="return nd();" type='SUBMIT' name='refresh' tabindex="3"  value='1'><img src='../structure/img/b_refresh.png' width='16' height='16'></button>
        <? endif;?>
      </td>
    </tr>
  </table>
</form>
</div>
<? echo $_SESSION['debug']? $objMysql->showStatistics():''; unset($_POST);?>
</body>
</html>
<!--
==Temperature==


{citeID|492|Brodersen et al. 2004}: Warm-water chironomid assemblages characterized by taxa such as Chironomus, Dicrotendipes, Ablabesmyia, and Procladius had a high oxy-regulatory capacity.

{citeID|507|Brooks and Birks 2000}:
*11 with significant symmetric unimodal Template:HOF:unimodal: Ablabesmyia (groups 10-12°C & >12°C)

==Conductivity==

{citeID|502|Zhang et al. 2007} report for Ablabesmyia in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 3819.85mg · l⁻¹ (÷ 600 = 6.37mS · cm⁻¹) with an effective occurrence (N2) = 5.93833. In article shortened as: Ab.
 -->