<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">

<head>
  <title>Test Outline - Fourier Analysis</title>
<!--   <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"> -->
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <meta http-equiv="expires" content="0">
  <style type="text/css">

ol.preformatted{
  list-style:decimal outside;
/*   border:2px solid gray; */
  background-color: #EEEED1;
  padding-left:3em;
/*   border-top:1px solid red; */
  margin:0px;
}
ol.preformatted li {
  font-family:  monospace;
    white-space : pre;
  background-color: white;
}
div.preformattedLi{
  font-family:  monospace;
  white-space:pre;
/*   background-color: white; */
/*   padding-left:3em; */
  background-color: #EEEED1;
  border-bottom:1px solid red;
  margin-top:1em;
  margin-bottom:0px;
}
div.preformatted{
  font-family: "Courier New", Courier, monospace;
  white-space : pre;
/*   background-color: white; */
/*   padding-left:3em; */
  background-color: #EEEED1;
/*   border-bottom:1px solid red; */
/*   margin-top:1em; */
  margin-bottom:0px;
}

td {
  vertical-align:top;
}
.digits4 {
  width:4em;
  text-align:right;
}

</style>
</head>
<body>
<?php

/* Es wird ein Array aus 4 Elementen zurück gegeben. Im Array-Index 0 steht die
Breite. Index 1 enthält die Höhe, 2 ein Flag je nach Grafik-Typ (1 = GIF, 2 =
JPG, 3 = PNG, SWF = 4) und Index 3 die richtige Zeichenkette im Format
"height=xxx width=xxx" zur Verwendung im IMG-Tag von HTML.
Beispiel 1. Grafik-Ausmaße ermitteln per GetImageSize:
*/

/*
Array
(
    [0] => 454
    [1] => 193
    [2] => 2
    [3] => width="454" height="193"
    [bits] => 8
    [channels] => 1
    [mime] => image/jpeg
)
 */
?>
<table>
<tr>
  <td>
    <fieldset><legend>Outline to (normalized) elliptic Fourier transformation</legend>
    <form action="test.php" method="post" enctype="multipart/form-data">
      <table>
        <tr>
          <td>Select one file as b/w image:<br>
          <input name="loadedImage" type="file"><br>
          <span style="font-size : x-small;">(PNG is recommended; *.GIF, *.JPG, *.BMP)</span>
          <br>
          </td>
        </tr>
        <tr>
          <td style="border-bottom:1px solid;">Number of harmonics:<br><input name="nharmo" type="text"  value="<?= isset($_POST['nharmo'])? $_POST['nharmo'] : "200"; ?>" class="digits4" title="number of harmonics"></td>
        </tr>
        <tr>
          <td style="text-align:right;">  <input type="submit" name='fileSended' value="Send file"></td>
        </tr>
      </table>

    <!--   <input name="loadedImage[]" type="file"><br> -->
    </form>
    </fieldset>
  </td>
  <td>
    <fieldset><legend>Chaincode to (normalized) elliptic Fourier transformation</legend>
    <form action="test.php" method="post" enctype="multipart/form-data">
      <table>
        <tr>
          <td>Insert chain code:
            <div class="preformatted" style="text-align:left;">
 Chaincode usu-
 ally without
 spaces:
  3   2   1
    \ | /
  4 - X - 0
    / | \
  5   6   7
            </div>

          </td>
          <td><textarea name="chain" style="width:20em;height:30em;" wrap="on"  ><?= isset($_POST['chain'])? $_POST['chain'] : ""; ?></textarea></td>
        </tr>
        <tr>
          <td style="border-bottom:1px solid;"></td>
          <td style="border-bottom:1px solid;">Number of harmonics:<br><input name="nharmo" type="text"  value="<?= isset($_POST['nharmo'])? $_POST['nharmo'] : "200"; ?>" class="digits4" title="number of harmonics"></td>
        </tr>
        <tr>
          <td ></td>
          <td style="text-align:right;">  <input name="chainSubmitted" type="submit" value="Send chain"></td>
        </tr>
      </table>

    <!--   <input name="loadedImage[]" type="file"><br> -->
    </form>
    </fieldset>
  </td>
</tr>
</table>
<?
include(preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__).'structure/test/inc.outline.php');
#print_pre($_POST);
  function print_pre($values){
    echo "\n<pre>\n";
      print_r($values);
    echo "\n</pre>\n";
  }
  function sci($x, $d=-1) {
    $min=($x<0)?"-":"+";
    $x=abs($x);
    $e=floor(($x==0)?0 : ($x==1? 0:log10($x)));
    #$e = ($x==1 && $e==-1)? 0:$x;
    $x*=pow(10, -$e);
    $fmt=($d>=0)?".".$d:"";
    $e=($e>=0)?"+".sprintf("%02d",$e):"-".sprintf("%02d",-$e);
    //     return $x;
    //     return sprintf("%+.10f",$x);
    // echo "\"$min%".$fmt."fe%s\"".",".$x.",".$e;
    $number = sprintf("$min%".$fmt."fe%s",$x,$e);
    return $number;
  }
  function calc_user(&$item, $key, $calc){
    // e.g.:  array_walk($array, 'calc_user', '-('.$const.')');
    #echo "return $item$calc;<br>";
    $item = eval("return $item$calc;");
  }

  $test = new outline;
  $math = new mathuser;

if(isset($_FILES['loadedImage'])){
    $size = GetImageSize (
      $_FILES['loadedImage']["tmp_name"]
      #,&$info # erweiterte Informationen aus der Datei
      );

  $im=$test->imagecreatefromfile($_FILES['loadedImage']['tmp_name'], true);

//   print_pre($size);
  $chain =  $test->imageDrawOutline($im, $size, $debug=false);
  $output = $math->chainToXY($chain);
  $x = $output['X']; $y = $output['Y'];
  #$imparams = $test->imageOutline($x, $y);
  #print_pre($imparams);
  $printHarm =true;

}# end if loadedImage exist
if(isset($_POST['chain'])){
  if(empty($_POST['chain'])){
    echo "<p>Empty chain code given. Stopped here.</p></body>";
    exit;
  }
  $search = array(
    /* 1*/ "/\s*/",     // white spaces
    /* 2*/ "/[\r\n]/",  // line break tabs
    /* 3*/ "/([0-7])/", // add white space for explode()
    /* 4*/ "/\s+$/"     // remove last white space for explode()

    );
  $replace = array(
    /* 1*/ "",     // white spaces
    /* 2*/ "",     // line break tabs
    /* 3*/ "\\1 ", // add white space for explode()
    /* 4*/ ""      // remove last white space for explode()
  );
  $chain= preg_replace($search,$replace,$_POST['chain']);
  $chain =  explode(" ",$chain);
  $output = $math->chainToXY($chain);
  $printHarm =true;
}# end isset($_POST['chain'])

if($printHarm){
  $harmonics = $math->getharmonics(
      $chain=$chain,
      $_POST['nharmo'],
      $debug=true
    );
  /** print x y values */
  $n = count($harmonics['normalized']["a"]);
  $x = $math->harmonicsToXY($n,
    $a = $harmonics['notnormalized']["a"],
    $b = $harmonics['notnormalized']["b"],
    $t = $n);
  $y = $math->harmonicsToXY($n,
    $a = $harmonics['notnormalized']["c"],
    $b = $harmonics['notnormalized']["d"],
    $t = $n  );
  $xn = $math->harmonicsToXY($n,
    $a = $harmonics['normalized']["a"],
    $b = $harmonics['normalized']["b"],
    $t = $n);
  $yn = $math->harmonicsToXY($n,
    $a = $harmonics['normalized']["c"],
    $b = $harmonics['normalized']["d"],
    $t = $n  );
$nchain=count($chain);
echo <<<EOF
<div class="preformattedLi">
Chaincode  |    3   2   1
usually    |      \ | /
without    |    4 - X - 0
space and  |      / | \
line break |    5   6   7
-----------+--------------

$nchain points as outline:

     1   5   10   15   20   25   30   35   40   45   50   55   60   65   70   75   80   85   90   95  100
</div>
<ol class="preformatted" start=0 >

EOF;
$outputChain = wordwrap(implode("", $chain),100, "\n", true);
$search = array(
  "/^([0-7])([0-7]{3})([0-7])/m",
  "/([0-7]{4})([0-7])/",
  "/^(.+)$/m"
);
$replace = array(
  "<span style='color:red'>\\1</span>\\2<span style='color:red'>\\3</span>",
   "\\1<span style='color:red'>\\2</span>",
   "\n  <li>\\1</li>"
);
$outputChain=preg_replace($search, $replace, $outputChain);
echo $outputChain."\n
</ol>";
echo <<<EOF
<div class="preformattedLi">
  N  +------------ NOT normalized elliptic Fourier -------------+
Harm |            a              b              c              d|
</div>
<ol class="preformatted">
EOF;
  foreach ($harmonics['notnormalized']["a"] as $key => $value) {
    echo
    " <li>".
    sci($harmonics['notnormalized']["a"][$key], 7)." ".
    sci($harmonics['notnormalized']["b"][$key], 7)." ".
    sci($harmonics['notnormalized']["c"][$key], 7)." ".
    sci($harmonics['notnormalized']["d"][$key], 7)."</li>\n";
  }
echo "\n</ol>\n";
echo <<<EOF
<div class="preformattedLi">
  N  +- x-y coordinates not normalized +
Harm |            x              y     |
</div>
<ol class="preformatted">
EOF;
  foreach ($x as $key => $value) {
    echo
    " <li>".
    sci($x[$key], 7)." ".
    sci($y[$key], 7)."</li>\n";
  }
  echo <<<EOF
</ol>
<div class="preformattedLi">
  N  +------------- normalized elliptic Fourier ----------------+
Harm |            a              b              c              d|
</div>
<ol class="preformatted">
EOF;
  foreach ($harmonics['normalized']["a"] as $key => $value) {
    echo
    " <li>".
    sci($harmonics['normalized']["a"][$key], 7)." ".
    sci($harmonics['normalized']["b"][$key], 7)." ".
    sci($harmonics['normalized']["c"][$key], 7)." ".
    sci($harmonics['normalized']["d"][$key], 7)."</li>\n";
  }
echo "\n</ol>\n";
echo <<<EOF
<div class="preformattedLi">
  N  +- x-y coordinates normalized +
Harm |        xnorm         ynorm  |
</div>
<ol class="preformatted">
EOF;
  foreach ($xn as $key => $value) {
    echo
    " <li>".
    sci($xn[$key], 7)." ".
    sci($yn[$key], 7)."</li>\n";
  }

echo "\n</ol>\n";
$xshift = min($xn)<0? abs(min($xn)):0;
$yshift = min($yn)<0? abs(min($yn)):0;
 array_walk($xn, 'calc_user', '+'.$xshift);
 array_walk($yn, 'calc_user', '+'.$yshift);
  $scale=empty($size) ? 200 : $size[0]/max($xn);
 array_walk($xn, 'calc_user', '*'.$scale);
 array_walk($yn, 'calc_user', '*'.$scale);
 if(isset($_POST['fileSended']) || !empty($chain)){
 echo "
<table>
 <tr>";
  echo isset($_POST['fileSended'])? "\n  <td style='text-align:center;'>Original Image:<br>":"";
    isset($_POST['fileSended'])? $test->imageOutline($output['X'], $output['Y'], $dst="source.png"):"";
  echo isset($_POST['fileSended'])? "\n</td>\n":"";
  echo "\n  <td style='text-align:center;'>Reconstructed Image:<br>";
    empty($chain)? "": $test->imageOutline($xn, $yn, $dst="outlined.png", $padding=8, $debug=false);
 echo "
  </td>
 </tr>
</table>
 ";
 }
  #print_pre($_POST);
}// end print harmonics

#harmonic.simple(x=1:n,a0=0,a=nefdf$nefabcd[,"a"],b=nefdf$nefabcd[,"b"],n,1:n)#;
  #print_pre(implode("\n",$x));
  #print_pre($math->ave_user($y));
  #print_pre($math->ave_user($x));
//   imagegif()*/
   ?>

</body>
<?
?>