<?php
  header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
  header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT"); // always modified
  header ("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
  header ("Pragma: no-cache"); // HTTP/1.0

/**
 * Automatic suggestions for references (Ajax)
 *
 * Gets variables by $_GET and query the database backend by settings in
 * Note if there is any produced error there will be no note
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @package chirokey_larvae
 * @subpackage database
 */
/*
the returned xml has the following structure
<results>
  <rs>foo</rs>
  <rs>bar</rs>
</results>
*/

/**
 * Read functions
 *
 * Extract current server path relatively: {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 */
include(preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__).'structure/functions.php');
/**
 * Read sql class for DB access
 *
 * Extract current server path relatively
 */
include(preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__).'structure/classes/sql.php');
//first get classes

$objMysql = new db_mysql;//class db_mysql

// URL eg. 'queryDB.php?limit=10&table=names_authors&field=author_names&'
$limit = isset($_GET['maxentries']) ? $_GET['maxentries'] : '20';
$info = empty($_GET['info']) ?  "" : ", `".$_GET['info']."`";
if($result=$objMysql->queryArray("
  SELECT DISTINCT
    `".$_GET['field']."` ".$info."
    FROM `".$_GET['table']."`
    WHERE
      `".$_GET['field']."` LIKE '".$_GET['input']."%' AND
      `".$_GET['field']."` IS NOT NULL AND
      `id` != 0
    ORDER BY `".$_GET['table']."`.`".$_GET['field']."` ASC
    LIMIT ".$limit.";
  ")){
  foreach($result as $value){
    $list[]=$value[$_GET['field']];
  }
} else exit; # no results

$list=array_unique($list);

for($i = 0 ; $i < count($list); $i++){
  $aInfo[$i]  = "";
}


  $input = strtolower( $_GET['input'] );
  $len = strlen($input);
  $limit = isset($_GET['limit']) ? (int) $_GET['limit'] : 0;


  $aResults = array();
  $count = 0;

  if ($len)
  {
    for ($i=0;$i<count($list);$i++)
    {
      // had to use utf_decode, here
      // not necessary if the results are coming from mysql
      //
      if (strtolower(substr(utf8_decode($list[$i]),0,$len)) == $input)
      {
        $count++;
        $aResults[] = array( "id"=>($i+1) ,"value"=>htmlspecialchars($list[$i]), "info"=>htmlspecialchars($aInfo[$i]) );
      }

      if ($limit && $count==$limit)
        break;
    }
  }



  if (isset($_REQUEST['json']))
  {
    header("Content-Type: application/json");

    echo "{\"results\": [";
    $arr = array();
    for ($i=0;$i<count($aResults);$i++)
    {
      $arr[] = "{\"id\": \"".$aResults[$i]['id']."\", \"value\": \"".$aResults[$i]['value']."\", \"info\": \"\"}";
    }
    echo implode(", ", $arr);
    echo "]}";
  }
  else
  {
    header("Content-Type: text/xml");

    echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?><results>";
    for ($i=0;$i<count($aResults);$i++)
    {
      echo "<rs id=\"".$aResults[$i]['id']."\" info=\"".$aResults[$i]['info']."\">".$aResults[$i]['value']."</rs>";
    }
    echo "</results>";
  }
?>