#!/bin/bash
###############################
# simple Linux BASH script to
# prepare ziped outline
###############################

temp=./outlineAnalysis/
fileName="outlineAnalysis.tar.gz"

if ! [ -d $temp ]; then
  mkdirhier $temp
  echo -e "\033[0;33mmake directory $temp\033[0m"
fi

cp ./key/outline.php $temp
cd ./key/
cp -R ./temp ../$temp
cd ..
chmod -R og+w $temp/temp
cp ./structure/classes/inc.outline.php $temp
mkdirhier ${temp}img
cp ./structure/img/outlinemethod.png ${temp}img/

date=`LC_TIME=C date +'%A %m/%d/%Y'`
sed -i "
 s#structure/classes/##g;
 s#../structure/img#img#g;
 s#<title>Outline with Fourier Analysis #<title>Outline with Fourier Analysis, version: $date #g;
 s#{1}[^/]\+.....php#{0}[^/]+\.php#g;
 s#<p>Using the  statistical program.*</p>##g;
 s#Another good tutorial for morphometric analysis#A good tutorial for morphometric analysis#g;" ${temp}outline.php
echo "Files version: $date
  * outline.php (output) and
  * inc.outline.php (class functions)
perform a normalized elliptic Fourier analysis after Kuhl, Frank P. and
Giardina, Charles R., 1982: Elliptic Fourier features of a closed contour,
Computer Graphics and Image Processing, vol. 18, no. 3, pp. 236-258.
Note that folder ./temp must be readable for anybody to allow the scripts
writing output images. Some configuration can be done in file 'outline.php'.
If you just unpack all files readable for anybody it should work. Further
statistical analysis see e.g. R- package 'shapes' (http://www.r-project.org/)

These scripts come without ANY WARRANTY and are licensed under
Creative Commons Noncommercial 3.0 (http://creativecommons.org/licenses/by-nc/3.0/)

Comments or bugs please to Andreas Plank (andreas.plank@web.de)
" > ${temp}readme1st.txt
tar vczf $fileName $temp

  echo -e "\033[0;33mremove directory $temp\033[0m"

rm  -R $temp
#