<?php
/**
 * Perform a check: images folder species = images in database?
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @package chirokey_pupae
 * @todo minor issue: document further detailed
 * @subpackage install/update
 */
$currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/session.inc.php');
header('content-type: text/html; charset=utf-8');
# redirect to http://localhost/chip/pupae/
include($currentServerPath.'structure/config.php');
include($currentServerPath.'structure/functions.php');

// redirect without Informations
// if($mysqli->multi_query("use chirokey_pupae")){
//   header("Location: http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir']);
//   exit;
// }

$title="Install interactive Chironomidae Key";
$link="../structure/css/basic.css";
include($currentServerPath.'structure/pages.php');
include($currentServerPath.'structure/classes/sql.php');//first get classes
include($currentServerPath.'structure/config.php');/* login */
include($currentServerPath.'structure/classes/tools.php');
$content = $page['head'];

/*
  1 - is already
    a update?
    (b use key)
  2 - install from new

  */
$legend = "Info";
$user = isset($_POST['user']) ? $_POST['user'] : 'root';
$checked = isset($_POST['onlyImgCheck']) ? $_POST['onlyImgCheck'] : '';
$message = "
<div >
This script compares images in the database and in folder '".$config['dirSpec']."' and takes a wile.
<!-- try to install or update the database. If this is the 1<sup>st</sup> install you can leave password empty otherwise please set. Note: <ul><li>the database/tables will be <strong>deleted</strong> before update or install with SQL 'DROP DATABASE IF EXISTS `chirokey_pupae`' or 'DROP TABLE IF EXISTS `...`</li><li>there will be done a test as well if image-strings in the database and image-files are identical. This takes some time.</li></ul>-->
<form action='' method='post'>
<table style='border:1px dashed;'>
  <tr style='vertical-align:top;'><td>User:</td><td><input title='user name' name='user' value='".$user."' type='text'></td></tr>
  <tr style='vertical-align:top;'><td>Password:<br>(none 1st install)</td><td><input title='password' name='password' value='".$_POST['password']."' type='password'></td></tr>
  <tr><td>image check?</td><td><input name='onlyImgCheck' value='checked' type='checkbox' checked></td></tr>
  <tr><td></td><td><input name='submit' type='submit' value='check'></td></tr>
</table>
</form>
</div>
";
if(isset($_POST['submit'])){// submit button was clicked
  $mysqli = new mysqli("localhost","root",$_POST['password']); # no password
  // check connection
  if (mysqli_connect_errno()) {
    $legend = "<span style='color:red;'><strong>Error</strong></span>";
      $content.= !empty($legend) && !empty($message) ? "<fieldset class='info'><legend>".$legend."</legend><div>".$message."</div></fieldset>" : '' ;
    echo $content;
    printf("<span style='color:red;'><strong>Connection lost: %s\n. (Wrong password or user? Info: Nothing is done)</strong></span>", mysqli_connect_error());
    echo $page['foot'];
    exit;
  }

    // @annotation: test images
    $mysqli->query("USE ".$config['database'].";");
    if($result=$mysqli->query("SELECT `id`, `filename` FROM images;")){
      while ($row = $result->fetch_row()) {
          $ImagesDB[$row[0]]=$row[1];
      }
    }
    // @annotation: close connection
    $mysqli->close();
    // DB image file errors
    $Files = FilesRead("../../".$config['dirSpec'],'',true);//no filter simple=true (not recursive)
    foreach ($ImagesDB as $keyDB => $valueDB) {
      if(!in_array($valueDB,$Files)){
        $errorsDB[$keyDB] = $valueDB;
      }
    }
    // DB errors
    if(is_array($errorsDB)){
      foreach ($errorsDB as $key => $value) {
        $errorsDbOutput.="\n    <li>id: ".$key.", file: ".$value."</li>";
      }
      $message.="
      <ul>
        <li>Errors in database:</li>
        <ul>".$errorsDbOutput."
        </ul>
      </ul>";
    }
    // image file errors
    foreach ($Files as $keyFile => $valueFile) {
      if(!in_array($valueFile,$ImagesDB)){
        $errorsFiles[] = $valueFile;
      }
    }
    if(is_array($errorsFiles)){// some information
      foreach ($errorsFiles as $key => $value) {
        $errorsFilesOutput.="\n    <li> file: ".$value." is not in database (table images)!</li>";
      }
      $message.="
      <ul>
        <li>Errors in file folder '/china/".$config['dirSpec']."':</li>
        <ul>".$errorsFilesOutput."
        </ul>
      </ul>";
    }
    if(!is_array($errorsFiles) && !is_array($errorsDB)){
      $installUpdate = $_POST['onlyImgCheck']=='checked' ? 'updated' :'installed';
      $message.="<br>OK! No errors! <!-- Database <strong>chirokey_pupae</strong> sucessfully ".$installUpdate." from file »".$installFile."«  (<strong>user</strong> 'chiro_user' and <strong>passwort</strong> 'chiroproject').--> Images in folder '/china/".$config['dirSpec']."' are the same as in the database. You can use the key now <a href='http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir']."'>http://localhost/".$config['ServerRootDir']."</a>.";
    }
//   }// end if update or install
}// end: submit button was clicked
  $content.= !empty($legend) && !empty($message) ? "<fieldset class='info'><legend>".$legend."</legend><div>".$message."</div></fieldset>" : '' ;
  unset($_POST);
  echo $content;
  echo $page['foot'];
?>
