<?php
/**
 * Generating chironomid's interactive web pages
 *
 * generates page home, pages of subfamily, pages of genera, page of specimen and iframes to get
 * clicked specimen compared  with all other taxa within the same genus name or
 * similar defined genera. Pages for each genus can  be edited and modified to
 * write some small mini articles with tables, lists oder even determination  keys
 * as ordered lists. A references list is automatically genrated at the end of each
 * genus page.
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-06-11 09:07:11
 * @package chirokey_pupae
 * @subpackage key
 * @todo minor issue: document in detail
 * @todo remove confusing GET variables: genus_valid_id and valid_id
 */

/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
 $currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
/**
 * Use sessions
 */
include($currentServerPath.'structure/session.inc.php');

header('content-type: text/html; charset=utf-8');
/**
 * Read functions
 */
include($currentServerPath.'structure/functions.php');
/**
 * Connect to database with classes
 */
include($currentServerPath.'structure/classes/sql.php');//first get classes
/**
 * Read config
 */
include($currentServerPath.'structure/config.php');/* login */
/**
 * Load several tools (highlighting, ...)
 */
include($currentServerPath.'structure/classes/tools.php');

/**
 * Start classes
 */
$objMysql = new db_mysql;//class db_mysql
$objHtml  = new html;//class html

/**
  * title definitions
  */
  $title = 'Characters';
  $link = $_GET['print']? '../structure/css/print.css':'../structure/css/basic.css';
  $javascript = 'src="../structure/js/functions.js"';
  $script ='
  <link rel="stylesheet" href="../structure/css/print.css" type="text/css"  media="print" >
  <link rel="shortcut icon" href="../structure/img/favicon.ico">
  <!--[if lt IE 8]>
    <script src="../structure/js/IE7.js" type="text/javascript"></script>
  <![endif]-->
    <script src="../structure/js/sorttableFilter.js" type="text/javascript"></script>

';
  // header content
/**
 * header, footer content
 */
  include($currentServerPath.'structure/pages.php');
  $content.= $page['head'];/* head of page */
  #$content.=print_pre($_SERVER,true);
/* control */
//    echo "\$_GET from url: <pre>";print_r($_GET);echo "</pre><br>";

/*
$_GET['show']
  subfamily
  genus
  compare
  references
  default
*/

switch ($_GET['show']) {
  case 'subfamily': // @annotation show subfamily: _GET['show'] == subfamily
  if($result=$objMysql->querySingleItem("SELECT `name` FROM `names_subfamily` WHERE `id`='".$_GET['subfamily_id']."'"))
    $result  = $result==-1 ? 'not given' : $result;
//     $content.=info_level("Subfamily",$result);
    $info="Subfamily: ".$result;
    $content.="<span id='toppage'></span>";
    $content = preg_replace(
      "#(<title>Characters)(</title>)#",
      "\\1 of subfamily $result\\2",
      $content);
  if(empty($_GET['subfamily_id'])){
    $content.=info_start($title="Info", 'info');
    $content.="Select at least one subfamily";
    $content.=info_end();
    echo $content.$page['foot'];
    exit;
  }

  if($_GET['morph_attrib_id']=='`names_subfamily`.`morph_attrib_id`') {
    // recieve all default structures like mentum 1, mentum, ...
      $_GET['morph_attrib_id']=$objMysql->querySingleItem("
        SELECT `names_subfamily`.`morph_attrib_id`
        FROM `names_subfamily`
        WHERE (`names_subfamily`.`id` =".$_GET['subfamily_id'].");
      ");
  }

  //$content.="<pre>".print_r($_GET['morph_attrib_id'],true)."</pre>";
 include($currentServerPath.'structure/config.php');/* login */
  // @annotation show subfamily: highlight references
  // $content.= "<pre>".print_r($MysqlSelect['ReferencesReplace'],true)."</pre>";
  if($referenceList=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
    foreach($referenceList as $ref){
      $replacetext[$ref->id]=htmlentities($ref->authors_short,ENT_NOQUOTES,'UTF-8');
    }
  }
  //$content.="<pre>".print_r($MysqlSelect['ShowSpeciesBySubfamily'],true)."</pre>";
  if($result=$objMysql->queryObjectArray($MysqlSelect['ShowSpeciesBySubfamily'])){
    foreach($result as $spec){
      $genus      = $spec->genus;
      $subgenus   = $spec->subgenus;
      $valid_id   = $spec->valid_id;
      $species    = $spec->species;
      $license    = $spec->license;
      $descriptor = replaceHTMLcode($spec->descriptor);
      $descriptor_id = $spec->descriptor_id;
      $authors    = replaceHTMLcode($spec->authors_short);
      $author_id  = $spec->author_id;
      $annotation = $objHtml->emphase($spec->annote,$replacetext,"references",false);
        $annotation=str_replace("'","\'",$annotation);
      $systematicNotes = $objHtml->emphase($spec->systematicNotes,$replacetext,"references",false);
        $systematicNotes=str_replace("'","\'",$systematicNotes);
      $file       = $spec->filename;
      $img_width  = $spec->img_width_default;
      $morph_long = $spec->morph_long;
      //@annotation show subfamily: image
      $subgenus = $subgenus ? "(<em>".$subgenus."</em>)" : "";
      $authors = $authors ? htmlentities($authors,ENT_QUOTES,'UTF-8') : "<span class=\'error\'>no author given</span>";
      $annotation = $annotation ? "<hr class=\'thin\'><img title=\'Note to this image\'  align=\'middle\' src=\'../structure/img/b_annote.png\' width=16 height=16 />&nbsp;".$annotation : "";
      $systematicNotes = $systematicNotes ? "<hr class=\'thin\'><img align=\'middle\'  title=\'systematic note\' src=\'../structure/img/b_systree_note.png\' width=16 height=16 />&nbsp;".$systematicNotes : "";
      $onmouseover="onmouseover=\"return overlib('<em>".$genus."</em> ".$subgenus." <em>".$species."</em> ".$descriptor." ".lb2string($annotation).lb2string($systematicNotes)."<hr class=\'thin\'><img src=\'../structure/img/book.png\' width=16 height=16 >&nbsp;".$authors."<br>".$license."', CAPTION, '".$morph_long."');\" onmouseout=\"return nd();\"";

      $content.= $genus==$last_genus ? '' : "\n<div style='clear : left;'></div>\n<h2 style='text-align:center;'><em>".$genus."</em></h2>\n  \n  ";
      $descriptor =$descriptor_id==0 ? " <span class='attention'>".$descriptor."</span>" :  "<a class='reference' title='Click for reference.' target='chirokey_pupae' href='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#refid".$descriptor_id."'>".htmlentities($descriptor,ENT_QUOTES,'UTF-8')."</a>" ;
      $content.="\n<div class='imagebox'>\n
      <span class=\"search\" title=\"Click to search &#187;".$genus." ".$species."&#171;\" onclick=\"check=confirm('You clicked on &#187;".$genus." ".$species."&#171;.\\nDo you wish to search this string in a new window?');if (check==false) return false; if (check==true) window.open('http://www.google.com/search?rls=en&amp;q=".$genus."+".$species."&amp;ie=utf-8&amp;oe=utf-8');\"><em  class='species'>".$genus." ".$subgenus." <br> ".$species."</em></span> ".$descriptor."\n<br>\n<br>\n  <a  class='nothing' href='?show=genus&amp;morph_attrib_id=".$_GET['morph_attrib_id']."&amp;genus_valid_id=".$valid_id."' target='chirokey_pupae'".$onmouseover.">";
      $content.="\n    <img src='../../".$config['dirSpec'].$file."' alt='".$file."'  width='".$img_width."'>";
      $content.="\n  </a>\n</div>\n";
      $last_genus = $genus;
      /**
      * Collecting all references in session variable
      *
      * All references are collected and made unique with {@link putToArray()}
      * to get only these references used on a page
      * @global string $_SESSION['references']
      */
      $_SESSION['references'][] = $author_id;
      $_SESSION['references'][] = $descriptor_id;
    }
    $content.="\n<div style='clear:left;'></div>\n";
    // @annotation show subfamily: get reference id's
    $refIds=implode(', ',$_SESSION['references']);unset($_SESSION['references']);
    if(!empty($refIds)){
        $MySQL['addWHERE'] =" AND id IN(".$refIds.")";
      include(preg_replace('#(.+/)([^/]+/){0}[^/]+\.php#',"\\1\\3", __FILE__).'/references.php');
      // prints the references
    }
  }
  else{// @annotation no result subfamily
  if($result=$objMysql->querySingleItem("SELECT `morph_long` FROM `morph_attrib`, `names_subfamily` WHERE `morph_attrib`.`id` IN(".$_GET['morph_attrib_id'].") AND `names_subfamily`.`id` = ".$_GET['subfamily_id'].";"))
    $content.=info_start($title="Info", 'info');
      $content.= "No image found for morphological structure: &#171;".$result."&#187;";
    $content.=info_end();
  }
  include($currentServerPath.'structure/pages.php');
  echo $content.$page['footbefore'].$page['foot'];
  exit;
    break;// end show subfamily
# @annotation show genus: _GET['show'] == genus
  case 'genus':
    if(empty($_GET['genus_valid_id'])) { // no selection
      $content.= info_start($title="Info", 'info').'Please select at least one genus.'.info_end();
      echo $content.$page['foot'];
      exit;
    }
    include($currentServerPath.'structure/config.php');/* login */
  # @annotation ____: fetch data GenusCharacters
    if($result=$objMysql->queryObjectArray($MysqlSelect['GenusCharacters'])){
      foreach($result as $spec){# is only 1
      # @annotation  ____: sections Ecology Notes
        $strEcologyNotes = "\n=Ecology=\n<!-- Ecology original -->\n".$spec->ecology."\n=Notes=\n<!-- Notes original -->\n".$spec->notes."\n=Data=\n<!-- Data original -->\n";
      # @annotation ____: repelace images Img:Prcl_chor_hes_Rie2001_r.jpg
        if(preg_match("#Img:[A-za-z_.0-9]+#",$strEcologyNotes))
          if($result=$objMysql->queryObjectArray($MysqlSelect['AllSpeciesImages'])){
            foreach($result as $imgField)
              $arrImg[$imgField->filename] = $imgField->imageToReplace;

            $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$arrImg, "strImgToImage");
          }
      # @annotation ____: Data section
        if($resultsChararcters=$objMysql->queryObjectArray($MysqlSelect['TaxaExistInCharacters'])){
          $data.="\n  <p>Other taxa that can be added or exist in database table characters see below. Note there exist only pages for taxa that were inserted by the menu <a class='menuCHIP' href='upload.php' target='chirokey_pupae' ><img  style='vertical-align : middle;' src='../structure/img/b_upload.png' width='20' height='20'>&nbsp;Images</a>&nbsp; or <a href='synonyms.php#ManageValidSpecies'  class='menuCHIP' target='chirokey_pupae' >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_systree.png' width='20' height='20'>&nbsp;Manage Names</a>. For <em>".$spec->genus."</em> sp. exist only this page.</p>";
          $i=1;
          foreach ($resultsChararcters as $value) {
            $data.="<!-- ".$value->taxon."-->"; // some comments
          # some specimen missing in characters
            if(empty($value->id)){
              $data.="\n  <span class='printinvisible' title='add numeric data'  id='id_characters".$i."'>";
                $data.="\n    <a class='nothing' target='chirokey_pupae'  href = 'execute.php?action=insert_characters&amp;id_author=".$value->id_author."&amp;taxon=".urlencode($value->taxon_simple)."&amp;author=".$value->author."&amp;names_valid_id=".$value->names_valid_id."&amp;link_back=".urlencode("http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#id_characters".$i++)."'>&nbsp;";
                $data.="<img src='../structure/img/tag_table_edit_insert.png' width='22' height='22' align='middle'>\n    </a>&nbsp;";
              $data.="\n  </span>";
            }else {
          # specimen already in characters
              $data.="\n  <span class='printinvisible' title='modify numeric data in separate window' id='id_characters".$i++."'>";
                $data.="\n    <a class='external' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/tbl_change.php?db=".$config['database']."&amp;table=characters&amp;primary_key=+%60characters%60.%60id%60+%3D+".$value->id."&amp;token=".$_SESSION['PMA_single_signon_token']."&amp;sql_query=SELECT+%2A+FROM+%60characters%60&amp;goto=sql.php'>&nbsp;";
              # depending on data in DB blinking image
                $data.="   <img src='../structure/img/tag_table_edit.png' width='22' height='22' align='middle'>\n    </a>&nbsp;";
              $data.="\n  </span>";
            }
            $data.=$value->taxon." (valid_id=".$value->names_valid_id.")&nbsp;";
          # edit taxon pages when id exist
            if(!empty($value->id)){
              $data.="\n  <span title='modify web page data' class='printinvisible' >";
                $data.="\n    <a class='nothing' target='chirokey_pupae'  href='?id_characters=".$value->id."&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=".$value->names_valid_id."'><img src='../structure/img/b_edit_page.png' align='middle' width='22' height='22' >";
              $data.="\n    </a>\n  </span>";
            }
            $data.="<br>\n";
          }// end foreach
        } else {// end fetch numeric data
          $data = "<p>No other taxa in the database. For insert use <a class='menuCHIP' href='synonyms.php#ManageValidSpecies' target='chirokey_pupae' >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_systree.png' width='20' height='20'>&nbsp;Manage Names</a>.</p>";
        }// no numeric data
      # @annotation ____: emphase general ($strEcologyNotes)
        $strEcologyNotes    = $objHtml->pattern2tag($strEcologyNotes);
        $genus      = $spec->genus;
        $subfamily  = $spec->subfamily;
      # @annotation ____: genera highlighting ($strEcologyNotes)
        if($resultsub=$objMysql->queryObjectArray($MysqlSelect['GeneraValidIdDesc'])){
          foreach($resultsub as $gen){
            $replacetext[$gen->valid_id]=$gen->genus_name;
          }
        }
        $similar    = $objHtml->emphase($spec->similar,$replacetext,"idtogenus");
        $similar_id = implode(" ", $spec->similar); // for use with compare
        $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$replacetext,"genus");
        unset($replacetext);
      # @annotation ____: highlight references ($strEcologyNotes)
        if($resultsub=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
          foreach($resultsub as $ref){
            $replacetext[$ref->id]=htmlentities($ref->authors_short,ENT_NOQUOTES,'UTF-8');
          }
        }
        $referenceArray=$replacetext;// copy references for later use
        $strEcologyNotes  = $objHtml->emphase($strEcologyNotes,$replacetext,"references");
        $data          = $objHtml->emphase($data,$replacetext,"references");
        unset($replacetext);
      # @annotation ____: highlight species ($strEcologyNotes)
        if($resultsub=$objMysql->queryObjectArray($MysqlSelect['SpeciesName'])){
          foreach($resultsub as $species)
            $replacetext[$species->id]=htmlentities($species->name,ENT_QUOTES,'UTF-8');
        }
        $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$replacetext,"species");
      # @annotation ____: repelace Templates Template:ArrayKey ($strEcologyNotes)
        if(preg_match("#Template:[A-za-z:0-9]+#",$strEcologyNotes)){
          include($currentServerPath.'structure/templates.php');
            $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$templates, "strTemplateToHtml");
        }# Templates found
      # @annotation ____: maps ($strEcologyNotes)
        if(!preg_match("#<!--(?!\{\{openLayer)[^-->]*\{\{openLayer\|([^\|]+)\|.*-->#Usm",$strEcologyNotes))
          $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$replacetext,"maps");
      # @annotation ____: create TOC ($toc)
        if(!empty($_SESSION['sections'])){
          $toc=implode("<br>\n  ",$_SESSION['sections']);// fetch sections
          $toc="\n<!-- Table of Content -->\n<div class='toc'>\n  <span style='font-size:125%;'>Table of Content:</span><br>\n  ".$toc."<br>\n  <a class='sec1' href='#Images'>Images</a><br>\n  <a class='sec1' href='#references'>References</a>\n</div>\n";
        }
        unset($_SESSION['sections']);// delete TOC
        unset($replacetext);
      # @annotation ____: edit pencils ($strEcologyNotes, $editSimilar. $edit...)
        $editSimilar   = isset($_SESSION) ? $objHtml->pencil('edit=similar&amp;genus='.$spec->genus.'&amp;genus_valid_id='.$_GET['genus_valid_id']) : '';
        $editSubfamily = isset($_SESSION) ? $objHtml->pencil('edit=subfamily&amp;genus='.$spec->genus.'&amp;genus_valid_id='.$_GET['genus_valid_id']) : '';
        $editEcology   = isset($_SESSION) ? $objHtml->pencil('edit=ecology&amp;genus='.$spec->genus.'&amp;id_characters='.$spec->id_characters.'&amp;genus_valid_id='.$_GET['genus_valid_id'], 'popup.php','title=\'Click to edit the entire DB-field Ecology (new window)\'') : '';
        $editNotes     = isset($_SESSION) ? $objHtml->pencil('edit=notes&amp;genus='.  $spec->genus.'&amp;id_characters='.$spec->id_characters.'&amp;genus_valid_id='.$_GET['genus_valid_id'], 'popup.php','title=\'Click to edit the entire DB-field Notes (new window)\'') : '';
      # split Ecology and Note section for sectionwise editing
      # @annotation ____: compose page (sectionwise editing)
        # seems to need a end-marker to separate correctly the sections

      # Ecology
        $strEcologyNotes = preg_replace('#Ecology</h1>[\n\r]<!-- Ecology original -->#ms','Ecology '.$editEcology.'</h1>',$strEcologyNotes);
        # Ecology/Notes subsectionwise
          $isEcology=true;
        /*
         if <!-- Notes original --> found then
          set isEcology=FALSE & replaces editNotes & reset intSection back to 1
          BEWARE of (...) !!!!
        */
          $strEcologyNotes = preg_replace('#^(<h[1-5][^>]+>[^<]+)(</h[1-5]>)$[\n\r]?(<!-- Notes original -->)?#mse',"'\\1 <!-- isSubsection='.(\$isEcology=(\$isEcology? ('\\3'=='<!-- Notes original -->'? false:true):false)).'-->'.('\\3'=='<!-- Notes original -->'?\$editNotes :( \$objHtml->pencil('edit='.(\$isEcology? 'ecology':'notes').'&amp;genus='.\$spec->genus.'&amp;id_characters='.\$spec->id_characters.'&amp;genus_valid_id='.\$_GET['genus_valid_id'].'&amp;section='.\$intSection=(\$isEcology? ++\$intSection:++\$intSectionAnew),'popup.php','title=\'Click to edit only this section from DB-field '.(\$isEcology? 'Ecology':'Notes').' (new window)\' ','b_edit_section2.gif'))).'\\2'",$strEcologyNotes);
          # Notes
//         $strEcologyNotes = preg_replace('#Notes</h1>[\n\r]<!-- Notes original -->#msU','Notes '.$editNotes.'</h1>',$strEcologyNotes);
      # Notes
//         $strNotes   = preg_replace('#(.+Ecology</h1>[\n\r]<!-- Ecology original -->.+)(<h1\s+class=\'sec1\'\s+id=\'Notes\'>Notes</h1>[\n\r]<!-- Notes original -->.+)<h1 class=\'sec1\' id=\'Data\'>Data</h1>#msU','\\2',$strEcologyNotes);
        # Notes original sections
        # Notes subsectionwise
//           $strNotes   = preg_replace('#^(<h[1-5].+)(</h[1-5]>)$#meU',"'\\1 '.\$objHtml->pencil('edit=notes&amp;genus='.\$spec->genus.'&amp;id_characters='.\$spec->id_characters.'&amp;genus_valid_id='.\$_GET['genus_valid_id'].'&amp;section='.++\$intSectNotes,'popup.php','title=\'Click to edit only this section from DB-field Notes (new window)\' ','b_edit_section2.gif').'\\2'",$strNotes);
        $strEcologyNotes= preg_replace("#<h1 class='sec1' id='Data'>Data.+</h1><!-- Data original -->#msU"," ",$strEcologyNotes);
        $strEcologyNotes = $strEcologyNotes.'<h1 class=\'sec1\' id=\'Data\'>Data</h1>';
      /*
        $strEcology = preg_replace('/(.+Ecology<\/h1>[\n\r]<!-- Ecology original -->.+)(<h1 +class=\'sec1\' +id=\'Notes\'>Notes<\/h1>[\n\r]<!-- Notes original -->.+)[\n\r]<h1 *class=\'sec1\' *id=\'Data\' *>Data<\/h1>/msU','\\1',$strEcologyNotes);
        # Ecology original sections
          $strEcology = preg_replace('#Ecology</h1>[\n\r]<!-- Ecology original -->#ms','Ecology '.$editEcology.'</h1>',$strEcology);
        # Ecology subsectionwise
          $strEcology = preg_replace('#^(<h[1-5].+)(</h[1-5]>)$#me',"'\\1 '.\$objHtml->pencil('edit=ecology&amp;genus='.\$spec->genus.'&amp;id_characters='.\$spec->id_characters.'&amp;genus_valid_id='.\$_GET['genus_valid_id'].'&amp;section='.++\$intSectEco,'popup.php','title=\'Click to edit only this section from DB-field Ecology (new window)\' ','b_edit_section2.gif').'\\2'",$strEcology);
      # Notes
        $strNotes   = preg_replace('#(.+Ecology</h1>[\n\r]<!-- Ecology original -->.+)(<h1\s+class=\'sec1\'\s+id=\'Notes\'>Notes</h1>[\n\r]<!-- Notes original -->.+)<h1 class=\'sec1\' id=\'Data\'>Data</h1>#msU','\\2',$strEcologyNotes);
        # Notes original sections
          $strNotes   = preg_replace('#Notes</h1>[\n\r]<!-- Notes original -->#msU','Notes '.$editNotes.'</h1>',$strNotes);
        # Notes subsectionwise
          $strNotes   = preg_replace('#^(<h[1-5].+)(</h[1-5]>)$#meU',"'\\1 '.\$objHtml->pencil('edit=notes&amp;genus='.\$spec->genus.'&amp;id_characters='.\$spec->id_characters.'&amp;genus_valid_id='.\$_GET['genus_valid_id'].'&amp;section='.++\$intSectNotes,'popup.php','title=\'Click to edit only this section from DB-field Notes (new window)\' ','b_edit_section2.gif').'\\2'",$strNotes);
        $strEcologyNotes = $strEcology.$strNotes.'<h1 class=\'sec1\' id=\'Data\'>Data</h1>';
        */
      # @annotation ____: info level ($info, $toc)
        $info="Genus: <em>".$spec->genus."</em>".$toc;
      # @annotation ____: compose page ($content)
        include($currentServerPath.'structure/pages.php');
        $content = preg_replace(
        "#(<title>Characters)(</title>)#",
        "\\1 of genus ".$spec->genus." (".$spec->subfamily.")\\2",
        $content);
        $content.="
        <div class='title' id='toppage'>\n<h1 >Genus <em>".$spec->genus."</em>\n <small>(".$spec->subfamily.")</small> ".$editSubfamily."</h1>
          <span class='printinvisible'>Search:&nbsp;".$page['genus_searches']."\n<br></span>\n similar: ".$similar." ".$editSimilar."
          <div class='printvisible'><br>".print_r(date("l F j<\s\u\p>S</\s\u\p>, Y"),true)."</div>
        </div>\n";
      # @annotation ____: Ecology/Notes ($content, $toc)
        $content.="\n<hr>\n".$toc."\n<hr>\n";
        $content.="\n<div class='description'>\n";

        $content.="\n".$strEcologyNotes."\n".$data;
        $content.="\n  <h1 class='sec1' id='Images'>Images</h1>\n";
      }// end foreach genus
    }// end if SelectGenusCharacters
    if($_GET['morph_attrib_id']=='`names_subfamily`.`morph_attrib_id`') {
      // recieve all default structures like mentum 1, mentum, ...
      $_GET['morph_attrib_id']=$objMysql->querySingleItem("
        SELECT `names_subfamily`.`morph_attrib_id`
        FROM `names_valid`
        LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id` = `names_subfamily`.`id`
        WHERE (`names_valid`.`id` =".$_GET['genus_valid_id'].");
      ");
    }

  # @annotation ____: images: DB ShowSpeciesByGenus (start)
    include($currentServerPath.'structure/config.php');/* login */
    if($result=$objMysql->queryObjectArray($MysqlSelect['ShowSpeciesByGenus'])){
      foreach($result as $spec){
        $subfamily  = $spec->subfamily;
        $genus      = $spec->genus;
        $subgenus   = $spec->subgenus;
        $species    = $spec->species;
        $license    = $spec->license;
        $authors    = replaceHTMLcode($spec->authors_short);
        $descriptor = replaceHTMLcode($spec->descriptor);
        $descriptor_id = $spec->descriptor_id;
        $author_id  = $spec->names_authors_id;
        $annotation = $objHtml->emphase($spec->annote,$referenceArray,"references",false);
          $annotation=str_replace("'","\'",$annotation);
        $systematicNotes = $objHtml->emphase($spec->systematicNotes,$referenceArray,"references",false);
          $systematicNotes=str_replace("'","\'",$systematicNotes);
      # $annotation = $spec->annote;
        $file       = $spec->filename;
        $img_width  = $spec->img_width_default;
        $morph_long = $spec->morph_long;
        $valid_id   = $spec->valid_id;

      # @annotation ____: images: compose
        $subgenus = $subgenus ? "(<em>".$subgenus."</em>)" : "";
        $authors = $authors ? htmlentities($authors,ENT_QUOTES,'UTF-8') : "<span class=\'error\'>no author given</span>";
        $annotation = $annotation ? "<hr class=\'thin\'><img title=\'Note to this image\'  align=\'middle\' src=\'../structure/img/b_annote.png\' width=16 height=16 />&nbsp;".$annotation : "";
        $systematicNotes = $systematicNotes ? "<hr class=\'thin\'><img align=\'middle\'  title=\'systematic note\' src=\'../structure/img/b_systree_note.png\' width=16 height=16 />&nbsp;".$systematicNotes : "";
        $onmouseover="onmouseover=\"return overlib('<em>".$genus."</em> ".$subgenus." <em>".$species."</em> ".$descriptor." ".lb2string($annotation).lb2string($systematicNotes)."<hr class=\'thin\'><img src=\'../structure/img/book.png\' width=16 height=16 >&nbsp;".$authors."<br>".$license."', CAPTION, '".$morph_long."');\" onmouseout=\"return nd();\"";
        $descriptor = $descriptor_id==0 ? " <span class='attention'>".$descriptor."</span>" :  "<a class='reference' title='Click for reference.' target='chirokey_pupae' href='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#refid".$descriptor_id."'>".htmlentities($descriptor,ENT_QUOTES,'UTF-8')."</a>" ;

        $content.="\n<div class='imagebox'>\n   <span class=\"search\" title=\"Click to search &#187;".$genus." ".$species."&#171;\" onclick=\"check=confirm('You clicked on &#187;".$genus." ".$species."&#171;.\\nDo you wish to search this string in a new window?');if (check==false) return false; if (check==true) window.open('http://www.google.com/search?rls=en&amp;q=".$genus."+".$species."&amp;ie=utf-8&amp;oe=utf-8');\"><em  class='species'>".$genus." ".$subgenus." <br> ".$species."</em></span> ".$descriptor." \n<br>\n<br>\n  <a  class='nothing' ".$onmouseover." href='chirokey.php?show=compare&amp;valid_id=".$valid_id."&amp;similar_id=".$similar_id."'>";
        $content.="\n    <img src='../../".$config['dirSpec'].$file."' width='".$img_width."'>";
        $content.="\n  </a>\n</div>\n";
        $_SESSION['references'][] = $author_id;
        $_SESSION['references'][] = $descriptor_id;
      }// end foreach
      $content.="\n<div style='clear:left;'></div>\n";
    }else{// @annotation ____: no image genus
      if($result=$objMysql->querySingleItem("SELECT `morph_long` FROM `morph_attrib`, `names_subfamily` WHERE `morph_attrib`.`id` IN(".$_GET['morph_attrib_id'].") ;")){
        $content.=info_start($title="Info", 'info');
          $content.= "No image found for morphological structure: &#171;".$result."&#187;";
        $content.=info_end();
      }
    }// end no image found
    # @annotation ____: get reference id's ($_SESSION['references'])
      if($_SESSION['references']) {
        $refIds=implode(', ',array_filter($_SESSION['references']));
      }
      unset($_SESSION['references']);
      if(!empty($refIds)){
          $MySQL['addWHERE'] =" AND id IN(".$refIds.")";
        include(preg_replace('#(.+/)([^/]+/){0}[^/]+\.php#',"\\1\\3", __FILE__).'/references.php');// prints the references
      }
    $content.="\n </div> <!-- end description --> \n";
    echo $content.($_SESSION['debug']==true? $objMysql->showStatistics():'').$page['footbefore'].$page['foot'];
    exit;
  break; // end show genus level
# @annotation show specimen
  case 'specimen':
  # @annotation ____:  no id_characters
    if(empty($_GET['id_characters'])) { // no selection
      $content.= info_start($title="Info", 'info').'No specimen was given. Error: valid_id is missing in URL.'.info_end();
      echo $content.$page['foot'];
      exit;
    }// end no selection
  # @annotation ____:  update authors ($_POST[update_characters_go])
    if(isset($_POST['update_characters_go'])){// update characters' reference
    $objMysql->execute("
      UPDATE `characters`
        SET `names_authors_id`= ".$_POST['author_id']."
        WHERE `id` = ".$_GET['id_characters']." LIMIT 1;
      ");
    unset($_POST);// delete POST
  }
  # @annotation ____: selections: specimens DB SpecimenCharacters
    if($result=$objMysql->queryObjectArray($MysqlSelect['SpecimenCharacters'])){
      foreach($result as $spec){# multiple entries
        $Select[$spec->id_characters] = $spec->specimen. " ".$spec->descriptor." from ".$spec->author." (id: ".$spec->id_characters.")";
      }// end foreach
   # @annotation ____: selections: other taxa
     $Select = $objHtml->select($Select, "id_characters", $_GET['id_characters'] , "", "value");
      $form = "<form action='' class='printinvisible'  name='select_characters' method='get'>\n";
      $form.= $Select;
      foreach ($_GET as $key => $value) {
        $form.= $key!="id_characters" ? "  <input type='hidden' value='".$value."' name='".$key."'>\n":"";
      }// end foreach GET variable
      $form.="  <input type='submit' value='go'>\n";
      $form.="</form>\n";
    }// end if result specimen
  # @annotation ____: selections: authors DB ReferencesReplace
    if($result=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
    foreach($result as $value)
        $referenceMenu[$value->id]=$value->authors_short;
      $default=array("NULL" => " No special author ");
      $referenceMenu= $default + $referenceMenu;
    }
  # @annotation ____: fetch single page DB SpecimenCharactersSingle
  if($result=$objMysql->queryObjectArray($MysqlSelect['SpecimenCharactersSingle'])){
    # @annotation ____: fetch if there are data in DB
      $resultBitlength=$objMysql->querySingleItem($MysqlSelect['SpecimenCharactersBitlenght']);

    # references
      # @annotation ____: add specimen's reference to $_SESSION for reference list
        $_SESSION['references'][] = $result[0]->author_id;
      # @annotation ____: form: selection authors
      $Select=$objHtml->select($referenceMenu,"author_id",$result[0]->author,"  title=\"select reference\" ");
      $form.= "<form action='' class='printinvisible' name='update_characters' method='post'>\n";
        $form.= $Select;
        foreach ($_GET as $key => $value) {
          $form.= $key!="id_characters"? "  <input type='hidden' value='".$value."' name='".$key."'>\n":"";
        }// end foreach GET variable
        $form.="  <input type='submit' value='update author' name='update_characters_go' onclick=\"if(document.update_characters.author_id.selectedIndex!=0) check=confirm('You will see only images from:\\n' + document.update_characters.author_id.options[document.update_characters.author_id.selectedIndex].text + '.\\nSelect «No special author» to see images for ".$result[0]->specimen." from all authors. But note that some data need to keep linked with the author.');if (check==false) return false;\">\n";
      $form.="</form>\n";
    # @annotation ____: content  (search)
      $genus =  $result[0]->specimen;# for search
      include($currentServerPath.'structure/pages.php');
    # head of page
      $content= $page['head'];
      foreach($result as $spec){
      # @annotation ____: content  (link back, add to $form)
        $form.="<span  class='printinvisible' >Go back to <a href='chirokey.php?genus_valid_id=".$spec->genus_valid_id."&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=genus#Data'><em>".$spec->genus."</em></a> (Data)</span>";
      # @annotation ____: content  (title)
        $content=preg_replace(
          "#(<title>Characters)(</title>)#",
          "\\1 of  ".$spec->specimen." (".$spec->subfamily.") from ".$spec->author."\\2",
          $content);
        $content.="  <div class='title' id='toppage'>";
        $content.="\n  <h1>";
          $content.="\n  <span class='printinvisible' title='modify numeric data in separate window' id='id_characters".$i++."'>";
            $content.="\n    <a class='external' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/tbl_change.php?db=".$config['database']."&amp;table=characters&amp;primary_key=+%60characters%60.%60id%60+%3D+".$spec->id_characters."&amp;token=".$_SESSION['PMA_single_signon_token']."&amp;sql_query=SELECT+%2A+FROM+%60characters%60&amp;goto=sql.php'>&nbsp;";
            $content.="   <img title='".($resultBitlength>1?'Additional (numeric) data for this entry in the database!':'Edit entry in phpmyadmin')."' src='../structure/img/tag_table_edit.".(1<(int)$resultBitlength?'gif':'png')."' width='22' height='22' align='middle'>\n    </a>&nbsp;";
          $content.="\n  </span>";
        $content.="\n    Taxon <em>".$spec->specimen."</em> ".$spec->descriptor;
        $content.="\n  </h1>";
      # @annotation ____: content  (insert & delete)
        /* see execute.php for variables */
        $content.="<form action='execute.php?action=delete_characters' method='POST' >
          <input type='hidden' name='id_characters' value='".$spec->id_characters."'>
          <input type='hidden' name='taxon' value='".$spec->specimen."'>
          <input type='hidden' name='link_back' value='chirokey.php?genus_valid_id=".$spec->genus_valid_id."&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=genus#Data'>";
        $content.="\n    <h2>";
          $content.="\n  <span class='printinvisible' title='add an additional new character page for ".$spec->specimen."'  >";
            $content.="\n    <a class='nothing' target='chirokey_pupae'  href = 'execute.php?action=insert_characters&amp;id_author=NULL&amp;taxon=".urlencode($spec->specimen)."&amp;author=&amp;names_valid_id=".$spec->names_valid_id."&amp;link_back=".urlencode("http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'])."'>&nbsp;";
            $content.="<img src='../structure/img/tag_table_edit_insert.png' width='22' height='22' align='middle'>\n    </a>&nbsp;";
          $content.="\n  </span>";
        $content.="(".$spec->subfamily.") from ".$spec->author;
        $content.="\n      <button class='printinvisible'  title=\"delete current dataset\" type=\"submit\" onclick=\"check=confirm('Do you really want to do delete dataset:\\n  ".$spec->specimen." ".$spec->descriptor."\\n  from ".$spec->author."\\n...in table characters? There is no way back!!!');if (check==false) return false;\" name=\"delete\">\n  <img src='../structure/img/b_drop.png' align='middle' width='16' height='16' > Delete\n     </button>\n";
        $content.="\n    </h2> \n";
        $content.="</form>";
        $content.="<span class='printinvisible'>Search:&nbsp;".$page['genus_searches']."\n<br></span>\n
            <div class='printvisible'><br>".print_r(date("l F j<\s\u\p>S</\s\u\p>, Y"),true)."</div>
          </div>\n";
      # @annotation ____: sections ($strEcologyNotes)
        # seems to need a end-marker to separate correctly the sections
        $strEcologyNotes = "\n=Ecology=\n<!-- Ecology original -->\n".$spec->ecology."\n=Notes=\n<!-- Notes original -->\n".$spec->notes;
      # @annotation ____: repelace images Img:Prcl_chor_hes_Rie2001_r.jpg ($strEcologyNotes)
        if(preg_match("#Img:[A-za-z_.0-9]+#",$strEcologyNotes))
          if($result=$objMysql->queryObjectArray($MysqlSelect['AllSpeciesImages'])){
            foreach($result as $imgField)
              $arrImg[$imgField->filename] = $imgField->imageToReplace;

            $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$arrImg, "strImgToImage");
          }
        $strEcologyNotes    = $objHtml->pattern2tag($strEcologyNotes);
      # @annotation ____: genera highlighting ($strEcologyNotes)
        if($resultsub=$objMysql->queryObjectArray($MysqlSelect['GeneraValidIdDesc'])){
          foreach($resultsub as $gen)
            $replacetext[$gen->valid_id]=$gen->genus_name;
        }
        $similar    = $objHtml->emphase($spec->similar,$replacetext,"idtogenus");
        $similar_id = implode(" ", $spec->similar); // for use with compare
        $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$replacetext,"genus");
        unset($replacetext);
      # @annotation ____: highlight references  ($strEcologyNotes)
        if($resultsub=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
          foreach($resultsub as $ref){
            $replacetext[$ref->id]=htmlentities($ref->authors_short,ENT_NOQUOTES,'UTF-8');
          }
        }
        $referenceArray=$replacetext;// copy references for later use
        $strEcologyNotes  = $objHtml->emphase($strEcologyNotes,$replacetext,"references");
        unset($replacetext);
      # @annotation ____: highlight species ($strEcologyNotes)
        if($resultsub=$objMysql->queryObjectArray($MysqlSelect['SpeciesName'])){
          foreach($resultsub as $species)
            $replacetext[$species->id]=htmlentities($species->name,ENT_QUOTES,'UTF-8');
        }
        $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$replacetext,"species");
      # @annotation ____: repelace Templates Template:ArrayKey ($strEcologyNotes)
        if(preg_match("#Template:[A-za-z:0-9]+#",$strEcologyNotes)){
          include($currentServerPath.'structure/templates.php');
            $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$templates, "strTemplateToHtml");
        }# Templates found
      # @annotation ____: maps ($strEcologyNotes)
        if(!preg_match("#<!--(?!\{\{openLayer)[^-->]*\{\{openLayer\|([^\|]+)\|.*-->#Usm",$strEcologyNotes))
          $strEcologyNotes = $objHtml->emphase($strEcologyNotes,$replacetext,"maps");

      # @annotation ____: create TOC ($toc)
        if(!empty($_SESSION['sections'])){
          $toc=implode("<br>\n  ",$_SESSION['sections']);// fetch sections
          $toc="\n<!-- Table of Content -->\n<div class='toc'>\n  <span style='font-size:125%;'>Table of Content:</span><br>\n  ".$toc."<br>\n  <a class='sec1' href='#Images'>Images</a><br>\n  <a class='sec1' href='#references'>References</a>\n</div>\n";
        }
        unset($_SESSION['sections']);// delete TOC
        unset($replacetext);
      # @annotation ____: edit pencils ($editSimilar, $edit...)
        $editSimilar   = isset($_SESSION) ? $objHtml->pencil('edit=similar&amp;genus='.$spec->genus.'&amp;genus_valid_id='.$_GET['genus_valid_id']) : '';
        $editSubfamily = isset($_SESSION) ? $objHtml->pencil('edit=subfamily&amp;genus='.$spec->genus.'&amp;genus_valid_id='.$_GET['genus_valid_id']) : '';
        $editEcology   = isset($_SESSION) ? $objHtml->pencil('edit=ecology&amp;id_characters='.$spec->id_characters.'&amp;genus='.$spec->specimen.'+from+'.$spec->author.'&amp;show=specimen&amp;valid_id='.$_GET['valid_id'].'&amp;genus_valid_id='.$_GET['valid_id'], 'popup.php','title=\'Click to edit the entire DB-field Ecology (new window)\'') : '';
        $editNotes     = isset($_SESSION) ? $objHtml->pencil('edit=notes&amp;id_characters='.  $spec->id_characters.'&amp;genus='.$spec->specimen.'+from+'.$spec->author.'&amp;show=specimen&amp;valid_id='.$_GET['valid_id'].'&amp;genus_valid_id='.$_GET['valid_id'], 'popup.php','title=\'Click to edit the entire DB-field Notes (new window)\'') : '';
      # split Ecology and Note section for sectionwise editing
      # @annotation ____: compose page (sectionwise editing)
        $strEcologyNotes = preg_replace('#Ecology</h1>[\n\r]<!-- Ecology original -->#ms','Ecology '.$editEcology.'</h1>',$strEcologyNotes);
        # Ecology/Notes subsectionwise
          $isEcology=true;
        /*
         if <!-- Notes original --> found then
          set isEcology=FALSE & replaces editNotes & reset intSection back to 1
          BEWARE of (...) !!!!
        */
        $strEcologyNotes = preg_replace('#^(<h[1-5][^>]+>[^<]+)(</h[1-5]>)$[\n\r]?(<!-- Notes original -->)?#mse',"'\\1 <!-- isSubsection='.(\$isEcology=(\$isEcology? ('\\3'=='<!-- Notes original -->'? false:true):false)).'-->'.('\\3'=='<!-- Notes original -->'?\$editNotes :( \$objHtml->pencil('show=specimen&amp;edit='.(\$isEcology? 'ecology':'notes').'&amp;genus='.\$spec->specimen.'&amp;id_characters='.\$spec->id_characters.'&amp;genus_valid_id='.\$_GET['valid_id'].'&amp;valid_id='.\$_GET['valid_id'].'&amp;section='.\$intSection=(\$isEcology? ++\$intSection:++\$intSectionAnew),'popup.php','title=\'Click to edit only this section from DB-field '.(\$isEcology? 'Ecology':'Notes').' (new window)\' ','b_edit_section2.gif'))).'\\2'",$strEcologyNotes);
      /*
        $strEcology = preg_replace('#(.+Ecology</h1>[\n\r]<!-- Ecology original -->.*)(<h1 +class=\'sec1\' +id=\'Notes\'>Notes</h1>[\n\r]<!-- Notes original -->.+)<!--MARKERENDDOCUMENT-->#msU','\\1',$strEcologyNotes);
        # Ecology original sections
          $strEcology = preg_replace('#Ecology</h1>[\n\r]<!-- Ecology original -->#ms','Ecology '.$editEcology.'</h1>',$strEcology);
        # Ecology subsectionwise
          $strEcology = preg_replace('#^(<h[1-5].+)(</h[1-5]>)$#me',"'\\1 '.\$objHtml->pencil('show=specimen&amp;edit=ecology&amp;genus='.\$spec->genus.'&amp;id_characters='.\$spec->id_characters.'&amp;genus_valid_id='.\$_GET['valid_id'].'&amp;valid_id='.\$_GET['valid_id'].'&amp;section='.++\$intSectEco,'popup.php','title=\'Click to edit only this section from DB-field Ecology (new window)\' ','b_edit_section2.gif').'\\2'",$strEcology);
          #http://localhost/chip/pupae/key/chirokey.php?id_characters=712&morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&show=specimen&valid_id=721
      # Notes
        $strNotes   = preg_replace('#(.+Ecology</h1>[\n\r]<!-- Ecology original -->.+)(<h1\s+class=\'sec1\'\s+id=\'Notes\'>Notes</h1>[\n\r]<!-- Notes original -->.+)<!--MARKERENDDOCUMENT-->#msU','\\2',$strEcologyNotes);
        # Notes original sections
          $strNotes   = preg_replace('#Notes</h1>[\n\r]<!-- Notes original -->#msU','Notes '.$editNotes.'</h1>',$strNotes);
        # Notes subsectionwise
          $strNotes   = preg_replace('#^(<h[1-5].+)(</h[1-5]>)$#meU',"'\\1 '.\$objHtml->pencil('show=specimen&amp;edit=notes&amp;genus='.\$spec->genus.'&amp;id_characters='.\$spec->id_characters.'&amp;genus_valid_id='.\$_GET['valid_id'].'&amp;valid_id='.\$_GET['valid_id'].'&amp;section='.++\$intSectNotes,'popup.php','title=\'Click to edit only this section from DB-field Notes (new window)\' ','b_edit_section2.gif').'\\2'",$strNotes);
        $strEcologyNotes = $strEcology.$strNotes;
        */
      # @annotation ____: info level + TOC menu ($info, $toc)
        $info="Taxon: <em>".$spec->specimen."</em>".$toc;
          include($currentServerPath.'structure/pages.php');

        $content.="<div style='text-align:center;'>".$form."</div>";
      # @annotation ____: Ecology/Notes ($content)
        $content.="\n<hr>\n".$toc."\n<hr>\n";
        $content.="\n<div class='description'>\n";

        $content.="\n".$strEcologyNotes."\n";
      # @annotation ____: Images ($content)
        $content.="\n  <h1 class='sec1' id='Images'>Images</h1>\n";
      }// end foreach single specimen
    }// end if result SpecimenCharactersSingle
  # @annotation ____: image compose (start)
    include($currentServerPath.'structure/config.php');/* login */
    # @annotation ____: highlight references DB ReferencesReplace
      if($referenceList=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
        foreach($referenceList as $ref){
          $replacetext[$ref->id]=htmlentities($ref->authors_short,ENT_NOQUOTES,'UTF-8');
        }
      }
    # @annotation ____: fetch images DB SpeciesBySpecimens
      if($result=$objMysql->queryObjectArray($MysqlSelect['SpeciesBySpecimens'])){
        foreach($result as $spec){
          $license       = $spec->license;
          $subgenus      = $spec->subgenus ? "(".$spec->subgenus.") " : "";
          $specimen      = $spec->genus." ".$subgenus.$spec->species;
          $descriptor    = replaceHTMLcode($spec->descriptor);
          $descriptor_id = $spec->descriptor_id;
          $authors       = replaceHTMLcode($spec->authors_short);
          $authors_id    = $spec->authors_id;
          //emphase($originaltext='',$replacetext='',$contenttype='')
          $annotation = $objHtml->emphase($spec->annote,$replacetext,"references",true);
            $annotation=str_replace("'","\'",$annotation);
          $systematicNotes = $objHtml->emphase($spec->systematicNotes,$replacetext,"references",true);
            $systematicNotes=str_replace("'","\'",$systematicNotes);
          $file         = $spec->filename;
          $img_width    = $spec->img_width_default;
          $morph_long   = $spec->morph_long;
          $reference    = replaceHTMLcode($spec->authors_short);

          $descriptor_overlib =$descriptor_id==0 ? " <span class=\'attention\'>".$descriptor."</span>" :  "<a class=\'reference\' title=\'Click for reference.\' target=\'chirokey_pupae\' href=\'http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#refid".$descriptor_id."\'>".htmlentities($descriptor,ENT_QUOTES,'UTF-8')."</a>" ;
          $authors = $authors ? "<a class=\'reference\' target=\'chirokey_pupae\' href=\'http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#refid".$authors_id."\'>".htmlentities($authors,ENT_QUOTES,'UTF-8')."</a>" : "<span class=\'error\'>no author given</span>";
          $annotation = $annotation ? "<hr class=\'thin\'><img title=\'Note to this image\'  align=\'middle\' src=\'../structure/img/b_annote.png\' width=16 height=16 />&nbsp;".$annotation : "";
          $systematicNotes = $systematicNotes ? "<hr class=\'thin\'><img align=\'middle\'  title=\'systematic note\' src=\'../structure/img/b_systree_note.png\' width=16 height=16 />&nbsp;".$systematicNotes : "";

          $onmouseover="onmouseover=\"return overlib('<em>".$specimen."</em> ".$descriptor_overlib.lb2string($annotation).lb2string($systematicNotes)."<hr class=\'thin\'><img  align=\'middle\' title=\'reference\' src=\'../structure/img/book.png\' width=16 height=16 />&nbsp;".$authors;
          $onmouseover.="<hr class=\'thin\'>Search:&nbsp;";
            $arrSearch = array("FaunaEuropea", "Species2000", "ITIS", "GoogleImgages", "AskImages", "GoogleScholar", "Scirius", "ScienceDirect", "Jstor");
            foreach ($arrSearch as $value)
              $onmouseover.= $objHtml->searchStringOnline($spec->genus."+".$spec->species, $value, true);
          $onmouseover.="<hr class=\'thin\'>".$license."', CAPTION, '".$morph_long."', CENTER, STICKY, MOUSEOFF);\" onmouseout=\"return nd();\"";

          $content.=preg_match("#Firefox#i",$_SERVER['HTTP_USER_AGENT']) ? "\n<a class='nothing' href='image.php?popup=1&file=".$file."&specimen=".$specimen."&descriptor=".$descriptor."&morph_long=".$morph_long."&image_id=".$spec->image_id."' target='newWindow'>" : "\n<a class='nothing' onClick=\"window.open('image.php?popup=1&file=".$file."&specimen=".$specimen."&descriptor=".$descriptor."&morph_long=".$morph_long."&image_id=".$spec->image_id."', '','toolbar=no,status=yes,menubar=no,scrollbars=yes,width=900,height=550')\"  ".$onmouseover.">\n";
          $content.="  <img style='border:1px dotted;padding:5px;'  src='../../".$config['dirSpec'].$file."' width='".$img_width."' alt='".$specimen."'>";
          $content.="\n</a>\n";
          $last_specimen=$specimen;

          $_SESSION['references'][] = $descriptor_id;
          $_SESSION['references'][] = $authors_id;
      }// end foreach specimen
//       print_pre($MysqlSelect['SpeciesBySpecimens']);
    $content.="\n<div style='clear:left;'></div>\n";
    }// end fetch SpeciesClicked
    else{// @annotation ____: no image genus
      if($result=$objMysql->querySingleItem("SELECT `morph_long` FROM `morph_attrib`, `names_subfamily` WHERE `morph_attrib`.`id` IN(".$_GET['morph_attrib_id'].") ;")){
        $content.=info_start($title="Info", 'info');
          $content.= "No image found for morphological structure: &#171;".$result."&#187;";
        $content.=info_end();
      }
    }// end no image found

  # @annotation ____: references
    if($_SESSION['references']) {
      $refIds=implode(', ',array_filter($_SESSION['references']));
    }
    unset($_SESSION['references']);
    if(!empty($refIds)){
        $MySQL['addWHERE'] =" AND id IN(".$refIds.")";
      include(preg_replace('#(.+/)([^/]+/){0}[^/]+\.php#',"\\1\\3", __FILE__).'/references.php');// prints the references
    }
    $content.=" \n</div> <!-- end description --> \n";
    echo $content.($_SESSION['debug']==true? $objMysql->showStatistics():'').$page['footbefore'].$page['foot'];
    exit;
  break; // end show specimen's level
  case 'compare': // @annotation show compared
  $content.= "<table width=\"100%\" >";
  $content.="
  <th style=\"border:0px;text-align:center;\">
    v&nbsp;v&nbsp;v&nbsp; selected specimen <em>".$_GET['genus']."</em>&nbsp;v&nbsp;v&nbsp;v&nbsp;
  </th>";
  $content.='
    <tr>
      <script type="text/javascript">
        var h = 0;
        var w = 0;
        if (self.innerHeight) // all except Explorer
        {
          w = self.innerWidth;
          h = self.innerHeight;
        }
        else if (document.documentElement && document.documentElement.clientHeight)
          // Explorer 6 Strict Mode
        {
          w = document.documentElement.clientWidth;
          h = document.documentElement.clientHeight;
        }
        else if (document.body) // other Explorers
        {
          w = document.body.clientWidth;
          h = document.body.clientHeight;
        }
        //alert(h);
      // automatic height of <td>
        function write_td(){
        document.write(\'<td width=100% height=\');
        var NewHeight=h/2-30;
        document.write(NewHeight);
        document.writeln(\'  style="text-align:left;">\');
          }
      // automatic height of <iframe></iframe>
        function write_iframe(src){
        document.write(\'<iframe \');
        document.write(\'src="\'+ src + \'" name="compare" width=99%\');
        var NewHeight=h/2-30;
        document.write(\' height=\');document.write(NewHeight);
        document.writeln(\' scrolling=auto marginheight=10 marginwidth=10 align=right frameborder=0>\');
        document.writeln(\'  <\/iframe>\');
          }
      </script>
      <script type="text/javascript">
      // write <td> here
        write_td();
      // first iframe:self.php here
        write_iframe(\'self.php?show=species\&amp;valid_id='.$_GET['valid_id'].'\');
      </script>
      </td>
    </tr>';
  $content.="
    <th style=\"border:0px;text-align:center;\">
      v&nbsp;v&nbsp;v&nbsp; comparing with selected <em>".$_GET['genus']."</em>&nbsp;v&nbsp;v&nbsp;v&nbsp;
    </th>\n
    <tr>
      <td style=\"border:0px;\">";//folgender <iframe> in Tabelle eingebettet...

  $content.='
      <script type="text/javascript">
        // automatic height of iframe
          write_iframe(\'compare.php?show=species\&amp;valid_id='.$_GET['valid_id'].'&amp;similar_id='.$_GET['similar_id'].'\');
      </script>';
  $content.="\n
      </td>
    </tr>
 </table>";
  echo $content.$page['foot'];
  exit;
    break;// end show compare
  case 'references': // @annotation show references
  $MySQL['addWHERE'] ="";
  include(preg_replace('#(.+/)([^/]+/){0}[^/]+\.php#',"\\1\\3", __FILE__).'/references.php');
    echo $content.($_SESSION['debug']? $objMysql->showStatistics():'').$page['foot'];
    exit;

    break;// end references
  default: // @annotation no variables
  $content.=$page['first'];
  echo $content.$page['foot'];
  break;
  exit;
}// end switch cases $_GET['show']

?>
