<?php
/**
 * Upload images
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-06-11 09:08:34
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @todo minor issue: document further detailed
 * @internal only check: proper update if user does something wrong (?dublicate saving)
 * @package chirokey_pupae
 * @subpackage program
 */

/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
 $currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/session.inc.php');
include($currentServerPath.'structure/functions.php');
include($currentServerPath.'structure/classes/filemanage.php');
include($currentServerPath.'structure/classes/tools.php');
include($currentServerPath.'structure/classes/sql.php');
include($currentServerPath.'structure/config.php');
$date=date("F j D, Y, g:i a O T");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>

<head>
  <title>Upload Images</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel='StyleSheet' href='../structure/css/basic.css'>
   <script type="text/javascript" src="../structure/js/overlib.js"></script>
</head>
<body>
<fieldset id='uploadImage' >
<legend><h2>Upload image</h2></legend>
<div style="text-align:center;">
<ul style="margin:auto;text-align:justify;width:90%;">
  <li>Upload will only work if <span class="necessary">&nbsp;necessary fields&nbsp;</span> are selected! </li>
  <li>Select a specimen, that is already stored in the database (Options will automatically change) or select a new combination:</li>
  <li>It's recommended to use *.gif for gray scaled images and *.png for colored images because they use compression without loosing quality. Jpeg files instead reduce the image quality in fine details of images due to jpeg-compression algorithm but on the other hand they have often a lower file size when colored images are used.</li>
</div>
</ul>

<form action="<?="http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#uploadImage";?>"  method='POST' enctype='multipart/form-data'>
  <input type='hidden' name='uploadImage' value='1'>
<table cellpadding='5' summary='upload files, select species'>
  <tr>
<!--     <td> -->
<!--   <input type="hidden" name="MAX_FILE_SIZE" value="<? /* =$config['img_max_filesize']*1024;*/?>"> -->
<!--     </td> -->
    <td>
<?
$objMysql = new db_mysql;//class db_mysql
$objHtml  = new html;//class html

  ##@annotation: select menus: already in DB
  if($result=$objMysql->queryObjectArray($MysqlSelect['AlreadyInDatabase'])){
    foreach($result as $value)
      $Select[$value->value]=$value->text;
    $default=array("NULL" => "-- select a specimen already stored in database -- ");
    $Select = $default + $Select;
  }
  $default = isset($_POST['genus_already']) ? $Select[$_POST['genus_already']] : '-- select a specimen already sored in database -- ';
  $HTMLelement="
    <SCRIPT LANGUAGE=\"JavaScript1.2\">
    // script to change options
      function changeSelects(str) {
        str=str.split('!');
        for (var i = 0; i < str.length; i++) {
          selectByName=str[i].split('|');
            var whichIndex = document.getElementsByName(selectByName[1])[0].selectedIndex
            var setTo      = document.getElementsByName(selectByName[1])[0].options[whichIndex].value
            var db         = selectByName[0]
            for (var n = 0; n < document.getElementsByName(selectByName[1])[0].options.length; n++) {
                if(document.getElementsByName(selectByName[1])[0].options[n].value == db){
                  document.getElementsByName(selectByName[1])[0].options[n].selected = true
                }
            }// end for level 2
        }// end for level 1
      }// end function changeSelects
    </SCRIPT>
  ";
  $HTMLelement.=$objHtml->select($Select,"genus_already",$default," onchange=\"changeSelects(this.value);\" title=\"select a specimen already sored in database\"");
  $selection=$HTMLelement."<br>";
  unset($Select);


##@annotation: select menus: genus query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['GeneraValidId'])){
    foreach($result as $value)
      $Select[$value->genus_valid_id]=$value->genus_name;
    $default=array("NULL" => "-- select genus -- ");
    $Select = $default + $Select;
  }
  $default = isset($_POST['genus_valid_id']) ? $Select[$_POST['genus_valid_id']] : '-- select genus -- ';
  $HTMLelement=$objHtml->select($Select,"genus_valid_id",$default,"style='width:300px;' class='necessary' title='genus name'");
  $SelectGenusName=$HTMLelement;
  $selection.=$HTMLelement."&nbsp;or add/modify <a class=\"external\" onmouseover=\"return overlib('After adding you must refresh this site by clicking the Images menu again!');\" onmouseout=\"return nd();\" target=\"_blank\" href=\"http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_genera&goto=tbl_structure.php&back=tbl_structure.php\">genus name...</a><br>";
  unset($Select);

##@annotation: select menus: species query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['SpeciesIdName'])){
    foreach($result as $value)
      $Select[$value->id]=$value->name;
  }
  $default = array("NULL" => "-- select species -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['species_id']) ? $Select[$_POST['species_id']] : '-- select species -- ';
  $HTMLelement = $objHtml->select($Select,"species_id",$default,"style='width:300px;' class='necessary' title='species name'");
  $SelectSpeciesName=$HTMLelement;
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"After adding you must refresh this site by clicking the Images menu again!\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_species&goto=tbl_structure.php&back=tbl_structure.php'>species name...</a><br>";
  unset($Select);

##@annotation: select menus: subfamily query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['SubfamilyNames'])){
    foreach($result as $value)
      $Select[$value->id]=$value->name;
  }
  $default = array("NULL" => "-- select subfamily -- ");
  $Select = $default + $Select;
  $default = isset($_POST['subfamily_id']) ? $Select[$_POST['subfamily_id']] : '-- select subfamily -- ';
  $HTMLelement = $objHtml->select($Select,"subfamily_id",$default,"style='width:300px;' class='necessary' title='subfamily name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"After adding you must refresh this site by clicking the Images menu again!\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_subfamily&goto=tbl_structure.php&back=tbl_structure.php'>subfamily name...</a><br>";
  unset($Select);

##@annotation: select menus: tribe query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['TribeNames'])){
    foreach($result as $value)
      $Select[$value->id]=$value->name;
  }
  $default = array("NULL" => "-- select tribe -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['tribe_id']) ? $Select[$_POST['tribe_id']] : '-- select tribe -- ';
  $HTMLelement = $objHtml->select($Select,"tribe_id",$default,"style='width:300px;'  title='tribe name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"After adding you must refresh this site by clicking the Images menu again!\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_tribe&goto=tbl_structure.php&back=tbl_structure.php'>tribe name...</a><br>";
  unset($Select);

##@annotation: select menus: subtribe query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['SubtribeNames'])){
    foreach($result as $value)
      $Select[$value->id]=$value->name;
  }
  $default = array("NULL" => "-- select subtribe -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['subtribe_id']) ? $Select[$_POST['subtribe_id']] : '-- select subtribe -- ';
  $HTMLelement = $objHtml->select($Select,"subtribe_id",$default,"style='width:300px;' title='subtribe name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"After adding you must refresh this site by clicking the Images menu again!\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_subtribe&goto=tbl_structure.php&back=tbl_structure.php'>subtribe name...</a><br>";
  unset($Select);

##@annotation: select menus: subgenus query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['SubgenusNames'])){
    foreach($result as $value)
      $Select[$value->id]=$value->name;
  }
  $default = array("NULL" => "-- select subgenus -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['subgenus_id']) ? $Select[$_POST['subgenus_id']] : '-- select subgenus -- ';
  $HTMLelement = $objHtml->select($Select,"subgenus_id",$default,"style='width:300px;' title='subgenus name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"After adding you must refresh this site by clicking the Images menu again!\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_subgenus&goto=tbl_structure.php&back=tbl_structure.php'>subgenus name...</a><br>";
  unset($Select);

##@annotation: select menus: reference + descriptor query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
    foreach($result as $value)
      $Select[$value->id]=$value->authors_short;
  }
  $defaultRef        = array("NULL" => "-- select reference -- ");
  $defaultDescriptor = array("0" => "-- select first descriptor -- ");
  $Select['Ref']         = $defaultRef + $Select;
  $Select['Descriptor']  = $defaultDescriptor + $Select;
  $default = isset($_POST['author_name_id_reference']) ? $Select['Ref'][$_POST['author_name_id_reference']] : '-- select reference -- ';
    $HTMLelement = $objHtml->select($Select['Ref'],"author_name_id_reference",$default,"style='width:300px;' class='necessary' title='reference author'");
    $selection.=$HTMLelement."&nbsp;or add/modify <a target='chirokey_pupae' href='update.php?title=references&amp;refid=new'>references...</a><br>";
  $default = isset($_POST['authors_names_id_descriptor']) ? $Select['Descriptor'][$_POST['authors_names_id_descriptor']] : '-- select first descriptor -- ';
    $HTMLelement = $objHtml->select($Select['Descriptor'],"authors_names_id_descriptor",$default,"style='width:300px;' title='first descriptor'");
    $selection.=$HTMLelement;
  $Select['InBrackets']= array("NULL" => "-- brackets? -- ","0" => "no","1" => "yes");
  $default = isset($_POST['in_brackets']) ? $Select['InBrackets'][$_POST['in_brackets']] : '-- brackets? -- ';
    # select compares the options not the value
    $HTMLelement = $objHtml->select($Select['InBrackets'],"in_brackets",$default,"style='width:150px;' title='descriptor in brackets?'");
    $selection.=$HTMLelement."&nbsp;or add/modify <a target='chirokey_pupae' href='update.php?title=references&amp;refid=new'>references...</a><br>";
    //$selection.=$default;
# $default = isset($_POST['in_brackets']) ? 'checked' :'';
# $selection.=$HTMLelement."<input name='in_brackets' type='checkbox' title='in brackets?' ".$default." value='1' >First descriptor in brackets? (...)<br>";
  unset($Select['Ref'],$Select['Descriptor'],$result,$Select);

##@annotation: select menus: morphological structure query+select
  if($result=$objMysql->queryObjectArray($MysqlSelect['MorphoIdShortLong'])){
    foreach($result as $value)
      $Select[$value->morph_short]= $value->morph_long;
  }
  $default = array("NULL" => "-- select morphological structure -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['structure_short']) ? $Select[$_POST['structure_short']] : '-- select morphological structure -- ';
  $HTMLelement = $objHtml->select($Select,"structure_short",$default,"style='width:300px;' class='necessary' title='morphological structure'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"After adding you must refresh this site by clicking the Images menu again!\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=morph_attrib&goto=tbl_structure.php&back=tbl_structure.php'>morphological structure...</a><br>";
  unset($Select);
  # annote
  $default = isset($_POST['annote']) ? $_POST['annote'] : '';
  $selection.="<textarea name='annote' title='important SHORT notes to the picture' style='width:300px;height:100px;'>".$default."</textarea>&nbsp;Notes<br>";

##@annotation: select menus: license query+select
  if($result=$objMysql->queryObjectArray("SHOW COLUMNS FROM `images` LIKE 'license';"))
      foreach($result as $value){
        $Select=explode("','",preg_replace("/(enum|set)\('(.+?)'\)/","\\2",$value->Type));
        $Select['Default']=$Select[0];
        $Select=array_combine($Select,$Select);
      }
    $default = array("NULL" => "-- select license -- ");
    $Select  = $default + $Select;
    $default = isset($_POST['license']) ? $Select[$_POST['license']] : 'only private usage';
    $HTMLelement = $objHtml->select($Select,"license",$default,"style='width:300px;' class='necessary'  title='license'");
    $selection.=$HTMLelement."&nbsp; add <a class='external' onmouseover='return overlib(\"You must add a value in ENUM() filed. After adding you must refresh this site by clicking the Images menu again!\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/tbl_structure.php?db=chirokey_pupae&table=images&goto=tbl_structure.php&back=tbl_structure.php'>license type</a><br>";
    unset($Select,$Select['Default']);
# print select menus
  echo $selection;

$objFileWriteDelete = new fileWriteDelete("../../".$config['dirSpec']);
$webpath         = $config['BaseUrl'].$config['dirSpec'];
/*[genus_valid_id] => 153
    [species_id] => 697
    [subfamily_id] => 1
    [tribe_id] => NULL
    [subtribe_id] => NULL
    [author_name_id_reference] => 20
    [structure_short] => sei*/
##@annotation: saving failed: sth. is missing
  if(isset($_POST['uploadImage'])){
    $missing.= $_POST['genus_valid_id']=="NULL" ? 'genus ' : '';
    $missing.= $_POST['species_id']=="NULL" ? 'species ' : '';
    $missing.= $_POST['subfamily_id']=="NULL" ? 'subfamily ' : '';
    $missing.= $_POST['author_name_id_reference']=="NULL" ? 'reference ' : '';
    $missing.= $_POST['structure_short']=="NULL" ? 'morphological&nbsp;structure ' : '';
    $missing.= $_POST['license']=="NULL" ? 'license ' : '';
    $missing.= empty($_FILES['uploadfile']['name']) ? 'a&nbsp;file ' :'';
    # replace ' ' -> ', '
    $missing = substr($missing,0,strlen($missing)-1);
    $missing = preg_replace(
      array("# #", "#,([^,]+)$#"),
      array(", ", " and \\1" ),
      $missing
    );
  # message
  if(!empty($missing))
    $message = "<div class='info'>Please select also <i>".$missing."</i>. ".empty($missing)."</div>";
  }// end saving failed

  if( empty($missing)==TRUE && isset($_POST['uploadImage'])==TRUE ){
##@annotation saving: start (nothing is missing)
  #print_r("empty: ".empty($missing));
  # prepare saving
    # replace difficult characters for HTML code in overlib('...')
    $_POST['annote'] = empty($_POST['annote']) ? 'NULL' : "'".replaceHTMLcode($_POST['annote'])."'";
    $_POST['license'] =  "'".$_POST['license']."'";
    $subgenus_id_NULL = $_POST['subgenus_id']== 'NULL' ? " IS NULL" : " = ".$_POST['subgenus_id']." ";
    //$_POST['in_brackets']= $_POST['in_brackets']!=1 ? 'NULL' : $_POST['in_brackets'];
  ##@annotation: saving: merge file name
  # genus name
    if($result=$objMysql->querySingleItem("SELECT `names_genera`.`name_short` FROM `names_genera` WHERE `names_genera`.`id` = ".$_POST['genus_valid_id']." LIMIT 1;"))
    $strFileName = $result;
  # subgenus name
    if($result=$objMysql->querySingleItem("SELECT `names_subgenus`.`name_short` FROM `names_subgenus` WHERE `names_subgenus`.`id` = ".$_POST['subgenus_id']."  LIMIT 1;")){
    $result = $result=="-1" ? '' : $result; # '-1' = not found
    $strFileName.= $result."_";}
  # species name
    if($result=$objMysql->querySingleItem("SELECT `name_short` FROM `names_species` WHERE `id` = ".$_POST['species_id']."  LIMIT 1;"))
    $strFileName.= $result."_";
  # structure
    $strFileName.= $_POST['structure_short']."_";
  # author name
    if($result=$objMysql->querySingleItem("SELECT `author_filename` FROM `names_authors` WHERE `id` = ".$_POST['author_name_id_reference']."  LIMIT 1;"))
    $strFileName.= $result;
   //echo "<pre>Name: ".$strFileName."|</pre>";

    $objFileWriteDelete->validateImage($_FILES['uploadfile']['tmp_name']);
  # test if already exist as file
    if(
      ($strFileInDB=$objMysql->querySingleItem("SELECT `filename` FROM `images` WHERE `filename` LIKE '".$strFileName."%'  LIMIT 1;")) !=-1 &&
      ($_POST['overwriting']==FALSE)
    ){
      $objFileWriteDelete->errors(10,$strFileInDB); // exit here
    }

  # query `authors_short` to write into image
    if($strReference=$objMysql->querySingleItem("SELECT `authors_short` FROM `names_authors` WHERE `id` = ".$_POST['author_name_id_reference']."  LIMIT 1;"))
  ##@annotation: saving: write file
    $objFileWriteDelete->write($strFileName,$strReference,$_FILES['uploadfile']['tmp_name']);
    /*
    in names_valid?
      - no -> INSERT
      - yes -> UPDATE

      in names_valid genus sp.?
        - no -> INSERT
        - yes -> void
      in characters?
        - no -> INSERT
        - yes -> void
    */
  ##@annotation: saving: is not in names_valid? überarbeiten
  $intValidId=$objMysql->querySingleItem("
    SELECT `names_valid`.`id`
      FROM `names_valid`
    WHERE
      `names_valid`.`genus_name_id`    = ".$_POST['genus_valid_id']." AND
      `names_valid`.`species_name_id`  = ".$_POST['species_id']." AND
      `names_valid`.`subgenus_name_id` $subgenus_id_NULL
     LIMIT 1;");
  if($intValidId==-1){
    ##@annotation: saving: is not in names_valid -> INSERT
      $objMysql->execute("
      INSERT INTO `names_valid` (
        `id`,
        `genus_name_id`,
        `species_name_id`,
        `descriptor_name_id`,
        `subfamily_name_id`,
        `in_brackets`,
        `tribe_name_id`,
        `subtribe_name_id`,
        `subgenus_name_id`
        )
      VALUES(
        '',
        ".$_POST['genus_valid_id'].",
        ".$_POST['species_id'].",
        ".$_POST['authors_names_id_descriptor'].",
        ".$_POST['subfamily_id'].",
        ".$_POST['in_brackets'].",
        ".$_POST['tribe_id'].",
        ".$_POST['subtribe_id'].",
        ".$_POST['subgenus_id']."
      );");
    if($intValidId=$objMysql->insertId());

         //echo "<br>names_valid nicht drin, letzte names_valid.id: ".$intValidId."<br>";
    } else {
  ##@annotation: saving: is in names_valid -> SELECT
      /* $intValidId=$objMysql->querySingleItem("
      SELECT `names_valid`.`id` FROM `names_valid`
      WHERE
        `names_valid`.`genus_name_id`    = ".$_POST['genus_valid_id']." AND
        `names_valid`.`species_name_id`  = ".$_POST['species_id']." AND
        `names_valid`.`subgenus_name_id` $subgenus_id_NULL
         LIMIT 1;");*/
      ##@annotation: saving: UPDATE table names_valid
      $objMysql->execute("
      UPDATE `names_valid` SET
        `genus_name_id`          = ".$_POST['genus_valid_id'].",
        `species_name_id`        = ".$_POST['species_id'].",
        `descriptor_name_id`     = ".$_POST['authors_names_id_descriptor'].",
        `subfamily_name_id`      = ".$_POST['subfamily_id'].",
        `in_brackets`            = ".$_POST['in_brackets'].",
        `tribe_name_id`          = ".$_POST['tribe_id'].",
        `subtribe_name_id`       = ".$_POST['subtribe_id'].",
        `subgenus_name_id`       = ".$_POST['subgenus_id']."
        WHERE `names_valid`.`id` = ".$intValidId."
        LIMIT 1;
    ");
    }# end is in names valid

  ##@annotation: saving: insert into images
    # get id for morphological structure
    if(($intMorphId=$objMysql->querySingleItem("
      SELECT `id` FROM `morph_attrib`
        WHERE
          `morph_attrib`.`morph_short` LIKE '".$_POST['structure_short']."'
            LIMIT 1
        ;"))!=-1){
      $intUserId = ($_SERVER['REMOTE_ADDR'] == "::1") ||
      ($_SERVER['REMOTE_ADDR'] == "127.0.0.1") ? 1 : $objMysql->querySingleItem("
      SELECT `id` FROM `users`
        WHERE `ip` LIKE '".$_SERVER['REMOTE_ADDR']."'
         LIMIT 1;");
      if(($objMysql->querySingleItem("
        SELECT `filename` FROM `images`
          WHERE `filename` LIKE '".$objFileWriteDelete->strFilename."'  LIMIT 1;
        "))==-1){
        # check IP address
      ##@annotation: saving: insert in DB
        $objMysql->execute("
          INSERT INTO `images`
            (`id`,
            `filename`,
            `annote`,
            `morph_id`,
            `names_authors_id`,
            `names_valid_id`,
            `license`,
            `users_id`)
          VALUES
            ('',
            '".$objFileWriteDelete->strFilename."',
            ".htmlentities($_POST['annote'],ENT_NOQUOTES,'UTF-8').",
            ".$intMorphId.",
            ".$_POST['author_name_id_reference'].",
            ".$intValidId.",
            ".$_POST['license'].",
            ".$intUserId.");");
          $upload="added";
      }else{# only update
      $objMysql->execute("
        UPDATE `images` SET
          `filename`         = '".$objFileWriteDelete->strFilename."',
          `annote`           = ".htmlentities($_POST['annote'],ENT_NOQUOTES,'UTF-8').",
          `morph_id`         = ".$intMorphId.",
          `names_authors_id` = ".$_POST['author_name_id_reference'].",
          `names_valid_id`   = ".$intValidId.",
          `license`          = ".$_POST['license'].",
          `users_id`         = ".$intUserId.",
          `time_modified`    = NOW()
          WHERE `filename` LIKE '".$objFileWriteDelete->strFilename."' LIMIT 1;");
        $upload="refreshed";
      }
    }# end write into table images

  ##@annotation:  saving: 'website' Genus sp. subgenus NULL is not in names_valid
  $intValidIdGenusSpec=$objMysql->querySingleItem("
    SELECT `names_valid`.`id` FROM `names_valid`
      WHERE
      `names_valid`.`genus_name_id`    = ".$_POST['genus_valid_id']." AND
      `names_valid`.`species_name_id`  = 192 AND
      `names_valid`.`subgenus_name_id` IS NULL
     LIMIT 1;");

    if($intValidIdGenusSpec==-1){
      $objMysql->execute("
        INSERT INTO `names_valid` (
          `id`,
          `genus_name_id`,
          `species_name_id`,
          `descriptor_name_id`,
          `subfamily_name_id`,
          `in_brackets`,
          `tribe_name_id`,
          `subtribe_name_id`,
          `subgenus_name_id`
        )
        VALUES(
          '',
          ".$_POST['genus_id'].",
          192,
          ".$_POST['authors_names_id_descriptor'].",
          ".$_POST['subfamily_id'].",
          ".$_POST['in_brackets'].",
          ".$_POST['tribe_id'].",
          ".$_POST['subtribe_id'].",
          'NULL'
        );
      ");
    if($intValidIdGenusSpec=$objMysql->insertId());
    } else {// Genus sp. subgenus NULL is in names_valid

      if($objMysql->querySingleItem("
        SELECT `characters`.`names_valid_id`
          FROM  `characters`, `names_valid`
        WHERE
          `names_valid`.`id` = `characters`.`names_valid_id` AND
          `names_valid`.`id` = ".$intValidIdGenusSpec."
        LIMIT 1
          ;")==-1){
        $objMysql->execute("
        INSERT INTO `characters`
        ( `id`, `names_valid_id`,`genus_info`)
        VALUES
        ( '',    ".$intValidIdGenusSpec.",     1);
        ");
        $info.="<p>A new genus website was added. Please refresh navigation menu above (Right mouse click something like: 'Frame > Refresh'.).</p>";
      }
    }# end UPDATE characters

  ##@annotation: saving: form to delete image
    $message.= "
    <form action='' method='POST'>
    <div class='notice'>
      ".$info."
      Picture <span class='file'>%2\$s</span> was ".$upload.". <br>(".$date.")
        <button title='delete image' type='submit' onclick=\"check=confirm('Delete this image from database and species directory? There is no way back!!!\\n%2\$s');if (check==false) return false;\" name='delete' value='%2\$s'>
          <img src='../structure/img/b_drop.png' width='16' height='16' >
        </button><br>
      <img src='%1\$s' style='vertical-align:text-top;'>
    </div>
    </form>\n";
    unset($_POST);
}# end uploadImage

##@annotation: delete image: POST['delete']
  if(isset($_POST['delete']) && !empty($_POST['delete'])){
    //print_r($_POST);
    $objFileWriteDelete->deleteFile($_POST['delete']);
    $message = "<div class='notice'>Picture <span class='file'>%2\$s</span> was succesfully deleted from database and species directory. <br>(".$date.")</div>";
    $objMysql->execute("DELETE FROM `images` WHERE `filename` LIKE '".$_POST['delete']."' LIMIT 1;");
    if(isset($_POST['EditDeleteImages'])){
    # add an image warning message if an image was integrated in either `ecology` or `notes`
      $UPDATECharacters="UPDATE `characters`
        SET
          `notes`  = REPLACE(`notes`  ,'../../".$config['dirSpec']."/".$_POST['delete']."','image.php?text=image deleted: ".$_POST['delete']." (".$date.")&amp;img_warning=1'),
          `ecology`= REPLACE(`ecology`,'../../".$config['dirSpec']."/".$_POST['delete']."','image.php?text=image deleted: ".$_POST['delete']." (".$date.")&amp;img_warning=1'),
          `notes`  = REPLACE(`notes`  ,'Img:".$_POST['delete']."','<img src=\'image.php?text=image deleted: ".$_POST['delete']." (".$date.")&amp;img_warning=1\'>'),
          `ecology`= REPLACE(`ecology`,'Img:".$_POST['delete']."','<img src=\'image.php?text=image deleted: ".$_POST['delete']." (".$date.")&amp;img_warning=1\'>')
          ;";
      $objMysql->execute($UPDATECharacters);
    }
    unset($_POST);
  }# end UPDATECharacters


  # echo "<pre>";
  # print_r($_POST);
  # print_r($_SERVER);
  # print_r($_FILES);
  # print_r($_REQUEST);
  # echo "</pre>";
?>
      <input name='uploadfile' type='file' accept='image/*' >
      <input name='hochladen' type='submit' value='upload'><br>
      overwrite existing file? <input name='overwriting' type='radio' checked='false' value='1'>&nbsp;yes
      <input name='overwriting' type='radio' checked='true' value='0'>&nbsp;no
      </td>
    </tr>
  </table>
<?
# print all messagees
printf($message, $webpath.$objFileWriteDelete->strFilename, $objFileWriteDelete->strFilename);
?>
  </form>
</fieldset>
<?  // @annotation edit images (fieldset)?>
<fieldset  style='text-align:justify;' id='Edit_delete_Images'>
  <legend><h2>Edit/delete Images</h2></legend>
  <p>To modify images, select either genus or species name or both. You can also use <a class='menuCHIP' href='search.php' target='chirokey_pupae' >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_find.png' width='20' height='20'>&nbsp;Search</a> to search for image annotations.</p>
  <form action='<?="http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#EditDeleteImages";?>'  method='POST' enctype='multipart/form-data'   id='EditDeleteImages'>
  <input type='hidden' value='1' name='EditDeleteImages'>
  <?
  echo $SelectGenusName."<br>\n";
  echo $SelectSpeciesName."<br>\n";
  $SubmitEditDeleteImages="Fetch Images";
  ?>
    <input type='submit' value='<?=$SubmitEditDeleteImages;?>'>
  </form>
  <?
  if(isset($_POST['EditDeleteImages'])){
//   $_POST['species_id']= $_POST['species_id']=='NULL' ? '192' : $_POST['species_id'];
   include($currentServerPath.'structure/config.php');/* get query */
# echo "<pre>".print_r($MysqlSelect['Images'],true)."</pre>";
    if($result=$objMysql->queryObjectArray($MysqlSelect['Images'])){
      foreach($result as $value){
      # @annotation edit images: compose fetched data
        $add=isset($authorLast)? "</dl>" :"";
        $form = $authorLast==$value->authors_short ? "<dd>\n<form action='' method='POST'>\n" : $add."<dl style='border:1px solid gray;padding:10px;'><dt style='background-color:#F0F8FF;'>".$value->authors_short.": <em>".$value->title."</em> ".$value->journal."</dt><dd>\n<form action='' method='POST'>\n";
        $form.="<input type='hidden' value='1' name='EditDeleteImages'>";
        $form.=" <span class=\"overlib\" onmouseover=\"return overlib('<img align=\'middle\'  src=\'../../".$config['dirSpec'].$value->filename."\' >', FULLHTML, ABOVE, RIGHT,CENTER );\" onmouseout=\"return nd();\">
          <em>".$value->taxon."</em>
        </span>
          ".$value->descriptor."
        <a href='synonyms.php' target='chirokey_pupae' title='manage specimen&#039;s name' class='nothing'><img src='../structure/img/b_systree.png' align='middle' ></a>
          (".$value->morph_long.")
        <span class='nothing' title='modify specimen&#039;s image' onClick=\"window.open('image.php?popup=1&action=edit&names_valid_id=".$value->names_valid_id."&file=".$value->filename."&specimen=".$value->taxon."&descriptor=".$value->descriptor."&morph_long=".$value->morph_long."&image_id=".$value->image_id."', '','toolbar=no,status=yes,menubar=no,scrollbars=yes,width=".$config['popup']['windowWidth'].",height=".$config['popup']['windowHeight']."')\" >
          <img id='pencilEdit' src='../structure/img/b_edit.png' width='16' height='16' >
        </span>
        added:&nbsp;".$value->time_added." ".$value->time_modified."

      <button title='delete image' type='submit' onclick=\"check=confirm('Delete this image from database and species directory? There is no way back!!!\\n".$value->filename."');if (check==false) return false;\" name='delete' value='".$value->filename."'><img src='../structure/img/b_drop.png' width='16' height='16' ></button>
      </form>
      </dd>\n";
      echo $form;
        $authorLast=$value->authors_short;
      }# end foreach
    }
    else
      echo "<div class='info'>No images.</div>";#ManageSynonyms
  }# end form EditDeleteImages
?>
</fieldset>
<?

echo $_SESSION['debug']? $objMysql->showStatistics():'';
echo $_SESSION['debug']? "\$_POST:\n".print_pre($_POST, true)."":'';
echo "\n</body>";
 ?>