#!/bin/bash
# $Id: makedoc.sh,v 1.2 2007/12/10 01:11:19 ashnazg Exp $
# note phpdoc-templates uses iso-8859-1 but it is better to use utf-8
# (1) replace iso-8859-1 -> utf-8 for *.tpl files (/opt/lampp/lib/php/data/PhpDocumentor/phpDocumentor/Converters/)
# (2) comment out in /opt/lampp/lib/php/PhpDocumentor/phpDocumentor/Setup.inc.php
#    // fix 1151650
#    if (stristr($ret, "utf-8") !== "")
#/**
#  * makedoc - PHPDocumentor script to save your settings
#  *
#  * Put this file inside your PHP project homedir, edit its variables and run whenever you wants to
#  * re/make your project documentation.
#  *
#  * The version of this file is the version of PHPDocumentor it is compatible.
#  *
#  * It simples run phpdoc with the parameters you set in this file.
#  * NOTE: Do not add spaces after bash variables.
#  *
#  * @copyright         makedoc.sh is part of PHPDocumentor project {@link http://freshmeat.net/projects/phpdocu/} and its LGPL
#  * @author            Roberto Berto <darkelder (inside) users (dot) sourceforge (dot) net>
#  * @version           Release-1.1.0
#  */


##############################
# should be edited
##############################

#/**
#  * title of generated documentation, default is 'Generated Documentation'
#  *
#  * @var               string TITLE
#  */
TITLE="Programmers documentation of CHIP (pupae)"

#/**
#  * name to use for the default package. If not specified, uses 'default'
#  *
#  * @var               string PACKAGES
#  */
PACKAGES="chirokey_new"

#/**
#  * name of a directory(s) to parse directory1,directory2
#  * $PWD is the directory where makedoc.sh (?/tmp)
#  *
#  * @var               string PATH_PROJECT
#  */
# PATH_PROJECT=$PWD
PATH_PROJECT=/opt/lampp/htdocs/chip/pupae

#/**
#  * path of PHPDoc executable
#  *
#  * @var               string PATH_PHPDOC
#  */
PATH_PHPDOC=/opt/lampp/bin/phpdoc

#/**
#  * where documentation will be put
#  *
#  * @var               string PATH_DOCS
#  */
PATH_DOCS=$PATH_PROJECT/doc

#/**
#  * what outputformat to use (html/pdf)
#  *
#  * @var               string OUTPUTFORMAT
#  */
OUTPUTFORMAT=HTML

#/**
#  * converter to be used
#  *
#  * @var               string CONVERTER
#  */
# Smarty|default
CONVERTER=Smarty

#/**
#  * template to use
#  *
#  * @var               string TEMPLATE
#  */
TEMPLATE=default

#/**
#  * parse elements marked as private
#  *
#  * @var               bool (on/off)           PRIVATE
#  */
PRIVATE=off

# Running the command-line in unix
#   -c, --config
#   -cp, --converterparams
#   -ct, --customtags
#   -dh, --hidden
#   -dn, --defaultcategoryname
#   -dn, --defaultpackagename
#   -d, --directory
#   -ed, --examplesdir
#   -f, --filename
#   -i, --ignore file(s) that will be ignored, multiple separated by ','.  Wildcards * and ? are ok
#   -is, --ignoresymlinks
#   -it, --ignore-tags
#   -j, --javadocdesc
#   -o, --output
#   -pp, --parseprivate
#   -po, --packageoutput
#   -p, --pear
#   -q, --quiet
#   -ric, --readmeinstallchangelog
#   -s, --sourcecode
#   -t, --target
#   -tb, --templatebase
#   -ti, --title
#   -ue, --undocumentedelements
# make documentation

cd /opt/lampp/htdocs/chip/pupae/doc
rm elementindex_chirokey_pupae.html elementindex.html index.html packages.html classtrees_chirokey_pupae.html li_chirokey_pupae.html errors.html todolist.html ric_ChangeLog.html ric_Install.html

rm -r ./chirokey_pupae ./media
cd /opt/lampp/htdocs
echo -e "\033[0;38mFiles and old folders removed!!"
echo -e "\033[0;32mCreating documentation...\033[0;31m"

"$PATH_PHPDOC" -q -ue -d "$PATH_PROJECT" -t "$PATH_DOCS" -ti "$TITLE" -dn $PACKAGES \
-o 'HTML:frames:DOM/earthli' -ct 'annotation' -pp $PRIVATE \
--ignore '*test*,config_full.php,config_reduced.php' \
--readmeinstallchangelog 'Install,ChangeLog'
echo -e "\033[0;32mFinished.\033[0m"

# $OUTPUTFORMAT:$CONVERTER:$TEMPLATE

# see  /opt/lampp/lib/php/data/PhpDocumentor/docbuilder/images
# 'HTML:default:earthli' # Farbe mit Icons
# 'HTML:default:default'
# 'HTML:default:l0l33t'
# 'HTML:default:phpdoc.de'
# 'HTML:default:DOM/earthli' # mit Baumstruktur
# 'HTML:default:DOM/default' # kein Schnickschack gut lesbar
# 'HTML:default:DOM/l0l33t' # ttfamily auch +/- gut lesbar
# 'HTML:default:DOM/phpdoc.de'
# 'HTML:Smarty:default'
# 'PDF:default:default'
# 'CHM:default:default'

# 'HTML:frames:default'] = 'ss_HTML_frames_default.png'
# 'HTML:frames:earthli'] = 'ss_HTML_frames_earthli.png'
# 'HTML:frames:l0l33t'] = 'ss_HTML_frames_l0l33t.png'
# 'HTML:frames:phpdoc.de'] = 'ss_HTML_frames_phpdoc.de.png'
# 'HTML:frames:phphtmllib'] = 'ss_HTML_frames_phphtmllib.png'
# 'HTML:frames:phpedit'] = 'ss_HTML_frames_phpedit.png'
# 'HTML:frames:DOM/default'] = 'ss_HTML_frames_DOM-default.png'
# 'HTML:frames:DOM/earthli'] = 'ss_HTML_frames_DOM-earthli.png'
# 'HTML:frames:DOM/l0l33t'] = 'ss_HTML_frames_DOM-l0l33t.png'
# 'HTML:frames:DOM/phpdoc.de'] = 'ss_HTML_frames_DOM-phpdoc.de.png'
# 'HTML:frames:DOM/phphtmllib'] = 'ss_HTML_frames_DOM-phphtmllib.png'
# 'HTML:Smarty:default'] = 'ss_HTML_Smarty_default.png'
# 'HTML:Smarty:HandS'] = 'ss_HTML_Smarty_HandS.png'
# 'HTML:Smarty:PHP'] = 'ss_HTML_Smarty_PHP.png'
# 'PDF:default:default'] = 'ss_PDF_default_default.png'
# 'CHM:default:default'] = 'ss_CHM_default_default.png'
# 'XML:DocBook/peardoc2:default'] = 'ss_XML_DocBook-peardoc2_default.png'
#
# vim: set expandtab :

# <b> -- emphasize/bold text
# <code> -- Use this to surround php code, some converters will highlight it
# <br> -- hard line break, may be ignored by some converters
# <i> -- italicize/mark as important
# <kbd> -- denote keyboard input/screen display
# <li> -- list item
# <ol> -- ordered list
# <p> -- If used to enclose all paragraphs, otherwise it will be considered text
# <pre> -- Preserve line breaks and spacing, and assume all tags are text (like XML's CDATA)
# <samp> -- denote sample or examples (non-php)
# <ul> -- unordered list
# <var> -- denote a variable name