-- phpMyAdmin SQL Dump
-- version 3.2.1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Dec 15, 2009 at 10:53 AM
-- Server version: 5.1.37
-- PHP Version: 5.3.0

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `chirokey_larvae_reduced`
--

-- --------------------------------------------------------

--
-- Table structure for table `characters`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:44 AM
-- Last check: Dec 15, 2009 at 10:44 AM
--

DROP TABLE IF EXISTS `characters`;
CREATE TABLE IF NOT EXISTS `characters` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'primary key',
  `names_valid_id` int(10) unsigned NOT NULL COMMENT 'id from table names_valid',
  `names_authors_id` bigint(10) DEFAULT NULL COMMENT 'id from table names_authors',
  `notes` longtext COMMENT 'text for notes',
  `genus_info` tinyint(1) unsigned DEFAULT NULL COMMENT 's dataset shown as genus info page?',
  `ecology` longtext COMMENT 'text for ecology',
  `similar` varchar(255) DEFAULT NULL COMMENT 'simalar specimen (id´s from table names_valid)',
  `usertimestamp` text COMMENT 'timestamp',
  `ant_segments` tinyint(3) DEFAULT NULL COMMENT 'number of antennal segments',
  `ant_ratio_mean` float DEFAULT NULL COMMENT 'antennal ratio: 1st segment to 2+3+4+5..',
  `ant_spur` tinyint(1) unsigned DEFAULT NULL COMMENT 'antennal spur?',
  `ant_spur_note` varchar(255) DEFAULT NULL COMMENT 'antennal spur notes',
  `ant_ratio_variation` float DEFAULT NULL COMMENT 'antennal ratio variation',
  `ant_ratio_n` int(5) unsigned DEFAULT NULL COMMENT 'antennal ratio: number of individuals',
  `ant_ratio_note` text COMMENT 'notes to AR',
  `ant_ring-organ_ratio_mean` float DEFAULT NULL COMMENT 'antenna: relation of ring organ compared to the base of antennal segment 1 (0=at the base, 1=at the top of segment 1)',
  `ant_ring-organ_ratio_variation` float DEFAULT NULL COMMENT 'ratio of antennal ringorgan: variation',
  `ant_ring-organ_ratio_n` int(5) unsigned DEFAULT NULL COMMENT 'ratio of antennal ringorgan: number of individuals',
  `ant_ring-organ_notes` text COMMENT 'notes to antennal ring organ',
  `ant_blade_ratio_mean` float DEFAULT NULL COMMENT 'antennal blade ratio: remaining blade/ant-sgm (mean)',
  `ant_blade_ratio_variation` float DEFAULT NULL COMMENT 'antennal blade variation',
  `ant_blade_ratio_n` int(4) unsigned DEFAULT NULL COMMENT 'antennal blade ratio: n-Individual',
  `ant_blade_ratio_note` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'antennal blade ratio: notes',
  `ant_lauterborn_organ` varchar(255) DEFAULT NULL COMMENT 'notes to lauterborn organ at antenna',
  `ant_pedestal` enum('no','very small','small','width~length','longer than wide','very long (more than 2x width)') DEFAULT NULL COMMENT 'antennal pedestal: description',
  `ant_pedestal_ratio_mean` float DEFAULT NULL COMMENT 'antennal pedestal ratio length:width',
  `ant_pedestal_ratio_variation` float DEFAULT NULL COMMENT 'variation ratio (l:w) of antennal pedestal',
  `ant_pedestal_ratio_n` int(5) DEFAULT NULL COMMENT 'number of individuals of ratio (l:w) of antennal pedestal',
  `ant_pedestal_notes` text COMMENT 'notes on antenna',
  `ant_note` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'antenna: notes',
  `head_ratio_mean` float DEFAULT NULL COMMENT 'head ratio: length to width !!!',
  `head_ratio_variation` float DEFAULT NULL COMMENT 'variation head ratio (l:w !!!)',
  `head_ratio_n` int(5) unsigned DEFAULT NULL COMMENT 'number of individual of head ratio (l:w !!!)',
  `head_notes` text COMMENT 'haed ratio note',
  `head_color` varchar(255) DEFAULT NULL COMMENT 'head color',
  `head_postoccipital_plate` varchar(255) DEFAULT NULL,
  `head_postoccipital_margin` varchar(255) DEFAULT NULL,
  `head_pattern` varchar(255) DEFAULT NULL COMMENT 'head: pattern',
  `men_middle_tooth` tinyint(2) unsigned DEFAULT NULL COMMENT 'mentum: middle tooth/teeth',
  `men_middle_pattern` varchar(255) DEFAULT NULL COMMENT 'mentum: pattern middle tooth',
  `men_lateral_teeth` tinyint(2) unsigned DEFAULT NULL COMMENT 'mentum lateral teeth',
  `men_lateral_pattern` varchar(255) DEFAULT NULL COMMENT 'mentum: pattern lateral teeth',
  `men_ventromental_plates` varchar(255) DEFAULT NULL COMMENT 'mentum: ventromental plates',
  `men_middle_tooth_ratio_mean` float DEFAULT NULL COMMENT 'mentum middle tooth: width to length (mean)',
  `men_middle_tooth_ratio_variation` float DEFAULT NULL COMMENT 'mentum middle tooth: width to length (variation)',
  `men_middle_tooth_ratio_n` int(5) unsigned DEFAULT NULL COMMENT 'mentum middle tooth: width to length (n individuals)',
  `men_middle-1stlat_tooth_ratio_mean` float DEFAULT NULL COMMENT 'mentum: width middle tooth to width 1st lateral tooth (mean)',
  `men_middle-1stlat_tooth_ratio_variance` float DEFAULT NULL COMMENT 'mentum: width middle tooth to width 1st lateral tooth (variation)',
  `men_middle-1stlat_tooth_ratio_n` int(5) unsigned DEFAULT NULL COMMENT 'mentum: width middle tooth to width 1st lateral tooth (n individuals)',
  `men_s-submenti_v-plates-relation` enum('<','<=','=','>=','>') DEFAULT NULL COMMENT 'mentum: relation of seta submenti to the base of ventromental plate in proximity to the top of mentum (= means exact at the base of v-plates; near to mentum:<, <=, =, >=, > far from mentum)',
  `men_s-submenti_men-lat-tooth_position_mean` float DEFAULT NULL COMMENT 'below which lateral tooth the s-submenti is located (decimal values; also ''extraplolation'' possible) mean',
  `men_s-submenti_men-lat-tooth_position_variation` float DEFAULT NULL COMMENT 'variation seta submenti -ateral tooth position',
  `men_s-submenti_note` text,
  `men_beard` tinyint(1) DEFAULT NULL COMMENT 'mentum beard',
  `men_vmplates_note` varchar(255) DEFAULT NULL COMMENT 'notes on ventromental plates',
  `man_inner` float unsigned DEFAULT NULL COMMENT 'mandible: inner teeth',
  `man_apical` tinyint(1) unsigned DEFAULT '2' COMMENT 'mandible apical tooth',
  `man_outer` tinyint(2) unsigned DEFAULT NULL COMMENT 'mandible outer teeth',
  `man_surface` tinyint(2) unsigned DEFAULT NULL COMMENT 'mandible surface teeth',
  `man_notes` text COMMENT 'Notes to mandible',
  `man_margin_engraved` float DEFAULT NULL COMMENT 'is mandible engraved at the margin?',
  `man_tooth_ratio_mean` float DEFAULT NULL COMMENT 'mandible: ratio apical tooth to the streight length of all bases from inner teeth measured at the base of the teeth respectively',
  `man_tooth_ratio_min` float DEFAULT NULL COMMENT 'minimal mandible tooth ratio',
  `man_tooth_ratio_max` float DEFAULT NULL COMMENT 'maximal mandible tooth ratio',
  `man_tooth_ratio_n` int(5) unsigned DEFAULT NULL COMMENT 'number of individualsmandible tooth ratio',
  `man_pattern` varchar(255) DEFAULT NULL COMMENT 'mandible: pattern, colors of teeth, margin etc.',
  `man_s-interna` tinyint(1) unsigned DEFAULT NULL COMMENT 'mandible: seta interna yes/no',
  `man_s-interna_note` varchar(255) DEFAULT NULL COMMENT 'mandible: seta interna',
  `man_s-subdentalis` tinyint(1) unsigned DEFAULT NULL COMMENT 'mandible: seta subdentalis yes/no',
  `man_s-subdentalis_note` varchar(255) DEFAULT NULL COMMENT 'mandible: seta subdentalis',
  `max_palp` varchar(255) DEFAULT NULL COMMENT 'maxilla: palpus',
  `max_lacinal_chetae` varchar(255) DEFAULT NULL COMMENT 'maxilla: lacinal chetae',
  `max_pecten_galearis` varchar(255) DEFAULT NULL COMMENT 'maxilla: pecten galearis',
  `max_galea_lamellae` varchar(255) DEFAULT NULL COMMENT 'maxilla: galea lamellae',
  `lab_s1` float DEFAULT NULL COMMENT 'labrum: number of seta S1',
  `lab_s1_note` varchar(255) DEFAULT NULL COMMENT 'labrum: shape, notes seta S1',
  `lab_s2` float DEFAULT NULL COMMENT 'labrum: number of seta S2',
  `lab_s2_note` varchar(255) DEFAULT NULL COMMENT 'labrum: shape, notes seta S2',
  `lab_s3` float DEFAULT NULL COMMENT 'labrum: number of seta S3',
  `lab_s4` float DEFAULT NULL COMMENT 'labrum: number of seta S4',
  `lab_s_note` varchar(255) DEFAULT NULL,
  `lab_n-preman_mean` float(3,1) DEFAULT NULL COMMENT 'premandible: number of teeth (mean)',
  `lab_n-preman_min` int(4) DEFAULT NULL COMMENT 'premandible: minimal number of teeth ',
  `lab_n-preman_max` int(4) DEFAULT NULL COMMENT 'premandible: maximal number of teeth ',
  `lab_n-preman_n` int(4) DEFAULT NULL COMMENT 'premandible: number of measurements',
  `lab_preman_brush` tinyint(1) DEFAULT NULL COMMENT 'premandible brush',
  `lab_preman_notes` text COMMENT 'notes to premandible',
  `lab_pecten_epipharyngis` varchar(255) DEFAULT NULL,
  `lab_ligula` varchar(255) DEFAULT NULL,
  `abd_parapods` varchar(255) DEFAULT NULL,
  `abd_lateral_setae` varchar(255) DEFAULT NULL,
  `abd_procerus_color` varchar(255) DEFAULT NULL COMMENT 'color of procerus',
  `abd_procerus_ratio` float DEFAULT NULL COMMENT 'abdomen: ratio (l:w) of procerus',
  `abd_procerus_n-setae` int(4) DEFAULT NULL COMMENT 'abdomen: number of setae of procerus',
  `abd_procerus_n-setae_note` varchar(255) DEFAULT NULL COMMENT 'abdomen: notes on setae of procerus',
  `abd_procerus_n-subapical-setae` int(4) DEFAULT NULL COMMENT 'abdomen: number of subapical setae on procerus',
  `abd_procerus_n-subapical-setae_note` varchar(255) DEFAULT NULL COMMENT 'abdomen: notens on subapical setae on procerus',
  `abd_anal_papillae` varchar(255) DEFAULT NULL,
  `abd_color` varchar(255) DEFAULT NULL COMMENT 'color from larva',
  `length_min` float(3,1) DEFAULT NULL COMMENT 'larval length minimum',
  `length_max` float(3,1) DEFAULT NULL COMMENT 'larval length maximum',
  `length_mean` float(3,1) DEFAULT NULL COMMENT 'larval length mean',
  `length_n` tinyint(3) unsigned DEFAULT NULL COMMENT 'larval length how many ',
  PRIMARY KEY (`id`),
  KEY `names_valid_id` (`names_valid_id`),
  KEY `names_authors_id` (`names_authors_id`),
  FULLTEXT KEY `man_notes` (`man_notes`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='characters of chironomids' AUTO_INCREMENT=919 ;

--
-- RELATIONS FOR TABLE `characters`:
--   `names_authors_id`
--       `names_authors` -> `id`
--   `names_valid_id`
--       `names_valid` -> `id`
--

--
-- Dumping data for table `characters`
--

INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(1, 4, 21, '==Characters==\r\n\r\n{citeID|21|Cranston et.al. 1983}: The combination of broad ventromantal plate with well developed beared, absence of seta interna, and mentum with a broad median tooth weakly divided anteriorly into 4  parts is distinctive. In some specimens the anterior margin of the median tooth of the mentum is worn so that it appears smooth. The S1 is intermediate in structure between the bifid and plumose types with one or both of the main branches subdivided.&lt;/br&gt;\r\nPlank 15.8.2005: in sample 02-YeR-15-1-5 cf. Acricotopus longipalpus  (immature stage 2 or 3) with ''''one'''' middle tooth\r\n\r\n\r\n\r\n{| style=''border:1px solid;'' class=''table-autosort table-autofilter ''\r\n\r\n&lt;thead&gt;\r\n|-\r\n!class=''table-sortable:default ''|Reference\r\n!class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:numeric ''|Antennal ratio\r\n!im90 class=''table-sortable:numeric ''|Antenna: blade ratio\r\n!im90 class=''table-sortable:numeric ''|Antenna: RO ratio\r\n!im90 class=''table-sortable:numeric ''|S1 branches\r\n!im90 class=''table-sortable:numeric ''|mandible 1 st to combined 3 inner\r\n\r\n|-\r\n! class=''table-filterable ''|&lt;!-- Reference --&gt;\r\n! class=''table-filterable ''|&lt;!-- Taxon --&gt;\r\n!|&lt;input name=''filterAntennal2'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antennal ratio --&gt;\r\n!|&lt;input name=''filterAntenna3'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antenna: blade ratio --&gt;\r\n!|&lt;input name=''filterAntenna4'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antenna: RO ratio --&gt;\r\n!|&lt;input name=''filterS5'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- S1 branches --&gt;\r\n!|&lt;input name=''filtermandible6'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- mandible 1 st to combined 3 inner --&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|{citeID|28|Zelentsov 1992}\r\n|A.lucens&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_men_Zel1992_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_men_Zel1992_r.gif 2009-12-15 10:36:17''>\r\n|1.9, 2.0, 2.1, 2.2, 2.3 &lt;!-- AR --&gt;\r\n|0.7 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_ant_Zel1992_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_ant_Zel1992_r.gif 2009-12-15 10:36:17''>&lt;!-- blade ratio --&gt;\r\n|0.23 &lt;!-- RO ratio --&gt;\r\n|2, 3, 4 &lt;!-- S1 branches --&gt;\r\n|1.3 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_man_Zel1992_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_man_Zel1992_r.gif 2009-12-15 10:36:17''> &lt;!-- mandible --&gt;\r\n\r\n|-\r\n|{citeID|40|Wang and Wang 1991}\r\n|A.lucens&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_men_WSD1991_r.gif 2009-12-15 10:36:17''>\r\n|1.1 &lt;!-- AR --&gt;\r\n|0.58 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_ant_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_ant_WSD1991_r.gif 2009-12-15 10:36:17''>&lt;!-- blade ratio --&gt;\r\n|0.2 &lt;!-- RO ratio --&gt;\r\n|? &lt;!-- S1 branches --&gt;\r\n|1.21 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_man_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_man_WSD1991_r.gif 2009-12-15 10:36:17''> &lt;!-- mandible --&gt;\r\n\r\n|-\r\n|{citeID|29|Hirvenoja 1973}\r\n|A.lucens&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_men_Hir1973_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_men_Hir1973_r.gif 2009-12-15 10:36:17''>\r\n|2.3 &lt;!-- AR --&gt;\r\n|0.8 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_ant_Hir1973_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_ant_Hir1973_r.gif 2009-12-15 10:36:17''>&lt;!-- blade ratio --&gt;\r\n|? &lt;!-- RO ratio --&gt;\r\n|2 &lt;!-- S1 branches --&gt;\r\n|1.3 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_man_Hir1973_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_man_Hir1973_r.gif 2009-12-15 10:36:17''> &lt;!-- mandible --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|A.longipalpus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_lopa_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_lopa_men_Tsa1999_r.gif 2009-12-15 10:36:17''>\r\n|1.5, 1.6, 1.7, 1.8 &lt;!-- AR --&gt;\r\n|0.85 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_lopa_ant_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_lopa_ant_Tsa1999_r.gif 2009-12-15 10:36:17''>&lt;!-- blade ratio --&gt;\r\n|0.15 &lt;!-- RO ratio --&gt;\r\n|6, 7, 8, 9, 10 &lt;!-- S1 branches --&gt;\r\n|0.81 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_lopa_man_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_lopa_man_Tsa1999_r.gif 2009-12-15 10:36:17''> &lt;!-- mandible --&gt;\r\n\r\n|-\r\n|{citeID|39|Wang, Ji. 1987}\r\n|A.nitidellus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_men_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_men_WJi1987_r.gif 2009-12-15 10:36:17''> \r\n|2.1, 2.2, 2.3 (n=1) &lt;!-- AR --&gt;\r\n|0.97 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_ant_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_ant_WJi1987_r.gif 2009-12-15 10:36:17''>&lt;!-- blade ratio --&gt;\r\n|0.20 &lt;!-- RO ratio --&gt;\r\n|? &lt;!-- S1 branches --&gt;\r\n|1.38 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_man_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_man_WJi1987_r.gif 2009-12-15 10:36:17''> &lt;!-- mandible --&gt;\r\n\r\n|-\r\n|{citeID|43|Ye 1984}\r\n|A.nitidellus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_men_Ye1984_r.gif 2009-12-15 10:36:17''>\r\n|1.6, 1.7, 1.8 (n=1) &lt;!-- AR --&gt;\r\n|0.8 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_ant_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_ant_Ye1984_r.gif 2009-12-15 10:36:17''>&lt;!-- blade ratio --&gt;\r\n|0.23 &lt;!-- RO ratio --&gt;\r\n|5 {overlib|labro-epipharyngeal region|<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_lab_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_lab_Ye1984_r.gif 2009-12-15 10:36:17''>}&lt;!-- S1 branches --&gt;\r\n|0.74 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_man_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_man_Ye1984_r.gif 2009-12-15 10:36:17''> &lt;!-- mandible --&gt;\r\n\r\n|-\r\n|{citeID|424|Johannsen 1937}\r\n|A.nitidellus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Acricotopus nitidellus (mentum) Johannsen 1937'' src=''image.php?text=image deleted: Acri_nitu_men_Joh1937_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|? &lt;!-- AR --&gt;\r\n|? &lt;!-- blade ratio --&gt;\r\n|? &lt;!-- RO ratio --&gt;\r\n|2 {overlib|bifid with sub branches|<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_se1_Joh1937_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_se1_Joh1937_r.gif 2009-12-15 10:36:17''> }&lt;!-- S1 branches --&gt;\r\n|1.48 &lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_man_Joh1937_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_man_Joh1937_r.gif 2009-12-15 10:36:17''> &lt;!-- mandible --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|334|Zhang and Wang 2004}, {citeID|279|Wang 2000}):\r\n*A. lucens (Zetterstedt) male {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Acri_luce_men_Zel1992_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_luce_men_Zel1992_r.gif 2009-12-15 10:36:17''>}\r\n*A. nitidellus? {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_men_Joh1937_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_men_Joh1937_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: Acri_nitu_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Acri_nitu_men_Ye1984_r.gif 2009-12-15 10:36:17''>}\r\n*A. simplex sp. nov. {citeID|334|Zhang and Wang 2004} male\r\n*A. sp. male female\r\n*A. zhalingensis sp. nov. {citeID|334|Zhang and Wang 2004} male\r\n', 1, '', '122 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'small', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, 'broad median tooth weakly divided anteriorly into 4  parts', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 2, NULL, 3, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'bifid and plumose types with one or both of the main branches subdivided', NULL, NULL, NULL, NULL, NULL, 1.0, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(2, 7, NULL, 'in China ({citeID|279|Wang 2000}):<br>\r\n*A.johnsoni (Coquillett)\r\n*A.trifascipennis (Zetterstedt)\r\n\r\nComments from {citeID|288|Fittkau and Roback 1983}:<br>\r\nLarvae of Apsectrotanypus differ from those of the most nearly related genera, Macropelopia, Alotanypus and Brundiniella, in the strongly reduced antennal segment 2 and the unusually deeply set style. Apsectrotanypus is easily distinguished from other genera by the small number and the unusually large size of dorsomental teeth. In addition, the short basal segment of the maxillary palp will separate it from Macropelopia and Alotanypus and the simple, small posterior parapod claws will separate it from Brundiniella.', 1, NULL, '83 212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3, 13, NULL, '==Characters==\r\n\r\n\r\n{citeID|21|Cranston et.al. 1983}: The combination of \r\n*4 segmented antenna with segment 2 divided into 2 parts, \r\n*broad, pectinate labral lamellae, \r\n*mentum with 2 long median teeth and \r\n*posterior displacement of setae submenti is distinctive. \r\nLarvae Euryhapsis  share some of these characters but head capsule setae are branched. In the Orthocladiinae the Lauterborn organs and style are located on the apex of sgment 2. In Brillia these structures occur on the apex of the third antennal part which might be mistaken for antennal  segment 3. It is proposed that antennal segment 2 has divided rather than the position of the Lauterborn organs and style has changed from segment 2 to the apex of segment 3. This division of segment 2 also occours in Abiskomyia (with one Lauterborn organ on each part) and in Heleniella.\r\n\r\nA key from [[http://insects.ummz.lsa.umich.edu/~ethanbr/aim/Keys/Diptera/keys_dom_chir_ortho_brillia.html Aquatic Insects of Michigan]]\r\n\r\n&lt;IFRAME align=''center'' height=''300'' width=''100%'' src=''http://insects.ummz.lsa.umich.edu/~ethanbr/aim/Keys/Diptera/keys_dom_chir_ortho_brillia.html'' type=''text/html''&gt;&lt;/IFRAME&gt;\r\n\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|reference\r\n!im90|antenna - segements\r\n!im90|antenna - note\r\n!im90|antenna - flagellum:blade\r\n!im90|mentum - middle\r\n!im90|mentum - lateral\r\n!im90|mentum - note\r\n!im90|mentum - seta submenti\r\n!im90|labrum - seta s1\r\n!im90|labrum - lamellae\r\n!im90|labrum - premandible\r\n!|mandible\r\n!im90|mandible - seta interna\r\n!im90|mandible - seta subentalis\r\n!im90|maxilla - lacinial chetae\r\n!im90|maxilla - pecten galearis\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|4\r\n|2nd antennal segment divided into small proximal and a longer(~3x) apical part\r\n|&gt;\r\n|3\r\n|4-5\r\n|middle tooth at least 3x smaller than outermost\r\n|inserted half way between mentum and postoccipital margin\r\n|plumose&lt;br&gt;remainig s simple\r\n|present, patially divided\r\n|2+1 inner\r\n|4-1-0-0\r\n|serrated branches\r\n|&gt; 4th inner tooth\r\n|serrated\r\n|no\r\n\r\n|}\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''one''\r\n|-\r\n!|reference\r\n!im|taxon\r\n!im|head\r\n!im|head (L:W)\r\n!im|postoccipital margin\r\n!im|antennal ratio (1 to remaining)\r\n!im|premandible\r\n!im|mentum (middle)\r\n!im|ventromental plates\r\n!im|mandible\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|20|Schmid 1993}\r\n|&lt;!--taxon--&gt;B. bifida (Kieffer 1909) (syn B.modesta)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Brillia bifida (mentum) Schmid 1993'' src=''image.php?text=image deleted: Bril_mode_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;rectangular, {yellow}, postmentum {dark brown}\r\n|&lt;!--head (L:W)--&gt;1.541 +- 0.176 (n=8)\r\n|&lt;!--postoccipital margin--&gt;&lt;span class=''dark''&gt;blackish&lt;/span&gt;\r\n|&lt;!--antennal ratio--&gt;1.480 +- 0.240 (n=8)\r\n|&lt;!--premandible--&gt;2 apical 1 inner\r\n|&lt;!--mentum (middle)--&gt;3x median &lt;  1st lateral\r\n|&lt;!-- ventromental plates --&gt;\r\n|&lt;!--mandible--&gt;4-1-0-0\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|20|Schmid 1993}\r\n|&lt;!--taxon--&gt;B. longifurca Kieffer 1921&lt;br&gt;&lt;img align=''middle'' width=200 title=''Brillia longifurca (mentum) Schmid 1993'' src=''image.php?text=image deleted: Bril_logp_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;{yellowish} rectangular\r\n|&lt;!--head (L:W)--&gt;1.610 +- 0.151 (n=10)\r\n|&lt;!--postoccipital margin--&gt;{pale}\r\n|&lt;!--antennal ratio--&gt;1.422 +- 0.126 (n=10)\r\n|&lt;!--premandible--&gt;2 apical 1 inner\r\n|&lt;!--mentum (middle)--&gt;2x median = nearly 1st lateral\r\n|&lt;!-- ventromental plates --&gt;\r\n|&lt;!--mandible--&gt;4-1-0-0\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|41|Yan et.al. 1982}\r\n|&lt;!--taxon--&gt;B. par (Coquillet)&lt;br&gt; ({citeID|6|Epler 2001}: The species formerly known as &ldquo;Brillia par&rdquo; is now placed in Xylotopus.)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Brillia par (mentum) Yan et.al. 1982'' src=''image.php?text=image deleted: Bril_pax_men_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;?\r\n|&lt;!--head (L:W)--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal ratio--&gt;1.35 \r\n|&lt;!--premandible--&gt;2 apical 1? inner\r\n|&lt;!--mentum (middle)--&gt;?\r\n|&lt;!-- ventromental plates --&gt;\r\n|&lt;!--mandible--&gt;3-1-0-0\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|452|Zelentsov 1989}\r\n|&lt;!--taxon--&gt;Cricotopus shilovae {citeID|452|Zelentsov 1989}&lt;br&gt;&lt;img align=''middle'' width=200 title=''Cricotopus shilovae (mentum) Zelentsov 1989'' src=''image.php?text=image deleted: Cric_shil_men_Zel1989_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;?\r\n|&lt;!--head (L:W)--&gt;?\r\n|&lt;!--postoccipital margin--&gt; {dark brown}\r\n|&lt;!--antennal ratio--&gt;1.3\r\n|&lt;!--premandible--&gt;1 apical 1 basal\r\n|&lt;!--mentum (middle)--&gt;1.5x median = 1st lateral; submental setation near the mentum (laterad) not near the postoccipital margin\r\n|&lt;!-- ventromental plates --&gt;quite elongated compared to Brilla\r\n|&lt;!--mandible--&gt;3.5-1-0-0 strongly ''''''engraved'''''' at outer margin&lt;br&gt;&lt;img align=''middle'' width=100 title=''Cricotopus shilovae (mandible) Zelentsov 1989'' src=''image.php?text=image deleted: Cric_shil_man_Zel1989_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n\r\n|}\r\n\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*B.bifasciata male {citeID|454|Wang et.al. 1994}\r\n*B.bifida (Kieffer 1909) male female syn B.modesta (Meigen 1830) {overlib|mentum|&lt;img align=''middle'' alt=''Brillia bifida (mentum)'' width=200 title=''Brillia bifida (mentum) Schmid 1993'' src=''image.php?text=image deleted: Bril_mode_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Brillia bifida (mentum)'' width=200 title=''Brillia bifida (mentum) NHM Collection (London)'' src=''../../imglarvae/Bril_bifi_men_NHMLond_r.jpeg'' &gt;}\r\n*B.brevicornis male {citeID|454|Wang et.al. 1994}\r\n*B.longifurca Kieffer male {overlib|mentum|&lt;img align=''middle'' alt=''Brillia longifurca (mentum)'' width=200 title=''Brillia longifurca (mentum) Schmid 1993'' src=''image.php?text=image deleted: Bril_logp_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*B.sp male', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Brillia as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n{textciteID|6|Epler 2001}: Brillia larvae are almost always associated with submerged allochthonous wood and leaves, and may be found in springs, streams, rivers and the littoral margins of lakes.\r\n\r\n{textciteID|481|Buskens and Moller-Pillot 1992}: Brillia longifurca only live in such polluted waters with satisfactory flow conditions. Here oxygen regimes seem to play an important role.\r\n', '49 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(4, 15, NULL, 'Gymnometriocnemus larvae are difficult to separate from those of Bryophaenocladius, differing only in the weakly divided posterior parapods of Gymnometriocnemus; those of Bryophaenocladius are undivided ({citeID|6|Epler 2001})&lt;br&gt;\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*B.cuneiformis Arnitage male female\r\n*B.propinquus Brundin male\r\n*B.scanicus Brundin male\r\n*B.vernalis (Goetghebuer) male', 1, 'Living in soil: Bryophaenocladius subvernalis (Edw.) see {citeID|475|Delettre 2000}', '56 49 61 79 116 13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5, 17, NULL, 'in China ({citeID|279|Wang 2000}):\r\n*C.stercorarius (DeGeer)\r\n\r\nComments from {citeID|21|Cranston et.al. 1983}:<br>\r\nThe presence of bififd s1 and s2 amongst genera withaout procerci is diagnostic for Camptocladius and Pseudosmittia. Most Pseudosmittia can be separated by \r\n*the possession of posterior parapods with claws but Psimplex (Strenzke), in wich the posterior parapods are absent, can only be separeted by the terminal antennal segment being 3x longer than the preceding. In Camptocladius  the terminal (of 3) segment is not longer and usually shorter than that preceding.', 1, '{citeID|21|Cranston et.al. 1983}: The larvae of the sole species C.stercorarius (de Geer) is found in cow dung.', '202 106 142 205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6, 19, NULL, '==Characters==\r\n\r\n\r\n{citeID|21|Cranston et.al. 1983}:\r\n\r\nChaetocladius appears  to be a well defined genus in adult and pupal stages. However, the larvae show quite large variation in \r\n*{overlib|labral lamellae|&lt;img align=''middle'' width=50 title=''Chaetocladius pereennis (setae S1, ...) Cranston et.al. 1983'' src=''image.php?text=image deleted: Chae_pere_set_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}, \r\n*{overlib|ventromental plates|&lt;img align=''middle'' width=200 title=''Chaetocladius dentiforceps (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Chae_dent_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} and \r\n*{overlib|anal tubles|&lt;img align=''middle'' width=100 title=''Chaetocladius sp (anal end) Cranston et.al. 1983'' src=''image.php?text=image deleted: Chae_spec_ane_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}.\r\nChaetocladius can be separated from Hydrobaenus by \r\n*the presence of a {overlib|premandibular brush|&lt;img align=''middle'' width=50 title=''Chaetocladius piger (premandible) Schmid 1993'' src=''image.php?text=image deleted: Chae_pige_pre_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}, by either having {overlib|2 or no (or vestigal)|&lt;img align=''middle'' width=50 title=''Chaetocladius pereennis (setae S1, ...) Cranston et.al. 1983'' src=''image.php?text=image deleted: Chae_pere_set_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=50 title=''Chaetocladius minutissimus (setae S1, ...) Cranston et.al. 1983'' src=''image.php?text=image deleted: Chae_minu_set_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} labral lamellae and by \r\n*having {overlib|antennal segment 3|&lt;img align=''middle'' width=60 title=''Chaetocladius piger (antenna) Schmid 1993'' src=''image.php?text=image deleted: Chae_pige_ant_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} shorter than or subequal to the fourth.&lt;br&gt;\r\nFrom Metriocnemus and Thienemannia the larvae differs in \r\n*having a {overlib|less well developed premandibular brush|&lt;img align=''middle'' width=50 title=''Chaetocladius piger (premandible) Schmid 1993'' src=''image.php?text=image deleted: Chae_pige_pre_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*usually {overlib|more developed ventromental plates|&lt;img align=''middle'' width=200 title=''Chaetocladius dentiforceps (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Chae_dent_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*usually {overlib|larger median teeth of mentum|&lt;img align=''middle'' width=200 title=''Chaetocladius piger (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Chae_pige_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} and\r\n*paired labral lamellae situated between S1 and the labral margin.\r\nThe {overlib|premandibular brush in Metriocnemus|&lt;img align=''middle'' width=50 title=''Metriocnemus albolineatus cf. (premandible) Schmid 1993'' src=''image.php?text=image deleted: Metr_allicf_pre_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} is more developed and the single larval lamellae distally split and situated between S2 and S1. In {overlib|Thienemannia the premandibular brush|&lt;img align=''middle'' width=150 title=''Thienemannia sp (labro-epipharyngeal region) Cranston et.al. 1983'' src=''image.php?text=image deleted: Thma_spec_lab_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} is vestigial and the labral lamellae absent.\r\n\r\n\r\n{| style=''border-style:solid;border-width:1px;'' id=''sortone'' class=''sortable''\r\n|-\r\n!|Reference\r\n!im90|head\r\n!im90|postoccipital paltes\r\n!im90|postoccipital margin\r\n!im90|antenna\r\n!im90|antennal blade\r\n!im90|antennal pedestal\r\n!im90|pecten epipharyngis\r\n!im90|seata S1\r\n!im90|premandible\r\n!im90|premandible brush\r\n!im90|mandible: inner apikal outer surface tooth\r\n!im90|mandible: seta interna\r\n!im90|ventromental plates\r\n!im90|beard\r\n!im90|mentum: median tooth\r\n!im90|mentum: lateral teeth\r\n!im90|posterior parapods\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}\r\n|\r\n|no\r\n|?\r\n|5 segm.,&lt;br&gt;freq. shorter than mandible never strongly reduced\r\n|shorter than flagellum, occaisionally longer\r\n|?\r\n|3 subequal spines\r\n|plumose/pectinate&lt;br&gt;other simple\r\n|2 (apical) + 1-2 blunt inner\r\n|weak, moderately developed\r\n|3/4-1-0-0&lt;br&gt;apical tooth shorter than combined withd of 3-4 inner\r\n|6-7 fairly strong branches, all serrated\r\n|large to small, often extending beyond outer lat. mental tooth\r\n|no\r\n|1..2\r\n|5\r\n|\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|{yellow} {light brown}\r\n|no\r\n|darkened\r\n|5\r\n|shorter or subequal to flagellum\r\n|\r\n|3 nearly subequal spines\r\n|plumose, remaining simple\r\n|2 or more\r\n|very weak to moderately developed\r\n|3/4-1-0-0\r\n|5-7 terminally serrated branches\r\n|extending beyond outer lateral mental tooth\r\n|\r\n|1-2\r\n|5\r\n\r\n|}\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*C.dentiforceps (Edwards) male {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Chae_dent_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Chae_dent_men_Sch1993_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: Chae_dent_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Chae_dent_men_WOr1983_r.gif 2009-12-15 10:36:17''>}\r\n*C.sp. male female', 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Chaetocladius sp. in Alpine running waters of 20.94&micro;S &middot; cm⁻&sup1; &plusmn;~44.64 (min-max: 4-425, n=110).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Chaetocladius sp. in Alpine running waters of 5.72&deg;C &plusmn;~2.37 (min-max: 0.01-9.81, n=128).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Chaetocladius sp. in Alpine running waters of 6.34 &plusmn;~0.56 (min-max: 5.11-9, n=94).\r\n', '65 86 177 116 184 202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(7, 20, NULL, '==Comments==\r\n\r\n{citeID|2|Pinder and Reiss 1983}: Species group C from Einfeldia cannot be distinguished from Chironomus in the larval stage. &lt;br&gt;\r\n{citeID|4|Oliver and Roussel 1983} (p.68): Larvae of Einfeldia with ''''one'''' pair of ventral tubules are easily distinguished from those of Chironomus with ''''two'''' pairs of tubules, but are difficult to separate from some Glyptotendipes. Usually the presence of spines on the inner margin of the mandible of Einfeldia will distinguish it from Glyptotendipes, but these are sometimes weak or worn.&lt;br&gt;\r\nanote Plank 28.06.2005: differences to Chironomus?: setation blow ventromental plates, pecten epipharyngis &lt;hr&gt;\r\n\r\n==Keys==\r\n\r\nsimple key from {citeID|278|Hofman 1971}:\r\n*the 5th lateral tooth of mentum:\r\n** isn''t smaller than neighbouring teeth; mandible with 3 dark, distinct inner teeth ... Chironomus plumosus type\r\n** smaller than neighbouring teeth; mandible with 2 dark, distinct inner teeth and 1 small pale inner tooth ... Chironomus anthracinus type\r\n&lt;hr&gt;\r\nKey from {citeID|8|Vallenduuk 1997} (not yet done):\r\n#a  {overlib|Lateral tubuli|&lt;img align=''middle'' alt=''Chironomus muratensis (anal end)'' width=100 title=''Chironomus muratensis (anal end) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_mura_ane_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} present.\r\n&lt;hr&gt;\r\nKey from {citeID|302|Brooks et.al. 2007}:\r\n#median tooth of mentum &gt; 1st lateral tooth -&gt; 2&lt;br&gt;median tooth of mentum &lt;== 1st lateral tooth -&gt; 3\r\n#Mandible with 3 inner teeth Einfeldia dissidens type [Plank: 1 tooth in middle]&lt;br&gt;Mandible with 2 inner teeth Einfeldia natchitocheae-type [Plank: 1 tooth in middle]\r\n#4th lateral tooth of mentum shorter than 5th lateral tooth, mandible with 2 inner teeth -&gt; Chironomus anthracinus type&lt;br&gt;4th lateral tooth longer than 5th lateral tooth, mandible with 3 inner teeth -&gt; 4\r\n#Dorsal sclerite of head with distinctive ''orange peel'' sculpturing, an large hole present -&gt; Einfeldia pagna type [is Chironomus like]&lt;br&gt;Dorsal sclerite entire sculpturing absent -&gt; Chironomus plumosus type\r\n\r\n\r\n==Characters==\r\n\r\nThis table is detailed in {citeID|8|Vallenduuk 1997} with many numerical characters (only a stub here)\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|Reference\r\n!|Taxon\r\n!im90|lateral tubuli\r\n!im90|ventral tubuli\r\n!|&lt;img align=''middle'' alt=''Chironomus pseudothummi (head ventral)'' width=50 title=''Chironomus pseudothummi (head ventral) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_pseu_hds_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;br&gt;gula\r\n!|&lt;img align=''middle'' alt=''Chironomus aberratus (head dorsal)'' width=50 title=''Chironomus aberratus (head dorsal) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_aber_hds_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;br&gt;clypeus\r\n!im90|head width\r\n!im90|mentum type\r\n!im90|mandible type\r\n!im90|literature\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.pallidivittatus\r\n|&lt;!-- lateral tubuli --&gt;+\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;?\r\n|&lt;!-- clypeus --&gt;+\r\n|&lt;!-- head width --&gt;607-685\r\n|&lt;!-- mentum type --&gt;1\r\n|&lt;!-- mandible type --&gt;?\r\n|&lt;!-- literature --&gt;{numciteID|459|Webb and Scholl 1987}, {numciteID|462|Kiknadze et al. 1991}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.tentans\r\n|&lt;!-- lateral tubuli --&gt;+\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;+\r\n|&lt;!-- clypeus --&gt;+\r\n|&lt;!-- head width --&gt;840-895\r\n|&lt;!-- mentum type --&gt;1\r\n|&lt;!-- mandible type --&gt;?\r\n|&lt;!-- literature --&gt;{numciteID|459|Webb and Scholl 1987}, {numciteID|462|Kiknadze et al. 1991}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.dorsalis\r\n|&lt;!-- lateral tubuli --&gt;+\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;+\r\n|&lt;!-- clypeus --&gt;+(-)\r\n|&lt;!-- head width --&gt;541-583\r\n|&lt;!-- mentum type --&gt;3\r\n|&lt;!-- mandible type --&gt;1, 2\r\n|&lt;!-- literature --&gt;{numciteID|458|Webb and Scholl 1985}, {numciteID|460|Webb et al. 1985}, {numciteID|9|Geiger et.al. 1978}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.plumosus\r\n|&lt;!-- lateral tubuli --&gt;+\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;+++\r\n|&lt;!-- clypeus --&gt;-\r\n|&lt;!-- head width --&gt;690-990\r\n|&lt;!-- mentum type --&gt;1 (2)\r\n|&lt;!-- mandible type --&gt;2 (3)\r\n|&lt;!-- literature --&gt;{numciteID|458|Webb and Scholl 1985}, {numciteID|460|Webb et al. 1985}, {numciteID|462|Kiknadze et al. 1991}, {numciteID|463|Shilova 1980}, {numciteID|9|Geiger et.al. 1978}, {numciteID|466|Shobanov 1989}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.annularius\r\n|&lt;!-- lateral tubuli --&gt;+\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;++\r\n|&lt;!-- clypeus --&gt;-\r\n|&lt;!-- head width --&gt;460-664\r\n|&lt;!-- mentum type --&gt;1, 2\r\n|&lt;!-- mandible type --&gt;1, 2 (3)\r\n|&lt;!-- literature --&gt;{numciteID|458|Webb and Scholl 1985}, {numciteID|460|Webb et al. 1985}, {numciteID|9|Geiger et.al. 1978}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.cingulatus\r\n|&lt;!-- lateral tubuli --&gt;+\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;++\r\n|&lt;!-- clypeus --&gt;-\r\n|&lt;!-- head width --&gt;623-664\r\n|&lt;!-- mentum type --&gt;1 (2)\r\n|&lt;!-- mandible type --&gt;1 (2)\r\n|&lt;!-- literature --&gt;{numciteID|458|Webb and Scholl 1985}, {numciteID|460|Webb et al. 1985}, {numciteID|9|Geiger et.al. 1978}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.salinarius\r\n|&lt;!-- lateral tubuli --&gt;-\r\n|&lt;!-- ventral tubuli --&gt;-\r\n|&lt;!-- gula --&gt;+\r\n|&lt;!-- clypeus --&gt;-\r\n|&lt;!-- head width --&gt;470-510\r\n|&lt;!-- mentum type --&gt;1 (2)\r\n|&lt;!-- mandible type --&gt;2, 3\r\n|&lt;!-- literature --&gt;{numciteID|458|Webb and Scholl 1985}, {numciteID|460|Webb et al. 1985}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.anthracinus\r\n|&lt;!-- lateral tubuli --&gt;-\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;+\r\n|&lt;!-- clypeus --&gt;-\r\n|&lt;!-- head width --&gt;701\r\n|&lt;!-- mentum type --&gt;2, 3\r\n|&lt;!-- mandible type --&gt;2, 3\r\n|&lt;!-- literature --&gt;{numciteID|458|Webb and Scholl 1985}, {numciteID|461|Johnson and Pejler 1978}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|8|Vallenduuk 1997}\r\n|&lt;!-- Taxon --&gt;C.riparius\r\n|&lt;!-- lateral tubuli --&gt;-\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;+\r\n|&lt;!-- clypeus --&gt;-\r\n|&lt;!-- head width --&gt;518-590\r\n|&lt;!-- mentum type --&gt;1 (2)\r\n|&lt;!-- mandible type --&gt;(2) 3\r\n|&lt;!-- literature --&gt;{numciteID|458|Webb and Scholl 1985}, {numciteID|460|Webb et al. 1985}, {numciteID|9|Geiger et.al. 1978}\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|285|Kiknadze 2005}\r\n|&lt;!-- Taxon --&gt;C.sinicus\r\n|&lt;!-- lateral tubuli --&gt;+\r\n|&lt;!-- ventral tubuli --&gt;+\r\n|&lt;!-- gula --&gt;++\r\n|&lt;!-- clypeus --&gt;-?\r\n|&lt;!-- head width --&gt;840&ndash;900 (860)\r\n|&lt;!-- mentum type --&gt;1\r\n|&lt;!-- mandible type --&gt;(2) 3\r\n|&lt;!-- literature --&gt;\r\n\r\n|}\r\n\r\n*Chironomus dorsalis\r\n** from {citeID|274|Dettinger-Klemm 2003}: Determination of the larva: The larva of C.dorsalis is well separable from the other known species of Western Europe by the presence of ventral and lateral tubules, the gula that is at least partly pigmented, the pigmented frontal apotome, the shape of mentum (Mentumtype III: fourth lateral tooth tiny and smaller as its neighboured teeth), and the relatively small head capsule (&lt;650~&micro;m) ({citeID|477|Vallenduuk and Moller-Pillot 1999}).\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*Subgenus Camptochironomus Kieffer\r\n**C.pallidivittatus (Malloch) male {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus pallidivittatus (mentum)'' width=200 title=''Chironomus pallidivittatus (mentum) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_pavi_men_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Chironomus pallidivittatus (mentum)'' width=200 title=''Chironomus pallidivittatus (mentum) Walker 2000'' src=''image.php?text=image deleted: Chir_pavi_men_Wal2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.tentans (Fabricus) male {overlib|head|&lt;img align=''middle'' alt=''Chironomus tentans (head ventral)'' width=150 title=''Chironomus tentans (head ventral) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_teta_hve_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Chironomus tentans (head dorsal)'' width=150 title=''Chironomus tentans (head dorsal) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_teta_hds_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*Subgenus Chironomus Meigen\r\n**C.annularius DeGeer\r\n**C.anthracinus Zetterstedt \r\n**C.attenuatus ? Walker {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus attenuatus (mentum)'' width=200 title=''Chironomus attenuatus (mentum) Yan and Ye 1977'' src=''image.php?text=image deleted: Chir_atus_men_YaY1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.cingulatus (Meigen)\r\n**C.circumdatus (Kieffer) female\r\n**C.dorsalis Authors not Meigen male female {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus dorsalis (mentum)'' width=200 title=''Chironomus dorsalis (mentum) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_dors_men_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.enshiensis Wang male\r\n**C.javanus Kieffer female\r\n**C.kiiensis Tokunaga female\r\n**C.longistylus ? Goetghebuer\r\n**C.lugubris ? Zetterstedt {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus lugubris (mentum)'' width=200 title=''Chironomus lugubris (mentum) Ye 1984'' src=''image.php?text=image deleted: Chir_lugu_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.nipponicus Tokunaga \r\n**C.okinawanus Hasegava and Sasa male female\r\n**C.plumosus (L) {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus plumosus f.reductus (mentum)'' width=200 title=''Chironomus plumosus f.reductus (mentum) Guo 1994'' src=''image.php?text=image deleted: Chir_plumfr_men_Guo1994_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.prasinellus Kieffer male female\r\n**C.pseudothummi Strenzke male {overlib|head|&lt;img align=''middle'' alt=''Chironomus pseudothummi (head dorsal)'' width=150 title=''Chironomus pseudothummi (head dorsal) Vallenduuk 1997'' src=''image.php?text=image deleted: Chir_pseu_hds_Val1997_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.riparius (Meigen) male {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus riparius (mentum)'' width=200 title=''Chironomus riparius (mentum) Ye 1984'' src=''image.php?text=image deleted: Chir_ripa_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.salinarius (Kieffer) {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus salinarius (mentum)'' width=200 title=''Chironomus salinarius (mentum) Ye and Wang 1982'' src=''image.php?text=image deleted: Chir_sali_men_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.samoensis Edwards\r\n**C.sinicus {citeID|285|Kiknadze 2005} {overlib|mentum|&lt;img align=''middle'' alt=''Chironomus sinicus (mentum)'' width=200 title=''Chironomus sinicus (mentum) Kiknadze 2005'' src=''image.php?text=image deleted: Chir_sini_men_Kik2005_r.png 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.sinuosus Guha and Chaudhuri male\r\n**C.sp. female\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Chironomus as ubiquitous taxa in a lentic-lotic gradient in France.\r\n\r\n===Littoral===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Chironomus (Ca.) tentans Fabr. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus anthracinus Zett. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||***** ||&middot;&middot;&middot;&middot;&middot; || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus decorus (Joh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus plumosus L. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus plumosus f. semireductus &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Profundal===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n|-\r\n|Chironomus anthracinus Zett. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||&middot;&middot;&middot;&middot;&middot; || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus atritibia Mall. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus decorus Joh. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus plumosus L. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || || || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus plumosus f. semireductus &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus tenuistylus Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || || || || || || || || || || || || || ||***** &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\n{textciteID|492|Brodersen et al. 2004}: Warm-water chironomid assemblages characterized by taxa such as Chironomus, Dicrotendipes, Ablabesmyia, and Procladius had a high oxy-regulatory capacity.\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Chironomus  and other taxa to find possible differences in temperature: 2000: 13.8&deg;C &plusmn; 3.7 (10.1 to 17.4), 2006: 13.2&deg;C &plusmn; 4.6 (8.6 to 17.8) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nChironomus sp. reported by {textciteID|516|Korhola et al. 2002} as warm adapted taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Chironomus sp.  and other taxa: 5.2m &plusmn; 1.7 (n=25). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Chironomus (n=35, Template:explained:N2:HillsDiversity=25.09, n&lt;sub&gt;max&lt;/sub&gt;=25.88) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 13.\r\n\r\n===Conductivity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Chironomus spp. in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 842.22mg &middot; l⁻&sup1; (&divide; 600 = 1.4mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 11.4094. In article shortened as: Ch.\r\n\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(8, 23, NULL, '{| style=''border:1px solid;'' \r\n|-\r\n!|Refrence\r\n!|differences to genus\r\n!|characters \r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Tanytarsus\r\n|for Cladotanytarsus: antennal segment 2 wedge-shaped, &lt;== segment 3; Lauterborn organs, situated on pedicels which are shorter than organs themselves. Some claws of posterior parapods with fine internal serrations\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Virgatanytarsus\r\n|for Virgatanytarsus: Some claws of posterior parapods with row or pad of robust hooklets\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Micropsectra\r\n|for Micropsectra: very numerous claws on the posterior parapods, many are small of them, like a horse-shoe, irregular rows\r\n\r\n|-\r\n|{citeID|302|Brooks et.al. 2007}\r\n|Pseudochironomus\r\n|for Cladotanytarsus: 3 lateral teeth outside short 2nd tooth; Pseudochironomus: 4 lateral teeth outside short 2nd tooth&lt;br&gt;note (2007-08-06 18:27): isn''t very distinctive Tanytarsus lugens type with mandible 3-1-2-2 also with 2nd teeth shorter\r\n\r\n|}\r\n\r\n\r\n{| style=''border :1px solid;''\r\n|-\r\n!|Reference\r\n!im|premandible\r\n!im|posterior parapods\r\n!im|antennal spur\r\n!im|antennal pedestals\r\n!im|postoccipital plate\r\n!|mandible\r\n!im|ventromental plates\r\n!im|mentum -- median tooth\r\n\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}:\r\n|&lt;!-- premandible --&gt;4-5\r\n|&lt;!-- post.parapods --&gt;some claws with finely ''''''serrated'''''' inner margin\r\n|&lt;!-- antennal spur --&gt;no\r\n|&lt;!-- antennal pedestal --&gt;.&lt;br&gt;short\r\n|&lt;!-- postocciptial plate --&gt;\r\n|&lt;!-- mandible --&gt;3-1-1-0\r\n|&lt;!-- ventromental plates --&gt;close together medially, rather wider than mentum\r\n|&lt;!-- mentum median --&gt;broad, rounded or notched laterally\r\n\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}:\r\n|&lt;!-- premandible --&gt;\r\n|&lt;!-- post.parapods --&gt;\r\n|&lt;!-- antennal spur --&gt;\r\n|&lt;!-- antennal pedestal --&gt;\r\n|&lt;!-- postocciptial plate --&gt;\r\n|&lt;!-- mandible --&gt;3-1-1-0\r\n|&lt;!-- ventromental plates --&gt;\r\n|&lt;!-- mentum median --&gt;\r\n|}\r\n\r\n\r\n==Mandible==\r\n\r\nDorsal tooth pale; apical tooth and 3 inner teeth brown. Seta subdentalis long, curved. Seta interna consisting of 4 plumose branches. Pecten mandibularis well developed; with numerus long lamellae ({citeID|2|Pinder and Reiss 1983})\r\n\r\n\r\n==Mentum==\r\n\r\nPlank (Wed Mar 11 2009 14:06:45 GMT+0100): Some Cladotanytarsus larvae are similar to Tanytarsus gracilentus with some lateral teeth shorter than their neighbor teeth\r\n\r\n\r\n==Comments==\r\n\r\nComments from {citeID|2|Pinder and Reiss 1983}: Cladotanytarsus larvae  differ from all other Tanytarsini in that \r\n*some of the curved claws of the posterior  parapods are finely serrated along the inner margin. In addition \r\n*the short, wedge-shaped antennal segment 2, bearing large Lauterborn organs on short pedicels, in combination with \r\n*wide ventromentla plates, which are very close together medially are quite characteristic.\r\n\r\n\r\n&lt;hr&gt;\r\n{citeID|268|Wang and Gou 2004} Abstract:&lt;br&gt;\r\nThe genus Cladotanytarsus from China, including 12 species, is reviewed. Three new species:\r\n* C. bisetus, C. dilatus, and C. paratridorsum are described and figured. \r\n*C. conversus (Johannsen), \r\n*C. digitalis Wang &amp; Zheng, \r\n*C. frontalis Wang &amp; Zheng, \r\n*C. nigrovittatus (Goetghebuer), \r\n*C. palmatus Wang &amp; Zheng, \r\n*C. parvus Wang &amp; Zheng, \r\n*C. pseudomancus (Goetghebuer), \r\n*C. vanderwulpi (Edwards), and \r\n*C. yunnanensis Wang &amp; Zheng are reexamined. \r\nA key to the males of Cladotanytarsus from China is presented.', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Cladotanytarsus as ubiquitous taxa in a lentic-lotic gradient in France.\r\n\r\n===Littoral===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Cladotanytarsus near weixionensis &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cladotanytarsus weixionensis Brund. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Profundal===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n\r\n|-\r\n|Cladotanytarsus near weixionensis &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cladotanytarsus weixionensis Brund. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n===Temperature===\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Cladotanytarsus  and other taxa to find possible differences in temperature: 2000: 14.8&deg;C &plusmn; 3.2 (11.7 to 18), 2006: 15&deg;C &plusmn; 3.7 (11.3 to 18.7) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n', '170 88 207 224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(9, 29, NULL, '==Characters genus=\r\n\r\n{citeID|21|Cranston et.al. 1983}: The genus Corynoneura is distinctive amongst those genera with elongate antennae \r\n*in having the antenna at least as long as the head capsule and \r\n*in having only 4 antennal segments\r\n\r\n{| style=''border:1px solid;''\r\n!|Reference \r\n!im|head\r\n!im|postoccipital margin\r\n!im90|antenna\r\n!im|antenna (note)\r\n!|s 1\r\n!im|pecten epipharyngis\r\n!im|premandible\r\n!im|premandible brush\r\n!im90|mentum (middle)\r\n!im90|mentum (lateral)\r\n!im|mentum (shape)\r\n!im|mandible\r\n!im|seta interna (mandible)\r\n!im90|pecten galearis (maxilla)\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt; \r\n|{pale} or black\r\n|4\r\n|3rd longer than 2nd\r\n|simple\r\n|3 small spines\r\n|1 to 12 teeth and trasparent\r\n|finely divided\r\n|2-3\r\n|5\r\n|triangular\r\n|4-1-0-0\r\n|5-6 branches\r\n|no\r\n|}\r\n\r\n==Characters Specimens==\r\n\r\nThis key is translated from {citeID|408|Hirvenoja and Hirvenoja 1988}:\r\n;1(8): middle tooth of mentum with a very small unpaired middle tooth between the equal lateral mentum teeth -&gt; 2\r\n;2(3): antennal length up to 330-350&micro;m, maximum as long as the head. Head with weak a sculptured -&gt; C.edwardsi Brundin\r\n;3(2): antennal length &gt; head -&gt; 4\r\n;4(7): antennal length about 1.25x head length -&gt; 5\r\n;5(6): antennal length about 370-390&micro;m. Head is weak and irregular sculptured -&gt; C.gratias Schlee\r\n;6(5): antennal length about 340-450&micro;m. {overlib|Head|&lt;img align=''middle'' width=150 title=''Corynoneura scutellata (head capsule) Cranston et.al. 1983'' src=''image.php?text=image deleted: Cone_scut_hed_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} mostly {overlib|weak and reticulate sculptured|&lt;img align=''middle'' title=''Corynoneura scutellata (dorsal structure) Cranston et.al. 1983'' src=''image.php?text=image deleted: Cone_scut_dor_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} -&gt; C.scutellata Winn.\r\n;7(4): antennal length up to 495-560&micro;m, about 1.5x the length of the head. {overlib|Head|&lt;img align=''middle'' title=''Corynoneura arctica (head capsule) Plank (annote)'' src=''../../imglarvae/Cone_arti_hed_PlaXXXX_r.jpeg'' &gt;} with {overlib|distinct reticulate sculpturing|&lt;img align=''middle''  title=''Corynoneura arctica (pattern on head) Plank (annote)'' src=''../../imglarvae/Cone_arti_pah_PlaXXXX_r.jpeg'' &gt;} -&gt; C.arctica {citeID|367|Kieffer 1923}\r\n;8(1): middle tooth of mentum reduced -&gt; C.sp. (?C.carriana Edwards)\r\n\r\n\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n!|reference\r\n!|taxon\r\n!im70|head\r\n!im70|head (L:W)\r\n!im70|head reticulation\r\n!im70|postoccipital margin\r\n!im70|antennal ratio (1 to remaining)\r\n!im70|antenna notes\r\n!im70|premandible\r\n!im70|mentum (outer teeth)\r\n!im70|mentum (middle - lateral x-times-middle)\r\n\r\n|-\r\n!|&lt;input name=''filterReference0'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Reference --&gt;\r\n!|&lt;input name=''filterTaxon1'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Taxon --&gt;\r\n!|&lt;input name=''filterHead2'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head --&gt;\r\n!|&lt;input name=''filterHead3'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head (L:W) --&gt;\r\n!|&lt;input name=''filterHead4'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head reticulation --&gt;\r\n!|&lt;input name=''filterPostoccipital5'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Postoccipital margin --&gt;\r\n!|&lt;input name=''filterAntennal6'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antennal ratio (1 to remaining) --&gt;\r\n!|&lt;input name=''filterAntenna7'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antenna notes --&gt;\r\n!|&lt;input name=''filterPremandible8'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Premandible --&gt;\r\n!|&lt;input name=''filterMentum9'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum (outer teeth) --&gt;\r\n!|&lt;input name=''filterMentum10'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum (middle - lateral x-times-middle) --&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|20|Schmid 1993}\r\n|&lt;!--taxon--&gt;C. scutellata gr. Winner, 1846&lt;br&gt;&lt;img align=''middle'' width=200 title=''Corynoneura scutellata gr. (mentum)'' src=''image.php?text=image deleted: Cone_scutgr_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;white - &lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|&lt;!--head (L:W)--&gt;1.653 +- 0.433 (n=3)\r\n|&lt;!--head reticulation--&gt;yes - weak(er) than C.arctica\r\n|&lt;!--postoccipital margin--&gt;{pale}\r\n|&lt;!--antennal ratio--&gt;1.098 +- 0.088 (n=3)\r\n|&lt;!--antenna notes--&gt;\r\n|&lt;!--premandible--&gt;8-12\r\n|&lt;!--mentum (outer teeth)--&gt;nearly subequal in size\r\n|&lt;!--mentum (median teeth)--&gt;1-2.0x\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|302|Brooks et.al. 2007}\r\n|&lt;!--taxon--&gt;C. arctica-type&lt;br&gt;&lt;img align=''middle'' width=200 title=''Corynoneura artica (mentum)'' src=''../../imglarvae/Cone_arti_men_PlaXXXX_r.jpeg'' &gt;\r\n|&lt;!--head --&gt;\r\n|&lt;!--head (L:W)--&gt;\r\n|&lt;!--head reticulation--&gt;yes - netlike\r\n|&lt;!--postoccipital margin--&gt;\r\n|&lt;!--antennal ratio--&gt;\r\n|&lt;!--antenna notes--&gt;\r\n|&lt;!--premandible--&gt;\r\n|&lt;!--mentum (outer teeth)--&gt;\r\n|&lt;!--mentum (median teeth)--&gt;1-2.0x\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|302|Brooks et.al. 2007}\r\n|&lt;!--taxon--&gt;C. coronata-type&lt;br&gt;&lt;img align=''middle'' width=200 title=''Corynoneura coronata (mentum)'' src=''../../imglarvae/Cone_coro_men_NHMLond_r.jpeg'' &gt;\r\n|&lt;!--head --&gt;\r\n|&lt;!--head (L:W)--&gt;\r\n|&lt;!--head reticulation--&gt;yes - scale like\r\n|&lt;!--postoccipital margin--&gt;\r\n|&lt;!--antennal ratio--&gt;\r\n|&lt;!--antenna notes--&gt;2nd 3rd = &lt;strong&gt;black&lt;/strong&gt;\r\n|&lt;!--premandible--&gt;\r\n|&lt;!--mentum (outer teeth)--&gt;\r\n|&lt;!--mentum (median teeth)--&gt;2-0.3x\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|302|Brooks et.al. 2007}\r\n|&lt;!--taxon--&gt;C. edwardsi-type\r\n|&lt;!--head --&gt;{pale}\r\n|&lt;!--head (L:W)--&gt;\r\n|&lt;!--head reticulation--&gt;no - or weak\r\n|&lt;!--postoccipital margin--&gt;\r\n|&lt;!--antennal ratio--&gt;\r\n|&lt;!--antenna notes--&gt;\r\n|&lt;!--premandible--&gt;\r\n|&lt;!--mentum (outer teeth)--&gt;\r\n|&lt;!--mentum (median teeth)--&gt;1-3.0x\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|20|Schmid 1993}\r\n|&lt;!--taxon--&gt;C. cf. antennalis  Kieffer, 1909&lt;br&gt;&lt;img align=''middle'' width=200 title=''Corynoneura antennalis (mentum)'' src=''image.php?text=image deleted: Cone_ante_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;{yellow}\r\n|&lt;!--head (L:W)--&gt;1.821 +- 0.193 (n=6)\r\n|&lt;!--head reticulation--&gt;?\r\n|&lt;!--postoccipital margin--&gt;&lt;span class=''dark''&gt;darkend&lt;/span&gt;\r\n|&lt;!--antennal ratio--&gt;0.949 +- 0.099 (n=6)\r\n|&lt;!--antenna notes--&gt;\r\n|&lt;!--premandible--&gt;5-6\r\n|&lt;!--mentum (outer teeth)--&gt;1st pair = 2nd pair (hight)\r\n|&lt;!--mentum (median teeth)--&gt;1-3.0x\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|20|Schmid 1993}\r\n|&lt;!--taxon--&gt;C. lobata (Edwards, 1929)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Corynoneura lobata (mentum)'' src=''image.php?text=image deleted: Cone_loba_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;{yellow}-gray\r\n|&lt;!--head (L:W)--&gt;1.605 +- 0.238 (n=9)\r\n|&lt;!--head reticulation--&gt;?\r\n|&lt;!--postoccipital margin--&gt;&lt;span class=''dark''&gt;darkend&lt;/span&gt;\r\n|&lt;!--antennal ratio--&gt;1.009 +- 0.066 (n=11)\r\n|&lt;!--antenna notes--&gt;\r\n|&lt;!--premandible--&gt;1\r\n|&lt;!--mentum (outer teeth)--&gt;1st pair &lt; 2nd pair (hight)\r\n|&lt;!--mentum (median teeth)--&gt;1-3.0x\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|20|Schmid 1993}\r\n|&lt;!--taxon--&gt;C. sp. A {citeID|20|Schmid 1993}&lt;br&gt;&lt;img align=''middle'' width=200 title=''Corynoneura sp. A (mentum)'' src=''image.php?text=image deleted: Cone_specA_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--head --&gt;{yellow}-gray\r\n|&lt;!--head (L:W)--&gt;1.770 +- 0.069 (n=4)\r\n|&lt;!--head reticulation--&gt;?\r\n|&lt;!--postoccipital margin--&gt;&lt;span class=''dark''&gt;darkend&lt;/span&gt; only in lateral areas\r\n|&lt;!--antennal ratio--&gt;0.952 +- 0.046 (n=6)\r\n|&lt;!--antenna notes--&gt;\r\n|&lt;!--premandible--&gt;4-6\r\n|&lt;!--mentum (outer teeth)--&gt;1st pair slightly &gt;== 2nd pair (hight)\r\n|&lt;!--mentum (median teeth)--&gt;1-1.2x\r\n\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n==Checklist China==\r\n\r\nIn China ({citeID|279|Wang 2000}):&lt;br&gt;\r\n*C.celtica Edwards\r\n*C.coronata (Edwards) {overlib|mentum|&lt;img align=''middle'' alt=''Corynoneura coronata (mentum)'' width=200 title=''Corynoneura coronata (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Cone_coro_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.lobata (Edwards) {overlib|mentum|&lt;img align=''middle'' alt=''Corynoneura lobata (mentum)'' width=200 title=''Corynoneura lobata (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Cone_loba_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Corynoneura lobata (mentum)'' width=200 title=''Corynoneura lobata (mentum) Schmid 1993'' src=''image.php?text=image deleted: Cone_loba_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.scutellata Winnertz {overlib|mentum|&lt;img align=''middle'' alt=''Corynoneura scutellata (mentum)'' width=200 title=''Corynoneura scutellata (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Cone_scut_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Corynoneura scutellata (mentum)'' width=200 title=''Corynoneura scutellata (mentum) Ye 1984'' src=''image.php?text=image deleted: Cone_scut_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.yashimurai (Tokunaga)', 1, '==Biotops==\r\n\r\n===Temperature===\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for:\r\n*Corynoneura  and other taxa to find possible differences in temperature: 2000: 11.6&deg;C &plusmn; 4.6 (7.1 to 16.2), 2006: 10&deg;C &plusmn; 5.2 (4.8 to 15.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n*Corynoneura/Thienemanniella  and other taxa to find possible differences in temperature: 2000: 10&deg;C &plusmn; 4.6 (5.4 to 14.6), 2006: 10&deg;C &plusmn; 5.3 (4.8 to 15.3) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nCorynoneura sp./Thiemanniola sp.[sic, probably Thienemanniella] reported by {textciteID|516|Korhola et al. 2002} as warm adapted taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Corynoneura sp.  and other taxa: 9.2m &plusmn; 6.3 (n=21). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Corynoneura/Thienemanniella (n=36, Template:explained:N2:HillsDiversity=24.8, n&lt;sub&gt;max&lt;/sub&gt;=14.68) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 32.\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Corynoneura the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(10, 31, NULL, '==Characters genus==\r\n\r\nTo distinguish Cricotopus/Orthocladius you can use openoffice database frontend in http://localhost/chip/larvae/key/characters_chiros.odb&lt;br&gt;\r\n\r\n{citeID|20|Schmid 1993}: in contrast to Orthocladius body setae mostly {overlib|in setal tuffs|&lt;img align=''middle''  title=''Cricotopus albiforceps (lateral setae 4) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricCr_alfo_las4_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}.&lt;br&gt; {citeID|21|Cranston et.al. 1983}: \r\n*The combination of bifid S1 and setal tuffs an at least the first 6 abdominal segments will distinguish most larvae of Cricotopus. \r\n*Those with a simple S1 are also easily distinguishd as they  also have setal tuffs. However, the few larvae with only simple setae on the abdomen (some Cricotopus (C.)) cannot be seperated from some Orthocladius with confidence.\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|reference\r\n!im90|head\r\n!im90|head - postoccipital margin\r\n!im90|antenna\r\n!im90|antenna - blade\r\n!|s1\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!im90|mandible\r\n!im90|mandible - seta subdentalis\r\n!im90|mandible - seta interna\r\n!im90|maxilla - pecten galearis\r\n!im90|ventromental plates\r\n!im90|mentum - median\r\n!im90|mentum - lateral\r\n!im90|mentum - pattern\r\n!im90|body\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;!-- head --&gt;{yellow} to &lt;span class=''brown'' &gt;blackish brown&lt;/span&gt;\r\n|&lt;!-- head pom --&gt;&lt;span class=''pale'' &gt;pale&lt;/span&gt; to &lt;span class=''darkened'' &gt;black&lt;/span&gt;\r\n|&lt;!-- ant --&gt;5\r\n|&lt;!-- ant blade --&gt;\r\n|&lt;!-- s1 --&gt;bifid (usually), rarely simple\r\n|&lt;!-- pee --&gt;1-3 scales\r\n|&lt;!-- pre --&gt;1-2; no brush or very weak (C.tremulus)\r\n|&lt;!-- man --&gt;3-1-0-0&lt;br&gt;mostly crenulated at outer edge\r\n|&lt;!-- man s subdent --&gt;present\r\n|&lt;!-- man s interna --&gt;6-7 simple or fine serrated branches\r\n|&lt;!-- max pect gal --&gt;present\r\n|&lt;!-- vep --&gt;\r\n|&lt;!-- men mid --&gt;1\r\n|&lt;!-- men lat --&gt;6 (in some: 5)\r\n|&lt;!-- men pat --&gt;\r\n|&lt;!-- body --&gt;segments I-VI(VII) with tufts of setae or longer setae C.tremulus\r\n\r\n|}\r\n\r\n\r\n==Checklist China==\r\n\r\nIn China {citeID|279|Wang 2000}:\r\n*Subgenus Cricotopus\r\n**C.albiforceps (Kieffer) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus albiforceps (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricCr_alfo_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.annulator Goetghebuer {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus annulator (mentum) Schmid 1993'' src=''image.php?text=image deleted: CricCr_anlt_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; }\r\n**C.bicinctus (Meigen) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus bicinctus (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricCr_bici_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Cricotopus bicinctus (mentum) Schmid 1993'' src=''image.php?text=image deleted: CricCr_bici_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.cylindraceus (Kieffer) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus cylindraceus (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricCr_cyli_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Cricotopus cylindraceus (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: CricCr_cyli_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.fugax (?) (Johannsen)  {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus fugax (mentum) Wang, Ji. 1987'' src=''image.php?text=image deleted: CricCr_fuga_men_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.nitens (Kieffer)\r\n**C.polyannulatus Tokunaga\r\n**C.similis Goetghebuer\r\n**C.taiwanus Tokunaga\r\n**C.tremulus (L.) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus tremulus (mentum) Schmid 1993'' src=''image.php?text=image deleted: CricCr_trem_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Cricotopus tremulus (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricCr_trem_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.triannulus (Macquart) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus triannulatus (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricCr_tran_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.trifascia Edwards {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus trifascia (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricCr_tria_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Cricotopus trifascia (mentum) Schmid 1993'' src=''image.php?text=image deleted: CricCr_tria_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.trifasciatus (Panzer)\r\n**C.tristis Hirvinoja\r\n*Subgenus Isocladius Kieffer\r\n**C.reversus Hirvinoja {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus reversus (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricIs_revu_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.sylvestris (Fabricus) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus sylvestris (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricIs_sylv_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Cricotopus sylvestris (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: CricIs_sylv_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**C.trifasciatus (Panzer) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cricotopus trifasciatus (mentum) Simpson et.al. 1983'' src=''image.php?text=image deleted: CricIs_triu_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Cricotopus trifasciatus (mentum) Schmid 1993'' src=''image.php?text=image deleted: CricIs_triu_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*Subgenus Pseudocricotopus Nishida\r\n**C.montanus Kieffer\r\n\r\n\r\n==Specimens==\r\n\r\n===Schmid 1993===\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''one''\r\n|-\r\n!|reference\r\n!im|taxon\r\n!im|head\r\n!im|postoccipital margin\r\n!im|head (L:W)\r\n!im|antennal ratio (1 to remaining)\r\n!im|antennal blade\r\n!im|premandible\r\n!im|seta S1\r\n!im|mentum (outer teeth)\r\n!im|mentum relation widths subm-setae to outer-teeth\r\n!im|mentum relation heights subm-setae to outer-teeth\r\n!im|mandible\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!--reference--&gt;\r\n|C. (Isocladius) obnixus gr. Hirvenoja, 1973&lt;!--taxon--&gt;\r\n|{yellow}&lt;!--head --&gt;\r\n|&lt;span class=''brown''&gt;darkened&lt;/span&gt;&lt;!--postoccipital margin--&gt;\r\n|2.381-2.128&lt;!--head (L:W)--&gt;\r\n|1.09 +- 0.09 (n=5)&lt;!--antennal ratio--&gt;\r\n| &lt; 5th segment&lt;!--antennal blade--&gt;\r\n|1&lt;!--premandible--&gt;\r\n|1&lt;!--s1--&gt;\r\n|5-6 pairs&lt;!--mentum (outer teeth)--&gt;\r\n|?&lt;!--mentum ratio widths--&gt;\r\n|?&lt;!--mentum ratio heights--&gt;\r\n|blunt seta subdentalus&lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!--reference--&gt;\r\n|C. (Isocladius) trifasciatus (Meigen, 1818)&lt;!--taxon--&gt;\r\n|{yellow} slightly darkened posteriorly&lt;!--head --&gt;\r\n|{dark}&lt;!--postoccipital margin--&gt;\r\n|1.179 +- 0.025 (n=4)&lt;!--head (L:W)--&gt;\r\n|1.880 +- 0.105 (n=4)&lt;!--antennal ratio--&gt;\r\n| &lt; apex of flagellum&lt;!--antennal blade--&gt;\r\n|1&lt;!--premandible--&gt;\r\n|2 - inner shorter&lt;!--s1--&gt;\r\n|6 pairs, 2nd fused with 1st pair&lt;!--mentum (outer teeth)--&gt;\r\n|1.000 (n=1)&lt;!--mentum ratio widths--&gt;\r\n|1.404 (n=1)&lt;!--mentum ratio heights--&gt;\r\n|?&lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!--reference--&gt;\r\n|C. (Cricotopus) bicinctus (Meigen, 1818)&lt;!--taxon--&gt;\r\n|{yellow}&lt;!--head --&gt;\r\n|{pale}&lt;!--postoccipital margin--&gt;\r\n|1.28 +- 0.102 (n=10)&lt;!--head (L:W)--&gt;\r\n|1.782 +- 0.099 (n=10)&lt;!--antennal ratio--&gt;\r\n|&lt;!--antennal blade--&gt;\r\n|3 - 1 basal 2 apical&lt;!--premandible--&gt;\r\n|2 - inner shorter&lt;!--s1--&gt;\r\n|6 pairs&lt;!--mentum (outer teeth)--&gt;\r\n|0.796 (n=1)&lt;!--mentum ratio widths--&gt;\r\n|0.773 (n=1)&lt;!--mentum ratio heights--&gt;\r\n|?&lt;!--mandible--&gt;\r\n\r\n\r\n|}\r\n\r\n===All Taxa===\r\n\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default ''|Reference\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:numeric ''|Antennal ratio\r\n!im90 class=''table-sortable:numeric ''|Antennal blade ratio\r\n!im90 class=''table-sortable:numeric ''|Head ratio\r\n!im90 class=''table-sortable:default ''|Head color\r\n!im90 class=''table-sortable:numeric ''|Mentum middle TR\r\n!im90 class=''table-sortable:numeric ''|Mentum middle to 1.lat-TR\r\n!im90 class=''table-sortable:numeric ''|Mentum s-submenti lat-tooth_position\r\n!im90 class=''table-sortable:numeric ''|Mandible inner\r\n!im90 class=''table-sortable:numeric ''|Mandible margin engraved?\r\n!im90 class=''table-sortable:default ''|Mandible seta interna\r\n!im90 class=''table-sortable:default ''|Mandible seta subdentalis\r\n!im90 class=''table-sortable:numeric ''|Seta S1\r\n!im90 class=''table-sortable:numeric ''|Premandible\r\n!im90 class=''table-sortable:numeric ''|Premandible brush\r\n\r\n|-\r\n! class=''table-filterable''|&lt;!-- Reference --&gt;\r\n!|&lt;input name=''filterTaxon1'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Taxon --&gt;\r\n!|&lt;input name=''filterAntennal2'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antennal ratio --&gt;\r\n!|&lt;input name=''filterAntennal3'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antennal blade ratio --&gt;\r\n!|&lt;input name=''filterHead4'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head ratio --&gt;\r\n!|&lt;input name=''filterHead5'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head color --&gt;\r\n!|&lt;input name=''filterMentum6'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum middle TR --&gt;\r\n!|&lt;input name=''filterMentum7'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum middle to 1.lat-TR --&gt;\r\n!|&lt;input name=''filterMentum8'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum s-submenti lat-tooth_position --&gt;\r\n!|&lt;input name=''filterMandible9'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible inner --&gt;\r\n!|&lt;input name=''filterMandible10'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible margin engraved? --&gt;\r\n!|&lt;input name=''filterMandible11'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible seta interna --&gt;\r\n!|&lt;input name=''filterMandible12'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible seta subdentalis --&gt;\r\n!|&lt;input name=''filterSeta13'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Seta S1 --&gt;\r\n!|&lt;input name=''filterPremandible14'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Premandible --&gt;\r\n!|&lt;input name=''filterPremandible15'' size=3 onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Premandible brush --&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) albiforceps&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_alfo_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_alfo_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.532 ( +- 0.09 n=19)\r\n| 1\r\n| 1.275 ( +- 0.086 n=19)\r\n| {yellow}\r\n| 2\r\n| 4\r\n| 6\r\n| 3\r\n| 1\r\n| 1 - 6 branches\r\n| 1 - yes\r\n| 1.9\r\n| 1.0\r\n| ?\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) algarum&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_alga_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_alga_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.708\r\n| 1\r\n| 1.52\r\n| ?\r\n| 1.711\r\n| 1.633\r\n| 7 - &gt;6\r\n| 3.5\r\n| 1\r\n| 1 - 6\r\n| 1 - reaching base of 1st internal tooth; is crenulated\r\n| 1.8\r\n| 2.0\r\n| 0\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) annulator&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_anlt_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_anlt_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.435 ( +- 0.109 n=7)\r\n| 1\r\n| 1.339 ( +- 0.045 n=8)\r\n| {yellow}\r\n| 1.81\r\n| 2.24\r\n| 7.5 - &gt;6th lateral tooth\r\n| 3\r\n| 0\r\n| 1 - 6\r\n| 1 - =1st inner tooth\r\n| 1.9\r\n| 2.0 1 apical and 1 small basal\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) annulator ?&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_anltc-_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_anltc-_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.274\r\n| 0.952\r\n| 1.36\r\n| ?\r\n| 1.857\r\n| 1.3\r\n| 5.5 - at tooth-position 5-6\r\n| 3\r\n| 0\r\n| 1 - 5 branches\r\n| 1 - =1st inner tooth\r\n| 2\r\n| 1.0 1 apical and 1 small basal\r\n| 0\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) bicinctus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_bici_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_bici_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.782 ( +- 0.099 n=10)\r\n| 1\r\n| 1.28 ( +- 0.0505 n=10)\r\n| {yellow}\r\n| 2.11\r\n| 3.08\r\n| 4.5 - at 4-5\r\n| 3\r\n| 0\r\n| 1 - 6\r\n| 1 - =1st apex of inner mandibular tooth\r\n| 2\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n| {citeID|21|Cranston et.al. 1983}\r\n| Cricotopus (Isocladius) brevipalpis gr.&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_brpagr_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_brpagr_men_WOr1983_r.gif 2009-12-15 10:36:17''>\r\n| 0.491\r\n| 0.65\r\n| ?\r\n| ?\r\n| 2.28\r\n| ?\r\n| 3.5 - at 3rd to 4th\r\n| 3.5\r\n| 0\r\n| 0 - \r\n| 1 - ?no\r\n| ?\r\n| ?\r\n| ?\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) curtus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_curt_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_curt_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.657 ( +- 0.037 n=4)\r\n| 1\r\n| 1.361 ( +- 0.041 n=3)\r\n| {yellow}\r\n| 1.313\r\n| 1.655\r\n| 6.5 - &gt; 6\r\n| 3.5\r\n| 0.5\r\n| 1 - 5 branches\r\n| 1 - reaching base of 1st inner tooth\r\n| 1.7\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) cylindraceus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_cyli_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_cyli_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 2.421\r\n| 1\r\n| ?\r\n| ?\r\n| 1.14\r\n| 3.33\r\n| 3.5\r\n| 3\r\n| 0\r\n| 1 - 6\r\n| 1 - reaching top of 1st inner tooth\r\n| ?\r\n| 1.0\r\n| 1\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) elegans&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_eleg_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_eleg_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.935\r\n| 0.9\r\n| 1.477\r\n| ?\r\n| 1.262\r\n| 1.579\r\n| 3.5\r\n| 3\r\n| 0\r\n| 1 - 5\r\n| 1 - very small not reaching the base of 1st inner tooth\r\n| 1\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) festivellus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_fest_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_fest_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.731 ( +- 0.124 n=8)\r\n| ?\r\n| 1.26 ( +- 0.032 n=8)\r\n| {yellow}\r\n| 2.4\r\n| 4.619\r\n| 6\r\n| 3\r\n| 1\r\n| 1\r\n| 1 - reaches base of 2nd inner tooth\r\n| 2\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) flavocinctus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_flcn_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_flcn_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.748\r\n| ?\r\n| ?\r\n| ?\r\n| 1.88\r\n| 5\r\n| 5\r\n| 3\r\n| 1\r\n| 1\r\n| 1\r\n| 1.8\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n| {citeID|39|Wang, Ji. 1987}\r\n| Cricotopus (Cricotopus) fugax&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_fuga_men_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_fuga_men_WJi1987_r.gif 2009-12-15 10:36:17''>\r\n| 1.53\r\n| 1\r\n| ?\r\n| ?\r\n| 0.854\r\n| 2\r\n| ?\r\n| 2\r\n| 1\r\n| 1 - 7 branches\r\n| 1 - does not reach base of 1st inner tooth\r\n| ?\r\n| ?\r\n| ?\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) fuscus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_fucu_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_fucu_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.898\r\n| ?\r\n| 1.443\r\n| ?\r\n| 1.29\r\n| 1.212\r\n| 6.5 ( +- 0.5)\r\n| 3.5\r\n| 1\r\n| ?\r\n| 1\r\n| 1.5\r\n| 2.0\r\n| ?\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Isocladius) intersectus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_insc_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_insc_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.664 ( +- 0.082 n=5)\r\n| 0.215\r\n| 1.361 ( +- 0.074 n=5)\r\n| {yellow}\r\n| 1.19\r\n| 2.72\r\n| 5 ( +- 0.3)\r\n| 3\r\n| 1\r\n| 1 - 7 finally fine brushed setae\r\n| 1 - does not reach 1st inner tooth\r\n| 1.5\r\n| 2.0 1 apical 1 basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) laetus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_laeu_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_laeu_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 2.017\r\n| 0.857\r\n| 1.454\r\n| ?\r\n| 0.783\r\n| 1.643\r\n| 4.5 ( +- 0.5)\r\n| 3\r\n| 1\r\n| 1 - 6 branches\r\n| 1 - does not reach the base of first inner tooth\r\n| 1.6\r\n| 3.0 n=1 2 and one basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) laricomalis&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_lari_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_lari_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.375\r\n| 0.851\r\n| 1.375\r\n| ?\r\n| 1.44\r\n| 1.9\r\n| 5\r\n| 3.5\r\n| 0.5\r\n| 1 - 6 branches\r\n| 1 - not reaching base of 0.5 ''tooth''\r\n| 1.9 - outer setae part is shorter not inner!\r\n| 2.0 n=1 1 apical 1 basal\r\n| 0\r\n\r\n|-\r\n| {citeID|21|Cranston et.al. 1983}\r\n| Cricotopus (Nostococladius) nostocicola&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricNo_nost_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricNo_nost_men_WOr1983_r.gif 2009-12-15 10:36:17''>\r\n| ?\r\n| ?\r\n| ?\r\n| ?\r\n| 2\r\n| 5.36\r\n| 4.5 ( +- 0.5)\r\n| 3\r\n| 0\r\n| 1 - 8 branches\r\n| 1 - reaches ~base of 1st inner tooth\r\n| ?\r\n| ?\r\n| ?\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Isocladius) obnixus gr.&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_obni_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_obni_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.09 ( +- 0.09 n=5)\r\n| 0.753\r\n| 2.254 ( +- 0.127 n=0)\r\n| {yellow}\r\n| 1.195\r\n| 1.111\r\n| ?\r\n| 3\r\n| 0.5\r\n| 0\r\n| 1 - reaches nearly base of 1st inner tooth\r\n| 1\r\n| 1.0 1 apical and smooth basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) ornatus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_ortu_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_ortu_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| ?\r\n| 0.83\r\n| 1.422\r\n| ?\r\n| 1.1 ( +- 0.1 n=1)\r\n| 1.846\r\n| 5\r\n| 3.5\r\n| 1\r\n| 1 - 6 branches\r\n| 1 - not reaching base of first 0.5 tooth\r\n| 1.7 - inner shorter\r\n| 3.0 1 braod basal tooth\r\n| ?\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) patens&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_pate_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_pate_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.588\r\n| 0.95\r\n| 1.427\r\n| ?\r\n| 1.531\r\n| 3.66\r\n| 4.5 ( +- 0.5)\r\n| 3.5\r\n| 0\r\n| 1 - ~5 braches\r\n| 1 - reaches base of 1st inner tooth\r\n| 1.8 - inner branch shorter\r\n| 1.0-2.0 n=2\r\n| 1\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) pirifer&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_piri_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_piri_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.677\r\n| 0.917\r\n| ?\r\n| ?\r\n| 1.4\r\n| 1.75\r\n| 7 - &gt;6\r\n| 4\r\n| 0.5\r\n| 1 - 6 branches\r\n| 1 - reaches at least base of 2nd inner tooth\r\n| 2\r\n| 2.0 n=2 2 apical 1 smooth basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|24|Langdon (www)}\r\n| Cricotopus (Cricotopus) pulchripes&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_pulc_men_Langdonwww_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_pulc_men_Langdonwww_r.jpg 2009-12-15 10:36:17''>\r\n| ?\r\n| ?\r\n| ?\r\n| ?\r\n| 1.4 ( +- 0.1 n=1)\r\n| 1.55 ( +- 0.1 n=1)\r\n| 3.5\r\n| ?\r\n| ?\r\n| ?\r\n| 1\r\n| ?\r\n| ?\r\n| ?\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) reversus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_revu_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_revu_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1\r\n| 0.9\r\n| 1.401\r\n| ?\r\n| 1.5 ( +- 0.1 n=1)\r\n| 1.9 ( +- 0.1 n=1)\r\n| 5.5\r\n| 4\r\n| 1\r\n| 1 - 5 branches\r\n| 1 - reaches middle of 1st inner tooth\r\n| 1.8 - inner branch shorter\r\n| 2.0 1-2 n=4 broad basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) sp. tremulus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_tremsp_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_tremsp_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.289 ( +- 0.028 n=3)\r\n| 0.83\r\n| 1.37 ( +- 0.227 n=6)\r\n| {brown}\r\n| 1.7\r\n| 1.85\r\n| 5 - additional fovea close to s.submenti\r\n| 3\r\n| 1\r\n| 1 - 5 branches\r\n| 1 - reaches base of 1st inner tooth\r\n| 2\r\n| 1.0 n=1\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) suspiciosus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_sspi_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_sspi_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.54\r\n| 0.89\r\n| 1.27\r\n| ?\r\n| 1.58\r\n| 1.78\r\n| 5.5 ( +- 0.5)\r\n| 3.5\r\n| 1\r\n| 1 - 4 branches\r\n| 1 - is small reaches not the base of 1st-lat tooth\r\n| 1.7 - inner shorter\r\n| 4.0 2-4 n=3\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) sylvestris&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_sylv_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_sylv_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.69\r\n| 0.9\r\n| 1.41\r\n| ?\r\n| 1.4\r\n| 2.5\r\n| 6\r\n| 3\r\n| 1\r\n| 1 - ~6-7 branches\r\n| 1 - reaches not the base of 1st inner tooth\r\n| 1.6\r\n| 2.0 2-3 n=4\r\n| 0\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) tibialis&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_tibi_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_tibi_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.53\r\n| 0.84\r\n| 1.2\r\n| ?\r\n| 2.1 ( +- 0.1 n=1)\r\n| 1.56 ( +- 0.1 n=1)\r\n| 4.5 ( +- 0.5)\r\n| 3.5\r\n| 1\r\n| 1 - ~6 branches\r\n| 1 - basal crenate; reaches the middle of 1st inner tooth\r\n| 1.8\r\n| 2.0 2-3 n=1\r\n| 1\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) tremulus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_trem_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_trem_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.39\r\n| 1\r\n| ?\r\n| ?\r\n| 2.1\r\n| 1.6\r\n| 5\r\n| 3\r\n| 1\r\n| 1 - 6 branches\r\n| 1 - small; does not reaching base of first inner tooth\r\n| 2\r\n| 1.0 n=2\r\n| 1\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Cricotopus) triannulatus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_tran_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_tran_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.46\r\n| 0.82\r\n| 1.43\r\n| ?\r\n| 2.24\r\n| 2.24\r\n| 5.5\r\n| 3.5\r\n| 1\r\n| 1 - 6\r\n| 1 - reaches base of 1st inner tooth\r\n| 1.8 - inner branch shorter\r\n| 2.0 n=2\r\n| ?\r\n\r\n|-\r\n| {citeID|46|Simpson et.al. 1983}\r\n| Cricotopus (Isocladius) tricinctus&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricIs_tric_men_Sim1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricIs_tric_men_Sim1983_r.gif 2009-12-15 10:36:17''>\r\n| 1.46\r\n| 0.8\r\n| 1.38\r\n| ?\r\n| 1.3\r\n| 1.69\r\n| 5\r\n| 3.5\r\n| 1\r\n| 1 - 5 branches\r\n| 1 - small don''t reaches basis of 1st inner tooth\r\n| 1.8\r\n| 4.0 2 apical, 2 basal teeth\r\n| ?\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) trifascia&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_tria_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_tria_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.817 ( +- 0.073 n=4)\r\n| 0.775\r\n| 1.241 ( +- 0.089 n=4)\r\n| {yellow}, posterior {brownish}\r\n| 1.8\r\n| 4.3\r\n| 6\r\n| 3\r\n| 1\r\n| 1 - 6 branches\r\n| 1 - reaches middle of 1st inner tooth\r\n| 1.7\r\n| 2.0 n=1 1 apical 1 toothlike process\r\n| 0\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Cricotopus (Cricotopus) vierriensis&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: CricCr_virr_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: CricCr_virr_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n| 1.531 ( +- 0.113 n=9)\r\n| 0.79\r\n| 1.279 ( +- 0.177 n=9)\r\n| {yellow}\r\n| 1.71\r\n| 2.31\r\n| 5.5 ( +- 0.5)\r\n| 4\r\n| 0.2\r\n| 1 - 5 branches\r\n| 1 - does reach middle of 2nd inner tooth\r\n| 1.6\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n|{citeID|452|Zelentsov 1989}&lt;!-- Reference --&gt;\r\n|Cricotopus (Isocladius) shilovae&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Cric_shil_men_Zel1989_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Cric_shil_men_Zel1989_r.gif 2009-12-15 10:36:17''>&lt;!-- Taxon --&gt;\r\n|1.3-1.5 (n=10)&lt;!-- Antennal ratio --&gt;\r\n|1.0, 1.1&lt;!-- Antennal blade ratio --&gt;\r\n|1.2, 1.3, 1.4&lt;!-- Head ratio --&gt;\r\n|?&lt;!-- Head color --&gt;\r\n|?&lt;!-- Mentum middle TR --&gt;\r\n|0.6&lt;!-- Mentum middle to 1.lat-TR --&gt;\r\n|6&lt;!-- Mentum s-submenti lat-tooth_position --&gt;\r\n|3&lt;!-- Mandible inner --&gt;\r\n|1&lt;!-- Mandible margin engraved? --&gt;\r\n|7&lt;!-- Mandible seta interna --&gt;\r\n|1 = 1st inner&lt;!-- Mandible seta subdentalis --&gt;\r\n|1.8&lt;!-- Seta S1 --&gt;\r\n|1&lt;!-- Premandible --&gt;\r\n|0?&lt;!-- Premandible brush --&gt;\r\n\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Cricotopus as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|Taxon\r\n!|Notes\r\n\r\n\r\n|-\r\n|Cricotopus sylvestris agg.\r\n|{citeID|481|Buskens and Moller-Pillot 1992}: Some orthoclads (e.g. Cricotopus sylvestris agg.) still occur in such waters [anaerobic] if specific microhabitats are present to migrate in the direction of the water surface.\r\n\r\n|}\r\n\r\n===Temperature===\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#ff0000"&gt;warm water&lt;/span&gt; Cricotopus sp., Procladius, Chironomus anthracinus-group, Dicrotendipes, Microtendipes chloris, Polypedilum cf. nebeculosum [sic]\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon:\r\n*Cricotopus undifferentiated  and other taxa: 11.5&deg;C &plusmn; 2.8, n=39 (no statistical relationship) . Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n*Cricotopus/Orthocladius  and other taxa: 11.4&deg;C &plusmn; 1.9, n=22 (unimodal Template:HOF:unimodal)  . Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Cricotopus sp. in Alpine running waters of 10.26&deg;C &plusmn;~4.86 (min-max: 4.07-21, n=12).\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Cricotopus/Orthocladius  and other taxa to find possible differences in temperature: 2000: 13.3&deg;C &plusmn; 4.2 (9 to 17.5), 2006: 13.9&deg;C &plusmn; 4.7 (9.2 to 18.5) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n===Conductivity===\r\n\r\n{citeID|502|Zhang et al. 2007} report for Orthocladius/Cricotopus in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 19229.92mg &middot; l⁻&sup1; (&divide; 600 = 32.05mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 2.12027. In article shortened as: Oc.\r\n\r\n\r\n===Depth===\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Orthocladius sp. Cricotopus sp.  and other taxa: 6.9m &plusmn; 5.3 (n=47). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n\r\n===Oxygen===\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cricotopus/Orthocladius (n=29, Template:explained:N2:HillsDiversity=21.37, n&lt;sub&gt;max&lt;/sub&gt;=9.09) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 33.\r\n', '122 1505 ', NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, '1st lateral close to middle tooth', NULL, 1.7, 0.1, 1, 3.3, 0.1, 1, NULL, 5.5, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 7, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(11, 33, NULL, '==Characters==\r\n\r\nComments from {citeID|2|Pinder and Reiss 1983}:\r\n*The form of the mentum, with tooth and 6 or 7 pairs of obliquely arranged, dark lateral teeth, together with \r\n*5 segmented antannae and \r\n*serrated, triangular pecten epipharyngis \r\ndistinguishes Cryptochironomus lavae from all other Chironomini. \r\n{citeID|302|Brooks et.al. 2007}: in contrast to Demicryptochironomus, Cryptochironomus''  first lateral tooth on mentum is fused with the middle tooth and there are only 6 lateral teeth.\r\n\r\n\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default ''|Reference\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|Head\r\n!im90 class=''table-sortable:default ''|Head (L:W)\r\n!im90 class=''table-sortable:default ''|Head reticulation\r\n!im90 class=''table-sortable:default ''|Postoccipital margin\r\n!im90 class=''table-sortable:default ''|Antennal ratio (1 to remaining)\r\n!im90 class=''table-sortable:default ''|Antenna notes\r\n!im90 class=''table-sortable:default ''|Premandible\r\n!im90 class=''table-sortable:default ''|Mentum (outer teeth)\r\n!im90 class=''table-sortable:default ''|Mentum (middle - lateral x-times-middle)\r\n\r\n|-\r\n!|&lt;input name=''filterReference0'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Reference --&gt;\r\n!|&lt;input name=''filterTaxon1'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Taxon --&gt;\r\n!|&lt;input name=''filterHead2'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head --&gt;\r\n!|&lt;input name=''filterHead3'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head (L:W) --&gt;\r\n!|&lt;input name=''filterHead4'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head reticulation --&gt;\r\n!|&lt;input name=''filterPostoccipital5'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Postoccipital margin --&gt;\r\n!|&lt;input name=''filterAntennal6'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antennal ratio (1 to remaining) --&gt;\r\n!|&lt;input name=''filterAntenna7'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antenna notes --&gt;\r\n!|&lt;input name=''filterPremandible8'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Premandible --&gt;\r\n!|&lt;input name=''filterMentum9'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum (outer teeth) --&gt;\r\n!|&lt;input name=''filterMentum10'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum (middle - lateral x-times-middle) --&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|{citeID|7|Morozova 2000}\r\n|C.sp\r\n|5.5-7.0\r\n|&lt;span class=''redorange''&gt;red-orange&lt;/span&gt;\r\n|only at foramen sclerite foundation\r\n|?\r\n|?\r\n|?\r\n|?\r\n|?&lt;!--mentum--&gt;\r\n|?\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|327|Curry 1958}\r\n|C.fulvus&lt;!--species--&gt;\r\n|?&lt;!--total length (mm)--&gt;\r\n|&lt;span class=''darkred''&gt;blood red&lt;/span&gt;&lt;!--body color--&gt;\r\n|darkens toward ventromental plates&lt;!--gular color--&gt;\r\n|uniform color&lt;!--head color--&gt;\r\n|NA&lt;!--head ratio (l:w)--&gt;\r\n|NA&lt;!--head length:width (&micro;m)--&gt;\r\n|?&lt;!--postoccipital margin--&gt;\r\n|?&lt;img align=''middle'' width=200 title=''Cryptochironomus fulvus (mentum) Curry 1958'' src=''image.php?text=image deleted: Crch_fulu_men_Cur1958_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;br&gt;outermost layer tooth distinctly lighter&lt;!--mentum--&gt;\r\n|with weak apical hairs&lt;!--claws anterior parapods--&gt;\r\n|0.95 (38:20:15:3:2)&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|7|Morozova 2000}\r\n|C.supplicans Meig.\r\n|7.0-10.0\r\n|&lt;span class=''redorange''&gt;red-orange&lt;/span&gt;\r\n|2 spots, 1/3 of the gular sclerite length&lt;br&gt;&lt;img align=''middle'' width=150 title=''Cryptochironomus supplicans (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_supp_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|?&lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|1.297 n=1\r\n|684:527 n=1\r\n|?\r\n|?&lt;br&gt;&lt;img align=''middle'' width=200 title=''Cryptochironomus supplicans (mentum) Morozova 2004'' src=''image.php?text=image deleted: Crch_supp_men_Mor2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!--mentum--&gt;\r\n|sharp\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|7|Morozova 2000}\r\n|C.albofasciatus Staeg.\r\n|8.0-11.0\r\n|&lt;span class=''redorange''&gt;red-orange&lt;/span&gt;\r\n|trapeziu-like spot; almost the whole sclerite&lt;br&gt;&lt;img align=''middle'' width=150 title=''Cryptochironomus albofasciatus (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_albo_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|?&lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|1.326 n=1\r\n|749:565 n=1\r\n|?\r\n|?&lt;!--mentum--&gt;\r\n|?\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|7|Morozova 2000}\r\n|C.obreptans Walk.\r\n|8.0-11.5\r\n|&lt;span class=''darkred''&gt;dark red&lt;/span&gt;\r\n|2 spots, 2/3 of the gular sclerite length&lt;br&gt;&lt;img align=''middle'' width=150 title=''Cryptochironomus obreptans (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_obre_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|?&lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|1.282 n=1\r\n|749:584 n=1\r\n|?\r\n|?&lt;!-- mentum --&gt;&lt;img align=''middle'' width=200 title=''Cryptochironomus obreptans (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Crch_obre_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|blunt\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|327|Curry 1958}\r\n|C.digitatus ({citeID|272|Malloch 1915})\r\n|10&lt;!--total length (mm)--&gt;\r\n|&lt;span class=''darkred''&gt;scarlet&lt;/span&gt;, white to colored &lt;span class=''darkred''&gt;dark red&lt;/span&gt; with &lt;span class=''green''&gt;green&lt;/span&gt; dorsal markings on each segment&lt;!-- body color --&gt;\r\n|darkened along the posterior margin of the sclerite&lt;!-- gular color --&gt;\r\n|uniform color &lt;span class=''yellow''&gt;ochrcous to fulvus&lt;/span&gt;&lt;!-- head color --&gt;\r\n|1.27 n=1&lt;!-- head ratio --&gt;\r\n|140:110 n=1&lt;!--head length:width (&micro;m)--&gt;\r\n|?&lt;!--postoccipital margin--&gt;\r\n|130-260&micro;m flat, lateral teeth dark, outermost tooth distinctly above its neighbors&lt;br&gt;&lt;img align=''middle'' width=200 title=''Cryptochironomus digitatus (mentum) Curry 1958'' src=''image.php?text=image deleted: Crch_digi_men_Cur1958_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!--mentum--&gt;\r\n|?&lt;!--claws anterior parapods--&gt;\r\n|1.15 (45:20:14:2:3) &lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|7|Morozova 2000}\r\n|C.redekei Krus.\r\n|11.5-13.5\r\n|&lt;span class=''lightred''&gt;bright red&lt;/span&gt;\r\n|no&lt;br&gt;&lt;img align=''middle'' width=150 title=''Cryptochironomus redekei (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_rede_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt; or &lt;span class=''brown''&gt;brown&lt;/span&gt;\r\n|1.317 n=1\r\n|822:624 n=1\r\n|&lt;span class=''brown''&gt;brown&lt;/span&gt;\r\n|?&lt;!--mentum--&gt;\r\n|?&lt;!--claws anterior parapods--&gt;\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|7|Morozova 2000} {citeID|311|Morozova 2004}\r\n|C.psittacinus Meig.\r\n|8.0-12.0\r\n|&lt;span class=''lightred''&gt;bright red&lt;/span&gt;\r\n|no&lt;br&gt;&lt;img align=''middle'' width=150 title=''Cryptochironomus psittacinus (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_psit_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt; or &lt;span class=''brownish''&gt;light brown&lt;/span&gt;\r\n|1.272 n=1\r\n|862.5 +- 62.5:547 n=1\r\n|&lt;span class=''darkbrown''&gt;dark brown&lt;/span&gt;\r\n|65-75&micro;m&lt;!-- mentum --&gt;\r\n|?\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|7|Morozova 2000} {citeID|311|Morozova 2004}\r\n|C.defectus Kieff, 1913\r\n|7.0-9.0\r\n|&lt;span class=''lightorange''&gt;light orange&lt;/span&gt;\r\n|no&lt;br&gt;&lt;img align=''middle'' width=150 title=''Cryptochironomus defectus (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_defe_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt; or &lt;span class=''brownish''&gt;light brown&lt;/span&gt;\r\n|1.324 n=1\r\n|555 +- 80:449 :n=1\r\n|&lt;span class=''brownish''&gt;light brown&lt;/span&gt;\r\n|45-63&micro;m, grooves nearly reaching margin of plates&lt;br&gt;&lt;img align=''middle'' width=200 title=''Cryptochironomus defectus (mentum) Morozova 2004'' src=''image.php?text=image deleted: Crch_defe_men_Mor2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum --&gt;\r\n|?\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|311|Morozova 2004}\r\n|C.rostratus Kieffer, 1921\r\n|?\r\n|?\r\n|?\r\n|?\r\n|1.415-1.491\r\n|427.5 +- 32.5:295 +- 30\r\n|?\r\n|35-50&micro;m, grooves slightly overlapped&lt;br&gt;&lt;img align=''middle'' width=200 title=''Cryptochironomus rostratus (mentum) Morozova 2004'' src=''image.php?text=image deleted: Crch_rost_men_Mor2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum --&gt;\r\n|?\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n|-\r\n|{citeID|311|Morozova 2004}\r\n|C.denticulatus (Goetghebuer, 1921)\r\n|?\r\n|?\r\n|?\r\n|?\r\n|?\r\n|?:380\r\n|?\r\n|35-50&micro;m, some lines of grooves occaisionally converging to from one line&lt;br&gt;&lt;img align=''middle'' width=200 title=''Cryptochironomus denticulatus (mentum) Morozova 2004'' src=''image.php?text=image deleted: Crch_decu_men_Mor2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum --&gt;\r\n|?\r\n|&lt;!--antennal ratio--&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n==Checklist==\r\n\r\nin China {citeID|279|Wang 2000}:\r\n*C.defectus Kieffer male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cryptochironomus defectus (mentum) Morozova 2004'' src=''image.php?text=image deleted: Crch_defe_men_Mor2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.digitatus ? Malloch {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cryptochironomus digitatus (mentum) Curry 1958'' src=''image.php?text=image deleted: Crch_digi_men_Cur1958_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Cryptochironomus digitatus (mentum) Yan and Ye 1977'' src=''image.php?text=image deleted: Crch_digi_men_YaY1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.fulvus (Johannsen) male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cryptochironomus fulvus (mentum) Curry 1958'' src=''image.php?text=image deleted: Crch_fulu_men_Cur1958_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.rostratus (Kieffer) male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cryptochironomus rostratus (mentum) Morozova 2004'' src=''image.php?text=image deleted: Crch_rost_men_Mor2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.sauter Kieffer male female \r\n*C.supplicans (Meigen) male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Cryptochironomus supplicans (mentum) Morozova 2004'' src=''image.php?text=image deleted: Crch_supp_men_Mor2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*C.sp. male female\r\n\r\n==Keys==\r\n\r\nThe following key is from {citeID|7|Morozova 2000}:\r\n\r\n;1 (8):Gular {overlib|sclerite coloured|&lt;img align=''middle'' width=150 title=''Cryptochironomus obreptans (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_obre_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n;2 (5):Head {yellow} or {light brown}\r\n;3 (4):Gular sclcrite coloured only at the foramen scleritc foundation. Body colour {red orange}. TL 5.5-7.0mm~-&gt; C. sp.\r\n;4 (3):Gular scleritc colouring has form of two spots occupying 1/3 of the gular sclerite length. Body colour {red orange}. TL 7.0-10.0mm~-&gt; C. supplicans Meig.\r\n;5 (2):Head {dark yellow} or {brown}\r\n;6 (7):Trapezium-like spot of gular sclerite colouring occupying almost the whole sclerite. Body colour {red orange}. TL 8.0&mdash;11.0mm~-&gt; C. albofasciatus Staeg.\r\n;7 (6):Gular sclerite colouring has form of two spots occupying 2/3 of the gular sclerite length. Body colour {dark red}. TL 8.0-11.5mm~-&gt; C. obreptans Walk.\r\n;8 (1):Gular {overlib|sclerite not coloured|&lt;img align=''middle'' width=150 title=''Cryptochironomus redekei (head ventral) Morozova 2000'' src=''image.php?text=image deleted: Crch_rede_hve_Mo2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n;9 (10):Head {dark yellow} or {brown}. Foramen sclerite {brown}. Body colour {bright red}. TL 11.5-13.5~-&gt; C. redekei Krus.\r\n;10 (9):Head {yellow} or {light brown}\r\n;11 (12):Foramen sclerite {dark brown}. Body colour {bright red}. TL 8.0-12.0mm~-&gt; C. psittacinus Meig.\r\n;12 (11):Foraincn sclerite {light brown}. Body colour {bright orange}. TL 7.0-9.0mm~-&gt;  C. defectus Kieff.\r\n\r\nFrom {citeID|311|Morozova 2004}:\r\n#~\r\n##Median tooth of mentum pale, without lateral incisions. Last lateral teeth of mentum situated above first lateral teeth~-&gt; 2.\r\n##Median tooth of mentum dark, with lateral incisions. Last lateral teeth of mentum situated below first lateral teeth~-&gt; C. ussouriensis (Goetghebuer, 1933). The species known only from Russia.\r\n#~\r\n##Gular sclerite pigmented, with spot occasionally large, occupying more than half of length of gular sclerite, or pale. Base of occipital sclerite pigmented similarly to apical tooth of mandible~-&gt; 3.\r\n##Gular sclerite pale, unpigmented. Base of occipital sclerite {pale} or {dark yellow}~-&gt; 4.\r\n#~\r\n##C. obreptans and C. supplicans. These species hardly distinguishable, can be differentiated using the following characters.\r\n###S3&mdash;S3 45-65 microns; index S3/A1, (ratio of S3-S3 to length of lst antennal segment) 0.63--0.70. Teeth on claws of fore pushers blunt~-&gt; C. obreptans (Walker, 1856).\r\n###S3-S3 60-80 microns; index S3/A1 0.76-0.90. Teeth on claws of fore pushers sharp~-&gt; C. supplicans (Meigen. 1830).\r\n#~\r\n##Length of head 395-635 microns. width 265-435 microns~-&gt; 5.\r\n##Length of head 600-925 microns. width 530-720 microns~-&gt; 7.\r\n#~\r\n##LMO [distance postoccipital margin &lt;-&gt; mentum middle tooth] 180-240 microns. Length of ventromental plates 45-63 microns. Length of head 475-635 microns. Grooves on ventromental plates nearly reaching margin of plates. Occurring in ditch- and slowly flowing water~-&gt; C. defectus (Kieffer, 1913).\r\n##LMO 135-170 microns. Length of ventromental plates 35-50 microns. Length of head 395-460 microns.  Grooves on ventromental plates constituting only 3/4 of length of ventromental plates. Living in flowing water~-&gt; 6.\r\n#~\r\n##Fourth lateral tooth of inentum higher than 5th one LMO 135-170 microns. Grooves of ventromental plates slightly overlapped. Length of head 395-460 microns, width 265-325 microns. 2nd and 3rd antennal segments of subequal length. SSd [ straight line from mandible apical &lt;-&gt; to the opposite edge] reaching upper tooth of mandible. Occurring in rivers~-&gt; C. rostratus Kieffer, 1921.\r\n##Fourth lateral tooth of mentum nearly as high as 5th one. LMO 150 microns. Grooves of ventromental plates large, rather widely separated from one another; some lines of grooves occasionally converging to form one line. Length of head unknown, width 380 microns. Second antennal segment shorter than 3rd one. SSd reaching 2nd lower tooth of mandible. Gccurring in streams, rare species~-&gt; C.denticulatus (Goetghebuer. 1921 ).\r\n#~\r\n##Occipital sclerite {pale} or {dark yellow}. Length of head 800-925 microns. LMO 330-360 microns. Length of ventromental plates 65-75 microns. Length of mandible 225-270 microns. Index S3/A1 1.05-1.2~-&gt; C.psittacinus (Meigen. 1830) and C.redekei (Kruseman. 1933).\r\n##Occipital sclerite {brown}, similarly to upper tooth of mandible. Length of head 600-820 microns. LMO 238-250 microns. Length of ventromental plates 55-65 microns. Length of mandible 215-225 microns. Index S3/A1 0.71-0.86~-&gt; Cryptochironomus sp.\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Cryptochironomus as ubiquitous taxa in a lentic-lotic gradient in France.\r\n\r\n===Conductivity/Salinity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Cryptochironomus in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 1283.64mg &middot; l⁻&sup1; (&divide; 600 = 2.14mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 2.55398. In article shortened as: Cr.\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Cryptochironomus sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '37 1431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(12, 35, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cyphomella/Harnischia (n=5, Template:explained:N2:HillsDiversity=4.37, n&lt;sub&gt;max&lt;/sub&gt;=3.64) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 17.\r\n', '109 59', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(13, 36, NULL, NULL, 1, NULL, '43 20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(14, 37, NULL, 'in China ({citeID|279|Wang 2000}):&lt;br&gt;\r\n\r\nSubgenus Irmakia\r\n*D. spatulatus \r\n*D. vulneratus \r\n\r\nComments from {citeID|2|Pinder and Reiss 1983}: The combination of \r\n*7 segmented antenna and \r\n*broad pale median mental tooth flanked by 7 pairs of darker coloured, oblique arranged lateral teeth \r\ncharacterizes larvae of this genus.\r\n&lt;br&gt;\r\nIn contrast to Demicryptochironomus, Cryptochironomus''  first lateral tooth on mentum is fused with the middle tooth and there are only 6 lateral teeth ({citeID|302|Brooks et.al. 2007}).', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Demicryptochironomus as lotic taxa in a lentic-lotic gradient in France.\r\n\r\nSee ?{textciteID|357|Yan et.al. 2005b}\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Demicryptochironomus the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '33 1431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(15, 39, NULL, '==Characters==\r\n\r\n{citeID|2|Pinder and Reiss 1983}: Dicrotendipes larvae, with 1 exception have labral sclerite 1 and 2 separete and an antero-median pit or mark on the frontal apoptome which atherwise occours oly in Demijerea, Einfeldia (species group A), Glyptotendipes (species group  C), Kiefferulus and Nilodorum. \r\n*The pecten epipharyngis almost always has 5-7 broad teeth\r\nwhilst in the other named genera many teeth are usually present. \r\n*A useful character is the antennal segment 4 which is 4-6x as long as broad in Dicrotendipes but distinctly shorter than this in the other mentioned genera.\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*D.flexus (Johansen) male\r\n*D.nervosus (Staeger) male\r\n*D.pelochloris (Kieffer) mal female\r\n*D.septemmaculatus Becker male female\r\n*D.tamaviridis Sasa male female\r\n*D.tritomus (Kieffer)\r\n\r\n==Key==\r\n\r\nKey to known 4th instar larvae of Holarctic Dicrotendipes from {citeID|442|Epler 1988b}:\r\n\r\n#~\r\n##Frontal apotome with a large anteromesal oval or subquadrate area; frontal pit or process absent~-&gt; 2\r\n##Frontal apotome without such an area; a small anteromedian frontal pit or frontal process usually present~-&gt; 5\r\n#~\r\n##A frontoclypeal apotome present; sixth lateral tooth of mentum well developed; 30-41, mean 35, ventromental strial ridges~-&gt; D. lobiger\r\n##A frontal apotome present; sixth lateral tooth of mentum reduced or closely appressed to 5th~-&gt; 3\r\n#~\r\n##Palaearctic species~-&gt; 4\r\n##Nearctic species; 37-60, mean 52 ventromental strial ridges~-&gt; D. leucoscelis\r\n#~\r\n##Eastern Palaearctic species; 30-34, mean 32 ventromental strial ridges~-&gt; D. pelochloris\r\n##Western Palaearctic species; about 40 ventromental strial ridges~-&gt; D. notatus\r\n#~\r\n##Second lateral tooth of mentum almost completely fused with or closely appressed to 1st so that 1st lateral tooth appears notched~-&gt; 6\r\n##Second lateral tooth at most only partially fused to 1st lateral at base, 1st lateral tooth not appearing notched~-&gt; 9\r\n#~\r\n##Head capsule integument appears coarsely granular at 400X; Nearctic species~-&gt; 16\r\n##Head capsuleintegument at most appears slightly granular at 400X; Nearctic or Palaearctic species~-&gt; 7\r\n#~\r\n##A long, ventral frontal process present on anteromedian margin of frontal apotome; Palaearctic only~-&gt; D. septemmaculatus\r\n##Long frontal process absent, but a frontal pit usually present; Nearctic only~-&gt; 8\r\n#~\r\n##Anal tubules reduced; anterior margin of ventromental plate mostly smooth; coastal, brackish water species of SE U.S.A.~-&gt; D. lobus\r\n##Anal tubules normal; at least anterior outer margin of ventromental plate usually crenulated; widespread in Nearctic~-&gt; D. neomodestus\r\n#~\r\n##60-70 ventromental strial ridges; Palaearctic only~-&gt; D. pallidicornis\r\n##Less than 50 ventromental strial ridges; Nearctic or Palaearctic~-&gt; 10\r\n#~\r\n##Ventromental plate with 22 or fewer strial ridges; anterior margin deeply scalloped~-&gt; 11\r\n##Ventromental plate with more than 22 strial ridges; anterior margin smooth or with shallow to moderate crenulations~-&gt; 12\r\n#~\r\n##Nearctic species (known only from Florida)~-&gt; D. thanatogratus\r\n##Palaearctic species~-&gt; D. fusconotatus\r\n#~\r\n##Proximal tooth of mandible saddle&mdash;shaped or with 2 points; or with inner surface of mandible adjacent to proximal tooth with deep semicircular incision; Nearctic~-&gt; 13\r\n##Proximal tooth of mandible mostly triangular in outline, not as above; Holarctic~-&gt; 14\r\n#~\r\n##Sixth lateral tooth of mentum rounded and closely appressed or fused to 5th lateral tooth; inner surface of mandible adjacent to proximal tooth with deep semicircular incision~-&gt; D. simpsoni\r\n##Sixth lateral tooth of mentum pointed; inner surface of mandible adjacent to proximal tooth without deep semicircular incision~-&gt; D. lucifer\r\n#~\r\n##Sixth lateral tooth of mentum rounded and closely appressed or fused to 5th lateral tooth~-&gt; D. nervosus\r\n##Sixth lateral tooth pointed, separate~-&gt; 15\r\n#~\r\n##Head capsule integument appears coarsely granular at 400X; head capsule color {yellow brown} to {yellow red brown}; Nearctic species~-&gt; 16\r\n##Head capsule integument at most appears slightly granular at 400X; head capsule color {light brown} to {brown} or {pale yellow}; Holarctic species~-&gt; 18\r\n#~\r\n##Postmentum or posterior portion of head capsule usually not darkened; 1st lateral teeth of mentum often turned outward; occurs throughout the Nearctic~-&gt; D. fumidus\r\n##Postmentum or posterior portion of head capsule much darker than rest of head capsule; 1st lateral teeth of mentum rarely turned outward; western U.S.A~-&gt; 17\r\n#~\r\n##Ventromental plate with crenulated anterior margin; 23-28, mean 25, ventromental strial ridges; known from central and eastern New Mexico and Imperial Dam vicinity, California (possibly Kansas)~-&gt; D. crypticus\r\n##Ventromental plate with smooth anterior margin; 34-42, mean 37, ventromental strial ridges; widespread in western U.S.A.~-&gt; D. californicus\r\n#~\r\n##Head capsule {pale yellow}~-&gt; 19\r\n##Head capsule {light brown} to {brown}~-&gt; 20\r\n#~\r\n##Ventromental strial ridges 28-36, mean 32; postmentum usually darkened~-&gt; D. modestus\r\n##Ventromental strial ridges 23-29, mean 25; postmentum rarely darkened~-&gt; D. tritomus\r\n#~\r\n##Anterior margin of ventromental plates mostly smooth; known only from Chiricahua Mountains of SE Arizona~-&gt; D. adnilus\r\n##Anterior margin of ventromental plates with shallow to moderate crenulations; widespread in Holarctic~-&gt; D. modestus\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Dicrotendipes as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n===Temperature===\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#ff0000"&gt;warm water&lt;/span&gt; Cricotopus sp., Procladius, Chironomus anthracinus-group, Dicrotendipes, Microtendipes chloris, Polypedilum cf. nebeculosum [sic]\r\n\r\n{citeID|492|Brodersen et al. 2004}: Warm-water chironomid assemblages characterized by taxa such as Chironomus, Dicrotendipes, Ablabesmyia, and Procladius had a high oxy-regulatory capacity.\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Dicrotendipes  and other taxa to find possible differences in temperature: 2000: 14.3&deg;C &plusmn; 3.2 (11.1 to 17.5), 2006: 14.3&deg;C &plusmn; 4 (10.3 to 18.3) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nDicrotendipes sp. reported by {citeID|516|Korhola et al. 2002} as warm adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Dicrotendipes  and other taxa: 11.9&deg;C &plusmn; 1.2, n=43 (skewed curve Template:HOF:skewedLeft Template:HOF:skewedRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n===Depth===\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Dicrotendipes sp.  and other taxa: 6.1m &plusmn; 3.7 (n=41). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Oxygen===\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Dicrotendipes (n=39, Template:explained:N2:HillsDiversity=27.34, n&lt;sub&gt;max&lt;/sub&gt;=18.82) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id\r\n%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 18.\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Dicrotendipes the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '20 43 34 67', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(16, 41, NULL, '{| style=''border:1px solid;''\r\n|-\r\n!|Reference\r\n!| Pr.Md. \r\n!|&lt;!-- se1 --&gt;seta S1\r\n!|post.Parapods\r\n!|spur\r\n!|poo.plate\r\n!|ant.ped.\r\n!|mand.\r\n!|ventrom.plates.\r\n!|median tooth <br>(mentum)\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}:\r\n|&lt;!-- pre --&gt;1<br> no brush\r\n|&lt;!-- se1 --&gt;simple\r\n|&lt;!-- post.par --&gt;\r\n|&lt;!-- spur --&gt;\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- anp --&gt;\r\n|&lt;!-- man --&gt;4-1-0-0\r\n|&lt;!-- vep --&gt;broad, extending beyond margin of outer mental tooth; beared\r\n|&lt;!-- men --&gt; 2; 6 lateral\r\n|}\r\n<br>\r\n\r\n''''{citeID|2|Pinder and Reiss 1983}:''''\r\n The simple S1, presence of beared and the mandoble with apical tooth longer than combined width of 4 inner teeth will seperate the larvae of Doncricotopus from all other Orthocladiinae.\r\n', 1, NULL, '232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(17, 43, NULL, 'Species group C (E.carbonaria, E.longipes) in {textciteID|2|Pinder and Reiss 1983} cannot be distinguished from Chironomus in the larval stage. In {textciteID|4|Oliver and Roussel 1983} (p.312) Larvae of Einfeldia with ''''one'''' pair of ventral tubules are easily distinguished from those of Chironomus with ''''two'''' pairs of tubules, but are difficult to separate from some Glyptotendipes. Usually the presence of spines on the inner margin of the mandible of Einfeldia will distinguish it from Glyptotendipes, but these are sometimes weak or worn.&lt;br&gt;\r\nannote Plank 28.06.2005: differences to Chironomus?: setation below ventromental plates, pecten epipharyngis&lt;br&gt;\r\nannote Brooks 12.10.2007 pers.com.:  distinctive for E.pagna is the hole in frontoclypaeus and the engraved pattern (see also pictures from {citeID|302|Brooks et.al. 2007}).\r\n&lt;hr&gt;\r\nExtracted key from {textciteID|302|Brooks et.al. 2007}:\r\n#median tooth of mentum &gt; 1st lateral tooth -&gt; 2&lt;br&gt;median tooth of mentum &lt;== 1st lateral tooth -&gt; 3\r\n#Mandible with 3 inner teeth Einfeldia dissidens type [Plank: 1 tooth in middle]&lt;br&gt;Mandible with 2 inner teeth Einfeldia natchitocheae-type [Plank: 1 tooth in middle]\r\n#4th lateral tooth of mentum shorter than 5th lateral tooth, mandible with 2 inner teeth -&gt; Chironomus anthracinus type&lt;br&gt;4th lateral tooth longer than 5th lateral tooth, mandible with 3 inner teeth -&gt; 4\r\n#Dorsal sclerite of head with distinctive ''orange peel'' sculpturing, an large hole present -&gt; Einfeldia pagna type [is Chironomus like]&lt;br&gt;Dorsal sclerite entire sculpturing absent -&gt; Chironomus plumosus type\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|taxon\r\n!im|hole (dorsal sclerite)\r\n!im|dorsal sculpturing\r\n!im|mentum: 1 single tooth (middle)\r\n!im|mentum type\r\n!im|mandible\r\n\r\n|-\r\n|{textciteID|22|Makarchenko 1999}\r\n|Einfeldia longipes\r\n|yes\r\n|yes\r\n|no\r\n|2\r\n|2-1-0-0\r\n\r\n|-\r\n|{textciteID|302|Brooks et.al. 2007}\r\n|Einfeldia pagna\r\n|yes\r\n|yes\r\n|no\r\n|1\r\n|3-1-2-0 ({citeID|2|Pinder and Reiss 1983})\r\n\r\n\r\n|-\r\n|{textciteID|2|Pinder and Reiss 1983}\r\n|Einfeldia carbonaria\r\n|no\r\n|no\r\n|no\r\n|1\r\n|3-1-0-0 \r\n\r\n|-\r\n|{textciteID|302|Brooks et.al. 2007}\r\n|Einfeldia dissidens type\r\n|no\r\n|no\r\n|yes\r\n|2\r\n|3-1-0-0\r\n\r\n|-\r\n|{textciteID|302|Brooks et.al. 2007}\r\n|Einfeldia natchitocheae-type\r\n|no\r\n|no\r\n|yes\r\n|3\r\n|2-1-0-0 \r\n\r\n\r\n|-\r\n|{textciteID|8|Vallenduuk 1997}\r\n|Chironomus\r\n|no\r\n|no\r\n|no\r\n|1-3\r\n|3-1-0-0 \r\n\r\n|-\r\n|{textciteID|8|Vallenduuk 1997}\r\n|Chironomus\r\n|no\r\n|no\r\n|no\r\n|1-3\r\n|2-1-0-0 \r\n\r\n|}\r\n', 1, '==Biotops==\r\n\r\n{textciteID|302|Brooks et al. 2007}: &laquo;Found in the littoral of lentic environments ({citeID|575|Hofmann 1984b}) and often soft sediments. Ususally indicative of eutrophic waters (e.g. {citeID|364|Chernovskyj 1949}; {citeID|576|Kansanen 1985}; {citeID|577|S&aelig;ther 1979}; {citeID|553|Brooks et al. 2001}; {citeID|578|Langdon et al. 2006}). In the alpine region of Switzerland the genus is also found in relatively cool conditions ({citeID|579|Heiri 2001}) and has been found in Lateglacial stadial sediments from the Swiss Alps (e.g. {citeID|532|Brooks 2000}). It is absent from modern sediments in the Norwegian training set ({citeID|580|Brooks and Birks 2001}).&raquo;\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n|-\r\n|Einfeldia dissidens (Walk.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Einfeldia synchrona (Ol.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Einfeldia dissidens (Walk.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Einfeldia synchrona (Ol.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n===Temperature===\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Einfeldia  and other taxa: 0&deg;C &plusmn; 0, n=2. Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', '53 20 51 197 36 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(18, 44, NULL, '==Generic characters==\r\n\r\n{citeID|2|Pinder and Reiss 1983}: Larvae of Endochironomus have very uniform characters,  so  that  separation  into  species groups is not appropriate. The species previously included in the intextus group are now placed in Tribelos. \r\n*A {overlib|frontal apotome|&lt;img align=''middle'' width=100 title=''Endochironomus albipennis (fronto clypeaus/apoptom) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Ench_alpe_fap_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} and an equally broad clypeus are present in Endochironomus larvae. \r\n*The form of the {overlib|S1 is specific|&lt;img align=''middle'' width=40 title=''Endochironomus albipennis (seta S1) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Ench_alpe_se1_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} to the genus, being slender, triangular and feathered only along the inner side; \r\n*the seta praemandibularis is always divided distally. \r\n*The {overlib|pecten epipharyngis|&lt;img align=''middle'' width=150 title=''Endochironomus albipennis (labro-epipharyngeal region) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Ench_alpe_lab_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} consists of 3 , distally toothed plates with toothlets also on their faces. \r\n*The dorsal tooth of the {overlib|mandible|&lt;img align=''middle'' width=100 title=''Endochironomus albipennis (mandible) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Ench_alpe_man_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} does not extend beyond the outer margin.\r\nTribelos and Phaenopsectra larvae are frequently confused with those or Endochironomus because of their very similar mentum. However, i&shy;n both of these genera the S1 is feathered along both sides, the seta praemandibularis is simple and the dorsal tooth protrudes beyond the outer margin of the mandible. In addition Phaepsectra larvae have a frontoclypeal apotome and a pecten epipharyngi&shy;s which lacks toothlets on the surface, whilst Tribelos has a labral sclerite 1 in place of the clypeus.\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*E.nigricans ? Johannsen {overlib|mentum|&lt;img align=''middle'' width=200 title=''Endochironomus nigricans (mentum) Yan and Ye 1977'' src=''image.php?text=image deleted: Ench_nica_men_YaY1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*E.pekanus (Kieffer) male\r\n*E.tendens ? (Fabricius) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Endochironomus tendens (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Ench_tede_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*E.sp male female\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Endochironomus as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n===Temperature===\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Endochironomus  and other taxa to find possible differences in temperature: 2000: 14.3&deg;C &plusmn; 2.6 (11.7 to 16.8), 2006: 14.3&deg;C &plusmn; 3.5 (10.7 to 17.8) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n===Oxygen===\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Endochironomus (n=16, Template:explained:N2:HillsDiversity=12.51, n&lt;sub&gt;max&lt;/sub&gt;=6.09) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 19.\r\n', '182 223 154 159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(19, 46, NULL, '==Characteristics genus==\r\n\r\n''''{citeID|21|Cranston et.al. 1983}'''': The combination of a \r\n*procercus more than 1.5x as long as wide, \r\n*body setae shorter than 1/2 the length of an abdominal segment and a \r\n*{overlib|simple S1|&lt;img align=''middle'' title=''Eukiefferiella claripennis (setae S1, ...) Schmid 1993'' src=''image.php?text=image deleted: Euki_clar_set_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} \r\nwill distinguish Eukiefferiella from Tvetenia.\r\n\r\nEukiefferiella has been divided into a number of groups. One of these groups, the veralli or discoloripes group, has been placed in Tvetenia. The groups have been primarily based on pupal characters. ... there are several groups or species (i.e. E. similis group, E. clypeata (Kieffer) and E. pseudomontana (Goethgebuer) which are unknown or require clarification. ... The genus requires revision.\r\n\r\n{| style=''border:1px solid;''\r\n!|Reference \r\n!im|head\r\n!im|postoccipital margin\r\n!im90|antenna\r\n!|s 1\r\n!|s 2\r\n!|s 3\r\n!im|premandible\r\n!im90|mentum (middle)\r\n!im90|mentum (lateral)\r\n!im|mentum (patterns)\r\n!im|mandible\r\n!im|seta interna (mandible)\r\n!im|seta subdentalis (mandible)\r\n!im|maxilla\r\n!im|pecten galearis (maxilla)\r\n!im|lacinal chaeta (maxilla)\r\n!im|abdomen\r\n\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|{yellow} to&lt;br&gt; {dark brown}\r\n|darkend\r\n|4-5\r\n|simple\r\n|simple\r\n|usually simple, sometimes bifid\r\n|broad and with apical tooth\r\n|1-2\r\n|4-5\r\n|sclerotization of median mental area with irregular longitudinal bands\r\n|3/4-1-0-0\r\n|4-7 simple or serrated branches\r\n|simple\r\n|seta-like galeal lamellae\r\n|no (mostly) or indistinct\r\n|at least 1, broad and distinctively serrated\r\n|body setae of variable length but shorter than 0.5 length of segment bearing them\r\n|}\r\n\r\n==Key==\r\n\r\nThis key is from {citeID|410|Bode 1983}:\r\n#''''a'''' Head capsule {yellow} to {light brown}; procerci 1.5-2.0 times longer than wide; middle abdomen (excluding thorax and last 2 abdominal segments) with some setae at least 1/2 as long as corresponding segment; labral seta 1 divided into two or more branches~-&gt; Tvetenia (2)&lt;br&gt;''''b'''' Head capsule medium {brown} to {black}; procerci less than 1.5 times as long as wide; middle abdominal setae less than 1/2 as long as  corresponding segment; labral seta 1 simple-&gt; Eukiefferiella (3)\r\n#''''a'''' Mentum with single median tooth; ventromental plates pointed at lateral margins~-&gt; T.discoloripes group&lt;br&gt;''''b'''' Mentum with two median teeth; ventromental plates rounded at lateral margins~-&gt; T.bavarica group\r\n#''''a'''' Middle abdominal setae at least 1/10 as long as segment; antennal blade longer than antennal segment 2. usually reaching apex of segment 4~-&gt; (4)&lt;br&gt;''''b'''' Middle abdominal setae less than 1/10 as long as segment; antennal blade about as long as antennal segment 2~-&gt; (7)\r\n#''''a'''' Mentum with 4 pairs of lateral teeth; labral seta~III bifid; head capsule height (unmounted) about 3/4 of head length~-&gt; E.devonica group&lt;br&gt;''''b'''' Mentum with 5 pairs of lateral teeth, labral seta~III simple; head capsule height (unmounted) only about 1/2 of head length~-&gt; (5)\r\n#''''a'''' Antennal ratio 1.00-1.20, 3rd segment no longer than wide; anal setae reduced, shorter than posterior parapods; middle abdominal setae only 1/5-1/6 as long as corresponding segment; mentum with single pointed median tooth~-&gt; E.similis group&lt;br&gt;''''b'''' Antennal ratio 1.20-1.80, 3rd segment longer than wide; anal setae longer than posterior parapods; middle abdominal setae at least 1/3 as long as corresponding segment; mentum variable~-&gt; (6)\r\n#''''a'''' Mentum with single median tooth; antennal ratio 1.50-1.80~-&gt; E.gracei group&lt;br&gt;''''b'''' Mentum with two median teeth; antennal ratio 1.20-1.50~-&gt; E.brehmi group\r\n#''''a'''' Posterior parapods 4-5 times longer than wide; anal setae greatly reduced, less than 1/2 as long as parapods; mentum with a single, wide median tooth~-&gt; E.cyanea group&lt;br&gt;''''b'''' Posterior parapods not more than 4 times longer than wide; anal setae about as long as parapods; mentum variable~-&gt; (8)\r\n#''''a'''' Sense pit located at midpoint or proximal to midpoint of basal antennal segment~-&gt; (9)&lt;br&gt;''''b'''' Sense pit located distal to midpoint of basal antennal segment~-&gt; (10)\r\n#''''a'''' Antenna 5-segmented, blade slightly longer than segment 2; mentum with median teeth quadrate and well-separated; ventromental plates rounded at posterolateral corner~-&gt; E.rectangularis group&lt;br&gt;''''b'''' Antenna 4-segmented, blade as long as segment 2; mentum with median teeth somewhat pointed and mostly fused, 1st lateral teeth mostly fused to medians; ventromental plates inconspicuous~-&gt; E.coerulescens group\r\n#''''a'''' Ventral seta of 10th abdominal segment small, only about 25&micro;m long; ventromental plates large and triangular, extending posterolaterally to edge of mentum; antennal ratio 1.40-1.80 mentum with wide, rounded median teeth~-&gt; E.pseudomontana group&lt;br&gt;''''b'''' Ventral seta of 10th abdominal segment larger, usually &gt; 40&micro;m long; ventromental plates not so extended laterally; antennal ratio usually &gt; 1.80; mentum variable~-&gt; (11)\r\n#''''a'''' Mentum with median teeth no wider than 1st lateral teeth~-&gt; E.claripennis group&lt;br&gt;''''b'''' Mentum with median teeth wider than 1st lateral teeth, or median tooth single~-&gt; E.brevicalar group\r\n\r\n==Taxa Characters==\r\n\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default ''|Reference\r\n! class=''table-sortable:default ''|Taxa\r\n!im90 class=''table-sortable:default ''|Mandible inner teeth\r\n!im90 class=''table-sortable:default ''|Mola (mandible inner margin spines)\r\n!im90 class=''table-sortable:default ''|Mentum middle\r\n\r\n|-\r\n!|&lt;input name=''filterReference0'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Reference --&gt;\r\n!|&lt;input name=''filterTaxa'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Taxa --&gt;\r\n!|&lt;input name=''filterMandible1'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible inner teeth --&gt;\r\n!|&lt;input name=''filterMola2'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n!|&lt;input name=''filterMentum3'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum middle --&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|E.clypeata&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_clyp_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_clyp_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n|3&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_clyp_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_clyp_man_Sch1993_r.gif 2009-12-15 10:36:17''>&lt;!-- Mandible inner teeth --&gt;\r\n|3&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n|2&lt;!-- Mentum middle --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|E.claripennis&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_clar_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_clar_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n|4&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_clar_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_clar_man_Sch1993_r.gif 2009-12-15 10:36:17''>&lt;!-- Mandible inner teeth --&gt;\r\n|4-5&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n|2&lt;!-- Mentum middle --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|E.brevicalcar&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_brev_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_brev_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n|4&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_brev_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_brev_man_Sch1993_r.gif 2009-12-15 10:36:17''>&lt;!-- Mandible inner teeth --&gt;\r\n|3&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n|1&lt;!-- Mentum middle --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|E.gracei&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_grce_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_grce_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n|3.5&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_grce_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_grce_man_Sch1993_r.gif 2009-12-15 10:36:17''>&lt;!-- Mandible inner teeth --&gt;\r\n|5 (2-3 large)&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n|1&lt;!-- Mentum middle --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|E.ilkleyensis&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_ilkl_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_ilkl_men_Sch1993_r.gif 2009-12-15 10:36:17''>\r\n|3&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_ilkl_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_ilkl_man_Sch1993_r.gif 2009-12-15 10:36:17''>&lt;!-- Mandible inner teeth --&gt;\r\n|3 large&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n|1&lt;!-- Mentum middle --&gt;\r\n\r\n|-\r\n|{citeID|325|B&iacute;r&oacute; 1981}\r\n|E.quadridentata&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_qude_men_Bia1981_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_qude_men_Bia1981_r.gif 2009-12-15 10:36:17''>\r\n|2.5&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_qude_man_Bia1981_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_qude_man_Bia1981_r.gif 2009-12-15 10:36:17''>&lt;!-- Mandible inner teeth --&gt;\r\n|?&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n|1&lt;!-- Mentum middle --&gt;\r\n\r\n|-\r\n|{citeID|41|Yan et.al. 1982}\r\n|E.tentoriola&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_teto_men_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_teto_men_Yan1982_r.gif 2009-12-15 10:36:17''>\r\n|4&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Euki_teto_man_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Euki_teto_man_Yan1982_r.gif 2009-12-15 10:36:17''>&lt;!-- Mandible inner teeth --&gt;\r\n|?&lt;!-- Mola (mandible inner margin spines) --&gt;\r\n|1&lt;!-- Mentum middle --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):&lt;br&gt;\r\n*E.boevensis Brundin\r\n*E.brevicalcar (Kieffer) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Eukiefferiella brevicalcar (mentum) Schmid 1993'' src=''image.php?text=image deleted: Euki_brev_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*E.claripennis (Ludbeck) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Eukiefferiella claripennis (mentum) Schmid 1993'' src=''image.php?text=image deleted: Euki_clar_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Eukiefferiella claripennis (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Euki_clar_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Eukiefferiella claripennis (mentum) Ye 1984'' src=''image.php?text=image deleted: Euki_clar_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*E.gracei (Edwards) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Eukiefferiella gracei (mentum) Schmid 1993'' src=''image.php?text=image deleted: Euki_grce_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Eukiefferiella gracei (mentum) Ye 1984'' src=''image.php?text=image deleted: Euki_grce_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*E.ilkleyensis (Edwards) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Eukiefferiella ilkleyensis (mentum) Schmid 1993'' src=''image.php?text=image deleted: Euki_ilkl_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*E.quadridentata (?) (Tshernovskij) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Eukiefferiella quadridentata (mentum) B&iacute;r&oacute; 1981'' src=''image.php?text=image deleted: Euki_qude_men_Bia1981_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*E.takahashi (Tokunaga)\r\n*E.tentoriola (?) (Tokunaga) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Eukiefferiella tentoriola (mentum) Yan et.al. 1982'' src=''image.php?text=image deleted: Euki_teto_men_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Eukiefferiella as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n===Temperature===\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Eukiefferiella  and other taxa to find possible differences in temperature: 2000: 10.6&deg;C &plusmn; 4.5 (6.1 to 15.2), 2006: 8.9&deg;C &plusmn; 4.6 (4.3 to 13.4) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n===Depth===\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Eukiefferiella sp.  and other taxa: 12.2m &plusmn; 7 (n=6). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', '155 186 18', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(20, 48, NULL, NULL, 1, NULL, '13 49', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(21, 49, NULL, '==Characters==\r\n\r\n{citeID|21|Cranston et.al. 1983}: Larvae of Euryhapsis and Brillia are similar but may be distinguished by the antennal structure. Both have 4 segmented  antenna, but the second is subdivided in Brillia. \r\n*The ventromental beared, which can only be seen at high magnification in Euryhapsis, is absent in Brillia.&lt;br&gt;\r\n{citeID|6|Epler 2001}: The \r\n*broad, pectinate labral lamellae; \r\n*{overlib|plumose S I|&lt;img align=''middle'' alt=''Euryhapsis cilium (setae S1, ...)'' title=''Euryhapsis cilium (setae S1, ...) Cranston et.al. 1983'' src=''image.php?text=image deleted: Eurh_cili_set_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}; \r\n*4 segmented antennae (with 2nd segment entire) with antennal blade longer than flagellum; \r\n*very short ventromental beard; \r\n*posteriorly displaced setae submenti; and \r\n*well developed procerci and \r\n*anal tubules will distinguish this genus.\r\n\r\n==Comments==\r\n\r\nSee also Cricotopus shilovae.\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}): \r\n*E.fuscipropes S&aelig;ther and Wang 1992 \r\n', 1, '==Conductivity==\r\n\r\n{citeID|502|Zhang et al. 2007} report for Euryhapsis in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 860.83mg &middot; l⁻&sup1; (&divide; 600 = 1.43mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 6.21979. In article shortened as: Eu.\r\n', '13 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(22, 51, NULL, NULL, 1, NULL, '197 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(23, 53, NULL, ';distinct:postoccipital margin\r\n\r\nDifferences within Glyptotendipes: \r\n*Mandible 3-1-&lt;span title=''inner-apikal-outer-surfece'' style=''color:red;''&gt;0/1&lt;/span&gt;-0\r\n*Frontal apoptome&lt;br&gt;\r\nMaybe some 4th instar larvae have a reticule head surface\r\n&lt;hr&gt;\r\nSubgenera ({citeID|298|Moller-Pillot et.al. 2000})\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|{citeID|299|Heyn 1992}\r\n!|{citeID|2|Pinder and Reiss 1983}\r\n!|{citeID|34|Moller-Pillot 1984a}\r\n\r\n|-\r\n|Glyptotendipes (Glyptotendipes)\r\n|Glyptotendipes gr. A\r\n|Glyptotendipes gr. pallens\r\n|-\r\n|Glyptotendipes (Caulochironomus)\r\n|Glyptotendipes gr. B\r\n|Glyptotendipes gr. caulicola\r\n|-\r\n|Glyptotendipes (Trichotendipes)\r\n|Glyptotendipes gr. C\r\n|Glyptotendipes gr. signatus\r\n\r\n|}\r\n\r\n==Checklist==\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|species\r\n!|subgenus\r\n!im|China (Wang 2000)\r\n!im|Western Europe (Moller-Pillot et.al. 2000)\r\n!im|notes\r\n\r\n|-\r\n|G. aequalis Kieffer\r\n|Caulochironomus\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. barbipes (Staeger)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes barbipes (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Glyp_babi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Glyptotendipes\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. caulicola (Kieffer)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes caulicola (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Glyp_caul_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Caulochironomus\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. foliicola Kieffer sensu {citeID|301|Kalugina 1979}\r\n|Caulochironomus\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. gripekonveni Kieffer&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes gripekonveni (mentum) Kalugina 1975'' src=''image.php?text=image deleted: GlypGl_grpe_men_Kal1975_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Glyptotendipes\r\n|*\r\n|*\r\n|\r\n\r\n|-\r\n|G. imbecilis (Walker)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes imbecilis (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Glyp_seve-_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Caulochironomus\r\n|*\r\n|*\r\n|\r\n\r\n|-\r\n|G. mancunianus (Edwards)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes mancunianus (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Glyp_macu_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Caulochironomus\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. lobiferus ({citeID|332|Say 1823})&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes lobiferus (mentum) Yan and Ye 1977'' src=''image.php?text=image deleted: Glyp_lofe_men_YaY1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Phytotendipes?\r\n|*\r\n|\r\n|\r\n\r\n|-\r\n|G. ospeli Contreras-Lichtenberg&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes ospeli (mentum) Contreras-Lichtenberg and Kiknadze 2000'' src=''image.php?text=image deleted: Glyp_ospe_men_CLK2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Glyptotendipes\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. pallens (Meigen) (syn glaucus (Meigen, 1818))&lt;br&gt;&lt;img align=''middle'' width=200 title=''Glyptotendipes pallens (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Glyp_paen_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Glyptotendipes\r\n|*\r\n|*\r\n|{citeID|12|Klink and Moller-Pillot 2003}: G. pallens can be separated from the other species (except G. glaucus) of subgenus Glyptotendipes by: The broad V-shaped dark band on the head with a length  1000&micro;m, very short tubules on the 11th segment or absent and ventromental plates at least 1.5x the width of the median tooth apart. G. pallens can be separated from the other species of subgenus Glyptotendipes (except {overlib|Glyptotendipes glaucus|&lt;img align=''middle'' width=200 title=''Glyptotendipes glaucus (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Glyp_glauc_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}) by: The {overlib|median mental tooth as high as the 1st lateral and about as wide|&lt;img align=''middle'' width=200 title=''Glyptotendipes pallens (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Glyp_paen_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}. The {overlib|antennal blade reaching only to the middle of the 3rd segment|&lt;img align=''middle'' width=60 title=''Glyptotendipes pallens (antenna) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Glyp_paen_ant_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}.\r\n\r\n\r\n|-\r\n|G. paripes (Edwards)\r\n|Glyptotendipes\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. signatus (Kieffer 1909) (? syn. varipes (Goetghebuer, 1927) {citeID|298|Moller-Pillot et.al. 2000})\r\n|Trichotendipes\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. sp. Belarus\r\n|Caulochironomus\r\n|\r\n|*\r\n|\r\n\r\n|-\r\n|G. viridis ({citeID|402|Macquart 1834})&lt;br&gt;&lt;img align=''middle'' width=150 title=''Glyptotendipes viridis (head ventral) Pankratova 1983'' src=''image.php?text=image deleted: GlypCa_vidi_hve_Pan1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|Caulochironomus\r\n|*\r\n|*\r\n|{citeID|298|Moller-Pillot et.al. 1997}: G. viridis can be separated from the other species of subgenus Caulochironomus (except G. mancunianus) by the mentum with single median tooth and 6 pairs of lateral teeth with the 4th lateral reduced. G. viridis can be separated from G. mancunianus by the {overlib|seta subdentalis|&lt;img align=''middle'' width=100 title=''Glyptotendipes viridis (mandible) Kalugina 1975'' src=''image.php?text=image deleted: GlypCa_vidi_man_Kal1975_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} longer than the width of the inner mandibular tooth. Also the frontal apotome is 2.5 x longer than wide (1.8 x in G. mancunianus) and the ventromental plates are 5 x wider than high (6.5 x in G. mancunianus).\r\n\r\n|}\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Glyptotendipes as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Glyptotendipes (G.) paripes (Edwards 1929) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n|-\r\n|Glyptotendipes (G.) paripes (Edwards 1929) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n===Temperature===\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Glyptotendipes  and other taxa to find possible differences in temperature: 2000: 12&deg;C &plusmn; 5.6 (6.4 to 17.7), 2006: 12.2&deg;C &plusmn; 6.5 (5.7 to 18.7) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n===Oxygen===\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Glyptotendipes (n=16, Template:explained:N2:HillsDiversity=9.28, n&lt;sub&gt;max&lt;/sub&gt;=8) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 20.\r\n\r\n===Conductivity===\r\n\r\n{citeID|502|Zhang et al. 2007} report for Glyptotendipes in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 1114.66mg &middot; l⁻&sup1; (&divide; 600 = 1.86mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 5.34744. In article shortened as: Gl.\r\n', '20 43 107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(24, 56, NULL, 'Gymnometriocnemus larvae are difficult to separate from those of Bryophaenocladius, differing only in the weakly divided posterior parapods of Gymnometriocnemus; those of Bryophaenocladius are undivided ({citeID|6|Epler 2001}).&lt;br&gt;\r\n\r\nIn China not mentioned ({citeID|279|Wang 2000}).', 1, NULL, '61 79 64 15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(25, 58, NULL, '{| frame=border \r\n|-\r\n!|reference\r\n!im|premandible\r\n!im|posterior parapods\r\n!im|labrum - seta S1\r\n!im|postoccipital plate\r\n!im|postoccipital  margin\r\n!im|antennal pededestals\r\n!im|mandible\r\n!im|ventromental plates.\r\n!im|mentum - median tooth\r\n\r\n\r\n|-\r\n|&lt;!-- ref --&gt;{citeID|2|Pinder and Reiss 1983}:\r\n|&lt;!-- cpp --&gt;1-2<br>brush indistinct to strong<hr&gt;3-5 in ''''''H.s.str.''''''\r\n|&lt;!-- cpp --&gt;\r\n|&lt;!-- seta1 --&gt;\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- pom --&gt;\r\n|&lt;!-- anp --&gt;\r\n|&lt;!-- man --&gt;3-1-0-0<br>apical tooth  shorter than than combined width of inner 3 teeth\r\n|&lt;!-- vep --&gt;beared\r\n|&lt;!-- men --&gt;\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n| colspan=9|The combination of the absence of anal tubules , presence of beard associated with the ventromental plate, and absent or indistinct Lauterborn organs is distinctive.\r\n\r\n\r\n|}<br>', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(26, 61, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*H.curtistila S&aelig;ther 1969 male\r\n*H.ornaticollis (Edwards)\r\n*H.osarumaculata Sasa male female\r\n*H.sp male', 1, NULL, '56 15 79 64 113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(27, 64, NULL, '==Characters==\r\n\r\n{citeID|21|Cranston et.al. 1983}:&lt;br&gt;\r\n\r\nThe genus is closely related to Paratrissocladius and the larvae have similar antennae. However, Paratrissocladius differs in \r\n*mentum, \r\n*S1, \r\n*pecten epiphyryngis, \r\n*premandible, etc. \r\n...see comments from {citeID|21|Cranston et.al. 1983} at Paratrissocladius.&lt;br&gt;\r\n\r\n==Checklist China==\r\n\r\nIn China {citeID|279|Wang 2000}:&lt;br&gt;\r\n*H.marcidus (Walker)\r\n*H.sp - male, female', 1, '==Biotops==\r\n\r\n===Littoral===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Heterotrissocladius hirtapex S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius latilaminus S&aelig;th.&lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius maeaeri Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius marcidus (Walk.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius oliveri S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius subpilosus (Kieff.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Profundal===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Heterotrissocladius changi S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius grimshawi Edw &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || ||&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius maeaeri Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius oliveri S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius scutellatus Goetgh. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius sp. A near subpilosus &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius sp. B near maeaeri &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius sp. D near changi &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius subpilosus (Kieff.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\nHeterotrissocladius, Protanypus, and Sergentia are common in the cold profundal of stratified lakes from temperate forest regions as well as arctic sites ({citeID|303|Walker 1991})\r\n\r\n{textciteID|526|Hofmann 2001} reports as cold-stenothermal taxa Heterotrissocladius sp., Paracladius sp., Orthocladius consobrinus, and Corynocera oliveri.\r\n\r\nHeterotrissocladius sp. reported by {textciteID|516|Korhola et al. 2002} as cold adapted taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|492|Brodersen et al. 2004}: Cold-water assemblages were dominated by oxyconformers such as Heterotrissocladius, Micropsectra, Hydrobaenus, and Diamesa.\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Heterotrissocladius  and other taxa to find possible differences in temperature: 2000: 9.9&deg;C &plusmn; 4.5 (5.4 to 14.5), 2006: 9.5&deg;C &plusmn; 4.7 (4.8 to 14.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Heterotrissocladius sp.  and other taxa: 12.8m &plusmn; 6.6 (n=15). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Heterotrissocladius the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '123 61 79 15 19 202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(28, 65, NULL, '{| frame=border \r\n\r\n|-\r\n!|Reference\r\n!| Pr.Md. \r\n!|post.parap. \r\n!|seta S1\r\n!|poo.plate\r\n!|poo.margin\r\n!|ant.ped.\r\n!|mand.\r\n!|ventrom.plates.\r\n!|median tooth (mentum)\r\n\r\n\r\n|-\r\n|&lt;!-- ref --&gt;{citeID|2|Pinder and Reiss 1983}:\r\n|&lt;!-- cpp --&gt;2<br>+/- pronounced inner accessory tooth; no brush\r\n|well developed<br>7 apical setae\r\n|&lt;!-- seta1 --&gt;coarsely, finely plumose<br>3-10 lobes\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- pom --&gt;\r\n|&lt;!-- anp --&gt;\r\n|&lt;!-- man --&gt;3-1-0-0<br>apical tooth much shorter than combined width of 3 inner teeth\r\n|&lt;!-- vep --&gt;well developed; no beared\r\n|&lt;!-- men --&gt;2 and 6 lateral\r\n\r\n\r\n|}<br>', 1, '==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Hydrobaenus  and other taxa: 11.4&deg;C &plusmn; 1.5, n=10 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|520|Porinchu and Cwynar 2002} reports cold-water chironomid taxa, such as Paracladius, Hydrobaenus/Oliveridia, Abiskomyia, and Parakiefferiella nigra from a tundra site near the lower Lena River, Northeast Siberia.\r\n\r\n{citeID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C.\r\n\r\n{citeID|492|Brodersen et al. 2004}: Cold-water assemblages were dominated by oxyconformers such as Heterotrissocladius, Micropsectra, Hydrobaenus, and Diamesa.\r\n\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type, Micropsectra insignilobus type, Protanypus, Tanytarsus lugens type, Hydrobaenus [most abundant in 13&deg;C to 15&deg;C, but only a few head capsules], Heterotrissocladius grimshawi type, Corynocera ambigua and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n', '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(29, 70, NULL, '{citeID|2|Pinder and Reiss 1983}: Larvae  of Krenopsectra  closely  resemble those of Micropsectra from which they can be separated (except from Micropsectra dives) by \r\n*the presence of a pronounced, orally directed dorsal projection on segment 11. \r\nA similar projection also occurs in the larva of Micropsectra roseiventris (Kieffer), but this is less pronounced and rounded rather than orally directed. Details of abdominal momhology are not known for either Parapsectra or the attenuata group of Micropsectra (...) which may therefore also have a similar projection.\r\n', 1, NULL, '119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(30, 79, NULL, '==Characters genus==\r\n\r\n{citeID|21|Cranston et.al. 1983}: The closely related Paralimnophyes is separable by\r\n*the presence of 4 long thin setae on each body segment and\r\n*the posession of 4 inner mandibular teeth.\r\nThe weakly serrate S1 seta may separate Limnophyes from Thienemannia which has a mor plumose S1.\r\n\r\n==Key==\r\n\r\nKey from {citeID|274|Dettinger-Klemm 2003}:\r\n#~\r\n##The setal marks of the antenna are somewhat distal to the ring organ and at about the same level. The basal segment of the antenna is longer than in Limnophyes minimus senso stricto (lenghts in&micro;m: instar I: 4-5; instar II: 9-14; instar III: 13-20; instar IV: 28-38; 33). A dark spot is present behind the base of the antenna (not or only badly visible in macerated specimens). Anal tubules of the instar IV are relatively short (70-89&micro;m) and show no incisions pretending segmentation. Anal setae long (lengths in&micro;m: instar I: &plusmn;50; instar II: &plusmn;140; instar III: &plusmn;203; instar IV: 243-370). S I with five branches, median branch about twice as long as first lateral branch ... Limnophyes asquamatus\r\n##The setal marks of the antenna are not at the same level on the flagellomere 1...2\r\n#~\r\n##The distal setal mark of the antenna is close to the apical margin of flagellomere 1 and far from  the basal mark (Figure 13 in {citeID|329|S&aelig;ther 1990}); flagellomere 1 is about 45&micro;m long. median chetulae laterales serrated ... Limnophyes edwardsi\r\n##The basal setal mark of flagellomere 1 is at approximately the same level as the ring organ and the distal mark is somewhat above the ring organ; flagellomere 1 shorter (until 35&micro;m) ... 3\r\n#~\r\n##Postmentum &lt; 125&micro;m ... 4\r\n##Postmentum &gt; 125&micro;m ... 5\r\n#~\r\n##Length/width-ratio of flagellomere 1 of the instar IV (head capsule length 200&micro;m) &lt; 2.5 (2.05- 2.24), flagellomere 1 relatively short (lengths in&micro;m: instar I: 3-4; instar II: 7 -8; instar III:12-14; instar IV: 25-26); no dark spot behind the antennal base. Anal tubules of the instar IV long (&plusmn;95&micro;m), often with one or two incisions pretending segmentation; anal setae relatively short (lengths in&micro;m: instar I: &plusmn;45; instar II: &plusmn;80; instar III: &plusmn;90; instar IV: &plusmn;190). SI with seven branches, the median branch not twice as long as the first lateral branch. Two outer chaetulae laterales smooth, the two following (median) are fringed by fine setae (which may be  broken off giving a serrated appearance). Size characteristics of the instar IV (in&micro;m): head capsule length &plusmn;239, length of postmentum &plusmn;117, width of mentum &plusmn;66, length of mandible &plusmn;80... L. minimus-complex\r\n##Median chaetulae laterales serrated (but see comment in 5, Limnophyes minimus-complex), mandible strongly bent apically (Figure 32C in {citeID|329|S&aelig;ther 1990})  ...  ''Limnophyes natalensis'' sensu {citeID|329|S&aelig;ther 1990}\r\n#~\r\n##(only instar IV): length/width-ratio of flagellomere 1 &lt; 2.5 (2.06-2.11), length of flagellomere 1 &plusmn;35&micro;m; no dark spot present behind the antennal base; anal tubules &plusmn;120&micro;m long, at least at its base with an incision; anal setae until 250&micro;m; SI with seven branches, the median branch somewhat longer as the first lateral branch; median chetulae laterales with fringe of fine setae;  head capsule length 280-290&micro;m, Postmentum &plusmn;155&micro;m, width of mentum &plusmn;85&micro;m and length of mandible &plusmn;110&micro;m ... Limnophyes natalensis senso stricto\r\n##L. carolinensis and L. pentaplastus (&lsquo;median chetulae laterales apparently smooth&rsquo;) are not clearly separable from L. natalensis senso stricto following the data provided by {citeID|329|S&aelig;ther 1990}.\r\n\r\n==Specimens==\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|specimen\r\n!im90|mentum - submental setation\r\n!im90|antenna\r\n\r\n|-\r\n|{citeID|274|Dettinger-Klemm 2003}\r\n|L.asquamatus\r\n|3.5 +- 0.5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Limnophyes asquamatus (mentum) Dettinger-Klemm 2003'' src=''image.php?text=image deleted: Limn_asqu_men_DeK2003_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;img align=''middle'' width=60 title=''Limnophyes asquamatus (antenna) Dettinger-Klemm 2003'' src=''image.php?text=image deleted: Limn_asqu_ant_DeK2003_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|L.gurgicola\r\n|1.75 +- 0.25&lt;br&gt;&lt;img align=''middle'' width=200 title=''Limnophyes gurgicola (mentum) Schmid 1993'' src=''image.php?text=image deleted: Limn_gurg_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;img align=''middle'' width=60 title=''Limnophyes gurgicola (antenna) Schmid 1993'' src=''image.php?text=image deleted: Limn_gurg_ant_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n\r\n|-\r\n|{citeID|43|Ye 1984}\r\n|L.transcaucasicus\r\n|1.75 +- 0.25&lt;br&gt;\r\n|&lt;img align=''middle'' width=60 title=''Limnophyes transcaucasicus (antenna) Ye 1984'' src=''image.php?text=image deleted: Limn_trca_ant_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n\r\n|}\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*L.asquamatus Andersen male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Limnophyes asquamatus (mentum) Dettinger-Klemm 2003'' src=''image.php?text=image deleted: Limn_asqu_men_DeK2003_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*L.bullus {citeID|443|Wang and S&aelig;ther 1993} male female\r\n*L.brachytomus (Kieffer)\r\n*L.difficilis Brundin male\r\n*L.fuscipygmus Tokunaga male\r\n*L.gurgicola (Edwards) male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Limnophyes gurgicola (mentum) Schmid 1993'' src=''image.php?text=image deleted: Limn_gurg_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*L.habilis (Walker)\r\n*L.minimus (Meigen) male female\r\n*L.opimus {citeID|443|Wang and S&aelig;ther 1993} male\r\n*L.orbicristatus {citeID|443|Wang and S&aelig;ther 1993} male\r\n*L.palleocestus {citeID|443|Wang and S&aelig;ther 1993} male female\r\n*L.pentaplastus (Kieffer)\r\n*L.pumilio (Holmgren)\r\n*L.triangularis Wang male\r\n*L.verpus {citeID|443|Wang and S&aelig;ther 1993} male female\r\n*L.sp. male female\r\n\r\n', 1, '==Biotops==\r\n\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Limnophyes as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n{citeID|541|Kurek and Cwynar 2009}: &laquo;For example, Pseudosmittia/Smittia and Limnophyes/Paralimnophyes are known as semi-terrestrial or littoral taxa ({citeID|302|Brooks et al. 2007}).&raquo;\r\n\r\n===Temperature===\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*8 have statistically significant (sigmoidal Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n\r\n===Salinity===\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Limnophyes sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '56 15 113 115 143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(31, 86, NULL, '==Characters==\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|references\r\n!im|specimen\r\n!im90|antenna\r\n!im90|seta s1\r\n!im90|premandible\r\n!im90|mandible\r\n!im90|mandible - seta interna\r\n!im90|mentum - teeth (inner+lateral)\r\n!im90|procerus\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}\r\n|Metriocnemus sp.\r\n|5 seg.; quite variable structure &lt;!-- antenna --&gt;\r\n| plumose or simple &lt;!-- s1 --&gt;\r\n| 2-4 apical + (in)distict brush&lt;!-- premandible --&gt;\r\n| 4/5-1-0-0&lt;br&gt; apical shorter than combined inner teeth&lt;!-- mandible --&gt;\r\n| 6-7 broad or narrow&lt;!-- mandible seta interna --&gt;\r\n| 2-4+5-6 no breard, v.plates very weak\r\n| well develloped or small (M.terrester Pagast)&lt;!-- procerus --&gt;\r\n\r\n|}\r\n\r\n\r\nComments by {citeID|21|Cranston et.al. 1983}: The range of variation in the character in Metriocnemus is hight. Some larvae may be difficult to seperate from those of Chaetocladius and Thienemannia. \r\n*The shape and placement of the labral lamellae, however, seperate larvae of Metriocnemus from those of Chaetocladius. \r\n*The sclerotizized and usually well developed procerus with short anal setae and the short supraanal seta separate Metriocnemus from Thienemannia.&lt;br&gt;\r\n\r\n==Checklist==\r\n\r\nin China {citeID|279|Wang 2000}:&lt;br&gt;\r\n*M.aculeatus Chaudhuri and Bhattacharay \r\n*M.brusti {citeID|405|S&aelig;ther 1989} {overlib|mentum|&lt;img align=''middle'' width=200 title=''Metriocnemus brusti (mentum) S&aelig;ther 1989'' src=''../../imglarvae/Metr_brus_men_Sae1989_r.gif'' &gt;}\r\n*M.calvescens S&aelig;ther\r\n*M.dentipalpus S&aelig;ther\r\n*M.eurynotus (Holmgren, 1833) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Metriocnemus eurynotus (mentum) Epler 2001'' src=''image.php?text=image deleted: Metr_euno_men_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*M.fuscipes (Meigen, 1818) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Metriocnemus fuscipes (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Metr_fusc_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Metriocnemus fuscipes (mentum) Schmid 1993'' src=''image.php?text=image deleted: Metr_fusc_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*M.gracei Edwards\r\n*M.picipes (Meigen)\r\n*M.unilinearis Chiauhuri and Bhattacharay\r\n*M.wangi S&aelig;ther\r\n', 1, ';Metriocnemus cavicola: {citeID|430|Schmidl et.al. 2008}: Larvae of the orthocladiine chironomid, Metriocnemus cavicola, favours shallow more open tree-holes with higher litter content but with sufficient open water to ensure an adequate oxygen supply.\r\n', '177 19 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(32, 88, NULL, '==Characters general==\r\n\r\n\r\n{| style=''border:1px solid;''\r\n&lt;caption&gt;Some general characteristics&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|Reference\r\n!im|premandible\r\n!im|parapods posterior\r\n!im|antenna spur\r\n!im|antenna pedestals\r\n!im|postoccipital plate\r\n!im|mandible\r\n!im|ventromental plates\r\n!im|mentum median\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}:&lt;!-- ref --&gt;\r\n|2 &lt;!-- pre --&gt;\r\n|very numerous claws, many are small of them, like a horse-shoe, irregular rows&lt;!-- pap post --&gt;\r\n|10&micro;m-40&micro;m (usually)&lt;!-- ant spur --&gt;\r\n|++&lt;!-- ant ped --&gt;\r\n|&lt;!-- pop --&gt;\r\n|3-1-1-0&lt;!-- man --&gt;\r\n|very close medially, about 1.2x width of mentum&lt;!-- vep --&gt;\r\n|notched or at laest crenate laterally&lt;!-- men-median --&gt;\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}:\r\n|2 &lt;!-- pre --&gt;\r\n|&lt;!-- par post --&gt;\r\n|short/sharp or &lt;br&gt; long medium-sized/sharp or &lt;br&gt;long straight/blunt&lt;!-- ant spur --&gt;\r\n|. to ++&lt;!-- ant ped --&gt;\r\n|. to +&lt;!-- pop --&gt;\r\n|3-1-1-0&lt;!-- man --&gt;\r\n|also rounded&lt;!-- vep --&gt;\r\n|&lt;!-- men median --&gt;\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n\r\n==Characters Heiri et.al. 2004==\r\n\r\n\r\n&lt;div style=''float:left;''&gt;\r\n{| style=''border:1px solid;float:left;margin-right:10px;''\r\n&lt;caption&gt;Characters of species types after {citeID|1|Heiri et.al. 2004}&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|type/group\r\n!im|antennal pedestal\r\n!im|antennal spur\r\n!im|postoccipital plate\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|''''''radialis type''''''\r\n|.&nbsp;short\r\n|.&nbsp;short sharp\r\n|reduced\r\n\r\n|-\r\n|''''''aristata type''''''\r\n|++&nbsp;long\r\n|++&nbsp;long, blunt\r\n|well developed&lt;BR&gt;&lt;span class=''pale''&gt;very pale&lt;/span&gt;\r\n\r\n|-\r\n|''''''bidentata type''''''\r\n|++&nbsp;long\r\n|+&nbsp;medium\r\n|well developed&lt;BR&gt;&lt;span class=''pale''&gt;very pale&lt;/span&gt;\r\n\r\n|-\r\n|''''''''insignilobus'' type''''''&lt;br&gt;- M. atrofasciata&lt;br&gt;- M. contracta&lt;br&gt;- M. groenlandica&lt;br&gt;- M. junci&lt;br&gt;- M. pharetrophora\r\n|++/+&nbsp;long to medium\r\n|.&nbsp;short sharp\r\n|reduced to&lt;BR&gt; well developed&lt;br&gt;{dark} to&nbsp;{pale}\r\n\r\n|-\r\n|''''''seguyi type''''''\r\n|++&nbsp;long\r\n| -&nbsp;no\r\n|well developed&lt;BR&gt;{pale}\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n{citeID|1|Heiri et.al. 2004}: Generic diagnosis for Micropsectra is given in {citeID|2|Pinder and Reiss 1983}. In fossil fourth-instar larvae the combination of a short sharp, long medium-sized sharp or long straight and blunt spur, bifid premandibles and a reduced to medium sized postoccipital plate will often separate Micropsectra from other Tanytarsini. M. seguyi does not feature a spur. However, in contrast to Paratanytarsus, M. seguyi features long antennal pedestals and a well developed postoccipital plate. Valid species of West Palaearctic Micropsectra not examined for this study (following {citeID|256|Ashe and Cranston 1991}): M. apposita, M. attenuata, M. auvergnensis, M. bodanica, M. borealis, M. clastrieri, M. fusca, M. insignilobus, M. lacustris, M. lindebergi, M. lindrothi, M. notescens, M. recurvata, M. roseiventris, M. subnitens.\r\n&lt;/div&gt;\r\n\r\n&lt;div style=''clear:both;''&gt;&lt;/div&gt;&lt;br&gt;\r\n\r\n==Specimens==\r\n\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n&lt;caption&gt;All specimens with filterable characters for multy-access determination mainly from Palaearctis.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default ''|Species\r\n!im class=''table-sortable:default ''|Reference\r\n!im class=''table-sortable:default ''|Species type\r\n!im class=''table-sortable:default ''|Head color\r\n!im class=''table-sortable:default ''|Postoccipital margin\r\n!im class=''table-sortable:default ''|Postoccipital plate\r\n!im90 class=''table-sortable:default ''|Antennal ratio\r\n!im90 class=''table-sortable:default ''|Antennal pedestal/ratio (L2W)\r\n!im90 class=''table-sortable:default ''|Antennal spur\r\n!im90 class=''table-sortable:default ''|Mentum\r\n!im90 class=''table-sortable:default ''|Mandible\r\n!im90 class=''table-sortable:default ''|Clypeal Seta S3\r\n\r\n|-\r\n!|&lt;input name=''filterspecies0'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterreference1'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n! class=''table-filterable''|\r\n!|&lt;input name=''filterhead3'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterpostoccipital4'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterpostoccipital5'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAR6'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterantennal7'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterantennal8'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filtermentum9'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filtermandible10'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterclypeal11'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Micropsectra radialis Goetghebuer (tentatively associated material)&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_radi_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_radi_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|radialis&lt;!-- type --&gt;\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt;-&lt;span class=''brownish''&gt;brownish&lt;/span&gt;\r\n|''''dark''''\r\n|.&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_radi_pom_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_radi_pom_Hei2004_r.jpg 2009-12-15 10:36:17''>&lt;br&gt;reduced to a thin pale band following the postoccipital margin\r\n|&lt;!--antennal ratio--&gt;\r\n|1.0? &lt;span title=''short''&gt;.&lt;/span&gt;\r\n|1.4&lt;br&gt;. short and sharp&lt;!-- spur --&gt;\r\n|&lt;span title=''mentum teeth brown'' class=''brown''&gt;brown&lt;/span&gt;\r\n|&lt;span title=''three inner teeth, one apical and one outer tooth, all teeth brown'' &gt;3-1-1-0&lt;/span&gt;&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_radi_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_radi_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|&lt;span title=''Seta S3'' &gt;simple&lt;/span&gt;\r\n\r\n|-\r\n|Micropsectra aristata Pinder&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_aris_men_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_aris_men_Hei2004_r.gif 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|aristata&lt;!-- type --&gt;\r\n|{pale}\r\n|&lt;span class=''brownish''&gt;brownish&lt;/span&gt;\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_aris_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_aris_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>&lt;br&gt;triangular with a rounded anterior margin, &lt;span class=''pale''&gt;very pale&lt;/span&gt;\r\n|&lt;!--antennal ratio--&gt;\r\n|2(1.2) top(bottom &Oslash;) &lt;!--antennal pedestal--&gt;&lt;span title=''long''&gt;++&lt;/span&gt;\r\n|2.4&lt;br&gt;++ long, straight and apically rounded\r\n|lateral teeth {dark brown} pigmentation of median tooth not clearly discernible\r\n|&lt;span title=''three inner teeth, one apical tooth and one outer tooth''&gt;3-1-1-0&lt;/span&gt;&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_aris_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_aris_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|branched\r\n\r\n|-\r\n|Micropsectra aristata Pinder&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_aris_men_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_aris_men_Hei2004_r.gif 2009-12-15 10:36:17''>\r\n|{citeID|280|Stur and Ekrem 2006}\r\n|aristata&lt;!-- type --&gt;\r\n|{pale}\r\n|&lt;!--postoccipital plate--&gt;broad\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_aris_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_aris_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>&lt;br&gt;triangular with a rounded anterior margin, &lt;span class=''pale''&gt;very pale&lt;/span&gt;\r\n|&lt;!--antennal ratio--&gt;2.44&ndash;2.54 (n=2)\r\n| &lt;!--antennal pedestal--&gt;&lt;span title=''long''&gt;++&lt;/span&gt;\r\n|++ 36&micro;m long digitiform spur\r\n|median tooth somewhat {pale}\r\n|&lt;span title=''three inner teeth, one apical tooth and one outer tooth''&gt;3-1-1-0&lt;/span&gt;\r\n|branched + middle branch very long\r\n\r\n|-\r\n|Micropsectra bidentata (Goetghebuer)&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_bide_men_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_bide_men_Hei2004_r.gif 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|bidentata&lt;!-- type --&gt;\r\n|very {pale}\r\n|pigmented\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_bide_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_bide_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>'' &gt;&lt;br&gt;{pale}  triangular with anterior margin rounded\r\n|?&lt;!--antennal ratio--&gt;\r\n|0.85&lt;!--antennal pedestal--&gt;&lt;span title=''short-medium length''&gt;.+&lt;/span&gt;\r\n|2.3&lt;br&gt;++ long, straight and sharp spur\r\n|&lt;span class=''brownis''&gt;brownish&lt;/span&gt;\r\n|not available\r\n|three long branches\r\n\r\n|-\r\n|Micropsectra atrofasciata (Kieffer)&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_atro_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_atro_men_WCh1983_r.gif 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|insignilobus&lt;!-- type --&gt;\r\n|{pale}\r\n|somewhat darker\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_atro_pom_StE2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_atro_pom_StE2006_r.gif 2009-12-15 10:36:17''>\r\n|2.17 {citeID|280|Stur and Ekrem 2006}&lt;!--antennal ratio--&gt;\r\n|1.2&lt;!--antennal pedestal--&gt;&lt;span title=''long''&gt;++&lt;/span&gt;\r\n|1.6-1.7&lt;br&gt;. short and sharp &lt;!-- spur --&gt;\r\n|teeth pigmented\r\n|&lt;span title=''three inner teeth, one apical tooth and one outer tooth''&gt;3-1-1-0&lt;/span&gt;&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_atro_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_atro_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|simple\r\n\r\n|-\r\n|Micropsectra contracta Reiss&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_cont_men_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_cont_men_Hei2004_r.gif 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|insignilobus&lt;!-- type --&gt;\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|''''dark''''\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_cont_pop1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_cont_pop1_Hei2004_r.jpg 2009-12-15 10:36:17''>&lt;br&gt;triangular with rounded anterior margin, ''''dark'''' except for pale posterior fringe\r\n|&lt;!--antennal ratio--&gt;\r\n|1 &lt;span title=''long''&gt;++&lt;/span&gt;\r\n|1&lt;br&gt;. short and sharp &lt;!-- spur --&gt; \r\n|median tooth with only lateral margin ''''dark''''\r\n|&lt;span title=''three inner teeth, one apical tooth and one outer tooth (outer tooth slightly paler than apical and inner teeth)''&gt;3-1-1-0&lt;/span&gt;\r\n|simple\r\n\r\n|-\r\n|Micropsectra groenlandica {citeID|470|Andersen 1937}&lt;br&gt;see also synonymus M.logani regarded in {citeID|280|Stur and Ekrem 2006}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_groe_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_groe_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|insignilobus&lt;!-- type --&gt;\r\n|&lt;span class=''pale''&gt;rather pale&lt;/span&gt;\r\n|pigmented\r\n|.&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_groe_pop_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_groe_pop_Hei2004_r.gif 2009-12-15 10:36:17''>&lt;br&gt;reduced, forming a broad triangle with both anterior and posterior margins rounded, &lt;span class=''brown''&gt;brown&lt;/span&gt; with a {pale} posterior band\r\n|1.77&lt;!--antennal ratio--&gt;\r\n|1.0 &lt;br&gt;++ long\r\n|1.0 &lt;br&gt;. short and sharp &lt;!-- spur --&gt;\r\n|median tooth with only lateral margin ''''dark''''\r\n|&lt;span title=''three inner teeth, one apical tooth, one outer tooth, all teeth pigmented''&gt;3-1-1-0&lt;/span&gt;\r\n|simple\r\n\r\n|-\r\n|Micropsectra junci (Meigen)&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_junc_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_junc_men_Ye1984_r.gif 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|insignilobus&lt;!-- type --&gt;\r\n|{pale} &lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|''''dark''''\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_junc_pop2_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_junc_pop2_Hei2004_r.jpg 2009-12-15 10:36:17''>&lt;br&gt;triangular with a rounded anterior margin, only anterior part slightly pigmented, posterior part pale and difficult to see\r\n|2.3 {citeID|43|Ye 1984}&lt;!--antennal ratio--&gt;\r\n|1.2 &lt;span title=''long''&gt;++&lt;/span&gt;\r\n|1.2&lt;br&gt;. short and sharp &lt;!-- spur --&gt;\r\n|median tooth ''''dark'''' laterally, {pale} mesially, second lateral teeth large, as long as first laterals\r\n|&lt;span title=''three inner teeth, one apical tooth, one outer tooth, mandible with distinct hump''&gt;3-1-1-0 1&nbsp;hump&lt;/span&gt;&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_junc_man_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_junc_man_Ye1984_r.gif 2009-12-15 10:36:17''>\r\n|simple\r\n\r\n|-\r\n|Micropsectra pharetrophora Fittkau &amp; Reiss&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_phar_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_phar_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|insignilobus&lt;!-- type --&gt;\r\n|{pale} &lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|pigmented\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_phar_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_phar_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>&lt;br&gt;triangular to trapezoidal, both anterior and posterior margins rounded, pigmented anteriorly, with a {pale} posterior band\r\n|?&lt;!--antennal ratio--&gt;\r\n|1.0 &lt;span title=''medium to large (difficult to see on the examined specimen)''&gt;+/++&lt;/span&gt;\r\n|1.0&lt;br&gt;. short and sharp&lt;!--  spur --&gt;\r\n|median tooth entirely ''''dark'''', second lateral teeth large, as long as first laterals\r\n|&lt;span title=''three inner teeth, one apical tooth, one outer tooth, mandible with distinct hump''&gt;3-1-1-0 1&nbsp;hump&lt;/span&gt;&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_phar_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_phar_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n| ?\r\n\r\n|-\r\n|Micropsectra seguyi Casas &amp; Laville&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_segu_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_segu_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|{citeID|1|Heiri et.al. 2004}\r\n|seguyi&lt;!-- type --&gt;\r\n|{pale}\r\n|&lt;span class=''pale''&gt;''''pale brown''''&lt;/span&gt;\r\n|++&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_segu_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_segu_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>&lt;br&gt;triangular with rounded anterior point, light brown anteriorly, otherwise pale\r\n|?&lt;!--antennal ratio--&gt;\r\n|1.2 &lt;span title=''long''&gt;++&lt;/span&gt;\r\n|no&lt;!-- spur --&gt;\r\n|median tooth entirely ''''dark'''' second lateral teeth large, as long as first lateral teeth, outermost lateral teeth leaning outwards (at least in the examined specimen)\r\n|&lt;span title=''three inner teeth (most posterior one paler than the other two and slightly reduced), one apical tooth and one dark outer tooth''&gt;3-1-''''1''''-0&lt;/span&gt;&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_segu_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_segu_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|simple\r\n\r\n|-\r\n|Micropsectra logani ({citeID|471|Johannsen 1928})&lt;br&gt;see also synonymus M.groenlandica regarded in {citeID|280|Stur and Ekrem 2006}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_loga_men_StE2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_loga_men_StE2006_r.gif 2009-12-15 10:36:17''>\r\n|{citeID|280|Stur and Ekrem 2006}\r\n|insignilobus&lt;!-- type --&gt;\r\n|{dark brown}&lt;!-- head color --&gt;\r\n|darker?&lt;!-- pom --&gt;\r\n|+&lt;br&gt;triangular with rounded anterior margin&lt;!-- postoccipital plate --&gt;\r\n|2.0&lt;!--antennal ratio--&gt;\r\n|1.0 &lt;!-- antennal pedestal/ratio l2w --&gt;\r\n|1.0&lt;br&gt;. &lt;!-- antennal spur --&gt;\r\n|&lt;!-- mentum --&gt;\r\n|&lt;span title=''three inner teeth one apical tooth and one outer tooth''&gt;3-1-1-0&lt;/span&gt;&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Mips_loga_man_StE2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_loga_man_StE2006_r.gif 2009-12-15 10:36:17''>&lt;!-- mandible --&gt;\r\n|simple&lt;!-- clypeal Seta S3 --&gt;\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n\r\n==Key West Palaearctic larvae==\r\n\r\n\r\nKey to known West Palaearctic Micropsectra larvae from {citeID|280|Stur and Ekrem 2006}:&lt;br&gt;\r\n\r\nThe larval key should be used with caution, since the larval stages of many species are unknown, and others are known from a few associated individuals only. The key adopts several of the couplets given by {citeID|281|Klink 1982}, and descriptions by {citeID|12|Klink and Moller-Pillot 2003}, but several species and diagnostic characters have been added. See also the comment on M. roseiventris above the pupal key. Larvae of the following species are unknown and therefore not included in the key: Micropsectra andalusiaca, M. appendica, M. attenuata, M. auvergensis Reiss, 1969, M. bodanica Reiss, 1969, M. borealis, M. calcifontis, M. clastrieri Reiss, 1969, M. contracta, M. freyi, M. insignilobus, M. lacustris S&auml;wedal, 1975, M. lindebergi S&auml;wedal, 1976, M. longicrista, M. rilensis Giłka, 2001, M. robusta, M. sofiae and M. zernyi.\r\n\r\n#~\r\n## Posterior parapods carry 70&ndash;100 claws; largest claws 2&ndash;3 times larger than smallest claws ({citeID|281|Klink 1982})~-&gt; 2\r\n## Posterior parapods carry 30&ndash;50 claws; {overlib|largest claws 3&ndash;4 times|<img src=''image.php?text=Image reduced version. Deleted: Mips_atro_cap_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_atro_cap_WCh1983_r.gif 2009-12-15 10:36:17''>} larger than smallest claws ({citeID|281|Klink 1982})~-&gt; 7\r\n#~\r\n## Second lateral seta of abdominal segments 2&ndash;7 fan-shaped ({citeID|281|Klink 1982})~-&gt; 3\r\n## Second lateral seta of abdominal segments 2&ndash;7 long, thin, split once or twice at most ({citeID|281|Klink 1982})~-&gt; 5\r\n#~\r\n## Head capsule completely {yellow} or {light brown}, labral lamella with 26&ndash;32 teeth  M. junci\r\n## Posterior margin of frontal apotome {light brown} or {dark brown}, remaining head capsule {yellow}; labral lamella with 36&ndash;52 teeth~-&gt; 4\r\n#~\r\n## Basal half of head capsule and frontal apotome {dark brown}; labral lamella with 42&ndash;52 teeth  M. notescens\r\n## Posterior margin of head and frontal apotome {light brown}; labral lamella with 35&ndash;44 teeth  M. apposita\r\n#~\r\n## Labral lamella with 30&ndash;34 teeth; labral seta SII pectinate; posterior parapods with c. 70 claws  M. recurvata\r\n## Labral lamella with 22&ndash;28 teeth; labral seta SII simple or pectinate; posterior parapods with c. 100 claws~-&gt; 6\r\n#~\r\n## Labral seta SII simple; head capsule {yellow} M. lindrothi\r\n## Labral seta SII pectinate; head capsule {brown} with {dark brown} submentum  M. radialis\r\n#~\r\n## {overlib|Antennal pedestal without spur|<img src=''image.php?text=Image reduced version. Deleted: Mips_segu_anp_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_segu_anp_Hei2004_r.jpg 2009-12-15 10:36:17''>}; posterior parapods with c. 30 claws~-&gt; 8\r\n## Antennal pedestal with {overlib|small|<img src=''image.php?text=Image reduced version. Deleted: Mips_atro_ant_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_atro_ant_WCh1983_r.gif 2009-12-15 10:36:17''>} or {overlib|large spur|<img src=''image.php?text=Image reduced version. Deleted: Mips_pall_ant_StE2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_pall_ant_StE2006_r.gif 2009-12-15 10:36:17''>}; posterior parapods with c. 50 claws~-&gt; 9\r\n#~\r\n## Large species, antennal segment 1 more than 175 &micro;m long; &lt;abbr title=''LOR = Lauterborn organ/antennal segments 3&ndash;5 length ratio''&gt;LOR&lt;/abbr&gt; c. 3.0; &lt;abbr title=''MVR = mentum/ventromental plate width ratio''&gt;MVR&lt;/abbr&gt; lower than 0.9  M. roseiventris\r\n## Smaller species, antennal segment 1 c. 150 &micro;m long; &lt;abbr title=''LOR = Lauterborn organ/antennal segments 3&ndash;5 length ratio''&gt;LOR&lt;/abbr&gt; c. 5.6; &lt;abbr title=''MVR = mentum/ventromental plate width ratio''&gt;MVR&lt;/abbr&gt; c. 1.0  M. seguyi\r\n#~\r\n## Antennal pedestal with {overlib|large, digitiform spur|<img src=''image.php?text=Image reduced version. Deleted: Mips_aris_ant_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Mips_aris_ant_WCh1983_r.gif 2009-12-15 10:36:17''>}; clypeal seta S3 branched~-&gt; 10\r\n## Antennal pedestal with small, triangular spur ; clypeal seta S3 simple~-&gt; 11\r\n#~\r\n## Antennal pedestal less than 130 &micro;m long along its median margin; &lt;abbr title=''LOR = Lauterborn organ/antennal segments 3&ndash;5 length ratio''&gt;LOR&lt;/abbr&gt; lower than 6.0 ({citeID|282|Pinder 1976})  M. aristata\r\n## Antennal pedestal more than 130 &micro;m long along its median margin; &lt;abbr title=''LOR = Lauterborn organ/antennal segments 3&ndash;5 length ratio''&gt;LOR&lt;/abbr&gt; higher than 6.0   M. pallidula\r\n#~\r\n## Antennal segment 1 shorter than 180 &micro;m; antennal pedestal shorter than 100 &micro;m~-&gt; 12\r\n##  Antennal segment 1 longer than 190 &micro;m; antennal pedestal longer than 100 &micro;m~-&gt; 14\r\n#~\r\n## Labral seta SII pectinate; postoccipital plate subtriangular ; longest anal seta more than 530 &micro;m  M. schrankelae\r\n## Labral seta SII plumose; postoccipital plate trapezoidal; longest anal seta less than 480 &micro;m or c. 600 &micro;m~-&gt; 13\r\n#~\r\n## Antennal segment 1 about 160 &micro;m long; &lt;abbr title=''AR = antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt; about 2.0 ({citeID|283|Fittkau and Reiss 1998})  M. pharetrophora\r\n## Antennal segment 1 less than 140 &micro;m long; &lt;abbr title=''AR = antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt; lower than 2.0   M. bavarica\r\n#~\r\n## Antennal segment 1 longer than 265 &micro;m; labral seta SII pectinate  M. klinki\r\n## Antennal segment 1 shorter than 250 &micro;m; labral seta SII simple or plumose~-&gt; 15\r\n#~\r\n## &lt;abbr title=''AR = antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt; higher than 2.1; &lt;abbr title=''LOR = Lauterborn organ/antennal segments 3&ndash;5 length ratio''&gt;LOR&lt;/abbr&gt; 3.6&ndash;4.0 ; labral seta SII plumose  M. atrofasciata\r\n## &lt;abbr title=''AR = antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt; lower than 2.1; &lt;abbr title=''LOR = Lauterborn organ/antennal segments 3&ndash;5 length ratio''&gt;LOR&lt;/abbr&gt; 3.6&ndash;5.5; labral seta SII simple  M. logani\r\n\r\n\r\n\r\n==Checklist (China)==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*M.apposita ? (Walker) \r\n*M.atrofasciata (Kieffer) male female {overlib|mentum|&lt;img align=''middle'' width=200 title=''Micropsectra atrofasciata (mentum) Stur and Ekrem 2006'' src=''image.php?text=image deleted: Mips_atro_men_StE2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*M.bidentata (Goetghebuer) male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Micropsectra bidentata (mentum) Heiri et.al. 2004'' src=''image.php?text=image deleted: Mips_bide_men_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} \r\n*M.baishanzua Wang male\r\n*M.junci (Meigen) male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Micropsectra junci (mentum) Ye 1984'' src=''image.php?text=image deleted: Mips_junc_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*M.nepalensis Reiss male\r\n*M.logani ? ({citeID|471|Johannsen 1928}) {overlib|mentum|&lt;img align=''middle'' alt=''Micropsectra logani (mentum)'' width=200 title=''Micropsectra logani (mentum) Stur and Ekrem 2006'' src=''image.php?text=image deleted: Mips_loga_men_StE2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*M.paucisetosa Wang and Zheng male\r\n*M.radialis ? Goetghebuer {overlib|mentum|&lt;img align=''middle'' width=200 title=''Micropsectra radialis (mentum) Heiri et.al. 2004'' src=''image.php?text=image deleted: Mips_radi_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*M.subviridis (Goetghebuer) male\r\n*M.taiwanus (Tokunaga) male\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Micropsectra as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n\r\n===Littoral===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Micropsectra contracta Reiss &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||***** ||***** ||***** || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra groenlandica And. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra insignilobus Kieff. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra lindebergi Saw. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||***** ||***** ||***** || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra [Oeklandia] borealis (Kieff.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Profundal===\r\n\r\n|-\r\n|Micropsectra contracta Reiss &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra groenlandica And. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra insignilobus Kieff. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra lindebergi S&auml;w. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Micropsectra gr. B/Tanytarsina gr. B  and other taxa: 6.9m &plusmn; 4.6 (n=51). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n\r\n===Pollution/Eutrophication===\r\n\r\n{textciteID|491|Bisthoven and Gerhardt 2003}: &laquo;The unpolluted streams ''&Ouml;vedsan'' and ''Sk&auml;ralidb&auml;cken'' each contained, respectively, 13 and 16 taxa, with a dominance of Microtendipes pedellus group and Micropsectra spp., respectively.&raquo;\r\n\r\n{textciteID|508|Meril&auml;inen et al. 2000}: &laquo;Table~2.: Four developmental stages in the northern (N) and southern (S) basins of Lake Lappaj&auml;rvi. Characterization of the sediment quality, sedimentary diatoms (reconstructed pH according to {citeID|509|Renberg and Hellberg 1982}) and chironomid remains (BQI according to {citeID|510|Wiederholm 1980})&raquo;\r\n\r\n{| style=''border:1px solid;'' \r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!colspan=''2''|Pre industrial&lt;br&gt;early 1990s\r\n!colspan=''2''|Increasing loading&lt;br&gt;ca. 1935-1960\r\n!colspan=''2''|Erosion&lt;br&gt;ca. 1960-1970\r\n!colspan=''2''|Meso-eutrophic stage&lt;br&gt;ca. 1970-present\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|Water content (% WW)\r\n|41&ndash;45 \r\n|81&ndash;82 \r\n|66&ndash;74 \r\n|79&ndash;83 \r\n|56&ndash;62 \r\n|68&ndash;77 \r\n|64&ndash;94 \r\n|73&ndash;89\r\n\r\n|-\r\n|Loss on ignition (% DW) \r\n|2.2&ndash;2.4 \r\n|14&ndash;16 \r\n|8.7&ndash;9.9 \r\n|13&ndash;15 \r\n|5.6&ndash;7 \r\n|8.8&ndash;14 \r\n|5.7&ndash;15 \r\n|7.1&ndash;15\r\n\r\n|-\r\n|Bulk density (g&middot;cm⁻&sup3;) \r\n|1.51&ndash;1.57 \r\n|1.13 \r\n|1.19&ndash;1.37 \r\n|1.0&ndash;1.12 \r\n|1.30&ndash;1.36 \r\n|1.14&ndash;1.22 \r\n|1.03&ndash;1.36 \r\n|1.05&ndash;1.19\r\n\r\n|-\r\n|pH spectra [based on diatomes]\r\n|5.9&ndash;6.4 \r\n|. . \r\n|5.9&ndash;6.8 \r\n|. . \r\n|6.7&ndash;6.9 \r\n|. . \r\n|6.9&ndash;7.4 \r\n|. .\r\n\r\n|-\r\n|Head capsules, 10⁻&sup3;&middot;m⁻&sup2;&middot;a⁻&sup1;\r\n|1.1&ndash;2.2 \r\n|25 \r\n|12&ndash;17 \r\n|24&ndash;87 \r\n|8.2&ndash;20 \r\n|27&ndash;34 \r\n|10&ndash;19 \r\n|17&ndash;60\r\n\r\n|-\r\n|Key species in chironomids \r\n|Hesu \r\n|Micr Stro \r\n|Micr Stro Seco \r\n|Chan Micr Stro\r\n|Chan Stro \r\n|Chan \r\n|Chan Chpl \r\n|Chan Chpl\r\n\r\n|-\r\n|BQI \r\n|4.4&ndash;4.6 \r\n|3.7 \r\n|3.2&ndash;3.5 \r\n|2.4&ndash;3.4 \r\n|2.0&ndash;3.3 \r\n|2.0&ndash;2.2 \r\n|2.2&ndash;2.5 \r\n|1.6&ndash;1.8\r\n\r\n|-\r\n&lt;td colspan=''9''&gt;Chan~=~Chironomus anthracinus gr., Chpl~=~Chironomus plumosus, Hesu~=~Heterotrissocladius subpilosus, Micr~=~Micropsectra spp., Seco~=~Sergentia coracina, Stro~=~Stictochironomus rosenscholdi.&lt;/td&gt;\r\n\r\n|}\r\n\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Micropsectra type (n=23, Template:explained:N2:HillsDiversity=15.69, n&lt;sub&gt;max&lt;/sub&gt;=29.52) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 4.\r\n\r\n{textciteID|492|Brodersen et al. 2004} report for Micropsectra sp. in lake Tasersuatsiaq (West Greenland) an oxygen consumption of 1.98/2.25 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 64.5/55 in % both in group {overlib|A|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  750~ha (lake area); 66.97898&deg;N; 50.69489&deg;W; 55~&micro;S~&middot; cm⁻&sup1;; 11.8&deg;C (July 2002); max. depth: &gt;80~m.\r\n\r\n===Temperature===\r\n\r\n{textciteID|492|Brodersen et al. 2004}: Cold-water assemblages were dominated by oxyconformers such as Heterotrissocladius, Micropsectra, Hydrobaenus, and Diamesa.\r\n\r\nMicropsectra gr.B/Tanytarsus gr.B reported by {textciteID|516|Korhola et al. 2002} as intermediate taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\nMicropsectra sp. reported by {textciteID|516|Korhola et al. 2002} as cold adapted taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Micropsectra undifferentiated  and other taxa: 7.0&lt; &deg;C, n=30 (sigmoidal decreasing Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', '170 23 119 150 207 96', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(33, 101, NULL, 'Not mentioned for China in {citeID|25|Walker 2000}.', 1, NULL, '159 121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(34, 1505, NULL, '==Characters general==\r\n\r\nTo distinguish Cricotopus/Orthocladius you can use openoffice database frontend in http://localhost/chip/larvae/key/characters_chiros.odb\r\n\r\n\r\n{citeID|20|Schmid 1993}: in contrast to Cricotopus body setae always simple, never with tuffs.\r\n{citeID|21|Cranston et.al. 1983}: A number of diverse larvaltypes, especially those of the subgenus O.(Euorthocladius) with more than 6 pairs of lateral teeth on mentum , have placed in Orthocladius. all have a mentum with a \r\n*single median tooth\r\n*{overlib|bifid S1|&lt;img align=''middle'' width=50 title=''Orthocladius ashei (setae S1, ...) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_ashe_set_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}, \r\n*simple bodysetae and \r\n*no beared associated with the ventromental plate (except O.(Pogonocladius)). \r\nThis combination will distiplnguish Orthocladius from other Orthocladiinae except Paratrichocladius and some Cricotopus (see comments under these genera)&lt;br&gt;\r\nNote: typical for Cricotopus and Orthocladius is the {overlib|engraved outer margin|&lt;img align=''middle'' width=100 title=''Orthocladius nigritus (mandible) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_nigr_man_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} on madible.\r\n\r\n\r\n==Key==\r\n\r\n===Subgenus level===\r\n\r\nA key to subgenus level is given by {citeID|406|S&aelig;ther 2005}:\r\n#~\r\n##Antenna 4&mdash;segmented, premandible bifid, pecten galearis present -&gt; Orthocladius (Pogonocladius)\r\n## Antenna 5&mdash;segmented or when 4&mdash;segmented premandible simple, premandible bifid or usually simple, pecten galearis usually absent -&gt; 2\r\n#~\r\n##Seta interna of mandible absent or when present, mentum with 15 or 17 teeth and premandible bifid; when mentum with 13 teeth, labral lamellae distinct and premandible bifid with weak bmsh or seta interna of mandible absent and premandible simple with apical notch and vestigial brush -&gt; Orthocladius (Mesorthocladius)\r\n##Seta interna of mandible present; premandible usually simple, when bifid brush absent; mentum usually with 13 or fewer teeth, when with 15-21 teeth, premandible simple -&gt; 3\r\n#~\r\n##Lauterborn organs robust and circular; mentum either with single broad, elongate median tooth and 2 pairs of basal, lateral teeth, or triangular in outline with first and second lateral teeth projecting above remaining lateral teeth or more convex in outline with median tooth more than 3.5 times as wide as first lateral tooth; body segments 4-9 often with lateral seta L4 developed as setal brush; pecten galearis often present; premandible simple often with vestigial brush -&gt; Orthocladius (Symposiocladius)\r\n##Lauterborn organs vestigial to well developed, when long and robust, not circular; when mentum triangular in outline or median tooth of mentum more than 3.5 times as wide as first lateral tooth setal brushes of abdomen and pecten galearis absent -&gt; 4\r\n#~\r\n##Head capsule {yellow} -&gt; Orthocladius (Orthocladius)\r\n##Head capsule {brown} to &lt;span class=''darkred''&gt;reddish brown&lt;/span&gt; -&gt; 5\r\n#~\r\n##Head capsule {light brown} to {dark brown}, not reddish; mentum sometimes with more than 13 teeth; mental extensions extended far posteriorly, distinctly exceeding line drawn through setae submenti -&gt; Orthocladius (Euorthocladius)\r\n##Head capsule &lt;span class=''darkred''&gt;dark reddish brown&lt;/span&gt;; mentum with 13 teeth, with median tooth &lt; 1.5 times as wide as first lateral tooth; mental extensions not extended far posteriorly, not or barely exceeding line drawn through setae submenti -&gt; Orthocladius (Eudactylocladius)\r\n\r\n===Holarctic===\r\n\r\nThe following key for holarctic species is from {citeID|30|Soponis 1990}:\r\n#~\r\n##Mentum with 2 teeth  -&gt; Orthocladius (Orthocladius) lignicola Kieffer\r\n##Mentum with &gt;== 13 teeth  -&gt; 2\r\n#~\r\n##Mentum with &gt;13 teeth ... Orthocladius (Euorthocladius) (part) -&gt; 3\r\n##Mentum with 13 teeth -&gt; 5\r\n#~\r\n##Mentum with 15 teeth, mandible without seta interna  -&gt; O. roussellae {citeID|30|Soponis 1990}\r\n##Mentum with &gt;15 teeth, mandible with seta interna -&gt; 4\r\n#~\r\n##Europe, North America  -&gt; O.rivulorum Kieffer\r\n##Japan  -&gt; O. suspensus (Tokunaga) [based on literature]\r\n#~\r\n##Head capsule {yellow}  -&gt; Orthocladius (Orthocladius)\r\n##Head capsule {brown}  -&gt; 6\r\n#~\r\n##Antenna 4 segmented, Lauterborn organs weak  -&gt; Orthocladius (Pogonocladius) consobrinus (Holmgren)\r\n##Antenna 4 segmented, Lauterborn organs robust  -&gt; 7\r\n#~\r\n##Head capsule &lt;span class=''darkred''&gt;dark reddish brown&lt;/span&gt;  -&gt; Orthocladius (Eudactylocladius)\r\n##Head capsule {light brown} to {dark brown}, not reddish ... Orthocladius (Euorthocladius) part  -&gt; 8\r\n#~\r\n##Mentum witdh median tooth &gt;1.5x wih of 1st lateral tooth (MR &gt; 1.5)  -&gt; 9\r\n##Mentum witdh median tooth &lt;1.5x wih of 1st lateral tooth (MR &lt; 1.5)  -&gt; 12\r\n#~\r\n##AR &gt; 1.85  -&gt; 10\r\n##AR &lt; 1.85  -&gt; 11\r\n#~\r\n##Premandible bifid  -&gt; O.calvus Pinder\r\n##Premandible simple  -&gt; O.thienemanni Kieffer\r\n#~\r\n##Europe, North America; head capsule {brown}  -&gt; O.luteipes Goetghebuer\r\n##Japan; head capsule {dark brown}   -&gt; O.kanii ({citeID|433|Tokunaga 1939})[based on literature]\r\n###{citeID|432|Sasa 1979}: Outer margin of mandible with three notches. Lauterborn&rsquo;s organ globular, about 4-times as wide as antenna] Segment III. Middle tooth of labial plate wider and with horizontal anterior margin. Claws on anterior and posterior pseudopods and head capsule {dark brown} -&gt; O.kanii ({citeID|433|Tokunaga 1939})\r\n###{citeID|432|Sasa 1979}: Outer margin of mandible smooth. Lauterbom&lsquo;s organ longer than wide. Middle tooth of labial plate with convex anterior margin. Claws on anterior and posterior pseudopods as well as head capsule &lt;span class=''lightbrown''&gt;yellowish brown&lt;/span&gt; -&gt; Orthocladius makabensis {citeID|432|Sasa 1979}; {overlib|O.yugashimaensis|&lt;img align=''middle'' width=200 title=''Orthocladius yugashimaensis (mentum) Makarchenko 2006'' src=''image.php?text=image deleted: OrthOr_yuga_men_Mak2006a_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} {citeID|432|Sasa 1979}\r\n#~\r\n##AR &lt; 1.80  -&gt; O.ashei, O.rivicola Kieffer\r\n##AR &gt; 1.80  -&gt; 13\r\n#~\r\n##Head casule {dark brown} -&gt; O.saxosus (Tokunaga)\r\n##Head casule {light brown} or {brown} -&gt; O.abiskoensis Thienemann &amp; Kr&uuml;ger\r\n\r\n\r\n==Checklist China==\r\n\r\nIn China from {citeID|279|Wang 2000}:\r\n* Subgenus Eudactylocladius Thienemann\r\n** O.mixtus (Holmgren) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius mixtus (mentum) Wang and Wang 1991'' src=''image.php?text=image deleted: Orth_mixt_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n* Subgenus Orthocladius Wulp\r\n** O.frigidus (Zetterstedt) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius frigidus (mentum) Schmid 1993'' src=''image.php?text=image deleted: Orth_frig_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** O.makabensis {citeID|432|Sasa 1979} \r\n** O.obumbratus {citeID|328|Johannsen 1905} {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius obumbratus (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_obum_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** O.saxicola (Kieffer) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius saxicola (mentum) Schmid 1993'' src=''image.php?text=image deleted: Orth_saxi_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** O.solivaga (?) Pankratova\r\n** O.yugashimaensis {citeID|432|Sasa 1979} {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius yugashimaensis (mentum) Makarchenko 2006'' src=''image.php?text=image deleted: OrthOr_yuga_men_Mak2006a_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n* Subgenus Euorthocladius Thienemann\r\n** O.kanii ({citeID|433|Tokunaga 1939}) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius kanii (mentum) Tokunaga 1939'' src=''image.php?text=image deleted: OrthEu_kani_men_Tok1939_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' width=200 title=''Orthocladius kanii (mentum) Makarchenko 2006'' src=''image.php?text=image deleted: OrthEu_kani_men_Mak2006a_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** O.rivulorum Kieffer  {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius rivulorum (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_rivu_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** O.thienemanni (Kieffer)  {overlib|mentum|&lt;img align=''middle'' width=200 title=''Orthocladius thienemanni (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_thni_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|reference\r\n!im90|head\r\n!im90|head - postoccipital margin\r\n!im90|antenna\r\n!im90|antenna - blade\r\n!|s1\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!|mandible\r\n!im90|mandible - seta subdentalis\r\n!im90|mandible - seta interna\r\n!im90|maxilla - pecten galearis\r\n!im90|ventromental plates\r\n!im90|mentum - median\r\n!im90|mentum - lateral\r\n!im90|mentum - pattern\r\n!im90|body\r\n\r\n==Characters==\r\n\r\n\r\n===Genus===\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;!-- head --{yellow} to &lt;span class=''brownish'' &gt;brownish&lt;/span&gt;\r\n|&lt;!-- head pom --&gt;&lt;span class=''pale'' &gt;pale&lt;/span&gt; to &lt;span class=''darkened'' &gt;darkened&lt;/span&gt;\r\n|&lt;!-- ant --&gt;5\r\n|&lt;!-- ant blade --&gt;blade shorter or lomger than flagellum\r\n|&lt;!-- s1 --&gt;bifid\r\n|&lt;!-- pee --&gt;3 spines\r\n|&lt;!-- pre --&gt;1 sometimes with basal tooth\r\n|&lt;!-- man --&gt;3/4-1-0-0\r\n|&lt;!-- man s subdent --&gt;present\r\n|&lt;!-- man s interna --&gt;mostly\r\n|&lt;!-- max pect gal --&gt;well developed\r\n|&lt;!-- vep --&gt;usually narrow, but variably developed\r\n|&lt;!-- men mid --&gt;1\r\n|&lt;!-- men lat --&gt;6 (to 9)\r\n|&lt;!-- men pat --&gt;\r\n|&lt;!-- body --&gt;with single setae but never with tufts of setae\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}\r\n|&lt;!-- head --&gt;\r\n|&lt;!-- head pom --&gt;\r\n|&lt;!-- ant --&gt;5 or 4\r\n|&lt;!-- ant blade --&gt;blade usually shorter than flagellum\r\n|&lt;!-- s1 --&gt;bifid, remaining s-setae simple\r\n|&lt;!-- pee --&gt;3 scales\r\n|&lt;!-- pre --&gt;1 or 2; when 1 -&gt; frequently notched\r\n|&lt;!-- man --&gt;3-1-0-0\r\n|&lt;!-- man s subdent --&gt;present\r\n|&lt;!-- man s interna --&gt;mostly\r\n|&lt;!-- max pect gal --&gt;well developed\r\n|&lt;!-- vep --&gt;narrow; beared present only in O.(Pogonocladius)\r\n|&lt;!-- men mid --&gt;1\r\n|&lt;!-- men lat --&gt;6 (to 9)\r\n|&lt;!-- men pat --&gt;\r\n|&lt;!-- body --&gt;with simple setae \r\n|}\r\n\r\n===Specimens===\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n!im90  class=''table-sortable:default ''|Reference\r\n!im90  class=''table-sortable:default ''|Species\r\n!im90  class=''table-sortable:default ''|Antennal ratio\r\n!im90  class=''table-sortable:default ''|Antennal blade ratio\r\n!im90  class=''table-sortable:default ''|Head ratio\r\n!im90  class=''table-sortable:default ''|Head color\r\n!im90  class=''table-sortable:default ''|Mentum middle TR\r\n!im90  class=''table-sortable:default ''|Mentum middle to 1.lat-TR\r\n!im90  class=''table-sortable:default ''|Mentum s-submenti lat-tooth_position\r\n!im90  class=''table-sortable:default ''|Mandible inner\r\n!im90  class=''table-sortable:default ''|Mandible margin engraved?\r\n!im90  class=''table-sortable:default ''|Mandible seta interna\r\n!im90  class=''table-sortable:default ''|Mandible seta subdentalis\r\n!im90  class=''table-sortable:default ''|Seta S1\r\n!im90  class=''table-sortable:default ''|Premandible\r\n!im90  class=''table-sortable:default ''|Premandible: brush\r\n\r\n|-\r\n!|&lt;input name=''filterReference0'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Reference --&gt;\r\n!|&lt;input name=''filterSpecies1'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Species --&gt;\r\n!|&lt;input name=''filterAntennal2'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antennal ratio --&gt;\r\n!|&lt;input name=''filterAntennal3'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Antennal blade ratio --&gt;\r\n!|&lt;input name=''filterHead4'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head ratio --&gt;\r\n!|&lt;input name=''filterHead5'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Head color --&gt;\r\n!|&lt;input name=''filterMentum6'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum middle TR --&gt;\r\n!|&lt;input name=''filterMentum7'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum middle to 1.lat-TR --&gt;\r\n!|&lt;input name=''filterMentum8'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mentum s-submenti lat-tooth_position --&gt;\r\n!|&lt;input name=''filterMandible9'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible inner --&gt;\r\n!|&lt;input name=''filterMandible10'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible margin engraved? --&gt;\r\n!|&lt;input name=''filterMandible11'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible seta interna --&gt;\r\n!|&lt;input name=''filterMandible12'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Mandible seta subdentalis --&gt;\r\n!|&lt;input name=''filterSeta13'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Seta S1 --&gt;\r\n!|&lt;input name=''filterPremandible14'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Premandible --&gt;\r\n!|&lt;input name=''filterPremandible15'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;&lt;!-- Premandible: brush --&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n| {citeID|30|Soponis 1990}\r\n| Orthocladius (Euorthocladius) abiskoensis&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius abiskoensis (mentum) Soponis 1990'' src=''image.php?text=image deleted: OrthEu_abis_men_Sop1990_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2.41\r\n| 0.93\r\n| 1.23\r\n| brown\r\n| 1.83\r\n| 1.15 ( +- 0.15 n=3)\r\n| 4.5\r\n| 3\r\n| 1\r\n| 1 - 5 branches\r\n| 1 - does not reach base of 1st inner tooth\r\n| 2\r\n| 1.0\r\n|\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Symposiocladius) annectens&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius annectens (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_anne_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.59\r\n| 0.73\r\n|\r\n| yellow\r\n| 1.05 ( +- 0.1 n=1)\r\n| 2.6\r\n| 4.5\r\n| 3.5\r\n| 1\r\n| 1 - 8 setae\r\n| 1 - reaches base of 1st inner tooth\r\n| 2\r\n| 2.0 1 apical 1 basal\r\n| 1\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Euorthocladius) ashei&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius ashei (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_ashe_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.742 ( +- 0.148 n=8)\r\n| 0.82\r\n| 1.249 ( +- 0.099 n=8)\r\n| yellow to brown\r\n| 1.6\r\n| 1.5\r\n| 4 - additional fovea next to s submenti\r\n| 3\r\n| 0\r\n| 1 - 6 branches\r\n| 1 - reaches middle of 1st inner tooth\r\n| 2\r\n| 2.0 1 and 1 broad basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) charensis&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius charensis (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_char_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.56\r\n| 0.64\r\n|\r\n| yellow\r\n| 1.48\r\n| 1.241\r\n| 2\r\n| 3\r\n| 0.5\r\n| 1 - 7 setae\r\n| 1 - reaches base of 1st inner tooth\r\n| 1.9\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) clarki&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius clarki (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_clak_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.93\r\n| 1\r\n|\r\n| yellow\r\n| 2.956\r\n| 3.045\r\n| 4\r\n| 3.5\r\n| 0\r\n| 1 - 7 setae\r\n| 1\r\n| 1.9\r\n| 2.5 1 apical incised 1 basal\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Pogonocladius) consobrinus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius consobrinus (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthPo_coso_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2.54\r\n| 0.76\r\n|\r\n| ?\r\n| 1.78\r\n| 1.55\r\n| 3.5\r\n| 3.5\r\n| 1\r\n| 1\r\n| 1 - does not reach basis of 1st inner tooth\r\n| 1.8 - inner shorter\r\n| 2.0 2 apical\r\n|\r\n\r\n|-\r\n| {citeID|343|Goetghebuer et.al. 1948}\r\n| Orthocladius (Orthocladius) crassicornis&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius crassicornis (mentum) Goetghebuer et.al. 1948'' src=''image.php?text=image deleted: Orth_crco_men_Goe1948_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2.69\r\n| 1.25\r\n|\r\n| ?\r\n| 1.6\r\n| 0.85\r\n| - ? not drawn\r\n|\r\n| ?\r\n|\r\n|\r\n| 1.7\r\n|\r\n|\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) curtiseta&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius curtiseta (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_cuts_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.33\r\n| 0.83\r\n|\r\n| ?\r\n| 1.33\r\n| 1.8\r\n| 4.7 ( +- 0.2)\r\n| 4\r\n| 0\r\n| 1 - 7 setae\r\n| 1 - reaches the base of 2nd inner tooth\r\n|\r\n| 1.0\r\n|\r\n\r\n|-\r\n| {citeID|324|Makarchenko and Makarchenko 2006}\r\n| Orthocladius (Orthocladius) defensus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius defensus (mentum) Makarchenko and Makarchenko 2006'' src=''image.php?text=image deleted: Orth_defn_men_Mak2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.44\r\n|\r\n|\r\n| ?\r\n| 2.9 ( +- 0.1 n=1)\r\n| 2.25\r\n| 4.5\r\n| 3\r\n| 0\r\n| 1\r\n| 1 - reaches middle of 1st inner tooth\r\n|\r\n|\r\n|\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) dentifer&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius dentifer (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_denf_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.37\r\n| 0.91\r\n|\r\n| ?\r\n| 1.42\r\n| 2.13\r\n| 3.5\r\n| 3.5\r\n| 1\r\n| 1 - ?8 setae\r\n| 1 - extend to base of 1st inner tooth\r\n|\r\n| 1.0\r\n|\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) dorenus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius dorenus (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_dore_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.84\r\n| 1\r\n|\r\n| ?\r\n| 2.29\r\n| 2.152\r\n| 4.5\r\n| 3.5\r\n| 1\r\n| 1 - 7 setae\r\n| 1\r\n| 2\r\n| 1.0\r\n|\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Orthocladius) frigidus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius frigidus (mentum) Schmid 1993'' src=''image.php?text=image deleted: Orth_frig_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.599 ( +- 0.073 n=10)\r\n| 0.97\r\n| 1.29 ( +- 0.038 n=12)\r\n| yellow L4 dark brown L3+2\r\n| 2\r\n| 1.56\r\n| 5.5 - additional fovea lateral to setae\r\n| 3.5\r\n| 1\r\n| 0\r\n| 1 - small don''t reaches the base of 1st inner tooth\r\n| 2\r\n| 2.0 1 apical and 1 broad basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|374|S&aelig;ther 2003}\r\n| Orthocladius (Symposiocladius) halvorseini&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius halvorseini (mentum) S&aelig;ther 2003'' src=''../../imglarvae/OrthSy_halv_men_Sae2003_r.gif'' &gt;\r\n| 1.42\r\n| 1.27\r\n| 1.923 ( +- 0.045 n=6)\r\n| black\r\n| 2.08\r\n| 6\r\n| 4.5\r\n| 3\r\n| 0\r\n| 1 - 5 branches\r\n| 1 - reaches basis of 1st inner tooth\r\n|\r\n| 1.0 n=1 brush: a view points\r\n| 1\r\n\r\n|-\r\n| {citeID|377|Dettinger-Klemm 2001}\r\n| Orthocladius (Symposiocladius) holsatus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius holsatus (mentum) Dettinger-Klemm 2001'' src=''image.php?text=image deleted: OrthSy_hosa_men_Det2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2.1 ( +- 0.15 n=4)\r\n| 0.855\r\n| 1.123\r\n| pale yellow\r\n| 3.11\r\n| 5.23 ( +- 1.2 n=4)\r\n| 3 ( +- 0.5)\r\n| 3\r\n| 0\r\n| 1 - 6-7 branches\r\n| 1 - reaching basis of 1st inner tooth\r\n| 1.5 - inner shorter\r\n| 1.0 n=2 brown\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) lapponicus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius lapponicus (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_lapo_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2.07\r\n| 0.92\r\n|\r\n| ?\r\n| 2.06\r\n| 1.73\r\n| 4.5 ( +- 0.5)\r\n| 3\r\n| 0.5\r\n| 1 - 7 setae\r\n| 1 - reaches base of 1st inner tooth\r\n| 2\r\n| 3.0 n=1 2 apical (incised) 1 broad basal\r\n| 0\r\n\r\n|-\r\n| {citeID|377|Dettinger-Klemm 2001}\r\n| Orthocladius (Symposiocladius) lunzensis&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius lunzensis (mentum) Dettinger-Klemm 2001'' src=''image.php?text=image deleted: OrthSy_lunz_men_Det2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.63\r\n| 1.12\r\n|\r\n| pale yellow\r\n| 4.52\r\n| 3.89\r\n| - not drawn\r\n| 3.5\r\n| 0\r\n| 1\r\n| 1 - reaches middle of 1st inner tooth\r\n|\r\n| neither drawn nor some text given\r\n|\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Euorthocladius) luteipes&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius luteipes (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_lute_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.29\r\n| 0.75\r\n|\r\n| ?\r\n| 2.6\r\n| 1.7\r\n| 3.1 ( +- 0.1)\r\n| 3\r\n| 0\r\n| 1 - 6 branches\r\n| 1 - reaches base of 1st inner tooth\r\n| 2\r\n| 1.0 1 apical 1 broad bulge basal\r\n|\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) mallochi&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius mallochi (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_mall_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.39\r\n| 0.85\r\n|\r\n| ?\r\n| 2.45\r\n| 1.69\r\n| 3\r\n| 4\r\n| 0.5\r\n| 1 - 7 seate\r\n| 1 - small don''t reaches base of 1st inner tooth\r\n| 1.8\r\n| 1.0 n=2 1 apical incised\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) manitobensis&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius manitobensis (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_mani_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.61\r\n| 0.87\r\n|\r\n| ?\r\n| 2.35\r\n| 3.2\r\n| 3.5 ( +- 0.5)\r\n| 3.5\r\n| 0.5\r\n| 1 - 7 setae\r\n| 1 - reaches base of 1st inner tooth\r\n| 1.9 - outer slightly shorter\r\n| 1.0 n=1\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) nigritus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius nigritus (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_nigr_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.43\r\n| 0.82\r\n|\r\n| ?\r\n| 1.65\r\n| 2.84\r\n| 4.5 ( +- 0.5)\r\n| 3.5\r\n| 1\r\n| 1 - ? 7 setae\r\n| 1 - reaches middle of first inner tooth\r\n|\r\n| 1.00-0 n=3 from text\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) obumbratus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius obumbratus (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_obum_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.8\r\n| 0.74\r\n|\r\n| ?\r\n| 2.04\r\n| 3.32\r\n| 4\r\n| 3\r\n| 0.2\r\n| 1 - 7 branches\r\n| 1 - reaches base of 1st inner tooth\r\n| 1.8\r\n| 2.0 1 incised apical 1 hooked basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) oliveri&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius oliveri (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_oliv_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2\r\n| 0.64\r\n|\r\n| yellow\r\n| 1.47\r\n| 1.59\r\n| 3.5 ( +- 0.5)\r\n| 3\r\n| 0.5\r\n| 1 - 6 seate\r\n| 1 - reaches basis of 1st inner tooth\r\n| 2\r\n| 3.0 n=1\r\n|\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Euorthocladius) rivicola&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius rivicola (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_rivi_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.518 ( +- 0.171 n=11)\r\n| 0.81\r\n| 1.304 ( +- 0.202 n=10)\r\n| yellow to brown\r\n| 2.087\r\n| 1.35 ( +- 0.2 n=11)\r\n| 4\r\n| 3\r\n| 0\r\n| 1 - 6 branches\r\n| 1 - reaches base of 1st inner tooth\r\n| 2\r\n| 2.0 n=1 1 apical 1 basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Euorthocladius) rivulorum&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius rivulorum (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_rivu_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.897 ( +- 0.047 n=5)\r\n| 0.9\r\n| 1.353 ( +- 0.173 n=5)\r\n| light brown to greyish\r\n| 2\r\n| 4.8\r\n| 1\r\n| 4\r\n| 0\r\n| 1 - 5 branches\r\n| 1 - reaches the middle of 1st inner tooth\r\n| 1.8\r\n| 1.0 n=1\r\n| 0\r\n\r\n|-\r\n| {citeID|41|Yan et.al. 1982}\r\n| Orthocladius (Euorthocladius) rivulorum gr.&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius rivulorum gr. (mentum) Yan et.al. 1982'' src=''image.php?text=image deleted: OrthEu_rivugr_men_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|\r\n|\r\n|\r\n| ?\r\n| 2.48\r\n| 3.63\r\n|\r\n| 4\r\n| 0\r\n| 1 - 10 branches\r\n| 1 - reaches base of 2nd inner tooth\r\n| 1.7\r\n| 1.0\r\n|\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) robacki&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius robacki (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_roba_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.78\r\n| 1\r\n| ?\r\n| ?\r\n| 3.125\r\n| 4.45\r\n| 4\r\n| 3\r\n| 0\r\n| 1 - 7 setaea\r\n| 1 - reaches base of 1st inner tooth\r\n| 1.7\r\n| 2.0 n=1 1 apical 1 small basal\r\n| 0\r\n\r\n|-\r\n| {citeID|30|Soponis 1990}\r\n| Orthocladius (Euorthocladius) roussellae&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius roussellae (mentum) Soponis 1990'' src=''image.php?text=image deleted: OrthEu_rous_men_Sop1990_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2.18\r\n| 1\r\n|\r\n| ?\r\n| 1.767 ( +- 0.681 n=4)\r\n| 1.654 ( +- 0.2 n=8)\r\n| - not drawn\r\n| 3.5\r\n| 0.5\r\n| 0 - not drawn\r\n| 1 - dont reaches base of 1st 0.5 inner tooth\r\n| 2\r\n| 3.0 n=2 2 apical 1 roundbasal\r\n|\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Euorthocladius) saxosus&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius saxosus (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_saxo_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.74 ( +- 0.192 n=5)\r\n| 1\r\n| 1.471 ( +- 0.035 n=9)\r\n| dark-brown\r\n| 1.42\r\n| 1.17 ( +- 0.17 n=5)\r\n| 5\r\n| 4\r\n| 0\r\n| 1 - 6 branches\r\n| 1 - reaches base on 3rd inner tooth\r\n| 2\r\n| 2.0 n=1\r\n| 0\r\n\r\n|-\r\n| {citeID|30|Soponis 1990}\r\n| Orthocladius (Euorthocladius) saxosus 1&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius saxosus 1 (mentum) Soponis 1990'' src=''image.php?text=image deleted: OrthEu_saxo1_men_Sop1990_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.67\r\n| 1.22\r\n|\r\n| ?\r\n| 2\r\n| 1.17\r\n| - not drawn\r\n| 3.5\r\n| 0\r\n| 1\r\n| 1 - reaches base of 1st inner tooth\r\n|\r\n|\r\n|\r\n\r\n|-\r\n| {citeID|30|Soponis 1990}\r\n| Orthocladius (Euorthocladius) saxosus 2&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius saxosus 2 (mentum) Soponis 1990'' src=''image.php?text=image deleted: OrthEu_saxo2_men_Sop1990_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.55\r\n| 0.7\r\n|\r\n| ?\r\n| 1.85\r\n| 1.58\r\n|\r\n| 4\r\n| 0\r\n| 1 - 5 branches\r\n| 1 - reaches base of 2nd inner tooth\r\n|\r\n|\r\n|\r\n\r\n|-\r\n| {citeID|374|S&aelig;ther 2003}\r\n| Orthocladius (Symposiocladius) schnelli&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius schnelli (mentum) S&aelig;ther 2003'' src=''../../imglarvae/OrthSy_schn_men_Sae2003_r.gif'' &gt;\r\n| 1.9 ( +- 0.1 n=11)\r\n|\r\n| 2.261 ( +- 0.178 n=11)\r\n| brown\r\n|\r\n|\r\n| 6\r\n| 3\r\n| 0.5\r\n| 1 - 7 branches\r\n| 1 - reaches 1st inner tooth\r\n| 1.5\r\n| 1.0 weak brush\r\n| 1\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Eudactylocladius) sp&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius sp (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthEd_spec_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|\r\n|\r\n|\r\n| ?\r\n| 1.87\r\n| 1.64\r\n| 3.7 ( +- 0.2)\r\n| 4.5\r\n| 0\r\n| 1\r\n| 1 - don''t reaches base of 1st inner tooth\r\n|\r\n|\r\n|\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Euorthocladius) thienemanni&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius thienemanni (mentum) Schmid 1993'' src=''image.php?text=image deleted: OrthEu_thni_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.725 ( +- 0.192 n=10)\r\n| 0.88\r\n| 1.25 ( +- 0.113 n=10)\r\n| yellow to light-brown\r\n| 2 ( +- 0.35 n=1)\r\n| 1.75 ( +- 0.35 n=10)\r\n| 4.5 ( +- 0.5)\r\n| 3.5\r\n| 0\r\n| 1 - 6 branches and longer unbrunched part\r\n| 1 - reaches base of first inner tooth\r\n| 2\r\n| 2.0 n=1 1 apical 1 broad basal tooth\r\n| 0\r\n\r\n|-\r\n| {citeID|6|Epler 2001}\r\n| Orthocladius (Orthocladius) vaillanti&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius vaillanti (mentum) Epler 2001'' src=''image.php?text=image deleted: OrthOr_vail_men_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|\r\n|\r\n|\r\n| ?\r\n| 2.64\r\n| 2.23\r\n| 5.8 ( +- 0.1)\r\n| 4\r\n| 0\r\n| 0\r\n| 1 - reaches basis of 1st inner tooth\r\n|\r\n|\r\n|\r\n\r\n|-\r\n| {citeID|20|Schmid 1993}\r\n| Orthocladius (Orthocladius) wetterensis&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius wetterensis (mentum) Schmid 1993'' src=''image.php?text=image deleted: Orth_wett_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 1.999 ( +- 0.069 n=5)\r\n| 0.9\r\n| 1.172 ( +- 0.132 n=9)\r\n| whitish-greyish\r\n| 3.58\r\n| 3.625 ( +- 0.175 n=9)\r\n| 5\r\n| 3.5\r\n| 0\r\n| 1 - 5-6 branches\r\n| 1 - reaches base of 1st inner tooth\r\n| 2\r\n| 1.0\r\n| 0\r\n\r\n|-\r\n| {citeID|3|Soponis 1977}\r\n| Orthocladius (Orthocladius) wiensi&lt;br&gt;&lt;img align=''middle'' width=200 title=''Orthocladius wiensi (mentum) Soponis 1977'' src=''image.php?text=image deleted: OrthOr_wien_men_Sop1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n| 2.07\r\n| 0.74\r\n|\r\n| ?\r\n| 2.12\r\n| 2.73\r\n| 4\r\n| 3\r\n| 1\r\n| 1 - 7 setae\r\n| 1 - reaches base of 1st inner tooth\r\n| 1.8 - inner shorter\r\n| 2.0 n=2 distorted\r\n| 0\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Orthocladius as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Orthocladius (0.) trigonolabis Edw. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Orthocladius (P.) consobrinus Holmgr. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Conductivity/Salinity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Orthocladius/Cricotopus in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 19229.92mg &middot; l⁻&sup1; (&divide; 600 = 32.05mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 2.12027. In article shortened as: Oc.\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Orthocladius sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n\r\n===Temperature===\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for\r\n*Cricotopus/Orthocladius  and other taxa to find possible differences in temperature: 2000: 13.3&deg;C &plusmn; 4.2 (9 to 17.5), 2006: 13.9&deg;C &plusmn; 4.7 (9.2 to 18.5) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n*Orthocladius sp.  and other taxa to find possible differences in temperature: 2000: 13.3&deg;C &plusmn; 4 (9.3 to 17.3), 2006: 12.7&deg;C &plusmn; 5 (7.7 to 17.7) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon\r\n*Cricotopus/Orthocladius  and other taxa: 11.4&deg;C &plusmn; 1.9, n=22 (unimodal Template:HOF:unimodal)  . Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n*Orthocladius sp.  and other taxa: 7.0&lt; &deg;C, n=43 (sigmoidal decreasing Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft)   . Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Orthocladius sp. Cricotopus sp.  and other taxa: 6.9m &plusmn; 5.3 (n=47). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cricotopus/Orthocladius (n=29, Template:explained:N2:HillsDiversity=21.37, n&lt;sub&gt;max&lt;/sub&gt;=9.09) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 33.\r\n', '31 122 108 65 ', NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(35, 106, NULL, NULL, 1, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Georthocladius sp./Parachaetocladius sp.  and other taxa: 11.1m &plusmn; 4.9 (n=5). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', '17 202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(36, 109, NULL, 'Key to groups ({citeID|2|Pinder and Reiss 1983}):\r\n# Antennae &gt;1/3 as long as head. Posterior parapods about 4x as long as basal width ... P.doris group<br>- Antennae &lt;1/3 as long as head. Posterior parapods < 3x as long as basal width -> 2\r\n# Antennal blade fused basally with segment 2 of antenna ... P.camptolabis group<br>- Antennal blade arises distally from segment 1 ... P.nigritula group\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.camptolabris (?) (Kieffer)\r\n*P.obscura Brundin', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Paracladopelma as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|492|Brodersen et al. 2004} report for Paracladopelma sp. in lake Tasersuatsiaq (West Greenland) an oxygen consumption of 6.92/4.53 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 23.2/35.4 in % is in group {overlib|D/C|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  750~ha (lake area); 66.97898&deg;N; 50.69489&deg;W; 55~&micro;S~&middot; cm⁻&sup1;; 11.8&deg;C (July 2002); max. depth: &gt;80~m.\r\n\r\n===Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Paracladopelma laminata-Agg. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Paracladopelma the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '35 152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(37, 111, NULL, '{citeID|2|Pinder and Reiss 1983}: Mentum: beard present in some unreared species larvae tentatively assigned to this genus but absent in all reared species.\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|specimen\r\n!im90|head\r\n!im90|postoccipital margin\r\n!im90|antenna\r\n!im90|seta s1\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!im90|premandible-brush\r\n!im90|mentum\r\n!im90|mandible\r\n!im90|beard\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|Parakiefferiella sp. Thienemann 1936\r\n|&lt;!-- head --&gt;whitish to yellow\r\n|&lt;!-- pom --&gt;darkened\r\n|&lt;!-- ant --&gt;6 - blade not reaching apex\r\n|&lt;!-- set1 --&gt;2 - bifid and serrated or palmate, remainig S-setae simple\r\n|&lt;!-- pee --&gt;3 slender, subequal scales\r\n|&lt;!-- pre --&gt;1 apical\r\n|&lt;!-- pre-brush --&gt;no\r\n|&lt;!-- men --&gt;1 + 5-6 lateral teeth\r\n|&lt;!-- man --&gt;3-1-0-0\r\n|&lt;!-- beard --&gt;?\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Parakiefferiella sp. Thienemann 1936\r\n|&lt;!-- head --&gt;\r\n|&lt;!-- pom --&gt;\r\n|&lt;!-- ant --&gt;6(-5) \r\n|&lt;!-- set1 --&gt;3 always? or more\r\n|&lt;!-- pee --&gt;3 subequal scales\r\n|&lt;!-- pre --&gt;1-2 apical + 1 broad inner\r\n|&lt;!-- pre-brush --&gt;no\r\n|&lt;!-- men --&gt;1-2 + 5-6 lateral teeth\r\n|&lt;!-- man --&gt;3-1-0-0\r\n|&lt;!-- beard --&gt;yes - in ureared, but &lt;strike&gt;reared&lt;/strike&gt;\r\n\r\n\r\n|}', 1, '==Temperature==\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for:\r\n*Parakiefferiella sp. including nigra  and other taxa to find possible differences in temperature: 2000: 10.9&deg;C &plusmn; 4.8 (6.1 to 15.7), 2006: 9.3&deg;C &plusmn; 4.5 (4.8 to 13.8) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n*Parakiefferiella cf.sp. B (Walker 1988)  and other taxa to find possible differences in temperature: 2000: 12&deg;C &plusmn; 5.6 (6.5 to 17.6), 2006: 9&deg;C &plusmn; 5.7 (3.3 to 14.7) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n*Parakiefferiella (Fig. 367 in O&amp;R)  and other taxa to find possible differences in temperature: 2000: 12.1&deg;C &plusmn; 4.5 (7.6 to 16.6), 2006: 11&deg;C &plusmn; 5.2 (5.8 to 16.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n', '64 232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(38, 113, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*P.hydrophilus (Goethgebuer)\r\n*P.jii {citeID|425|Wang and S&aelig;ther 2002a}\r\n\r\n{citeID|425|Wang and S&aelig;ther 2002a}: the immature stages are known for P. hydrophilus and P. albibasis only. \r\n            .                   .\r\n', 1, '==Biotops==\r\n\r\n{citeID|541|Kurek and Cwynar 2009}: &laquo;For example, Pseudosmittia/Smittia and Limnophyes/Paralimnophyes are known as semi-terrestrial or littoral taxa ({citeID|302|Brooks et al. 2007}).&raquo;\r\n', '79 56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(39, 116, NULL, '{citeID|21|Cranston et.al. 1983}:<br>\r\nLarvae of Paraphaenocladius often are difficult separate from those of Parametriocnemus. Apparently the only consistent difference is:\r\n*the curved preanal segmenting causing the posterior direction of procerci and\r\n*anal setae in Paraphaenocladius.\r\nAlso, Parametriocnemus apparently \r\n*never has secondary ventromental plates and\r\n*never a single median mental tooth as in several Paraphaenocladius.\r\nParaphaenocladius also always has 3 premandibular teeth, while Parametriocnemus has 4-6 teeth.<br>\r\n\r\nIn China ({citeID|279|Wang 2000}):<br>\r\n*P.exagitans exagitans Johannsen\r\n*P.impensus contractus Sæther and Wang\r\n*P.nashthecus Sæther\r\n*P.triangulus Sæhter and Wang', 1, NULL, '15 115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(40, 118, NULL, 'Comments from {citeID|21|Cranston et.al. 1983}: The structure of the S1 seta is distinctive and may only be confused with that of Smittia and Antillocladius, from which Parasmittia can be separated by the shorter, 4 segmented antenna.&lt;br&gt; Differences to Eukiefferiella: Mandible 4-1-0-0 instead of 3-1-0-0.&lt;br&gt;\r\n\r\nIn China ({citeID|279|Wang 2000}) not mentioned.\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|reference\r\n!im90|head\r\n!im90|head - postoccipital margin\r\n!im90|antenna\r\n!im90|antenna - blade\r\n!|s1\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!im90|premandible - inner tooth\r\n!im90|mentum - middle tooth\r\n!im90|mentum - lateral teeth\r\n!im90|ventromental plates\r\n!|mandible\r\n!im90|manible - seta subdentalis\r\n!im90|manible - seta interna\r\n!im90|maxilla - palpus\r\n!im90|maxilla - laccinal chetae\r\n!im90|abdomen\r\n|-\r\n|&lt;!-- ref --&gt;{citeID|21|Cranston et.al. 1983}\r\n|&lt;!-- head --&gt;\r\n|&lt;!-- head pom --&gt;\r\n|&lt;!-- ant --&gt;4\r\n|&lt;!-- ant blade --&gt;\r\n|&lt;!-- s1 --&gt;unusual, deeply incised lobes\r\n|&lt;!-- pee --&gt;3\r\n|&lt;!-- pre --&gt;2, no brush\r\n|&lt;!-- pre inner tooth --&gt;1 broad\r\n|&lt;!-- men midlle --&gt;\r\n|&lt;!-- men lat --&gt;5\r\n|&lt;!-- vep --&gt;well developed, no beard\r\n|&lt;!-- man --&gt;3-1-0-0\r\n|&lt;!-- man s subd. --&gt;\r\n|&lt;!-- man - s int. --&gt;3-4 fine serrated branches\r\n|&lt;!-- max - palpus --&gt;\r\n|&lt;!-- max - lacc. chetae --&gt;\r\n|&lt;!-- abdomen --&gt;no parapods\r\n|}\r\n', 1, '==Biotops==\r\n\r\n{citeID|541|Kurek and Cwynar 2009}: &laquo;For example, Pseudosmittia/Smittia and Limnophyes/Paralimnophyes are known as semi-terrestrial or littoral taxa ({citeID|302|Brooks et al. 2007}).&raquo;\r\n', '155 142 195 46 116 110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(41, 119, NULL, '==Key==\r\n\r\nKey to the larvae of Paratanytarsus, encountered in the Netherlands by {citeID|14|Klink 1983}, revised by {citeID|393|Moller-Pillot 1990}:\r\n#a) 3 chaetulae labrales~... 3rd instar larvae&lt;br&gt;b) 5 chaetulae labrales (4th instar larvae)~-&gt; 2\r\n#a) {overlib|Pedicels as long as the lauterborn|&lt;img align=''middle'' width=80 title=''Paratanytarsus confusus (apex of antenna) Klink 1983'' src=''image.php?text=image deleted: Pata_conf_aan_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} organs they bear. {overlib|Pecten epipharyngis|&lt;img align=''middle'' width=80 title=''Paratanytarsus dissimilis (pecten epipharyngis) Epler 2001'' src=''image.php?text=image deleted: Pata_disi_pee_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} with 5 (rarely 6) teeth -&gt; 3&lt;br&gt;b) {overlib|Pedicels twice as short|&lt;img align=''middle'' width=80 title=''Paratanytarsus austriacus (apex of antenna) Klink 1983'' src=''image.php?text=image deleted: Pata_autr_aan_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} as the lauterborn organs they bear. Pecten epipharyngis with 3-4 teeth~-&gt; 4\r\n# Klink gives some differences between the larvae of P. inopertus and P.confusus. In my opinion all these differences are unreliable. Also the adults are difficult to separate. Therefore I prefere for the larvae to use the name~-&gt; P. dissimilis agg.\r\n#a) {overlib|Pecten epipharyngis|&lt;img align=''middle'' width=150 title=''Paratanytarsus austriacus (pecten epipharyngis) Klink 1983'' src=''image.php?text=image deleted: Pata_autr_pee_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} with 4 teeth. {overlib|L3 on segments 2-6|&lt;img align=''middle'' width=200 title=''Paratanytarsus austriacus (abdomen) Klink 1983'' src=''image.php?text=image deleted: Pata_autr_abd_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} more than half as long as L2. L4 on segment 7 subequal to the L2. Head {brownish} with 3 {yellow} bands -&gt; P. austriacus&lt;br&gt;b) Pecten epipharyngis with 3 (rarely 4) teeth. L 3 on segments 2-6 shorter (only in P. lauterborni half as long as L2). L4 on segment 7 much shorter than L2. Head {yellow} (rarely {brownish}-{yellow}) -&gt; 5\r\n#a) L2 on abdominal segments 1-7 bifid or branched (only visible in lactic acid)~-&gt; 6&lt;br&gt;b) L2 on abdominal segments 1-7 simple~-&gt; 7\r\n#a) L2 on segments 1-7 branched. L4 on segments 2-6 longer than L2. 4th antennal segment mostly longer than the 3rd. Pecten labralis with 30-34 teeth. -&gt; P.tenellulus&lt;br&gt;b) L2 on segments 1-7 bifid. L4 on segments 2-6 weakly developed. 4th antennal segment mostly shorter than the 3rd. Pecten labralis with 20-26 teeth-&gt; P. intricatus\r\n#a) Pecten labralis with 38-45 (rarely 34-37) teeth -&gt; P. grimmii&lt;br&gt;b) {overlib|Pecten labralis|&lt;img align=''middle'' width=250 title=''Paratanytarsus tenuis (labro-epipharyngeal region) Klink 1983'' src=''image.php?text=image deleted: Pata_teis_lab_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} with 16-26 teeth~-&gt; 8\r\n#a) {overlib|Lauterborn organs|&lt;img align=''middle'' width=80 title=''Paratanytarsus lauterborni (apex of antenna) Klink 1983'' src=''image.php?text=image deleted: Pata_laut_aan_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} taper gradually into a very long distal part. L2 on all abdominal segments long (more than 1/4 of segment length, nearly as long as the distance from L2 to L4)~-&gt; P. lauterborni&lt;br&gt;b) {overlib|Lauterborn organs|&lt;img align=''middle'' width=80 title=''Paratanytarsus tenuis (apex of antenna) Klink 1983'' src=''image.php?text=image deleted: Pata_teis_aan_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} taper abruptly into a very small distal part. L2 short, about 1/4 of segment length~-&gt; P. tenuis agg.\r\n\r\n==Characters Genus==\r\n\r\nComments {citeID|2|Pinder and Reiss 1983}: (...) The most characteristic feature of this genus is the \r\n*pecten epipharyngis which consist of 3-5 separate finger-like lobes. \r\nA similar form of pecten epipharyngis occours in Lithotanytarsus and Sublettea. However Lithotanytarsus has charcteristic conical projections mesally on the antennal pedestal and in Sublettea the Lauterborn organs are borne on pedicels which reach almoast to the antennal apex. wheras Paratanytarsus the Lauterborn organs are sessile or on very short pedicels.&lt;br&gt;\r\n\r\n\r\n{citeID|1|Heiri et.al. 2004}: In fossil-fourth instar larvae the combination of \r\n*a short antennal pedestals, \r\n*the absence of a spur, \r\n*the strongly reduced postoccipital plate and \r\n*the strongly incised ventral postoccipital margin\r\nwill often separate Paratanytarsus from other Tanytarsini.\r\n\r\nValid species of West Palaearctic Paratanytarsus not examined for this study (following {citeID|256|Ashe and Cranston 1991}): P. abiskoensis, P. bausellus, P. boemicus, P. chlorogyne, P. confusus, P. dimorphis, P. hyperboreus, P. inopertus, P. inquilinus, P. intricatus, P. laccophilus, P. laetipes, P. lauterborni, P. luteola, P. mediterraneus, P. natvigi, P. setosimanus, P. tenellulus, P. tenuis.\r\n{citeID|2|Pinder and Reiss 1983}: Mentum median tooth rounded or notched laterally; with 5 pairs of lateral teeth , more or less unicolorous, brown. Ventromental plates medially seperated by less than width of median tooth, slightly wider than mentum.\r\n\r\n{citeID|302|Brooks et.al. 2007}: Paratanytarsus could be confused with many other Tanytarsini but even badly damaged head capsules should be identifiable from the combination of\r\n*deeply incised post-occipital arch and short pedestral.\r\nSpecimens of Neozavrelia may also have this combination of characters but in this genus the fifthlateral tooth is absent or minuite. Paratanytarsus is similar in general appearence to Micropsectra radialis. Look carefully especially in small specimens, for the small spur, that is usually present in M.radialis but which is absent in Paratanytarsus.\r\n\r\n\r\n\r\n{| style=''border:1px solid;''\r\n|-\r\n!|Reference\r\n!im90|premandible\r\n!im90|premandible - brush\r\n!im90|posterior parapods\r\n!im90|postoccipital plate\r\n!im90|postoccipital margin\r\n!im90|antennal spur\r\n!im90|antenna - segment 1\r\n!im90|antenna - segment 2\r\n!im90|antennal pedestals\r\n!|mandible\r\n!im90|ventromental plates\r\n!im90|mentum median tooth\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}:\r\n|&lt;!-- pre --&gt;2\r\n|&lt;!-- pre brush --&gt;yes\r\n|&lt;!-- cpp --&gt;relatively few claws, 15-20, simple\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- pom --&gt;\r\n|&lt;!-- spur --&gt;no\r\n|&lt;!-- ant1 --&gt;basal ring organ\r\n|&lt;!-- ant2 --&gt;cylindrical or weakly expanded distally; distinctly &lt; 3rd\r\n|&lt;!-- anp --&gt;tall\r\n|&lt;!-- man --&gt;3/2-1-1-0\r\n|&lt;!-- vep --&gt;medially seperated by less than width of median tooth, slightly wider than mentum\r\n|&lt;!-- men med --&gt;rounded or notched laterally\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}:\r\n|&lt;!-- pre --&gt;\r\n|&lt;!-- pre brush --&gt;\r\n|&lt;!-- cpp --&gt;\r\n|&lt;!-- pop --&gt;strongly reduced\r\n|&lt;!-- pom --&gt;.incised\r\n|&lt;!-- spur --&gt;no\r\n|&lt;!-- ant1 --&gt;\r\n|&lt;!-- ant2 --&gt;\r\n|&lt;!-- anp --&gt;.&lt;br&gt;(=short)\r\n|&lt;!-- man --&gt;3/2-1-1-0\r\n|&lt;!-- vep --&gt;\r\n|&lt;!-- men med --&gt;\r\n\r\n|-\r\n|{citeID|302|Brooks et.al. 2007}:\r\n|&lt;!-- pre --&gt;2\r\n|&lt;!-- pre brush --&gt;\r\n|&lt;!-- cpp --&gt;\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- pom --&gt;.incised\r\n|&lt;!-- spur --&gt;no\r\n|&lt;!-- ant1 --&gt;\r\n|&lt;!-- ant2 --&gt;\r\n|&lt;!-- anp --&gt;1\r\n|&lt;!-- man --&gt;3/2-1-1-0\r\n|&lt;!-- vep --&gt;\r\n|&lt;!-- men med --&gt;\r\n\r\n|-\r\n|Plank annotations:\r\n|&lt;!-- pre --&gt;\r\n|&lt;!-- pre brush --&gt;\r\n|&lt;!-- cpp --&gt;\r\n|&lt;!-- pop --&gt;.&lt;br&gt;sometimes\r\n|&lt;!-- pom --&gt; to ++?\r\n|&lt;!-- spur --&gt;\r\n|&lt;!-- ant1 --&gt;\r\n|&lt;!-- ant2 --&gt;\r\n|&lt;!-- anp --&gt;\r\n|&lt;!-- man --&gt;\r\n|&lt;!-- vep --&gt;\r\n|&lt;!-- men med --&gt;\r\n\r\n|}\r\n\r\n\r\n\r\n==Characters specimens==\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default ''|Reference\r\n! class=''table-sortable:default ''|Type\r\n! class=''table-sortable:default ''|Taxa\r\n!im90 class=''table-sortable:default ''|Head\r\n!im90 class=''table-sortable:default ''|Postoccipital plate\r\n!im90 class=''table-sortable:default ''|Postoccipital margin\r\n!im90 class=''table-sortable:default ''|Antennal pedestal\r\n!im90 class=''table-sortable:default ''|Antennal spur\r\n!im90 class=''table-sortable:default ''|Antennal blade\r\n!im90 class=''table-sortable:default ''|Mandible\r\n!im90 class=''table-sortable:default ''|Pecten epipharyngis\r\n!im90 class=''table-sortable:default ''|Pecten labralis\r\n!im90 class=''table-sortable:default ''|Mentum\r\n!im90 class=''table-sortable:default ''|Ventromental plates\r\n!im90 class=''table-sortable:default ''|Abdomen\r\n!im90 class=''table-sortable:default ''|Parapods posterior\r\n!im90 class=''table-sortable:default ''|Lateral setae 2 (L2) on segments 1-7\r\n!im90 class=''table-sortable:default ''|Notes\r\n\r\n|-\r\n!|\r\n! class=''table-filterable ''|\r\n!|&lt;input name=''filterTaxa2'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterHead3'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterPostoccipital4'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterPostoccipital5'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAntennal6'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAntennal7'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAntennal8'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterMandible9'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterPecten10'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterPecten11'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterMentum12'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterVentromental13'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAbdomen14'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterParapods15'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterLateral16'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|1|Heiri et.al. 2004}\r\n|&lt;!--type--&gt;austriacus type\r\n|&lt;!--taxa--&gt;P.austriacus (Kieffer)\r\n|&lt;!--head--&gt; pigmented\r\n|&lt;!--postoccipital plate--&gt; reduced strongly\r\n|&lt;!--postoccipital margin--&gt;{dark}\r\n|&lt;!--antennal pedestal--&gt; 1-1.1 short\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt;?\r\n|&lt;!--mandible--&gt;3-1-1-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Paratanytarsus austriacus (mandible) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pata_autr_man_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--pecten epipharyngis--&gt;4 {citeID|12|Klink and Moller-Pillot 2003}\r\n|&lt;!--pecten labralis--&gt;?\r\n|&lt;!--mentum--&gt;all teeth &lt;span class=''dark''&gt;dark&lt;/span&gt;&lt;br&gt;&lt;img align=''middle'' width=200 title=''Paratanytarsus austriacus (mentum) Heiri et.al. 2004'' src=''image.php?text=image deleted: Pata_autr_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--ventromental plates--&gt;?\r\n|&lt;!--abdomen--&gt;?\r\n|&lt;!--post. parap.--&gt;?\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;?\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|12|Klink and Moller-Pillot 2003} {citeID|14|Klink 1983} \r\n|&lt;!--type--&gt;austriacus type\r\n|&lt;!--taxa--&gt;P.austriacus (Kieffer in Albrecht, 1924)\r\n|&lt;!--head--&gt; &lt;span class=''brownish''&gt;brownish&lt;/span&gt; + 3 &lt;span class=''yellow''&gt;yellow&lt;/span&gt; bands dorsal\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;small smooth\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt; &gt; 5th ; exceeds flagellum\r\n|&lt;!--mandible--&gt;3-1-1-0&lt;br&gt;\r\n|&lt;!--pecten epipharyngis--&gt;4\r\n|&lt;!--pecten labralis--&gt;20-26\r\n|&lt;!--mentum--&gt;median: simple/slightly notched&lt;br&gt;&lt;img align=''middle'' width=200 title=''Paratanytarsus austriacus (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pata_autr_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--ventromental plates--&gt; &gt; mentum (slightly); close together\r\n|&lt;!--abdomen--&gt;8mm\r\n|&lt;!--post. parap.--&gt;15 simple\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;1 simple, very long&lt;br&gt;&lt;img align=''middle'' width=40 title=''Paratanytarsus austriacus (lateral setae) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pata_autr_las_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|1|Heiri et.al. 2004}\r\n|&lt;!--type--&gt;penicillatus type\r\n|&lt;!--taxa--&gt;P.penicillatus (Goetghebuer)\r\n|&lt;!--head--&gt; pigmented\r\n|&lt;!--postoccipital plate--&gt; reduced\r\n|&lt;!--postoccipital margin--&gt;{dark}\r\n|&lt;!--antennal pedestal--&gt;1-1.1 short\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt;?\r\n|&lt;!--mandible--&gt;2-1-1-0 dark patch where third inner tooth should be&lt;br&gt;&lt;img align=''middle'' width=100 title=''Paratanytarsus penicillatus (mandible) Heiri et.al. 2004'' src=''image.php?text=image deleted: Pata_peni_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--pecten epipharyngis--&gt;3\r\n|&lt;!--pecten labralis--&gt;?\r\n|&lt;!--mentum--&gt;all teeth &lt;span class=''dark''&gt;dark&lt;/span&gt;, mentum convex&lt;br&gt;&lt;img align=''middle'' width=200 title=''Paratanytarsus penicillatus (mentum) Heiri et.al. 2004'' src=''image.php?text=image deleted: Pata_peni_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--ventromental plates--&gt;?\r\n|&lt;!--abdomen--&gt;?\r\n|&lt;!--post. parap.--&gt;?\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;?\r\n|&lt;!--notes--&gt;stronger striae at ventromental plates -&gt; Rheotanytarsus\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|1|Heiri et.al. 2004}\r\n|&lt;!--type--&gt;penicillatus type\r\n|&lt;!--taxa--&gt;P.bituberculatus (Edwards)\r\n|&lt;!--head--&gt; pigmented\r\n|&lt;!--postoccipital plate--&gt; reduced strongly\r\n|&lt;!--postoccipital margin--&gt;{brown}\r\n|&lt;!--antennal pedestal--&gt;1 short, conical\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt;?\r\n|&lt;!--mandible--&gt;2-1-1-0 dark&lt;br&gt;&lt;img align=''middle'' width=100 title=''Paratanytarsus bituberculatus (mandible) Heiri et.al. 2004'' src=''image.php?text=image deleted: Pata_bitu_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--pecten epipharyngis--&gt;?\r\n|&lt;!--pecten labralis--&gt;?\r\n|&lt;!--mentum--&gt;all teeth &lt;span class=''dark''&gt;dark&lt;/span&gt;, mentum convex&lt;br&gt;&lt;img align=''middle'' width=200 title=''Paratanytarsus bituberculatus (mentum) Heiri et.al. 2004'' src=''image.php?text=image deleted: Pata_bitu_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--ventromental plates--&gt;?\r\n|&lt;!--abdomen--&gt;?\r\n|&lt;!--post. parap.--&gt;?\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;?\r\n|&lt;!--notes--&gt;stronger striae at ventromental plates -&gt; Rheotanytarsus\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|12|Klink and Moller-Pillot 2003} {citeID|14|Klink 1983} \r\n|&lt;!--type--&gt;\r\n|&lt;!--taxa--&gt;P.intricatus (Goetghebuer, 1921) P.bilobatus (syn.)\r\n|&lt;!--head--&gt; {pale}\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;small smooth\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt; &lt; 2nd ; hardly reaching 2nd segment\r\n|&lt;!--mandible--&gt;3-1-1-0\r\n|&lt;!--pecten epipharyngis--&gt;3\r\n|&lt;!--pecten labralis--&gt;20-26\r\n|&lt;!--mentum--&gt;median: simple/slightly notched\r\n|&lt;!--ventromental plates--&gt; &gt; mentum (slightly); close together\r\n|&lt;!--abdomen--&gt;4mm\r\n|&lt;!--post. parap.--&gt;15 simple\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;2 bifid&lt;br&gt;&lt;img align=''middle'' width=100 title=''Paratanytarsus intricatus (abdomen) Klink 1983'' src=''image.php?text=image deleted: Pata_intr_abd_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|12|Klink and Moller-Pillot 2003}  \r\n|&lt;!--type--&gt;\r\n|&lt;!--taxa--&gt;P.grimmi (Schneider, 1885)\r\n|&lt;!--head--&gt; {pale}\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;small smooth\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt; = 4th segm.\r\n|&lt;!--mandible--&gt;3-1-1-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Paratanytarsus grimmii (mandible) Wang and Wang 1991'' src=''image.php?text=image deleted: Pata_grim_man_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;br&gt;{citeID|40|Wang and Wang 1991} has 2-1-1-0\r\n|&lt;!--pecten epipharyngis--&gt;3\r\n|&lt;!--pecten labralis--&gt;38-42\r\n|&lt;!--mentum--&gt;median: simple/slightly notched&lt;br&gt;&lt;img align=''middle'' width=200 title=''Paratanytarsus grimmii (mentum) Wang and Wang 1991'' src=''image.php?text=image deleted: Pata_grim_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--ventromental plates--&gt; &gt; mentum (slightly); close together\r\n|&lt;!--abdomen--&gt;6mm\r\n|&lt;!--post. parap.--&gt;15 simple\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;1 simple\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|12|Klink and Moller-Pillot 2003} {citeID|14|Klink 1983} \r\n|&lt;!--type--&gt;\r\n|&lt;!--taxa--&gt;P.lauterborni (Kieffer, 1909)\r\n|&lt;!--head--&gt; {pale} to &lt;span class=''brownish''&gt;brownish&lt;/span&gt;-&lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;small smooth\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt; = 5th segm.\r\n|&lt;!--mandible--&gt;3-1-1-0\r\n|&lt;!--pecten epipharyngis--&gt;3\r\n|&lt;!--pecten labralis--&gt;20-26\r\n|&lt;!--mentum--&gt;median: simple/slightly notched\r\n|&lt;!--ventromental plates--&gt; &gt; mentum (slightly); close together\r\n|&lt;!--abdomen--&gt;7mm\r\n|&lt;!--post. parap.--&gt;15 simple\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;1 simple&lt;br&gt;&lt;img align=''middle'' width=100 title=''Paratanytarsus lauterborni (abdomen) Klink 1983'' src=''image.php?text=image deleted: Pata_laut_abd_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|12|Klink and Moller-Pillot 2003} {citeID|14|Klink 1983} \r\n|&lt;!--type--&gt;\r\n|&lt;!--taxa--&gt;P.tenellulus (Goetghebuer, 1921)\r\n|&lt;!--head--&gt; {pale}\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;small smooth\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt; &lt; 5th segm., reaches the 5th base\r\n|&lt;!--mandible--&gt;3-1-1-0\r\n|&lt;!--pecten epipharyngis--&gt;3\r\n|&lt;!--pecten labralis--&gt;30-34\r\n|&lt;!--mentum--&gt;median: simple/slightly notched\r\n|&lt;!--ventromental plates--&gt; &gt; mentum (slightly); close together\r\n|&lt;!--abdomen--&gt;6mm\r\n|&lt;!--post. parap.--&gt;15 simple\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;1 simple but branched distally&lt;br&gt;&lt;img align=''middle'' width=40 title=''Paratanytarsus tenellus (lateral setae) Klink 1983'' src=''image.php?text=image deleted: Pata_tene_las_Kli1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|6|Epler 2001} \r\n|&lt;!--type--&gt;dissimilis\r\n|&lt;!--taxa--&gt;P.dissimilis ({citeID|328|Johannsen 1905})\r\n|&lt;!--head--&gt; ?\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt;\r\n|&lt;!--mandible--&gt;?\r\n|&lt;!--pecten epipharyngis--&gt;5\r\n|&lt;!--pecten labralis--&gt;\r\n|&lt;!--mentum--&gt;median: simple/slightly notched&lt;img align=''middle'' width=200 title=''Paratanytarsus dissimilis (mentum) Epler 2001'' src=''image.php?text=image deleted: Pata_disi_men_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|&lt;!--ventromental plates--&gt; &lt; mentum (slightly); close together\r\n|&lt;!--abdomen--&gt;?\r\n|&lt;!--post. parap.--&gt;?\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|14|Klink 1983}\r\n|&lt;!--type--&gt;dissimilis\r\n|&lt;!--taxa--&gt;P.inopertus (Walker)\r\n|&lt;!--head--&gt;{yellow}\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;?\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt;= 5th segment \r\n|&lt;!--mandible--&gt;?\r\n|&lt;!--pecten epipharyngis--&gt;5\r\n|&lt;!--pecten labralis--&gt;20-26\r\n|&lt;!--mentum--&gt;?\r\n|&lt;!--ventromental plates--&gt;\r\n|&lt;!--abdomen--&gt;?\r\n|&lt;!--post. parap.--&gt;?\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;1 simple long (150&micro;m)\r\n|&lt;!--notes--&gt;for {citeID|393|Moller-Pillot 1990} P.inopertus and P.confusus not reliable as differable taxa. He recommends therefore P.dissimilis agg.\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|14|Klink 1983}\r\n|&lt;!--type--&gt;dissimilis\r\n|&lt;!--taxa--&gt;P.confusus Palmen\r\n|&lt;!--head--&gt;{yellow}\r\n|&lt;!--postoccipital plate--&gt;?\r\n|&lt;!--postoccipital margin--&gt;?\r\n|&lt;!--antennal pedestal--&gt;?\r\n|&lt;!--antennal spur--&gt;no\r\n|&lt;!--antennal blade--&gt;= 5th segment \r\n|&lt;!--mandible--&gt;?\r\n|&lt;!--pecten epipharyngis--&gt;5\r\n|&lt;!--pecten labralis--&gt;16-26\r\n|&lt;!--mentum--&gt;?\r\n|&lt;!--ventromental plates--&gt;\r\n|&lt;!--abdomen--&gt;?\r\n|&lt;!--post. parap.--&gt;?\r\n|&lt;!--lateral setae 2 on segments 1-7--&gt;1 simple relatively short (100&micro;m)\r\n|&lt;!--notes--&gt;for {citeID|393|Moller-Pillot 1990} P.inopertus and P.confusus not reliable as differable taxa. He recommends therefore P.dissimilis agg.\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n==Checklist China==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.dissimilis? ({citeID|328|Johannsen 1905})\r\n*P.inopterus (Walker) male \r\n*P.lauterborni? (Kieffer)\r\n*P.parthenogeneticus (Freeman) female\r\n*P.penicillatus (Goetghebuer) male female\r\n*P.sinensis Guha and Chaudhuri male\r\n*P.tenellulus (Goetghebuer) male\r\n*P.tenuis (Meigen) male female\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Paratanytarsus as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Paratanytarsus hyperboreus Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paratanytarsus natvigi (Goetgh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paratanytarsus penicillatus Goetgh. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** || || || || || || || || ||***** &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\n{textciteID|507|Brooks and Birks 2000}:\r\n*8 have statistically significant (Template:HOF:sigmoidalUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Paratanytarsus  and other taxa to find possible differences in temperature: 2000: 12.9&deg;C &plusmn; 4.5 (8.4 to 17.4), 2006: 12.8&deg;C &plusmn; 5.4 (7.4 to 18.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nParatanytarsus sp. reported by {textciteID|516|Korhola et al. 2002} as intermediate taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Paratanytarsus  and other taxa: 8.7&deg;C &plusmn; 2.5, n=92 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n===Conductivity/Salinity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Paratanytarsus in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 1409.85mg &middot; l⁻&sup1; (&divide; 600 = 2.35mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 14.7736. In article shortened as: Pt.\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Paratanytarsus sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Paratanytarsus sp.  and other taxa: 6.5m &plusmn; 4.7 (n=35). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', '170 88 207 70 96 1507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(42, 121, NULL, '''''{citeID|2|Pinder and Reiss 1983}:'''' small to medium sized larvae, 4-8 mm long. Color deep {red} with 2 pairs of eyes close touching. \r\n*Antenna with 6 Segments Ring organ situated in proximal 1/3-1/4 of basal segment. Blade mostly shorter than flagellum; accessory blade moderately long. Lauterborn organs present on segments 2 and 3. Style seated on segment 3. \r\n*Mandible with strong pale dorsal tooth an 2 distinct inner teeth.\r\n*Body lateral and ventral tubles absent.\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.albimanus (Meigen) male {overlib|mentum|&lt;img align=''middle'' title=''Paratendipes albimanus (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pate_albi_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*P.nigrofasciatus Kieffer male female\r\n*P.nudisquama Edwards male female {overlib|mentum|&lt;img align=''middle'' title=''Paratendipes nudisquama (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pate_nusq_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Paratendipes as ubiquitous taxa in a lentic-lotic gradient in France.\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Paratendipes (n=9, Template:explained:N2:HillsDiversity=7.1, n&lt;sub&gt;max&lt;/sub&gt;=5.32) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 24.\r\n\r\n===Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Paratendipes sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(43, 122, NULL, '{| frame=border \r\n|-\r\n!|reference\r\n!im90|head\r\n!im90|head - postoccipital margin\r\n!im90|antenna\r\n!im90|antenna - blade\r\n!|s1\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!im90|mandible\r\n!im90|mandible - seta subdentalis\r\n!im90|mandible - seta interna\r\n!im90|ventromental plates\r\n!im90|mentum - median\r\n!im90|mentum - lateral\r\n!im90|mentum - pattern\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;!-- head --{yellow} to &lt;span class=''darkbrown''&gt;darkbrown&lt;/span&gt;\r\n|&lt;!-- head pom --&gt;pale to black\r\n|&lt;!-- ant --&gt;5\r\n|&lt;!-- ant blade --&gt;not extending beyond the flagellum\r\n|&lt;!-- s1 --&gt;bifid or with lat. serrations: simple or bifid\r\n|&lt;!-- pee --&gt;3 slender scales\r\n|&lt;!-- pre --&gt;1-2\r\n|&lt;!-- man --&gt;3/4-1-0-0&lt;br&gt; at the base several toothlets\r\n|&lt;!-- man s subdent --&gt;peg-like\r\n|&lt;!-- man s interna --&gt;5-6 apically serrated branches\r\n|&lt;!-- vep --&gt;rounded ''shoulder'' on base, seta submenti always median of ventromental base\r\n|&lt;!-- men mid --&gt;1 \r\n|&lt;!-- men lat --&gt;6\r\n|&lt;!-- men pat --&gt;2nd pair smaller than 1st or 3rd\r\n\r\n|}\r\n&lt;br&gt;\r\n\r\n\r\n{citeID|21|Cranston et.al. 1983}: Larvae of Paratrichocladius are separeted with difficulty from some Cricotopus (Cricotopus) and Orthocladius. \r\n*the outer margins of the mandible is smoothor very weakly crenulate  wich distinguishes Paratrichocladius from those Cricotopus and Orthocladius which have a distinctly crenulates outer margin,\r\n*the body lacks setal tuffs which is characteristic in most Cricotopus. \r\n*the first lateral tooth of the mentum is wider in the middle than at the base,\r\n*generally the first lateral tooth of Cricotopus and Orthocladius is the widest at the base or in some species appressed to either the median or second lateral tooth,\r\n*a seta interna on the mandible is present in all species of Paratrichocladius contrary to that stated by {citeID|29|Hirvenoja 1973}.&lt;br&gt;\r\n\r\nIn China {citeID|279|Wang 2000}:\r\n*P.ater Wang and Zeng male\r\n*P.hamatus Wang and Zeng male\r\n*P.rufiventris (Meigen) male\r\n*P.sp. male female', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Paratrichocladius as lotic taxa in a lentic-lotic gradient in France.\n', '31 1505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(44, 125, NULL, NULL, 1, NULL, '166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(45, 130, NULL, '==Comments ==\r\n\r\n{citeID|288|Fittkau and Roback 1983}: Procladius is closely related to Djalmabatista. The latter is recognizable, amongst other characters, by the very large accessory blade on the antenna, mor than 2x length of flagellum. ''''''Both'''''' genera differ from all other genera of Tanypodinae with\r\n*ventromental plates, in the \r\n*{overlib|ligula|<img src=''image.php?text=Image reduced version. Deleted: Prcl_chor_lig_Ser1996_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Prcl_chor_lig_Ser1996_r.gif 2009-12-15 10:36:17''>} which is {blackish brown} over the distal 1/2, and the\r\n*large, blunt basal tooth of the {overlib|mandible|<img src=''image.php?text=Image reduced version. Deleted: Prcl_chor_mandet_Ser1996_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Prcl_chor_mandet_Ser1996_r.gif 2009-12-15 10:36:17''>}.\r\n\r\n==Checklist China==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*Subgenus Holotanypus Roback\r\n**P.choreus ({citeID|337|Meigen 1804}) {overlib|head setation|<img src=''image.php?text=Image reduced version. Deleted: Prcl_chor_hes_Rie2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Prcl_chor_hes_Rie2001_r.gif 2009-12-15 10:36:17''>}\r\n**P.crassinervis (Zetterstedt)\r\n**P.culiciformis (?) (Linn&eacute;)\r\n**P.denticulatus (?) Sublette\r\n**P.insularis (Kieffer)\r\n**P.iris (Kieffer)\r\n**P.lacteiclava (Kieffer)\r\n**P.nipponicus Tokunaga\r\n**P.sagittalis (Kieffer)\r\n*Subgenus Psilotanupus Kieffer\r\n**P.lugens (Kieffer)\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''one''\r\n|-\r\n!|reference\r\n!im|taxon\r\n!im|head\r\n!im|head (L:W)\r\n!im|antennal ratio (1 to remaining)\r\n!im|ligula\r\n!im|premandible\r\n!im|pecten hypopharynx\r\n!im|mandible\r\n\r\n|-\r\n|&lt;!--reference--&gt;{citeID|288|Fittkau and Roback 1983}\r\n|&lt;!--taxon--&gt;Procladius Skuse\r\n|&lt;!--head --&gt;{whitish} oval\r\n|&lt;!--head (L:W)--&gt;1.176-1.25\r\n|&lt;!--antennal ratio--&gt;3.5-5-0\r\n|&lt;!--ligula--&gt;5 apex &lt;span class=''darkbrown''&gt;blackish brown&lt;/span&gt;\r\n|&lt;!--premandible--&gt;1\r\n|&lt;!--pecten hypopharynx--&gt;10-15\r\n|&lt;!--mandible--&gt;uniformly curved\r\n\r\n|}\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Phaenopsectra as ubiquitous taxa in a lentic-lotic gradient in France.\r\n\r\n===Temperature===\r\n\r\n{textciteID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#ff0000"&gt;warm water&lt;/span&gt; Cricotopus sp., Procladius, Chironomus anthracinus-group, Dicrotendipes, Microtendipes chloris, Polypedilum cf. nebeculosum [sic]\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Procladius-group  and other taxa: 0&deg;C &plusmn; 0, n=80 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\n{textciteID|492|Brodersen et al. 2004}: Warm-water chironomid assemblages characterized by taxa such as Chironomus, Dicrotendipes, Ablabesmyia, and Procladius had a high oxy-regulatory capacity.\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Procladius  and other taxa to find possible differences in temperature: 2000: 14.1&deg;C &plusmn; 3.4 (10.7 to 17.6), 2006: 14.5&deg;C &plusmn; 3.9 (10.7 to 18.4) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here&lt;/a&gt;.\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Procladius (n=33, Template:explained:N2:HillsDiversity=18.43, n&lt;sub&gt;max&lt;/sub&gt;=27.27) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 29.\r\n\r\n===Conductivity/Salinity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Procladius in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 13809.84mg &middot; l⁻&sup1; (&divide; 600 = 23.02mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 6.17679. In article shortened as: Pr.\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Procladius sp. (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Procladius the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '215 220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(46, 132, NULL, 'Propsilocerus has a ''''bifid'''' premandible, wheras that of Tokunagayusurika is simple. Also Propsilocerus has anormal shaped head capsule, and Tokunagayusurika has a pear-shaped head capsule ({citeID|21|Cranston et.al. 1983})<br>\r\n{citeID|270|Wang and Sæther 2001}:\r\n;Propsilocerus paradoxus (Lundström): the larva can be separated from other larvae of the genus except of the larvae P. lacustris by having a 4-segmented antenna combined with a metum with 7 pairs of gradually smaller lateral teeth. It differs from P. lacustris by baving S1 plumose on both sides and not just apically.\r\n;Propsilocerus sinicus Sæther and Wang: the larva can be separated from other larvae of the genus by having a 5-segmented antenna, reduced anterior parapods and only about 8 claws on each posterior parapod. The mentum has 7 pairs of lateral teeth of which the 5th and 6th are larger than the 5th, and 7th appears as a small basal nothch.\r\n\r\n<hr>\r\nKey from {citeID|284|Tang et.al. 2004} for all immature stages:<br>\r\n# - Antenna with 5 segments, S1 plumose on ''''one'''' side ... P.sinicus Sæther & Wang<br>- Antenna with 4 segments, S1 plumose on ''''both'''' sides ... 2\r\n# - Mentum with 6-7 pairs of lateral dorsomental teeth ... 3<br>- Mentum with 9-10 pairs of lateral dorsomental teeth ... 4\r\n# - Mentum with 6 pairs of lateral teeth, first lateral tooth distinctly shorter than the second. Four median mental teeth subequal in size ... P.lacustris Kieffer<br>- Mentum with 7 pairs of lateral teeth, first lateral tooth larger than the second, one median tooth larger than the other 3 teeth remarkably ... P.paradoxus (Lundström)\r\n# - Median portion of mentum concave with one strong lateral pair and 4-10 minute sharply triangular teeth ... P.jacutis (Zevereva)<br>- Median portion of mentum approximately straight with fewer teeth ... 5\r\n# - 3th and 4th antennal segment  aubequal in legth;mentum with 9-10, usually 9, pairs of lateral teeth ... P.akamusi (Tokunga)<br>- 4th antennal segment 1.5-2 times longer than 3rd, mentum with 10 pairs of lateral teeth ... P.taihuensis (Wen, Zhou & Rong)', 1, NULL, '206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(47, 232, NULL, '==Genus==\r\n\r\n\r\n{| style=''border-style:solid;border-width:1px;''\r\n\r\n|-\r\n!|Reference\r\n!im|premandible\r\n!im|premandible (brush)\r\n!im|parapods - posterior\r\n!im|labrum seta S1\r\n!im90|head - postoccipital plate\r\n!im90|head - postoccipital margin\r\n!im90|antenna pedestals\r\n!|mandible\r\n!im|mandible notes\r\n!im|ventromental plates\r\n!im90|mentum - middle tooth\r\n!im90|mentum - lateral tooth\r\n\r\n\r\n|-\r\n|&lt;!-- ref --&gt;{citeID|2|Pinder and Reiss 1983}:\r\n|&lt;!-- pre --&gt;1\r\n|&lt;!-- pre brush --&gt;no\r\n|&lt;!-- parap post --&gt;divided, simple claws\r\n|&lt;!-- lab s1 --&gt;palmate&lt;br&gt;3-10 lobes\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- pom --&gt;\r\n|&lt;!-- anp --&gt;\r\n|&lt;!-- man --&gt;3-1-0-0\r\n|&lt;!-- man notte --&gt;apical tooth slightly shorter than or up to 4x longer than combined width of inner teeth\r\n|&lt;!-- vep --&gt;broad with straight lateral margin, extincting beyond outer tooth of flattened mentum; beared\r\n|&lt;!-- men mid. --&gt;1-2\r\n|&lt;!-- men lat. --&gt;\r\n\r\n|}\r\n\r\n\r\n==Specimens==\r\n\r\n\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default '' |Reference\r\n! class=''table-sortable:default '' |species\r\n!im90 class=''table-sortable:default '' |head - color\r\n!im90 class=''table-sortable:default '' |head - width\r\n!im90 class=''table-sortable:default '' |antenna - AR\r\n!im90 class=''table-sortable:default '' |antenna - segment 1\r\n!im90 class=''table-sortable:default '' |labrum - seta S1\r\n! class=''table-sortable:default '' |mandible\r\n!im90 class=''table-sortable:default '' |mandible: length 1 to 3 inner\r\n!im90 class=''table-sortable:default '' |mandible - seta interna\r\n!im class=''table-sortable:default '' |mentum - middle teeth\r\n!im class=''table-sortable:default '' |mentum - beard\r\n!im class=''table-sortable:default '' |procerus - setae\r\n\r\n|-\r\n!|&lt;input name=''filterReference0'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterspecies1'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterhead2'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterhead3'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterantenna4'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterantenna5'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterlabrum6'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filtermandible7'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filtermandible8'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filtermandible9'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filtermentum10'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filtermentum11'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterprocerus12'' size=''3'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(P.) barbimanus ({citeID|276|Edwards 1929})&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_men_Tsa1999_r.gif 2009-12-15 10:36:17''> &lt;!-- species --&gt;\r\n|{yellow} {citeID|427|Thienemann 1937}&lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|? &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, narrow, height hardly &gt;== 1st lateral tooth &lt;!-- mentum middle teeth --&gt;\r\n|yes &lt;!-- mentum - beard --&gt;\r\n|7: size identical &lt;!-- procerus --&gt;\r\n\r\n\r\n|-\r\n|{citeID|12|Klink and Moller-Pillot 2003}\r\n|P.(P.) barbimanus ({citeID|276|Edwards 1929})&lt;br&gt; &lt;!-- species --&gt;\r\n|{yellow} {citeID|427|Thienemann 1937}&lt;!-- head color --&gt;\r\n|600-700 &lt;!-- head width --&gt;\r\n|2.5-3 &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|7-9 &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|1&lt;br&gt;(is about as long as the combined inner teeth) &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, narrow, height hardly &gt; 1st lateral tooth &lt;!-- mentum middle teeth --&gt;\r\n|yes: 10 &lt;!-- mentum - beard --&gt;\r\n|7 &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|474|Tang 2006}\r\n|P.(P.) barbimanus ({citeID|276|Edwards 1929})&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_men_Tan2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_men_Tan2006_r.gif 2009-12-15 10:36:17''> &lt;!-- species --&gt;\r\n|{yellow} {citeID|427|Thienemann 1937}&lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|? &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, narrow, height hardly &lt;== 1st lateral tooth &lt;!-- mentum middle teeth --&gt;\r\n|yes &lt;!-- mentum - beard --&gt;\r\n|? &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|244|Cranston 1982}\r\n|P.(P.) barbimanus ({citeID|276|Edwards 1929})&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_men_Cra1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_men_Cra1982_r.gif 2009-12-15 10:36:17''> &lt;!-- species --&gt;\r\n|{yellow} {citeID|427|Thienemann 1937}&lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|? &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, narrow, height = 1st lateral tooth &lt;!-- mentum middle teeth --&gt;\r\n|yes &lt;!-- mentum - beard --&gt;\r\n|? &lt;!-- procerus --&gt;\r\n\r\n\r\n|-\r\n|{citeID|42|Ye and Wang 1982}\r\n|P.(P.) barbimanus ({citeID|276|Edwards 1929})&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_men_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_men_Ye1982_r.gif 2009-12-15 10:36:17''> &lt;!-- species --&gt;\r\n|{yellow} {citeID|427|Thienemann 1937}&lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|1.86 &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|8 &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|0.82 &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, narrow, height hardly &gt;== 1st lateral tooth &lt;!-- mentum middle teeth --&gt;\r\n|yes &lt;!-- mentum - beard --&gt;\r\n|7: size identical &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{textciteID|22|Makarchenko 1999}, {textciteID|449|Zelentsov and Makarchenko 1988}, {textciteID|350|Akhorov 1977}\r\n|P.(P.) pancratovae {textciteID|350|Akhorov 1977}&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_panc_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|{brown} &lt;!-- head color --&gt;\r\n|450-516 &micro;m &lt;!-- head width --&gt;\r\n|2.0-2.3 &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|10-15 lobes &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|&lt; (lower) &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, narrow, width = or hardly more 1st lateral &lt;!-- mentum middle teeth --&gt;\r\n|4-8 hairs &lt;!-- mentum - beard --&gt;\r\n|7: 5 long + 2 short &lt;!-- procerus --&gt;\r\n|-\r\n\r\n|{textciteID|22|Makarchenko 1999}\r\n|P.(P.) sokolovae {textciteID|449|Zelentsov and Makarchenko 1988}&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_soko_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|{yellow} &lt;!-- head color --&gt;\r\n|560-595 &micro;m &lt;!-- head width --&gt;\r\n|2.7-3.0 &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|7-10 lobes &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|&lt; (lower) &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, narrow, width = or hardly more 1st lateral &lt;!-- mentum middle teeth --&gt;\r\n|9-15 hairs &lt;!-- mentum - beard --&gt;\r\n|7: 5 long + 2 short &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(P.) zetterstedti Brundin, 1949&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_zett_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|? &lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|? &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|= (equal) &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, width &gt; 1.5x 1st lateral &lt;!-- mentum middle teeth --&gt;\r\n|yes &lt;!-- mentum - beard --&gt;\r\n|5: 5 (identical size) &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(P.) sordidellus (Zetterstedt, 1838)&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|? {yellow}, POP/POM {pale} or {yellow} (pers. com. Hongqu Tang, Korea)&lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|6-8 {citeID|21|Cranston et.al. 1983} {citeID|20|Schmid 1993} &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, (note: much higher than 1st lateral) rounded chamfered apex, cut in the middle well expressed, 1.5-1.8x base 1st lateral tooth; {citeID|6|Epler 2001}: median teeth apically pointed; mandible almost completely {dark brown}-{black} &lt;!-- mentum middle teeth --&gt;\r\n|4-8 short hairs (35-55 &micro;m) &lt;!-- mentum - beard --&gt;\r\n|7:5 long thick, 2 shorter &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{textciteID|449|Zelentsov and Makarchenko 1988}\r\n|P.(P.) fennicus {textciteID|450|Stor&aring; 1939}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_fenn_men_Zel1988_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_fenn_men_Zel1988_r.gif 2009-12-15 10:36:17''> &lt;!-- species --&gt;\r\n|&lt;!-- head color --&gt;\r\n|360-390 &lt;!-- head width --&gt;\r\n|2.2 &lt;!-- ant AR --&gt;\r\n|90-96 &lt;!-- ant1 --&gt;\r\n|8-10 &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, &lt;!-- mentum middle teeth --&gt;\r\n|4-8 short hairs (35-55 &micro;m) &lt;!-- mentum - beard --&gt;\r\n|7:4 long thick, 3 shorter &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(P.) ventricosus Kieffer, 1925&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_veco_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|? &lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|? &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, (note: much higher than 1st lateral) rounded chamfered apex, cut in the middle well expressed, 1.9-2x base 1st lateral tooth &lt;!-- mentum middle teeth --&gt;\r\n|4-8 short hairs (35-55 &micro;m) &lt;!-- mentum - beard --&gt;\r\n|7:5 long thick, 2 shorter &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(P.) nevalis Akhrorov, 1977&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_neva_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|? &lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|102-132 &micro;m &lt;!-- ant1 --&gt;\r\n|6-10 blades &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, lower than the 1st lateral &lt;!-- mentum middle teeth --&gt;\r\n|10-15 hairs &lt;!-- mentum - beard --&gt;\r\n|7 in length identical setae  &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(P.) ishimicus Tshernovskij, 1949&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_ishi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|? &lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|? &lt;!-- ant AR --&gt;\r\n|87-95 &micro;m &lt;!-- ant1 --&gt;\r\n|4-5 blades &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, lower than the 1st lateral &lt;!-- mentum middle teeth --&gt;\r\n|5-8 hairs &lt;!-- mentum - beard --&gt;\r\n|7 in length identical setae  &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(P.) versatilis Linevitsh, 1963&lt;br&gt;&lt;img src=''image.php?text=image deleted: PsclPs_vers_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' width=160&gt; &lt;!-- species --&gt;\r\n|? &lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|2.1-2.3 &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|? &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|= (equal) &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2, considerably higher than the first lateral teeth &lt;!-- mentum middle teeth --&gt;\r\n|yes &lt;!-- mentum - beard --&gt;\r\n|? &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|P.(A.) obvius ({citeID|309|Walker 1856})&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclAl_obvi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclAl_obvi_men_Tsa1999_r.gif 2009-12-15 10:36:17''> &lt;!-- species --&gt;\r\n|? &lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|3.77 &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|3-4 &lt;!-- labrum - seta S1 --&gt;\r\n|3-1-0-0 &lt;!-- mandible --&gt;\r\n|2  &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|yes &lt;!-- set interna man --&gt;\r\n|2 (2 slightly notched or 1 very broad with a noched hump ;-)) &lt;!-- mentum middle teeth --&gt;\r\n|15-20? &lt;!-- mentum - beard --&gt;\r\n|7 ({citeID|42|Ye and Wang 1982}) &lt;!-- procerus --&gt;\r\n\r\n|-\r\n|{citeID|40|Wang and Wang 1991}\r\n|P.(P.) limbatellus ({citeID|263|Holmgren 1869})&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_limb_men_Cra1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_limb_men_Cra1982_r.gif 2009-12-15 10:36:17''>&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_limb_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_limb_men_WSD1991_r.gif 2009-12-15 10:36:17''>&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: PsclPs_limb_men_MPb1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_limb_men_MPb1984_r.gif 2009-12-15 10:36:17''> &lt;!-- species --&gt;\r\n|? POP/POM {brown} (pers. com. Hongqu Tang, Korea)&lt;!-- head color --&gt;\r\n|? &lt;!-- head width --&gt;\r\n|2.8 &lt;!-- ant AR --&gt;\r\n|? &lt;!-- ant1 --&gt;\r\n|? &lt;!-- labrum - seta S1 --&gt;\r\n|? &lt;!-- mandible --&gt;\r\n|? &lt;!-- mandible 1 st to 3 inner --&gt;\r\n|? &lt;!-- set interna man --&gt;\r\n|2 &lt;!-- mentum middle teeth --&gt;\r\n|6 &lt;!-- mentum - beard --&gt;\r\n|7 {citeID|244|Cranston 1982} &lt;!-- procerus --&gt;\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n''''mandible:'''' sometimes it looks like 4 inner teeth (Plank)\r\n\r\n\r\n==Key==\r\n\r\n\r\nThe given key was translated by [[http://babelfish.altavista.com/tr]] from {citeID|22|Makarchenko 1999}:&lt;br&gt;\r\n;1(4): {overlib|Seta interna|<img src=''image.php?text=Image reduced version. Deleted: PsclAl_obvi_man_Tsa1999_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclAl_obvi_man_Tsa1999_r.jpg 2009-12-15 10:36:17''>} from mandible usually absent; apical tooth {yellow} with dark apex, more than 1.8x longer than the span width of the base of three dark internal teeth. Mentum trapezoidal, with 1 very wide and low middle tooth, in the center with 2 small semicircular kinks or 2 hardly noticeable projections, divided by short or weak groove. 2 distinct setae at the base of preanal procerus\r\n;2(3): {overlib|&lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt; equal or more than 3|<img src=''image.php?text=Image reduced version. Deleted: PsclAl_obvi_ant_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclAl_obvi_ant_Tsa1999_r.gif 2009-12-15 10:36:17''>}.  {overlib|S1 of labrum is split to 2-4|<img src=''image.php?text=Image reduced version. Deleted: PsclAl_obvi_lab_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclAl_obvi_lab_Tsa1999_r.gif 2009-12-15 10:36:17''>} wide short blades. {overlib|Apical tooth of mandibles 2.2-2.5 times|<img src=''image.php?text=Image reduced version. Deleted: PsclAl_obvi_man_Tsa1999_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclAl_obvi_man_Tsa1999_r.jpg 2009-12-15 10:36:17''>} longer than the span of the base of three internal teeth~-&gt; subgenus Allopsectrocladius W&uuml;lker, 1956. In Russia distribution of 1 holarctic species P.(A.) obvius (Walker, 1856). They live in the littoral of lakes, reservoirs and the small standing reservoirs.\r\n;3(2): {overlib|&lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt; less than 2.2|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_panc_ant_Akh1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_panc_ant_Akh1977_r.gif 2009-12-15 10:36:17''>}. {overlib|S1 with 6-9|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_set_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_set_Sch1993_r.gif 2009-12-15 10:36:17''>} long and narrow blades. Apical tooth of mandible of approximately 1.8 times of longer than the span of the base of three internal teeth~-&gt; subgenus Mesopsectrocladius Laville, 1971. In Russia it is probable.\r\n;4(1): {overlib|Seta interna|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_octocf_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_octocf_man_Sch1993_r.gif 2009-12-15 10:36:17''>} of mandibles is present; apical tooth {dark brown} or {yellow} with dark apex, it is less than 1.8 times longer than the span of three internal teeth. Mentum is almost triangular, with 1-2 middle teeth, which are raised above the first lateral teeth; the apex of middle teeth in specific different structure. Procerus with 1-6 small setae.\r\n;5(6): {overlib|Mentum with 1 middle tooth|<img src=''image.php?text=Image reduced version. Deleted: PsclMo_sept_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclMo_sept_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}, which with the five- or trident apex (second teeth frequently they are erased and five-toothed apex it appears trident) or with 1 triangular projection in the middle, &lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt; approximately 1.5~-&gt; Monopsectrocladius W&uuml;lker, 1956. In Russia this subgenus is certainly a fraction of doubt and can be attributed  to P.(M.) septentrionalis Tshernovskij, 1949. It is known only on the larva from the European part of Russia. They live in the littoral of lakes.\r\n;6(5): {overlib|Mentum with 2 middle teeth|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_men_Sch1993_r.gif 2009-12-15 10:36:17''>} or with {overlib|1 middle tooth and a pair of mammilliform projections|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_bise_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_bise_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} in the middle~-&gt; species of genus Psectrocladius W&uuml;lker, 1956\r\n;7(12):{overlib|Mentum with 1 middle tooth|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_vers_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_vers_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}.\r\n;8(9): &lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt;=2.1-2.3; length of the apical tooth of mandibles are equal to the span of the base of three internal teeth. {overlib|Middle tooth of mentum considerably higher than the first lateral teeth|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_vers_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_vers_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}, its width is equal to the span of the first four lateral teeth~-&gt; P.(P.) versatilis Linevitsh, 1963\r\n;9(8): &lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt;=2.5-3.1, {overlib|length of the apical tooth of mandibles is more than 1.2 times|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_simu_man_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_simu_man_Tsa1999_r.gif 2009-12-15 10:36:17''>} it is more than the span of the base of three internal teeth. {overlib|Middle tooth of mentum only hardly higher|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_simu_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_simu_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} than first lateral, its width is equal to the span of five lateral teeth.\r\n;10(11): length of the basal member of the antenna of 108-123&micro;m. The {overlib|beard of ventro-mental plates with 5-6 hairs|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_bise_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_bise_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}~-&gt; P.(P.) bisetus Goetghebuer, 1942\r\n;11(10): length of the basal segment of antenna 132-168&micro;m. The {overlib|beard of ventro-mental plates|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_simu_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_simu_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} with 15-20 hairs ({citeID|474|Tang 2006}: &lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt;=3.5, S1 ?4-5)~-&gt; P.(P.) simulans (Johansen, 1937)\r\n;12(7): {overlib|Mentum with 2 middle teeth.|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}\r\n;13(22): {overlib|Middle teeth of mentum narrow|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_panc_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_panc_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}, width of one of the middle teeth is equal or hardly more than the width of the base of the first lateral tooth. The {overlib|length of the apical tooth of mandibles is lower|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_panc_man_Akh1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_panc_man_Akh1977_r.gif 2009-12-15 10:36:17''>} than the span of the base of three internal teeth.\r\n;14(17): {overlib|Procerus with 5 long thick and 2|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_panc_prc_Akh1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_panc_prc_Akh1977_r.gif 2009-12-15 10:36:17''>} shorter thin setae.\r\n;15(16): Head capsule is {brown}, its width 450-516&micro;m. &lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt;=2.0-2.2. S1 of labrum is split to 10-15 blades. The {overlib|beard of ventromental plates with 7-8|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_panc_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_panc_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} hairs~-&gt; P.(P.) pancratovae Akhrorov, 1977\r\n;16(15): head capsule {yellow}, its width  560-595&micro;m. &lt;abbr title=''AR: antennal ratio (1. to remaining segments)''&gt;AR&lt;/abbr&gt;=2.7-3.0. S1 of labrum is split to 7-10 blades. The {overlib|beard of ventromental plates with 7-10|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soko_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soko_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} hairs [added: {overlib|dorsal structure|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soko_dor_Zel1988_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soko_dor_Zel1988_r.gif 2009-12-15 10:36:17''>}]~-&gt; P.(P.) sokolovae Zelentzov &amp; Makarchenko, 1988 is known only from Russia - northwestern Chukotka. They live in the tundra lakes at the depth of 60-80cm among the silt, the detrite, the algae; the thickness of soil to the permafrost of 20-25cm.\r\n;17(14): {overlib|procerus with 7 long thick setae|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_prc_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_prc_Ye1982_r.gif 2009-12-15 10:36:17''>}, identical size.\r\n;18(19): {overlib|middle teeth of mentum equal or hardly higher|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} than the first lateral teeth~-&gt; P.(P.) barbimanus (Edwards, 1929)\r\n;19(18): {overlib|middle teeth of mentum lower|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_ishi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_ishi_men_Tsa1999_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_neva_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_neva_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} than first lateral.\r\n;20(21): S1 of labrum split to 6-10 blades. The {overlib|beard of ventro-mental plates with 10-15|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_neva_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_neva_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} hairs. Length of basal segment of the antenna 102-132&micro;m~-&gt; P.(P.) nevalis Akhrorov, 1977\r\n;21(20): S1 of labrum are split to 4-5 blades. In the {overlib|beard of ventro-mental plates 5-8|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_ishi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_ishi_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} it is hair. Length of basal segment of the antenna of 87-95&micro;m~-&gt; P.(P.) ishimicus Tshernovskij, 1949\r\n;22(13): {overlib|middle teeth of mentum considerably wider|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_zett_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_zett_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} than previously, width of one of the middle teeth more than 1.5 times exceeds the width of the base of the 1st lateral tooth. The length of the apical tooth of mandibles is equal to the span of the base of three internal teeth.\r\n;23(24): Procerus with 5 long thick setae, identical size~-&gt; P.(P.) zetterstedti Brundin, 1949\r\n;24(23): {overlib|Procerus with 5 long thick, identical size, and 2 shorter|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_panc_prc_Akh1977_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_panc_prc_Akh1977_r.gif 2009-12-15 10:36:17''>} thin setae (as in P.(P) pancratovae)~-&gt; 25\r\n;25(30): {overlib|middle teeth of mentum with the rounded chamfered apex|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_veco_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_veco_men_Tsa1999_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_fenn_men_Zel1988_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_fenn_men_Zel1988_r.gif 2009-12-15 10:36:17''>}.\r\n;26(29): {overlib|cut between the middle teeth of mentum is well expressed|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_veco_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_veco_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}. The beard of the ventromental plates with 4-8 short hairs (35-55&micro;m).\r\n;27(28): {overlib|width of one middle tooth of mentum is 1.5-1.8 times|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} more than the width of the base of the 1st lateral tooth. Bright scleritis of the rear external angle of maxilla are wide~-&gt; P.(P.) sordidellus (Zetterstedt, 1838)\r\n;28(27): {overlib|width of one middle tooth of mentum is 1.9-2 times|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_veco_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_veco_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} more than the width of the base of the 1st lateral tooth. Bright scleritis of the rear external angle of maxilla are narrow~-&gt; P.(P.) ventricosus Kieffer, 1925\r\n;29(26): {overlib|cut between the middle teeth of mentum hardly expressed|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_fenn_men_Zel1988_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_fenn_men_Zel1988_r.gif 2009-12-15 10:36:17''>}. The beard of the ventro-mental plates with 10-14 long hairs (60-105&micro;m)~-&gt; P.(P.) fennicus {citeID|450|Stor&aring; 1939}. Holarctic form. In Russia it is reliably known from Karelia and from the Chukotka peninsula. They live in the lakes, including thermocarstic lakes.\r\n;30(25): middle teeth of mentum with {overlib|small mammilliform or weak-sharpened protrusion at the apex|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_lifi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_lifi_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}.\r\n;31(32): surface of head with a large {overlib|grainy sculpture|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_lifi_dor_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_lifi_dor_Tsa1999_r.gif 2009-12-15 10:36:17''>}. The width of one {overlib|middle tooth of mentum is 1.8-2 times|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_lifi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_lifi_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} more than the width of the base of the 1st lateral tooth [added: {overlib|dorsal structure|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_lifi_dor_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_lifi_dor_Tsa1999_r.gif 2009-12-15 10:36:17''>}]~-&gt; P.(P.) litofilus Akhrorov, 1977\r\n;32(31): surface of head with small {overlib|.grainy sculpture|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_fabr_dor_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_fabr_dor_Tsa1999_r.gif 2009-12-15 10:36:17''>}. The width of one {overlib|middle tooth of mentum 2.1-2.5 times|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_fabr_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_fabr_men_Tsa1999_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_dela_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_dela_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} of more than the width of the base of the 1st lateral tooth\r\n;33(34): {overlib|Beard of the ventro-mental plates of 9-15|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_fabr_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_fabr_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} long hairs (70-87&micro;m). {overlib|Anal papillae 165-210&micro;m|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_fabr_ane_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_fabr_ane_Tsa1999_r.gif 2009-12-15 10:36:17''>}, they are equal or hardly shorter than posterior parapods. Length of head setae 60-118&micro;m~-&gt; P.(P.) fabricus Zelentzov, 1980\r\n;34(33): {overlib|Beard of the ventro-mental plates with 6-9|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_dela_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_dela_men_Tsa1999_r.gif 2009-12-15 10:36:17''>} long hairs (35-55&micro;m). {overlib|Anal papillae 120-145&micro;m|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_dela_ane_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_dela_ane_Tsa1999_r.gif 2009-12-15 10:36:17''>}, are equal to half of the length of posterior parapods. Length of head setae 120-180&micro;m~-&gt; P.(P.) delatoris Zelentzov, 1980\r\n\r\n\r\n==Checklist (China)==\r\n\r\n\r\nIn China ({citeID|279|Wang 2000}):&lt;br&gt;\r\nPsectrocladius (Allopsectrocladius):\r\n*P.obvius {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: PsclAl_obvi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclAl_obvi_men_Tsa1999_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclAl_obvi_men_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclAl_obvi_men_Ye1982_r.gif 2009-12-15 10:36:17''>}\r\nPsectrocladius (Psectrocladius):\r\n*P.barbimanus {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}\r\n*P.limbatellus (?) {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_limb_men_MPb1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_limb_men_MPb1984_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_limb_men_Cra1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_limb_men_Cra1982_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_limb_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_limb_men_WSD1991_r.gif 2009-12-15 10:36:17''>}\r\n*P.longipennis\r\n*P.sordidellus (?) {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_men_Sch1993_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_soid_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}\r\n\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Psectrocladius as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n\r\n|-\r\n|Psectrocladius (A.) platypes Edw. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || || || || || || || || || || || ||&middot;&middot;&middot;** &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n|-\r\n|Psectrocladius (P.) psilopterus Kieff.&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** || || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Psectrocladius (P.) simulans (Joh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for:\r\n*Psectrocladius sp.  and other taxa to find possible differences in temperature: 2000: 13.6&deg;C &plusmn; 2.3 (11.3 to 15.9), 2006: 15&deg;C &plusmn; 3.9 (11.1 to 18.9) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n*Psectrocladius (Allo/Mesopsectrocladius)  and other taxa to find possible differences in temperature: 2000: 13.6&deg;C &plusmn; 1.5 (12.1 to 15.2), 2006: 14.6&deg;C &plusmn; 2.3 (12.3 to 16.9) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nPsectrocladius sp. reported by {textciteID|516|Korhola et al. 2002} as intermediate taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Psectrocladius undifferentiated  and other taxa: 14.7&gt; &deg;C, n=57 (sigmoidal increasing Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Psectrocladius sp.  and other taxa: 6.7m &plusmn; 5.1 (n=50). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for:\r\n*Psectrocladius (Psectrocladius) (n=26, Template:explained:N2:HillsDiversity=19.83, n&lt;sub&gt;max&lt;/sub&gt;=8.02) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 42.\r\n*Psectrocladius (Septentrionalis) (n=12, Template:explained:N2:HillsDiversity=9.51, n&lt;sub&gt;max&lt;/sub&gt;=4.82) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 43.\r\n\r\n{textciteID|492|Brodersen et al. 2004} report for Psectrocladius sp. in lake Tasersuatsiaq (West Greenland) an oxygen consumption of 5.94 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 34.4 in % is in group {overlib|C|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  750~ha (lake area); 66.97898&deg;N; 50.69489&deg;W; 55~&micro;S~&middot; cm⁻&sup1;; 11.8&deg;C (July 2002); max. depth: &gt;80~m.\r\n\r\n===Conductivity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Psectrocladius sp3 in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 466.11mg &middot; l⁻&sup1; (&divide; 600 = 0.78mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 2.68204. In article shortened as: Ps3. (Psectrocladius sp3 can be identiﬁed by the two median teeth of the mentum being far more prominent than that of other Psectrocladius spp)\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Psectrocladius the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '147 65 108 41', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(48, 142, NULL, '==Characters genus==\r\n\r\nComments from {citeID|21|Cranston et.al. 1983}: Pseudosmittia shares the bifid S1 and S2 with Camptocladius, but all species described can be separeted by \r\n*the possession of posterior parapods (in most species), \r\n*anale tubules and a terminal antennal segment  longer than that preceding.\r\nIt is also likely that all species possess a {overlib|premandibular brush|&lt;img align=''middle'' title=''Pseudosmittia holsata (premandible) Schmid 1993'' src=''image.php?text=image deleted: Pssm_hols_pre_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}, a feature not present in Camptocladius.&lt;br&gt;\r\n{citeID|302|Brooks et.al. 2007}:\r\n*Setae submenti positioned medially below first lateral tooth\r\n*Ventromental plates, narrow, abruptly curved adjacent to outer lateral tooth\r\n\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|Reference\r\n!im90|antennal segments\r\n!im|antenna (note)\r\n!im|antennal blade\r\n!|s1\r\n!|s2\r\n!|s3\r\n!|s4\r\n!im|pecten epipharyngis (labrum)\r\n!im90|premandible\r\n!im90|premandible brush\r\n!|mandible\r\n!im90|mandible note\r\n!im90|mentum middle\r\n!im90|mentum lateral\r\n!im90|beared\r\n\r\n|-\r\n|&lt;!-- ref --&gt;{citeID|21|Cranston et.al. 1983}\r\n|&lt;!-- ant segm --&gt;3-4\r\n|&lt;!-- ant note --&gt;not longer than half of mandible; terminal segment usually longer than that eceding\r\n|&lt;!-- ant blade --&gt;&lt; flagellum, often greatly\r\n|&lt;!-- s1 --&gt;bifid\r\n|&lt;!-- s2 --&gt;bifid\r\n|&lt;!-- s3 --&gt;simple\r\n|&lt;!-- s4 --&gt;simple\r\n|&lt;!-- pee --&gt;3 usually simple sometimes serrated spines\r\n|&lt;!-- pre --&gt;2-4\r\n|&lt;!-- pre brush --&gt;?always\r\n|&lt;!-- man --&gt;3-1-0-0\r\n|&lt;!-- man note --&gt;apical tooth shorter than combined width of 3 inner teeth\r\n|&lt;!-- men median --&gt;1\r\n|&lt;!-- men lat --&gt;4&lt;br&gt;?always\r\n|&lt;!-- beared --&gt;no\r\n\r\n|}\r\n\r\n==Specimens==\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|species\r\n!im90|head - color\r\n!im90|mandible - color\r\n!im90|mentum - color\r\n!im90|abdomen - color\r\n!im90|claws - anterior\r\n!im90|claws - posterior\r\n!im90|claws - note\r\n!im90|antenna - ratio\r\n!im90|labrum - seta S1\r\n!im90|premandible\r\n!|mandible\r\n!im90|mandible: length 1 to 3 inner\r\n!im90|mandible - seta interna\r\n!im90|procerus - setae\r\n\r\n\r\n|-\r\n|{citeID|335|Wang 1990}\r\n|&lt;!-- species --&gt;P. sp. (aizaiensis cf) {citeID|335|Wang 1990}\r\n|&lt;!-- head color --&gt;{yellow}\r\n|&lt;!-- mandible color --&gt;{brown}\r\n|&lt;!-- mentum color --&gt;&lt;span class=''yellowbrown''&gt;pale brown&lt;/span&gt;\r\n|&lt;!-- abdomen color --&gt;{pale}-&lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|&lt;!-- claws - anterior  --&gt;80 (about ~)\r\n|&lt;!-- claws - posterior  --&gt;9-10\r\n|&lt;!-- claws - note  --&gt;anterior+posterior with 2 forms : narrowly triangular and horse-shoe shaped\r\n|&lt;!-- AR --&gt; 1.0\r\n|&lt;!-- labrum - seta S1 --&gt;2 - bifid\r\n|&lt;!-- premandible --&gt;4 (2 apical 2 molar like inner)\r\n|&lt;!-- mandible --&gt;3.5-1-0-0\r\n|&lt;!-- mandible 1 st to 3 inner --&gt; 1 &lt; 2+3+4\r\n|&lt;!-- set interna man --&gt;no\r\n|&lt;!-- procerus --&gt;no -  1 long, 2 short\r\n\r\n|}\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sort''\r\n|-\r\n!|Reference\r\n!im90|species\r\n!im90|mentum: middle+lateral\r\n!im90|mentum: submental setation at lateral tooth\r\n!im90|mandible\r\n!im90|seta s1\r\n!im90|premandible\r\n!im90|premandible brush\r\n\r\n|-\r\n|{citeID|325|B&iacute;r&oacute; 1981}&lt;!-- reference --&gt;\r\n|Pseudosmittia trilobata {citeID|276|Edwards 1929}\r\n|1 + 4(5?)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Pseudosmittia trilobata (mentum) B&iacute;r&oacute; 1981'' src=''image.php?text=image deleted: Pssm_tril_men_Bia1981_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!-- mentum+lateral --&gt;\r\n|not drawn&lt;!--submental setation--&gt;\r\n|3-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Pseudosmittia trilobata (mandible) B&iacute;r&oacute; 1981'' src=''image.php?text=image deleted: Pssm_tril_man_Bia1981_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|2.0&lt;!-- seta s1 --&gt;\r\n|4&lt;!-- pre --&gt;\r\n|not drawn&lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!-- reference --&gt;\r\n|Pseudosmittia holsata \r\n|1 + 4&lt;br&gt;&lt;img align=''middle'' width=200 title=''Pseudosmittia holsata (mentum) Schmid 1993'' src=''image.php?text=image deleted: Pssm_hols_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|0.5&lt;!--submental setation--&gt;\r\n|3.5-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Pseudosmittia holsata (mandible) Schmid 1993'' src=''image.php?text=image deleted: Pssm_hols_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|1.9 inner slightly shorter&lt;!-- seta s1 --&gt;\r\n|3&lt;!-- pre --&gt;\r\n|yes&lt;!-- pre-brush --&gt;\r\n\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}&lt;!-- reference --&gt;\r\n|Pseudosmittia sp. \r\n|1 + 4&lt;br&gt;&lt;img align=''middle'' width=200 title=''Pseudosmittia sp (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Pssm_spec_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|1.5&lt;!--submental setation--&gt;\r\n|3-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Pseudosmittia sp (mandible) Cranston et.al. 1983'' src=''image.php?text=image deleted: Pssm_spec_man_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|1.8 inner shorter&lt;!-- seta s1 --&gt;\r\n|3&lt;!-- pre --&gt;\r\n|yes&lt;!-- pre-brush --&gt;\r\n\r\n\r\n|-\r\n|{citeID|335|Wang 1990}&lt;!-- reference --&gt;\r\n|Pseudosmittia aizaiensis cf.\r\n|1 + 5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Pseudosmittia sp (mentum) Wang 1990'' src=''image.php?text=image deleted: Pssm_spec_men_Wan1990_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|2.0&lt;!--submental setation--&gt;\r\n|3.5-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Pseudosmittia sp (mandible) Wang 1990'' src=''image.php?text=image deleted: Pssm_spec_man_Wan1990_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|2.0&lt;!-- seta s1 --&gt;\r\n|4&lt;!-- pre --&gt;\r\n|not drawn&lt;!-- pre-brush --&gt;\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!-- reference --&gt;\r\n|Pseudosmittia sp. A  {citeID|20|Schmid 1993}\r\n|1 + 4&lt;br&gt;&lt;img align=''middle'' width=200 title=''Pseudosmittia sp. A (mentum) Schmid 1993'' src=''image.php?text=image deleted: Pssm_specA_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|1.0&lt;!--submental setation--&gt;\r\n|3-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Pseudosmittia sp. A (mandible) Schmid 1993'' src=''image.php?text=image deleted: Pssm_specA_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|2.0&lt;!-- seta s1 --&gt;\r\n|4&lt;!-- pre --&gt;\r\n|not drawn&lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!-- reference --&gt;\r\n|Pseudosmittia virgo Strenzke 1950\r\n|1 + 4&lt;br&gt;&lt;img align=''middle'' width=200 title=''Pseudosmittia virgo (mentum) Schmid 1993'' src=''image.php?text=image deleted: Pssm_virg_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|1.0&lt;!--submental setation--&gt;\r\n|3-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Pseudosmittia virgo (mandible) Schmid 1993'' src=''image.php?text=image deleted: Pssm_virg_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|2.0? not drawn&lt;!-- seta s1 --&gt;\r\n|2&lt;!-- pre --&gt;\r\n|yes&lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}&lt;!-- reference --&gt;\r\n|Camptocladius stercorarius (de Geer)\r\n|1 + 4&lt;br&gt;&lt;img align=''middle'' width=200 title=''Camptocladius stercorarius (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Cacl_ster_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|0.5&lt;!--submental setation--&gt;\r\n|4-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Camptocladius stercorarius (mandible) Cranston et.al. 1983'' src=''image.php?text=image deleted: Cacl_ster_man_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|1.9 inner shorter&lt;!-- seta s1 --&gt;\r\n|3&lt;!-- pre --&gt;\r\n|not drawn&lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}&lt;!-- reference --&gt;\r\n|Georthocladius luteipes\r\n|1 + 4&lt;br&gt;&lt;img align=''middle'' width=200 title=''Georthocladius luteipes (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Geor_lute_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|1.5&lt;!--submental setation--&gt;\r\n|2-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Georthocladius luteipes (mandible) Cranston et.al. 1983'' src=''image.php?text=image deleted: Geor_lute_man_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|1.0 &lt;!-- seta s1 --&gt;\r\n|1&lt;!-- pre --&gt;\r\n|not drawn&lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|294|Wang 1994}&lt;!-- reference --&gt;\r\n|Smittia aterrima\r\n|1 + 5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Smittia aterrima (mentum) Wang 1994'' src=''image.php?text=image deleted: Smit_ater_men_WaS1994_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|1.0&lt;!--submental setation--&gt;\r\n|? &lt;!-- mandible --&gt;\r\n|? &lt;!-- seta s1 --&gt;\r\n|? &lt;!-- pre --&gt;\r\n|? &lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}&lt;!-- reference --&gt;\r\n|Smittia contingens {citeID|309|Walker 1856}\r\n|1 + 5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Smittia contingens (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Smit_cont_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|1-2&lt;!--submental setation--&gt;\r\n|3-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Smittia contingens (mandible) Cranston et.al. 1983'' src=''image.php?text=image deleted: Smit_cont_man_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|5 serrated &lt;!-- seta s1 --&gt;\r\n|2 &lt;!-- pre --&gt;\r\n|not drawn &lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!-- reference --&gt;\r\n|Smittia paranudipennis {citeID|240|Brundin 1947}\r\n|1 + 5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Smittia paranudipennis (mentum) Schmid 1993'' src=''image.php?text=image deleted: Smit_panu_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|8 ca. &gt;5&lt;!--submental setation--&gt;\r\n|3.5-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Smittia paranudipennis (mandible) Schmid 1993'' src=''image.php?text=image deleted: Smit_panu_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|5-7 serrated &lt;!-- seta s1 --&gt;\r\n|2 + 1 smooth basal&lt;!-- pre --&gt;\r\n|not drawn &lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!-- reference --&gt;\r\n|Smittia sp. A {citeID|20|Schmid 1993}\r\n|1 + 5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Smittia sp. A (mentum) Schmid 1993'' src=''image.php?text=image deleted: Smit_specA_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|5 &lt;!--submental setation--&gt;\r\n|3.5-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Smittia sp. A (mandible) Schmid 1993'' src=''image.php?text=image deleted: Smit_specA_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|4-5 serrated &lt;!-- seta s1 --&gt;\r\n|2 + 1 smooth basal&lt;!-- pre --&gt;\r\n|not drawn &lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}&lt;!-- reference --&gt;\r\n|Smittia sp. B {citeID|20|Schmid 1993}\r\n|1 + 5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Smittia sp. B (mentum) Schmid 1993'' src=''image.php?text=image deleted: Smit_specB_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|5 &lt;!--submental setation--&gt;\r\n|3-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Smittia sp. B (mandible) Schmid 1993'' src=''image.php?text=image deleted: Smit_specB_man_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|5 serrated &lt;!-- seta s1 --&gt;\r\n|3 &lt;!-- pre --&gt;\r\n|not drawn &lt;!-- pre-brush --&gt;\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}&lt;!-- reference --&gt;\r\n|Parasmittia carinata \r\n|1 + 5&lt;br&gt;&lt;img align=''middle'' width=200 title=''Parasmittia carinata (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Pasm_cari_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mentum+lateral --&gt;\r\n|3 &lt;!--submental setation--&gt;\r\n|3-1-0-0&lt;br&gt;&lt;img align=''middle'' width=100 title=''Parasmittia carinata (mandible) Cranston et.al. 1983'' src=''image.php?text=image deleted: Pasm_cari_man_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;!-- mandible --&gt;\r\n|6 serrated &lt;!-- seta s1 --&gt;\r\n|3 &lt;!-- pre --&gt;\r\n|not drawn &lt;!-- pre-brush --&gt;\r\n\r\n|}\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):&lt;br&gt;\r\n*P.aizaiensis Wang {overlib|mentum|&lt;img align=''middle'' width=200 title=''Pseudosmittia cf.aizaiensis (mentum) Wang 1990'' src=''image.php?text=image deleted: Pssm_spec_men_Wan1990_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*P.duplicata Caspers\r\n*P.forcipata (Goetghebuer, 1921)\r\n*P.mathilda Albu\r\n*P.recta (Edwards)', 1, 'Living in soil: Pseudosmittia longicrus (K.) see {citeID|475|Delettre 2000}\r\n\r\n==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*8 have statistically significant (sigmoidal Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n', '17 202 155 118 19 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(49, 147, NULL, 'in China ({citeID|279|Wang 2000}) Rheocricotopus Thienemann and Harnisch:\r\n*Subgenus Psilocricotopus S&aelig;ther\r\n** R. atripes (Kieffer) male\r\n** R. chalybeatus Edwards male {overlib|mentum|&lt;img align=''middle'' alt=''Rheocricotopus chalybeatus (mentum)'' width=200 title=''Rheocricotopus chalybeatus (mentum) Schmid 1993'' src=''image.php?text=image deleted: Rhcr_chal_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** R. bifasciatus {citeID|398|Wang and Zheng 1991} male\r\n** R. brachypus {citeID|398|Wang and Zheng 1991}  male\r\n** R. emeiensis Wang and Zheng male\r\n** R. glabricollis (Meigen) male {overlib|mentum|&lt;img align=''middle'' alt=''Rheocricotopus glabricollis (mentum)'' width=200 title=''Rheocricotopus glabricollis (mentum) S&aelig;ther 1985'' src=''../../imglarvae/Rhcr_glab_men_Sae1985_r.gif'' &gt;}\r\n** R. nigrus Wang and Zheng male\r\n* Subngenus Rheocricotopus s.str.\r\n** R. baishanensis {citeID|398|Wang and Zheng 1991}  male\r\n** R. effusus (Walker) male {overlib|mentum|&lt;img align=''middle'' alt=''Rheocricotopus effusus (mentum)'' width=200 title=''Rheocricotopus effusus (mentum) Schmid 1993'' src=''image.php?text=image deleted: Rhcr_effu_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Rheocricotopus effusus (mentum)'' width=200 title=''Rheocricotopus effusus (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Rhcr_effu_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** R. fuscipes (Kieffer) {overlib|mentum|&lt;img align=''middle'' alt=''Rheocricotopus fuscipes (mentum)'' width=200 title=''Rheocricotopus fuscipes (mentum) Wang and Wang 1991'' src=''image.php?text=image deleted: Rhcr_fuci_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Rheocricotopus fuscipes (mentum)'' width=200 title=''Rheocricotopus fuscipes (mentum) Yan et.al. 1982'' src=''image.php?text=image deleted: Rhcr_fuci_men_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n** R. orientalis Wang male\r\n** R. tibialis {citeID|398|Wang and Zheng 1991}  male\r\n** R.sp. male female\r\n\r\nThe larvae of 4th stage. Key was translated from русский язык by [[http://babelfish.altavista.com/tr babelfish]] from {citeID|271|Makarchenko and Makarchenko 2005}:\r\n#- body setae long and strong, their maximum length is more than 100&micro;m (subgenus Psilocricotopus S&aelig;ther). {overlib|S1|&lt;img align=''middle'' alt=''Rheocricotopus glabricollis (labro-epipharyngeal region)'' width=150 title=''Rheocricotopus glabricollis (labro-epipharyngeal region) S&aelig;ther 1985'' src=''../../imglarvae/Rhcr_glab_lab_Sae1985_r.gif'' &gt;} is apically split to 6-7 teeth; the length of the basal segment of {overlib|antenna|&lt;img align=''middle'' alt=''Rheocricotopus glabricollis (antenna)'' width=60 title=''Rheocricotopus glabricollis (antenna) S&aelig;ther 1985'' src=''../../imglarvae/Rhcr_glab_ant_Sae1985_r.gif'' &gt;} 96-111&micro;m two middle teeth of {overlib|mentum|&lt;img align=''middle'' alt=''Rheocricotopus glabricollis (mentum)'' width=200 title=''Rheocricotopus glabricollis (mentum) S&aelig;ther 1985'' src=''../../imglarvae/Rhcr_glab_men_Sae1985_r.gif'' &gt;} are lateral without the additional kinks .... R (P.) glabricollis (Meigen)&lt;br&gt;- the body setae short, not are longer than 85&micro;m (subgenus Rheocricotopus s.str.) ... 2\r\n#- two middle teeth of mentum are lateral with the additional kinks. AR approximately 1.55; the length of the last segment of antenna of approximately 10&micro;m .... R. (R.) pauciseta S&aelig;ther&lt;br&gt;- two middle teeth of mentum simple, without the kinks lateral, sometimes with the weakly expressed external protrusions, value AR others ... 3\r\n#- AR 1,1-1,3. Ventromental plates with 12-13 setae in the lower part .... R (R.) eminellobus S&aelig;ther&lt;br&gt;- AR 1,5-1,8. {overlib|Ventro-mental plates|&lt;img align=''middle'' alt=''Rheocricotopus effusus (mentum)'' width=200 title=''Rheocricotopus effusus (mentum) Schmid 1993'' src=''image.php?text=image deleted: Rhcr_effu_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Rheocricotopus effusus (mentum)'' width=200 title=''Rheocricotopus effusus (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Rhcr_effu_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} with 25-31 setae, located along the entire surface ... R (R.) effusus (Walker)\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Rheocricotopus as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n===Temperature===\r\n\r\n{textciteID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C.\r\n\r\n===Conductivity/Salinity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Rheocricotopus in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 3248mg &middot; l⁻&sup1; (&divide; 600 = 5.41mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 3.624. In article shortened as: Rh.\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Rheocricotopus sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '4 160 191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(50, 150, NULL, '{| style="border:1px solid;"\r\n!|Reference \r\n!im|antennal pedestal\r\n!im|antennal spur\r\n!|s 1\r\n!|s 2\r\n!|s 3\r\n!|s 4\r\n!im|pecten epipharyngis\r\n!im|premandible\r\n!im|mandible\r\n!im|median tooth (mentum)\r\n!im|lateral teeth (mentum)\r\n!im|ventromental plates\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}:	\r\n|tall\r\n|no\r\n|comb-like\r\n|distally plumose on long pedestr.\r\n|fine seta-like\r\n|present\r\n|simple broad comb or&lt;br&gt;incompletely div. in 3 parts\r\n| 2+brush\r\n| 3/2-1-1-0\r\n| 1 or 2 notches occasionally distinctly trifid\r\n| 5\r\n|almost in contact medially, somewhat wider than mentum width, strongly curved anterior margin\r\n|}\r\n\r\n{citeID|2|Pinder and Reiss 1983}:&lt;br&gt;\r\nunlike in any other genus of Tanytarsini the pecten epipharyngis of Rheotanytarsus is a single, distally serrated plate, which may however be deeply divided into 3 lobes. The cases constructed by larvae are also quite characteristic, bearing several arm-like extensions at the end. Descriptions of larvae are given in Bause 1913 and Fittkau 1960.&lt;br&gt;\r\n\r\nIn China {citeID|279|Wang 2000}:&lt;br&gt;\r\n*R.acerbus (Johannsen)\r\n*R.aestuarius (Tokunaga)\r\n*R.exiguus (?) (Johannsen)\r\n*R.muscicola Thienamann\r\n*R.tamaquartus Sasa', 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Rheotanytarsus sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(51, 154, NULL, '==Generic characters==\r\n\r\n===Pinder and Reiss 1983===\r\n\r\nComments from {citeID|2|Pinder and Reiss 1983}: Sergentia larvae may be recognized by \r\n*the 4 more or less equally broad, pointed and widely separated median mental teeth which are set above the remainder of the mentum, and also by \r\n*the 4 inner mandibular teeth. In addition \r\n*the anterior margin of the frontoclypeal apotome is convex, not straight as in Polypedilum.\r\n\r\nSergentia has been regarded by all North American authors as a synonym of Phaenopsectra. However, at least the larvae and male imagines possess characters  which establish Sergentia as a separate genus. The mandible of the Sergentia larvae has \r\n*4 inner teeth, regularly decreasing in size (only 3 in Phaenopsectra , with a deep notch before the basal one), \r\n*brown mental teeth  (shining  black  in  described  Phaenopsectra), \r\n*as well as 4 separate, equalIy broad median mental teeth and \r\n*6 pairs of scarcely differing lateral teeth \r\n(in Phaenopsectra 2 small, sunken, closely adjacent teeth centrally and 2 large outer median teeth, together with 6 pairs of Iateral teeth, very strongly differentiated in size).\r\n\r\nBaicalosergentia Linevich was cited by the author herself as a subgenus of Sergentia or as a valid genus ({citeID|472|Linevich 1977}). On the basis of the descriptions the larvae cannot be distinguished from Sergentia s.str.\r\n\r\n\r\n===Brooks et.al. 2007===\r\n\r\nIn {citeID|302|Brooks et.al. 2007}:\r\n* {overlib|2 apical teeth on premandible|<img src=''image.php?text=Image reduced version. Deleted: Serg_cora_lab_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Serg_cora_lab_WCh1983_r.gif 2009-12-15 10:36:17''>}, {overlib|ventromental plates with paired striations|<img src=''image.php?text=Image reduced version. Deleted: Serg_cora_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Serg_cora_men_WCh1983_r.gif 2009-12-15 10:36:17''>} prominent along anterior margin -&gt; S.coracina-type\r\n* {overlib|4 teeth on premandible|<img src=''image.php?text=Image reduced version. Deleted: Serg_love-_pre_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Serg_love-_pre_Tsa1999_r.gif 2009-12-15 10:36:17''>}, {overlib|ventromental plates densely striated|<img src=''image.php?text=Image reduced version. Deleted: Serg_love-_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Serg_love-_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}, striations extend across entire width of plates -&gt; S.longiventris-type\r\n\r\n\r\n==Chacklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*S.longiventris (Kieffer)\r\n*S.sp female\r\n', 1, '{citeID|2|Pinder and Reiss 1983}: Larvae of Sergentia occur in the sublittoral and profundal of oligotrophic to mesotrophic lakes. They are probably coldstenothermic. The genus is distributed within subarctic to tempente and montane regions of the Holarctic. About 6 species occur in the Palaearctic (including Baicalosergentia), at least 1 species in the Nearctic. Heterotrissocladius, Protanypus, and Sergentia are common in the cold profundal of stratified lakes from temperate forest regions as well as arctic sites ({citeID|303|Walker 1991}).\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Sergentia coracina (Zett.) as [Phaenopsectra coracina]&lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n\r\n&lt;tbody&gt;\r\n|-\r\n|Sergentia coracina (Zett.)  [as Phaenopsectra coracina]&lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n==Temperature==\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Sergentia  and other taxa to find possible differences in temperature: 2000: 10&deg;C &plusmn; 4.4 (5.5 to 14.4), 2006: 9.7&deg;C &plusmn; 4.5 (5.3 to 14.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Sergentia  and other taxa: 15.8&deg;C &plusmn; 19.7, n=86 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C. [..] Sergentia has also been associated with cold waters ({citeID|524|Walker and Mathewes 1989}; {citeID|525|Walker et al. 1997}) and identified as a cold-stenothermic taxon ({citeID|507|Brooks and Birks 2000}).\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Sergentia (n=23, Template:explained:N2:HillsDiversity=12.21, n&lt;sub&gt;max&lt;/sub&gt;=24.05) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 26.\r\n', '44 223 182 154 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(52, 155, 21, '==Characters==\r\n\r\nComments ({citeID|21|Cranston et.al. 1983}): Smittia is a well defined genus in the larval stage. Amongst the genera without procerci the plumose S1 is shared only with Parasmittia and Antillocladius. These genera have a long antennal blade.&lt;br&gt;\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|reference\r\n!im90|head\r\n!im90|head - postoccipital margin\r\n!im90|antenna\r\n!im90|antenna - blade\r\n!im90|seta S1\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!im90|premandible - inner tooth\r\n!im90|mentum - middle tooth\r\n!im90|mentum - lateral teeth\r\n!im90|ventromental plates\r\n!im90|mandible\r\n!im90|manible - seta subdentalis\r\n!im90|manible - seta interna\r\n!im90|maxilla - palpus\r\n!im90|maxilla - laccinal chetae\r\n!im90|abdomen\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt;\r\n|&lt;span class=''dark''&gt;darkened&lt;/span&gt;\r\n|4\r\n|reaching 4th segment\r\n|plumose&lt;br&gt;remaining S-setae simple\r\n|3 scales\r\n|2\r\n|yes/no\r\n|1 dome-shaped\r\n|5\r\n|weakly\r\n|3-1-0-0\r\n|reaching 4th inner tooth\r\n|5-6 serrated branches\r\n|partially divided into 2 parts\r\n|reduced\r\n|no procerus\r\n\r\n\r\n|}\r\n\r\n==Checklist China==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*S.aterrima (Meigen)\r\n*S.contingens (Walker)\r\n*S.edwardsi Goetghebuer\r\n*S.leucopogon (Meigen)\r\n*S.niitakana (Tokunaga)\r\n*S.nudipennis (Goetghebuer)\r\n*S.pratorum (Goetghebuer)\r\n*S.rostrata Wang and Wang\r\n*S.truncatocauda (Tokunaga)', 1, '==Biotops==\r\n\r\n{citeID|541|Kurek and Cwynar 2009}: &laquo;For example, Pseudosmittia/Smittia and Limnophyes/Paralimnophyes are known as semi-terrestrial or littoral taxa ({citeID|302|Brooks et al. 2007}).&raquo;\r\n\r\nLiving in soil see {citeID|475|Delettre 2000}:\r\n*Smittia pratorum G.\r\n*Smittia celtica {citeID|476|Rossaro and Delettre 1992}\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Smittia in Alpine running waters of 7.86 &plusmn;~1.17 (min-max: 5.16-8.9, n=30).\r\n', '110 118 142 195 46 71', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(53, 159, NULL, '{citeID|2|Pinder and Reiss 1983}: Stictochironomus larvae may be identified from the following combination of characters: \r\n*antenna with 6 segments and alternate Lauterborn organs; \r\n*dorsal tooth of mandible dark, as are all of the mental teeth; \r\n*4 median teeth of mentum higher than the 6 pairs of lateral teeth,\r\n*central pair much more slender and lower than outer pai&shy;r. \r\nLarvae with only 3 median teeth (cf. Chernovski (1949b), sub Stictochironomus connectens No. 2) may be aberant specimens, in which 1 of the 2 small median teeth is reduced. {citeID|287|Oliver et.al. 1978} figure under Stictochironomus sp. 3 (fig. 64) a distinctly different larval mentum, in which both small central median teeth are completely absent. Larvae living in sand generally have strongly worn mouthparts.&lt;br&gt;\r\nIn China ({citeID|279|Wang 2000}):\r\n*S.akizukii (Tokunaga)\r\n*S.flavicingulus (Walker, 1848)\r\n*S.sticticus (Fabricius) male\r\n*S.sp. male\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|species\r\n!im|mandible\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|Stictochironomus rosenscholdi ({citeID|355|Zetterstedt 1838})&lt;br&gt;&lt;img align=''middle'' width=200 title=''Stictochironomus rosenscholdi (mentum)'' src=''image.php?text=image deleted: Stic_rosc_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|2-1-1-0\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Stictochironomus sp.1 {citeID|2|Pinder and Reiss 1983}&lt;br&gt;&lt;img align=''middle'' width=200 title=''Stictochironomus sp. 1 (mentum)'' src=''image.php?text=image deleted: Stic_spec1_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|2-1-1-0\r\n\r\n|-\r\n|{citeID|42|Ye and Wang 1982}\r\n|Stictochironomus flavicingulus (Walker, 1848)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Stictochironomus flavicingulus (mentum)'' src=''image.php?text=image deleted: Stic_flci_men_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|3-1-1-0\r\n\r\n|-\r\n|{citeID|40|Wang and Wang 1991}\r\n|Stictochironomus akizukii (Tokunaga, 1940)&lt;br&gt;&lt;img align=''middle'' width=200 title=''Stictochironomus akizukii (mentum)'' src=''image.php?text=image deleted: Stic_akiz_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|3-1-0-0\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Stictochironomus sp.2 {citeID|2|Pinder and Reiss 1983}&lt;br&gt;&lt;img align=''middle'' width=200 title=''Stictochironomus sp. 2 (mentum)'' src=''image.php?text=image deleted: Stic_spec2_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|?\r\n\r\n\r\n|-\r\n|{citeID|22|Makarchenko 1999}\r\n|Stictochironomus crassiforceps ({citeID|275|Kieffer 1922})&lt;br&gt;&lt;img align=''middle'' width=200 title=''Stictochironomus crassiforceps (mentum)'' src=''image.php?text=image deleted: Stic_crfo_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|?\r\n\r\n|}\r\n', 1, '==Biotops==\r\n\r\n{textciteID|2|Pinder and Reiss 1983}: Larvae of Stictochironomus occur in profundal soft sediments or littoral sand of ligotrophic to mesotrophic lakes; also prevalent i&shy;n sandy sediments of streams and slowly flowing rivers. The genus is represented in the Nearctic by 13 species and in the Palaearctic by about 8, in part identical, species; in need of revision. In addition there are 6 Afrotropical and 1 known Oriental species.\r\n\r\n{textciteID|554|Ilyashuk and Ilyashuk 2001}: &laquo;Perhaps the distributional patterns of P. penicillatus and Stictochironomus spp. after ~1982 suggest that P. penicillatus tolerates a wider range of pH and heavy metal concentrations than Stictochironomus spp.&raquo;\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Stictochironomus sp.  and other taxa: 8.6m &plusmn; 2.5 (n=4). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Temperature===\r\n\r\nStictochironomus sp. reported by {textciteID|516|Korhola et al. 2002} as cold adapted taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n===Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Stictochironomus sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Stictochironomus the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '44 223 182 154 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(54, 166, NULL, NULL, 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Synorthocladius as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Synorthocladius sp.  and other taxa: 11.2m &plusmn; 10.4 (n=4). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Temperature===\r\n\r\n{textciteID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C.\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Synorthocladius (n=19, Template:explained:N2:HillsDiversity=15.12, n&lt;sub&gt;max&lt;/sub&gt;=4.32) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 44.\r\n\r\n===Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Synorthocladius sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(55, 170, NULL, '==Similar genera==\r\n\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default ''|Reference\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|Postoccipital plate\r\n!im90 class=''table-sortable:default ''|Premandible\r\n!im90 class=''table-sortable:default ''|Antennal pedestal\r\n!im90 class=''table-sortable:default ''|Antennal spur\r\n!im90 class=''table-sortable:default ''|Antenna 2-nd segment\r\n!im class=''table-sortable:default ''|Mandible\r\n!im90 class=''table-sortable:default ''|Pecten epipharyngis\r\n!im90 class=''table-sortable:default ''|Ventromental plates\r\n!im90 class=''table-sortable:default ''|Mentum middle\r\n!im90 class=''table-sortable:default ''|Parapods posterior\r\n!im90 class=''table-sortable:default ''|Notes\r\n\r\n|-\r\n!|\r\n! class=''table-filterable''|\r\n!|&lt;input name=''filterPostoccipital2'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterPremandible3'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAntennal4'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAntennal5'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAntenna6'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterMandible7'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterPecten8'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterVentromental9'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterMentum10'' size=3 onkeyup=''Table.filter(this,this)''&gt;\r\n!|\r\n!|\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}&lt;!--reference--&gt;\r\n|Micropsectra&lt;!--taxon--&gt;\r\n|. to +&lt;!--postoccipital plate--&gt;\r\n|2&lt;!--premandible--&gt;\r\n|. to ++&lt;!--antennal pedestal--&gt;\r\n|short/sharp or long medium-sized/sharp or long straight/blunt&lt;!--antennal spur--&gt;\r\n|cylindrical?&lt;!--antenna 2 segment --&gt;\r\n|3-1-1-0&lt;!--mandible--&gt;\r\n|3(?) comb-like&lt;!--pecten epipharyngis--&gt;\r\n|also rounded&lt;!--ventromental plates--&gt;\r\n|&lt;!-- mentum middle --&gt;\r\n|&lt;!--post. parap.--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}&lt;!--reference--&gt;\r\n|Micropsectra&lt;!--taxon--&gt;\r\n|&lt;!--postoccipital plate--&gt;\r\n|2&lt;!--premandible--&gt;\r\n|++&lt;!--antennal pedestal--&gt;\r\n|10&micro;m-40&micro;m (usually)&lt;!--antennal spur--&gt;\r\n|cylindrical&lt;!--antenna 1st:2nd segment --&gt;\r\n|3-1-1-0&lt;!--mandible--&gt;\r\n|3(?) comb-like&lt;!--pecten epipharyngis--&gt;\r\n|very close medially, about 1.2x width of mentum&lt;!--ventromental plates--&gt;\r\n|notched or at laest crenate laterally&lt;!-- mentum middle --&gt;\r\n|very numerous claws, many are small of them, like a horse-shoe, irregular rows&lt;!--post. parap.--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}&lt;!--reference--&gt;\r\n|Tanytarsus&lt;!--taxon--&gt;\r\n|+++ trapezoidal&lt;!--postoccipital plate--&gt;\r\n|&lt;!--premandible--&gt;\r\n|+ to ++&lt;!--antennal pedestal--&gt;\r\n|+ to .&lt;!--antennal spur--&gt;\r\n|&lt;!--antenna 1st:2nd segment --&gt;\r\n|3/2-1-1/2-1/2/plate&lt;!--mandible--&gt;\r\n|&lt;!--pecten epipharyngis--&gt;\r\n|&lt;!--ventromental plates--&gt;\r\n|&lt;!-- mentum middle --&gt;\r\n|&lt;!--post. parap.--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}&lt;!--reference--&gt;\r\n|Tanytarsus&lt;!-- taxon --&gt;\r\n|&lt;!-- pop --&gt;\r\n|3-5&lt;!--premandible--&gt;\r\n|tall&lt;!-- anp --&gt;\r\n|yes/no&lt;!-- spur --&gt;\r\n|cylindrical&lt;!-- ant2 --&gt;\r\n|3/2-1-1/2-1/2/plate&lt;!-- man --&gt;\r\n|3(?) comb-like&lt;!--pecten epipharyngis--&gt;\r\n|narrowly separated madially, somwhat wider than mentum&lt;!-- vep --&gt;\r\n|rounded or laterally notched or crenate&lt;!-- men mid --&gt;\r\n|few claws, simple arranged like a horse-shoe&lt;!-- cpp --&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}&lt;!--reference--&gt;\r\n|Cladotanytarsus&lt;!--taxon--&gt;\r\n|&lt;!--postoccipital plate--&gt;\r\n|4-5&lt;!--premandible--&gt;\r\n|. short&lt;!--antennal pedestal--&gt;\r\n|no&lt;!--antennal spur--&gt;\r\n|wedge-shaped, &lt;== 3rd&lt;!--antenna 1st:2nd segment --&gt;\r\n|3-1-1-0&lt;!--mandible--&gt;\r\n|3(?) comb-like&lt;!--pecten epipharyngis--&gt;\r\n|close together medially, rather wider than mentum&lt;!--ventromental plates--&gt;\r\n|broad, rounded or notched laterally&lt;!-- mentum middle --&gt;\r\n|some claws with finely ''''''serrated'''''' inner margin&lt;!--post. parap.--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}&lt;!--reference--&gt;\r\n|Virgatanytarsus&lt;!--taxon--&gt;\r\n|&lt;!--postoccipital plate--&gt;\r\n|5&lt;!--premandible--&gt;\r\n|++ tall&lt;!--antennal pedestal--&gt;\r\n|no&lt;!--antennal spur--&gt;\r\n|cylindrical&lt;!--antenna 1st:2nd segment --&gt;\r\n|3-1-1-0&lt;!--mandible--&gt;\r\n|3(?) comb-like&lt;!--pecten epipharyngis--&gt;\r\n|very close together medially, 1.1-1.2x witdh of mentum&lt;!--ventromental plates--&gt;\r\n|rounded or pointed&lt;!-- mentum middle --&gt;\r\n|characteristic(!) - bear a pad or row of very strong hooklets in addition to usual simple hooks&lt;!--post. parap.--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}&lt;!--reference--&gt;\r\n|Pseudochironomus Malloch&lt;!--taxon--&gt;\r\n|&lt;!--postoccipital plate--&gt;\r\n|2&lt;!--premandible--&gt;\r\n|&lt;!--antennal pedestal--&gt;\r\n|. short broad or point&lt;!--antennal spur--&gt;\r\n|cylindrical (like Chironomus)&lt;!--antenna 1st:2nd segment --&gt;\r\n|4-1-0-0&lt;!--mandible--&gt;\r\n|3 lobes&lt;!--pecten epipharyngis--&gt;\r\n|slender, almost touching medially, as wide as mentum or distinctly wider, straight or curved&lt;!--ventromental plates--&gt;\r\n|rounded broad&lt;!-- mentum middle --&gt;\r\n|&lt;!--post. parap.--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}&lt;!--reference--&gt;\r\n|Rheotanytarsus&lt;!--taxon--&gt;\r\n|&lt;!--postoccipital plate--&gt;\r\n|2+brush&lt;!--premandible--&gt;\r\n|++ tall&lt;!--antennal pedestal--&gt;\r\n|no&lt;!--antennal spur--&gt;\r\n|cylindrical&lt;!--antenna 1st:2nd segment --&gt;\r\n|3/2-1-1-0&lt;!--mandible--&gt;\r\n|comb or incompletely div. in 3 parts&lt;!--pecten epipharyngis--&gt;\r\n|almost in contact medially, somewhat wider than mentum width, strongly curved anterior margin&lt;!--ventromental plates--&gt;\r\n|1 or 2 notches occasionally distinctly trifid&lt;!-- mentum middle --&gt;\r\n|&lt;!--post. parap.--&gt;\r\n|&lt;!--notes--&gt;\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}&lt;!--reference--&gt;\r\n|Paratanytarsus&lt;!--taxon--&gt;\r\n|&lt;!--postoccipital plate--&gt;\r\n|2+brush&lt;!--premandible--&gt;\r\n|++ tall&lt;!--antennal pedestal--&gt;\r\n|no&lt;!--antennal spur--&gt;\r\n|cylindrical or weakly expanded distally; distinctly &lt; 3rd&lt;!--antenna 1st:2nd segment --&gt;\r\n|3/2-1-1-0&lt;!--mandible--&gt;\r\n|lobes 3-5&lt;!--pecten epipharyngis--&gt;\r\n|medially seperated by less than width of median tooth, slightly wider than mentum&lt;!--ventromental plates--&gt;\r\n|rounded or notched laterally&lt;!-- mentum middle --&gt;\r\n|relatively few claws, 15-20, simple&lt;!--post. parap.--&gt;\r\n|{citeID|1|Heiri et.al. 2004} incised postoccipital margin (in general? Plank)&lt;!--notes--&gt;\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|Refrence\r\n!|differences to genus\r\n!|characters \r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Paratanytarsus\r\n|for Paratanytarsus: antennal segment 2 sometimes distally expanded, premandible with 2 teeth, pecten epipharyngis: 3-5 fingerlike lobes (never palmate)\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Cladotanytarsus\r\n|for Cladotanytarsus: antennal segment 2 wedge-shaped,  &lt;==  segment 3; Lauterborn organs, situated on pedicels which are shorter than organs themselves. Some claws of posterior parapods with fine internal serrations\r\n|}\r\n\r\n\r\n{| style=''border:1px solid;''\r\n|-\r\n!|Reference\r\n!im|premandible\r\n!im|parapods - posterior\r\n!im|poostoccipital plate\r\n!im|antenna - spur\r\n!im|antenna - pedestals\r\n!im|antenna - segment 2\r\n!|mandible    \r\n!im|ventromental plates\r\n!im|mentum - middle\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}:\r\n|&lt;!-- pre --&gt;&gt;2\r\n|&lt;!-- cpp --&gt;few claws, simple arranged like a horse-shoe\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- spur --&gt;yes/no\r\n|&lt;!-- anp --&gt;tall\r\n|&lt;!-- ant2 --&gt;cylindrical\r\n|&lt;!-- man --&gt;3/2-1-1/2-1/2/plate\r\n|&lt;!-- vep --&gt;narrowly separated madially, somwhat wider than mentum\r\n|&lt;!-- men mid --&gt;rounded or laterally notched or crenate\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}:\r\n|&lt;!-- pre --&gt;\r\n|&lt;!-- cpp --&gt;\r\n|&lt;!-- pop --&gt;+++&lt;br&gt;trapezoidal\r\n|&lt;!-- spur --&gt;+ to .\r\n|&lt;!-- anp --&gt;+ to ++\r\n|&lt;!-- ant2 --&gt;\r\n|&lt;!-- man --&gt;3/2-1-1/2-1/2/plate\r\n\r\n|}\r\n\r\n===Systematic comments===\r\n\r\nGodtfred Anker Halvorsen''s comment in a mail: Some systematists belive, I think, that the genus Corynocera are the same as Tanytarsus, but no formal  synonymizing have been done. The name Tanytarsus is a junior synonym of Corynocera, so if that happens all Tanytarsus species will be named  Corynocera.\r\n\r\n==Determination keys==\r\n\r\n===Ekrem 2004===\r\n\r\n''''Key to larvae of species in the Tanytarsus eminulus-, gregarius-, lugens- and mendax species groups'''' from {citeID|310|Ekrem 2004}: \r\n\r\n&laquo;It should be noted that few larvae of European Tanytarsus species have been described, and that there are, at present, no certain diagnostic characters for the larvae of  species in the above groups (see {citeID|537|Ekrem 2003}). This key should therefore be used with caution, and descriptions should be checked in detail for certain identification. Common to all larvae included in the key are: Mandible with three inner teeth; second antennal segment well sclerotized in basal 112-213; antennal pedestal without spur; mentum of normal Tanytarsus type; postoccipital plate at least moderately developed.&raquo;\r\n\r\n#~\r\n## {overlib|Mandible|<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_man_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_man_Paa1972_r.gif 2009-12-15 10:36:17''>} with a large medially directed accessory plate overlying median teeth ({citeID|404|Paasivirta 1972}: fig. 3)~-&gt; T. gracilentus (Holmgren) [A.Plank (Sat Jun 27 2009 16:36:52 GMT+0200) see also Corynocera oliveri]\r\n## If one ore more accessory teeth are present, they never form such a large plate as above~-&gt; 2\r\n#~\r\n## One or more large accessory dorsal teeth present on {overlib|mandible (Fig. 128)|Img:Tany_bphu_man_Ekr2004_r.gif}~-&gt; 3\r\n## Only minute or no accessory dorsal {overlib|mandibular teeth present (Figs 38, 160)|Img:Tany_lest_man_Ekr2004_r.gifImg:Tany_form_man_Ekr2002_r.gif}~-&gt; 5\r\n#~\r\n## Labral seta {overlib|SII pectinate (Fig. 147)|Img:Tany_luge_lab_Ekr2004_r.gif}~-&gt; T. lugens Kieffer\r\n## Labral seta SII simple or with one lateral point~-&gt; 4\r\n#~\r\n## {overlib|Mandible with 3 spines on mola (Fig 168)|Img:Tany_masp_man_Ekr2004_r.gif}; {overlib|Lauterborn organ pedicels without pigmented band (Fig 169)|Img:Tany_masp_ant_Ekr2004_r.gif} ~-&gt; T. mancospinosus Ekrem &amp; Reiss\r\n## {overlib|Mola bare or with fewer spines (Fig 127)|Img:Tany_bphu_man_Ekr2004_r.gif}; {overlib|Lauterborn organ pedicels with pigmented band (Fig 128)|Img:Tany_bphu_ant_Ekr2004_r.gif}~-&gt; T. bathophilus Kieffer\r\n#~\r\n## {overlib|LOR &lt; 2.0 (Fig. 178)|Img:Tany_mend_ant_Ekr2002_r.gif}~-&gt; 6\r\n## {overlib|LOR &gt; 2.0 (Fig. 95)|Img:Tany_stia_ant_Ekr2004_r.gif}~-&gt; 7\r\n#~\r\n## {overlib|Mandible with minute|Img:Tany_form_man_Ekr2002_r.gif} accessory dorsal tooth (Fig. 160)~-&gt; T.formosanus Kieffer\r\n## {overlib|Mandible lacking minute|Img:Tany_mend_man_Ekr2002_r.gif} accessory dorsal tooth (Fig. 179)~-&gt; T.mendx Kieffer\r\n#~\r\n## {overlib|Labral seta SII simple|Img:Tany_ejun_se2_Ekr2004_r.gif}, {overlib|AR about 2.7, LOR about 3.0|Img:Tany_ejun_ant_Ekr2004_r.gif} (Figs 15, 18)~-&gt; T.ejuncidus (Walker)\r\n## If labral seta SII simple and LOR about 3.0, then AR lower than 2.7~-&gt; 8\r\n#~\r\n## Labral seta SII simple~-&gt; 9\r\n## Labral seta SII pectinate or plumose~-&gt; 13\r\n#~\r\n## {overlib|AR about 1.8, LOR about 2.5 (Fig. 37)|Img:Tany_lest_ant_Ekr2004_r.gif}~-&gt; T.lestagei Goetghebuer\r\n## AR &gt; 1.8~-&gt; 10\r\n#~\r\n## {overlib|AR about 2.3, LOR about 3.0 (Fig. 52)|Img:Tany_psle_ant_Ekr2004_r.gif}~-&gt; T.pseudolestagei Shilova\r\n## {overlib|AR about 2.2-2.6, LOR about 2.1-2.4 (Fig. 73)|Img:Tany_medi_ant_Ekr2004_r.gif}~-&gt; 11\r\n#~\r\n## {overlib|Pigmented bands basally on styli of Lauterborn organs|Img:Tany_medi_ant_Ekr2004_r.gif}; {overlib|premandible with 4 teeth|Img:Tany_medi_pre_Ekr2004_r.gif} (Figs 73,75)~-&gt; T.medius Reiss &amp; Fittkau\r\n## {overlib|No pigmented bands basally on styli of Lauterborn organs|Img:Tany_volg_ant_Ekr2004_r.gif}; {overlib|premandible with 3-4 teeth|Img:Tany_volg_pre_Ekr2004_r.gif} (Figs 198, 200)~-&gt; 12\r\n#~\r\n## {overlib|Premandible with 3 teeth|Img:Tany_volg_pre_Ekr2004_r.gif}, {overlib|AR &gt; 2.3|Img:Tany_volg_ant_Ekr2004_r.gif} (Figs 198, 200)~-&gt; T. volgensis Miseiko\r\n## Premandible with 4 teeth, {overlib|AR &lt; 2.3|Img:Tany_occu_ant_Ekr2004_r.gif} (Fig. 185)~-&gt; T. occultus Brundin\r\n#~\r\n## {overlib|Labral seta SII pectinate|Img:Tany_emin_se2_Ekr2004_r.gifImg:Tany_telm_se2_Ekr2004_r.gif}, {overlib|one spine on mola|Img:Tany_emin_man_Ekr2004_r.gif} (Figs 27, 29, 64)~-&gt; 14\r\n## {overlib|Labral seta SII plumose|Img:Tany_stia_se2_Ekr2004_r.gifImg:Tany_grin_se2_Ekr2004_r.gif}; {overlib|two closely set spines on mola|Img:Tany_stia_man_Ekr2004_r.gif} (Figs 96 97 114)~-&gt; 15\r\n#~\r\n## {overlib|AR about 2.5; LOR &gt; 3.2|Img:Tany_telm_se2_Ekr2004_r.gif} (Fig. 61)~-&gt; T. telmaticus Lindeberg\r\n## {overlib|AR about 2.0; LOR about 2.5|Img:Tany_ejun_ant_Ekr2004_r.gif} (Fig. 26)~-&gt; T. eminulus (Walker)\r\n#~\r\n## {overlib|LOR &gt; 3.5|Img:Tany_stia_ant_Ekr2004_r.gif} (Fig. 95)~-&gt; T. striatulus Lindeberg\r\n## LOR &lt; 3.5~-&gt; 16\r\n#~\r\n## {overlib|LOR &gt; 2.7|Img:Tany_dibr_ant_Ekr2004_r.gif}; {overlib|lateral tubules on body segment VIII|<img src=''image.php?text=Image reduced version. Deleted: Tany_dibr_abd_Mol2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_dibr_abd_Mol2001_r.gif 2009-12-15 10:36:17''>} (Fig. 5)~-&gt; T. dibranchius Kieffer in Zavřel\r\n## {overlib|LOR usually &lt; 2.7|Img:Tany_grin_ant_Ekr2004_r.gif}, no lateral tubules on segment body VIII (Fig. 111)~-&gt; T. gregarius Kieffer/T. inaequalis Goetghebuer\r\n\r\n==Specimens==\r\n\r\n{| style=''border:1px solid;''  class=''table-autosort table-autofilter '' \r\n\r\n&lt;thead&gt;\r\n|-\r\n! class=''table-sortable:default ''|Reference\r\n!im90 class=''table-sortable:default ''|Species\r\n!im90 class=''table-sortable:default ''|Type\r\n!im90 class=''table-sortable:default ''|Antennal pedestal (L2W)\r\n!im90 class=''table-sortable:default ''|Spur of antenna (L2W)\r\n!im90 class=''table-sortable:default ''|Postoccipital plate\r\n!im90 class=''table-sortable:default ''|Mandible inner-apical-outer-surface tooth\r\n\r\n|-\r\n! class=''table-filterable''|\r\n!|&lt;input name=''filterSpecies1'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterType2'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAntennal3'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterSpur4'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterPostoccipital5'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterMandible6'' size=''8'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. brundini Lindeberg&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_brun_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_brun_men_WCh1983_r.gif 2009-12-15 10:36:17''>\r\n|''''''chinyensis type''''''\r\n|1.5 planar on top\r\n|4.2 &lt;br&gt;+++&nbsp;very long, often inwards\r\n|well developed&lt;br&gt;{brownish}&nbsp;({pale})\r\n|3-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_brun_man_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_brun_man_WCh1983_r.gif 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. chinyensis Goetghebuer&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_chin_men1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_chin_men1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''chinyensis type''''''\r\n|1.6-1.8 planar on top\r\n|4.2? as T. brundini&lt;br&gt;+++&nbsp;very long, often inwards\r\n|well developed&lt;br&gt;{brownish}&nbsp;({pale})\r\n|3-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_chin_man1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_chin_man1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. lactescens Edwards&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_lact_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_lact_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''lactescens type''''''\r\n|2 diagonal on top\r\n|1.2&lt;br&gt;+&nbsp;medium, straight\r\n|well developed&lt;br&gt;very {pale}\r\n|2-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_lact_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_lact_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. signatus v.d.Wulp&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_sign_men1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_sign_men1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''lactescens type''''''\r\n|1.6 diagonal on top\r\n|1.0&lt;br&gt;+&nbsp;medium, straight\r\n|well developed&lt;br&gt;&lt;span class=''pale''&gt;very pale&lt;/span&gt;\r\n|2-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_sign_man1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_sign_man1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. buchonius Reiss &amp; Fittkau&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_buch_men1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_buch_men1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''''pallidicornis'' type''''''\r\n|1.5-1.6 slightly diagonal on top\r\n|0.5&lt;br&gt;.&nbsp;small roundish hump\r\n|well developed&lt;br&gt;&lt;span class=''brownish''&gt;brownish to&lt;/span&gt;&nbsp;{pale}\r\n|3-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_buch_man1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_buch_man1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. usmaensis Pagast&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_usma_men_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_usma_men_Hei2004_r.gif 2009-12-15 10:36:17''>\r\n|''''''''pallidicornis'' type''''''\r\n|1.5 slightly diagonal on top\r\n|0.2?&lt;br&gt;.&nbsp;small roundish hump\r\n|well developed&lt;br&gt;&lt;span class=''brownish''&gt;brownish to&lt;/span&gt;&nbsp;{pale}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_usma_pop_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_usma_pop_Hei2004_r.gif 2009-12-15 10:36:17''>\r\n|3-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_usma_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_usma_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. sp. type VI\r\n|''''''type VI''''''\r\n|?\r\n|.&nbsp;small roundish hump\r\n|?\r\n|2-1-1-0\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. nemorosus Edwards&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_nemu_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_nemu_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''nemorosus type'''''' \r\n|1.5 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;&lt;span class=''pale''&gt;very pale&lt;/span&gt;\r\n|2-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_nemu_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_nemu_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. dibranchius Kieffer&lt;br&gt;Img:Tany_dibr_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|0.9 seems to be planar on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_dibr_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_dibr_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. ejuncidus (Walker)&lt;br&gt;Img:Tany_ejun_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.4 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_ejun_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_ejun_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|3-1-1-0&lt;br&gt;Img:Tany_ejun_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. eminulus (Walker)&lt;br&gt;Img:Tany_emin_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.4 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_emin_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_emin_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. formosanus Kieffer&lt;br&gt;Img:Tany_form_men_Ekr2002_r.gif\r\n|''''''mendax type''''''\r\n|0.9 seems to be planar on top; conical\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}\r\n|3-1-1-0&lt;br&gt;Img:Tany_form_man_Ekr2002_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. gibbosiceps Kieffer&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_gibb_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_gibb_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''mendax type''''''\r\n|1.5 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_gibb_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_gibb_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|3-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_gibb_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_gibb_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. gregarius Kieffer / T. inaequalis Goetghebuer&lt;br&gt;Img:Tany_grin_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.3&lt;br&gt;{citeID|310|Ekrem 2004}&lt;br&gt;+/++&lt;br&gt;&nbsp;medium/long\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_grin_pom_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_grin_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. lestagei Ghoetghebuer&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_lest_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_lest_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''mendax type''''''\r\n|1-1.1 planar on top; conical\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_lest_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_lest_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. mendax Reiss &amp; Fittkau&lt;br&gt;Img:Tany_mend_men_Ekr2002_r.gif\r\n|''''''mendax type''''''\r\n|1.4 seems to be planar on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_mend_pop1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_mend_pop1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|3-1-1-0&lt;br&gt;Img:Tany_mend_man_Ekr2002_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. medius Kieffer&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_medi_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_medi_men_Tsa1999_r.gif 2009-12-15 10:36:17''>&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_medi_men1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_medi_men1_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''mendax type''''''\r\n|1-1.1 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_medi_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_medi_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. occultus Brundin&lt;br&gt;Img:Tany_occu_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.5-1.6 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_occu_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_occu_man_Hei2004_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_occu_man_Hei2004_r.gif 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004} {citeID|310|Ekrem 2004}\r\n|T. pseudolestagei Shilova&lt;br&gt;Img:Tany_psle_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.1 seems to be diagonal on top conical\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_psle_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_psle_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004} {citeID|310|Ekrem 2004}\r\n|T. striatulus Lindeberg&lt;br&gt;Img:Tany_stia_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.0&lt;br&gt;{citeID|310|Ekrem 2004}&lt;br&gt;+/++&lt;br&gt;&nbsp;medium/long\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_stia_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_stia_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. telmaticus  Lindeberg&lt;br&gt;Img:Tany_telm_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.4 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_telm_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_telm_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. volgensis Miseiko&lt;br&gt;Img:Tany_volg_men_Ekr2004_r.gif\r\n|''''''mendax type''''''\r\n|1.1-1.2 slightly diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark}&nbsp;to {pale}&lt;br&gt;Img:Tany_volg_pop_Ekr2004_r.gif\r\n|3-1-1-0&lt;br&gt;Img:Tany_volg_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. type C {citeID|278|Hofman 1971} (fossil material)&lt;br&gt;T.glabrescens {citeID|276|Edwards 1929} as mentioned by {citeID|302|Brooks et.al. 2007}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_typc_men_Hof1971_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_typc_men_Hof1971_r.gif 2009-12-15 10:36:17''>\r\n|''''''type C''''''\r\n|0.9-1 planar on top\r\n|0.8&lt;br&gt;.&nbsp;small roundish hump\r\n|well develloped, plate and margin very {pale}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_specC_pom_Hei2004_r.jpeg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_specC_pom_Hei2004_r.jpeg 2009-12-15 10:36:17''>\r\n|3-1-2-2&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_typc_man_Hof1971_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_typc_man_Hof1971_r.gif 2009-12-15 10:36:17''>\r\n\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. bathophilus Kieffer&lt;br&gt;Img:Tany_bphu_men_Ekr2002_r.gif\r\n|''''''lugens type''''''\r\n|1.2 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark} to&nbsp;{pale}&lt;br&gt;Img:Tany_bphu_pop_Ekr2004_r.gif\r\n|3-1-1-1&lt;br&gt;Img:Tany_bphu_man_Ekr2002_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004} {citeID|404|Paasivirta 1972}\r\n|T. gracilentus {citeID|403|Holmgren 1883}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17''>&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_men_Bro2007_r.jpeg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_men_Bro2007_r.jpeg 2009-12-15 10:36:17''>\r\n|''''''lugens type''''''\r\n|1.5 {citeID|404|Paasivirta 1972} &lt;br&gt;1.4 {citeID|302|Brooks et.al. 2007}&lt;br&gt;+/++&lt;br&gt;&nbsp;medium/long\r\n|no\r\n|?\r\n|3-1-3-2&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_man_Mol2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_man_Mol2001_r.gif 2009-12-15 10:36:17''>&lt;br&gt;({citeID|17|Moller-Pillot and Goddeeris 2001})&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_man_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_man_Paa1972_r.gif 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}\r\n|Corynocera oliveri {citeID|467|Lindeberg 1970}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17''>\r\n|''''''lugens type''''''&lt;br&gt; but a Corynocera \r\n|1.3 {citeID|25|Walker 2000} \r\n|no\r\n|?\r\n|3-1-3-2&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Coce_olie_man_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Coce_olie_man_WCh1983_r.gif 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. lapponicus Lindeberg&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_lapo_men_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_lapo_men_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|''''''lugens type''''''\r\n|1.3-1.4 diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark} to&nbsp;{pale}&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_lapo_pop_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_lapo_pop_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n|3-1-2-1(plate-like)&lt;br&gt;<img src=''image.php?text=Image reduced version. Deleted: Tany_lapo_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_lapo_man_Hei2004_r.jpg 2009-12-15 10:36:17''>\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. lugens Kieffer&lt;br&gt;Img:Tany_luge_men_Ekr2004_r.gif\r\n|''''''lugens type''''''\r\n|1.6&lt;br&gt;{citeID|310|Ekrem 2004}&lt;br&gt;+/++&lt;br&gt;&nbsp;medium/long\r\n|no\r\n|well developed&lt;br&gt;{dark} to&nbsp;{pale}\r\n|3-1-2-1&lt;br&gt;Img:Tany_luge_man_Ekr2004_r.gif\r\n\r\n|-\r\n|{citeID|1|Heiri et.al. 2004}\r\n|T. mancospinosus Ekrem &amp; Reiss&lt;br&gt;Img:Tany_masp_men_Ekr2004_r.gif\r\n|''''''lugens type''''''\r\n|1.9-2 slightly diagonal on top\r\n|no\r\n|well developed&lt;br&gt;{dark} to&nbsp;{pale}&lt;br&gt;Img:Tany_masp_pop_Ekr2004_r.gif\r\n|3-1-1-1&lt;br&gt;Img:Tany_masp_man_Ekr2004_r.gif\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n\r\n\r\n\r\n===Fossil larvae===\r\n\r\n{citeID|1|Heiri et.al. 2004}: In fossil fourth-instar larvae the medium-sized to long antennal pedestals and the large, often trapezoidal postoccipital plate will often separate Tanytarsus from other Tanytarsini. The examined Tanytarsus species may feature a large, backwards-curving, a medium-sized straight and blunt or a short and blunt spur on the antennal pedestal. However, none of them features a short and sharp spur as can be found in many Micropsectra larvae. \r\n\r\n==Checklist (China)==\r\n\r\nIn China ({citeID|279|Wang 2000}): \r\n*T.bifurcus Freeman male \r\n*T.chinensis Goetghebuer male {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Tany_chin_men1_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_chin_men1_Hei2004_r.jpg 2009-12-15 10:36:17''><img src=''image.php?text=Image reduced version. Deleted: Tany_chin_men2_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_chin_men2_Hei2004_r.jpg 2009-12-15 10:36:17''>}\r\n*T.ejuncidus (Walker) male {overlib|mentum|Img:Tany_ejun_men_Ekr2004_r.gif}\r\n*T.fimbriatus Reiss male\r\n*T.formosanus Kieffer male female  {overlib|mentum|Img:Tany_form_men_Ekr2002_r.gif}\r\n*T.gracilentus (Holmgren) male {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17''><img src=''image.php?text=Image reduced version. Deleted: Tany_grac_men_Bro2007_r.jpeg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_men_Bro2007_r.jpeg 2009-12-15 10:36:17''>}\r\n*T.gregarius Kieffer {overlib|mentum of T.gregarius-inaequalis|Img:Tany_grin_men_Ekr2004_r.gif}\r\n*T.holochlorus Edwards male female\r\n*T.inaequalis Goetghebuer male {overlib|mentum of T.gregarius-inaequalis|Img:Tany_grin_men_Ekr2004_r.gif}\r\n*T.kyotoensis (Tokunaga)\r\n*T.lestagei Goetghebuer male \r\n*T.lobatifrons Kieffer {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Tany_lobf_men_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_lobf_men_WJi1987_r.gif 2009-12-15 10:36:17''>}\r\n*T.oyamai Sasa  {overlib|mentum|Img:Tany_oyam_men_Ekr2002_r.gif<img src=''image.php?text=Image reduced version. Deleted: Tany_oyam_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_oyam_men_Ye1984_r.gif 2009-12-15 10:36:17''>}\r\n*T.pectus Guha and Chaudhuri male\r\n*T.takahshii Kawai and Sasa male\r\n*T.tamaotoi Sasa male\r\n*T.trichoproctos Wang male\r\n*T.uraiensis Tokunaga male female {overlib|mentum|Img:Tany_urai_men_Ekr2002_r.gif}\r\n*T.verralli Goetghebuer male {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Tany_verr_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_verr_men_Tsa1999_r.gif 2009-12-15 10:36:17''>}\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Tanytarsus as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n===Eutrophication===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Tanytarsus lugens Kieff. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus niger And. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus usmaensis Pag. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n\r\n|-\r\n|Tanytarsus bathophilus Kieff. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus decipiens Lind. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || || ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus gregarius Kieff. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus inaequalis Goetgh. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus lugens Kieff. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||***** ||***** ||***** || || || || || || || || || || ||&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus n. sp. lestagei &ndash; aggl. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus palmeni Lind. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n===Temperature===\r\n\r\nMicropsectra gr.B/Tanytarsus gr.B reported by {textciteID|516|Korhola et al. 2002} as intermediate taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxa:\r\n*Tanytarsus sp. B  and other taxa: 12.7&deg;C &plusmn; 3.8, n=67 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n*Tanytarsus undifferentiated  and other taxa: 0&deg;C &plusmn; 0, n=92 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Tanytarsus s. lat. (n=40, Template:explained:N2:HillsDiversity=34.41, n&lt;sub&gt;max&lt;/sub&gt;=31.58) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 1.\r\n\r\n{textciteID|492|Brodersen et al. 2004} report for Tanytarsus sp. in lake Tasersuatsiaq (West Greenland) an oxygen consumption of 3.38 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 33.6 in % is in group {overlib|B|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  750~ha (lake area); 66.97898&deg;N; 50.69489&deg;W; 55~&micro;S~&middot; cm⁻&sup1;; 11.8&deg;C (July 2002); max. depth: &gt;80~m.\r\n\r\n\r\n===Conductivity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Tanytarsus spp. in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 780.54mg &middot; l⁻&sup1; (&divide; 600 = 1.3mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 7.73835. In article shortened as: Tt.\r\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(883, 1682, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Brillia flavifrons (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(884, 1683, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Chironomus bernensis (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(56, 176, NULL, NULL, 1, NULL, '202 17', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(57, 177, NULL, '==Characteristics==\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|references\r\n!im|specimen\r\n!im90|antenna\r\n!im90|seta s1\r\n!im90|premandible\r\n!im90|mandible\r\n!im90|mandible - seta interna\r\n!im90|mentum - teeth (inner+lateral)\r\n!im90|procerus\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}\r\n|Thienemannia sp.\r\n|5 seg. 3 shorter than fourth&lt;!-- antenna --&gt;\r\n| plumose &lt;!-- s1 --&gt;\r\n| 2+2 inner&lt;!-- premandible --&gt;\r\n| 3/4-1-0-0&lt;br&gt; apical shorter than combined inner teeth&lt;!-- mandible --&gt;\r\n| 7 smooth weakly serrated branches&lt;!-- mandible seta interna --&gt;\r\n| 2+5; v.plates weak no beard&lt;!-- mentum --&gt;\r\n| short rounded weakly sclerotized, no spur&lt;!-- procerus --&gt;\r\n\r\n|}\r\n\r\nComments by {citeID|21|Cranston et.al. 1983}: The above diagnosis is based on the description by Potthast ({citeID|409|Potthast 1914}, as Metriocnemus clavaticornis (Kieffer), four tentatively associated larvae of T. gracilis (Kieffer), collected in the Netherlands by Dr. H. K. M. Moller-Pillot and agreeing with the description by Potthast, and on two larvae in the Zoologisches Staatssammlung, Munich, determined as Metriocnemus clavaticornis? While the abdomen appear identical there are differences in the mentum, the number of mandibular teeth and the presence or absence of labral lamellae. However, both types of larvae are separable from Metriocnemus by means of the short, weakly sclerotized procerci without spurs and the long supraanal seta, and both species  are here regarded as belonging in Thienemannia.\r\n\r\nGenus Thienemannia in {citeID|279|Wang 2000} for China not mentioned.', 1, NULL, '86 19', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(58, 178, NULL, '==Characters==\r\n\r\n{citeID|20|Schmid 1993}: in contrast to Corynoneura Thienemanniella has 5 segments on antenna.\r\n*''''Mandible:'''' apical tooth subequal to first of 4 inner teeth, \r\n*Seta subdentalis weak or absent. Seta interna with 6 plumose branches&lt;br&gt;\r\n\r\n{citeID|21|Cranston et.al. 1983}: Thienemanniella is a distinctive genus, sharing with Corynoneura \r\n*the modified chaetulae laterales and labral setae, fused meso- and metathoracic segments, ventrobasal spine on the posterior parappods as well as the elongate antennae.\r\nOther genera with similar length antennae are \r\n*Heterotanytarsus, with a large alternate Lauterborn organs, \r\n*Lopescladius with a divided second antennal segment and \r\n*Rheosmittia with alternate Lauterborn organs on the second antennal segment. &lt;br&gt;\r\nThienemanniella larvae are separable from those of Corynoneura by the 5 segmented antenna in the former genus, 4 segmented in the latter.\r\n\r\n{| style=''border:1px solid;''\r\n!|Reference \r\n!im|head\r\n!im|postoccipital margin\r\n!im90|antenna\r\n!im90|antenna (note)\r\n!im90|antennal blade\r\n!|s 1\r\n!|s 2-3\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!im90|premandible brush\r\n!im90|mentum (middle)\r\n!im90|mentum (lateral)\r\n!im90|seta submenti (mentum)\r\n!im90|ventromental plates\r\n!im90|mandible\r\n!im90|seta interna (mandible)\r\n!im90|pecten galearis (maxilla)\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt; to &lt;span class=''darkbrown''&gt;dark brown&lt;/span&gt; \r\n|darkened\r\n|5\r\n|&gt; 0,5x length of head capsule\r\n|not longer than 2nd segment\r\n|bifid\r\n|simple\r\n|3 spines\r\n|1\r\n|yes\r\n|1-3\r\n|5\r\n|well posterior to base of ventromental plates\r\n|weakly\r\n|4-1-0-0\r\n|6 serrated branches\r\n|no\r\n|}\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''one''\r\n|-\r\n!im90|Reference\r\n!|Taxon\r\n!|Head\r\n!im90|head (L:W)\r\n!im90|postoccipital margin\r\n!im90|antennal ratio (1 to remaining)\r\n!im90|premandible\r\n!im90|mentum (outer teeth)\r\n!im90|mentum relation widths subm-setae to outer-teeth\r\n!im90|mentum relation heights subm-setae to outer-teeth\r\n!im90|mandible\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;!--reference--&gt;\r\n|T. acuticornis Lenz, 1939&lt;br&gt;&lt;img align=''middle'' width=200 title=''Thienemanniella_acuticornis_(mentum)'' src=''image.php?text=image deleted: Thme_acuc_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!--taxon--&gt;\r\n|{yellow} &lt;!--head --&gt;\r\n|1.462 +- 0.12 (n=4) &lt;!--head (L:W)--&gt;\r\n|&lt;span class=''dark''&gt;black&lt;/span&gt; &lt;!--postoccipital margin--&gt;\r\n|1.897 +- 0.092 (n=5) &lt;!--antennal ratio--&gt;\r\n|1 broad + brush &lt;!--premandible--&gt;\r\n|6 pairs &lt;!--mentum (outer teeth)--&gt;\r\n|2.654 (n=1) &lt;!--mentum ratio widths--&gt;\r\n|3.705 (n=1) &lt;!--mentum ratio heights--&gt;\r\n|4-1-0-0&lt;br&gt;equal &lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;!--reference--&gt;\r\n|T. clavicornis Kieffer, 1911&lt;br&gt;&lt;img align=''middle'' width=200 title=''Thienemanniella clavicornis (mentum)'' src=''image.php?text=image deleted: Thme_clav_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!--taxon--&gt;\r\n|{brown} &lt;!--head --&gt;\r\n|1.698 +- 0.092 (n=5) &lt;!--head (L:W)--&gt;\r\n|&lt;span class=''dark''&gt;black&lt;/span&gt; &lt;!--postoccipital margin--&gt;\r\n|1.339 +- 0.039 (n=5) &lt;!--antennal ratio--&gt;\r\n|1 broad + brush &lt;!--premandible--&gt;\r\n|3 median, 5 pairs &lt;!--mentum (outer teeth)--&gt;\r\n|1.484 (n=1) &lt;!--mentum ratio widths--&gt;\r\n|2.494 (n=1) &lt;!--mentum ratio heights--&gt;\r\n|4-1-0-0&lt;br&gt;apical-small &lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;!--reference--&gt;\r\n|T. partita Schlee, 1968&lt;br&gt;&lt;img align=''middle'' width=200 title=''Thienemanniella partita (mentum)'' src=''image.php?text=image deleted: Thme_part_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!--taxon--&gt;\r\n|{yellow} &lt;!--head --&gt;\r\n|1.555 +- 0.398 (n=7) &lt;!--head (L:W)--&gt;\r\n|&lt;span class=''dark''&gt;black&lt;/span&gt; &lt;!--postoccipital margin--&gt;\r\n|1.526 +- 0.050 (n=7) &lt;!--antennal ratio--&gt;\r\n|1 broad + brush &lt;!--premandible--&gt;\r\n|3 median, 5 pairs evenly decreasing &lt;!--mentum (outer teeth)--&gt;\r\n|1.352 (n=1) &lt;!--mentum ratio widths--&gt;\r\n|2.711 (n=1) &lt;!--mentum ratio heights--&gt;\r\n|4-1-0-0&lt;br&gt;apical-small &lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;!--reference--&gt;\r\n|T. cf. majuscula Edwards, 1939&lt;br&gt;&lt;img align=''middle'' width=200 title=''Thienemanniella majuscula cf. (mentum)'' src=''image.php?text=image deleted: Thme_majucf_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!--taxon--&gt;\r\n|{yellow} &lt;!--head --&gt;\r\n|1.383 +- 0.314 (n=6) &lt;!--head (L:W)--&gt;\r\n|&lt;span class=''dark''&gt;black&lt;/span&gt; &lt;!--postoccipital margin--&gt;\r\n|1.403 +- 0.027 (n=6) &lt;!--antennal ratio--&gt;\r\n|1 broad + brush &lt;!--premandible--&gt;\r\n|3 median, 5 pairs &lt;!--mentum (outer teeth)--&gt;\r\n|1.379 (n=1) &lt;!--mentum ratio widths--&gt;\r\n|2.936 (n=1) &lt;!--mentum ratio heights--&gt;\r\n|4-1-0-0&lt;br&gt;apical &gt; 1st inner &lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;!--reference--&gt;\r\n|T. vittata Edwards, 1929&lt;br&gt;&lt;img align=''middle'' width=200 title=''Thienemanniella vittata (mentum)'' src=''image.php?text=image deleted: Thme_vitt_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!--taxon--&gt;\r\n|{yellow} &lt;!--head --&gt;\r\n|1.623 +- 0.190 (n=8) &lt;!--head (L:W)--&gt;\r\n|&lt;span class=''dark''&gt;black&lt;/span&gt; &lt;!--postoccipital margin--&gt;\r\n|1.365 +- 0.043 (n=10) &lt;!--antennal ratio--&gt;\r\n|1 broad + brush &lt;!--premandible--&gt;\r\n|3 median, 5 pairs evenly decreasing &lt;!--mentum (outer teeth)--&gt;\r\n|1.473 (n=1) &lt;!--mentum ratio widths--&gt;\r\n|2.188 (n=1) &lt;!--mentum ratio heights--&gt;\r\n|4-1-0-0&lt;br&gt;apical &lt;== 1st inner &lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;!--reference--&gt;\r\n|T. sp. D {citeID|20|Schmid 1993}&lt;br&gt;&lt;img align=''middle'' width=200 title=''Thienemanniella sp. D (mentum)'' src=''image.php?text=image deleted: Thme_specD_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!--taxon--&gt;\r\n|{brown} &lt;!--head --&gt;\r\n|1.433 +- 0.103 (n=4) &lt;!--head (L:W)--&gt;\r\n|&lt;span class=''dark''&gt;black&lt;/span&gt; &lt;!--postoccipital margin--&gt;\r\n|1.154 +- 0.102 (n=4) &lt;!--antennal ratio--&gt;\r\n|1 broad + brush &lt;!--premandible--&gt;\r\n|3 median, 5 pairs &lt;!--mentum (outer teeth)--&gt;\r\n|1.638 (n=1) &lt;!--mentum ratio widths--&gt;\r\n|2.365 (n=1) &lt;!--mentum ratio heights--&gt;\r\n|4-1-0-0&lt;br&gt;apical-short &lt;!--mandible--&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;!--reference--&gt;\r\n|T. sp. E {citeID|20|Schmid 1993}&lt;br&gt;&lt;img align=''middle'' width=200 title=''Thienemanniella sp. E (mentum)'' src=''image.php?text=image deleted: Thme_specE_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;!--taxon--&gt;\r\n|&lt;span class=''darkbrown''&gt;darkbrown&lt;/span&gt; &lt;!--head --&gt;\r\n|1.477 +- 0.171 (n=4) &lt;!--head (L:W)--&gt;\r\n|&lt;span class=''dark''&gt;black&lt;/span&gt; &lt;!--postoccipital margin--&gt;\r\n|1.154 +- 0.102 (n=6) &lt;!--antennal ratio--&gt;\r\n|1 broad + brush transparent &lt;!--premandible--&gt;\r\n|3 median, 5 pairs &lt;!--mentum (outer teeth)--&gt;\r\n|1.567 (n=1) &lt;!--mentum ratio widths--&gt;\r\n|2.319 (n=1) &lt;!--mentum ratio heights--&gt;\r\n|4-1-0-0&lt;br&gt;apical (slightly) &gt;== 1st inner &lt;!--mandible--&gt;\r\n\r\n|}\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*T.clavicornis (Kieffer) {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Thme_clav_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Thme_clav_men_Sch1993_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: Thme_clav_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Thme_clav_men_WOr1983_r.gif 2009-12-15 10:36:17''>}\r\n*T.majuscula (Edwards) {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Thme_majucf_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Thme_majucf_men_Sch1993_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: Thme_maju_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Thme_maju_men_WSD1991_r.gif 2009-12-15 10:36:17''>}\r\n*T.vittata (Edwards)  {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Thme_vitt_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Thme_vitt_men_Sch1993_r.gif 2009-12-15 10:36:17''>}', 1, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*8 have statistically significant (sigmoidal Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n\r\nCorynoneura sp./Thiemanniola sp.[sic, probably Thienemanniella] reported by {citeID|516|Korhola et al. 2002} as warm adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Corynoneura/Thienemanniella (n=36, Template:explained:N2:HillsDiversity=24.8, n&lt;sub&gt;max&lt;/sub&gt;=14.68) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 32.\r\n', '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(59, 182, NULL, '''''{citeID|2|Pinder and Reiss 1983}: ''''  Tribelos larvae may be recognized and seperated from the closly related genera Endochironomus, Phaenopsectra and Sergentia by the follwoing combination of characters: \r\n\r\n* frontal apoptome and labral sclerite 1 and 2 present (Phaenopsectra and Sergentia have frontoclypeal apotome and labral sclerite 2),\r\n* trifid pecten epipharyngis with additional teeth an surface (Phaenopsectra  and Sergentia without such teeth),\r\n* seta premandibilarids simple (distally divided only in Endochironomus),\r\n* only 2 of the 4 median teeth of mentum delineated from rest of mentum (in Phaenopsectra and Sergentia all 4 median teeth are delinated)\r\n* and mandible with 3 inner teeth as in Phaenopsectra (Sergentia with 4 inner teeth)\r\n\r\nAs a Result of the lamost identical mentum, larvae of Tribelos species have usually been erroneously identified as Endochironomus  or Phaenopsectra and vice versa. There is now sufficient ma terial available for these genera to be distinguished as larvae.[...] The generic Position of other species is an  open question.\r\n', 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Tribelos (n=7, Template:explained:N2:HillsDiversity=5.69, n&lt;sub&gt;max&lt;/sub&gt;=4.71) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 28.\r\n', '44 223 154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(60, 184, NULL, NULL, 1, NULL, '65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(61, 186, NULL, '==Characters==\r\n\r\n{citeID|2|Pinder and Reiss 1983}: Larvae of Tvetenia are distinguished from those of Eukiefferiella by the\r\n*long body setae, \r\n*well developed procerus and\r\n*{overlib|subdivided S1|&lt;img align=''middle'' title=''Tvetenia bavarica (setae S1, ...) Schmid 1993'' src=''image.php?text=image deleted: Tvet_bava_set_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} (which is difficult to see in some species).\r\n\r\n{| style=''border:1px solid;''\r\n!|Reference \r\n!im|head\r\n!im|postoccipital margin\r\n!im90|antenna\r\n!im|antenna (note)\r\n!|s 1\r\n!im|premandible\r\n!im90|mentum (middle)\r\n!im90|mentum (lateral)\r\n!im|mentum (patterns)\r\n!im|mentum (seta submenti)\r\n!im|mandible\r\n!im|seta interna (mandible)\r\n!im|inner margin (mandible)\r\n!im|pecten galearis (maxilla)\r\n!im|lacinal chaeta (maxilla)\r\n!im|abdomen\r\n!im|procerus\r\n\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;span class=''yellow''&gt;yellow&lt;/span&gt; to&lt;br&gt; &lt;span class=''yellowbrown''&gt;yellow brown&lt;/span&gt;\r\n|{pale} or black\r\n|5\r\n|4th segment longer/subequal than 3rd \r\n|3-4 branches\r\n|1 blunt \r\n|1-2\r\n|5\r\n|sclerotization with irregular, paler longitudinal bands, thus striated\r\n|near base of ventromental plates or distinctly separated\r\n|3-1-0-0\r\n|5-6 weakly serrated branches\r\n|with or without spines\r\n|present\r\n|serrated, outermost: triangular and broadened\r\n|body setae strongly developed, at least 0,5 length of segment bearing them. \r\n|5-10 anal setae (&gt;== 450&micro;m)\r\n|}\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|Reference\r\n!|species\r\n!im|mandible inner teeth\r\n!im|mandible inner margin (mola): spines\r\n!im|mentum middle teeth\r\n!im|mentum submental setaion-lateral tooth\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|T.calvescens&lt;br&gt;&lt;img align=''middle'' width=200 title=''Tvetenia calvescens (mentum)'' src=''image.php?text=image deleted: Tvet_calv_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|3.5\r\n|2\r\n|2\r\n|4-4.5\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|T.discoloripes&lt;br&gt;&lt;img align=''middle'' width=200 title=''Tvetenia discoloripes (mentum)'' src=''image.php?text=image deleted: Tvet_disc_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n|3\r\n|0\r\n|2\r\n|3\r\n\r\n|-\r\n|{citeID|40|Wang and Wang 1991}\r\n|T.verralli&lt;br&gt;&lt;img align=''middle'' width=200 title=''Tvetenia verralli (mentum)'' src=''image.php?text=image deleted: Tvet_verr_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;br&gt;{citeID|12|Klink and Moller-Pillot 2003}: T.verralli can be separated from the other Tvetenia species by: Smooth mola and {overlib|antennal blade reaching the tip of the 3rd antennal|&lt;img align=''middle'' width=60 title=''Tvetenia verralli (antenna) Wang and Wang 1991'' src=''image.php?text=image deleted: Tvet_verr_ant_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} segment.\r\n|?\r\n|0\r\n|2\r\n|4\r\n\r\n|}\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*T.calvescens (Edwards) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Tvetenia calvescens (mentum) Schmid 1993'' src=''image.php?text=image deleted: Tvet_calv_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*T.discoloripes (Goetghebuer) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Tvetenia discoloripes (mentum) Schmid 1993'' src=''image.php?text=image deleted: Tvet_disc_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*T.veralli (Edwards) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Tvetenia verralli (mentum) Wang and Wang 1991'' src=''image.php?text=image deleted: Tvet_verr_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Tvetenia as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n===Conductivity===\r\n\r\n{citeauthorID|489|Rossaro et al. 2006}~({citeyearID|489|Rossaro et al. 2006}, {citeyearID|536|Rossaro et al. 2004})  report a conductivity for Tvetenia bavarica in Alpine running waters of 48.44&micro;S &middot; cm⁻&sup1; &plusmn;~12.03 (min-max: 7-124, n=11).\r\n', '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(62, 197, NULL, NULL, 1, NULL, '20 43 9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(63, 202, NULL, 'not mentioned for China ({citeID|279|Wang 2000})', 1, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Georthocladius sp./Parachaetocladius sp.  and other taxa: 11.1m &plusmn; 4.9 (n=5). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', '17 106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(64, 205, NULL, NULL, 1, NULL, '202 17 176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(65, 206, NULL, 'Propsilocerus has a ''''bifid'''' premandible, wheras that of Tokunagayusurika is simple. Also Propsilocerus has anormal shaped head capsule, and Tokunagayusurika has a pear-shaped head capsule ({citeID|21|Cranston et.al. 1983})', 1, NULL, '132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(66, 207, NULL, '{| frame=border \r\n|-\r\n!|Reference\r\n!im|premandible\r\n!im|posterior parapods\r\n!im|antennal spur\r\n!im|postoccipital plate\r\n!im|postoccipital margin\r\n!im|antennal pedestal\r\n!im|mandible\r\n!im|ventromental plates\r\n!im|median tooth (mentum)\r\n|-\r\n|{citeID|2|Pinder and Reiss 1983}:\r\n|5\r\n|&lt;!-- claws pp. --&gt; characteristic(!) - bear a pad or row of very strong hooklets in addition to usual simple hooks\r\n|&lt;!-- spur --&gt;no\r\n|&lt;!-- pop --&gt;\r\n|&lt;!-- pom --&gt;\r\n|&lt;!-- anp --&gt;++&lt;br&gt;tall\r\n|&lt;!-- man --&gt;3-1-1-0&lt;br&gt;brown teeth\r\n|&lt;!-- ventr.pl --&gt;very close together medially, 1.1-1.2x witdh of mentum\r\n|rounded or pointed\r\n|}\r\n&lt;br&gt;', 1, NULL, '119 88 23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(67, 210, NULL, 'Parapsectrocladius: a new genus of Orthocladiinae Chironomidae (Diptera) from Patagonia, the southern Andes. Insect Syst. Evol. 31:103-120', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(68, 215, NULL, '{nociteID|418|Roback and Tennessen 1978}\r\n{nociteID|419|Roback 1989}\r\n\r\nIn China ({citeID|279|Wang 2000}) only:\r\n*D.sp.', 1, NULL, '130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(69, 223, NULL, '{citeID|2|Pinder and Reiss 1983}: Phaenopsectra larvae may be readily separated from the similar larvae of Tribelos by\r\n*the absense of labral sclerite 1 and the 3 plates of the pecten epipharyngis, which are serrated only distally. \r\nThe most closely related genus, Sergentia, invariably has 4 rather than 3 inner mandibular teeth. Sergentia is not a synonym of Phaenopsectra but a separate genus. The larvae of an undescribed species from southern North America, reared to imago, indicates that the generic concept of Phaenopsectra needs  broadening.  This  larva  differs  from  Phaenopsectra s.str. in having light-brown, not shining-black mentum and mandibles. The dorsal tooth of the mandible is strongly protruding. All 4~median teeth of mentum are about equal in length. The fourth lateral tooth of the mentum is as long as the neighbouring teeth. In addition the imago differs in several respects from Phaenopsectra s.str.', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Phaenopsectra as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n{textciteID|2|Pinder and Reiss 1983}: Larvae of Phaenopsectra occur in sandy and muddy sediments of small standing waters and flowing waters. They also occur in [so-called] ''''''Aufwuchs'''''' of submerged water plants and hard substrata. The genus has a Holarctic distrbution. In the Palaearctic there are at least 3 species, in the Nearctic there are 9, with some species in common. Whether all Nearctic species belong to Phaenopsectra is questionable.\r\n\r\n===Salinity===\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Phaenopsectra sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Phaenopsectra the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n\r\n\r\n', '227 154 182 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(70, 245, NULL, NULL, 0, NULL, '130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(71, 264, NULL, NULL, 0, NULL, '65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(72, 265, NULL, NULL, 0, NULL, '15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(73, 266, NULL, NULL, 0, NULL, '15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(74, 267, NULL, NULL, 0, NULL, '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(75, 268, NULL, NULL, 0, NULL, '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(76, 269, NULL, NULL, 0, '==Biotops==\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Dicrotendipes nervosus (Staeg.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Dicrotendipes nervosus (Staeg.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Salinity===\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Dicrotendipes nervosus (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(77, 270, NULL, NULL, 0, '==Eutrophication==\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Some taxa, e.g. Dicrotendipes pulsus type, Pagastiella orophila and Ablabesmyia monilis type, showed very even distributions among the lakes.&raquo; [..] &laquo;Some clearly eurytopic taxa were recognised, including constantly and abundantly appearing Microtendipes pedellus type, Psectrocladius (P.) sordidellus type, Dicrotendipes pulsus type and Ablabesmyia monilis type&raquo;', '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(78, 271, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with II: 8.05&ndash;8.65.\r\n', '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(79, 272, NULL, NULL, 0, NULL, '43 20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(80, 273, NULL, NULL, 0, NULL, '43 20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(81, 274, NULL, NULL, 0, NULL, '43 20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(82, 275, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Rheocricotopus effusus in Alpine running waters of 34.23&micro;S &middot; cm⁻&sup1; &plusmn;~20.17 (min-max: 8-77, n=21).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Rheocricotopus effusus in Alpine running waters of 6.37&deg;C &plusmn;~2.56 (min-max: 0.3-9.81, n=31).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Rheocricotopus effusus in Alpine running waters of 7.05 &plusmn;~0.6 (min-max: 9.9-8.1, n=22).\r\n', '135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(83, 276, NULL, NULL, 0, NULL, '135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(84, 277, NULL, NULL, 0, NULL, '135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(85, 278, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Rheocricotopus fuscipes in Alpine running waters of 10.77&deg;C &plusmn;~4.42 (min-max: 4.5-19, n=17).\r\n', '135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(86, 279, NULL, NULL, 0, NULL, '135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(87, 283, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(88, 284, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(90, 286, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(91, 287, NULL, NULL, 0, '==Biotops==\r\n\r\n{textciteID|8|Vallenduuk et al. 1997}: &laquo;Known for whole Europe from stagnant (stilstaande) water types. In the Netherlands it is found relatively few.&raquo;\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  6.0-11.0.\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(92, 288, NULL, NULL, 0, '==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Chironomus hyperboreus Staeger 1845 in lake Store Salts&oslash; (West Greenland) an oxygen consumption of \r\n*1.96/1.47/1.39/1.48/1.87 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of \r\n*23.2/28.3/37.5/15.6/28 in % are all in group {overlib|E|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. \r\nThe data [1, lake Store Salts&oslash;] was characterised by:  31~ha (lake area); 66.99&deg;N; 50.59833&deg;W; 2,798~&micro;S~&middot; cm⁻&sup1;; 14.0&deg;C (July 2002); max. depth: 11~m, the data [2, lake Lake SS2] by:  37~ha (lake area); 66.99667&deg;N; 50.97000&deg;W; 293~&micro;S~&middot; cm⁻&sup1;; 15.3&deg;C (July 2002); max. depth: 11~m and remainig data [3-5, lake Tasersuatsiaq] were characterised by: 750~ha (lake area); 66.97898&deg;N; 50.69489&deg;W; 55~&micro;S~&middot; cm⁻&sup1;; 11.8&deg;C (July 2002); max. depth: &gt;80~m.\r\nFor lake Lake SS2 [2] (West Greenland) but with an experimental temperature of 15&deg;C an oxygen consumption of \r\n*2.77/2.56 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of \r\n*19.4/21.6 in % was measured and taxa are in group {overlib|D|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators}.\r\n\r\n\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(93, 289, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(94, 290, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: as Cryptochironomus macropodus Ljachov it occoured in experimental mesocosmos with III: 5.02&ndash;5.95. (I [A.Plank] don''t know if Cryptochironomus macropodus Ljachov is valid or not (Tue Dec 08 2009 14:38:21 GMT+0100))\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(95, 291, NULL, NULL, 0, '{textciteID|8|Vallenduuk et al. 1997}: &laquo;Based on adult males, determined by {textciteID|582|Strenzke 1959}, this species is generally found in small, especially acidic, partly temporaire waters. In the Netherlands and other Western European countries.&raquo;\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(96, 292, NULL, NULL, 0, '{textciteID|6|Epler 2001}: &laquo;A species usually found in lotic, organically polluted conditions,  such as streams below sewage treatment plants.&raquo;\r\n\r\n{textciteID|8|Vallenduuk et al. 1997}: &laquo;Until recently, C.riparius was put usually to the name C.thummi and often C.piger was included as subspecies. C.riparius is very common, especially in smaller, even temporary water types. The species tolerates a low pH (&lt;4) and a high contamination. This issue is used for indicating contamination.&raquo;\r\n\r\n===Oxygen===\r\n\r\n{textciteID|492|Brodersen et al. 2004} report for Chironomus cf. riparius Meigen 1804 in lake Lake SS2 (West Greenland) an oxygen consumption of \r\n*2.27/2.6 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of \r\n*19.8/22.3 in % both in group {overlib|E|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. \r\nThe lake was characterised by:  37~ha (lake area); 66.99667&deg;N; 50.97000&deg;W; 293~&micro;S~&middot; cm⁻&sup1;; 15.3&deg;C (July 2002); max. depth: 11~m. At an experimental temperature of 15&deg;C in the same lake it was measured: an oxygen consumption of \r\n*3.46/4.68 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of \r\n*21.2/25 in % and both in group {overlib|D|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators}.\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(97, 293, NULL, 'Adults see {textciteID|546|Ree and Yum 2006}.\r\n', 0, '{textciteID|482|Pinder 1986}: &laquo;Chironomus salinarius has been recorded from freshwater as well as chloride concentrations of up to 41%.&raquo;\r\n\r\n{textciteID|477|Vallenduuk and Moller-Pillot 1999}: &laquo;Common in whole Europe in salt and brack water and also in salty water in the inland. Still alive at 20,000~mg/l chloride or higher, therefore salter than marine water. {textciteID|570|Krebs and Moller-Pillot n.d.} found a preference for a floor of fine detritus or very fine sand, although larvae were found also on hard substrat. Also on kelp in the [[http://maps.google.com/maps?f=q&amp;source=s_q&amp;hl=de&amp;geocode=&amp;q=Grevelingen,+Niederlande&amp;sll=37.0625,-95.677068&amp;sspn=46.092115,73.125&amp;ie=UTF8&amp;hq=&amp;hnear=Grevelingen,+Niederlande&amp;z=12 Grevelingen [Netherland] ]].&raquo;\r\n\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(98, 294, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(99, 295, NULL, NULL, 0, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Chironomus nudiventris (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(100, 296, NULL, '==History==\r\n\r\nIn {citeID|11|Guo 1994} was Chironomus plumosus f.reductus described but was moved to C.plumosus (2009-06-28 05:32:54). Note &rsquo;f.reductus&rsquo; in images was added.', 0, '==Biotops==\r\n\r\nAs imagines several other types are not distinguishable from  C. plumosus. That''s why most data for distribution in whole Europe are uncertain. However, from cytologically checked larvae of Russia, Switzerland it becomes clear that C.plumosus occurs frequently in lakes and rivers in coincidence with the former data. In smaller water types C.plumosus are scarcer. According to research of {textciteID|570|Krebs and Moller-Pillot n.d.}  (determination of imagines without cytological control!) taxon colonises also closed and drinking containers, when they are not ?broken [mits deze niet te brak zijn]. The tolerance for salt is clearly smaller than for C.annularius. {textciteID|570|Krebs and Moller-Pillot n.d.} found maximum chloride around 3000mg~&middot;~l⁻&sup1;.\r\n\r\n&lt;!--Als imago zijn diverse andere soorten niet van C. plumosus te onderscheiden. Om deze reden zijn de meeste opgaven van het voorkomen in geheel Europa onzeker. Uit cytologisch gecontroleerde larven van Rusland, Zwitserland en elders blijkt echter, dat C.plumosus in meren en riveren een veel voorkomende soort is, overeenkomstig de vroegere opgaven. In kleinere wateren is C.plumosus schaarser. Volgens onderzoek van Krebs (determinatie van imagines zinder cytologosche controle!) koloniseert de soort ook sloten en drinkputten, mits deze niet te brak zijn. De tolerantie voor zout is duidelijk geringer dan bij C.annularius. Het door {textciteID|570|Krebs and Moller-Pillot n.d.} gevonden maximale chlorifgehalte ligt rond de 3000mg/l.--&gt;\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  6.0-11.0.\r\n\r\n===Temperature===\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Chironomus plumosus-group  and other taxa: 14.7&gt; &deg;C, n=25 (sigmoidal increasing Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{textciteID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Endochironomus impar type, Chironomus plumosus type [most abundant in 15-16 &amp; &gt;16&deg;C], Nanocladius rectinervis type, Endochironomus albipennis type, Glyptotendipes pallens type, Einfeldia pagana type and Microchironomus tener type had the highest temperature optima.&raquo;\r\n\r\n===Eutrophication===\r\n\r\n{textciteID|508|Meril&auml;inen et al. 2000}: &laquo;Table~2.: Four developmental stages in the northern (N) and southern (S) basins of Lake Lappaj&auml;rvi. Characterization of the sediment quality, sedimentary diatoms (reconstructed pH according to {citeID|509|Renberg and Hellberg 1982}) and chironomid remains (BQI according to {citeID|510|Wiederholm 1980})&raquo;\r\n{| style=''border:1px solid;'' \r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!colspan=''2''|Pre industrial&lt;br&gt;early 1990s\r\n!colspan=''2''|Increasing loading&lt;br&gt;ca. 1935-1960\r\n!colspan=''2''|Erosion&lt;br&gt;ca. 1960-1970\r\n!colspan=''2''|Meso-eutrophic stage&lt;br&gt;ca. 1970-present\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|Water content (% WW)\r\n|41&ndash;45 \r\n|81&ndash;82 \r\n|66&ndash;74 \r\n|79&ndash;83 \r\n|56&ndash;62 \r\n|68&ndash;77 \r\n|64&ndash;94 \r\n|73&ndash;89\r\n\r\n|-\r\n|Loss on ignition (% DW) \r\n|2.2&ndash;2.4 \r\n|14&ndash;16 \r\n|8.7&ndash;9.9 \r\n|13&ndash;15 \r\n|5.6&ndash;7 \r\n|8.8&ndash;14 \r\n|5.7&ndash;15 \r\n|7.1&ndash;15\r\n\r\n|-\r\n|Bulk density (g&middot;cm⁻&sup3;) \r\n|1.51&ndash;1.57 \r\n|1.13 \r\n|1.19&ndash;1.37 \r\n|1.0&ndash;1.12 \r\n|1.30&ndash;1.36 \r\n|1.14&ndash;1.22 \r\n|1.03&ndash;1.36 \r\n|1.05&ndash;1.19\r\n\r\n|-\r\n|pH spectra [based on diatomes]\r\n|5.9&ndash;6.4 \r\n|. . \r\n|5.9&ndash;6.8 \r\n|. . \r\n|6.7&ndash;6.9 \r\n|. . \r\n|6.9&ndash;7.4 \r\n|. .\r\n\r\n|-\r\n|Head capsules, 10⁻&sup3;&middot;m⁻&sup2;&middot;a⁻&sup1;\r\n|1.1&ndash;2.2 \r\n|25 \r\n|12&ndash;17 \r\n|24&ndash;87 \r\n|8.2&ndash;20 \r\n|27&ndash;34 \r\n|10&ndash;19 \r\n|17&ndash;60\r\n\r\n|-\r\n|Key species in chironomids \r\n|Hesu \r\n|Micr Stro \r\n|Micr Stro Seco \r\n|Chan Micr Stro\r\n|Chan Stro \r\n|Chan \r\n|Chan Chpl \r\n|Chan Chpl\r\n\r\n|-\r\n|BQI \r\n|4.4&ndash;4.6 \r\n|3.7 \r\n|3.2&ndash;3.5 \r\n|2.4&ndash;3.4 \r\n|2.0&ndash;3.3 \r\n|2.0&ndash;2.2 \r\n|2.2&ndash;2.5 \r\n|1.6&ndash;1.8\r\n\r\n|-\r\n&lt;td colspan=''9''&gt;Chan~=~Chironomus anthracinus gr., Chpl~=~Chironomus plumosus, Hesu~=~Heterotrissocladius subpilosus, Micr~=~Micropsectra spp., Seco~=~Sergentia coracina, Stro~=~Stictochironomus rosenscholdi.&lt;/td&gt;\r\n\r\n|}\r\n\r\n===Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Chironomus plumosus-Gr. (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(101, 297, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(102, 298, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  2.0&ndash;11.0.\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(103, 299, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(104, 300, NULL, NULL, 0, '==Biotops==\r\n\r\nLarvae frequently in whole Europe and occurs in small, mostly temporary and even ephemeral waters ({citeID|8|Vallenduuk et al. 1997}; {citeID|581|Dettinger-Klemm 2000}) with high abundances during colonisation ({citeID|274|Dettinger-Klemm 2003}).\r\n\r\n===Oxygen===\r\n\r\n{textciteID|482|Pinder 1986}: &laquo;In the Chironominae such tolerance is related to the possession of hemoglobin, and larvae of Chironomus dorsalis have been reported to extend their tubes as much as 20~mm above the sediment surface in order to maintain an oxygen concentration of more than 7~mg~&middot;l⁻&sup1; at the tube entrance ({citeID|572|Konstantinov 1971}).&raquo;\r\n\r\n\r\n===Conductivity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Chironomus dorsalis in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 6821.44mg~&middot;~l⁻&sup1; (&divide;~600 = 11.37mS~&middot;~cm⁻&sup1;) with an effective occurrence (N2) = 2.4505. In article shortened as: Cd.\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(105, 301, NULL, NULL, 0, '==Biotops==\r\n\r\n{textciteID|8|Vallenduuk et al. 1997}: &laquo;Found in lot of sites in Europe, almost exclusively in stationary, eutrophic, little polluted waters. {textciteID|570|Krebs and Moller-Pillot n.d.} found the type in the delta area especially in wateren with much plant material and/or organic silt.&raquo;\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with IV: 4.09&ndash;4.98.\r\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(106, 302, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(107, 303, NULL, NULL, 0, NULL, '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(108, 304, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with II: 8.05&ndash;8.65, III: 5.02&ndash;5.95, IV: 4.09&ndash;4.98, V: 3.01&ndash;3.82.\n', '53 43 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(109, 305, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  2.0&ndash;11.0.\r\n', '159 121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(110, 306, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Eukiefferiella minor in Alpine running waters of 33.88&micro;S &middot; cm⁻&sup1; &plusmn;~61.11 (min-max: 6-474, n=137).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Eukiefferiella minor in Alpine running waters of 4.9&deg;C &plusmn;~2.41 (min-max: 0.01-12, n=166).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Eukiefferiella minor in Alpine running waters of 6.52 &plusmn;~0.98 (min-max: 5.11-9.9, n=121).\r\n', '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(111, 307, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(112, 308, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(113, 309, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(114, 310, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(115, 311, 20, NULL, 0, '==Biotops==\r\n\r\n{citeID|20|Schmid 1993}: in upper reaches of Alpine rivers\r\n\r\n{citeID|481|Buskens and Moller-Pillot 1992}: only live in such polluted waters with satisfactory flow conditions. Here oxygen regimes seem to play an important role.\r\n\r\n==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Eukiefferiella claripennis in Alpine running waters of 35.6&micro;S &middot; cm⁻&sup1; &plusmn;~36.81 (min-max: 5-91, n=15).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Eukiefferiella claripennis in Alpine running waters of 5.45&deg;C &plusmn;~1.46 (min-max: 3.89-9.81, n=23).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Eukiefferiella claripennis in Alpine running waters of 6.61 &plusmn;~0.57 (min-max: 5.33-7.87, n=13).\r\n', '186', NULL, 4, 2.096, NULL, NULL, 0.069, 4, NULL, 0.2, NULL, 1, NULL, 0.682, NULL, 1, 'reaching base of 3rd', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.348, 0.113, 3, NULL, 'grey-brown', NULL, 'darkened', NULL, 2, NULL, 5, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, NULL, 5, NULL, NULL, 0, NULL, 4, 1, 0, 0, '4-5 short spines at inner margin', NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, '5 serrated branches', NULL, NULL, NULL, NULL, 1, 'inbetween 6-8 short setae', 1, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, NULL, NULL, 'posterior bear dark-brown/black claws', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(116, 312, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(117, 313, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Eukiefferiella fuldensis in Alpine running waters of 11.42&micro;S &middot; cm⁻&sup1; &plusmn;~9.57 (min-max: 4-124, n=103).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Eukiefferiella fuldensis in Alpine running waters of 4.81&deg;C &plusmn;~2.28 (min-max: 1.93-9.81, n=105).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Eukiefferiella fuldensis in Alpine running waters of 6.24 &plusmn;~0.31 (min-max: 5.11-6.6, n=96).\r\n', '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(118, 314, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(119, 315, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(120, 316, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(121, 317, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(122, 318, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(123, 1580, 20, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Eukiefferiella brevicalcar in Alpine running waters of 24.14&micro;S &middot; cm⁻&sup1; &plusmn;~51.69 (min-max: 2-474, n=186).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Eukiefferiella brevicalcar in Alpine running waters of 4.24&deg;C &plusmn;~1.48 (min-max: 0.01-9.81, n=204).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Eukiefferiella brevicalcar in Alpine running waters of 6.54 &plusmn;~0.68 (min-max: 4.94-9.9, n=176).\r\n', '186', NULL, 5, 1.94, NULL, NULL, 0.158, 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'reaches apex of 2nd segm', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.531, 0.174, 6, NULL, 'brown to dark brown', NULL, 'dakened', NULL, 1, NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 3.5, 0.5, NULL, NULL, NULL, 4, 1, 0, 0, '3 short spines at inner margin', NULL, NULL, NULL, NULL, NULL, NULL, 1, '5 serrated branches', 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(124, 320, 20, NULL, 0, NULL, '186', NULL, 4, 1.769, NULL, NULL, 0.071, 8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'reaching 3rd', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.433, 0.099, 8, NULL, 'brown', NULL, 'darkened', NULL, 2, 'distinctly higher than laterals', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 3, 1, 0, 0, '3 short spines at inner margin', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(125, 310, 21, ' Taxon moved: moved from group level to species level Eukiefferiella gracei gr. No reference given -&gt; Eukiefferiella gracei (Edwards 1929) (2009-07-04 08:37:44)', 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, 2.423, NULL, 1, 5.818, NULL, 1, NULL, 3, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(126, 322, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(127, 323, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(128, 324, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(129, 325, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(130, 326, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(131, 327, NULL, NULL, 0, NULL, '186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(132, 328, NULL, NULL, 0, NULL, '155 142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(133, 329, NULL, NULL, 0, NULL, '20 43 9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(134, 330, NULL, NULL, 0, NULL, '20 43 9', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(135, 334, NULL, NULL, 0, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Allopsectrocladius &ndash; group  and other taxa: 6m &plusmn; 3.5 (n=27). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Temperature==\r\n\r\nAllopsectrocladius gr. reported by {citeID|516|Korhola et al. 2002} as intermediate taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Allopsectrocladius-group  and other taxa: 11.5&deg;C &plusmn; 1.1, n=30 (skewed curve Template:HOF:skewedLeft Template:HOF:skewedRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(136, 335, NULL, 'For morphological images see also {textciteID|449|Zelentsov and Makarchenko 1988}.\r\n', 0, '==Biotops==\r\n\r\nIn {textciteID|449|Zelentsov and Makarchenko 1988} described as Psectrocladius (Ps.) aff. sordidellus (Zett.): Larvae are found in mass among mossy pillows on the oozy bottom, at a depth of 30-40cm, the temperature of water was near 8&deg;C. For refining specific status of larvae it is necessary to analyze pupae and  imagos, which, unfortunately, at present we do not have.\r\n&lt;!--Личинки в массе собраны среди моховых подушек на илистом грунте, глубина 30-40см, температура воды около 8&deg;. Для уточнения видого статуса личинок необходимо проанализировать куколок и имаго, которых, к сожалению, в настоящее время мы не имеем--&gt;\r\n\r\n===Temperature===\r\n\r\n{textciteID|507|Brooks and Birks 2000}:\r\n*11 with significant symmetric unimodal Template:HOF:unimodal: [..] Psectrocladius sordidellus-group (groups 8-10&deg;C &amp; 10-12&deg;C &amp; &gt;12&deg;C)\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Psectrocladius (P. sordidellus group, P. semicirculatus in {textciteID|21|Cranston et al. 1983})  and other taxa to find possible differences in temperature: 2000: 14.1&deg;C &plusmn; 3.4 (10.7 to 17.4), 2006: 13.9&deg;C &plusmn; 4.4 (9.5 to 18.3) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here&lt;/a&gt;.\r\n\r\nPsectrocladius sordidellus gr. reported by {textciteID|516|Korhola et al. 2002} as intermediate taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Psectrocladius sordidellus-group  and other taxa: 11.6&deg;C &plusmn; 4.6, n=90 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n===pH===\r\n\r\n{textciteID|507|Brooks and Birks 2000}: acidophil Psectrocladius sordidellus-group, Psectrocladius septentrionalis-group, Heterotanytarsus apicalis\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos II: 8.05&ndash;8.65, III: 5.02&ndash;5.95, IV: 4.09&ndash;4.98, V: 3.01&ndash;3.82 with tolerances of  2.0&ndash;11.0.\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Psectrocladius sordidellus &ndash; group  and other taxa: 7m &plusmn; 5 (n=53). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Eutrophication===\r\n\r\n{textciteID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Some clearly eurytopic taxa were recognised, including constantly and abundantly appearing Microtendipes pedellus type, Psectrocladius (P.) sordidellus type, Dicrotendipes pulsus type and Ablabesmyia monilis type&raquo;\r\n\r\n===Oxygen===\r\n\r\n{textciteID|492|Brodersen et al. 2004} report for Psectrocladius sordidellus/limbatellus group in lake Aajuitsup Tasia (West Greenland) an oxygen consumption of 6.72/6.4 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 52/44.8 in % is in group {overlib|A/B|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  1,350~ha (lake area); 67.09253&deg;N; 50.30568&deg;W; 72~&micro;S~&middot; cm⁻&sup1;; 6.5&deg;C (July 2002); max. depth: &gt;32~m.\r\n\r\n===Conductivity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Psectrocladius sordidellus-type in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 10008.21mg &middot; l⁻&sup1; (&divide; 600 = 16.68mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 10.4026. In article shortened as: Ps.\r\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(137, 336, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(138, 337, NULL, '{textciteID|350|Akhorov 1977}: length 7-8mm\n', 0, '{textciteID|350|Akhorov 1977}:\r\n*the depth of biotops of larvae did not exceed 2.5-3m\r\n*temperatures in waterbodies ranged from 0&deg;C in the beginning of June to 18&deg;C at the end of July, pH ranged from 8.3-9.5; \r\n*O₂ in ?brandished water: in small pools and residual reservoirs from 6.4 to 8.64~mg~&middot;~l⁻&sup1;, while in the upper reaches of lake Zorkul [Зоркуль] O₂ limits were 6.4-8.0~mg~&middot;~l⁻&sup1;\r\n* elevation was 4126m\r\n\r\n&lt;!--В местах обитаняи личинок глубина воды не превышала 2,5-3м. содержание кислорода в воде колебалось: в мелких озерках и остаточных водоемах от 6,4 до 8,64 мг/л, а в веховье озеро. Зоркуль-в пределах 6,4-8 мг/л--&gt;\r\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(139, 338, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(140, 339, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(141, 340, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(142, 341, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(143, 342, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(144, 343, NULL, NULL, 0, '==pH==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*acidophil Psectrocladius sordidellus-group, Psectrocladius septentrionalis-group, Heterotanytarsus apicalis\r\n\r\n==Temperature==\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Psectrocladius (P. septentrionalis in {citeID|21|Cranston et al. 1983})  and other taxa to find possible differences in temperature: 2000: 13&deg;C &plusmn; 1.5 (11.5 to 14.5), 2006: 15.5&deg;C &plusmn; 3.4 (12.1 to 18.8) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nMonopsectrocladius gr. reported by {citeID|516|Korhola et al. 2002} as intermediate taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Psectrocladius septentrionalis-group  and other taxa: 11.4&deg;C &plusmn; 1.9, n=84 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Monopsectrocladius &ndash; group  and other taxa: 5.5m &plusmn; 4 (n=42). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Psectrocladius (Monopsectrocladius) (n=22, Template:explained:N2:HillsDiversity=13.39, n&lt;sub&gt;max&lt;/sub&gt;=8.11) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 41.\r\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(145, 344, NULL, 'Characters after {textciteID|449|Zelentsov and Makarchenko 1988}:\r\n{| style=''border:1px solid;'' \r\n\r\n&lt;thead&gt;\r\n|-\r\n!|Character\r\n!|P. sokolovae\r\n!|P. pancratovae\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|head capsule (w &micro;m)&lt;!-- Character --&gt;\r\n|560-595&lt;!-- P. sokolovae --&gt;\r\n|450-516&lt;!-- P. pancratovae --&gt;\r\n\r\n|-\r\n|head color&lt;!-- Character --&gt;\r\n|{yellow}&lt;!-- P. sokolovae --&gt;\r\n|{brown}&lt;!-- P. pancratovae --&gt;\r\n\r\n|-\r\n|AR&lt;!-- Character --&gt;\r\n|2.7-3.0&lt;!-- P. sokolovae --&gt;\r\n|2.0-2.2&lt;!-- P. pancratovae --&gt;\r\n\r\n|-\r\n|S1 branches&lt;!-- Character --&gt;\r\n|7-10&lt;!-- P. sokolovae --&gt;\r\n|10-15&lt;!-- P. pancratovae --&gt;\r\n\r\n|-\r\n|frontal sclerits (max width &micro;m)&lt;!-- Character --&gt;\r\n|200-240&lt;!-- P. sokolovae --&gt;\r\n|165-178&lt;!-- P. pancratovae --&gt;\r\n\r\n|-\r\n|beard&lt;!-- Character --&gt;\r\n|9-15&lt;!-- P. sokolovae --&gt;\r\n|4-8&lt;!-- P. pancratovae --&gt;\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n', 0, '{textciteID|449|Zelentsov and Makarchenko 1988}: \r\n* 11.2&deg;C temperature at sampling time\r\n* Larvae are congregate in small tundra lakes at the depth of 60-80cm among the silt, the detrite and the algae; the thickness of the frozen ground is 20-25cm&lt;!--Личинки собраны b небольшом тундровом озере наглубине 60-80см седи ила, детрита и водореслей; толшна грунта до мерзлоты 20-25см--&gt;\r\n* swarming occours near the sea side at a hight of ~2m\r\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(146, 345, NULL, 'from {citeID|12|Klink and Moller-Pillot 2003}:\r\n''''Body'''': Medium sized larvae up to 10 mm long. The anterior and posterior parapods are separate and bear rows of claws. Procercus weakly sclerotized with 2 - 3 (4) {overlib|spurs|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_prc_Tan2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_prc_Tan2006_r.gif 2009-12-15 10:36:17''>} and two pairs of anal tubules present ({citeID|21|Cranston et al. 1983}; {citeID|35|Moller-Pillot 1984b}).\r\n''''Head'''': The head length is 0.6-0.7 mm ({citeID|35|Moller-Pillot 1984b}). \r\n''''Antenna'''': The antenna consists of five segments. The blade is shorter than the flagellum. Lauterborn organs are small or absent.\r\n''''Mentum'''': The mentum has two median teeth and 5 pairs of lateral teeth. The ventromental plates are larve covering some lateral teeth. The beard is distinct.\r\n''''Labrum'''': The pecten epipharyngis consists of three subequal spined scales, {overlib|SI is palmate|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_set_Tan2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_set_Tan2006_r.gif 2009-12-15 10:36:17''>} and the premandible has one apical tooth ({citeID|21|Cranston et al. 1983}; {citeID|35|Moller-Pillot 1984b}).\r\n''''Mandible'''': The mandible has an apical tooth which is about as long as the combined inner teeth. The seta interna is present ({citeID|21|Cranston et al. 1983}).\r\n''''Differential characteristics'''': The combination the {overlib|palmate SI|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_set_Tan2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_set_Tan2006_r.gif 2009-12-15 10:36:17''>} on the labrum, beard present and procercus with {overlib|spurs|<img src=''image.php?text=Image reduced version. Deleted: PsclPs_barb_prc_Tan2006_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: PsclPs_barb_prc_Tan2006_r.gif 2009-12-15 10:36:17''>} is distinctive for the genus Psectrocladius. P. barbimanus can be separated from the other Psectrocladius by 2 mid-mental teeth equal in height as the first laterals and head length  0.6 mm.\r\n', 0, '==Biotops==\r\n\r\n{citeID|498|Gardarsson et al. 2004}: The dominant midge of Lake M&yacute;vatn [northern Iceland], Tanytarsus gracilentus showed 3 cyclic oscillations during the 20-year period. The fluctuations were tracked by Micropsectra lindrothi, Procladius islandicus, Orthocladius consobrinus, Psectrocladius barbimanus and Chironomus islandicus.\r\n\r\n{citeID|427|Thienemann 1937} This species is known until now from Greenland, Iceland, England, Germany (Holstein, Oberbayern). It is living in lakes, probably always in the littoral zone between plants and where algae cover surfaces. It is flying in spring  (Iceland, Germany Oberbayern), but also in the summer (Greenland) and autumn (England). Gut content: herbal detritus. Lives in brackish and limnic water. Length 10㎜.\r\n\r\n==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004}: in lake Skaelverdam (West Greenland) oxygen consumption was 8.17 and 8.70 ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with critical P&lt;sub&gt;sat&lt;/sub&gt; values 28.7 and 36.6% respectively. The site was characterised by following parameters: 0.5~ha (lake area); 67.00037&deg;N; 50.80578&deg;W; 2,552~&micro;S~&middot; cm⁻&sup1;; ?&deg;C; max. depth: 8~m. [...] as group B it belongs to  oxy-conformers  with high critical P&lt;sub&gt;sat&lt;/sub&gt;\r\n\r\n==Salinity==\r\n\r\n{citeID|502|Zhang et al. 2007}: &laquo;Taxa that inhabit the most saline lakes include Psectrocladius barbimanus-type and the Orthocladius/Cricotopus group, which was also the overwhelmingly dominant taxon in the most saline lakes from the analyses undertaken by {citeID|503|Walker et al. 1995} in British Columbia, Canada.&raquo; For Psectrocladius barbimanus-type in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 22588.68mg &middot; l⁻&sup1; (&divide; 600 = 37.65mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 2.96625. In article shortened as: Pb.\r\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(147, 346, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(148, 347, NULL, 'For morphological images see also {textciteID|449|Zelentsov and Makarchenko 1988}.\n', 0, 'See {textciteID|449|Zelentsov and Makarchenko 1988}.\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(149, 348, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(150, 349, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(151, 350, NULL, NULL, 0, '==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Psectrocladius sordidellus/limbatellus group in lake Aajuitsup Tasia (West Greenland) an oxygen consumption of 6.72/6.4 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 52/44.8 in % is in group {overlib|A/B|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  1,350~ha (lake area); 67.09253&deg;N; 50.30568&deg;W; 72~&micro;S~&middot; cm⁻&sup1;; 6.5&deg;C (July 2002); max. depth: &gt;32~m.', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(152, 351, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(153, 352, NULL, NULL, 0, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Monopsectrocladius &ndash; group  and other taxa: 5.5m &plusmn; 4 (n=42). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Temperature==\r\n\r\nMonopsectrocladius gr. reported by {citeID|516|Korhola et al. 2002} as intermediate taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type [most abundant in &lt; 13&deg;C], Parakiefferiella nigra type, Micropsectra insignilobus type, Protanypus, Tanytarsus lugens type, Hydrobaenus, Heterotrissocladius grimshawi type, Corynocera ambigua and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Psectrocladius (Monopsectrocladius) (n=22, Template:explained:N2:HillsDiversity=13.39, n&lt;sub&gt;max&lt;/sub&gt;=8.11) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 41.\r\n\r\n\r\n==Conductivity==\r\n\r\n{citeID|502|Zhang et al. 2007} report for Psectrocladius calcaratus-type in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 3216.07mg &middot; l⁻&sup1; (&divide; 600 = 5.36mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 1.30224. In article shortened as: Pc.\r\n', '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(154, 353, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(155, 354, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(156, 355, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(157, 356, NULL, NULL, 0, NULL, '147 65', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(158, 1524, NULL, ' added 2008-04-23 12:00:33 A.Plank: I named B.longiforceps wrong in {citeID|20|Schmid 1993}', 0, NULL, '49 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(159, 358, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Brillia bifida in Alpine running waters of 49.58&micro;S &middot; cm⁻&sup1; &plusmn;~39.26 (min-max: 8-112, n=12).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Brillia bifida in Alpine running waters of 7.1&deg;C &plusmn;~2.03 (min-max: 1.2-11, n=22).\r\n', '49 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(160, 359, NULL, NULL, 0, NULL, '49 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(161, 360, NULL, NULL, 0, NULL, '49 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(162, 361, NULL, NULL, 0, 'Biology in {textciteID|452|Zelentsov 1989} translated with [[http://de.babelfish.yahoo.com/translate_txt Babel Fish]]: Larva inhabit small shallow (0.5-0.8m) standing and weakly-flowing ponds (lake lagoons, residual basins, pits and puddles), considerably more rarely they are encountered in the calm zones of rivers and in the shore of lakes at  depths down to 1m. They build barrel-shaped (dolioform), elastic shapes of milky-yellow color houses, which are attached to different substrates (bottom of reservoir, stones, in accumulation of algae, vegetation). They live on the silt, on the bottom coverd with moss or algae, on stones, covered with silt or overgrown layers ("?Aufwuchs"), on the ground of vegetation and plant detritus. Based on  contents of bowels, they eat predominantly diverse algae and partially detritus. Larvae put into aquariums together with other chironomids and oligochaetes, rapaciousnesses was not observed. Mono-cyclic. Swarming of imagines in the different reservoirs occurs from July 12 to 17 until August 10. Swarm, as in the previous form [Cricotopus shilovae], small, are formed of 20-30 individuals. They swarm from 0.5 to 1.5m above the earth''s surface, grass and stones. Distribution/occurrence: USSR: Eastern Pamir (lake Yashilkul [Яшилькуль], Bulunkul [Булункуль], Zorkul [Зоркуль], Karakul [Каракуль], Big Кукджигит [Болшой Кукджигит] also near the lake of Yashilkul), Lake Song-Kel [Сонг-Кёль] (Kyrghyzstan). Nepal and Afghanistan. Form is found on elevations from 3,000 to 5,400m above sea level.\r\n&lt;!-- Личинки обитают внебольших мелких (0.5-0.8m) стоячих и слабопроточных водоемах (приозерных лагунах, остаточных водоемчиках, ямах и лужах), значительно реже встречаются в затишных участках рек и в прибрежье озер на глубинах до 1м. Строят бочонкообразной формы эластичные молочножелтого цвета домики (рис. 9, E-3), которые прикрепляют к различным субстратам (дно водоема, камни, скопления водорослей, растительност). Живут на илах, в обрастаниях дна из мха или водорослей, на камнях, покрытых илом или обрастаниями, на донной растительности и растительном детрите. Судя по содержимому кишечников, питаются преимущественно разнообразными водорослями и частично детритом. У личинок, помещенных в аквариумы с другими хирономидами и олигохетами, хищничества пе наблюдалось.\r\nМоноцикличен. Лёт имаго в разных водоемах происходит с 12-17 июля по 10 августа. Рои, как и у предыдущего вида, небольшие, сформированы из 20-30 особей. Роятся от 0.5 до 1.5м над поверхностью земли, травы и камней.\r\nРаспространение. СССР: Восточный Памир (озера Яшилькуль, Булункуль, Зоркуль, Каракуль, Болшой Кукджигит и близ озеро Сасыккуль), Киргизская ССР (озеро Сонг-Кёль). Непал и Афганистан.\r\nВид найден на высотах от 3,000 до 5,400м над уровнем моря. --&gt;\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 3, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(163, 362, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with I: 9.01&ndash;9.73 [as syn A.lucidus St&aelig;ger 1839].\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(164, 363, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(165, 364, NULL, NULL, 0, '==Conductivity/Salinity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Paratanytarsus austriacus in Alpine running waters of 63.92&micro;S &middot; cm⁻&sup1; &plusmn;~46.52 (min-max: 7.4-230, n=16).\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Paratanytarsus austriacus (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Paratanytarsus austriacus in Alpine running waters of 5.34&deg;C &plusmn;~1.04 (min-max: 4.6-8.8, n=16).\r\n', '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(166, 365, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(167, 366, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(168, 367, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(169, 368, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(170, 369, NULL, NULL, 0, '==Biotops==\r\n\r\n{textciteID|560|Malo et al. 1998}: &laquo;Paratanytarsus bituberculatus (Edwards), a species characteristic of stagnant water (Langton 1991) was found in the slow-flowing waters of the Xarrama stream in the autumn collections.&raquo;\r\n', '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(171, 370, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(172, 371, NULL, NULL, 0, '==Biotops==\r\n\r\n{textciteID|14|Klink 1983}: &laquo;{citeauthorID|241|Brundin 1949}~({citeyearID|241|Brundin 1949}:790) states that the larvae are inhabiting freshwater- and brackish lakes, in algae on reed and stones. According to {citeauthorID|293|Thienemann 1951}~({citeyearID|293|Thienemann 1951}:626) the larvae occur in freshwater, but definitely prefer brackish water. {citeauthorID|562|Palm&eacute;n 1960}~({citeyearID|562|Palm&eacute;n 1960}:281) collected P.inopertus  as one of the most abundant chironomids in the brackishwater area Tv&auml;rminne (South-Finnland). The species is assigned to a solid substrate and algal growth. In waters with a soft bottom, the species can only be found on the vegetation. In the ''Bodensee'' [Germany] P.inopertus is the dominant species with P.dimorphus in the growth on solid substrate and in the sediment ({citeID|563|Reiss 1968b}:276-277). [..] Other chironomids that can often be found in combination with P.inopertus are: Ablabesmyia monilis, Endochironomus tendens, Dicrotendipes nervosus, Glyptotendipes pallens. These species can also be characterized as inhabitants of the littoral zones in eutrophic lakes and so many findings are in full agreement with the cited literature, that P.inopertus prefers probably inhabit the solid substrate on the wind-exposed banks.&raquo;\r\n', '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(173, 372, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(174, 373, NULL, NULL, 0, '==Biotops==\r\n\r\n{textciteID|14|Klink 1983}: &laquo;{citeauthorID|562|Palm&eacute;n 1960}~({citeyearID|562|Palm&eacute;n 1960}:281) collected the adults and exuviae from the oligohalic estuaries in the southern part of Finnland, together with P.inopertus (Walker). In the potamal of the river Fulda [Germany], P.confusus is the dominant species in summertime. The larvae are found in mosses, algae and mudlayers on stones and branches. The species is stated as eurytermous and rheophilic ({citeauthorID|564|Lehmann 1971}, {citeyearID|564|Lehmann 1971}:504-505)&raquo;\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with  I: 9.01&ndash;9.73,  II: 8.05&ndash;8.65, III: 5.02&ndash;5.95, IV: 4.09&ndash;4.98, V: 3.01&ndash;3.82.\r\n', '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(175, 1471, NULL, '==Differences==\r\n\r\nParatanytarsus austriacus-type has {overlib|three inner teeth|<img src=''image.php?text=Image reduced version. Deleted: Pata_autr_man_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pata_autr_man_WCh1983_r.gif 2009-12-15 10:36:17''>} on the mandible and Paratanytarsus penicillatus-type {overlib|two inner teeth|<img src=''image.php?text=Image reduced version. Deleted: Pata_peni_man_Hei2004_r.jpg 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pata_peni_man_Hei2004_r.jpg 2009-12-15 10:36:17''>} on the mandible\r\n\r\n\r\n\r\nTechnical note: Paratanytarsus penicillatus type No reference given fused to  Paratanytarsus penicillatus No reference given (2009-12-05 22:10:21)\r\n', 0, '==Biotops==\r\n\r\nMentioned just in {textciteID|274|Dettinger-Klemm 2003} (Germany) in the species list as founded in temporary pools. Difficult to associate it correctly to a certain sampled sites from this study.\r\n\r\nFound in an oligotrophic lake in Norway (&Oslash;vre Heimdalsvatn, 61&deg; 25'' 60 N, 8&deg; 50'' 60 E) by {textciteID|552|Aagaard 1978} emerging from June until August.\r\n\r\n{textciteID|554|Ilyashuk and Ilyashuk 2001}: &laquo;The most important taxa were typical elements of oligotrophic lakes, i.e. Micropsectra insignilobus, Paratanytarsus penicillatus, Stictochironomus spp. and Heterotrissocladius marcidus.&raquo; [..] &laquo;Perhaps the distributional patterns of P. penicillatus and Stictochironomus spp. after ~1982 suggest that P. penicillatus tolerates a wider range of pH and heavy metal concentrations than Stictochironomus sp.&raquo; [ data: 67&deg; 57&prime;N; 32&deg; 29&prime;E; 475.3m a.s.l.; surface area: 12.5ha; drainage area: 205ha; mean depth: 10m; maximum depth: 18; pH: 6.12 (5.70&ndash;6.29); colour   3 (1&ndash;9) mg~Pt~&middot;~l⁻&sup1;; P_tot 2 (0&ndash;4) ; N_tot: 94 (49&ndash;211) &micro;g~&middot;~l⁻&sup1; ]\r\n\r\n{textciteID|556|Ilyashuk et al. 2007}: &laquo;In the study lakes, Paratanytarsus penicillatus-type and Tanytarsus lugens-type are the most abundant taxa. In Fennoscandia, P. penicillatus-type (Brooks and Birks, 2001) and T. lugens-type (Olander et al., 1999; {citeID|518|Larocque et al. 2001}) show little sensitivity to temperature and apparently both taxa are characterized by a wide range of thermal tolerances. However, these taxa likely differ in the habitat preferences along bathymetric gradient. Paratanytarsus penicillatus according to S&aelig;ther (1979) is a typical member of shallow-water communities. T. lugens-type is characterized as deep-water inhabitant (e.g., Hofmann, 1988; {citeID|515|Korhola et al. 2000}), and, in shallow lakes, it is also more associated with deeper zone Za of lake basin ({citeID|1|Heiri et al. 2004}).&raquo; \r\n\r\n===Depth===\r\n\r\n{textciteID|556|Ilyashuk et al. 2007}: &laquo;[..] a high sedimentation rate affected some of inhabitants of the deep-water zone Za but resulted in the thriving of shallow-water Paratanytarsus penicillatus-type that prefers habitats where severe processes of sediment transport occur.&raquo;\r\n\r\n===Temperature===\r\n\r\n{textciteID|555|Ilyashuk et al. 2005}: &laquo;After c. 4000 cal. yr BP there was an increase in S. coracina-type and P. penicillatus-type, another cold-adapted species T_Jul_opt = 7.6&deg;C for Paratanytarsus) [..]&raquo;\r\n\r\n{textciteID|556|Ilyashuk et al. 2007}: &laquo;Taxa with a broader range of thermal tolerances, such as Psectrocladius sordidellus-type and Paratanytarsus penicillatus-type, become common, along with the warm-temperature indicators Microtendipes pedellus-type and Chironomus anthracinus-type.&raquo;\r\n\r\n===Phosphorus===\r\n\r\nFound lakes for a phosphorus transfer model for trophic status in UK by {textciteID|553|Brooks et al. 2001} with tendency to oligotrophic conditions.\r\n', '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(176, 375, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(177, 376, NULL, NULL, 0, NULL, '170 88 207 70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(178, 383, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(179, 384, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(180, 385, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(181, 386, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(182, 387, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(183, 388, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Thienemanniella partita in Alpine running waters of 11.15&micro;S &middot; cm⁻&sup1; &plusmn;~8.59 (min-max: 5-111, n=65).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Thienemanniella partita in Alpine running waters of 5.01&deg;C &plusmn;~1.52 (min-max: 2.53-8.2, n=67).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Thienemanniella partita in Alpine running waters of 6.33 &plusmn;~0.29 (min-max: 5.27-8.5, n=57).\r\n', '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(184, 389, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(185, 390, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(186, 391, NULL, NULL, 0, NULL, '29', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(187, 397, NULL, NULL, 0, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(188, 398, NULL, NULL, 0, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(189, 399, 20, NULL, 0, '{citeID|20|Schmid 1993}: in epilithic moss-patches and in the submerged parts of debris \r\ndams in the headwter areas of brooks and streams.\r\n\r\n==Conductivity==\r\n\r\n{citeID|489|Rossaro et al. 2006} report a conductivity for Tvetenia bavarica in Alpine running waters of 48.44&micro;S &middot; cm⁻&sup1; &plusmn;~12.03, n=11.\r\n', '46', NULL, NULL, 1.33, NULL, NULL, 0.835, 7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.47, 0.025, 12, 'postoccipital margin plae', 'yellow to light brown', NULL, NULL, NULL, 2, NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, 0, NULL, 3, 1, 0, 0, '2 spines on inner margin\ndorsal 1 dimple ', NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, '5 setae', NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, 0, NULL, 1, 0, NULL, '3 lobes', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(190, 400, 20, NULL, 0, '{citeID|20|Schmid 1993}: Larvae were found in headwater areas to rivers of higher stream order.\r\n\r\n==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Tvetenia calvescens in Alpine running waters of 24.56&micro;S &middot; cm⁻&sup1; &plusmn;~39.25 (min-max: 4-339, n=230).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Tvetenia calvescens in Alpine running waters of 4.8&deg;C &plusmn;~1.91 (min-max: 0.01-10, n=267).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Tvetenia calvescens in Alpine running waters of 6.44 &plusmn;~0.65 (min-max: 5.11-9.9, n=208).\r\n', '46', NULL, NULL, 1.46, NULL, NULL, 0.82, 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.49, 0.1, 17, 'postoccipital margin pale', 'yellow', NULL, NULL, NULL, 2, NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, 0, NULL, 3, 1, 0, 0, '2-3 spines on inner margin', NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, '5', NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '3 lobes', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(191, 401, NULL, NULL, 0, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(192, 402, NULL, NULL, 0, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(193, 403, NULL, NULL, 0, NULL, '83 212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(194, 404, NULL, NULL, 0, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Apsectrotanypus trifascipennis (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '83 212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(195, 406, NULL, NULL, 0, NULL, '64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(196, 407, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*8 have statistically significant (sigmoidal Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n\r\nParakiefferiella bathophila cf. reported by {citeID|516|Korhola et al. 2002} as warm adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Parakiefferiella bathophila  and other taxa: 11.6&deg;C &plusmn; 2.9, n=22 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Parakiefferiella cf.bathophila (n=28, Template:explained:N2:HillsDiversity=20.18, n&lt;sub&gt;max&lt;/sub&gt;=8.26) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 38.\r\n', '64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(197, 408, NULL, NULL, 0, NULL, '64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(198, 409, NULL, NULL, 0, NULL, '64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(199, 410, NULL, NULL, 0, NULL, '64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(200, 411, NULL, NULL, 0, NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(201, 412, NULL, NULL, 0, NULL, '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(202, 413, NULL, NULL, 0, NULL, '202 106 142 205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(203, 415, NULL, NULL, 0, NULL, '53 20 51 197 36 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(204, 416, NULL, NULL, 0, '==Temperature==\r\n\r\n{textciteID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Among the chironomids, Micropsectra radialis type, Heterotrissocladius maeaeri type and Corynocera oliveri type, for example, were restricted to the northern and cold lakes, while Microchironomus tener type and Einfeldia pagna type were restricted to the warmest lakes.&raquo; [..] &laquo;Endochironomus impar type, Chironomus plumosus type, Nanocladius rectinervis type, Endochironomus albipennis type , Glyptotendipes pallens type, Einfeldia pagna type [most abundant in &gt;16&deg;C] and Microchironomus tener type had the highest temperature optima.&raquo;\r\n', '53 20 51 197 36 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(205, 417, NULL, NULL, 0, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Einfeldia carbonaria (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '53 20 51 197 36 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(206, 418, NULL, NULL, 0, NULL, '53 20 51 197 36 39', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(207, 419, NULL, NULL, 0, NULL, '132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(208, 442, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(209, 443, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(210, 444, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(211, 445, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(212, 446, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(213, 447, NULL, NULL, 0, '==Temperature==\r\n\r\nHeterotrissocladius maeaeri reported by {citeID|516|Korhola et al. 2002} as cold adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|534|Luoto 2009} states: &laquo;Among the chironomids, Micropsectra radialis type, Heterotrissocladius maeaeri type and Corynocera oliveri type, for example, were restricted to the northern and cold lakes, while Microchironomus tener type and Einfeldia pagna type were restricted to the warmest lakes.&raquo;\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000}: The estimated lake depth optima and tolerances of those chironomid taxa having an effective number of occurrences (N2&sup1;) &gt;= 3. Samples from Fennoscandia, mainly NW Finnish Lapland.&lt;br&gt;&sup1;⁾ This weighted averaging tolerance was adjusted by dividing Hill''s  diversity measure N2 for Hill number 2. {nociteID|514|Hill 1973}\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n!|Taxa\r\n!im90|Number of Occurrence.\r\n!im90|N2 (effective number of occurrence)\r\n!im90|WA Optimum\r\n!im90|WA Tolerance\r\n\r\n|-\r\n|Heterotrissocladius sp.\r\n|15\r\n|12.2\r\n|12.8\r\n|6.6\r\n\r\n|-\r\n|Heterotrissocladius maeaeri\r\n|13\r\n|11.6\r\n|11.5\r\n|7.8\r\n\r\n|-\r\n|Heterotrissocladius marcidus\r\n|5\r\n|4.6\r\n|11.6\r\n|8.1\r\n\r\n|-\r\n|Heterotrissocladius grimshawi\r\n|15\r\n|14.2\r\n|10.6\r\n|7.5\r\n\r\n|-\r\n|Heterotrissocladius subpilosus\r\n|12\r\n|7.7\r\n|16.5\r\n|9.7\r\n\r\n|-\r\n|Psectrocladius sp.\r\n|50\r\n|44.5\r\n|6.7\r\n|5.1\r\n\r\n|-\r\n|Psectrocladius sordidellus &ndash; group\r\n|53\r\n|46.7\r\n|7\r\n|5\r\n\r\n|-\r\n|Monopsectrocladius &ndash; group\r\n|42\r\n|32.8\r\n|5.5\r\n|4\r\n\r\n|-\r\n|Allopsectrocladius &ndash; group\r\n|27\r\n|22.7\r\n|6\r\n|3.5\r\n\r\n|-\r\n|Heterotanytarsus sp.\r\n|12\r\n|11.1\r\n|9.4\r\n|3.6\r\n\r\n|-\r\n|Orthocladius sp. Cricotopus sp.\r\n|47\r\n|40.2\r\n|6.9\r\n|5.3\r\n\r\n|-\r\n|Zalutschia zalutschicola\r\n|17\r\n|11.8\r\n|8.8\r\n|6.7\r\n\r\n|-\r\n|Zalutschia sp.\r\n|27\r\n|14.9\r\n|6.9\r\n|3.2\r\n\r\n|-\r\n|Corynoneura sp.\r\n|21\r\n|17.9\r\n|9.2\r\n|6.3\r\n\r\n|-\r\n|Abiskomyia sp.\r\n|3\r\n|3\r\n|23.2\r\n|7\r\n\r\n|-\r\n|Protanypus sp.\r\n|10\r\n|9.5\r\n|11.3\r\n|6.8\r\n\r\n|-\r\n|Synorthocladius sp.\r\n|4\r\n|3.7\r\n|11.2\r\n|10.4\r\n\r\n|-\r\n|Georthocladius sp./Parachaetocladius sp.\r\n|5\r\n|3.8\r\n|11.1\r\n|4.9\r\n\r\n|-\r\n|Nanocladius sp.\r\n|6\r\n|5.6\r\n|8.5\r\n|3.9\r\n\r\n|-\r\n|Eukiefferiella sp.\r\n|6\r\n|5.4\r\n|12.2\r\n|7\r\n\r\n|-\r\n|Mesocricotopus sp.\r\n|5\r\n|4.5\r\n|10.8\r\n|3.8\r\n\r\n|-\r\n|Microtendipes sp.\r\n|42\r\n|35.2\r\n|6.4\r\n|4\r\n\r\n|-\r\n|Dicrotendipes sp.\r\n|41\r\n|36.4\r\n|6.1\r\n|3.7\r\n\r\n|-\r\n|Sergentia coracina\r\n|44\r\n|34.7\r\n|7.8\r\n|5\r\n\r\n|-\r\n|Unidentified Tanytarsini\r\n|53\r\n|49.1\r\n|7.6\r\n|5.4\r\n\r\n|-\r\n|Micropsectra gr. B/Tanytarsina gr. B\r\n|51\r\n|43.3\r\n|6.9\r\n|4.6\r\n\r\n|-\r\n|Tanytarsus lugens\r\n|36\r\n|27.7\r\n|7.4\r\n|4.4\r\n\r\n|-\r\n|Tanytarsus chinyensis\r\n|4\r\n|3.6\r\n|8.4\r\n|2.3\r\n\r\n|-\r\n|Paratanytarsus sp.\r\n|35\r\n|29.5\r\n|6.5\r\n|4.7\r\n\r\n|-\r\n|Cladotanytarsus mancus &ndash; group\r\n|25\r\n|22.6\r\n|5.3\r\n|3.2\r\n\r\n|-\r\n|Corynocera ambigua\r\n|34\r\n|24.1\r\n|7.7\r\n|5.4\r\n\r\n|-\r\n|Corynocera oliveri\r\n|9\r\n|7.7\r\n|9.4\r\n|6.3\r\n\r\n|-\r\n|Micropsectra radialis &ndash; group\r\n|24\r\n|19\r\n|9.9\r\n|6.5\r\n\r\n|-\r\n|Pagastiella sp.\r\n|23\r\n|20.5\r\n|5.5\r\n|3.7\r\n\r\n|-\r\n|Polypedilum sp.\r\n|22\r\n|19.5\r\n|5.8\r\n|3\r\n\r\n|-\r\n|Stempellinella sp.\r\n|19\r\n|16.9\r\n|9.4\r\n|7.1\r\n\r\n|-\r\n|Chironomus sp.\r\n|25\r\n|20\r\n|5.2\r\n|1.7\r\n\r\n|-\r\n|Cladopelma sp.\r\n|20\r\n|18.9\r\n|5.4\r\n|2.1\r\n\r\n|-\r\n|Pseudochironomus sp.\r\n|10\r\n|9.3\r\n|4.6\r\n|2.2\r\n\r\n|-\r\n|Stictochironomus sp.\r\n|4\r\n|3.9\r\n|8.6\r\n|2.5\r\n\r\n|-\r\n|Tanypodinae spp.\r\n|53\r\n|49.6\r\n|7\r\n|5.1\r\n\r\n|-\r\n|Chaoboridae spp.\r\n|9\r\n|4.3\r\n|5.5\r\n|3.3\r\n\r\n|}', '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(214, 448, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(215, 449, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(216, 450, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(217, 451, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(218, 452, NULL, NULL, 0, '==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Heterotrissocladius cf. oliveri [?H.olivera] {citeID|31|S&aelig;ther 1975} in lake Tasersuatsiaq (West Greenland) an oxygen consumption of 3.15/2.32 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 23.6/31.2 in % is in group {overlib|D/C|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  750~ha (lake area); 66.97898&deg;N; 50.69489&deg;W; 55~&micro;S~&middot; cm⁻&sup1;; 11.8&deg;C (July 2002); max. depth: &gt;80~m.', '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(219, 453, NULL, NULL, 0, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Heterotrissocladius marcidus  and other taxa: 11.6m &plusmn; 8.1 (n=5). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Heterotrissocladius marcidus group  and other taxa: 14.7&gt; &deg;C, n=36 (sigmoidal increasing Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C.\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Heterotrissocladius marcidus in Alpine running waters of 7.28&deg;C &plusmn;~2.34 (min-max: 0.01-15, n=26).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Heterotrissocladius marcidus in Alpine running waters of 7.23 &plusmn;~1.09 (min-max: 5.76-9, n=14).\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Heterotrissocladius grp. marcidus (n=17, Template:explained:N2:HillsDiversity=9.83, n&lt;sub&gt;max&lt;/sub&gt;=14.29) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 34.\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Heterotrissocladius marcidus group in lake Tasersuatsiaq (West Greenland) an oxygen consumption of 4.19/4.31 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 65.3/43.8 in % is in group {overlib|A/B|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  750~ha (lake area); 66.97898&deg;N; 50.69489&deg;W; 55~&micro;S~&middot; cm⁻&sup1;; 11.8&deg;C (July 2002); max. depth: &gt;80~m.\r\n\r\n==Conductivity/Salinity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Heterotrissocladius marcidus in Alpine running waters of 99.95&micro;S &middot; cm⁻&sup1; &plusmn;~151.41 (min-max: 2-425, n=18).\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Heterotrissocladius marcidus (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(220, 454, NULL, NULL, 0, NULL, '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(221, 455, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*5 statistically significant (sigmoidal) Template:HOF:sigmoidalNotUpperLeft Template:HOF:sigmoidalUpperLeft thus optima beyond sampled 5.7 &deg;C: Heterotrissocladius subpilosus, Micropsectra radialis, Tanytarsina group B, Tanytarsus lugens/Corynocera oliveri, and unidentified Tanytarsini\r\n*&lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina\r\n\r\nHeterotrissocladius subpilosus reported by {citeID|516|Korhola et al. 2002} as cold adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Heterotrissocladius subpilosus group  and other taxa: 0&deg;C &plusmn; 0, n=8. Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n==Eutrophication==\r\n\r\n{citeID|508|Meril&auml;inen et al. 2000}: &laquo;Table~2.: Four developmental stages in the northern (N) and southern (S) basins of Lake Lappaj&auml;rvi. Characterization of the sediment quality, sedimentary diatoms (reconstructed pH according to {citeID|509|Renberg and Hellberg 1982}) and chironomid remains (BQI according to {citeID|510|Wiederholm 1980})&raquo;\r\n{| style=''border:1px solid;'' \r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!colspan=''2''|Pre industrial&lt;br&gt;early 1990s\r\n!colspan=''2''|Increasing loading&lt;br&gt;ca. 1935-1960\r\n!colspan=''2''|Erosion&lt;br&gt;ca. 1960-1970\r\n!colspan=''2''|Meso-eutrophic stage&lt;br&gt;ca. 1970-present\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|Water content (% WW)\r\n|41&ndash;45 \r\n|81&ndash;82 \r\n|66&ndash;74 \r\n|79&ndash;83 \r\n|56&ndash;62 \r\n|68&ndash;77 \r\n|64&ndash;94 \r\n|73&ndash;89\r\n\r\n|-\r\n|Loss on ignition (% DW) \r\n|2.2&ndash;2.4 \r\n|14&ndash;16 \r\n|8.7&ndash;9.9 \r\n|13&ndash;15 \r\n|5.6&ndash;7 \r\n|8.8&ndash;14 \r\n|5.7&ndash;15 \r\n|7.1&ndash;15\r\n\r\n|-\r\n|Bulk density (g&middot;cm⁻&sup3;) \r\n|1.51&ndash;1.57 \r\n|1.13 \r\n|1.19&ndash;1.37 \r\n|1.0&ndash;1.12 \r\n|1.30&ndash;1.36 \r\n|1.14&ndash;1.22 \r\n|1.03&ndash;1.36 \r\n|1.05&ndash;1.19\r\n\r\n|-\r\n|pH spectra [based on diatomes]\r\n|5.9&ndash;6.4 \r\n|. . \r\n|5.9&ndash;6.8 \r\n|. . \r\n|6.7&ndash;6.9 \r\n|. . \r\n|6.9&ndash;7.4 \r\n|. .\r\n\r\n|-\r\n|Head capsules, 10⁻&sup3;&middot;m⁻&sup2;&middot;a⁻&sup1;\r\n|1.1&ndash;2.2 \r\n|25 \r\n|12&ndash;17 \r\n|24&ndash;87 \r\n|8.2&ndash;20 \r\n|27&ndash;34 \r\n|10&ndash;19 \r\n|17&ndash;60\r\n\r\n|-\r\n|Key species in chironomids \r\n|Hesu \r\n|Micr Stro \r\n|Micr Stro Seco \r\n|Chan Micr Stro\r\n|Chan Stro \r\n|Chan \r\n|Chan Chpl \r\n|Chan Chpl\r\n\r\n|-\r\n|BQI \r\n|4.4&ndash;4.6 \r\n|3.7 \r\n|3.2&ndash;3.5 \r\n|2.4&ndash;3.4 \r\n|2.0&ndash;3.3 \r\n|2.0&ndash;2.2 \r\n|2.2&ndash;2.5 \r\n|1.6&ndash;1.8\r\n\r\n|-\r\n&lt;td colspan=''9''&gt;Chan~=~Chironomus anthracinus gr., Chpl~=~Chironomus plumosus, Hesu~=~Heterotrissocladius subpilosus, Micr~=~Micropsectra spp., Seco~=~Sergentia coracina, Stro~=~Stictochironomus rosenscholdi.&lt;/td&gt;\r\n\r\n|}\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Heterotrissocladius grp. subpilosus (n=6, Template:explained:N2:HillsDiversity=4.85, n&lt;sub&gt;max&lt;/sub&gt;=2.13) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 36.\r\n\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Heterotrissocladius subpilosus  and other taxa: 16.5m &plusmn; 9.7 (n=12). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', '111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(222, 465, NULL, NULL, 0, NULL, '182 223 154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(223, 466, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with III: 5.02&ndash;5.95, IV: 4.09&ndash;4.98, V: 3.01&ndash;3.82.\r\n\r\n\r\n===Temperature===\r\n\r\n{textciteID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Endochironomus impar type [most abundant in &gt;16&deg;C], Chironomus plumosus type, Nanocladius rectinervis type, Endochironomus albipennis type, Glyptotendipes pallens type, Einfeldia pagana type and Microchironomus tener type had the highest temperature optima.&raquo;\r\n', '182 223 154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(224, 467, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Endochironomus impar type, Chironomus plumosus type, Nanocladius rectinervis type, Endochironomus albipennis type [most abundant in &gt;16&deg;C], Glyptotendipes pallens type, Einfeldia pagana type and Microchironomus tener type had the highest temperature optima.&raquo;', '182 223 154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(225, 469, NULL, NULL, 0, NULL, '13 49', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(226, 470, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(227, 471, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(228, 472, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(229, 473, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(230, 474, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(231, 475, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(232, 476, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(233, 477, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(234, 478, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(235, 479, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(236, 480, NULL, NULL, 0, NULL, '65 86 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(237, 481, NULL, NULL, 0, NULL, '17 202 155 118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(238, 482, NULL, NULL, 0, NULL, '17 202 155 118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(239, 483, NULL, NULL, 0, NULL, '17 202 155 118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(240, 484, NULL, NULL, 0, NULL, '17 202 155 118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(241, 492, NULL, NULL, 0, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Paralimnophyes hydrophilus (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '79 56', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(242, 496, NULL, NULL, 0, NULL, '56 49 61 79 116 13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(243, 497, NULL, NULL, 0, NULL, '56 49 61 79 116 13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(244, 498, NULL, NULL, 0, NULL, '56 49 61 79 116 13', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(245, 506, 356, NULL, 0, NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 7, NULL, NULL, 0, NULL, 2, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(246, 507, NULL, NULL, 0, NULL, '33', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(247, 508, NULL, NULL, 0, '==Temperature==\r\n\r\nAs cool-water chironomids {citeID|535|Birks et al. 2000} reports: Heterotrissocladius grimshawi, Micropsectra radialis, and Corynocera oliveri/Tanytarsus lugens.\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*5 statistically significant (sigmoidal Template:HOF:sigmoidalNotUpperLeft Template:HOF:sigmoidalUpperLeft) thus optima beyond sampled 5.7 &deg;C: Heterotrissocladius subpilosus, Micropsectra radialis, Tanytarsina group B, Tanytarsus lugens/Corynocera oliveri, and unidentified Tanytarsini\r\n*&lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Micropsectra radialis  and other taxa: 7.0&lt; &deg;C, n=18 (sigmoidal decreasing Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\n{citeID|511|Brooks 2006} reports &laquo;[..] ultra-cold stenothermic oligotrophes than in the Latedevensian, especially Diamesinae, Paracladius, Corynocera oliveri type and Micropsectra radialis type.&raquo;\r\n\r\n{citeID|521|Porinchu et al. 2002} state for 57 lakes in the central, eastern Sierra Nevada of California (America): As well, Micropsectra insignilobus type has a broader temperature tolerance than Micropsectra radialis type.\r\n\r\n{citeID|534|Luoto 2009} states: &laquo;Among the chironomids, Micropsectra radialis type, Heterotrissocladius maeaeri type and Corynocera oliveri type, for example, were restricted to the northern and cold lakes, while Microchironomus tener type and Einfeldia pagna type were restricted to the warmest lakes.&raquo;\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Micropsectra radialis &ndash; group  and other taxa: 9.9m &plusmn; 6.5 (n=24). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(248, 509, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Micropsectra atrofasciata in Alpine running waters of 14.28&micro;S &middot; cm⁻&sup1; &plusmn;~25.38 (min-max: 4.24-425, n=208).\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Micropsectra atrofasciata  and other taxa to find possible differences in temperature: 2000: 10.4&deg;C &plusmn; 4.5 (6 to 14.9), 2006: 10.7&deg;C &plusmn; 4.5 (6.2 to 15.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Micropsectra atrofasciata in Alpine running waters of 5.1&deg;C &plusmn;~3.04 (min-max: 0.01-14, n=260).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Micropsectra atrofasciata in Alpine running waters of 6.26 &plusmn;~0.47 (min-max: 4.94-9.4, n=195).\r\n', '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(249, 510, NULL, NULL, 0, NULL, '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(250, 511, NULL, NULL, 0, NULL, '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(251, 512, NULL, NULL, 0, NULL, '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(252, 513, NULL, '==Characters==\r\n\r\nA description by {citeID|1|Heiri et al. 2004}:&lt;br&gt;\r\n;Head capsule: {pale}, postoccipital margin {brownish}, postoccipital plate triangular with a rounded anterior margin, very {pale}\r\n;Antennal pedestal: long, with a long, straight and apically rounded spur \r\n;Mentum: lateral teeth dark brown, pigmentation of median tooth not clearly discernible\r\n;Mandible: three inner teeth, one apical tooth and one outer tooth\r\n;Premandible: bifid \r\n;Clypeal seta S3: branched', 0, NULL, '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(253, 514, NULL, NULL, 0, NULL, '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(254, 515, NULL, NULL, 0, NULL, '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(255, 516, NULL, NULL, 0, NULL, '170 23 119 150 207 7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(256, 517, NULL, NULL, 0, NULL, '206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(257, 518, NULL, NULL, 0, NULL, '13 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(258, 519, NULL, NULL, 0, NULL, '13 48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(259, 520, NULL, NULL, 0, NULL, '61 79 64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(260, 521, NULL, NULL, 0, NULL, '61 79 64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(261, 522, NULL, NULL, 0, NULL, '61 79 64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(262, 523, NULL, NULL, 0, NULL, '61 79 64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(263, 524, NULL, NULL, 0, NULL, '202 17 176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(264, 526, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*11 with significant symmetric unimodal Template:HOF:unimodal: [..] Tanytarsus pallidicornis-group  (groups 10-12&deg;C &amp; &gt;12&deg;C) \r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Tanytarsus pallidicornis type  and other taxa to find possible differences in temperature: 2000: 13.9&deg;C &plusmn; 3.8 (10.2 to 17.7), 2006: 13.8&deg;C &plusmn; 4.5 (9.3 to 18.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Tanytarsus pallidicornis-Gr. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(265, 527, NULL, NULL, 0, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Tanytarsus chinyensis  and other taxa: 8.4m &plusmn; 2.3 (n=4). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Tanytarsus cf.chinyensis (n=5, Template:explained:N2:HillsDiversity=3.74, n&lt;sub&gt;max&lt;/sub&gt;=4.55) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 9.\r\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(266, 528, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(267, 529, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(268, 530, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(269, 531, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(270, 532, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with  IV: 4.09&ndash;4.98 [as syn. Tanytarsus gr. holochlorus Edw.].\r\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(271, 533, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(272, 534, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(273, 535, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(274, 536, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(275, 537, NULL, '{citeID|16|Ekrem 2002}\r\n*''''Diagnosis'''' Larva with AR about 2.0; antenna with segment 3&ndash;5 pigmented; Lauterborn organs small, on pedestals about 2&times; longer than length of antennal segments 3&ndash;5 with broad, basal band; mentum with 3 broad median teeth; mandible with 3 inner ventral teeth, 1 apical ventral, 1 apical dorsal and 1 large dorsal plate-like tooth; postoccipital plate narrow with distinct cleavage. \r\n*''''Remarks'''' Diagnostic characters for larvae of the T. lugens species group have not been established, but common for T. bathophilus and T. lugens is the large dorsal plate-like tooth on the mandibles. This character, however, is also present on larval mandibles of Corynocera ambigua Zetterstedt and C. oliveri Lindeberg ({citeID|469|Hofmann 1984}), but these species can be distinguished by their reduced mentum and mandible (C. ambigua) and three dorsoapical mandibular teeth (C. oliveri). Hofmann, op. cit. mentions that the middle tooth and first lateral teeth of the mentum of Corynocera larvae constitutes a distal ventral plate and that the next lateral teeth are situated dorsally of their median neighbour teeth. This mentum construction is also present, although not as dominating, in many if not all Tanytarsus species, and caution should be taken by palaeoecologists who wish to determine worn mouth parts of Tanytarsini head capsules to species and even genus level!', 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(276, 538, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(277, 539, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(278, 540, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(279, 541, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(280, 542, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(281, 1664, NULL, '==History==\r\n\r\nTanytarsus sp. C {citeID|278|Hofmann 1971} is T. glabrescens {citeID|276|Edwards 1929} as mentioned by {citeID|302|Brooks et al. 2007}.', 0, '==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Tanytarsus sp. C  and other taxa: 12.7&deg;C &plusmn; 0.7, n=11 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Tanytarsus sp. C  and other taxa to find possible differences in temperature: 2000: 14.4&deg;C &plusmn; 3.8 (10.5 to 18.2), 2006: 14.1&deg;C &plusmn; 3.6 (10.5 to 17.7) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n{citeID|521|Porinchu et al. 2002} reports as warmer preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Pagastiella, Polypedilum and Tanytarsus sp. A/C are most abundant at sites with surface water temperatures in excess of 17.5&deg;C.\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Tanytarsus cf.glabrescens (n=8, Template:explained:N2:HillsDiversity=6.33, n&lt;sub&gt;max&lt;/sub&gt;=4.65) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 7.\r\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(282, 544, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(283, 545, NULL, 'See {textciteID|551|Ekrem and Halvorsen 2007}.', 0, '==Biotops==\r\n\r\n{textciteID|551|Ekrem and Halvorsen 2007}: &laquo;The larvae of T. lapponicus have been found in the sublittoral/profundal zone in a study of recovering acidified lakes in the Killarney Provincial Park, Ontario, Canada (the Northern Lakes Recovery Study - NLRS). Twenty-two lakes were studied, with pH ranging from 4.6 to 7.7. The depth at which the larvae were found range from 6-22m [..] only the sublittoral/profundal zone was sampled in each lake. The species appears to be an indicator of non-acidic conditions. It was found in lakes with pH ranging from 5.8-7.7, but was absent from lakes with lower pH. Tanytarsus lapponicus was found in both clearwater and brownwater lakes, the dissolved organic carbon content (DOC) ranged from 0.8~mg~&middot;~l⁻&sup1; to 4.2~mg~&middot;~l⁻&sup1;&raquo;\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(284, 546, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(285, 547, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(286, 548, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(287, 549, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(288, 550, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(289, 551, NULL, 'A.Plank (Mon Mar 16 2009 14:36:06 GMT+0100): {overlib|mandible of Corynocera oliveri''s|<img src=''image.php?text=Image reduced version. Deleted: Coce_olie_man_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Coce_olie_man_WCh1983_r.gif 2009-12-15 10:36:17''>} mandible is exact the same as {overlib|Tanytarsus gracilentus|<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_man_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_man_Paa1972_r.gif 2009-12-15 10:36:17''><img src=''image.php?text=Image reduced version. Deleted: Tany_grac_man_Mol2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_man_Mol2001_r.gif 2009-12-15 10:36:17''>}. Also the mentum looks similar: {overlib|''''''oliveri''''''|<img src=''image.php?text=Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17''>} and {overlib|''''''gracilentus''''''|<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17''>}. But Tanytarsus gracilentus has a dark plate behind the mentum ({citeID|302|Brooks et al. 2007}). See also [[http://lists.vm.ntnu.no/pipermail/chironomidae/2009-March/thread.html#93 Chironomidae discussion list]]. Many literature data should possibly be handled with care.\r\n\r\n\r\n{| style=''border:1px solid;'' \r\n\r\n&lt;thead&gt;\r\n|-\r\n!|Reference\r\n!|Length\r\n!im90 |Larvae color \r\n!im90 |Head: color\r\n!im90 |Head: width\r\n!im90 |Head: length\r\n!im90 |Antenna: AR\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|{textciteID|404|Paasivirta 1972}&lt;!-- Reference --&gt;\r\n|7.0-7.5mm (n=10)&lt;!-- Length --&gt;\r\n|alive {yellowish} {pink}, prepupa stage the thorax becomes {yellowish green}&lt;!-- Larvae color --&gt;\r\n|{pale brown}&lt;!-- Head: color --&gt;\r\n|362-406 (n=9)&lt;!-- Head: width --&gt;\r\n|493-543 (n=9)&lt;!-- Head: length --&gt;\r\n|2.4&lt;!-- Antenna: AR --&gt;\r\n\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n', 0, 'Template:questions:open see also \r\n*{textciteID|495|Ingvason et al. 2006} \r\n*in {textciteID|498|Gardarsson et al. 2004}: &laquo;A theoretical approach, based on the same data set as well as measurements of body size, and centered on the dominant species, T. gracilentus, is presented by {textciteID|493|Einarsson et al. 2002}&raquo;.\r\n*life cycle see {textciteID|538|Lindegaard and J&oacute;nasson 1975}\r\n\r\n==Biotops==\r\n\r\n{textciteID|404|Paasivirta 1972} found T.gracilentus at the isand group Valassaaret ([[http://maps.google.com/maps?f=q&amp;hl=de&amp;geocode=&amp;time=&amp;date=&amp;ttype=&amp;q=63%C2%B0+25''N,+21%C2%B0+4''E&amp;ie=UTF8&amp;z=13 63&deg; 25''N, 21&deg; 4''E]]) in the ooze bed along the shallow coast and in ponds of the main island but not on gravel or stony beds. Occours together with Chironomus plumosus type, Psectrocladius limbatellus, Cricotopus sylvestris, T. veralli coll., Paratanytarsus inopertus, P. laetipes, Procladius sp., Stictochironomus sp., Endochironomus sp. and Cladotanytarsus sp. based on traps during May 18 until July 20 1968. He suggest T.gracilentus being a pioneer species.\r\n\r\n{textciteID|551|Ekrem and Halvorsen 2007}: &laquo;T. gracilentus mainly inhabits freshwater rockpools an shallow brackish water habitats in Fennoscandinavia, but can be extremely numerous in oligotrophic lakes in arctic and subarctic environments (e.g. Lake Myvytn on Iceland)&raquo;\r\n\r\n\r\n===Depth===\r\n\r\n{textciteID|404|Paasivirta 1972} found in several depths but was concentrated  at 0.2-0.6~m in the [[http://maps.google.com/maps?f=q&amp;source=s_q&amp;hl=de&amp;geocode=&amp;q=63.430227N,+21.069417E&amp;sll=63.430227,21.069417&amp;sspn=0.012784,0.035706&amp;ie=UTF8&amp;ll=63.428864,21.070533&amp;spn=0.012785,0.035706&amp;z=15 K&auml;rringsund]].\r\n\r\n===Oxygen===\r\n\r\n{textciteID|492|Brodersen et al. 2004}: in lake Store Salts&oslash; (West Greenland) oxygen consumption was 8.48 and 6.92㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with critical P&lt;sub&gt;sat&lt;/sub&gt; values 15.1% and 18.3% respectively both in group {overlib|E|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators}. The site was characterised by following parameters: 31~ha (lake area); 66.99&deg;N; 50.59833&deg;W; 2,798~&micro;S~&middot; cm⁻&sup1;; 14.0&deg;C (July 2002); max. depth: 11~m. [...] Group E taxa were strong oxy-regulators such as Chironomus hyperboreus, Chironomus riparius type, T. gracilentus, and the oligochaetes (Lumbriculus variegatus and Uncinais uncinata). The mean critical P&lt;sub&gt;sat&lt;/sub&gt; for the group E chironomids was 22.6%. [...]  T. gracilentus is an indicator of strongly stratiﬁed and meromictic West Greenland lakes ({citeID|494|Brodersen and Anderson 2002}).\r\n\r\n\r\n===Oscillation in abundance===\r\n\r\n{textciteID|497|&Oacute;lafsson et al. 2003}: The chironomid, Tanytarsus gracilentus and Chironomus islandicus are among the most abundant macroinvertebrate in Lake M&yacute;vatn, northern Iceland. These species as well as some Orthocladiinae and Tanypodinae species comprise the bulk of the lake benthos. Two species of the green algae, Cladophorales, Aegagropila linnae and Cladophora glomerata characterise the benthos to a great extent in this shallow lake. Both chironomids and algae show severe fluctuation in abundance and distribution between years.\r\n\r\n{textciteID|498|Gardarsson et al. 2004}: The pattern of population fluctuations of chironomid species at Lake Myvatn serves to cluster the species into two main groups: (1) a large cyclic group, including Tanytarsus gracilentus, Micropsectra lindrothi, Orthocladius consobrinus, Psectrocladius barbimanus, Procladius islandicus and probably Chironomus islandicus. These species are generally associated with the profundal zone (e.g. {citeID|500|Lindegaard 1979}) and are considered to feed largely on detritus and diatoms ({citeID|499|Olafsson 1990}; {citeID|501|Ingvason et al. 2002}), with the exception of the mainly predatory Procladius. [...] Tanytarsus gracilentus showed cyclic population fluctuations with three peaks during the 20-year period; on the basis of variation in wing length, these fluctuations are thought to be driven by its interaction with resources and not by predator-prey interactions ({citeID|493|Einarsson et al. 2002}). The fluctuations in T. gracilentus were closely tracked by a related species, Micropsectra lindrothi (r&lt;sub&gt;Pearson&lt;/sub&gt;~= 0.67, P~&lt; 0.001, n~= 40, at KS [was placed in a sheltered garden at the farm Kalfastr&ouml;nd, 12 m from the shore of Lake Myvatn, 1.4 m above the surface, 0.4~m above the sward]; r&lt;sub&gt;Pearson&lt;/sub&gt;~= 0.35, P~&lt; 0.05, at SN [was in an exposed situation on a boat shed at Sydri-Neslond on the shore of Lake Myvatn]), which also had 2 flight periods\r\n\r\n===Conductivity===\r\n\r\n\r\n{textciteID|404|Paasivirta 1972}: reports a specific conductivity of 235-6,600~&micro;S.\r\n\r\n{textciteID|547|Walker 1987}, p. 36: &laquo;At high salinities (4000 to 12,000 &micro;S/cm) with somewhat lower productivity, Tanytarsus gracilentus and Cryptotendipes ariel prevail.&raquo;\r\n\r\n{textciteID|536|Rossaro et al. 2004}, {textciteID|489|Rossaro et al. 2006} report a conductivity for Tanytarsus gracilentus in Alpine running waters of 90.54&micro;S &middot; cm⁻&sup1; &plusmn;~9.59 (min-max: 72-109, n=11).\r\n\r\n{textciteID|492|Brodersen et al. 2004} report 2,798 &micro;S &middot; cm⁻&sup1; in a lake in Greenland.\r\n\r\n===Temperature===\r\n\r\n{textciteID|536|Rossaro et al. 2004}, {textciteID|489|Rossaro et al. 2006} report a H₂O temperature for Tanytarsus gracilentus in Alpine running waters of 4.11&deg;C &plusmn;~1.31 (min-max: 2-8, n=13).\r\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(290, 552, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(291, 553, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(292, 554, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(293, 555, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(294, 556, NULL, NULL, 0, NULL, '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(295, 557, NULL, 'See also Tanytarsus gracilentus and Tanytarsus sp. C. Mandibles are slightly similar.', 0, '==Temperature==\r\n\r\n{textciteID|506|Lotter et al. 1997}: &laquo;{textciteID|241|Brundin 1949} defined the &lsquo;Tanytarsus lugens&rsquo;- community consisting of ten cold stenothermal, poly-oxybiontic, and eurybathic species, which are found in the littoral zone of lakes only under subarctic/arctic conditions. In temperate lakes, they are restricted to the profundal zone, i.e. the region below the thermocline.[...]  Our results indicate that members of the &lsquo;Tanytarsus lugens&rsquo;-community are most abundant in high-elevation Swiss lakes.&raquo;\r\n\r\nAs cool-water chironomids {textciteID|535|Birks et al. 2000} reports: Heterotrissocladius grimshawi, Micropsectra radialis, and Corynocera oliveri/Tanytarsus lugens.\r\n\r\n{textciteID|507|Brooks and Birks 2000}: \r\n*5 statistically significant (sigmoidal Template:HOF:sigmoidalNotUpperLeft Template:HOF:sigmoidalUpperLeft) thus optima beyond sampled 5.7 &deg;C: Heterotrissocladius subpilosus, Micropsectra radialis, Tanytarsina group B, Tanytarsus lugens/Corynocera oliveri, and unidentified Tanytarsini\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Tanytarsus lugens  and other taxa: 11.7&deg;C &plusmn; 3.8, n=38 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Tanytarsus lugens/Corynocera oliveri type  and other taxa to find possible differences in temperature: 2000: 11.9&deg;C &plusmn; 4.5 (7.4 to 16.5), 2006: 11.6&deg;C &plusmn; 4.8 (6.8 to 16.4) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n\r\n{textciteID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type, Micropsectra insignilobus type, Protanypus, Tanytarsus lugens type [most abundant in &lt; 13&deg;C to 16&deg;C], Hydrobaenus, Heterotrissocladius grimshawi type, Corynocera ambigua and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n\r\n==Depth==\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Tanytarsus lugens  and other taxa: 7.4m &plusmn; 4.4 (n=36). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n{textciteID|556|Ilyashuk et al. 2007}: &laquo;T. lugens-type is characterized as deep-water inhabitant (e.g., Hofmann, 1988; {citeID|515|Korhola et al. 2000}), and, in shallow lakes, it is also more associated with deeper zone Za of lake basin ({citeID|1|Heiri et al. 2004}).&raquo; \r\n\r\n==Oxygen==\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Tanytarsus cf.lugens (n=11, Template:explained:N2:HillsDiversity=8.81, n&lt;sub&gt;max&lt;/sub&gt;=4.17) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 11.\r\n', '88 23 150 207 119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(296, 559, NULL, NULL, 0, NULL, '56 15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(297, 560, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Heleniella serratosioi in Alpine running waters of 24.68&micro;S &middot; cm⁻&sup1; &plusmn;~48.09 (min-max: 2-474, n=76).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Heleniella serratosioi in Alpine running waters of 5.35&deg;C &plusmn;~2.08 (min-max: 1-15, n=91).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Heleniella serratosioi in Alpine running waters of 6.43 &plusmn;~0.75 (min-max: 4.94-9.4, n=69).', '56 15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(298, 563, NULL, NULL, 0, NULL, '215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(299, 564, NULL, NULL, 0, NULL, '215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(300, 567, NULL, NULL, 0, NULL, '44 223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(301, 568, NULL, NULL, 0, NULL, '44 223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(302, 569, NULL, NULL, 0, NULL, '44 223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(303, 570, NULL, NULL, 0, NULL, '44 223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(304, 579, NULL, NULL, 0, NULL, '37', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(305, 580, NULL, NULL, 0, NULL, '37', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(306, 581, NULL, NULL, 0, NULL, '37', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(307, 582, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, NULL, 'brush not drawn', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(308, 583, 2, NULL, 0, '==Biotops==\r\n\r\n===Temperature===\r\n\r\n{textciteID|302|Brooks et al. 2007}: S.coracina is cold stenotherm ({citeID|242|Brundin 1956}; {citeID|567|Brodin 1986})\r\n\r\n{textciteID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina.\r\n\r\nSergentia coracina reported by {textciteID|516|Korhola et al. 2002} as intermediate taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type, Micropsectra insignilobus type, Protanypus, Tanytarsus lugens type, Hydrobaenus, Heterotrissocladius grimshawi type, Corynocera ambigua and Sergentia coracina type [most abundant in &lt;13&deg;C to 16&deg;C] had the lowest temperature optima in the present dataset.&raquo;\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Sergentia coracina  and other taxa: 7.8m &plusmn; 5 (n=44). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n\r\n===Eutrophication===\r\n\r\n{textciteID|508|Meril&auml;inen et al. 2000}: &laquo;Table~2.: Four developmental stages in the northern (N) and southern (S) basins of Lake Lappaj&auml;rvi. Characterization of the sediment quality, sedimentary diatoms (reconstructed pH according to {textciteID|509|Renberg and Hellberg 1982}) and chironomid remains (BQI according to {citeID|510|Wiederholm 1980})&raquo;\r\n{| style=''border:1px solid;'' \r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!colspan=''2''|Pre industrial&lt;br&gt;early 1990s\r\n!colspan=''2''|Increasing loading&lt;br&gt;ca. 1935-1960\r\n!colspan=''2''|Erosion&lt;br&gt;ca. 1960-1970\r\n!colspan=''2''|Meso-eutrophic stage&lt;br&gt;ca. 1970-present\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|Water content (% WW)\r\n|41&ndash;45 \r\n|81&ndash;82 \r\n|66&ndash;74 \r\n|79&ndash;83 \r\n|56&ndash;62 \r\n|68&ndash;77 \r\n|64&ndash;94 \r\n|73&ndash;89\r\n\r\n|-\r\n|Loss on ignition (% DW) \r\n|2.2&ndash;2.4 \r\n|14&ndash;16 \r\n|8.7&ndash;9.9 \r\n|13&ndash;15 \r\n|5.6&ndash;7 \r\n|8.8&ndash;14 \r\n|5.7&ndash;15 \r\n|7.1&ndash;15\r\n\r\n|-\r\n|Bulk density (g&middot;cm⁻&sup3;) \r\n|1.51&ndash;1.57 \r\n|1.13 \r\n|1.19&ndash;1.37 \r\n|1.0&ndash;1.12 \r\n|1.30&ndash;1.36 \r\n|1.14&ndash;1.22 \r\n|1.03&ndash;1.36 \r\n|1.05&ndash;1.19\r\n\r\n|-\r\n|pH spectra [based on diatomes]\r\n|5.9&ndash;6.4 \r\n|. . \r\n|5.9&ndash;6.8 \r\n|. . \r\n|6.7&ndash;6.9 \r\n|. . \r\n|6.9&ndash;7.4 \r\n|. .\r\n\r\n|-\r\n|Head capsules, 10⁻&sup3;&middot;m⁻&sup2;&middot;a⁻&sup1;\r\n|1.1&ndash;2.2 \r\n|25 \r\n|12&ndash;17 \r\n|24&ndash;87 \r\n|8.2&ndash;20 \r\n|27&ndash;34 \r\n|10&ndash;19 \r\n|17&ndash;60\r\n\r\n|-\r\n|Key species in chironomids \r\n|Hesu \r\n|Micr Stro \r\n|Micr Stro Seco \r\n|Chan Micr Stro\r\n|Chan Stro \r\n|Chan \r\n|Chan Chpl \r\n|Chan Chpl\r\n\r\n|-\r\n|BQI \r\n|4.4&ndash;4.6 \r\n|3.7 \r\n|3.2&ndash;3.5 \r\n|2.4&ndash;3.4 \r\n|2.0&ndash;3.3 \r\n|2.0&ndash;2.2 \r\n|2.2&ndash;2.5 \r\n|1.6&ndash;1.8\r\n\r\n|-\r\n&lt;td colspan=''9''&gt;Chan~=~Chironomus anthracinus gr., Chpl~=~Chironomus plumosus, Hesu~=~Heterotrissocladius subpilosus, Micr~=~Micropsectra spp., Seco~=~Sergentia coracina, Stro~=~Stictochironomus rosenscholdi.&lt;/td&gt;\r\n\r\n|}\r\n\r\n===pH===\r\n\r\n{textciteID|302|Brooks et al. 2007}: S.coracina is acidophil ({citeID|569|Uutala 1986}; {citeID|567|Brodin 1986}; {citeID|568|Ilyashuk and Ilyashuk 2000}; {citeID|517|Olander et al. 1999})\r\n', '223', NULL, 5, 1.45, 0, NULL, 0.1, 1, NULL, 0.39, 0.1, 1, NULL, 0.96, 0.1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, '2 inner lower', 6, NULL, NULL, NULL, NULL, NULL, 7, NULL, 0, NULL, 7, NULL, '>6th lateral', 0, NULL, 4, 1, 1, 0, '4 inner in contrast to Endochironomus', 0, NULL, NULL, NULL, NULL, NULL, 1, 'tree like', 1, 'reaches 3rd inner tooth', NULL, NULL, NULL, NULL, 15, 'plumose', 12, 'plumose', NULL, NULL, NULL, 2.0, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(309, 584, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, 1, 1, 1, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '4 treelike brunches', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5.0, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(310, 585, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, 1, 1, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '3 tree like', 1, 'serrated reaches basis of 3rd inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4.0, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(311, 586, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.5, NULL, NULL, NULL, 1, '2 apical 1 small, smooth basal', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(312, 587, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, 1, 1, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '4 tree like branches', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(313, 588, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(314, 589, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4.0, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(315, 590, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 1, '2 rounded apical 1 hump basal', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(316, 591, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not drawn', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(317, 592, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not drawn', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(318, 593, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, 1, 1, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '4 tree like brushes', 1, 'reaches 2nd inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4.0, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(319, 594, 36, NULL, 0, NULL, '223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4.5, NULL, NULL, NULL, 1, '4 apical 1 rounded/smooth basal', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(320, 598, 20, NULL, 0, '{citeID|20|Schmid 1993}: larvae and pupae have been found in hight densities in the upper reaches of brooks and rivers in the surface layer of the bed sediments (0-10cm)\r\n\r\n==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Paratrichocladius skirwithensis in Alpine running waters of 344.08&micro;S &middot; cm⁻&sup1; &plusmn;~186.82 (min-max: 4-710, n=86).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Paratrichocladius skirwithensis in Alpine running waters of 4.6&deg;C &plusmn;~2.11 (min-max: 0.01-15, n=254).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Paratrichocladius skirwithensis in Alpine running waters of 8.45 &plusmn;~0.91 (min-max: 5.54-9.9, n=69).\r\n', '103 31', NULL, 5, 1.665, 0, NULL, 0.099, 8, NULL, 0.17, NULL, 1, NULL, 0.85, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.198, 0.083, 9, NULL, 'yellow, in instar II and III brown', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 1.82, NULL, 1, 2, 0.2, 9, NULL, 4.3, 0.2, NULL, 0, NULL, 3, 1, 0, 0, 'apical tooth narrower than 3rd inner', 0, NULL, NULL, NULL, NULL, NULL, 1, '6 serrated branches', 1, 'toothlets at base', NULL, NULL, NULL, NULL, 2, 'outer margin sometimes serrated', NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 9, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(321, 698, 40, NULL, 0, NULL, '103 31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 3.09, NULL, 1, 5.23, NULL, 1, NULL, 4, NULL, NULL, 0, NULL, 4, 1, 0, 0, 'large apical tooth', 0, NULL, NULL, NULL, NULL, NULL, NULL, 'not drawn', 1, 'reaches 2nd inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(322, 600, 20, NULL, 0, '{citeID|20|Schmid 1993} in brook mosses and at the sediment surface (0-10cm) in the krenal region of brooks.\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Paratrichocladius nivalis in Alpine running waters of 6.41&deg;C &plusmn;~4.13 (min-max: 0.01-15, n=60).\r\n', '103 31', NULL, 5, 1.691, 0, NULL, 0.131, 5, NULL, 0.14, NULL, 1, NULL, 0.92, NULL, 1, 'reaching base of 5th segment', NULL, NULL, 0, NULL, NULL, NULL, NULL, 1.267, 0.022, 5, NULL, 'dark-brown', NULL, 'black', NULL, 1, NULL, 6, '2nd lateral teeth smaller than 1st and 3rd pair; MR >== 2', NULL, 1.8, NULL, 1, 1.8, 0.1, 1, NULL, 4.5, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'toothlets at the base', NULL, NULL, NULL, NULL, 2, 'outer margin sometimes serrated', 1, NULL, 1, NULL, NULL, 2.0, NULL, NULL, 1, 0, '2 distinct teeth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(323, 601, NULL, NULL, 0, NULL, '118 142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(324, 602, 20, NULL, 0, NULL, '118 142', NULL, NULL, 0.69, NULL, NULL, 0.445, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.31, 0.095, 4, 'postoccipital margin pale', 'yellow', NULL, NULL, NULL, 1, 'dome-shaped', 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, 3, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, 0, '2 apical an 1 basal tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(325, 603, NULL, NULL, 0, NULL, '118 142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(326, 604, NULL, NULL, 0, NULL, '118 142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(327, 605, NULL, NULL, 0, NULL, '202 17', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(328, 606, NULL, NULL, 0, NULL, '202 17', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(329, 607, NULL, NULL, 0, NULL, '17 106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(330, 608, NULL, NULL, 0, NULL, '17 106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(331, 614, NULL, NULL, 0, NULL, '86 19', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(332, 615, NULL, NULL, 0, NULL, '197 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(333, 620, 20, NULL, 0, NULL, '103 122', NULL, 5, 1.531, 0, NULL, 0.113, 9, NULL, 0.11, NULL, 1, NULL, 0.79, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.279, 0.177, 9, NULL, 'yellow', NULL, 'pale', NULL, 1, NULL, 6, NULL, NULL, 1.71, NULL, 1, 2.31, NULL, 1, NULL, 5.5, 0.5, NULL, 0, NULL, 4, 1, 0, 0, NULL, 0.2, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'does reach middle of 2nd inner tooth', NULL, NULL, NULL, NULL, 1.6, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(334, 621, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.375, 0, NULL, NULL, 1, NULL, 0.171, NULL, 1, NULL, 0.851, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.375, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, '1st+2nd tooth fused', NULL, 1.44, NULL, 1, 1.9, NULL, 1, NULL, 5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'not reaching base of "0.5" tooth', NULL, NULL, NULL, NULL, 1.9, 'outer setae part is shorter not inner!', 1, NULL, 1, NULL, NULL, 2.0, NULL, NULL, 1, 0, '1 apical 1 basal', '3 scales', NULL, NULL, NULL, NULL, 1, 4, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(335, 622, 46, NULL, 0, NULL, '103 122', NULL, 5, 1, 0, NULL, NULL, 1, NULL, 0.176, NULL, 1, NULL, 0.9, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.401, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, '1st+2nd lateral slightly fused', NULL, 1.5, 0.1, 1, 1.9, 0.1, 1, NULL, 5.5, NULL, NULL, 0, NULL, 4, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches middle of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, 'inner branch shorter', 1, NULL, 1, NULL, NULL, 2.0, 1, 2, 4, 0, 'broad basal tooth', NULL, NULL, NULL, '~20 setae on tufts', NULL, 1, 7, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(336, 623, 20, NULL, 0, NULL, '103 122', NULL, 5, 1.88, 0, NULL, 0.105, 1, NULL, 0.18, NULL, 1, NULL, 1.74, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.179, 0.025, 4, NULL, 'yellow slightly darkened posteriorly', NULL, 'dark', NULL, 1, NULL, 6, '1st + 2nd tooth fused', NULL, 1.36, NULL, 1, 1.81, NULL, 1, NULL, 5.5, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'don''t reach basis of 1st inner tooth', NULL, NULL, NULL, NULL, 1.6, 'inner branch shorter', NULL, NULL, NULL, NULL, NULL, 3.0, NULL, NULL, NULL, 0, '2 apical 1 basal tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(337, 624, 46, 'holarctic', 0, '==Temperature==\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Cricotopus/Orthocladius (C. cylindraceus type)  and other taxa to find possible differences in temperature: 2000: 13.5&deg;C &plusmn; 4.1 (9.4 to 17.5), 2006: 13.8&deg;C &plusmn; 4.5 (9.3 to 18.3) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n', '', '1|2006-11-24 23:01:00', 5, 2.421, 0, NULL, NULL, 1, NULL, 0.25, NULL, 1, NULL, 1, NULL, NULL, NULL, 'very small on 3rd segment', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.14, NULL, 1, 3.33, NULL, 1, '>', 3.5, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0, 1.273, NULL, NULL, 1, 'not crenulated at outer margin', 1, '6', 1, 'reaching top of 1st inner tooth', 'yes', '10', 'yes week', '6', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(338, 625, 20, 'as C.cf intersectus', 0, 'Danube (2007-1981km): rip-rap zone and on leaves of the submerged macrophyte Potamogeton pectinatus - associated with C.reductus. (Note in Hirvenoja 1973 C.reductus resembles C.intersectus strongly only C.reductus has >20 setae at VII abdominal segment)', '103 122', NULL, 5, 1.664, 0, NULL, 0.082, 5, NULL, 0.831, NULL, 1, NULL, 0.215, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.361, 0.074, 5, NULL, 'yellow', NULL, 'darkened', NULL, 1, NULL, 6, 'fused 1st and 2nd', NULL, 1.19, NULL, 1, 2.72, NULL, 1, NULL, 5, 0.3, NULL, 0, NULL, 3, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '7 finally fine brushed setae', 1, 'does not reach 1st inner tooth', NULL, NULL, NULL, NULL, 1.5, NULL, 0, NULL, 0, NULL, NULL, 2.0, NULL, NULL, NULL, 0, '1 apical 1 basal tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(339, 626, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.677, 0, NULL, NULL, 1, NULL, 0.167, NULL, 1, NULL, 0.917, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.4, NULL, 1, 1.75, NULL, 1, NULL, 7, NULL, '>6', 0, NULL, 4, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches at least base of 2nd inner tooth', NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, 1, NULL, NULL, 2.0, NULL, 3, 2, 0, '2 apical 1 smooth basal tooth', NULL, NULL, NULL, '3 at tufts', NULL, 1, 5, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(340, 627, 46, NULL, 0, '==Biotops==\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Cricotopus (I.) sylvestris (Fabr.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Cricotopus (I.) sylvestris (Fabr.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n===Conductivity/Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Cricotopus sylvestris-Gr. (Diptera) as el~= &laquo;euryhaline-limnic taxa, i.e. freshwater taxa that tolerate salinity up to 10% (even higher salinity for a short time)&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~6-freshwater (&lt;0.5&permil;)&lt;br&gt;~~2-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~2-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Cricotopus sylvestris-type in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 3318.17mg &middot; l⁻&sup1; (&divide; 600 = 5.53mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 7.98875. In article shortened as: Cs.\r\n', '103 122', NULL, 5, 1.69, 0, NULL, NULL, 1, NULL, 0.13, NULL, 1, NULL, 0.9, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.41, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.4, NULL, 1, 2.5, NULL, 1, NULL, 6, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '~6-7 branches', 1, 'reaches not the base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.6, NULL, 1, NULL, 1, NULL, NULL, 2.0, 2, 3, 4, 0, NULL, '3 scales', NULL, NULL, NULL, 'darkend the half end', 1, 6, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(341, 628, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.588, 0, NULL, NULL, 1, NULL, 0.22, NULL, 1, NULL, 0.95, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.427, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, '1st+2nd lateral slightly fused', NULL, 1.531, NULL, 1, 3.66, NULL, 1, NULL, 4.5, 0.5, NULL, 0, NULL, 3.5, 1, 0, 0, 'seems no engraving', 0, NULL, NULL, NULL, NULL, NULL, 1, '~5 braches', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, 'inner branch shorter', 1, NULL, 1, NULL, NULL, 1.0, 1, 1, 2, 1, NULL, '3 long scales', NULL, NULL, '~12 setae at tuffs', NULL, 1, 6, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(342, 629, 46, NULL, 0, NULL, '', NULL, 5, 1.935, 0, NULL, NULL, 1, 'small antenna', 0.405, NULL, 1, NULL, 0.9, NULL, 1, NULL, 'on 2nd? segment', NULL, NULL, NULL, NULL, NULL, NULL, 1.477, NULL, 1, 'conical shape, eyes very close together', NULL, NULL, NULL, NULL, 1, NULL, 6, 'fused: 1st to 2nd; 2nd pair very small', NULL, 1.262, NULL, 1, 1.579, NULL, 1, '<', 3.5, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0, NULL, NULL, NULL, 1, 'mandible dark', 1, '5', 1, 'very small not reaching the base of 1st inner tooth', 'yes', '10', '?no', '?no', 1, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(343, 630, 46, NULL, 0, NULL, '', '1|2006-11-24 19:30:34', 5, 1.708, 0, NULL, NULL, 1, 'image measured', 0.192, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.52, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.711, NULL, 1, 1.633, NULL, 1, '>', 7, NULL, '>6', 0, NULL, 3.5, 1, 0, 0, NULL, 1, 2.86, NULL, NULL, 1, 'crenulated at outer margin', 1, '6', 1, 'reaching base of 1st internal tooth; is crenulated', NULL, '11', 'yes', '7', 1.8, NULL, 0, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(344, 631, 20, '', 0, '==Biotops==\r\n\r\n{citeID|481|Buskens and Moller-Pillot 1992}: need running water or lakes with fresh water in which they preferably live.\r\n\r\n{citeID|487|Langton and Jes&uacute;s 1999}: found pupal  exuviae in permanent and temporary Mediterranean streams.\r\n\r\n{citeID|488|Kravtsova 2007}: found in littoral zones. Characteristics of chironomid communities in Bolshye Koty Bay, Southern Baikal  (September, 1988):\r\n*Cricotopus bicinctus: n=6 (taxa), n=2 (samples), biomass 183&plusmn;176 (mg&middot;m&lt;sup&gt;-2&lt;/sup&gt;, %~error), 84% (dominant species)\r\n\r\n{citeID|489|Rossaro et al. 2006}: Chironomid species collected in streams above 900~m a.s.l. in the Italian Alps with the number of sites where a species was collected:\r\n*Cricotopus bicinctus (Meigen, 1818) 4\r\n\r\n===Salinity===\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Cricotopus bicinctus (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n===Tubes===\r\n\r\n{citeID|484|Hirabayashi and Wotton 1999}: &laquo;Psectrocladius limbatellus larvae used conditioned pellets as food and as tube building materials, thus re-using the organic matter that surrounds them. {citeID|485|Wiley and Warren 1992} described a similar recycling of organic matter by Cricotopus bicinctus (Meigen) larvae, with each larva re-using a central tube structure and foraging in the same surrounding territory (territory recycling). These impacts have been termed &lsquo;ecosystem engineering&rsquo; by {citeID|486|Lawton and Jones 1995}.&raquo;\r\n\r\n===High altitude===\r\n\r\n{citeID|379|Roback and Coﬀman 1987}: &laquo;Cricotopus (C.) bicinctus gr. cf. vierriensis Goetg. Cricotopus vierriensis Goetghebuer 1935: 4174 18.:&lt;br&gt; Three larvae and a prepupa are placed in this taxon. All of the larvae key directly to C. vierriensis in {citeID|29|Hirvenoja 1973} however, abdominal setal tufts are visible on only one larva (NP33). One of the larvae from NP18 has characters that differ from the other specimens and may represent a second species that keys to C. vierriensis. In this specimen, the antenna1 proportions are different, the mentum has a less wide median tooth, the premandible is broader and the maxilla has no pectinate lamellae on the galea. The abdomen of this specimen has a light violet tint in contrast to the greenish-yellow color of the other specimens. The antenna, mentum, prementum and maxilla of the two forms are compared in Figs. 93-96,98-101. Gut contents - mixture of detritus and diatoms. Based on larval head characters, the prepupa appears to belong to this taxon. No abdominal setal tufts are visible. The developing pupal integument is partially visible and is not inconsistent with C. vierriensis in size and arrangement of dorsal spinule groups on A.11-VI. However, the presence of spinule groups on A.VII and VIII does not fit vierriensis. No respiratory organ could be seen, probably because of the poor condition of the specimen. The lateral setae of A.VII-VIII of the pupa are unusually large for any species of Cricotopus known to me (Fig. 97). SPECIMENS EXAMINED. NP18: 2 larvae, dt. 2000 m; NP33: 1 larva, alt. 2390 m; NP144: 1 Praepupae, alt. 2300 m.&raquo;\r\n\r\n==Growth==\r\n\r\n{citeID|482|Pinder 1986}: Larvae reared at lower temperatures are usually longer than those reared at higher temperatures ({citeID|483|Mackey 1977}). In most species, rates of growth and development increase with a rise in temperature, but in Cricotopus bicinctus an increase in temperature from 15&deg; to 20&deg;C produced an increased rate of development, but not of growth ({citeID|483|Mackey 1977}).\r\n\r\n{citeID|274|Dettinger-Klemm 2003}: Developmental zero of Cricotopus bicinctus  3.8&deg;C (see {citeID|483|Mackey 1977})\r\n', '', '1|2006-11-24 21:40:38', 5, 1.782, 0, NULL, 0.099, 10, NULL, 0.133, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.28, 0.0505, 10, NULL, 'yellow', NULL, 'pale', NULL, 1, NULL, 6, '2nd pair of lateral teeth distincly smaller than 1st and 3rd', NULL, 2.11, NULL, 1, 3.08, NULL, 1, '>', 4.5, NULL, 'at 4-5', 0, NULL, 3, 1, 0, 0, '1 toothlike spine at seta subdentalis', 0, 2.083, NULL, NULL, 1, 'inner margin with 2-3 spines, outer magin crenulated', 1, '6', 1, '=1st apex of inner mandibular tooth', 'yes', '9', 'yes, (weekly)', '6', 2, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 'I-VI with setal tufts <== 50µm', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(345, 632, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.53, 0, NULL, NULL, 1, NULL, 0.33, NULL, 1, NULL, 0.84, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.2, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.1, 0.1, 1, 1.56, 0.1, 1, NULL, 4.5, 0.5, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '~6 branches', 1, 'basal crenate; reaches the middle of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, NULL, 1, NULL, 1, NULL, NULL, 2.0, 2, 3, 1, 1, NULL, '3 longer scales', NULL, NULL, '~10 setae', NULL, 1, 7, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(346, 633, 20, NULL, 0, NULL, '103 122', NULL, 5, 1.817, 0, NULL, 0.073, 4, NULL, 0.1, NULL, 1, NULL, 0.775, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.241, 0.089, 4, NULL, 'yellow, posterior brownish', NULL, 'dark', NULL, 1, NULL, 6, '5-6 lateral teeth', NULL, 1.8, NULL, 1, 4.3, NULL, 1, NULL, 6, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches middle of 1st inner tooth', NULL, NULL, NULL, NULL, 1.7, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, '1 apical 1 toothlike process', NULL, NULL, NULL, '<=10 setae', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(347, 634, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.46, 0, NULL, NULL, 1, NULL, 0.16, NULL, 1, NULL, 0.8, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.38, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.3, NULL, 1, 1.69, NULL, 1, NULL, 5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'small don''t reaches basis of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, NULL, 1, NULL, 1, NULL, NULL, 4.0, NULL, NULL, NULL, NULL, '2 apical, 2 basal teeth', '3 scales', NULL, NULL, '8 setae', NULL, 1, 6, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(348, 635, 20, NULL, 0, NULL, '103 122', NULL, 5, 1.289, 0, NULL, 0.028, 3, NULL, 0.2, NULL, 1, NULL, 0.83, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.37, 0.227, 6, NULL, 'brown', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 1.7, NULL, 1, 1.85, NULL, 1, NULL, 5, NULL, 'additional fovea close to s.submenti', 0, NULL, 3, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(349, 636, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.748, 0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.88, NULL, 1, 5, NULL, 1, NULL, 5, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1.8, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(350, 637, 46, 'from bituberculatus-material Thienemann', 0, NULL, '', '1|2006-11-24 20:55:40', 5, 1.274, 0, NULL, NULL, 1, NULL, 0.217, NULL, 1, NULL, 0.952, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.36, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.857, NULL, 1, 1.3, NULL, 1, '>', 5.5, NULL, 'at tooth-position 5-6', 0, NULL, 3, 1, 0, 0, NULL, 0, 2.5, NULL, NULL, 1, 'not crenulated at outer margin', 1, '5 branches', 1, '=1st inner tooth', 'yes', '8-(10?)', 'yes', '7', 2, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, '1 apical and 1 small basal', '3 scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(351, 638, 20, 'as C. cf.festivellus', 0, NULL, '103 122', NULL, 5, 1.731, 0, NULL, 0.124, 8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.26, 0.032, 8, NULL, 'yellow', NULL, 'pale', NULL, 1, NULL, 6, NULL, NULL, 2.4, NULL, 1, 4.619, NULL, 1, NULL, 6, NULL, NULL, 0, NULL, 3, 1, 0, 0, 'apical tooth long: apical tooth=cpmbined 3rd+2nd', 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, 'reaches base of 2nd inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(352, 639, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.46, 0, NULL, NULL, 1, NULL, 0.14, NULL, 1, NULL, 0.82, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.43, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.24, NULL, 1, 2.24, NULL, 1, NULL, 5.5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '6', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, 'inner branch shorter', 1, NULL, 1, NULL, NULL, 2.0, NULL, NULL, 2, NULL, NULL, '3 long scales', NULL, NULL, '~8 setae', NULL, 1, 6, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(353, 640, 46, NULL, 0, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Cricotopus fuscus in Alpine running waters of 9.24&deg;C &plusmn;~4.24 (min-max: 6-21, n=17).\r\n', '103 122', NULL, 5, 1.898, 0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.443, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.29, NULL, 1, 1.212, NULL, 1, NULL, 6.5, 0.5, '>6', 0, NULL, 3.5, 1, 0, 0, '\n\n\n', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1.5, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(354, 641, 20, NULL, 0, NULL, NULL, '1|2006-11-24 20:35:05', 5, 1.435, 0, NULL, 0.109, 7, NULL, 0.148, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.339, 0.045, 8, NULL, 'yellow', NULL, 'light', NULL, 1, NULL, 6, NULL, NULL, 1.81, NULL, 1, 2.24, NULL, 1, '>', 7.5, NULL, '>6th lateral tooth', 0, NULL, 3, 1, 0, 0, NULL, 0, 1.917, NULL, NULL, 1, 'outer margin NOT crenulated', 1, '6', 1, '=1st inner tooth', 'yes', '6', 'yes', '6', 1.9, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 0, '1 apical and 1 small basal', NULL, NULL, NULL, 'I-VI with small (<== 50µm) tufts of <== 15 setae', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(355, 642, 46, NULL, 0, NULL, '103 122', NULL, 5, NULL, 0, NULL, NULL, 1, NULL, 0.175, NULL, 1, NULL, 0.83, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.422, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.1, 0.1, 1, 1.846, NULL, 1, NULL, 5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'not reaching base of first 0.5 tooth', NULL, NULL, NULL, NULL, 1.7, 'inner shorter', 1, NULL, 1, NULL, NULL, 3.0, NULL, NULL, NULL, NULL, '1 braod basal tooth', NULL, NULL, NULL, 'tuffs: about 10 setae', NULL, 1, 2, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(356, 643, 20, 'as C.curtus Hirvenoja, 1973', 0, NULL, '', '1|2006-11-24 22:33:38', 5, 1.657, 0, NULL, 0.037, 4, NULL, 0.139, NULL, 1, NULL, 1, NULL, NULL, NULL, 'on 3rd opposite to each other', NULL, NULL, NULL, NULL, NULL, NULL, 1.361, 0.041, 3, NULL, 'yellow', NULL, 'pale', NULL, 1, NULL, 6, NULL, NULL, 1.313, NULL, 1, 1.655, NULL, 1, '>=', 6.5, NULL, '> 6', 0, NULL, 3.5, 1, 0, 0, NULL, 0.5, 1.389, NULL, NULL, 1, 'crenulated on outer margin', 1, '5 branches', 1, 'reaching base of 1st inner tooth', 'yes', '9', 'yes', '9', 1.7, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 'I-VI with small (<40µm) setal tufts of 7-8 setae', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(357, 644, 46, 'holarctic', 0, '==Temperature==\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Cricotopus/Orthocladius (C. tremulus type)  and other taxa to find possible differences in temperature: 2000: 12.9&deg;C &plusmn; 4.4 (8.5 to 17.3), 2006: 13&deg;C &plusmn; 4.9 (8.1 to 18) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Cricotopus tremulus-Gr. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '103 122', NULL, 5, 1.39, 0, NULL, NULL, 1, NULL, 0.21, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.1, NULL, 1, 1.6, NULL, 1, NULL, 5, NULL, NULL, 0, NULL, 3, 1, 0, 0, 'dark', 1, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'small; does not reaching base of first inner tooth', NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, 2, 1, NULL, '3 long scales', NULL, NULL, NULL, NULL, 1, 6, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(358, 645, 46, NULL, 0, NULL, '103 122', NULL, 5, 2.017, 0, NULL, NULL, 1, NULL, 0.171, NULL, 1, NULL, 0.857, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.454, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 0.783, NULL, 1, 1.643, NULL, 1, NULL, 4.5, 0.5, NULL, 0, NULL, 3, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'does not reach the base of first inner tooth', NULL, NULL, NULL, NULL, 1.6, NULL, 1, NULL, 1, NULL, NULL, 3.0, NULL, NULL, 1, 0, '2 and one basal tooth', NULL, NULL, NULL, NULL, NULL, NULL, 6, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(359, 646, 20, NULL, 0, 'on the leaves of submerged macrophytes Potamogeton pectinatus of an impoundment area of the river Danube (Altenwörth, km 1994.1)', '103 122', NULL, 5, 1.09, 0, NULL, 0.09, 5, NULL, 0.568, NULL, 1, NULL, 0.753, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.254, 0.127, 0, 'n not given', 'yellow', NULL, NULL, NULL, 1, NULL, 6, '5-6 teeth', NULL, 1.195, NULL, 1, 1.111, NULL, 2, NULL, NULL, NULL, NULL, 0, NULL, 3, 1, 0, 0, '1st > 3+2 iiner teeth', 0.5, NULL, NULL, NULL, NULL, NULL, 0, NULL, 1, 'reaches nearly base of 1st inner tooth', NULL, NULL, NULL, NULL, 1, NULL, 1, NULL, 1, NULL, 'remaining S-setae simple', 1.0, NULL, NULL, NULL, 0, '1 apical and smooth basal tooth', NULL, NULL, NULL, 'setal tufts >200µm', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(360, 647, 20, 'as C.cf.albiforceps', 0, NULL, '', '1|2006-11-24 18:59:45', 5, 1.532, 0, NULL, 0.09, 19, NULL, 0, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.275, 0.086, 19, NULL, 'yellow', NULL, 'pale', NULL, 1, NULL, 6, '1st pair of lateral teeth paler than remainig teeth', NULL, 2, NULL, 1, 4, NULL, 1, '>', 6, NULL, NULL, 0, NULL, 3, 1, 0, 0, 'apical longer', 1, 1.095, NULL, NULL, 1, 'crenulated at outer edge', 1, '6 branches', 1, 'yes', NULL, '7', 'yes', '6', 1.9, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'I-VI with setal tufts <== 80µm', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(361, 648, 21, NULL, 0, NULL, '', '1|2006-11-24 22:01:23', 5, 0.491, 0, NULL, NULL, 1, 'from Makarchenko 1999, not longer than wide Cranston et.al. 1983', 0, NULL, 1, 'from Makarchenko 1999', 0.65, NULL, 1, 'from Makarchenko 1999', 'on 2nd small', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, 1, NULL, 6, '2nd teeth distincly smaller than 1st and 3rd lateral teeth', NULL, 2.28, NULL, 1, NULL, NULL, NULL, '>', 3.5, NULL, 'at 3rd to 4th', 0, NULL, 3.5, 1, 0, 0, NULL, 0, 0.833, NULL, NULL, 1, 'curved mandible', 0, '', 1, '?no', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'conical scale', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(362, 649, 46, NULL, 0, NULL, '103 122', NULL, 5, 1.54, 0, NULL, NULL, 1, NULL, 0.2, NULL, 1, NULL, 0.89, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.27, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.58, NULL, 1, 1.78, NULL, 1, NULL, 5.5, 0.5, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '4 branches', 1, 'is small reaches not the base of 1st-lat tooth', NULL, NULL, NULL, NULL, 1.7, 'inner shorter', 1, NULL, 1, NULL, NULL, 4.0, 2, 4, 3, 0, NULL, '3 round scales', NULL, NULL, '~10', NULL, 1, 5, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(363, 650, 24, NULL, 0, NULL, '103 122', NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'is broken', 6, '1st lateral nearly fused with middle', NULL, 1.4, 0.1, 1, 1.55, 0.1, 1, NULL, 3.5, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(364, 651, 21, NULL, 0, NULL, '103 122', NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2, NULL, 1, 5.36, NULL, 1, NULL, 4.5, 0.5, NULL, 0, NULL, 3, 1, 2, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '8 branches', 1, 'reaches ~base of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'very small tuff lateral ~4 setae (Makarchenko 1999)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(365, 652, 39, NULL, 0, NULL, '103 122', NULL, 5, 1.53, 0, NULL, NULL, 1, NULL, 0.168, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 5, 'lightly fused: 1st+2nd', NULL, 0.854, NULL, 1, 2, NULL, 1, NULL, NULL, NULL, NULL, 0, NULL, 2, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '7 branches', 1, 'does not reach base of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(366, 654, NULL, NULL, 0, NULL, '56 15 113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(367, 655, NULL, NULL, 0, NULL, '56 15 113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(368, 656, NULL, NULL, 0, NULL, '56 15 113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(369, 657, NULL, NULL, 0, 'Limnophyes globifer see {citeID|353|Cranston 1979}.\r\n', '56 15 113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(370, 658, NULL, NULL, 0, NULL, '44 223 154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(371, 659, NULL, 'holarctic', 0, '{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|Reference\r\n!|Taxon\r\n!|Notes\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|481|Buskens and Moller-Pillot 1992}\r\n|Orthocladius (Pogonocladius) consobrinus\r\n|a well known orthoclad living in lakes, has proved to tolerate hypertrophic water. Very likely it seems to need a stable oxygen regime more than oligo- or mesotrophic water.\r\n\r\n|}\r\n\r\n\r\n{citeID|498|Gardarsson et al. 2004}: The dominant midge of Lake M&yacute;vatn [northern Iceland], Tanytarsus gracilentus showed 3 cyclic oscillations during the 20-year period. The fluctuations were tracked by Micropsectra lindrothi, Procladius islandicus, Orthocladius consobrinus, Psectrocladius barbimanus and Chironomus islandicus.\r\n\r\n==Temperature==\r\n\r\n{citeID|526|Hofmann 2001} reports as cold-stenothermal taxa Heterotrissocladius sp., Paracladius sp., Orthocladius consobrinus, and Corynocera oliveri.', '31 122', NULL, 5, 2.54, 0, NULL, NULL, 1, NULL, 0.13, NULL, 1, NULL, 0.76, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, 'fused 1st to 2nd', NULL, 1.78, NULL, 1, 1.55, NULL, 1, NULL, 3.5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, 'does not reach basis of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, 'inner shorter', 1, NULL, 1, NULL, NULL, 2.0, NULL, NULL, NULL, NULL, '2 apical', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(372, 660, 3, NULL, 0, NULL, '31 122', NULL, 5, 1.56, 0, NULL, NULL, 1, '1.715 (+-0.215, n=10) Soponis 1977', 0.156, NULL, 1, NULL, 0.64, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'yellow', NULL, NULL, NULL, 1, 'middle+1st laterals brighter', 6, NULL, NULL, 1.48, NULL, 1, 1.241, NULL, 1, NULL, NULL, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '7 setae', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.9, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 6, NULL, 2, NULL, NULL, 'yellow', NULL, NULL, NULL, NULL),
(373, 661, 3, NULL, 0, NULL, '31 122', NULL, 5, 1.39, 0, NULL, NULL, 1, '1.78-2.24 (n=8)', 0.21, NULL, 1, NULL, 0.85, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.45, NULL, 1, 1.69, NULL, 1, NULL, 3, NULL, NULL, 0, 'very long plates', 4, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '7 seate', 1, 'small don''t reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, NULL, 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, 2, 0, '1 apical incised', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(374, 662, 20, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Orthocaldius (Euorthocladius) rivicola. Denoted in the article as ''''''Euorthocladius rivicola''''''.\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Orthocaldius (Euorthocladius) rivicola. Denoted in the article as ''''''Euorthocladius rivicola''''''.\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Orthocaldius (Euorthocladius) rivicola. Denoted in the article as ''''''Euorthocladius rivicola''''''.\r\n', '31 122', NULL, 5, 1.518, 0, NULL, 0.171, 11, NULL, 0.24, NULL, 1, 'RO ratio (lower): 0.24 RO ratio (upper): 0.37', 0.81, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.304, 0.202, 10, NULL, 'yellow to brown', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 2.087, NULL, 1, 1.35, 0.2, 11, NULL, 4, NULL, NULL, 0, NULL, 3, 1, 0, 0, '2 fovea at outer margin', 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, ' 1 apical 1 basal tooth', '3 broad scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(375, 663, 20, NULL, 0, NULL, '31 122', NULL, 5, 1.29, 0, NULL, NULL, 1, NULL, 0.24, NULL, 1, NULL, 0.75, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.6, NULL, 1, 1.7, NULL, 1, NULL, 3.1, 0.1, 'additional fovea close to s.submenti', 0, NULL, 3, 1, 0, 0, 'only 1 fovea outer margin drawn', 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, NULL, '1 apical 1 broad bulge basal', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(376, 664, 20, NULL, 0, 'occored in higher densities in the upper rhitral of alpine gravel brooks', '31 122', NULL, 5, 1.138, 0, NULL, 0.059, 12, NULL, 0.17, NULL, 1, NULL, 1.05, 0.05, 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.339, 0.14, 9, NULL, 'orange brown', NULL, 'orange brown slightly darker', NULL, 1, NULL, 6, NULL, NULL, 2.55, NULL, 1, 2.875, 0.125, 9, NULL, 6, NULL, 'additional fovea near to s.submenti', 0, NULL, 3, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches base of 2nd inner tooth', NULL, NULL, NULL, NULL, 1.6, 'inner shorter', NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(377, 665, 20, NULL, 0, NULL, '31 122', NULL, 5, 1.74, 0, NULL, 0.192, 5, NULL, 0.22, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.471, 0.035, 9, NULL, 'dark-brown', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 1.42, NULL, 1, 1.17, 0.17, 5, NULL, 5, NULL, NULL, 0, NULL, 4, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches base on 3rd inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, NULL, '3 broad scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(378, 666, 3, 'AR: 1.33\nRO ratio: 0.23\nblade ratio: 0.83\n', 0, NULL, '31 122', NULL, 5, 1.33, 0, NULL, NULL, 1, NULL, 0.23, NULL, 1, NULL, 0.83, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.33, NULL, 1, 1.8, NULL, 1, NULL, 4.7, 0.2, '4.5-5', 0, NULL, 4, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '7 setae', 1, 'reaches the base of 2nd inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(379, 667, 3, NULL, 0, NULL, '31 122', NULL, 5, 1.61, 0, NULL, NULL, 1, '1.83 Soponis 1977', 0.09, NULL, 1, NULL, 0.87, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.35, NULL, 1, 3.2, NULL, 1, NULL, 3.5, 0.5, '3-4', 0, NULL, 3.5, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '7 setae', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.9, 'outer slightly shorter', 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(380, 668, 41, NULL, 0, NULL, '31 122', NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 9, NULL, NULL, 2.48, NULL, 1, 3.63, NULL, 1, NULL, NULL, NULL, NULL, 0, NULL, 4, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '10 branches', 1, 'reaches base of 2nd inner tooth', NULL, NULL, NULL, NULL, 1.7, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(381, 669, 3, 'different shapes of mentum, holarctic, with O.dentifer, O.obumbratus, O.smolandicus Soponis1977', 0, 'rivers lakes', '31 122', NULL, 5, 1.59, 0, NULL, NULL, 1, '2.335 (+-0.375 n=10) Soponis 1977', 0.12, NULL, 1, NULL, 0.73, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'yellow', NULL, NULL, NULL, 1, NULL, 6, 'fused 1st to middle', NULL, 1.05, 0.1, 1, 2.6, NULL, 1, NULL, 4.5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, 'little spine at seta subdentalis', 1, NULL, NULL, NULL, NULL, NULL, 1, '8 setae', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 1, '1 apical 1 basal', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.7, 3.6, 3.0, 4);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(382, 670, 20, NULL, 0, NULL, '31 122', NULL, 5, 1.49, 0, NULL, 0.024, 6, NULL, 0.16, NULL, 1, NULL, 0.94, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.259, 0.156, 11, '1.794+-0.046 n=11 ?printing error ->headindex(1.794,0.049)=0.557 +- 0.03', 'yelow', NULL, 'darkened', NULL, 1, NULL, 6, NULL, NULL, 2.78, NULL, 1, 3.25, 0.2, 10, NULL, 6.2, 0.2, NULL, 0, NULL, 4, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches 2 inner tooth', NULL, NULL, NULL, NULL, 1.7, 'inner shorter', NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(383, 671, 20, NULL, 0, 'occurred in the rip-rap zone of the river Danube (km 1994-2007) and the river Yabbs (km 10.1', '31 122', NULL, 5, 1.999, 0, NULL, 0.069, 5, NULL, 0.17, NULL, 1, NULL, 0.9, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.172, 0.132, 9, NULL, 'whitish-greyish', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 3.58, NULL, 1, 3.625, 0.175, 9, NULL, 5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, 'apical tooth longer than 3rd inner tooth', 0, NULL, NULL, NULL, NULL, NULL, 1, '5-6 branches', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(384, 672, 3, 'AR: 1.37\nRO ratio: 0.23\nblade ratio: 0.91', 0, NULL, '31 122', NULL, 5, 1.37, 0, NULL, NULL, 1, '1.435 (+-0.125, n=2) Soponis 1977', 0.262, NULL, 1, NULL, 0.91, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, 1.42, NULL, 1, 2.13, NULL, 1, NULL, 3.5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '?8 setae', 1, 'extend to base of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(385, 673, 20, NULL, 0, 'middle TR: 2.48\nmiddle to 1st-lat TR: 3.04\nbase of ventromental plates extended proximally', '31 122', NULL, 5, 1.675, 0, NULL, 0.061, 5, NULL, 0.22, NULL, 1, NULL, 0.775, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.323, 0.102, 8, NULL, 'yellow', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 2.48, NULL, 1, 2.6, 0.15, 5, NULL, 3.5, NULL, NULL, 0, 'base extended proximally', 4, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches middle of 2nd inner tooth, crenate at basis', NULL, NULL, NULL, NULL, 1.8, 'inner shorter', NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, '1 apical 1 basal tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(386, 674, 20, NULL, 0, NULL, '31 122', NULL, 5, 1.32, 0, NULL, 0.089, 5, NULL, 0.11, NULL, 1, NULL, 0.92, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.193, 0.046, 9, NULL, 'brown', NULL, 'brown', NULL, 1, NULL, 6, NULL, NULL, 2.11, NULL, 1, 1.65, NULL, 1, NULL, 4, NULL, 'additional small setal fovea', 0, NULL, 4.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '5 apically serrated branches', 1, 'basis crenate several toothlets', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, NULL, '3 broad scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(387, 675, 20, NULL, 0, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Orthocaldius (Euorthocladius) thienemanni. Denoted in the article as ''''''Euorthocladius thienemanni''''''.\r\n', '31 122', NULL, 5, 1.725, 0, NULL, 0.192, 10, NULL, 0.32, NULL, 1, NULL, 0.88, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.25, 0.113, 10, NULL, 'yellow to light-brown', NULL, 'darkened', NULL, 1, NULL, 6, NULL, NULL, 2, 0.35, 1, 1.75, 0.35, 10, NULL, 4.5, 0.5, 'addition foveal setae', 0, 'elongated proximally', 3.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches and longer unbrunched part', 1, 'reaches base of first inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, '1 apical 1 broad basal tooth', '3 broad scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(388, 676, 3, NULL, 0, NULL, '31 122', NULL, 5, 2.07, 0, NULL, NULL, 1, '2.24-2.25 (n=2) Soponis 1977', 0.12, NULL, 1, NULL, 0.92, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2nd instar', 6, NULL, NULL, 2.06, NULL, 1, 1.73, NULL, 1, NULL, 4.5, 0.5, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '7 setae', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, 1, NULL, NULL, 3.0, NULL, NULL, 1, 0, '2 apical (incised) 1 broad basal', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(389, 677, 3, NULL, 0, NULL, '31 122', NULL, 5, 2, 0, NULL, NULL, 1, '2.43-2.88 n=10 Soponis 1977', 0.07, NULL, 1, NULL, 0.64, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'yellow', NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.47, NULL, 1, 1.59, NULL, 1, NULL, 3.5, 0.5, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '6 seate', 1, 'reaches basis of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, 1, NULL, NULL, 3.0, NULL, NULL, 1, NULL, NULL, '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'green', NULL, NULL, NULL, NULL),
(390, 678, 20, NULL, 0, NULL, '31 122', NULL, 5, 1.724, 0, NULL, 0.137, 7, NULL, 0.15, NULL, 1, NULL, 0.8, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.221, 0.048, 6, NULL, 'yellow to greyish', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 2.7, NULL, 1, 3.655, NULL, 1, NULL, 5, NULL, NULL, 0, 'base elongated', 3.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches the base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(391, 679, 30, NULL, 0, NULL, '31 122', NULL, 5, 2.41, 0, NULL, NULL, 1, NULL, 0.14, NULL, 1, NULL, 0.93, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.23, NULL, 1, NULL, 'brown', NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.83, NULL, 1, 1.15, 0.15, 3, NULL, 4.5, NULL, NULL, 0, NULL, 3, 1, 0, 0, '1 fovea at outer margin', 1, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'does not reach base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'yellow to brown', NULL, NULL, NULL, NULL),
(392, 680, 3, NULL, 0, NULL, '31 122', NULL, 5, 1.43, 0, NULL, NULL, 1, '1.37-1.79 (n=3) Soponis 1977', 0.16, NULL, 1, NULL, 0.82, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.65, NULL, 1, 2.84, NULL, 1, NULL, 4.5, 0.5, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '? 7 setae', 1, 'reaches middle of first inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, 0, 0, 3, 0, 'from text', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(393, 681, 30, NULL, 0, NULL, '31 122', NULL, 5, 2.18, 0, NULL, NULL, 1, NULL, 0.077, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 7, NULL, NULL, 1.767, 0.681, 4, 1.654, 0.2, 8, NULL, NULL, NULL, 'not drawn', 0, NULL, 3.5, 1, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 0, 'not drawn', 1, 'dont reaches base of 1st 0.5 inner tooth', NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, 1, NULL, NULL, 3.0, NULL, NULL, 2, NULL, '2 apical 1 roundbasal', '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(394, 682, 20, 'From {citeID|6|Epler 2001}: &laquo;O. (O.) frigidus - This species and O. vaillanti are the only Orthocladius species in the SE US that lack a seta interna on the mandible. Orthocladius (Eou.) roussellae Soponis, known only from Alaska, Wyoming, the Yukon and Northwest Territories, also lacks a seta interna; O. roussellae has 15 teeth on the mentum. Orthocladius frigidus had been placed in the subgenus Euorthocladius, but Soponis (1987) redescribed the species and placed it in O. (Orthocladius). Orthocladius frigidus larvae are difficult to separate from those of O. vaillanti; it appears the only separating character is the rugose outer margin of the mandible of frigidus (which is smooth in vaillanti). Soponis (1990: fig. 13) shows the S I of frigidus as being unevenly bifid; Schmid (1993: fig. 87D) illustrates them as evenly bifid. The S I of vaillanti are evenly bifid. Both species have a similar mentum, although that of frigidus may be more convex; more material is needed. As with so many species of Orthocladius, associated pupae are needed for accurate identification. [C/O sp. 2, some C/O sp. 60]&raquo;', 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Orthocladius frigidus in Alpine running waters of 27.61&micro;S &middot; cm⁻&sup1; &plusmn;~45.98 (min-max: 4-425, n=238).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Orthocladius frigidus in Alpine running waters of 4.35&deg;C &plusmn;~1.98 (min-max: -0.1-21, n=292).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Orthocladius frigidus in Alpine running waters of 6.43 &plusmn;~0.7 (min-max: 4.5-9.9, n=226).\r\n', '31 122', NULL, 5, 1.599, 0, NULL, 0.073, 10, NULL, 0.19, NULL, 1, NULL, 0.97, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.29, 0.038, 12, NULL, 'yellow L4 dark brown L3+2', NULL, 'darkened', NULL, 1, NULL, 6, NULL, NULL, 2, NULL, 1, 1.56, NULL, 1, NULL, 5.5, NULL, 'additional fovea lateral to setae', 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 0, NULL, 1, 'small don''t reaches the base of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 0, '1 apical and 1 broad basal tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(395, 683, 20, NULL, 0, 'mainly found in riffle zones with hight velocity, in sediment depth 0-40cm and branches of Hydrurus foetidus at the sediment surface, depending on instar level\nSeebach, Erlauf, Salzbach, Alpine Rhine', '31 122', NULL, 5, 1.897, 0, NULL, 0.047, 5, NULL, 0.211, NULL, 1, NULL, 0.9, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.353, 0.173, 5, NULL, 'light brown to greyish', NULL, 'darkened', NULL, 1, NULL, 8, '8-10', NULL, 2, NULL, 1, 4.8, NULL, 1, NULL, 1, NULL, NULL, 0, NULL, 4, 1, 0, 0, '2nd inner bigger', 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches the middle of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, NULL, 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, '3 slender scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(396, 684, 3, NULL, 0, NULL, '31 122', NULL, 5, 1.78, 0, NULL, NULL, 1, NULL, 0.16, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 3.125, NULL, 1, 4.45, NULL, 1, NULL, NULL, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '7 setaea', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.7, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, '1 apical 1 small basal', '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(397, 685, 20, NULL, 0, NULL, '31 122', NULL, 5, 1.742, 0, NULL, 0.148, 8, NULL, 0.17, NULL, 1, NULL, 0.82, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.249, 0.099, 8, NULL, 'yellow to brown', NULL, 'darkened', NULL, 1, NULL, 6, NULL, NULL, 1.6, NULL, 1, 1.5, NULL, 1, NULL, 4, NULL, 'additional fovea next to s submenti', 0, NULL, 3, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches middle of 1st inner tooth', NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 0, '1 and 1 broad basal tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(398, 686, 30, NULL, 0, NULL, '31 122', NULL, 5, 1.67, 0, NULL, NULL, 1, NULL, 0.27, NULL, 1, NULL, 1.22, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, 2, NULL, 1, 1.17, NULL, 1, NULL, NULL, NULL, 'not drawn', 0, NULL, 3.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(399, 687, 40, 'Fauna Europaea O.mixtus ->  Orthocladius (Eudactylocladius) priomixtus Sæther 2004\nITIS: O.mixtus -> Orthocladius decoratus (Holmgren, 1869)', 0, NULL, '31 122', NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'lower than lateral tooth', 6, NULL, NULL, 6.5, NULL, 1, 2, NULL, 1, NULL, 4, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches base of 1st inner tooth (after 0.5)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(400, 688, 3, NULL, 0, NULL, '31 122', NULL, 5, 1.8, 0, NULL, NULL, 1, '1.71-2.52 (n=11)', 0.16, NULL, 1, NULL, 0.74, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'middle 3 teeth more lightly', 6, NULL, NULL, 2.04, NULL, 1, 3.32, NULL, 1, NULL, 4, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0.2, NULL, NULL, NULL, NULL, NULL, 1, '7 branches', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, NULL, 1, NULL, 1, NULL, NULL, 2.0, NULL, NULL, NULL, 0, '1 incised apical 1 hooked basal tooth', '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(401, 672, 21, NULL, 0, NULL, '31 122', NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.42, NULL, 1, 3.25, NULL, 1, NULL, 5, NULL, NULL, 0, NULL, NULL, 0, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(402, 690, 3, 'holarctic', 0, 'Template:Reference:Error found with O.carlatus, dentifer, dorenus mallochi, nigritus. obumbratus, oliveri, robacki, and troyni. The Larvae wer collected in small, bog-fed stream in a deciduous forest near Almonte. The larvae build tubes.\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*8 have statistically significant (sigmoidal Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n', '31 122', NULL, 5, 1.93, 0, NULL, NULL, 1, '2.485 +-0.305 n=10 (Soponis 1977)', 0.2, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'yellow', NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.956, NULL, 1, 3.045, NULL, 1, NULL, 4, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '7 setae', 1, NULL, NULL, NULL, NULL, NULL, 1.9, NULL, NULL, NULL, NULL, NULL, NULL, 2.5, NULL, NULL, NULL, 0, '1 apical incised 1 basal', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'green', NULL, NULL, NULL, NULL),
(403, 691, 3, NULL, 0, NULL, '31 122', NULL, 5, 1.84, 0, NULL, NULL, 1, '1.930 (+-0.3, n=10)\n', 0.16, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.29, NULL, 1, 2.152, NULL, 1, NULL, 4.5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, '7 setae', 1, NULL, NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, NULL, NULL, NULL, '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(404, 692, 3, NULL, 0, NULL, '31 122', NULL, 5, 2.07, 0, NULL, NULL, 1, NULL, 0.14, NULL, 1, NULL, 0.74, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'niddle to 2nd laterals brighter', 6, NULL, NULL, 2.12, NULL, 1, 2.73, NULL, 1, NULL, 4, NULL, NULL, 0, 'very long plates', 3, 1, 0, 0, 'at outer margin fovea at 1st inner tooth', 1, NULL, NULL, NULL, NULL, NULL, 1, '7 setae', 1, 'reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, 1.8, 'inner shorter', 1, NULL, 1, NULL, NULL, 2.0, NULL, NULL, 2, 0, 'distorted', '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(405, 693, 308, NULL, 0, NULL, '31 122', NULL, 5, 1.53, 0, NULL, 0.11, 2, NULL, 0.27, NULL, 1, NULL, 0.85, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, 'fused 1st to 2nd', NULL, 3.37, NULL, 1, 4.769, NULL, 1, NULL, 6, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '?8 setae', 1, 'reach base of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(406, 694, 30, NULL, 0, NULL, '31 122', NULL, 5, 1.55, 0, NULL, NULL, 1, NULL, 0.23, NULL, 1, NULL, 0.7, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'to 1st latarals: widely separated ', 6, 'to middle: widely separated ', NULL, 1.85, NULL, 1, 1.58, NULL, 1, NULL, NULL, NULL, NULL, 0, NULL, 4, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches base of 2nd inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(407, 699, NULL, NULL, 0, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Cladotanytarsus mancus &ndash; group  and other taxa: 5.3m &plusmn; 3.2 (n=25). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Cladotanytarsus mancus gr.1  and other taxa: 14.7&gt; &deg;C, n=27 (sigmoidal increasing Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\nCladotanytarsus mancus reported by {citeID|516|Korhola et al. 2002} as intermediate taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cladotanytarsus cf.mancus (n=21, Template:explained:N2:HillsDiversity=16.44, n&lt;sub&gt;max&lt;/sub&gt;=7.06) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 2.\r\n\r\n==Conductivity==\r\n\r\n{citeID|502|Zhang et al. 2007} report for Cladotanytarsus mancus-type in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 695.03mg &middot; l⁻&sup1; (&divide; 600 = 1.16mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 1.1155. In article shortened as: Cm.\r\n', '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(408, 700, NULL, NULL, 0, NULL, '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(409, 701, NULL, NULL, 0, NULL, '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(410, 702, NULL, NULL, 0, '==Oxygen==\r\n\r\nNote: possibly placed right here at Cladotanytarsus sp. 1a: {citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cladotanytarsus sp. grp. A (n=7, Template:explained:N2:HillsDiversity=5.72, n&lt;sub&gt;max&lt;/sub&gt;=3.77) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 3.\r\n', '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(411, 703, NULL, NULL, 0, NULL, '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(412, 704, NULL, NULL, 0, NULL, '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(413, 705, NULL, NULL, 0, NULL, '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(414, 706, NULL, NULL, 0, NULL, '170 88', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(415, 710, NULL, NULL, 0, NULL, '101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(416, 711, NULL, NULL, 0, NULL, '101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(417, 712, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Paratendipes nudisquama in Alpine running waters of 151.68&micro;S &middot; cm⁻&sup1; &plusmn;~110.29 (min-max: 11-425, n=19).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Paratendipes nudisquama in Alpine running waters of 3.83&deg;C &plusmn;~2.84 (min-max: 0.01-10, n=35).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Paratendipes nudisquama in Alpine running waters of 8.4 &plusmn;~0.71 (min-max: 6.8-9.9, n=20).\r\n', '101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(418, 717, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Endochironomus impar type, Chironomus plumosus type, Nanocladius rectinervis type, Endochironomus albipennis type , Glyptotendipes pallens type[most abundant in &gt;16&deg;C], Einfeldia pagana type and Microchironomus tener type had the highest temperature optima.&raquo;\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Glyptotendipes pallens (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(419, 1625, NULL, NULL, 0, NULL, '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(420, 719, NULL, NULL, 0, NULL, '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(421, 720, NULL, NULL, 0, NULL, '20 43', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(422, 722, NULL, NULL, 0, NULL, '170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(423, 723, NULL, NULL, 0, NULL, '170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(424, 724, NULL, NULL, 0, NULL, '170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(425, 727, NULL, NULL, 0, NULL, '119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(426, 728, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(427, 729, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(428, 1571, 6, '==History==\r\n\r\n*from {citeID|20|Schmid 1993} added 2008-03-30 20:53:06 described as M.obscuripes Holmgren 1869 (invalid http://www.faunaeur.org/full_results.php?id=283993)\r\n*from {citeID|21|Cranston et al. 1983} added 2008-03-30 20:54:22 described as M.hygropetricus Kieffer 1912 (invalid see [[http://www.faunaeur.org/full_results.php?id=283993]])', 0, '==Biotops==\r\n\r\n===Conductivity===\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Metriocnemus hygropetricus [mentioned as Metriocnemus hygropetricus] in Alpine running waters of 92.96&micro;S &middot; cm⁻&sup1; &plusmn;~107.9 (min-max: 11-395, n=20).\r\n\r\n===Temperature===\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Metriocnemus hygropetricus [mentioned as Metriocnemus hygropetricus] in Alpine running waters of 5.73&deg;C &plusmn;~1.93 (min-max: 0.3-10, n=32).\r\n\r\n===pH value===\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Metriocnemus hygropetricus [mentioned as Metriocnemus hygropetricus] in Alpine running waters of 7.45 &plusmn;~1.25 (min-max: 6.26-9.9, n=18).\r\n', '19 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(429, 731, NULL, NULL, 0, NULL, '19 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(431, 733, NULL, NULL, 0, NULL, '19 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(432, 734, 20, NULL, 0, NULL, '19 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(434, 1638, NULL, NULL, 0, NULL, '19 177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(435, 737, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(436, 738, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(437, 739, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(438, 740, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(439, 741, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(440, 742, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(441, 743, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(442, 744, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(443, 745, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(444, 746, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(445, 747, NULL, NULL, 0, NULL, '184 191 100 19 135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(446, 748, NULL, NULL, 0, NULL, '135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(447, 751, NULL, NULL, 0, NULL, '178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(448, 752, NULL, NULL, 0, NULL, '178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(450, 754, NULL, NULL, 0, NULL, '178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(451, 755, NULL, NULL, 0, NULL, '178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(452, 756, NULL, NULL, 0, '==Biotops==\r\n\r\n{textciteID|565|Bitu&scaron;&iacute;k et al. 2006}: &laquo;Absence of P. nivosa, presence of Micropsectra radialis, and also Tanytarsus bathophilus, Zavrelimyia sp., Paratanytarsus austriacus, Corynoneura arctica/scutellata separated group B of seven alpine lakes.&raquo;\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with II: 8.05&ndash;8.65.\r\n\r\n===Temperature===\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Corynoneura scutellata  and other taxa: 7.0&lt; &deg;C, n=12 (sigmoidal decreasing Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft)   . Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{textciteID|535|Birks et al. 2000}: &laquo;[..] warmwater chironomids such as Cricotopus, Paracladius, Tanytarsus sp. B, and Corynoneura scutellata agg. [..]&raquo;; {textciteID|511|Brooks 2006}: &laquo;thermophilic taxon&raquo;\r\n\r\n===Salinity===\r\n\r\nAbundance classes after {textciteID|566|Moller-Pillot and Buskens 1990} are: 0-lacking, 1-rarely occouring, 2-occaisionally occouring, 4-very frequently occouring\r\n{| style=''border:1px solid;'' \r\n\r\n&lt;thead&gt;\r\n|-\r\n!im90 |oligohalin (500-3000mg/l)\r\n!im90 |mesohalin (3000-10,000mg/l)\r\n!im90 |polysalin (&gt;10,000mg/l)\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|2&lt;!-- oligohalin --&gt;\r\n|0&lt;!-- mesohalin --&gt;\r\n|0&lt;!-- polysalin --&gt;\r\n\r\n&lt;/tbody&gt;\r\n\r\n|}\r\n', '178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(453, 757, NULL, NULL, 0, NULL, '178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(454, 1, NULL, '', 1, 'Abiskomyia and Oliveridia are also characteristic taxa of arctic lakes ({citeID|21|Cranston et.al. 1983})\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Abiskomyia sp.  and other taxa: 23.2m &plusmn; 7 (n=3). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Abiskomyia  and other taxa: 1.7&deg;C &plusmn; 2.5, n=8. Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|520|Porinchu and Cwynar 2002} reports cold-water chironomid taxa, such as Paracladius, Hydrobaenus/Oliveridia, Abiskomyia, and Parakiefferiella nigra from a tundra site near the lower Lena River, Northeast Siberia.', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(455, 2, NULL, '==Characteristics==\r\n\r\nCited from {citeID|15|Rieradevall and Brooks 2001}: This is a very characteristic genus, easily distinguishable in modern material from the pair of dark claws on the posterior parapods and the basal segment of the maxillary palp which is divided into 2&ndash;6 segments. According to {citeID|297|Laville 1971} A. monilis has the posterior part of the basal segment (basal of the ring organ) divided into two, while A. longistyla has four sections, and it is not divided in A. phatta.\r\n\r\n\r\n==Checklist China==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*A.monilis ({citeID|258|Linn&amp;amp;eacute; 1758}) male {overlib|head setation|<img src=''image.php?text=Image reduced version. Deleted: Abla_moni_hes_Rie2001_r.png 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Abla_moni_hes_Rie2001_r.png 2009-12-15 10:36:17''>}\r\n*A.longistyla {citeID|251|Fittkau 1962} {overlib|head setation|<img src=''image.php?text=Image reduced version. Deleted: Abla_lost_hes_Rie2001_r.png 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Abla_lost_hes_Rie2001_r.png 2009-12-15 10:36:17''>}\r\n*A.phatta ({citeID|259|Egger 1863}) {overlib|head setation|<img src=''image.php?text=Image reduced version. Deleted: Abla_phat_hes_Rie2001_r.png 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Abla_phat_hes_Rie2001_r.png 2009-12-15 10:36:17''>}\r\n*A.sp male', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Ablabesmyia as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n\r\n===Temperature===\r\n\r\n{citeID|492|Brodersen et al. 2004}: Warm-water chironomid assemblages characterized by taxa such as Chironomus, Dicrotendipes, Ablabesmyia, and Procladius had a high oxy-regulatory capacity.\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*11 with significant symmetric unimodal Template:HOF:unimodal: Ablabesmyia (groups 10-12&deg;C &amp; &gt;12&deg;C)\r\n\r\n===Conductivity===\r\n\r\n{citeID|502|Zhang et al. 2007} report for Ablabesmyia in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 3819.85mg &middot; l⁻&sup1; (&divide; 600 = 6.37mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 5.93833. In article shortened as: Ab.\r\n', '216 92', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(456, 3, NULL, '', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(457, 6, NULL, '', 1, '==Biotops==\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Anatopynia sens . lat . the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(458, 8, NULL, '{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|specimen\r\n!im90|head ratio - l:w\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Conchapelopia melanops (Wiedemann)\r\n|1.667\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Arctopelopia sp.\r\n|1.429\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Thienemannimyia sp.\r\n|1.429-1.538\r\n\r\n|}\r\n\r\nNot mentioned for China ({citeID|279|Wang 2000}).', 1, '==Biotops==\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Arctopelopia barbitarsis (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || ||&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*11 with significant symmetric unimodal Template:HOF:unimodal: Arctopelopia (groups &lang;8-10&deg;C&rang; &amp; 10-12&deg;C &amp; &gt;12&deg;C)\r\n\r\n', '26 179 148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(459, 9, NULL, '{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n|-\r\n|Pseudodiamesa nivosa Goetgh. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Pseudodiamesa arctica (Mall.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Oliveria tricornis (Ol.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Lauterbornia sedna (Ol.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Paracladius quadrinodosus Hirv. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus caudatus (Edw.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n\r\n|-\r\n|Heterotrissocladius subpilosus (Kieff.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius oliveri S&aelig;th. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Monodiamesa ekmani Brund. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus saetheri Wied. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Tanytarsus palmeni Lind. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|*****\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Lauterbornia coracina Kieff. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;\r\n|&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Paracladius alpicola (Zett.) &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Monodiamesa alpicola Brund. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus forcipatus Egg. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Micropsectra groenlandica And. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius maeaeri Brund. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus hamiltoni S&aelig;th. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Micropsectra lindebergi S&auml;w. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Tanytarsus lugens Kieff. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius sp. A near subpilosus &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius sp. B near maeaeri &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus ramosus S&aelig;th. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Micropsectra contracta Reiss &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Micropsectra insignilobus Kieff. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Paracladopelma galaptera (Town.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Paracladopelma nigritula (Goetgh.) &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Monodiamesa tuberculata S&aelig;th. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Macropelopia fehlmanni (Kieff.) &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|*****\r\n|*****\r\n|*****\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Tanytarsus bathophilus Kieff. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|*****\r\n|*****\r\n|*****\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus morio Zett. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|***** &lt;!-- mesohumic --&gt;\r\n|***** &lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius changi S&aelig;th. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius scutellatus Goetgh. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius sp. D near changi &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus sp. A near morio &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Protanypus sp. B near morio &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Tanytarsus decipiens Lind. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Monodiamesa nitida (Kieff.) &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Heterotrissocladius grimshawi Edw &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt;\r\n|&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Monodiamesa sp. poss. prolilobata S&aelig;th. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Monodiamesa bathyphila (Kieff.) &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt;\r\n|&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Stictochironomus rosenschoeldi (Zett.) &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Sergentia [Phaenopsectra] coracina (Zett.) &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Tanytarsus n. sp. lestagei &ndash; aggl. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Monodiamesa depectinata S&aelig;th. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Chironomus atritibia Mall. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Chironomus anthracinus Zett. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt;\r\n|&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;\r\n|&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Tanytarsus inaequalis Goetgh. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Tanytarsus gregarius Kieff. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|*****\r\n|&middot;&middot;&middot;&middot;&middot;\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Chironomus plumosus f. semireductus &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Cryptotendipes casuarius (Town.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Chironomus decorus Joh. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Cryptotendipes darbyi (Subl.) &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|&lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~~~~~&lt;/u&gt;\r\n|&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;\r\n|\r\n|\r\n|&lt;!-- mesohumic --&gt;\r\n|&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Chironomus plumosus L. &lt;!-- taxon --&gt;\r\n|x &lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|&lt;u&gt;*****&lt;/u&gt;\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Zalutschia zalutschicola Lip. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt;\r\n|&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Chironomus tenuistylus Brund. &lt;!-- taxon --&gt;\r\n|&lt;!-- alpine --&gt;\r\n|x &lt;!-- boreal --&gt;\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|\r\n|***** &lt;!-- mesohumic --&gt;\r\n|***** &lt;!-- polyhumic --&gt;\r\n  &lt;/tbody&gt;\r\n\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Abiskomyia virgo Edw. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Arctopelopia barbitarsis (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || ||&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus (Ca.) tentans Fabr. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus anthracinus Zett. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||***** ||&middot;&middot;&middot;&middot;&middot; || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus decorus (Joh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus plumosus L. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Chironomus plumosus f. semireductus &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cladopelma edwardsi (Krus.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cladopelma viridula (Fabr.)&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&middot;&middot;&middot;&middot;&middot; || || || || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cladotanytarsus near weixionensis &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cladotanytarsus weixionensis Brund. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cricotopus (I.) sylvestris (Fabr.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Cryptotendipes casuarius (Town.)&lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cryptotendipes darbyi (Subl.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || ||***** &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n|-\r\n|Demicryptochironomus vulberatus (Zett.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || ||***** &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n|-\r\n|Dicrotendipes nervosus (Staeg.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Einfeldia dissidens (Walk.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Einfeldia synchrona (Ol.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Endochironomus albipennis (Meig.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ ||~~~~~ &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Endochironomus nigricans (John.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Endochironomus subtendens (Town.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Glyptotendipes (P.) paripes Edw. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Harnischia curtilamellata (Moll.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;&lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot;&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotanyarsus nudalus S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotanytarsus apicalis (Kieff.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||***** ||***** ||***** ||***** ||***** || || || || || || || || ||***** &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotanytarsus perennis S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius hirtapex S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius latilaminus S&aelig;th.&lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius maeaeri Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius marcidus (Walk.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius oliveri S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Heterotrissocladius subpilosus (Kieff.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Hydrobaenus conformis (Holmgr.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Hydrobaenus conformis/abradorensis S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Hydrobaenus fusistylus (Goetgh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Hydrobaenus martini S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Labrundinia longipalpis (Goetgh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || || || || || || || || || || || ||***** &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n|-\r\n|Lauterbornia coracin Kieff &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Lauterbornia sedna Ol. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Mesocricotopus thienemanni (Goetgh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** || || || || || || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra contracta Reiss &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||***** ||***** ||***** || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra groenlandica And. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra insignilobus Kieff. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Micropsectra lindebergi Saw. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||***** ||***** ||***** || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Monodiamesa depectinata S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Monodiamesa ekmani Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Monopelopia tenuicalar (Kieff.)&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) anderseni S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) balticus (Palm.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||***** || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) distinctus (Mall.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) incomptus S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) minimus S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) rectinervis (Kieff.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius bicolor (Zett.)&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Oeklandia borealis Kieff. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Oliveria tricornis (Ol.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Orthocladius (0.) trigonolabis Edw. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Orthocladius (P.) consobrinus Holmgr. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Pagastiella orophila (Edw.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Pagastiella ostansa (Webb) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || ||&lt;u&gt;~~~~~&lt;/u&gt;&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladius alpicola (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladius quadrinodosus Hirv. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladopelma galaptera (Town.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladopelma nais (Town.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladopelma nigritula (Goetgh.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||***** || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladopelma undine (Town.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladopelma winnelli Jacks. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paratanytarsus hyperboreus Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paratanytarsus natvigi (Goetgh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paratanytarsus penicillatus Goetgh. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** || || || || || || || || ||***** &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Phaenopsectra albescens (Town.)&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Polypedilum (Po.) nubeculosum (Meig.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Protanypus morio (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || || || ||***** &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Psectrocladius (A.) platypes Edw. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || || || || || || || || || || || ||&middot;&middot;&middot;** &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n|-\r\n|Psectrocladius (P.) psilopterus Kieff.&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** || || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Psectrocladius (P.) simulans (Joh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Pseudochironomus fulviventris (Joh.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Pseudochironomus pseudoviridis (Mall.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Pseudochironomus rex Haub.&lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Robackia demeijerei (Krus.)&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Saetheria tylus (Town.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Sergentia [Phaenopsectra] coracina (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Stempellina bausei (Kieff.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||***** ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||***** || || || || || || || || || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Stempellina brevis Edw. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Stempellina minor (Edw.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Stempellina n. sp. near almi Brund. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Stictochironomus histrio (Fabr.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || ||&middot;&middot;&middot;&middot;&middot; ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || ||&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Stictochironomus rosenschoeldi (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanypus punctipennis (Meig.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus lugens Kieff. &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus niger And. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Tanytarsus usmaensis Pag. &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Thienemannimyia fusciceps (Edw.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||***** ||***** ||***** ||***** ||***** || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia lingulata S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia mucronata (Brund.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia obsepta (Webb) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia tornetraeskensis (Edw.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia trigonacies S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia zutschicola Lip. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n\r\n  &lt;/tbody&gt;\r\n|}\r\n', 1, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(460, 10, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(461, 11, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(462, 12, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(463, 16, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(464, 18, NULL, NULL, 1, NULL, '46', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(465, 22, NULL, 'Key to groups ({citeID|2|Pinder and Reiss 1983}):\r\n#Tree extreme lateral teeth separeted from reminder by a deep notch, thus forming a separete group ... C.laccophila group&lt;br&gt;- lateral teeth not separeted in this way ... C.lateralis group\r\n\r\nComments ({citeID|2|Pinder and Reiss 1983}): \r\n*Larvae of Cladopelma, Cryptotendipes and Microchironomus differ from other genera of Chironominae, except for some Paracladopelma, in that the outer teeth of the mentum are somewhat enlarged and set forward relative to the slope of the other lateral teeth. \r\n*Cladopelma larvae differ from those of Microchironomus in that the median tooth of the mentum is medially notched or simply rounded, never trifid and from Cryptotendipes in that the central part of teh mentum does not slope mauch more steeply than the lateral regions.&lt;br&gt;\r\nIn China ({citeID|279|Wang 2000}):\r\n*C.edwardsi (Kruseman)\r\n*C.fridmanae (?) (Tshernovskij)\r\n*C.virescens (Meigen)\r\n*C.viridula (Fabricus)\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Cladopelma as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Cladopelma edwardsi (Krus.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n|-\r\n|Cladopelma viridula (Fabr.)&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&middot;&middot;&middot;&middot;&middot; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&middot;&middot;&middot;&middot;&middot; || || || || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n===Depth===\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Cladopelma sp.  and other taxa: 5.4m &plusmn; 2.1 (n=20). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Temperature===\r\n\r\nCladopelma sp. reported by {citeID|516|Korhola et al. 2002} as intermediate taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Cladopelma  and other taxa: 14.7&gt; &deg;C, n=17 (sigmoidal increasing Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n===Oxygen===\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cladopelma (n=22, Template:explained:N2:HillsDiversity=12.53, n&lt;sub&gt;max&lt;/sub&gt;=11.29) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 15.\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Cladopelma [reported as Cryptocladopelma] the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '87', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(466, 24, NULL, '==Chaecklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*C. decempunctatus Tokunaga female\r\n*C. formosae  Kieffer female \r\n*C. immaculatus Kieffer female\r\n*C. pinguis (Loew)\r\n*C. lampronotus Kieffer male\r\n*C. microtrichus Yan and Ye male female\r\n*C. nervosus (Meigen)\r\n*C. sugiyamai Tokunaga male female\r\n*C. sp. male female\r\n\r\nLarval morphology for C.pinguis (Loew) and C. aureus Roback see {citeID|421|Roback 1975b}.', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(467, 25, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(468, 26, NULL, '{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|specimen\r\n!im90|head ratio - l:w\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Conchapelopia melanops (Wiedemann)\r\n|1.667\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Arctopelopia sp.\r\n|1.429\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Paramerina sp.\r\n|1.818-2.0\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Thienemannimyia sp.\r\n|1.429-1.538\r\n\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Rheopelopia sp.\r\n|1.538\r\n\r\n|}\r\n\r\n==Comments==\r\n\r\n{citeID|288|Fittkau and Roback 1983}: Conchapelopia is closely related to Arctopelopia, Thienemannimyia, Rheopelopia, Meropelopia and Helopelopia. The latter 2 genera have also been regarded as subgenera of Conchapelopia. \r\n*in common with Helopelopia and Rheopelopia , Conchapelopia has 3 segment b seta.\r\n*Helopelopia differs from Conchapelopia, amongst other respects, \r\n**in having a broad pseudoradula and \r\n**a differently formed basal tooth on mandible and\r\n**in the arrangement of ventrolateral setae and sensillum minusculum, which are distributed in the basal 1/2 of the mandible\r\n*Rheopelopia is easily distinguishable from Conchapelopia by\r\n**the scarcely recognizable basal mandibular tooth.\r\n\r\n==Rieradevall and Brooks 2001==\r\n\r\n{citeID|15|Rieradevall and Brooks 2001}: &laquo;Other distinctive characters: Head capsule {pale}. The palp b setae is 3 segmented, which distinguishes this genus from Arctopelopia. The ring organ of the maxillary palp is situated in the distal third. The basal tooth of the mandible is short. Material examined: C. melanops: England, associated larvae, n = 2. C. viator: England, associated larvae, n = 1 (BMNH). Conchapelopia sp. (probably C. melanops): Spain, unassociated larvae, n = 4 (MR).&raquo;\r\n\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*C.melanops (Meigen)\r\n*C.viator (Kieffer)', 1, NULL, '217 179 8 148 2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(469, 27, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(470, 28, NULL, '==Comments==\r\n\r\nA.Plank (Mon Mar 16 2009 14:36:06 GMT+0100): Corynocera oliveri''s mandible is exact the same as Tanytarsus gracilentus. Also the mentum looks similar: {overlib|oliveri|<img src=''image.php?text=Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17''>} and {overlib|gracilentus|<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17''>}\r\n\r\n \r\nGodtfred Anker Halvorsen''s comment in a mail: Some systematists belive, I think, that the genus Corynocera are the same as Tanytarsus, but no formal  synonymizing have been done. The name Tanytarsus is a junior synonym of Corynocera, so if that happens all Tanytarsus species will be named  Corynocera.\r\n\r\n==Characters==\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head --&gt;\r\n!|Reference\r\n!|Taxon\r\n!im90|Head\r\n!im90|Head: postoccipital plate\r\n!im90|Head: postoccipital margin\r\n!im90|Antenna: segments\r\n!im90|Antenna: pedestal\r\n!im90|Antenna: spur\r\n!im90|Mentum: middle\r\n!im90|Mentum: submental setation\r\n!im90|Mentum: ventromental plates\r\n!im90|Labrum: premandible\r\n!im90|Labrum: seta S1\r\n!im90|Labrum: labral lamellae\r\n!im90|Labrum: pecten epipharyngis\r\n!im90|Mandible (inner-apical-outer-surface)\r\n!im90|Body: parapods\r\n!im90|Body: size\r\n!im90|Notes\r\n!im90|Literature\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|12|Klink and Moller-Pillot 2003}\r\n|&lt;!-- Taxon --&gt;C.oliveri\r\n|&lt;!-- Head --&gt;S3 is simple\r\n|&lt;!-- Head: postoccipital plate --&gt;?\r\n|&lt;!-- Head: postoccipital margin --&gt;?\r\n|&lt;!-- Antenna: segments --&gt;5, basal segment &gt;&gt; flagellum, 2nd is cylindrical &gt; than the remaining segments; The pedestals of the small Lauterborn organs reach far beyond the antennal apex.\r\n|&lt;!-- Antenna: pedestal --&gt;tall smooth \r\n|&lt;!-- Antenna: spur --&gt;\r\n|&lt;!-- Mentum: middle --&gt;3 in middle and set backwards 2 sets of 4 pairs of lateral teeth.\r\n|&lt;!-- Mentum: submental setation --&gt;\r\n|&lt;!-- Mentum: ventromental plates --&gt;close together medially and &gt; mentum\r\n|&lt;!-- Labrum: premandible --&gt;5\r\n|&lt;!-- Labrum: seta S1 --&gt;comb\r\n|&lt;!-- Labrum: labral lamellae --&gt;1 single plate with numerous apical teeth\r\n|&lt;!-- Labrum: pecten epipharyngis --&gt;3 smooth plates with distal teeth\r\n|&lt;!-- Mandible (inner-apical-outer-surface) --&gt;3-1-3-toothed lobe; The pecten mandibularis is present and seta interna with branches.\r\n|&lt;!-- Body: parapods --&gt;posterior parapods bear only impel claws ({citeID|2|Pinder and Reiss 1983})\r\n|&lt;!-- Body: size --&gt;7mm (up to ~), medium sized larvae\r\n|&lt;!-- Notes --&gt;\r\n|&lt;!-- Literature --&gt;\r\n\r\n|-\r\n|&lt;!-- Reference --&gt;{citeID|2|Pinder and Reiss 1983}\r\n|&lt;!-- Taxon --&gt;C.oliveri\r\n|&lt;!-- Head --&gt;S3 is simple setalike\r\n|&lt;!-- Head: postoccipital plate --&gt;?\r\n|&lt;!-- Head: postoccipital margin --&gt;?\r\n|&lt;!-- Antenna: segments --&gt;5\r\n|&lt;!-- Antenna: pedestal --&gt;tall\r\n|&lt;!-- Antenna: spur --&gt;no\r\n|&lt;!-- Mentum: middle --&gt;3, middle slightly higher than outer median teeth\r\n|&lt;!-- Mentum: submental setation --&gt;?\r\n|&lt;!-- Mentum: ventromental plates --&gt;close together medially 1.1x mentum width\r\n|&lt;!-- Labrum: premandible --&gt;5+brush\r\n|&lt;!-- Labrum: seta S1 --&gt;comb\r\n|&lt;!-- Labrum: labral lamellae --&gt;well develloped\r\n|&lt;!-- Labrum: pecten epipharyngis --&gt;3 distally toothed scales\r\n|&lt;!-- Mandible (inner-apical-outer-surface) --&gt;3-1-3-toothed lobe\r\n|&lt;!-- Body: parapods --&gt;posterior parapods bear only impel claws\r\n|&lt;!-- Body: size --&gt;\r\n|&lt;!-- Notes --&gt;\r\n|&lt;!-- Literature --&gt;\r\n\r\n|}\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sorttwo''\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|Reference\r\n!|Taxon\r\n!|Differential characteristics\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|12|Klink and Moller-Pillot 2003}\r\n|C.oliveri\r\n|The mentum is distinctive for the genus in having a central and dorsal or lateral part with only 1-2 or 4 pairs of teeth. C. oliveri can be separated from C. ambigua by the teeth and lobes on the mandible and the mentum flatter and 4 pairs of lateral teeth.\r\n\r\n\r\n|}\r\n\r\n\r\n', 1, '', '170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(471, 34, NULL, '==Characters==\r\n\r\n{citeID|2|Pinder and Reiss 1983}: Cryptotendipes larvae are distinguished from all other genera of Chironomini --- with the exception of Cladopelma and Microchironomus --- by the enlaged outer mental teeth, set forward in relation to the slope of the other lateral teeth. They differ from the remaining 2 genera in having the second pair of lateral teeth set well back making the central part of the mentum much more steeply sloping than the lateral regions.&lt;br&gt;\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*C.casuarius ({citeID|291|Townes 1945})\r\n*C.nigronitens ({citeID|276|Edwards 1929})\r\n\r\n==Key==\r\n\r\nthis key is from {citeID|357|Yan et.al. 2005a}:\r\n\r\n#~\r\n##Mentum with simple broad, flat, round median tooth; outer 3 teeth indistinctly set off from others; marine~-&gt; C. acalcar Reiss (Palaearctic)\r\n##Mentum with trilid median tooth, lateral notch distinct or fused. If only 1 simple median tooth. then harely projecting. Last 2 or 3 laterals composing enlarge, compound tooth~-&gt; 2\r\n#~\r\n##Mentum with 1 predominant higher median tooth. 4 lateral teeth in addition to outer 3 teeth. Ventromental plate relatively small~-&gt; 3\r\n##Mentum with trifid median tooth or at least with notch rudiments on each side. Outer 3 lateral teeth distinctly set off~-&gt; 4\r\n#~\r\n##Without distinct enlarged outer compound tooth ~-&gt; C. pseudotener (Goetghebuer) (Holarctic)\r\n##With distinct enlarged outer compound tooth~-&gt; C. emorsus (Townes) sensu Beck &amp; Beck, l969 (Nearctic)\r\n#~\r\n##Pecten epipharyngis usually with 2 teeth~-&gt; C. sp. 3 {Palaearctic)\r\n##Pecten epipharyngis usually with 3 teeth~-&gt; 5\r\n#~\r\n##Seta subdentalis relatively short, at most reaching apex of first inner tooth~-&gt; 6\r\n##Seta subdentalis long, extending beyond all inner teeth~-&gt; 7\r\n#~\r\n##Labral scletites l and 2 present. Two inner mandible teeth flat; third antennal segment longer than fourth~-&gt; C. usmaensis (Pagast) {Palaearctic)\r\n##Labral sclerites l and 2 fused. Two inner mandible teeth clearly pointed; third antennal segment shorter than fourth, at most halfas long as fourth segment~-&gt; C. sp. 4 (Palaearctic)\r\n#~\r\n##Inner teeth of mandible pointed. Posterior occipital margin pigmented only in median part~-&gt; C. sp. 2 (Oriental)\r\n##Inner teeth of mandible flat. Posterior occipital margin entirely dark~-&gt; 8\r\n#~\r\n##Nearctic~-&gt; C. emorsus (Townes)\r\n##Palaearctic~-&gt; C. sp. 1\r\n', 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cryptotendipes (n=11, Template:explained:N2:HillsDiversity=8.3, n&lt;sub&gt;max&lt;/sub&gt;=5.04) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 16.\r\n', '22 87', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(472, 38, NULL, '==Checklist==\r\n\r\nIn China {citeID|279|Wang 2000}:\r\n*D.aberrata Lundbeck, 1898 male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa aberrata (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Diam_abea_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.alpina Tokunaga male female\r\n*D.bertrami Edwards male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa bertrami (mentum) Schmid 1993'' src=''image.php?text=image deleted: Diam_bert_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.filicauda {citeID|436|Tokunaga 1960} male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa filicauda (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Diam_fili_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.gregsoni Edwards, 1933 male {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa gregsoni (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Diam_grso_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.insignipes Kieffer {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa insignipes (mentum) Schmid 1993'' src=''image.php?text=image deleted: Diam_insi_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Diamesa insignipes gr. (mentum) Wang, Ji. 1987'' src=''image.php?text=image deleted: Diam_insigr_men_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.kaszabi  Serra-tosio, 1983 male\r\n*D.leona Roback, 1957 male\r\n*D.nivoriunda? (Fitch, 1847) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa nivoriunda (mentum) Ye and Wang 1982'' src=''image.php?text=image deleted: Diam_nivu_men_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.tsutsuii {citeID|435|Tokunaga 1936} male female {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa tsutsuii (mentum) Makarchenko 1999'' src=''image.php?text=image deleted: Diam_tsut_men_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.veletensis Serra-Tosio, 1971 male\r\n*D.vernalis Makarchenko {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa vernalis (mentum) Ye and Wang 1982'' src=''image.php?text=image deleted: Diam_vern_men_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Diamesa vernalis (mentum) Wang, Ji. 1987'' src=''image.php?text=image deleted: Diam_vern_men_WJi1987_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Diamesa vernalis (mentum) Wang and Wang 1991'' src=''image.php?text=image deleted: Diam_vern_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.zerny Edwards {overlib|mentum|&lt;img align=''middle'' width=200 title=''Diamesa zerny (mentum) Schmid 1993'' src=''image.php?text=image deleted: Diam_zern_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*D.sp male female\r\n', 1, '==Temperature==\r\n\r\n{citeID|492|Brodersen et al. 2004}: Cold-water assemblages were dominated by oxyconformers such as Heterotrissocladius, Micropsectra, Hydrobaenus, and Diamesa.\r\n\r\n{citeID|6|Epler 2001}: &laquo;Diamesa larvae are usually found in cool running water. {citeID|290|Hudson et.al. 1990} noted that D. nivoriunda tolerates high turbidity and siltation.&raquo;\r\n\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Diamesa  and other taxa: 0&deg;C &plusmn; 0, n=2. Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for 2~Diamesa spp. in lake Glacier Lake 1 (West Greenland) an oxygen consumption of 6.08/9.23 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 26.2/43 in % is in group {overlib|D/B|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  40~ha (lake area); 67.13521&deg;N; 50.12833&deg;W; 2~&micro;S~&middot; cm⁻&sup1;; 4-7&deg;C (July 2002); max. depth: 22~m.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(473, 40, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(474, 42, NULL, NULL, 1, NULL, '45 196 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(475, 45, NULL, 'in China ({citeID|279|Wang 2000}):\r\n*E.flavens (?) (Malloch)', 1, NULL, '196 1632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(477, 55, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(478, 59, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Cyphomella/Harnischia (n=5, Template:explained:N2:HillsDiversity=4.37, n&lt;sub&gt;max&lt;/sub&gt;=3.64) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 17.\r\n', '35', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(479, 60, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(481, 63, NULL, NULL, 1, '==Biotops==\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Heterotanytarsus sp.  and other taxa: 9.4m &plusmn; 3.6 (n=12). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Temperature===\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Heterotrissocladius undifferentiated  and other taxa: 7.0&lt; &deg;C, n=31 (sigmoidal decreasing Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Heterotanytarsus the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(482, 67, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*?Kiefferulus crassiforceps (Kieffer)\r\n*Kiefferulus glauciventris (Kieffer)\r\n*Kiefferulus longilobus (Kieffer)\r\n*Kiefferulus tendipediformis (Goetghebuer)', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Kiefferullus as lentic taxa in a lentic-lotic gradient in France.\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(483, 68, NULL, NULL, 1, NULL, '34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(484, 69, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(485, 71, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*K.camptophleps (Edwards)', 1, NULL, '155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(486, 72, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Labrundinia (n=19, Template:explained:N2:HillsDiversity=12.43, n&lt;sub&gt;max&lt;/sub&gt;=9.62) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 31.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(487, 73, NULL, 'in China {citeID|279|Wang 2000}:\r\n*L.multiseta Makarchenko male\r\n*L.vidua (Kieffer)', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(489, 75, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(490, 76, NULL, NULL, 1, '{citeID|306|Cranston 2007}: Larsia is a frequently-occuring genus especially in warm streams and rivers, but is encountered less often in tropical standing waters.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(491, 77, NULL, NULL, 1, '{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|Reference\r\n!|Taxon\r\n!|Notes\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|481|Buskens and Moller-Pillot 1992}\r\n|Lasiodiamesa sp.\r\n|prefers small stagnant waters, such as pools (see also Telmatopelopia nemorum)\r\n\r\n|}\r\n\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(492, 78, NULL, 'Not reported fro China in {citeID|279|Wang 2000}.', 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Lauterborniella (n=14, Template:explained:N2:HillsDiversity=9.03, n&lt;sub&gt;max&lt;/sub&gt;=7.06) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 21.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(494, 81, NULL, NULL, 1, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(496, 83, NULL, '==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*M.decedens ? (Walker, 1848)\r\n*M.johannseni ? Roback\r\n*M.nebulosa (Meigen)\r\n*M.notata (Meigen)\r\n', 1, NULL, '7 212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(497, 84, NULL, NULL, 1, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Mesocricotopus sp.  and other taxa: 10.8m &plusmn; 3.8 (n=5). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(498, 85, NULL, ';Nomenclature:{citeID|264|Spies 2006}', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(499, 87, NULL, 'Comments ({citeID|2|Pinder and Reiss 1983}): Larvae of Microchironomus are easily distinguished frome other Chironomini except for Cladopelma, Cryptotendipes and some Paracladopelma by the outer goup of mental teeth which are enlarged and set forward relative to the  general slope of the mentum. \r\n*The median mental tooth of Microchironomus larvae is distinctly trifid, unlike that of Cladopelma in which it is rounded or notched medially. The median tooth may also appear trifid in Cryptotendipes but in this case the central part of the mentum slopes very steeply wheras in Microchironomus the whole mentum slopes very gently.\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*M.deribae (Freeman)\r\n*M.tener (Kieffer)', 1, NULL, '22 34', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(500, 90, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*M.britteni (Edwards) male\r\n*M.chloris (Meigen) male\r\n*M.diffinis (Edwards) male\r\n*M.pedellus (Degeer) male\r\n*M.rydalensis (Edwards) male female\r\n*M.trunctus Kawai and Sasa male\r\n*M.sp. male\r\nBut see also {citeID|394|Qi and Wang 2006}.', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Microtendipes as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n===Temperature===\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Microtendipes  and other taxa to find possible differences in temperature: 2000: 15.3&deg;C &plusmn; 3.2 (12.1 to 18.6), 2006: 16.1&deg;C &plusmn; 3.4 (12.7 to 19.5) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nMicrotendipes sp. reported by {citeID|516|Korhola et al. 2002} as warm adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Microtendipes  and other taxa: 12.6&deg;C &plusmn; 1.3, n=54 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|520|Porinchu and Cwynar 2002} reports Microtendipes and Corynocera ambigua as temperate taxa.\r\n\r\n\r\n===Depth===\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Microtendipes sp.  and other taxa: 6.4m &plusmn; 4 (n=42). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Oxygen===\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Microtendipes (n=20, Template:explained:N2:HillsDiversity=13.34, n&lt;sub&gt;max&lt;/sub&gt;=8.14) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 22.\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Microtendipes the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(501, 91, NULL, NULL, 1, '==Biotops==\r\n\r\n===Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Monodiamesa sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Monodiamesa the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(502, 92, NULL, 'Not mentioned for China in {citeID|279|Wang 2000}. Comments from {citeID|288|Fittkau and Roback 1983}: Monopelopia in common  with Telmatopelopia and Xenopelopia, has \r\n*Lauterborn organs arising like the ends of a tuning fork from antennal segment 2, as well as \r\n*posterior parapod claws with strong teeth on inner margin. \r\nIn Monopelopia, in contrast to the other genera, the middle tooth of the ligula is exeptionally short and slender and the ventromentum is distincly set off from the M appendage and has narrow, longitudianl folds.', 1, NULL, '2 173 190 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(503, 93, NULL, '{citeID|21|Cranston et.al. 1983}:\r\n*Comments: Nanocladius, with its \r\n**large to elongate, broad vantromental plate without beard and with\r\n**weakly developed labrum setae is a distinctive genus in larval stage.&lt;br&gt;\r\n\r\n{citeID|6|Epler 2001}:\r\n*DIAGNOSIS: \r\n**The simple labral setae (a single Japanese species with apically pectinate S II); \r\n**large ventromental plates which extend past the lateral margin of the mentum; \r\n**lack of cardinal beard  and\r\n**distinctive mentum with wide median area, usually with two small central teeth, distinguish the genus in [[http://home.earthlink.net/~johnepler/ our]] area.\r\n\r\n*NOTES: A common and widespread genus, Nanocladius is divided into two subgenera: Nanocladius (Plecopteracoluthus) is phoretic or parasitic on aquatic insects; Nanocladius (Nanocladius) species are freeiving. Larvae are found in lakes, rivers and streams; at least one species, N. distinctus, is tolerant of high levels of organic nutrients.&lt;br&gt;\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*N.bicolor (Zetterstedt) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Nanocladius bicolor (mentum) Schmid 1993'' src=''image.php?text=image deleted: Nano_bico_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*N.rectinervis (Kieffer) {overlib|mentum|&lt;img align=''middle'' width=200 title=''Nanocladius rectinervis (mentum) Cranston et.al. 1983'' src=''image.php?text=image deleted: Nano_rect_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Nanocladius rectinervis (mentum) Schmid 1993'' src=''image.php?text=image deleted: Nano_rect_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*N.vitellinus (?) (Kieffer)', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Nanocladius as lotic taxa in a lentic-lotic gradient in France.\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Nanocladius (N.) anderseni S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) balticus (Palm.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||***** || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) distinctus (Mall.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) incomptus S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) minimus S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius (N.) rectinervis (Kieff.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Nanocladius bicolor (Zett.)&lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||***** ||***** ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; || || || || ||*****&lt;!-- mesohumic --&gt; ||*****&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Nanocladius  and other taxa to find possible differences in temperature: 2000: 13.4&deg;C &plusmn; 4.5 (8.9 to 17.9), 2006: 13&deg;C &plusmn; 5.3 (7.7 to 18.3) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Nanocladius  and other taxa: 0&deg;C &plusmn; 0, n=3. Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Nanocladius sp.  and other taxa: 8.5m &plusmn; 3.9 (n=6). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Nanocladius (n=16, Template:explained:N2:HillsDiversity=12.56, n&lt;sub&gt;max&lt;/sub&gt;=4.44) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 37.\r\n\r\n===Conductivity/Salinity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Nanocladius in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 1168.93mg &middot; l⁻&sup1; (&divide; 600 = 1.95mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 1.2401. In article shortened as: Na.\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Nanocladius sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(504, 94, NULL, '{citeID|288|Fittkau and Roback 1983}: Natarsia is easily distinguished from larvae of aother Tanypodinae lacking toothed dorsomental plates (Pentaneurini) by the relatively thick and short antenna, only about 1/3 the head length, and the large basal tooth of the mandible. The specific differences in length of antennal blade and accessory blade are noteworthy, as is the configuration of the teeth of the ligula, which may be deeply concave or straight.', 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Natarsia punctata (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(505, 95, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(506, 96, NULL, '', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(507, 97, NULL, '==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*N.dubius (Meigen) male female\r\n*N.sp male female', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(508, 98, NULL, 'in China ({citeID|286|Yan et.al. 2005}):\r\n*N.acre Adam & Sæther\r\n*N. japonicum Niitsuma\r\n*N. nojirimaculatum Sasa\r\n*N. sp.1', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(509, 99, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(510, 100, NULL, NULL, 1, 'Abiskomyia and Oliveridia are also characteristic taxa of arctic lakes ({citeID|21|Cranston et.al. 1983})\r\n\r\n==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Oliveridia  and other taxa: 11.1&deg;C &plusmn; 1.1, n=25 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|520|Porinchu and Cwynar 2002} reports cold-water chironomid taxa, such as Paracladius, Hydrobaenus/Oliveridia, Abiskomyia, and Parakiefferiella nigra from a tundra site near the lower Lena River, Northeast Siberia.\r\n\r\n{citeID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(511, 104, NULL, '', 1, '==Biotops==\r\n\r\n===Temperature===\r\n\r\n{ctextiteID|507|Brooks and Birks 2000}: \r\n*11 with significant symmetric unimodal Template:HOF:unimodal: [..] Pagastiella (groups 10-12&deg;C &amp; &gt;12&deg;C)\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Pagastiella  and other taxa to find possible differences in temperature: 2000: 15&deg;C &plusmn; 1.5 (13.5 to 16.5), 2006: 15.7&deg;C &plusmn; 2 (13.7 to 17.7) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\nPagastiella sp. reported by {textciteID|516|Korhola et al. 2002} as intermediate taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|521|Porinchu et al. 2002} reports as warmer preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Pagastiella, Polypedilum and Tanytarsus sp. A/C are most abundant at sites with surface water temperatures in excess of 17.5&deg;C.\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Pagastiella sp.  and other taxa: 5.5m &plusmn; 3.7 (n=23). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Pagastiella the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(512, 105, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(513, 107, NULL, '==Checklists==\r\n\r\n===China===\r\n\r\nReported for China in {citeID|279|Wang 2000}:\r\n*P.arcuatus (Goetghebuer) ♂♀\r\n*P.primitivus (Johannsen) ♂\r\n*P.varus (Goetghebuer) ♂\r\n*P.sp. ♂♀', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classify Parachironomus as lentic taxa in a lentic-lotic gradient in France.\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Parachironomus (n=24, Template:explained:N2:HillsDiversity=16.65, n&lt;sub&gt;max&lt;/sub&gt;=6.98) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 23.\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Parachironomus the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '53', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(514, 108, NULL, '{citeID|21|Cranston et.al. 1983}: Among larvae with a \r\n*bifid S1 and a\r\n*beared beneath the ventromentum the presence of a broad, dome-shaped lightly coloured median tooth of the mentum is distinctive.&lt;br&gt;\r\nKey from {citeID|20|Schmid 1993}:\r\n#~\r\n##{overlib|Premandible|<img src=''image.php?text=Image reduced version. Deleted: Pacl_alpi_pre_Hir1973_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pacl_alpi_pre_Hir1973_r.gif 2009-12-15 10:36:17''>} with brush -&gt; P.alpicola\r\n##{overlib|premandible|<img src=''image.php?text=Image reduced version. Deleted: Pacl_conv_pre_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pacl_conv_pre_Sch1993_r.gif 2009-12-15 10:36:17''>} without brush -&gt; P.conversus\r\n\r\n{| style=''border:1px solid;'' \r\n|-\r\n!|reference\r\n!im90|head\r\n!im90|head - postoccipital margin\r\n!im90|antenna\r\n!im90|antenna - blade\r\n!|s1\r\n!im90|pecten epipharyngis\r\n!im90|premandible\r\n!im90|mandible\r\n!im90|mandible - seta subdentalis\r\n!im90|mandible - seta interna\r\n!im90|ventromental plates\r\n!im90|mentum - median\r\n!im90|mentum - lateral\r\n!im90|mentum - pattern\r\n\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|&lt;!-- head --&gt;&lt;span class=''pale''&gt;whitish&lt;/span&gt;\r\n|&lt;!-- head pom --&gt;slightly darkened\r\n|&lt;!-- ant --&gt;5\r\n|&lt;!-- ant blade --&gt;blade reaching apex of 4th antennal segment\r\n|&lt;!-- s1 --&gt;bifid with thin lobes\r\n|&lt;!-- pee --&gt;3 spines\r\n|&lt;!-- pre --&gt;2 large teeth; brush: yes/no\r\n|&lt;!-- man --&gt;3-1-0-0&lt;br&gt; long apical tooth\r\n|&lt;!-- man s subdent --&gt;\r\n|&lt;!-- man s interna --&gt;\r\n|&lt;!-- vep --&gt;on base several fine setae (beared)\r\n|&lt;!-- men mid --&gt;1 pale\r\n|&lt;!-- men lat --&gt;6\r\n|&lt;!-- men pat --&gt;\r\n|}\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.alpicola (Zetterstedt) {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Pacl_alpi_men_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pacl_alpi_men_WOr1983_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: Pacl_alpi_men_Hir1973_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pacl_alpi_men_Hir1973_r.gif 2009-12-15 10:36:17''>}\r\n*P.conversus (?) (Walker) {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Pacl_conv_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pacl_conv_men_Sch1993_r.gif 2009-12-15 10:36:17''> <img src=''image.php?text=Image reduced version. Deleted: Patc_inse_men_WSD1991_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Patc_inse_men_WSD1991_r.gif 2009-12-15 10:36:17''>}\r\n*P.inaequalis (?) (Kieffer) {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Pacl_inae_men_Ye1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Pacl_inae_men_Ye1982_r.gif 2009-12-15 10:36:17''>}', 1, '==Biotops==\r\n\r\n===Littoral===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Paracladius alpicola (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n|-\r\n|Paracladius quadrinodosus Hirv. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Profundal===\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n|-\r\n|Paracladius alpicola (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Paracladius quadrinodosus Hirv. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\n{citeID|526|Hofmann 2001} reports as cold-stenothermal taxa Heterotrissocladius sp., Paracladius sp., Orthocladius consobrinus, and Corynocera oliveri.\r\n\r\n{citeID|520|Porinchu and Cwynar 2002} reports cold-water chironomid taxa, such as Paracladius, Hydrobaenus/Oliveridia, Abiskomyia, and Parakiefferiella nigra from a tundra site near the lower Lena River, Northeast Siberia.\r\n\r\n{citeID|511|Brooks 2006}:\r\n*&laquo;[..] ultra-cold stenothermic oligotrophes than in the Latedevensian, especially Diamesinae, Paracladius, Corynocera oliveri type and Micropsectra radialis type.&raquo;\r\n\r\n===Conductivity===\r\n\r\n{citeID|502|Zhang et al. 2007} report for Paracladius in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 626.13mg &middot; l⁻&sup1; (&divide; 600 = 1.04mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 4.50082. In article shortened as: Pa.\r\n', '1505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(515, 110, NULL, 'Not mentioned for China in {citeID|279|Wang 2000}.', 1, NULL, '155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(516, 115, NULL, '{citeID|21|Cranston et.al. 1983}:&lt;br&gt;\r\n==Generic Characters==\r\n\r\nThe larvae of Parametriocnemus are quite similar to those of Paraphaenocladius but do not have posteriorly directed procerci and anal setae. The two genera almost certainly are sistergroups and a larval synapomorphy may be the very short spines of pecten epipharyngis.\r\n{| style=''border-style:solid;border-width:1px;''\r\n|-\r\n!|Reference\r\n!|&lt;span title=''head''&gt;head&lt;/span&gt;\r\n!|&lt;span title=''postoccipital margin''&gt;po-mar&lt;/span&gt;\r\n!|&lt;span title=''antenna''&gt;ant&lt;/span&gt;\r\n!|&lt;span title=''anal spur'' &gt;spur&lt;/span&gt;\r\n!|&lt;span title=''antennal pedestal''&gt;ant.ped&lt;/span&gt;\r\n!|&lt;span title=''premandible''&gt;prem&lt;/span&gt;\r\n!|&lt;span title=''seata S1''&gt;S1&lt;/span&gt;\r\n!|&lt;span title=''mandible: inner apikal outer surface tooth''&gt;mand&lt;/span&gt;\r\n!|&lt;span title=''mandible: seta interna''&gt;mand&lt;br&gt;set-int&lt;/span&gt;\r\n!|&lt;span title=''ventromental plates''&gt;v-plates&lt;/span&gt;\r\n!|&lt;span title=''median tooth mantum''&gt;men-med&lt;br&gt; teeth&lt;/span&gt;\r\n!|&lt;span title=''mentum lateral teeth''&gt;men-lat&lt;br&gt; teeth&lt;/span&gt;\r\n!|&lt;span title=''posterior parapods''&gt;po-par&lt;/span&gt;\r\n\r\n|-\r\n|{citeID|20|Schmid 1993}\r\n|yellow\r\n|slightly darker\r\n|5 Sgm.&lt;br&gt;AR &gt;1\r\n| -\r\n|\r\n|\r\n|plumose;&lt;br&gt; remainig setae simple\r\n|3-1-0-0\r\n|6-8 branches\r\n|extending beyond outer mental teeth of flattened mentum\r\n|2\r\n|5\r\n|\r\n|}\r\n\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.lundbecki ? (Johannsen)\r\n*P. stylatus (Kieffer) male', 1, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*8 have statistically significant (sigmoidal Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Parametriocnemus (n=3, Template:explained:N2:HillsDiversity=2.84, n&lt;sub&gt;max&lt;/sub&gt;=2.08) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 40.\r\n', '116 79 143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(517, 123, NULL, '{citeID|21|Cranston et.al. 1983}:\r\n* The genus clearly is closely related to Heterotrissocladius. The larvae have the same type of characteristic antenna. However, Heterotrissocladius has:\r\n**5 pairs of lateral teeth on mentum,\r\n**wide ventromental plates,\r\n**bifid premandible, \r\n**plumose S1 and \r\n**weak, serrated spines on pecten epipharyngis.', 1, NULL, '64', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(518, 134, NULL, NULL, 1, '==Biotops==\r\n\r\n==Depth==\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Protanypus sp.  and other taxa: 11.3m &plusmn; 6.8 (n=10). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Temeprature==\r\n\r\nHeterotrissocladius, Protanypus, and Sergentia are common in the cold profundal of stratified lakes from temperate forest regions as well as arctic sites ({citeID|303|Walker 1991}).\r\n\r\nProtanypus sp. reported by {textciteID|516|Korhola et al. 2002} as cold adapted taxa based on {textciteID|517|Olander et al. 1999}.\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Protanypus  and other taxa: 3.3&deg;C &plusmn; 8.3, n=27 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n\r\n{textciteID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type, Micropsectra insignilobus type, Protanypus [most abundant in &lt; 13&deg;C, but only a few head capsules], Tanytarsus lugens type, Hydrobaenus, Heterotrissocladius grimshawi type, Corynocera ambigua and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Protanypus the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(519, 140, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(520, 141, NULL, ';Nomenclature:{citeID|264|Spies 2006}', 1, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*11 with significant symmetric unimodal Template:HOF:unimodal: [..] Pseudorthocladius (groups 10-12&deg;C &amp; &gt;12&deg;C)\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(521, 143, NULL, 'Not mentioned for China in {citeID|279|Wang 2000}.', 1, NULL, '116 79 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(522, 148, NULL, NULL, 1, NULL, '26 179 8', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(523, 149, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(524, 151, NULL, '', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(525, 152, NULL, '==Diagnosis==\r\n\r\n{citeID|6|Epler 2001}: Distinguished by \r\n*the small seta-like S1 and {overlib|large S2|<img src=''image.php?text=Image reduced version. Deleted: Saet_spec_se2_WaS1994_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Saet_spec_se2_WaS1994_r.gif 2009-12-15 10:36:17''>;} \r\n*6 segmented {overlib|antennae|<img src=''image.php?text=Image reduced version. Deleted: Saet_spec1_ant_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Saet_spec1_ant_WCh1983_r.gif 2009-12-15 10:36:17''>}, with second segment not as long as third and style at apex of segment 3 not exceeding apex of segment 5\r\n*mandible without dorsal tooth\r\n*premandible with 3 large inner teeth and brush present\r\n*and the coarsely striated ventromental plates.\r\n\r\n{citeID|6|Epler 2001} notes: S&aelig;theria is very close to Paracladopelma, but can be distinguished by the 6 segmented antenna with the relatively shorter second segment (in Paracladopelma the second antennal segment is longer than the third). Contrary to the diagnoses in {citeID|292|Jackson 1977} and {citeID|2|Pinder and Reiss 1983}, the premandible does have a brush, although it is hyaline and not easily observed.&lt;br&gt;\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*S.sp. male', 1, '==Biotops==\r\n\r\n{citeID|6|Epler 2001}: Larvae are found in sandy substrata, usually in running water.\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon S&aelig;theria sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', '109 1440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(526, 153, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(527, 156, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*S.bausei? (Kieffer)', 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Stempellina/Zavreliella (n=6, Template:explained:N2:HillsDiversity=4.35, n&lt;sub&gt;max&lt;/sub&gt;=2.78) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 5.\r\n', '192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(528, 158, NULL, 'Systematic notes ({citeID|304|Spies and S&aelig;ther 2004}):\r\n* The type species of Stenochironomus Kieffer, 1919 is Chironomus pulchripennis Coquillett, 1902 by designation of Townes (1945). Stenochironomus gibbus (Fabricius, 1794), nomen protectum, is the valid name for S. parisiensis (Thunberg, 1784) syn. n., nomen oblitum.\r\n\r\n\r\nKey to 4th Instar Larvae (modified from {citeID|305|Borkent 1984}) from website [[http://insects.ummz.lsa.umich.edu/~ethanbr/aim/ Aquatic Insects of Michigan]]&lt;br&gt;\r\n\r\n*1a Mandibular adductor apodeme with posterior dark pigmentation; Ligula with very fine shagreen, extending posteriorly to, or nearly to, the lateral edge of base of lobe, defined posteriorly in most specimens by a discrete border; Paralabial plate wider than portion of maxilla to which it is fused; also: Anal papillae without constriction -&gt;...2\r\n*1b Mandibular adductor apodeme with no posterior dark pigmentation; Ligula with very fine to scale-like shagreen, not extending posteriorly to the lateral edge of base of lobe, or rarely, extending to the lateral edge, not defined or defined posteriorly by a discrete border; Paralabial plate and a portion of maxilla with which it is fused, of approximately equal width -&gt;...3\r\n\r\n*2a(1a) Head capsule length 534-698 &micro;; Distance of antennal seta from base/length of antennal segment 1 = 0.63-0.72 Stenochironomus poecilopterus (Mitchell)\r\n*2b Head capsule length 592-776 &micro;; Distance of antennal seta from base/length of antennal segment 1 = 0.68-0.82 Stenochironomus pulchripennis (Coquillett)\r\n\r\n*3a(1b) Spicules of pecten epipharyngis in a short, medially-placed row but grouped medially; head capsule length 407-640 &micro;; Ligular lobes joined or not joined by coloration; Distance of antennal seta from base/length of antennal segment 1 = 0.48-0.71 Stenochironomus macateei (Malloch)\r\n*3b Spicules of pecten epipharyngis in a longer row, extending laterally to bases of chaetulae laterales; head capsule length 533-756 &micro;; Ligular lobes joined by coloration; Distance of antennal seta from base/length of antennal segment 1 = 0.69-0.83 Stenochironomus hilaris (Walker)\r\n\r\n\r\n&lt;br&gt;In {citeID|279|Wang 2000}:\r\n*Stenochironomus hilaris (Walker, 1848)\r\n*Stenochironomus gibbus (Fabricius, 1794) male\r\n*Stenochironomus nelumbus (Tokunaga and Kuroda)\r\n*Stenochironomus nubilipennis Yamamoto male\r\n*Stenochironomus satorui (Tokunaga and Kuroda) male\r\n*Stenochironomus takahashii (Tokunaga) female', 1, 'The chironomid Stenochironomus nelumbus was found on lotus in Zhongshan Botanical Garden in Nanjing in 1986. This was the first record of this insect in China. The body length was 3-4.5mm for adults, 10-11 mm for larvae and 4-6 mm for pupae. Larvae mined the leaves and pupated in water. Spraying with 40% omethoate did not give effective control, but damage was reduced by keeping lotus leaves out of water. The morphology of this species is described in detail.\r\nIn: "A report on the bionomics of Stenochironomus nelumbus on lotus", Shen, B. Y. 1987, Plant Protection 13(3): 37-38\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Stenochironomus (n=5, Template:explained:N2:HillsDiversity=4.84, n&lt;sub&gt;max&lt;/sub&gt;=2.35) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 27.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(529, 160, NULL, '==Characters==\r\n\r\n{citeID|21|Cranston et.al. 1983}: The \r\n*type of the mentum and \r\n*the ventromental plates together with the \r\n*simple or toothed S1 is \r\ndistinctive among chironomids. Some larvae tentatively assigned to Parakiefferiella have a weak beared and may actually belong to Stilocladius.\r\n\r\n{| style=''border-style:solid;border-width:1px;''\r\n|-\r\n!|Reference\r\n!im90|head\r\n!im90|postoccipital plate\r\n!im90|postoccipital margin\r\n!im90|antenna\r\n!im90|antenna blade\r\n!im90|antenna pedestal\r\n!im90|pecten epipharyngis\r\n!im90|S1\r\n!im90|premandible\r\n!im90|premandible brush\r\n!im90|mandible\r\n!im90|mandible set-int\r\n!im90|ventromental plates\r\n!im90|beard\r\n!im90|mentum middle teeth\r\n!im90|mentum lateral teeth\r\n!im90|posterior parapods\r\n\r\n|-\r\n|{citeID|20|Schmid 1993} &lt;br&gt;S.montanus Rossaro, 1979\r\n|&lt;span style=''color:brown;''&gt;brown&lt;/span&gt;\r\n|no\r\n|black\r\n|6\r\n|shorter than flagellum\r\n|?\r\n|3 spines\r\n|apically serrated\r\n|1\r\n|?\r\n|4-1-0-0&lt;br&gt;apical tooth longer than combined width of 4 inner\r\n|6-8 serrated branches\r\n|extending past outermost lateral teeth\r\n|4 setae (shorter than 7&micro;m) beneath ventromental plates\r\n|1 broad\r\n|6\r\n|\r\n\r\n|-\r\n|{citeID|21|Cranston et.al. 1983}\r\n|\r\n|no\r\n|?\r\n|6 segm.,&lt;br&gt; shorter than mandible\r\n|about as long assegments 2 and 3 combined\r\n|?\r\n|3 weak spines\r\n|simple (S.clinopecten S&aelig;ther) or with apical teeth (S.montanus Rossaro)&lt;br&gt;other simple\r\n|1\r\n|no\r\n|3/4-1-0-0\r\n|4 serrated branches\r\n|very broad, extending past outermost teeth on flattend mentum\r\n|4-6 weak setae underneath or slightly laterad\r\n|1 broad\r\n|5-6\r\n|\r\n\r\n|}\r\n\r\n==Keys==\r\n\r\n&lt;!-- 1. Щетинки лабрума SI расщеплены на несколько ветвей (рис. 19); ментум с 6 парами боковых зубцов; мандибула с 5 зубцами.......................................................2\r\n&mdash; Щетинки лабрума SI простые; ментум с 5 парами боковых зубцов; мандибула с 4 зубцами................... .............................................S. clinopecten S&aelig;ther\r\n2. Длина тела 2,8&ndash;3,1 мм; длина головной капсулы 180&ndash;210 мкм; щетинка антенны такой же длины, как 2-й членик антенны; срединный зубец ментума в 4&ndash;5 раз шире первого бокового зубца; подставка преанальной кисточки с 6 вершинными щетинками ........................................................................ S. orientalis sp.n.\r\n&mdash; Длина тела около 5 мм; длина головной капсулы 230&ndash;280 мкм; щетинка антенны короче 2-го членика антенны; срединный зубец ментума в 3 раза шире первого бокового зубца; подставка преанальной кисточки с 5 вершинными щетинками.........S. montanus Rossaro\r\n--&gt;\r\n\r\nKey of {citeID|542|Makarchenko and Makarchenko 2003a}\r\n\r\n#~\r\n## Seta SI of labrum {overlib|split into several branches|<img src=''image.php?text=Image reduced version. Deleted: Stcl_orie_se1_Mak2003a_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Stcl_orie_se1_Mak2003a_r.gif 2009-12-15 10:36:17''>}; mentum with 6 pairs of lateral teeth; mandibles with 5 teeth~-&gt; 2\r\n## {overlib|Labral seta SI is simple|<img src=''image.php?text=Image reduced version. Deleted: Stcl_clin_lab_WOr1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Stcl_clin_lab_WOr1983_r.gif 2009-12-15 10:36:17''>}; mentum with 5 pairs of lateral teeth; mandibles with 4 teeth~-&gt; S. clinopecten S&aelig;ther\r\n#~\r\n## The body size is 2.8-3.1mm; the length of head capsule is 180-210&micro;m; {overlib|antennal flagellum is as long as the 2nd segment of antenna|<img src=''image.php?text=Image reduced version. Deleted: Stcl_orie_ant_Mak2003a_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Stcl_orie_ant_Mak2003a_r.gif 2009-12-15 10:36:17''>}; the middle tooth of {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Stcl_orie_men_Mak2003a_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Stcl_orie_men_Mak2003a_r.gif 2009-12-15 10:36:17''>} is 4-5 times wider than the first lateral tooth; ?the procerus with 6 apical setae? [подставка преанальной кисточки с 6 вершинными щетинками]~-&gt; S. orientalis of sp.n. {citeID|542|Makarchenko and Makarchenko 2003a}\r\n## The length of body of approximately 5 mm; the length of head capsule is 230-280&micro;m; the {overlib|antennal flagellum is shorter than the 2nd segment of antenna|<img src=''image.php?text=Image reduced version. Deleted: Stcl_mont_ant_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Stcl_mont_ant_Sch1993_r.gif 2009-12-15 10:36:17''>}; the middle tooth of {overlib|mentum|<img src=''image.php?text=Image reduced version. Deleted: Stcl_mont_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Stcl_mont_men_Sch1993_r.gif 2009-12-15 10:36:17''>} is 3 times wider than the first lateral tooth; ?the procerus with 5 apical setae? [подставка преанальной кисточки с 5 вершинными щетинками]~-&gt; S. montanus Rossaro \r\n\r\n==Checklist China==\r\n\r\n In China ({citeID|279|Wang 2000}):\r\n* S.intermedius {citeID|399|Wang 1998} male', 1, NULL, '111 147 ', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(530, 161, NULL, '', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(531, 162, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(532, 163, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*S.fulva (Johannsen) male female\r\n*S.repentina Makarchenko\r\n*S.takatensis (Tokunaga) male female\r\n\r\n{citeID|6|Epler 2001}: This genus is distinguished by the \r\n*premandible with simple apex, with 1-2 (4?) small inner teeth; \r\n*maxilla with galea bearing mostly setae-like lamellae; \r\n*median tooth of mentum less than 4X width of first lateral tooth, or \r\n*median tooth weakly bilobed; and \r\n*the well developed procerci.\r\n', 1, NULL, '1435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(533, 164, NULL, '', 1, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(535, 168, NULL, '==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*T.carinatus Sublette\r\n*T.chinensis Wang male female\r\n*T.grodhausi Sublette\r\n*T.punctipennis (Meigen)\r\n*T.vilipennis (Kieffer)', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(537, 172, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(538, 173, NULL, NULL, 1, '{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|Reference\r\n!|Taxon\r\n!|Notes\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|481|Buskens and Moller-Pillot 1992}\r\n|Telmatopelopia nemorum\r\n|prefers small stagnant waters, such as pools. (see also Lasiodiamesa sp.)\r\n\r\n|}\r\n\r\n', '92', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(539, 174, NULL, 'Not mentioned for China in {citeID|279|Wang 2000}.', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(540, 175, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(541, 179, NULL, '{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|specimen\r\n!im90|head ratio - l:w\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Thienemannimyia sp.\r\n|1.429-1.538\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Paramerina sp.\r\n|1.818-2.0\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Arctopelopia sp.\r\n|1.429\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Conchapelopia melanops (Wiedemann)\r\n|1.667\r\n\r\n|}\r\n{citeID|288|Fittkau and Roback 1983}: Thienemannimyia is closely related to Arctopelopia, Conchapelopia, Meropelopia, Helopelopia and Rheopelopia. The 2 of these genera, which have a 2 segmented b seta in common whith Thienemannimyia, differ by \r\n*having a strongly broadened pseudoradula and \r\n*a higher number of teeth on the pecten epipharyngis (Arctopelopia) or \r\n*having a pale posterior margin on the head and, \r\n*on the mandible, widely separated ventromental setae 2 and 3 (Meropelopia).\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*T.fuscipes (Goetghebuer) male\r\n*T.geijskesi (Goetghebuer)\r\n*T.lentiginosa (Fries)\r\n*T.sp male female\r\n&lt;hr&gt;\r\n', 1, NULL, '8 26 148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(542, 180, NULL, NULL, 1, 'See {citeID|478|Lehmann 1973}.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(543, 181, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*T.sp. male', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(544, 183, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(545, 185, NULL, '==Chaeclist==\r\n\r\nIn China {citeID|279|Wang 2000}:\r\n*T.longimana (Staeger) male female', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(547, 189, NULL, '', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(548, 190, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Xenopelopia sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(549, 191, NULL, '\r\n==Checklist (China)==\r\n\r\nIn {citeID|279|Wang 2000}:\r\n\r\n*Z. mucronata ({citeID|241|Brundin 1949})\r\n*Z. zalutschicola {citeID|468|Lipina 1939}\r\n\r\n\r\n', 1, '==Eutrophication==\r\n\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Zalutschia lingulata S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; || || || || || || ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia mucronata (Brund.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia obsepta (Webb) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; || || ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || ||&lt;u&gt;~~~~~&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia tornetraeskensis (Edw.) &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia trigonacies S&aelig;th. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||&lt;!-- boreal --&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; ||&lt;u&gt;~~~~~&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n|-\r\n|Zalutschia zutschicola Lip. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&middot;&middot;&middot;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||***** &lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n\r\n|-\r\n|Zalutschia zalutschicola Lip. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; || || || || || || || || || || ||&lt;u&gt;*****&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; &lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Zalutschia sp.  and other taxa: 6.9m &plusmn; 3.2 (n=27). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Zalutschia (n=22, Template:explained:N2:HillsDiversity=14.02, n&lt;sub&gt;max&lt;/sub&gt;=5.5) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 45.\r\n\r\n==Conductivity==\r\n\r\n{citeID|502|Zhang et al. 2007} report for Zalutschia in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 7851.36mg &middot; l⁻&sup1; (&divide; 600 = 13.09mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 7.08664. In article shortened as: Za.\r\n', '147 111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(550, 192, NULL, 'There exist a revision in {citeID|457|Ekrem and Stur 2009}.', 1, '{citeID|507|Brooks and Birks 2000}: \r\n*8 have statistically significant (sigmoidal Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) thus the optima beyond sampled 14 &deg;C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia\r\n', '156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(551, 193, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Stempellina/Zavreliella (n=6, Template:explained:N2:HillsDiversity=4.35, n&lt;sub&gt;max&lt;/sub&gt;=2.78) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 5.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(552, 194, NULL, '==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*Z.hirtimana (Kieffer) male female\r\n*Z.sinuosa ? (Coquillett)\r\n*Z.sp. male', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(553, 195, NULL, NULL, 1, '', '118 155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(554, 196, NULL, 'not mentioned in China after {citeID|279|Wang 2000}&lt;br&gt;\r\n\r\n;comments from {citeID|21|Cranston et.al. 1983}: The mentum of Baeoctenus resembles that of Epoicocladius more than any other genus, although the genera are not closely related. Differences, however, are found in nearly all other stages.', 1, NULL, '45', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(555, 199, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(556, 200, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(557, 203, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(558, 204, NULL, 'Not mentioned for China in {citeID|279|Wang 2000}.', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(559, 208, NULL, NULL, 1, NULL, '1613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(560, 209, NULL, 'DIAGNOSIS ({citeID|6|Epler 2001}): Distinguished by the \r\n*frontoclypeal apotome\r\n*{overlib|S1|&lt;img align=''middle'' alt=''Apedilum elachistum (seta S1)'' title=''Apedilum elachistum (seta S1) Epler 2001'' src=''image.php?text=image deleted: Aped_elac_se1_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} with bases fused medially\r\n*S2 with short basal segment\r\n*{overlib|pecten epipharyngis|&lt;img align=''middle'' alt=''Apedilum elachistum (pecten epipharyngis)'' width=80 title=''Apedilum elachistum (pecten epipharyngis) Epler 2001'' src=''image.php?text=image deleted: Aped_elac_pee_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} a single plate\r\n*{overlib|6 segmented antenna|&lt;img align=''middle'' alt=''Apedilum elachistum (antenna)''  title=''Apedilum elachistum (antenna) Epler 2001'' src=''image.php?text=image deleted: Aped_elac_ant_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}, with alternate Lauterborn organs\r\n*mentum with pale bifid median tooth, and first lateral teeth reduced and appressed to larger second lateral teeth\r\n*well developed maxillary plate striations and \r\n*{overlib|mandible|&lt;img align=''middle'' alt=''Apedilum elachistum (mandible)'' width=100 title=''Apedilum elachistum (mandible) Epler 2001'' src=''image.php?text=image deleted: Aped_elac_man_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} with dorsal teeth\r\n\r\nNOTES ({citeID|6|Epler 2001}): Two species are described from the Nearctic; both are to be expected throughout eastern North America. Both species were formerly included in Paralauterborniella but were shown to be generically distinct by {citeID|289|Epler 1988}. Larvae may be separated by maxillary plate striae counts. The maxillary plate lies dorsal to the ventromental plate; striae of the maxillary plate are particularly well developed in Apedilum\r\nlarvae and are more noticeable than the striae of the ventromental plate. There are 90-105 striae in each plate in 4th instar A. elachistum larvae; 110-125 in A. subcinctum.&lt;br&gt;\r\n\r\nFor China not mentioned in {citeID|279|Wang 2000}.\r\n\r\n', 1, '{citeID|6|Epler 2001}: Larvae are found on submerged vegetation in ponds, canals and lakes, and the slowly moving portions of rivers; they can also be found in brackish water.', '90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(561, 212, NULL, 'Not mentioned fo China in {citeID|279|Wang 2000}.', 1, NULL, '7 83', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(562, 213, NULL, 'Not mentioned in China ({citeID|279|Wang 2000}).', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(563, 214, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(564, 216, NULL, 'Hudsonimyia not mentioned in China ({citeID|279|Wang 2000}).', 1, NULL, '2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(565, 217, NULL, '{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n|-\r\n!|reference\r\n!|specimen\r\n!im90|head ratio - l:w\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Paramerina sp.\r\n|1.818-2.0\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Conchapelopia melanops (Wiedemann)\r\n|1.667\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Arctopelopia sp.\r\n|1.429\r\n\r\n|-\r\n|{citeID|288|Fittkau and Roback 1983}\r\n|Thienemannimyia sp.\r\n|1.429-1.538\r\n\r\n|}\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.cingulata (Walker) male\r\n*P.sp. male', 1, '{citeID|306|Cranston 2007}: Paramerina is a worldwide genus, quite speciose, and with larvae tolerant of a wide range of environmentally deleterious conditions.\r\n', '26 8 179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(566, 218, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(567, 219, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(568, 220, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*P.dyari (Coquillett, 1902)\r\n*P.sp. male', 1, NULL, '130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(569, 224, NULL, '{| style=''border:1px solid;'' \r\n|-\r\n!|Refrence\r\n!|differences to genus\r\n!|characters \r\n\r\n|-\r\n|{citeID|302|Brooks et.al. 2007}\r\n|Cladotanytarsus\r\n|for Cladotanytarsus: 3 lateral teeth outside short 2nd tooth; Pseudochironomus: 4 lateral teeth outside short 2nd tooth\r\n\r\n|}\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.sp.', 1, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Pseudochironomus sp.  and other taxa: 4.6m &plusmn; 2.2 (n=10). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Pseudochironomus (n=27, Template:explained:N2:HillsDiversity=21.4, n&lt;sub&gt;max&lt;/sub&gt;=4.26) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 12.\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Pseudochironomus sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Pseudochironomus the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '23', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(570, 225, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*P. nivosa? male female {overlib|mentum|&lt;img align=''middle'' width=200 title=''Pseudodiamesa nivosa (mentum) Schmid 1993'' src=''image.php?text=image deleted: Psdi_nivo_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=200 title=''Pseudodiamesa nivosa gr. (mentum) Ye 1984'' src=''image.php?text=image deleted: Psdi_nivogr_men_Ye1984_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*P. pertinax? {overlib|mentum|&lt;img align=''middle'' width=200 title=''Pseudodiamesa pertinax (mentum) Epler 2001'' src=''image.php?text=image deleted: Psdi_pert_men_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}', 1, '==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff-Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Pseudodiamesa  and other taxa: 7.0&lt; &deg;C, n=10 (sigmoidal decreasing Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(571, 227, NULL, '{citeID|2|Pinder and Reiss 1983}&lt;br&gt;\r\nThe genus Polypedilum is at present very heterogeneous in its larval characters. It is therefore highly probable that some of the included species will be found not to belong here (P.nubifer, P.braseniae, P.ontario). However, irrespective of these species it is still difficult to provide generic characters for Polypedilum. The best larval character is the straight anterior margin of the frontoclypeal apotome, which is anterolaterally broadened to form lobes on which the s3 are inserted. Polypedilum larvae can be recognized by the combination of\r\n*5 segmented antenna,\r\n*tripartite, distally serrated pecten epipharyngis,\r\n*usually only 2 inner mandibular teeth and\r\n*dark dorsal tooth (if present), together with\r\n*typical Polypedilum mentum \r\n**1 pair of high central median teeth,\r\n**1 lower pair of lower, outer median teeth and\r\n**tall first lateral (tooth) which may however be modified in a variety of ways.\r\n\r\nThree subgenera are distinguished on imaginal characters: Polypedilum s.str., Pentapedilum Kieffer and Tripodura Townes but larval characters do not fully sustain this division. In addition Pedionemus larvae are not distinguishable from those of Polypedilum.&lt;br&gt;\r\n\r\n\r\n==Checklist China==\r\n\r\nIn China {citeID|279|Wang 2000}:&lt;br&gt;\r\n*Subgenus Cerobregma S&aelig;ther and Sundal\r\n**P.exilicaudatum S&aelig;ther and Sundal\r\n*Subgenus Pentapedilum Kieffer\r\n**P.convexum (Johannsen) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum convexum (mentum)'' width=200 title=''Polypedilum convexum (mentum) Cranston 2000a'' src=''image.php?text=image deleted: PopePe_cove_men_Cra2000a_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.sordens ({citeID|339|Wulp 1874}) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum sordens (mentum)'' width=200 title=''Polypedilum sordens (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pope_sord_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum sordens (mentum)'' width=200 title=''Polypedilum sordens (mentum) Brooks et al. 2007'' src=''image.php?text=image deleted: PopePe_sord_men_Bro2007_r.jpeg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.tritum (Walker) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum tritum (mentum)'' width=200 title=''Polypedilum tritum (mentum) Epler 2001'' src=''image.php?text=image deleted: PopePe_trim_men_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*Subgenus Polypedilum Kieffer\r\n**P.acutum Kieffer\r\n**P.albicorne (Meigen) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum albicorne (mentum)'' width=200 title=''Polypedilum albicorne (mentum) Rossaro 1985'' src=''image.php?text=image deleted: PopePo_albi_men_Ros1985_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum albicorne (mentum)'' width=200 title=''Polypedilum albicorne (mentum) Klink and Moller-Pillot 2003'' src=''image.php?text=image deleted: PopePo_albi_men_Kli2003_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.apfelbecki (Strobl) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum apfelbecki (mentum)'' width=200 title=''Polypedilum apfelbecki (mentum) Rossaro 1985'' src=''image.php?text=image deleted: PopePo_apfe_men_Ros1985_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.asakawaense Sasa\r\n**P.benokiense Sasa and Hasegawa\r\n**P.bisetosum Wang\r\n**P.fallax (?) (Johannsen) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum fallax (mentum)'' width=200 title=''Polypedilum fallax (mentum) Yan et al. 1982'' src=''image.php?text=image deleted: Pope_fall_men_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum fallax (mentum)'' width=200 title=''Polypedilum fallax (mentum) Epler 2001'' src=''image.php?text=image deleted: Pope_fall_men_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.fuscum (?) Freemann\r\n**P.henicurum  Wang\r\n**P.japonicum Tokunaga\r\n**P.illinoense (Malloch) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum illinoense (mentum)'' width=200 title=''Polypedilum illinoense (mentum) Soponis and Russell 1982'' src=''image.php?text=image deleted: Pope_illi_men_Sop1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.laetum (Meigen) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum laetum (mentum)'' width=200 title=''Polypedilum laetum (mentum) Klink and Moller-Pillot 2003'' src=''image.php?text=image deleted: PopePo_laet_men_Kli2003_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum laetum (mentum)'' width=200 title=''Polypedilum laetum (mentum) Yan et al. 1982'' src=''image.php?text=image deleted: Pope_laet_men_Yan1982_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.lichuanensis Wang\r\n**P.masudai (Tokunaga)\r\n**P.medivittatum (Tokunaga)\r\n**P.nubeculosum (Meigen) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum nubeculosum (mentum)'' width=200 title=''Polypedilum nubeculosum (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pope_nube_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum nubeculosum (mentum)'' width=200 title=''Polypedilum nubeculosum (mentum) Brooks et al. 2007'' src=''image.php?text=image deleted: PopePo_nube_men_Bro2007_r.jpeg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.nubifer (Skuse) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum nubifer (mentum)'' width=200 title=''Polypedilum nubifer (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pope_nubi_men_WCh1983_r.png 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum nubifer (mentum)'' width=200 title=''Polypedilum nubifer (mentum) Brooks et al. 2007'' src=''image.php?text=image deleted: PopePo_nubi_men_Bro2007_r.jpeg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.shanguiensis Wang\r\n**P.tamanigrum Sasa\r\n*Subgenus Tripodura Townes\r\n**P.pullum (Zetterstedt)\r\n**P.scalaenum (Schrank) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum scalaenum (mentum)'' width=200 title=''Polypedilum scalaenum (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pope_scal_men_WCh1983_r.png 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n*Subgenus Urespedilum Sasa and Kikuchi\r\n**P.convictum (Walker) {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum convictum (mentum)'' width=200 title=''Polypedilum convictum (mentum) Pinder and Reiss 1983'' src=''image.php?text=image deleted: Pope_covi_men_WCh1983_r.png 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum convictum (mentum)'' width=200 title=''Polypedilum convictum (mentum) Brooks et al. 2007'' src=''image.php?text=image deleted: PopePo_covi_men_Bro2007_r.jpeg 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n**P.cultellatum Goetghebuer {overlib|mentum|&lt;img align=''middle'' alt=''Polypedilum cultellatum (mentum)'' width=200 title=''Polypedilum cultellatum (mentum) Rossaro 1985'' src=''image.php?text=image deleted: PopeUr_cule_men_Ros1985_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;&lt;img align=''middle'' alt=''Polypedilum cultellatum (mentum)'' width=200 title=''Polypedilum cultellatum (mentum) Klink and Moller-Pillot 2003'' src=''image.php?text=image deleted: PopeUr_cule_men_Kli2003_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}\r\n\r\n', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Polypedilum as ubiquitous taxa in a lentic-lotic gradient in France.\r\n\r\nIn {textciteID|389|Cranston 2004}: &laquo;Polypedilum is the most species-rich genus of Chironominae, and is very common and diverse in tropical waters, including those of Borneo, Sumatra, Java and Bali. Polypedilum larvae are collectors gatherers, found in all kinds of water bodies, including phytotelmata. P. convexum is found in the latter habitat, including within Nepethes pitcher plants. Polypedilum watsoni is abundant in the organically-polluted reaches of the Kelian River, Kalimantan.&raquo;\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Polypedilum (Po.) nubeculosum (Meig.) &lt;!-- taxon --&gt; ||x&lt;!-- alpine --&gt; ||x&lt;!-- boreal --&gt; || || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&lt;!-- mesohumic --&gt; ||&middot;&middot;&middot;&middot;&middot; &lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n===Temperature===\r\n\r\n{textciteID|507|Brooks and Birks 2000}:\r\n*11 with significant symmetric unimodal Template:HOF:unimodal: [..] Polypedilum (groups &lang;10-12&deg;C&rang; &amp; &gt;12&deg;C)\r\n\r\n{textciteID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Polypedilum  and other taxa: 12.9&deg;C &plusmn; 0.9, n=24 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{textciteID|521|Porinchu et al. 2002} reports as warmer preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Pagastiella, Polypedilum and Tanytarsus sp. A/C are most abundant at sites with surface water temperatures in excess of 17.5&deg;C.\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica) for Polypedilum  and other taxa to find possible differences in temperature: 2000: 14.6&deg;C &plusmn; 3.8 (10.8 to 18.4), 2006: 15&deg;C &plusmn; 4.2 (10.8 to 19.2) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n===Depth===\r\n\r\n{textciteID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Polypedilum sp.  and other taxa: 5.8m &plusmn; 3 (n=22). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Polypedilum (n=33, Template:explained:N2:HillsDiversity=22.42, n&lt;sub&gt;max&lt;/sub&gt;=10.92) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 25.\r\n\r\n===Conductivity===\r\n\r\n{textciteID|502|Zhang et al. 2007} report for Polypedilum in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 1428.22mg &middot; l⁻&sup1; (&divide; 600 = 2.38mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 2.50703. In article shortened as: Po.\r\n\r\n===Acidification===\r\n\r\n{textciteID|571|Henrikson et al. 1982} report for acidified oligotrophic lakes in Sweden for Polypedilum the following data:\r\n* pH: 4.3-4.7, conductivity: 68-89 (&micro;S/cm), Elements in mg/l: Cl: 11-16, SO 4: 8.7-13, Na: 5.2-6.7, K: 0.7-1.2, Ca: 1.7-2.1, Mg: 1.2-1.5, Al: 0.1-0.6, Tot-P: 3-13 (&micro;g/l), Tot-N: 330-470 (&micro;g/l), Secci depth: 7.5-13 (m), Area: 0.3 (km&sup2;), Maximum depth: 18 (m).\r\n', '78 223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(572, 228, NULL, NULL, 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Prodiamesa as ubiquitous taxa in a lentic-lotic gradient in France.\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(573, 230, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(574, 231, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(576, 233, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(577, 234, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(578, 235, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(579, 236, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(580, 237, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(581, 238, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(582, 239, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(583, 240, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(584, 241, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(585, 242, 3, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 1.87, NULL, 1, 1.64, NULL, 1, NULL, 3.7, 0.2, NULL, 0, NULL, 4.5, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, 'don''t reaches base of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(586, 243, NULL, NULL, 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(588, 248, NULL, NULL, 0, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Clunio marinus (Diptera) as em~= &laquo;euryhaline marine taxa that have a wide affinity to salinity and tolerate salinity between 0.5 and 35%&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~0-freshwater (&lt;0.5&permil;)&lt;br&gt;~~2-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~2-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~3-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~3-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(589, 247, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(590, 246, 374, NULL, 0, 'The species is mining submerged wood apparently preferring Alnus sp., Corylus avellana in the Palaearctic and Acer sp. in the Nearctic', NULL, NULL, 5, 1.12, 0, NULL, NULL, 1, NULL, 0.16, NULL, 1, NULL, 0.93, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'very broad', 1, NULL, NULL, 1.84, NULL, 1, 16, NULL, 1, NULL, 2.5, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, NULL, 0, '1 apical 1 smooth basal', '3 scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(591, 249, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(592, 250, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(593, 251, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(594, 252, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(595, 253, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(596, 254, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(597, 255, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(598, 256, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(599, 257, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(600, 258, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(601, 259, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(602, 260, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(603, 261, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(604, 262, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(605, 263, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(606, 280, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(607, 281, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(608, 282, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(609, 331, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(610, 332, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(611, 333, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(612, 377, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(613, 378, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Krenosmittia camptophleps in Alpine running waters of 9.51&micro;S &middot; cm⁻&sup1; &plusmn;~2.11 (min-max: 4-12, n=78).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Krenosmittia camptophleps in Alpine running waters of 6.94&deg;C &plusmn;~1.8 (min-max: 2.45-9.81, n=82).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Krenosmittia camptophleps in Alpine running waters of 6.21 &plusmn;~0.42 (min-max: 4.94-6.6, n=77).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(614, 379, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*11 with significant symmetric unimodal Template:HOF:unimodal: [...] Zalutschia zalutschicola (groups &lang;8-10&deg;C&rang; &amp; 10-12&deg;C &amp; &lang;&gt;12&deg;C&rang;)\r\n\r\nZalutschia zalutschicola reported by {citeID|516|Korhola et al. 2002} as intermediate taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Zalutschia zalutschicola  and other taxa: 0&deg;C &plusmn; 0, n=26 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Zalutschia zalutschicola  and other taxa: 8.8m &plusmn; 6.7 (n=17). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(615, 380, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(616, 381, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Zalutschia lingulata pauca  and other taxa: 9.2&deg;C &plusmn; 1.1, n=26 (skewed curve Template:HOF:skewedLeft Template:HOF:skewedRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(617, 382, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(618, 392, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(619, 393, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(620, 394, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(621, 395, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(622, 396, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(623, 405, NULL, NULL, 0, '==Biotops==\r\n\r\n{textciteID|560|Malo et al. 1998}: &laquo;Microtendipes chloris (Meigen), is typical of stagnant water and lives in littoral and sublittoral zones (Pinder &amp; Reiss 1986). It was recently recorded from the Iberian Peninsula (Soriano et al. 1993) and in this study was obtained in streams influenced by reservoirs (Seda and Divor streams) and the Valverde stream.&raquo;\r\n\r\n===Temperature===\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#ff0000"&gt;warm water&lt;/span&gt; Cricotopus sp., Procladius, Chironomus anthracinus-group, Dicrotendipes, Microtendipes chloris, Polypedilum cf. nebeculosum [sic]\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(624, 414, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(625, 420, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(626, 421, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Parametriocnemus stylatus in Alpine running waters of 15.07&micro;S &middot; cm⁻&sup1; &plusmn;~25.83 (min-max: 6-246, n=66).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Parametriocnemus stylatus in Alpine running waters of 7.31&deg;C &plusmn;~1.9 (min-max: 0.3-11.2, n=93).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Parametriocnemus stylatus in Alpine running waters of 6.2 &plusmn;~0.59 (min-max: 5.27-9.2, n=63).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(627, 422, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(628, 423, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(629, 424, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(630, 425, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(631, 426, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa goetghebueri in Alpine running waters of 31.8&micro;S &middot; cm⁻&sup1; &plusmn;~92.58 (min-max: 2-474, n=28).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa goetghebueri in Alpine running waters of 3.83&deg;C &plusmn;~3.63 (min-max: 0.01-11, n=37).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa goetghebueri in Alpine running waters of 6.6 &plusmn;~1.16 (min-max: 5.11-9.4, n=28).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(632, 427, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(633, 428, NULL, '{citeID|20|Schmid 1993} reports another Diamesa steinboecki cf. &lt;a href=''chirokey.php?id_characters=643&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=438#Images'' target=''chirokey_larvae''&gt;see here&lt;/a&gt;.', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(634, 429, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa tonsa in Alpine running waters of 101.2&micro;S &middot; cm⁻&sup1; &plusmn;~59 (min-max: 11-252, n=16).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa tonsa in Alpine running waters of 7.15&deg;C &plusmn;~2.57 (min-max: 0.01-12, n=34).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa tonsa in Alpine running waters of 7.89 &plusmn;~0.38 (min-max: 7-8.9, n=14).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(635, 430, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa cinerella in Alpine running waters of 42.61&micro;S &middot; cm⁻&sup1; &plusmn;~61.65 (min-max: 4-474, n=94).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa cinerella in Alpine running waters of 3.64&deg;C &plusmn;~1.83 (min-max: 0.01-9.81, n=111).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa cinerella in Alpine running waters of 6.08 &plusmn;~1.06 (min-max: 5.05-9.4, n=88).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(636, 431, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(637, 432, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa bertrami in Alpine running waters of 11.86&micro;S &middot; cm⁻&sup1; &plusmn;~27.12 (min-max: 4-474, n=102).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa bertrami in Alpine running waters of 3.48&deg;C &plusmn;~1.29 (min-max: 0.01-9.2, n=119).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa bertrami in Alpine running waters of 6.11 &plusmn;~0.44 (min-max: 5.11-9.4, n=93).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(638, 433, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(639, 434, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(640, 435, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(641, 436, NULL, NULL, 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa zernyi in Alpine running waters of 88.26&micro;S &middot; cm⁻&sup1; &plusmn;~140.27 (min-max: 4-474, n=247).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa zernyi in Alpine running waters of 3.39&deg;C &plusmn;~2.11 (min-max: 0.01-12, n=298).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa zernyi in Alpine running waters of 7.39 &plusmn;~1.53 (min-max: 4.94-9.9, n=232).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(642, 437, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(643, 438, NULL, '{citeID|22|Makarchenko 1999} reports another Diamesa steinboecki &lt;a href=''chirokey.php?id_characters=633&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=428#Images'' target=''chirokey_larvae''&gt;see here&lt;/a&gt;.', 0, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa steinboecki in Alpine running waters of 15.89&micro;S &middot; cm⁻&sup1; &plusmn;~41.98 (min-max: 2-474, n=187). Note that these values are supposed to belog to Diamesa steinboecki cf. of {citeID|20|Schmid 1993}, because {citeID|22|Makarchenko 1999} reports another Diamesa steinboecki.\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa steinboecki in Alpine running waters of 2.68&deg;C &plusmn;~1.61 (min-max: -0.1-8.15, n=208). Note that these values are supposed to belog to Diamesa steinboecki cf. of {citeID|20|Schmid 1993}, because {citeID|22|Makarchenko 1999} reports another Diamesa steinboecki.\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa steinboecki in Alpine running waters of 5.77 &plusmn;~0.62 (min-max: 4.5-9.4, n=183). Note that these values are supposed to belog to Diamesa steinboecki cf. of {citeID|20|Schmid 1993}, because {citeID|22|Makarchenko 1999} reports another Diamesa steinboecki.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(644, 439, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(645, 440, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(646, 441, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(647, 456, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(648, 457, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(649, 458, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(650, 459, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(651, 460, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(652, 461, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(653, 462, NULL, NULL, 0, '{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos III: 5.02&ndash;5.95, IV: 4.09&ndash;4.98 with tolerances of 2.0&ndash;11.0\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(654, 463, NULL, NULL, 0, '==Euryoek==\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Some taxa, e.g. Dicrotendipes pulsus type, Pagastiella orophila and Ablabesmyia monilis type, showed very even distributions among the lakes.&raquo; [..] &laquo;Some clearly eurytopic taxa were recognised, including constantly and abundantly appearing Microtendipes pedellus type, Psectrocladius (P.) sordidellus type, Dicrotendipes pulsus type and Ablabesmyia monilis type&raquo;', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(655, 464, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(656, 468, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(657, 485, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(658, 486, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(659, 487, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(660, 488, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(661, 489, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(662, 490, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(663, 491, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(664, 493, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Endochironomus impar type, Chironomus plumosus type, Nanocladius rectinervis type [most abundant in &gt;16&deg;C], Endochironomus albipennis type, Glyptotendipes pallens type, Einfeldia pagana type and Microchironomus tener type had the highest temperature optima.&raquo;', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(665, 494, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(666, 495, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(667, 499, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(668, 500, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(669, 501, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(670, 502, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(671, 503, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(672, 504, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(673, 505, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(674, 525, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(675, 558, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(676, 561, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(678, 565, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(679, 566, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(680, 571, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Arctopelopia griseipennis in Alpine running waters of 12.13&deg;C &plusmn;~3.04 (min-max: 6-21, n=14).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(681, 1649, NULL, '==History==\r\n\r\nadded 2009-03-16 15:09:13 named wrongly from {citeID|25|Walker 2000}\r\n\r\n==Comments==\r\n\r\nA.Plank (Mon Mar 16 2009 14:36:06 GMT+0100): Corynocera oliveri''s mandible is exact the same as Tanytarsus gracilentus. Also the mentum looks similar: {overlib|oliveri|<img src=''image.php?text=Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Coce_olie_men_WCh1983_r.gif 2009-12-15 10:36:17''>} and {overlib|gracilentus|<img src=''image.php?text=Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Tany_grac_men_Paa1972_r.gif 2009-12-15 10:36:17''>}. But Tanytarsus gracilentus has a dark plate behind the mentum ({citeID|302|Brooks et al. 2007}). See also Chironomidae discussion list.\r\n\r\n{citeID|527|Velle et al. 2005} reports: &laquo;The adult of C. oliveri was first collected and described from a sub-Arctic Swedish Lapland pond at 970m above sea level ({citeID|467|Lindeberg 1970}) and the tentatively associated larva was described by {citeID|469|Hofmann 1984}. The environmental preferences for C. oliveri are poorly known and it was only found in two of 153 lakes in the Norwegian calibration set. At RAT, BRU, and OYK where the early Holocene peak of C. oliveri type is most pronounced [..], the concurrent maximum abundance of charophytes ({citeID|528|Bjune 2004}; {citeID|529|Velle et al. 2005b}) suggest that C. oliveri type may be positively influenced by charophytes, like its congener C. ambigua ({citeID|530|Brodersen and Lindegaard 1999}; {citeID|531|Walker and Mathewes 1988}).&raquo;', 0, '{citeID|504|Bigler et al. 2003}: Template:explained:LOI at 550℃ 10-18% during 8,200-9,000cal. yrs BP\r\n\r\n==Temperature==\r\n\r\nAs cool-water chironomids {citeID|535|Birks et al. 2000} reports: Heterotrissocladius grimshawi, Micropsectra radialis, and Corynocera oliveri/Tanytarsus lugens.\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*5 statistically significant (sigmoidal Template:HOF:sigmoidalNotUpperLeft Template:HOF:sigmoidalUpperLeft) thus optima beyond sampled 5.7 &deg;C: Heterotrissocladius subpilosus, Micropsectra radialis, Tanytarsina group B, Tanytarsus lugens/Corynocera oliveri, and unidentified Tanytarsini\r\n*&lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Corynocera oliveri  and other taxa: 0&deg;C &plusmn; 0, n=46 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|526|Hofmann 2001} reports as cold-stenothermal taxa Heterotrissocladius sp., Paracladius sp., Orthocladius consobrinus, and Corynocera oliveri.\r\n\r\n{citeID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C. [..] C. oliveri has been associated with cold, northern lakes and ponds ({citeID|4|Oliver and Roussel 1983}; {citeID|517|Olander et al. 1999}; {citeID|523|Porinchu and Cwynar 2000}). Another study found that coastal, upper subalpine lakes and ponds of British Columbia are dominated by head capsules resembling those attributed in {citeID|2|Pinder and Reiss 1983} to C. oliveri ({citeID|524|Walker and Mathewes 1989}). Moreover, it has been suggested Corynocera spp. can serve as a proxy for climate, with C. oliveri indicative of cold conditions and C. ambigua suggestive of warmer climatic conditions ({citeID|520|Porinchu and Cwynar 2002}).\r\n\r\n{citeID|505|Gandouin and Franquet 2002}: &laquo;Zone A [12895&plusmn;250~- 14284.5&plusmn;844.5 cal. age BP] presents a similar trend in sub-zones ChZ-1 and ChZ-3, with a progressive increase in the temperature of the surface waters shown by decreases in the percentage of the cold stenothermic Tanytarsus lugens/Corynocera oliveri grp. ({citeID|506|Lotter et al. 1997} [`T.lugens&acute;]; {citeID|507|Brooks and Birks 2000}).&raquo;\r\n\r\nCorynocera oliveri reported by {citeID|516|Korhola et al. 2002} as cold adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n\r\n{citeID|511|Brooks 2006}:\r\n*&laquo;[..] ultra-cold stenothermic oligotrophes than in the Latedevensian, especially Diamesinae, Paracladius, Corynocera oliveri type and Micropsectra radialis type.&raquo;\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for:\r\n*Tanytarsus lugens/Corynocera oliveri type  and other taxa to find possible differences in temperature: 2000: 11.9&deg;C &plusmn; 4.5 (7.4 to 16.5), 2006: 11.6&deg;C &plusmn; 4.8 (6.8 to 16.4) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n*Corynocera oliveri  and other taxa to find possible differences in temperature: 2000: 9.3&deg;C &plusmn; 4.6 (4.7 to 14), 2006: 10.6&deg;C &plusmn; 5 (5.6 to 15.6) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n\r\n{citeID|534|Luoto 2009} states: &laquo;Among the chironomids, Micropsectra radialis type, Heterotrissocladius maeaeri type and Corynocera oliveri type, for example, were restricted to the northern and cold lakes, while Microchironomus tener type and Einfeldia pagna type were restricted to the warmest lakes.&raquo;\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Corynocera oliveri  and other taxa: 9.4m &plusmn; 6.3 (n=9). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Organic content==\r\n\r\n{citeID|527|Velle et al. 2005a} reports a reduced Template:explained:LOI of 5-10% when C.oliveri was found more abundant in a sediment core from R&aring;t&aring;sj&oslash;en, a lowalpine lake in central Norway.\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Corynocera nr. oliveri (n=23, Template:explained:N2:HillsDiversity=14.02, n&lt;sub&gt;max&lt;/sub&gt;=13.48) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 10.\r\n\r\n==Conductivity==\r\n\r\n{citeID|502|Zhang et al. 2007} report for Corynocera oliveri in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 3514.36mg &middot; l⁻&sup1; (&divide; 600 = 5.86mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 10.3079. In article shortened as: Co. Note that these data may probably contain also Tanytarsus gracilentus.\r\n\r\n\r\n==Holocene History==\r\n\r\n{citeID|527|Velle et al. 2005a} reports: &laquo;Overall, it appears that each lake has its own unique chironomid ontogeny and, apart from the early Holocene occurrence of C. oliveri and C. anthracinus type, there is no clear pattern ofamon g-lake chironomid succession. Similar results were found by {citeID|532|Brooks 2000} in a study of Late glacial chironomid assemblages along an altitudinal transect of lakes in the Swiss Alps.&raquo;', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(682, 573, NULL, NULL, 0, '==Temperature==\r\n\r\nCorynocera ambigua reported by {citeID|516|Korhola et al. 2002} as intermediate taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Corynocera ambigua  and other taxa: 10.4&deg;C &plusmn; 2.5, n=59 (skewed curve Template:HOF:skewedLeft Template:HOF:skewedRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|520|Porinchu and Cwynar 2002} report Microtendipes and Corynocera ambigua as temperate taxa.\r\n\r\n{citeID|512|Bunbury and Gajewski 2008} compared 2 years from a dataset in Yukon (Northamerica)  for Corynocera ambigua  and other taxa to find possible differences in temperature: 2000: 12.4&deg;C &plusmn; 6 (6.4 to 18.4), 2006: 12.5&deg;C &plusmn; 5.4 (7.2 to 17.9) &lt;a href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#sortone'' target=''chirokey_larvae''&gt;see here fore details&lt;/a&gt;.\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type, Micropsectra insignilobus type, Protanypus, Tanytarsus lugens type, Hydrobaenus, Heterotrissocladius grimshawi type, Corynocera ambigua [most abundant in &lt;13&deg;C to 16&deg;C] and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Corynocera ambigua  and other taxa: 7.7m &plusmn; 5.4 (n=34). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(683, 574, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(684, 575, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(685, 576, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(686, 577, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(687, 578, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(688, 595, NULL, NULL, 0, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with  II: 8.05&ndash;8.65.\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(689, 596, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(690, 597, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(691, 609, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(692, 610, NULL, NULL, 0, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Prodiamesa olivacea in Alpine running waters of 4.04&deg;C &plusmn;~3.9 (min-max: 0.3-10, n=12).\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Prodiamesa olivacea (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(693, 611, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(694, 612, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(695, 613, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(696, 616, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(697, 617, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(698, 618, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(699, 619, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(700, 653, 21, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, 'long', 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5.5, NULL, NULL, 0, NULL, 3, 1, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, NULL, 0, 'broad with faint indication of bifid apex', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 9.9, NULL, NULL),
(701, 695, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(702, 696, 21, NULL, 0, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina\r\n', NULL, NULL, 5, 2.44, 0, NULL, 0.1, 1, NULL, 0.14, 0.05, 1, NULL, 0.86, 0.1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'paler', 6, NULL, NULL, 5, 0.2, 1, 3.7, 0.2, 1, NULL, 3.5, NULL, NULL, 1, NULL, 4, 1, 0, 0, 'apical toth = width of 4 inner teeth', 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'reaches basis of 2nd inner tooth', NULL, NULL, 'no', NULL, 2, NULL, 1, NULL, 1, NULL, NULL, 3.0, NULL, NULL, NULL, 1, '2 apical and 1 basal; in Schmid 1993 mentioned as brushed premandible', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 9.0, NULL, NULL),
(703, 697, 42, NULL, 0, NULL, NULL, NULL, NULL, 1.95, 0, NULL, 0.1, 1, NULL, 0.16, 0.1, 1, NULL, 0.81, 0.1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'very broad', 6, NULL, NULL, 6, 0.5, 1, 5.1, 0.5, 1, NULL, NULL, NULL, 'not drawn', 1, NULL, 4, 1, 0, 0, 'apical slightly shorter than width of 4 inner teeth', 0, NULL, NULL, NULL, NULL, NULL, 1, '7 branches', 0, 'not drawn', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(704, 698, 20, NULL, 0, 'occoured in sandy (grain size > 2mm) sediment surface (0-10cm) of the river Danube (1994 km)', NULL, NULL, 5, 2.476, 0, NULL, 0.141, 6, NULL, 0.15, NULL, 1, NULL, 0.94, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.279, 0.049, 4, NULL, NULL, NULL, NULL, NULL, 1, 'pale', 6, NULL, NULL, 3.23, 0.2, 1, 4.34, 0.2, 1, NULL, 3, NULL, NULL, 1, NULL, 3.5, 1, 0, 0, 'langth of apical tooth = width of 3 inner teeth ', 0, NULL, NULL, NULL, NULL, NULL, 1, '4-6 branches', 1, 'reaches nearly middle of 1st inner 0.5 tooth', NULL, NULL, 'no', 'no', 1.8, 'inner shorter', NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(705, 707, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(706, 708, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(707, 709, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(708, 713, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(709, 714, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(710, 715, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(711, 716, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(712, 721, NULL, '{citeID|294|Wang 1994}: &laquo;Larva {pale yellow}, 6.2mm, antenna 0.5&times;head segement 28&times;long as wide, blade shorter than flagellum. [..] 22-III-1984, Lishui River, Hunan province. Collected by Wang Shida.&raquo; [no ecology given]\r\n\r\n\r\n{| style=&#039;border:1px solid;&#039; class=&#039;sortable&#039; id=&#039;sortone&#039;\r\n\r\n|-\r\n&lt;!-- table head --&gt;\r\n!|Reference\r\n!|Taxon\r\n!im90|Head: length\r\n!im90|Antenna: segments\r\n!im90|Antenna: length 1\r\n!im90|Antenna: length 2-5\r\n!im90|Body: supra anal setae\r\n!im90|Literature\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|545|Vallenduuk and Moller-Pillot 2007}&lt;!-- Reference --&gt;\r\n|C. melanops&lt;!-- Taxon --&gt;\r\n|750-920&lt;!-- Head length --&gt;\r\n|5&lt;!-- Antenna: segments --&gt;\r\n|300&lt;!-- Antenna: length 1 --&gt;\r\n|60&lt;!-- Antenna: length 2-5 --&gt;\r\n|620-720&lt;!-- Body: supra anal setae --&gt;\r\n|&lt;!-- Literature --&gt;\r\n\r\n|}', 0, '{citeID|544|Sp&auml;nhoff et al. 2005}: &laquo;Abiotic parameters at the two sampling sites of the M&uuml;hlenbach in Ladbergen [[http://maps.google.de/maps?hl=de&amp;q=52%C2%B07+38+N,+7%C2%B052+48+E&amp;lr=&amp;ie=UTF8&amp;ll=52.127218,7.88003&amp;spn=0.034566,0.071411&amp;t=h&amp;z=14&amp;iwloc=A [Germany Google Maps]]] adapted from Aschemeier 1996.&raquo;\r\n\r\n{|\r\n|-\r\n!|Measured variable\r\n!|Headwater\r\n!|Mid-reach\r\n|-\r\n|Conductivity &micro;s&middot;cm⁻&sup1;\r\n|464-545\r\n|582-660\r\n|-\r\n|pH                           \r\n|6.3-7.4       \r\n|7.5-7.9\r\n|-\r\n|Oxygen content mg&middot;l⁻&sup1;        \r\n|4.7-10.2      \r\n|7.3-11.8\r\n|-\r\n|Oxygen saturation %          \r\n|46.0-83.3     \r\n|75.7-92.5\r\n|-\r\n|Ammonium mg&middot;l⁻&sup1;              \r\n|0.113-0.965   \r\n|0.059-0.205\r\n|-\r\n|Nitrite mg&middot;l⁻&sup1;               \r\n|0.013-0.184   \r\n|0.038-0.105\r\n|-\r\n|Nitrate mg&middot;l⁻&sup1;               \r\n|4.36-13.97    \r\n|5.63-11.94\r\n|-\r\n|Phosphate mg&middot;l⁻&sup1;             \r\n|0.005-0.021   \r\n|0.007-0.079\r\n|-\r\n|Mean discharge l&middot;s⁻&sup1;         \r\n|ca. 10        \r\n|ca. 300\r\n|-\r\n|Stream width m               \r\n|1-1.5         \r\n|3.5-5\r\n|}\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Conchapelopia melanops (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n\r\nSalinity in g Cl/l from {citeID|545|Vallenduuk and Moller-Pillot 2007}:\r\n{| style=&#039;border:1px solid;&#039; \r\n\r\n|-\r\n!| Reference\r\n!|Taxon\r\n!|&lt;0.3\r\n!|0.3-1\r\n!|1-3\r\n!|3-10\r\n!|&gt;10\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|545|Vallenduuk and Moller-Pillot 2007}\r\n|C. melanops &lt;!-- Taxon --&gt;\r\n|10\r\n|0\r\n|0\r\n|0\r\n|0\r\n\r\n|}', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(713, 725, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(714, 726, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(715, 749, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(716, 750, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(717, 758, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(719, 1429, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(720, 1430, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(725, 1431, NULL, 'in China ({citeID|279|Wang 2000}):&lt;br&gt;\r\n*G.sp. (male)\r\n\r\nComments from {citeID|2|Pinder and Reiss 1983}&lt;br&gt;\r\nThe diagnosis is based on the 1 species known as larva, G. alboviridis (Malloch), first described in {citeID|26|S&aelig;ther 1977}. This larvae differs from other Chironomini in the combination of \r\n*broad, pale median mental tooth flanked by several pairs of obliquely sloping, darker lateral teeth, \r\n*small scale-like pecten epipharyngis, \r\n*weakly divided into 3 shallow lobes and \r\n*premandible with 6 slender teeth progressively diminishing in size proximally.&lt;br&gt;\r\n{citeID|302|Brooks et.al. 2007}: Gillotia most closely resembles Cryptochironomus from which it can be distinguished by the short, narrow outer teeth on the mentum. In Cryptochironomus the outer tooth is subequal in length to the other lateral teeth but broad and notched apically.', 1, NULL, '33 37', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(726, 1432, NULL, 'in China Gillotia sp.', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(727, 1433, NULL, '27°0.3''N 88°18''E 2042 asl. {citeID|273|Hazra et.al. 1998}', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(729, 1434, NULL, '27°0.3''''N 88°18''''E 2042 asl. {citeID|273|Hazra et.al. 1998}', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(730, 1435, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*P.gaedii (Meigen) male, female\r\n*P.longimana (Kieffer) male, female\r\n*P.sp male, female', 1, NULL, '163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(731, 1436, NULL, NULL, 0, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Potthastia longimana-Gr. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(732, 1437, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(733, 1438, NULL, 'not in China but in [[http://insects.ummz.lsa.umich.edu/~ethanbr/chiro/chklists/RussianEast.htm Checklist of the Russian Far East 2000]]', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(734, 1440, NULL, 'DIAGNOSIS ({citeID|6|Epler 2001}): Distinguished by the \r\n*long basal segment of S II\r\n*pecten epipharyngis of 2 plates\r\n*6 segmented antennae, with alternate Lauterborn organs on the apices of segments 2 and 3\r\n*distinctive mentum with broad, pale median tooth\r\n*wide ventromental plates with coarse striae and \r\n*mandible without a dorsal tooth\r\n\r\nNOTES ({citeID|6|Epler 2001}): One species, P. nigrohalteralis, is known from North America. Hudson et al. 1990 noted an undescribed species based on an adult collected from Lake Norman in North Carolina, but the specimen was not available for examination. Note that Paralauterborniella in {citeID|2|Pinder and Reiss 1983} includes two species that were returned to Apedilum by {citeID|289|Epler 1988}, the genus in which they were originally described by {citeID|291|Townes 1945}. Although {citeID|2|Pinder and Reiss 1983} described the S2 as simple, it is fringed.<br>\r\n\r\nNot mentioned in China ({citeID|279|Wang 2000}), but included in the key of {citeID|22|Makarchenko 1999}.', 1, '==Biotops==\r\n\r\n{textciteID|557|Gandouin et al. 2006} classifies Paralauterborniella as ubiquitous taxa in a lentic-lotic gradient in France.\r\n\r\n{textciteID|6|Epler 2001}: Larvae usually occur in streams and rivers, but have been found in lakes.\r\n', '152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(735, 1441, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(739, 1443, NULL, '', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(740, 1444, NULL, '==Systematic Note==\r\n\r\nFor {textciteID|393|Moller-Pillot 1990} P. inopertus and P. confusus are not reliable as differable taxa. He recommends therefore P. dissimilis agg.\r\n', 0, '==Biotops==\r\n\r\nIn {textciteID|557|Gandouin et al. 2006} Paratanytarsus dissimilis plots as ubiquitous-lentic taxon in a lentic-lotic gradient in France.\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'width~length', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'yellow', 'small', 'dark, well developed', NULL, 1, 'seems to be round; vertical stripes', 5, 'decreasing in size, brown teeth, below: pattern with dark brown tooth-base-wide lobes curving to the middle tooth', 'in contact to each other', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'inervation: ventromental root | 1x porus-width > < 1x porus-width |', 1, NULL, 3, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3 hooks on inner margin, 2 basal and 1 near teh first inner teeth', 1, '4 branches well developed', 0, 'no', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.0, NULL, NULL, NULL, 2, NULL, '5 fingerlike lobes', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(741, 1506, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(742, 1507, NULL, 'Not mentioned in China ({citeID|279|Wang 2000}). See {citeID|392|Roback 1975} for larva of S.coffmani (Roback 1957).\r\n\r\n', 1, NULL, '119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(743, 579, 7, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(749, 1510, 7, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(750, 1512, 7, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(751, 1513, 7, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(752, 1534, NULL, '==Comments==\r\n\r\nComments fronm {citeID|6|Epler 2001}: The mentum, with teeth almost completely coverd by the ventromentum; and the posteriorly displaced setae submenti will distinguish this genus.&lt;br&gt;&lt;img align=''middle'' alt=''Pagastia sp (head setation ventral)''  title=''Pagastia sp (head setation ventral) Epler 2001'' src=''image.php?text=image deleted: Pags_spec_hev_Epl2001_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;\r\n\r\n==Key==\r\n\r\nLarvae of 4th instar ({citeID|321|Makarchenko and Makarchenko 2000}):\r\n#~\r\n##Head capsule with {overlib|dark markings|&lt;img align=''middle'' width=150 title=''Pagastia sp. 1 (head dorsal) Makarchenko and Makarchenko 2000'' src=''image.php?text=image deleted: Pags_spec1_hds_Mak2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt; &lt;img align=''middle'' width=100 title=''Pagastia sp. 1 (head lateral) Makarchenko and Makarchenko 2000'' src=''image.php?text=image deleted: Pags_spec1_hel_Mak2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} -&gt; 2\r\n##Head capsule without dark markings -&gt; 3\r\n#~\r\n##Middle tooth of mentum {overlib|with several apexes|&lt;img align=''middle'' width=200 title=''Pagastia sp. 1 (mentum) Makarchenko and Makarchenko 2000'' src=''image.php?text=image deleted: Pags_spec1_men_Mak2000_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} -&gt; Pagastia (P.) sp. 1 (Palaearctic)\r\n##Middle tooth of mentum simple -&gt; P. (P.) nivis (Tokunaga, 1936), P. (P.) partica (Roback, 1957)\r\n#~\r\n##AR &gt; {overlib|1.6|&lt;img align=''middle'' width=60 title=''Pagastia orientalis (antenna) Makarchenko 1999'' src=''image.php?text=image deleted: Pags_orie_ant_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} -&gt; 4\r\n##AR &lt; {overlib|1.2|&lt;img align=''middle'' width=60 title=''Pagastia lanceolata (antenna) Makarchenko 1999'' src=''image.php?text=image deleted: Pags_lanc_ant_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} -&gt;  P. (P.) lanceolata (Tokunaga, 1936), P. (P.) orthogonia Oliver, 1959\r\n#~\r\n##Apical tooth of {overlib|mandible shorter than combined width of inner teeth|&lt;img align=''middle'' width=100 title=''Pagastia orientalis (mandible) Makarchenko 1999'' src=''image.php?text=image deleted: Pags_orie_man_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;} -&gt;  P. (P.) orientalis (Tshemovskij, 1949), P. (P.) altaica Makarchenko, Kerkis, Ivanchenko, 1997\r\n##Apical tooth of mandible longer than combined width of inner teeth -&gt; P. (H.) sequax (Garrett, 1925)\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*P.lanceolata (Tokunaga)\r\n*P.orientalis (Tshernovskij)', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(753, 1562, NULL, NULL, 0, '{citeID|352|Makarchenko 2005}: Kedrovaya Pad Nature reserve in southern part of Primorye Territory of the Russian far east, H2O Temp: 14&deg;C at collection time, collected on small-medium sized stones covered with green algae.', NULL, NULL, NULL, 1.585, NULL, NULL, 0.83, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0.005, 5, NULL, 'light yellow', NULL, NULL, NULL, 1, '4.7-5.0 width of lateral tooth', 7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, 2, 0, 0, 'dark brown or black in distal part', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 6.0, 6, 7, NULL, 0, 'brown to light brown', NULL, NULL, NULL, NULL, 'dark brown', 1.16, 7, NULL, 2, 'dark brown 208-232µm long', NULL, NULL, 7.4, 6.8, NULL, 5),
(754, 1563, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(755, 1564, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(756, 1565, 356, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.28, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL, NULL, 2, 2, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.9, 1),
(757, 1570, 21, NULL, 0, NULL, NULL, NULL, 4, 0.58, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'little apex in middle', NULL, '5', NULL, 1.76, NULL, 1, 2.88, NULL, 1, NULL, 1.5, NULL, NULL, 0, NULL, 3, 2, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(758, 1423, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(759, 1502, 21, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(760, 1579, 325, NULL, 0, 'in ''Aufwuchs'' from rivers, brooks; Kaukasus, Jugoslawia (Donau)', NULL, NULL, NULL, 1.41, NULL, NULL, NULL, 1, NULL, 0.08, NULL, 1, NULL, 0.805, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 4, NULL, NULL, 2, NULL, 1, 3.16, 0.2, 2, NULL, 4, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5.0, 6.0, 5.5, NULL),
(761, 1581, 325, NULL, 0, 'Alps in karst brooks', NULL, NULL, 5, 1.4, NULL, NULL, NULL, 1, '4th  > 3rd', 0.135, NULL, 1, NULL, 0.57, NULL, 1, NULL, NULL, NULL, 0, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 'brown', NULL, NULL, NULL, 2, NULL, 5, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 3, 1, 0, 0, '3 spines on inner margin', NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'palely purple', NULL, NULL, 3.0, NULL),
(762, 1493, 294, NULL, 0, NULL, NULL, NULL, 4, 0.61, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'in middle little apex', 5, NULL, NULL, 1.79, NULL, 1, 2.25, NULL, 1, NULL, 1, NULL, NULL, 0, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(763, 1538, 324, NULL, 0, NULL, NULL, NULL, 5, 1.44, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.9, 0.1, 1, 2.25, NULL, 1, NULL, 4.5, NULL, NULL, 0, NULL, 3, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, 'reaches middle of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(764, 1554, 343, NULL, 0, NULL, NULL, NULL, 5, 2.69, NULL, NULL, NULL, 1, NULL, 0.23, NULL, 1, NULL, 1.25, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'lower than 1st lateral', 6, NULL, NULL, 1.6, NULL, NULL, 0.85, NULL, NULL, NULL, NULL, NULL, '? not drawn', NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.7, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '3 long scales', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(765, 238, 21, 'rivulorum like', 0, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'broad', 8, NULL, NULL, 2.65, NULL, 1, 6.53, NULL, 1, NULL, 0.5, NULL, NULL, 0, NULL, 3.5, 2, 0, 0, 'very long apical tooth, longer than combined 3 inner; mandible belongs to this rivulorum-like mentum?', 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches base of 2nd inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(766, 242, 21, 'not rivulorum like; mandible belongs to this speciemen? see man_notes', 0, NULL, NULL, NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 'lower than laterals', 7, NULL, NULL, 2, NULL, 1, 1.17, NULL, 1, NULL, 4.9, 0.1, NULL, NULL, NULL, 3.5, 2, 0, 0, 'very long apical tooth, longer than combined 3 inner; mandible belongs to this rivulorum-like mentum?', 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches base of 2nd inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(767, 1582, 20, NULL, 0, '{citeID|20|Schmid 1993}: frequently occoured in bed sediments (0-10cm) of nearly all studied running water bodies [rivers and brooks].\r\n\r\n==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Paratrichocladius rufiventris in Alpine running waters of 100.12&micro;S &middot; cm⁻&sup1; &plusmn;~133.46 (min-max: 9-425, n=23).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Paratrichocladius rufiventris in Alpine running waters of 5.97&deg;C &plusmn;~3.03 (min-max: 1.6-12, n=28).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Paratrichocladius rufiventris in Alpine running waters of 7.14 &plusmn;~1.37 (min-max: 5.11-9.1, n=22).\r\n', NULL, NULL, 5, 1.259, 0, NULL, 0.134, 15, NULL, 0.2, NULL, 1, NULL, 0.83, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.247, 0.153, 15, NULL, 'yellow to light brown, instar II and III dark brown', NULL, 'pale', NULL, 1, NULL, 6, '2nd pair smaller than 1st and 3rd lateral', NULL, 2.06, NULL, 1, 2.45, 0.15, 15, NULL, 4.7, 0.3, NULL, 0, NULL, 3.5, 2, 0, 0, 'apical narrower and shorter than 1st inner', 0.5, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'peg-like with a row of toothlets at the base', NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(768, 1583, 20, NULL, 0, 'larvae were found in hight densities in the  surface of the bed sediments (0-20cm) of rivers and brooks', NULL, NULL, 5, 1.559, 0, NULL, 0.099, 8, NULL, 0.12, NULL, 1, NULL, 0.69, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.272, 0.143, 8, NULL, 'yellow with slightly darkened posterior-dorsal part; in instar II + III brown', NULL, 'black', NULL, 1, NULL, 6, '2nd pair smaller than 1st and 3rd', NULL, 1.31, NULL, 1, 1.7, 0.3, 8, NULL, 4.5, NULL, NULL, 0, NULL, 3.5, 1, 0, 0, '3rd inner tooth (next to apical) braoder than apical', 0, NULL, NULL, NULL, NULL, NULL, 1, '5-6 weakly  serrated branches', 1, 'toothlets at the base', NULL, NULL, NULL, NULL, 1, 'lateral serrated', 1, NULL, 1, NULL, 'between bases of S1 a row of 4-5 minute setae', 1.0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(769, 1584, 20, NULL, 0, 'larvae have been occaisionally found in the upper reaches of brooks in the surface layer of the bed sediments (0-10cm)', NULL, NULL, 5, 1.765, 0, NULL, 0.092, 5, NULL, 0.1, NULL, 1, NULL, 0.83, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.143, 0.155, 5, NULL, 'yellow', NULL, 'dark brown', NULL, 1, NULL, 6, '2nd pair smaller than 1st and 3rd', NULL, 1.7, NULL, 1, 1.95, 0.25, 5, NULL, 4.5, NULL, NULL, 0, NULL, 4, 2, 0, 0, '4th inner tooth broader than apical', 0, NULL, NULL, NULL, NULL, NULL, 1, '6 branches', 1, 'toothlets at the base', NULL, NULL, NULL, NULL, 2, NULL, 1, NULL, NULL, NULL, NULL, 1.0, NULL, NULL, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(770, 1585, 6, 'O. (O.) vaillanti - Caldwell (1999) recently described the larva and adult male of this species, known\npreviously only from the Palaearctic as a pupa (Langton & Cranston 1991). Very similar to O.\nfrigidus, but apparently separable by the more rugose outer margin of the mandible of O. frigidus\n(smooth in vaillanti). See also O. frigidus above. I have also examined associations of an undescribed\nOrthocladius species from Ohio that will run to O. vallainti in the key above; however, this\nlarva has bifid premandibles and the pupa has a ?normal? Orthocladius thoracic horn, not the type\nseen in O. vaillanti or O. frigidus. Refer to this undescribed species as O. sp. ?Ohio?. [C/O sp. 64]', 0, NULL, NULL, NULL, 5, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, 6, NULL, NULL, 2.64, NULL, 1, 2.23, NULL, 1, NULL, 5.8, 0.1, NULL, 0, NULL, 4, 1, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 0, NULL, 1, 'reaches basis of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(771, 1586, 374, NULL, 0, 'collected by from lakes and rivers all over Norway', NULL, NULL, 5, 1.9, 0, NULL, 0.1, 11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2.261, 0.178, 11, NULL, 'brown', NULL, NULL, NULL, 1, 'brownish, black mentum', 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 6, NULL, NULL, 0, NULL, 3, 2, 0, 0, NULL, 0.5, NULL, NULL, NULL, NULL, NULL, 1, '7 branches', 1, 'reaches 1st inner tooth', NULL, NULL, 'present but weak', NULL, 1.5, NULL, 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, NULL, 1, 'weak brush', '3 fused scales', NULL, NULL, '6-9 setae: 152µm (105-300, n=8)', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 3.3, 4.3, 3.7, 4),
(772, 1587, 377, '\n', 0, 'The egg mass from Borken was collected in the pelagial zone,\nfrom ?oating blue-green algae (Nostoc spec.). Freshly hatched larvae showed\npositive phototactic reactions. The guts of slide-mounted larvae are ?lled mostly\nwith pennate diatoms, and to a lesser extent with ?lamentous algae, presumably\nNostoc spec. The larvae developed well in algal material from the sampling site,\nwithout any soil added to the culture vessel. The species is assumed to be an algae\nfeeder living between ?lamentous algae in lentic waters. The larvae developed at 20°C\n(long-day conditions) in about 3 weeks. The species is therefore potentially multi-\nvoltine. Altogether, ?ve males of Orthocladius holsatus were caught in emergence\ntraps from the litoral zone of lake Borken in May (2 males), July (2 males), and August\n(1 male), 1997 (Bohle et al. 1998). The species is assumed to be eurythermous.\n', NULL, NULL, 5, 2.1, 0, NULL, 0.15, 4, NULL, 0.14, NULL, 1, NULL, 0.855, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.123, NULL, 2, NULL, 'pale yellow', NULL, 'brown', NULL, 1, NULL, 6, NULL, NULL, 3.11, NULL, 1, 5.23, 1.2, 4, NULL, 3, 0.5, NULL, 0, 'very narrow', 3, 2, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, '6-7 branches', 1, 'reaching basis of 1st inner tooth', 'about 7 sensilla of which one is 2- or 3-segmented', '6-7 lacinial chaetae', NULL, NULL, 1.5, 'inner shorter', 1, NULL, 1, NULL, NULL, 1.0, NULL, NULL, 2, 0, 'brown', NULL, NULL, 'hooks of anterior and posterior parapods, anal setae, and caudal side of procercus brown', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'yellow greyish', 3.6, 5.1, 4.3, 6),
(773, 1589, 377, '\n', 0, 'see {citeID|378|Thienemann 1942}', NULL, NULL, 6, 1.63, 0, NULL, NULL, 1, NULL, 0.21, NULL, 1, NULL, 1.12, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'at least in one specimen a minuite 6th segment (1.3µm long) observed', NULL, NULL, NULL, 'In addition to the characters of head capsule mentioned for Orthocladius holsatus, two light pores on each side of midline on postoccipital margin present', 'pale yellow', NULL, 'brown', NULL, 1, NULL, 6, NULL, NULL, 4.52, NULL, 1, 3.89, NULL, 1, NULL, NULL, NULL, 'not drawn', 0, NULL, 3.5, 2, 0, 0, NULL, 0, NULL, NULL, NULL, NULL, NULL, 1, NULL, 1, 'reaches middle of 1st inner tooth', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'neither drawn nor some text given', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5.4, 6.3, 6.0, 2),
(774, 1588, 374, 'Althought the larvae have single L4 setae the species otherwise appears very simmilar to O.(S.)holsatus. Cranston and Oliver (1988) showed that some populations also of O.(S.)lignicola may have simple L4 setae.', 0, 'in a river western Norway', NULL, NULL, 5, 1.42, 1, NULL, NULL, 1, NULL, 0.31, NULL, 1, NULL, 1.27, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.923, 0.045, 6, NULL, 'black', NULL, 'black', NULL, 1, NULL, 6, NULL, NULL, 2.08, NULL, 1, 6, NULL, 1, NULL, 4.5, NULL, NULL, 0, NULL, 3, 2, 0, 0, 'apical half black', 0, NULL, NULL, NULL, NULL, NULL, 1, '5 branches', 1, 'reaches basis of 1st inner tooth', NULL, NULL, 'relatively distinct', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1.0, NULL, 0, 1, 1, 'brush: a view points', NULL, NULL, NULL, NULL, NULL, 1.241, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(775, 1590, 22, 'Note the 4 teeth on {overlib|premandible|<img src=''image.php?text=Image reduced version. Deleted: Serg_love-_pre_Tsa1999_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Serg_love-_pre_Tsa1999_r.gif 2009-12-15 10:36:17''>} in contrast to {overlib|S.coracina|<img src=''image.php?text=Image reduced version. Deleted: Serg_cora_lab_WCh1983_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Serg_cora_lab_WCh1983_r.gif 2009-12-15 10:36:17''>}.', 0, '==Temperature==\r\n\r\n{citeID|549|Larocque 2008}: &laquo;Taxa only found in warm lakes were Sergentialongiventris, Lauterborniella, Corynoneura type 2, Pseudorthocladius and Potypedilum.&raquo; [&gt; 15&deg;C]\r\n\r\n{textciteID|302|Brooks et al. 2007}: &laquo;S.longiventris is thermophilic and occours in the profundal of dystrophic lakes ({citeID|241|Brundin 1949}, {citeID|567|Brodin 1986})&raquo;\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|Reference\r\n!im90|flow rat (m/s)\r\n!im0|avg. gravel''s diameter (mm)\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|548|Leman and Chebanova 2005}\r\n|0.34, 0.18&lt;!-- flow rat (m/s)--&gt;\r\n|10.7, 9.5&lt;!-- avg. gravel''s diameter (mm) --&gt;\r\n\r\n|}\r\n', NULL, NULL, NULL, 1.23, 0, NULL, NULL, 1, NULL, 0.23, NULL, 1, NULL, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not drawn', 0, NULL, 4, 2, 1, 0, 'not drawn', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not drawn', NULL, 'not drawn', NULL, NULL, NULL, 4.0, NULL, NULL, NULL, NULL, 'brush not drawn', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(776, 1599, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(777, 1607, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*S.impectinata {citeID|400|S&aelig;ther and Wang 1993}\r\n', 1, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(778, 1609, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(779, 1610, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(780, 1611, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(781, 1612, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(782, 1613, NULL, '==Systematic notes==\r\n\r\n{citeID|411|Kobayashi 1994} summarize, that N.longistyla {citeID|413|Kawai 1991} is the valid name for Pseudobrillia komorii {citeID|412|Niitsuma 1991}.\r\n\r\n==Checklist==\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*N.longistyla {citeID|413|Kawai 1991}', 1, NULL, '208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(783, 1615, NULL, 'Adults are described in {citeID|414|Wang and S&aelig;ther 1997}. In China ({citeID|279|Wang 2000}):\r\n*Q.lii {citeID|414|Wang and S&aelig;ther 1997} male', 1, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(784, 1616, NULL, 'Adults described in {citeID|415|Wang and S&aelig;ther 2002}.', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(785, 1617, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*S.endocladiae (Tokunaga) male female\r\n\r\n{nociteID|416|Cranston and Dimitriadis 2005}', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(786, 1618, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*T.cladopsila Wang male\r\n*T.multiannulata (Tokunaga) male female', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(787, 1619, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(788, 1620, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*B.motoharui Tokunaga male female', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(789, 1621, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*S.sp male female', 1, '==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Stempellinella sp.  and other taxa: 9.4m &plusmn; 7.1 (n=19). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Temperature==\r\n\r\nStempellinella sp. reported by {citeID|516|Korhola et al. 2002} as cold adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Stempelinella (n=17, Template:explained:N2:HillsDiversity=14.09, n&lt;sub&gt;max&lt;/sub&gt;=3.36) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 6.\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Stempellinella sp. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(790, 1622, NULL, '{nociteID|400|S&aelig;ther and Wang 1993}\r\n\r\nIn China ({citeID|279|Wang 2000}):\r\n*Z.plauta male', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(791, 1623, NULL, 'In China ({citeID|279|Wang 2000}):\r\n*X.aequipedes {citeID|400|S&aelig;ther and Wang 1993} male\r\n', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(834, 1442, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(797, 1450, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(798, 1633, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(799, 1632, NULL, 'Not mentioned for China ({citeID|279|Wang 2000}).', 1, '', '45', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(837, 1445, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(802, 1647, NULL, '==History==\r\n\r\nadded 2008-11-25 18:17:06 was saved wrongly as C.lacunarius', 1, '==Conductivity==\r\n\r\n{citeID|502|Zhang et al. 2007} report for Corynoneura lacustris-type in a salinity calibration data set from Tibetan Plateau weighted average total dissolved solids (TDS) of 989.06mg &middot; l⁻&sup1; (&divide; 600 = 1.65mS &middot; cm⁻&sup1;) with an effective occurrence (N2) = 5.58829. In article shortened as: Cl.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(804, 1447, NULL, '==Morphology==\r\n\r\n{textciteID|285|Kiknadze et al. 2005}:\r\nAR 1.55&ndash;2.28, 1.98; Pecten epipharyngis: 12&ndash;17, 14 slender teeth; mandible 3-1-0-0; larva medium-sized (1.7&ndash;2.2, 2.0cm), body {red} in coloration; {overlib|head capsule|<img src=''image.php?text=Image reduced version. Deleted: Chir_sini_hds_Kik2005_r.png 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Chir_sini_hds_Kik2005_r.png 2009-12-15 10:36:17''>} L: 0.87&ndash;1.12 (0.95mm), W: 0.84&ndash;0.90 (0.86mm), L/W: 1.04-1.24 (1.09); frontoclypeal apotome present and only one medial labral sclerite; SL3, SL5 present, S1 &ndash; S5 distinctly.\r\n', 1, '==Distribution==\r\n\r\n{textciteID|285|Kiknadze et al. 2005}: &laquo;The type specimens were collected by light trap in the type locality. The species was also found in Inner Mongolia, Hebei and Lioaning Province (Palearctic China) ({citeID|279|Wang 2000}? [reference is not clear]).&raquo;\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(805, 1648, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(844, 1522, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(807, 1464, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(808, 1482, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Polypedilum sordens-Gr. (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(809, 1461, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(810, 1608, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(835, 1543, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(811, 1573, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(812, 1574, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(813, 1572, 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(814, 1575, 12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(815, 1460, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(816, 1539, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(817, 1536, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(838, 1645, NULL, 'Very similar to menta of {overlib|Brillia|Img:Bril_lofu_men_NHMLond_r.jpeg} or {overlib|Euryhapsis|<img src=''image.php?text=Image reduced version. Deleted: Eurh_suvi_men_Sch1993_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' title=''Image reduced version. Deleted: Eurh_suvi_men_Sch1993_r.gif 2009-12-15 10:36:17''>}, but note the destinct submental setation of {overlib|Cricotopus shilovae|&lt;img align=''middle'' alt=''Cricotopus shilovae (mentum)'' width=200 title=''Cricotopus shilovae (mentum) Zelentsov 1989'' src=''image.php?text=image deleted: Cric_shil_men_Zel1989_r.gif 2009-12-15 10:36:17&amp;img_warning=1'' &gt;}!\r\n\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head --&gt;\r\n!|Reference\r\n!|Taxon\r\n!im90|Head: width (&micro;m)\r\n!im90|Head: postoccipital margin\r\n!im90|Antenna: segments\r\n!im90|Antenna: ratio\r\n!im90|Mentum: middle\r\n!im90|Mentum: submental setation\r\n!im90|Mentum: ventromental plates\r\n!im90|Labrum: premandible\r\n!im90|Labrum: seta S1\r\n!im90|Mandible (inner-apical-outer-surface)\r\n!im90|Mandible: engraved\r\n!im90|Body: parapods\r\n!im90|Body: size (mm)\r\n!im90|Notes\r\n!im90|Literature\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|{citeID|28|Zelentsov 1992}&lt;!-- Reference --&gt;\r\n|Cricotopus shilovae {citeID|28|Zelentsov 1992}&lt;!-- Taxon --&gt;\r\n|360-440&lt;!-- Head: width --&gt;\r\n|{dark brown}&lt;!-- Head: postoccipital margin --&gt;\r\n|5&lt;!-- Antenna: segments --&gt;\r\n|1.3-1.5 (n=10)&lt;!-- Antenna: ratio --&gt;\r\n|1 lower tooth&lt;!-- Mentum: middle --&gt;\r\n|6th outer tooth&lt;!-- Mentum: submental setation --&gt;\r\n|&lt;!-- Mentum: ventromental plates --&gt;\r\n|1&lt;!-- Labrum: premandible --&gt;\r\n|1.8; inner shorter&lt;!-- Labrum: seta S1 --&gt;\r\n|3-1-0-0&lt;!-- Mandible (inner-apical-outer-surface) --&gt;\r\n|1&lt;!-- Mandible engraved --&gt;\r\n|?&lt;!-- Body: parapods --&gt;\r\n|4-8&lt;!-- Body: size --&gt;\r\n|&lt;!-- Notes --&gt;\r\n|{numciteID|28|Zelentsov 1992}&lt;!-- Literature --&gt;\r\n\r\n|}', NULL, 'Biology ({citeID|452|Zelentsov 1989}): Larvae inhabit the littoral zone of lakes from the shoreline down to 4m. They live in aggregations of filamentous algae, and in biofouling on the stones, on higher aquatic vegetation and on silt with plant detritus. Larvae build mucous tubes attached to substratum, with particles of sand and detritus from outside. Univoltine. Imagines occurred from July 23 to August 3. Swarming of midges begins at 11-12 hours a.m. and ends 16-17 h. in the evening. Swarms consist of 8-15 individuals. The species can swarm also together with the individuals of other Cricotopus species. Swarming usually occurs at the height of 0.5-1.5m above the stones or above low vegetation on the shore. Distribution/occurrence: Lake Yashilkul [Яшилькуль] (eastern Pamirs) and Lake Song-Kel [Сонг-Кёль] (Kyrghyzstan)\r\n&lt;!-- translated by Andrey Przhiboro\r\n[Биология: Личинки обитают в литорали озер на глубинах от уреза воды до 4м. Живут в скополениях нитчатых водорослей, вобрастаниях на камнях, высшей водной растительности и илах с остатками растительного детрита. Строят прикрепленные к субстрату слизистые домики-трубки, снаружи укрепленные частичками песка и детрита. Монцикличен. Лёт имаго с 23 июля по 3 августа. Роение комаров начинается с 11-12 час дня, заканчивается в 16-17 час вечера. Рои состоят из 8-15 особей. Виид может роиться и с особями других видов рода Cricotopus. Роение происходит обично на высоте 0.5-1.5м над камнями или береговой наземной растительностью. Распространение. Оз. Яшилькуль (Восточный Памир) и оз. Сонг-Кёль (Киргизская ССР)]--&gt;', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(829, 1542, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(830, 1541, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(831, 1544, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(839, 1651, NULL, NULL, NULL, '==Eutrophication==\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Some clearly eurytopic taxa were recognised, including constantly and abundantly appearing Microtendipes pedellus type, Psectrocladius (P) sordidellus type, Dicrotendipes pulsus type and Ablabesmyia monilis type&raquo;\r\n\r\n===Pollution===\r\n\r\n{citeID|491|Bisthoven and Gerhardt 2003}: &laquo;The unpolluted streams ''&Ouml;vedsan'' and ''Sk&auml;ralidb&auml;cken'' each contained, respectively, 13 and 16 taxa, with a dominance of Microtendipes pedellus gr. and Micropsectra sp., respectively.&raquo;\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Microtendipes pedellus in Alpine running waters of 8.91&deg;C &plusmn;~2.9 (min-max: 5.5-12, n=16).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(840, 1446, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(841, 1448, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(842, 1451, NULL, NULL, NULL, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with IV: 4.09&ndash;4.98.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(843, 1449, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(845, 1540, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(846, 1634, NULL, NULL, NULL, '==Biology==\r\n\r\n;D.aberrata Lundbeck, 1898:  ''''''Smittium biforme'''''' - a symbotic fungus - live in the gut content of Diamesa aberrata larvae ({citeID|434|White and Lichtwardt 2004}).\r\n\r\n==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa aberrata in Alpine running waters of 176.17&micro;S &middot; cm⁻&sup1; &plusmn;~39.07 (min-max: 48-252, n=11).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa aberrata in Alpine running waters of 4.39&deg;C &plusmn;~3.26 (min-max: 1.6-9.7, n=20).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(847, 1652, NULL, NULL, NULL, '{citeID|498|Gardarsson et al. 2004}: The dominant midge of Lake M&yacute;vatn [northern Iceland], Tanytarsus gracilentus showed 3 cyclic oscillations during the 20-year period. The fluctuations were tracked by Micropsectra lindrothi, Procladius islandicus, Orthocladius consobrinus, Psectrocladius barbimanus and Chironomus islandicus.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(848, 1653, NULL, NULL, NULL, '{citeID|498|Gardarsson et al. 2004}: The dominant midge of Lake M&yacute;vatn [northern Iceland], Tanytarsus gracilentus showed 3 cyclic oscillations during the 20-year period. The fluctuations were tracked by Micropsectra lindrothi, Procladius islandicus, Orthocladius consobrinus, Psectrocladius barbimanus and Chironomus islandicus.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(849, 1654, NULL, NULL, NULL, '{citeID|498|Gardarsson et al. 2004}: The dominant midge of Lake M&yacute;vatn [northern Iceland], Tanytarsus gracilentus showed 3 cyclic oscillations during the 20-year period. The fluctuations were tracked by Micropsectra lindrothi, Procladius islandicus, Orthocladius consobrinus, Psectrocladius barbimanus and Chironomus islandicus.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(850, 1655, NULL, NULL, NULL, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*11 with significant symmetric unimodal Template:HOF:unimodal: [..] Heterotanytarsus apicalis (groups [8-10&deg;C] &amp; 10-12&deg;C &amp; &gt;12&deg;C)\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Heterotanytarsus apicalis  and other taxa: 11.7&deg;C &plusmn; 0.7, n=12 (unimodal Template:HOF:unimodal)  . Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n==pH==\r\n\r\n{citeID|507|Brooks and Birks 2000}: \r\n*acidophil Psectrocladius sordidellus-group, Psectrocladius septentrionalis-group, Heterotanytarsus apicalis\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(851, 1593, NULL, NULL, NULL, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(852, 1657, NULL, NULL, NULL, '==Temperature==\r\n\r\nAs cool-water chironomids {citeID|535|Birks et al. 2000} reports: Heterotrissocladius grimshawi, Micropsectra radialis, and Corynocera oliveri/Tanytarsus lugens.\r\n\r\n{citeID|507|Brooks and Birks 2000} reports as &lt;span style="color:#0000ff"&gt;cold water&lt;/span&gt; chironomids Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina.\r\n\r\nHeterotrissocladius grimshawi reported by {citeID|516|Korhola et al. 2002} as cold adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Heterotrissocladius grimshawi  and other taxa: 10.8&deg;C &plusmn; 1.2, n=16 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|521|Porinchu et al. 2002} reports as colder preferring taxa for 57 lakes in the central, eastern Sierra Nevada of California (America): Corynocera oliveri type, Rheocricotopus, Heterotrissocladius grimshawi type, H. marcidus type, Synorthocladius, Sergentia and Hydrobaenus/Oliveridia are most common and most abundant at sites with surface water temperature less than 15&deg;C.\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type, Micropsectra insignilobus type, Protanypus, Tanytarsus lugens type, Hydrobaenus, Heterotrissocladius grimshawi type [most abundant in &lt;13&deg;C + &gt; 16&deg;C, but only a few head capsules], Corynocera ambigua and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n\r\n\r\n==Depth==\r\n\r\n{citeID|515|Korhola et al. 2000} compared samples from Fennoscandia, mainly NW Finnish Lapland concerning sampling depth for Heterotrissocladius grimshawi  and other taxa: 10.6m &plusmn; 7.5 (n=15). For further details &lt;a target=''chirokey_larvae''  href=''chirokey.php?id_characters=213&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=447#sortone''&gt;see here.&lt;/a&gt;\r\n\r\n==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Heterotrissocladius grp. grimshawii (n=12, Template:explained:N2:HillsDiversity=3.63, n&lt;sub&gt;max&lt;/sub&gt;=24) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 35.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(853, 1658, NULL, '\n', NULL, '==Biotops==\r\n\r\n\r\n\r\n{textciteID|8|Vallenduuk 1997}: &laquo;According to {textciteID|458|Webb and Scholl 1985} cytologically checked larvae from the south of Germany they have lateral tubuli. In cytologial material examined from Siberia this feature missing. All publications of larvae from Denmark, England and the Netherlands have no lateral tubuli. Our fitting in the table has been based on this (Dutch and Danish) material. From Danish research activities and also proofed elsewhere in Europe C. anthracinus is frequently the dominant type in large lakes. In the large Maarsseveense Plas the type is especially found in the profundal ({citeID|574|Heinis 1993})&raquo;\r\n\r\n\r\n\r\n===Oxygen===\r\n\r\n{textciteID|482|Pinder 1986}: &laquo;Growth of Chironomus anthracinus in Lake Esrom is known to be inhibited when oxygen levels fall to less than 4% saturation in summer ({citeID|573|J&oacute;nasson and Kristiansen 1967}).&raquo;\r\n\r\n\r\n===Temperature===\r\n\r\n{textciteID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#ff0000"&gt;warm water&lt;/span&gt; Cricotopus sp., Procladius, Chironomus anthracinus-group, Dicrotendipes, Microtendipes chloris, Polypedilum cf. nebeculosum [sic]\r\n\r\n{textciteID|511|Brooks 2006}: \r\n*&laquo;Thermophilic taxa once more returned in the early Holocene notably Chironomus anthracinus type. This taxon has a high temperature optimum in most training sets (although in the Swiss calibration set Chironomus anthracinus type tends to dominate in cool lakes ({citeID|506|Lotter et al. 1997}) so its appearance very early in the Holocene seems surprising.&raquo;\r\n\r\n{textciteID|512|Bunbury and Gajewski 2008} compared 2 years to find possible differences (Units are in &deg;C):\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|Taxon\r\n!|Count\r\n!|Optimum 2000\r\n!im90|Tolerance 2000\r\n!im90|Range lower 2000\r\n!im90|Range upper 2000\r\n!|Optimum 2006\r\n!im90|Tolerance 2006\r\n!im90|Range lower 2006\r\n!im90|Range upper 2006\r\n\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|Tanytarsina\r\n|41\r\n|13.5\r\n|3.9\r\n|9.6\r\n|17.5\r\n|13.9\r\n|4.3\r\n|9.7\r\n|18.2\r\n\r\n|-\r\n|Procladius\r\n|37\r\n|14.1\r\n|3.4\r\n|10.7\r\n|17.6\r\n|14.5\r\n|3.9\r\n|10.7\r\n|18.4\r\n\r\n|-\r\n|Psectrocladius (P. sordidellus group, P.semicirculatus in {citeID|21|Cranston et al. 1983})\r\n|37\r\n|14.1\r\n|3.4\r\n|10.7\r\n|17.4\r\n|13.9\r\n|4.4\r\n|9.5\r\n|18.3\r\n\r\n|-\r\n|Chironomus\r\n|36\r\n|13.8\r\n|3.7\r\n|10.1\r\n|17.4\r\n|13.2\r\n|4.6\r\n|8.6\r\n|17.8\r\n\r\n|-\r\n|Dicrotendipes\r\n|33\r\n|14.3\r\n|3.2\r\n|11.1\r\n|17.5\r\n|14.3\r\n|4.0\r\n|10.3\r\n|18.3\r\n\r\n|-\r\n|Orthocladiinae (unknown)\r\n|33\r\n|12.4\r\n|4.6\r\n|7.8\r\n|17.0\r\n|12.7\r\n|4.8\r\n|7.9\r\n|17.6\r\n\r\n|-\r\n|Pentaneurini\r\n|31\r\n|13.8\r\n|3.8\r\n|10.0\r\n|17.6\r\n|13.7\r\n|4.9\r\n|8.8\r\n|18.6\r\n\r\n|-\r\n|Paratanytarsus\r\n|31\r\n|12.9\r\n|4.5\r\n|8.4\r\n|17.4\r\n|12.8\r\n|5.4\r\n|7.4\r\n|18.2\r\n\r\n|-\r\n|Cricotopus/Orthocladius\r\n|30\r\n|13.3\r\n|4.2\r\n|9.0\r\n|17.5\r\n|13.9\r\n|4.7\r\n|9.2\r\n|18.5\r\n\r\n|-\r\n|Tanytarsus lugens group\r\n|28\r\n|14.3\r\n|3.8\r\n|10.5\r\n|18.1\r\n|14.6\r\n|4.5\r\n|10.1\r\n|19.1\r\n\r\n|-\r\n|Polypedilum\r\n|27\r\n|14.6\r\n|3.8\r\n|10.8\r\n|18.4\r\n|15.0\r\n|4.2\r\n|10.8\r\n|19.2\r\n\r\n|-\r\n|Cladopelma\r\n|27\r\n|14.0\r\n|3.3\r\n|10.7\r\n|17.4\r\n|14.6\r\n|4.0\r\n|10.6\r\n|18.6\r\n\r\n|-\r\n|Cricotopus/Orthocladius (C. tremulus type)\r\n|22\r\n|12.9\r\n|4.4\r\n|8.5\r\n|17.3\r\n|13.0\r\n|4.9\r\n|8.1\r\n|18.0\r\n\r\n|-\r\n|Cladotanytarsus\r\n|20\r\n|14.8\r\n|3.2\r\n|11.7\r\n|18.0\r\n|15.0\r\n|3.7\r\n|11.3\r\n|18.7\r\n\r\n|-\r\n|Cricotopus/Orthocladius (C. cylindraceus type)\r\n|20\r\n|13.5\r\n|4.1\r\n|9.4\r\n|17.5\r\n|13.8\r\n|4.5\r\n|9.3\r\n|18.3\r\n\r\n|-\r\n|Tanytarsus lugens/Corynocera oliveri type\r\n|19\r\n|11.9\r\n|4.5\r\n|7.4\r\n|16.5\r\n|11.6\r\n|4.8\r\n|6.8\r\n|16.4\r\n\r\n|-\r\n|Microtendipes\r\n|18\r\n|15.3\r\n|3.2\r\n|12.1\r\n|18.6\r\n|16.1\r\n|3.4\r\n|12.7\r\n|19.5\r\n\r\n|-\r\n|Corynocera oliveri\r\n|17\r\n|9.3\r\n|4.6\r\n|4.7\r\n|14.0\r\n|10.6\r\n|5.0\r\n|5.6\r\n|15.6\r\n\r\n|-\r\n|Sergentia\r\n|15\r\n|10.0\r\n|4.4\r\n|5.5\r\n|14.4\r\n|9.7\r\n|4.5\r\n|5.3\r\n|14.2\r\n\r\n|-\r\n|Psectrocladius spp.\r\n|14\r\n|13.6\r\n|2.3\r\n|11.3\r\n|15.9\r\n|15.0\r\n|3.9\r\n|11.1\r\n|18.9\r\n\r\n|-\r\n|Endochironomus\r\n|13\r\n|14.3\r\n|2.6\r\n|11.7\r\n|16.8\r\n|14.3\r\n|3.5\r\n|10.7\r\n|17.8\r\n\r\n|-\r\n|Micropsectra atrofasciata\r\n|13\r\n|10.4\r\n|4.5\r\n|6.0\r\n|14.9\r\n|10.7\r\n|4.5\r\n|6.2\r\n|15.2\r\n\r\n|-\r\n|Tanytarsus pallidicornis type\r\n|12\r\n|13.9\r\n|3.8\r\n|10.2\r\n|17.7\r\n|13.8\r\n|4.5\r\n|9.3\r\n|18.2\r\n\r\n|-\r\n|Nanocladius\r\n|12\r\n|13.4\r\n|4.5\r\n|8.9\r\n|17.9\r\n|13.0\r\n|5.3\r\n|7.7\r\n|18.3\r\n\r\n|-\r\n|Corynoneura\r\n|12\r\n|11.6\r\n|4.6\r\n|7.1\r\n|16.2\r\n|10.0\r\n|5.2\r\n|4.8\r\n|15.2\r\n\r\n|-\r\n|Glyptotendipes\r\n|11\r\n|12.0\r\n|5.6\r\n|6.4\r\n|17.7\r\n|12.2\r\n|6.5\r\n|5.7\r\n|18.7\r\n\r\n|-\r\n|Corynoneura/Thienemanniella\r\n|11\r\n|10.0\r\n|4.6\r\n|5.4\r\n|14.6\r\n|10.0\r\n|5.3\r\n|4.8\r\n|15.3\r\n\r\n|-\r\n|Pagastiella\r\n|9\r\n|15.0\r\n|1.5\r\n|13.5\r\n|16.5\r\n|15.7\r\n|2.0\r\n|13.7\r\n|17.7\r\n\r\n|-\r\n|Tanytarsus sp. C\r\n|9\r\n|14.4\r\n|3.8\r\n|10.5\r\n|18.2\r\n|14.1\r\n|3.6\r\n|10.5\r\n|17.7\r\n\r\n|-\r\n|Corynocera ambigua\r\n|9\r\n|12.4\r\n|6.0\r\n|6.4\r\n|18.4\r\n|12.5\r\n|5.4\r\n|7.2\r\n|17.9\r\n\r\n|-\r\n|Orthocladius spp.\r\n|8\r\n|13.3\r\n|4.0\r\n|9.3\r\n|17.3\r\n|12.7\r\n|5.0\r\n|7.7\r\n|17.7\r\n\r\n|-\r\n|Heterotrissocladius\r\n|8\r\n|9.9\r\n|4.5\r\n|5.4\r\n|14.5\r\n|9.5\r\n|4.7\r\n|4.8\r\n|14.2\r\n\r\n|-\r\n|Psectrocladius (Allo/Mesopsectrocladius)\r\n|7\r\n|13.6\r\n|1.5\r\n|12.1\r\n|15.2\r\n|14.6\r\n|2.3\r\n|12.3\r\n|16.9\r\n\r\n|-\r\n|Parakiefferiella spp. including nigra\r\n|7\r\n|10.9\r\n|4.8\r\n|6.1\r\n|15.7\r\n|9.3\r\n|4.5\r\n|4.8\r\n|13.8\r\n\r\n|-\r\n|Parakiefferiella cf. sp. B ({citeID|513|Walker 1988})\r\n|7\r\n|12.0\r\n|5.6\r\n|6.5\r\n|17.6\r\n|9.0\r\n|5.7\r\n|3.3\r\n|14.7\r\n\r\n|-\r\n|Parakiefferiella (Fig. 367 in O&amp;R)\r\n|6\r\n|12.1\r\n|4.5\r\n|7.6\r\n|16.6\r\n|11.0\r\n|5.2\r\n|5.8\r\n|16.2\r\n\r\n|-\r\n|Eukiefferiella\r\n|6\r\n|10.6\r\n|4.5\r\n|6.1\r\n|15.2\r\n|8.9\r\n|4.6\r\n|4.3\r\n|13.4\r\n\r\n|-\r\n|Psectrocladius (P.septentrionalis in {citeID|21|Cranston et al. 1983})\r\n|5\r\n|13.0\r\n|1.5\r\n|11.5\r\n|14.5\r\n|15.5\r\n|3.4\r\n|12.1\r\n|18.8\r\n\r\n|}\r\n\r\n===HOF models===\r\n\r\nTable 5 from {textciteID|518|Larocque et al. 2001}: Estimated optima and tolerances for taxa occurring in more than 10 lakes using Gaussian logit regression (GLR) and Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature. Number of occurrences in the training set are also included. The types of model skewed unimodal (SK Template:HOF:skewedLeft Template:HOF:skewedRight), symmetric unimodal (UN Template:HOF:unimodal), sigmoidal decreasing (SD Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft) and sigmoidal increasing (SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight) are indicated. No model indicates that the taxa had no relationship to temperature. A sign of &lt; indicates that the temperature is lower than the gradient while &gt; indicates an optimum higher than the gradient. Under model a ''?'' indicates taxa with less than 10 occurrences and ''??'' indicates taxa with more than 10 occurrences but no statistical relationship:\r\n\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sorttwo''\r\n\r\n|-\r\n!|Taxa\r\n!im90|Number of Occurrence\r\n!im90|Optimum (TJul &deg;C)\r\n!im90|Tolerance (&plusmn; &deg;C)\r\n!im90|Model type HOF\r\n\r\n|-\r\n|Abiskomyia \r\n|8\r\n|1.7\r\n|2.5\r\n|?\r\n\r\n|-\r\n|Corynoneura scutellata \r\n|12\r\n|7.0&lt;\r\n|\r\n|SD Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft\r\n\r\n|-\r\n|Cricotopus undifferentiated \r\n|39\r\n|11.5\r\n|2.8\r\n|??\r\n\r\n|-\r\n|Cricotopus/Orthocladius \r\n|22\r\n|11.4\r\n|1.9\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Orthocladius sp. \r\n|43\r\n|7.0&lt;\r\n|\r\n|SD Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft\r\n\r\n|-\r\n|Heterotanytarsus apicalis \r\n|12\r\n|11.7\r\n|0.7\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Heterotrissocladius undifferentiated \r\n|31\r\n|7.0&lt;\r\n|\r\n|SD Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft\r\n\r\n|-\r\n|Heterotrissocladius grimshawi \r\n|16\r\n|10.8\r\n|1.2\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Heterotrissocladius brundini \r\n|31\r\n|11.0\r\n|2.7\r\n|??\r\n\r\n|-\r\n|Heterotrissocladius marcidus group \r\n|36\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Heterotrissocladius subpilosus group \r\n|8\r\n|0.0\r\n|0.0\r\n|?\r\n\r\n|-\r\n|Hydrobaenus \r\n|10\r\n|11.4\r\n|1.5\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Nanocladius \r\n|3\r\n|0.0\r\n|0.0\r\n|?\r\n\r\n|-\r\n|Oliveridia \r\n|25\r\n|11.1\r\n|1.1\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Pagastiella orophila \r\n|21\r\n|13.9\r\n|1.3\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Parakiefferiella bathophila \r\n|22\r\n|11.6\r\n|2.9\r\n|??\r\n\r\n|-\r\n|Psectrocladius undifferentiated \r\n|57\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Allopsectrocladius- group \r\n|30\r\n|11.5\r\n|1.1\r\n|SK Template:HOF:skewedLeft Template:HOF:skewedRight\r\n\r\n|-\r\n|Psectrocladius septentrionalis- group \r\n|84\r\n|11.4\r\n|1.9\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Psectrocladius sordidellus- group \r\n|90\r\n|11.6\r\n|4.6\r\n|??\r\n\r\n|-\r\n|Zalutschia zalutschicola \r\n|26\r\n|0.0\r\n|0.0\r\n|??\r\n\r\n|-\r\n|Zalutschia lingulata pauca \r\n|26\r\n|9.2\r\n|1.1\r\n|SK Template:HOF:skewedLeft Template:HOF:skewedRight\r\n\r\n|-\r\n|Chironomus anthracinus- group \r\n|30\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Chironomus plumosus&mdash; group \r\n|25\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Cladopelma \r\n|17\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Dicrotendipes \r\n|43\r\n|11.9\r\n|1.2\r\n|SK Template:HOF:skewedLeft Template:HOF:skewedRight\r\n\r\n|-\r\n|Einfeldia \r\n|2\r\n|0.0\r\n|0.0\r\n|?\r\n\r\n|-\r\n|Microtendipes \r\n|54\r\n|12.6\r\n|1.3\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Polypedilum \r\n|24\r\n|12.9\r\n|0.9\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Sergentia\r\n|86\r\n|15.8\r\n|19.7\r\n|??\r\n\r\n|-\r\n|Cladotanytarsus mancus gr.1 \r\n|27\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Constempellina brevicosta \r\n|12\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Corynocera oliveri \r\n|46\r\n|0.0\r\n|0.0\r\n|??\r\n\r\n|-\r\n|Corynocera ambigua \r\n|59\r\n|10.4\r\n|2.5\r\n|SK Template:HOF:skewedLeft Template:HOF:skewedRight\r\n\r\n|-\r\n|Micropsectra undifferentiated \r\n|30\r\n|7.0&lt;\r\n|\r\n|SD Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft\r\n\r\n|-\r\n|Micropsectra radialis \r\n|18\r\n|7.0&lt;\r\n|\r\n|SD Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft\r\n\r\n|-\r\n|Micropsectra insignilobus \r\n|44\r\n|10.0\r\n|3.1\r\n|??\r\n\r\n|-\r\n|Paratanytarsus \r\n|92\r\n|8.7\r\n|2.5\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Tanytarsus undifferentiated \r\n|92\r\n|0.0\r\n|0.0\r\n|??\r\n\r\n|-\r\n|Tanytarsus pallidicornis- group \r\n|43\r\n|14.7&gt;\r\n|\r\n|SI Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight\r\n\r\n|-\r\n|Tanytarsus sp. B \r\n|67\r\n|12.7\r\n|3.8\r\n|??\r\n\r\n|-\r\n|Tanytarsus sp. C \r\n|11\r\n|12.7\r\n|0.7\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Tanytarsus lugens \r\n|38\r\n|11.7\r\n|3.8\r\n|??\r\n\r\n|-\r\n|Protanypus \r\n|27\r\n|3.3\r\n|8.3\r\n|??\r\n\r\n|-\r\n|Pseudodiamesa\r\n|10\r\n|7.0&lt;\r\n|\r\n|SD Template:HOF:sigmoidalUpperLeft Template:HOF:sigmoidalNotUpperLeft\r\n\r\n|-\r\n|Diamesa \r\n|2\r\n|0.0\r\n|0.0\r\n|?\r\n\r\n|-\r\n|Pentaneurini-group \r\n|72\r\n|11.6\r\n|1.9\r\n|UN Template:HOF:unimodal\r\n\r\n|-\r\n|Procladius-group \r\n|80\r\n|0.0\r\n|0.0\r\n|??\r\n\r\n|}\r\n\r\n==Eutrophication==\r\n\r\n{textciteID|508|Meril&auml;inen et al. 2000}: &laquo;Table~2.: Four developmental stages in the northern (N) and southern (S) basins of Lake Lappaj&auml;rvi. Characterization of the sediment quality, sedimentary diatoms (reconstructed pH according to {citeID|509|Renberg and Hellberg 1982}) and chironomid remains (BQI according to {citeID|510|Wiederholm 1980})&raquo;\r\n{| style=''border:1px solid;'' \r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!colspan=''2''|Pre industrial&lt;br&gt;early 1990s\r\n!colspan=''2''|Increasing loading&lt;br&gt;ca. 1935-1960\r\n!colspan=''2''|Erosion&lt;br&gt;ca. 1960-1970\r\n!colspan=''2''|Meso-eutrophic stage&lt;br&gt;ca. 1970-present\r\n\r\n|-\r\n&lt;!-- table head--&gt;\r\n!|\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n\r\n\r\n&lt;!-- table body --&gt;\r\n|-\r\n|Water content (% WW)\r\n|41&ndash;45 \r\n|81&ndash;82 \r\n|66&ndash;74 \r\n|79&ndash;83 \r\n|56&ndash;62 \r\n|68&ndash;77 \r\n|64&ndash;94 \r\n|73&ndash;89\r\n\r\n|-\r\n|Loss on ignition (% DW) \r\n|2.2&ndash;2.4 \r\n|14&ndash;16 \r\n|8.7&ndash;9.9 \r\n|13&ndash;15 \r\n|5.6&ndash;7 \r\n|8.8&ndash;14 \r\n|5.7&ndash;15 \r\n|7.1&ndash;15\r\n\r\n|-\r\n|Bulk density (g&middot;cm⁻&sup3;) \r\n|1.51&ndash;1.57 \r\n|1.13 \r\n|1.19&ndash;1.37 \r\n|1.0&ndash;1.12 \r\n|1.30&ndash;1.36 \r\n|1.14&ndash;1.22 \r\n|1.03&ndash;1.36 \r\n|1.05&ndash;1.19\r\n\r\n|-\r\n|pH spectra [based on diatomes]\r\n|5.9&ndash;6.4 \r\n|. . \r\n|5.9&ndash;6.8 \r\n|. . \r\n|6.7&ndash;6.9 \r\n|. . \r\n|6.9&ndash;7.4 \r\n|. .\r\n\r\n|-\r\n|Head capsules, 10⁻&sup3;&middot;m⁻&sup2;&middot;a⁻&sup1;\r\n|1.1&ndash;2.2 \r\n|25 \r\n|12&ndash;17 \r\n|24&ndash;87 \r\n|8.2&ndash;20 \r\n|27&ndash;34 \r\n|10&ndash;19 \r\n|17&ndash;60\r\n\r\n|-\r\n|Key species in chironomids \r\n|Hesu \r\n|Micr Stro \r\n|Micr Stro Seco \r\n|Chan Micr Stro\r\n|Chan Stro \r\n|Chan \r\n|Chan Chpl \r\n|Chan Chpl\r\n\r\n|-\r\n|BQI \r\n|4.4&ndash;4.6 \r\n|3.7 \r\n|3.2&ndash;3.5 \r\n|2.4&ndash;3.4 \r\n|2.0&ndash;3.3 \r\n|2.0&ndash;2.2 \r\n|2.2&ndash;2.5 \r\n|1.6&ndash;1.8\r\n\r\n|-\r\n&lt;td colspan=''9''&gt;Chan~=~Chironomus anthracinus gr., Chpl~=~Chironomus plumosus, Hesu~=~Heterotrissocladius subpilosus, Micr~=~Micropsectra spp., Seco~=~Sergentia coracina, Stro~=~Stictochironomus rosenscholdi.&lt;/td&gt;\r\n\r\n|}\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(854, 1477, NULL, NULL, NULL, '==Temperature==\r\n\r\n{citeID|507|Brooks and Birks 2000}:\r\n*&lt;span style="color:#ff0000"&gt;warm water&lt;/span&gt; Cricotopus sp., Procladius, Chironomus anthracinus-group, Dicrotendipes, Microtendipes chloris, Polypedilum cf. nebeculosum [sic]\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Polypedilum nubeculosum (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(855, 1592, NULL, NULL, NULL, '==Eutrophication==\r\n\r\n\r\n{| style=''border:1px solid;'' \r\n&lt;caption&gt;{textciteID|508|Meril&auml;inen et al. 2000}: &laquo;Table~2.: Four developmental stages in the northern (N) and southern (S) basins of Lake Lappaj&auml;rvi. Characterization of the sediment quality, sedimentary diatoms (reconstructed pH according to {textciteID|509|Renberg and Hellberg 1982}) and chironomid remains (BQI according to {textciteID|510|Wiederholm 1980})&raquo;&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n!colspan=''2''|Pre industrial&lt;br&gt;early 1990s\r\n!colspan=''2''|Increasing loading&lt;br&gt;ca. 1935-1960\r\n!colspan=''2''|Erosion&lt;br&gt;ca. 1960-1970\r\n!colspan=''2''|Meso-eutrophic stage&lt;br&gt;ca. 1970-present\r\n\r\n|-\r\n!|\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n!|N\r\n!|S\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Water content (% WW)\r\n|41&ndash;45 \r\n|81&ndash;82 \r\n|66&ndash;74 \r\n|79&ndash;83 \r\n|56&ndash;62 \r\n|68&ndash;77 \r\n|64&ndash;94 \r\n|73&ndash;89\r\n\r\n|-\r\n|Loss on ignition (% DW) \r\n|2.2&ndash;2.4 \r\n|14&ndash;16 \r\n|8.7&ndash;9.9 \r\n|13&ndash;15 \r\n|5.6&ndash;7 \r\n|8.8&ndash;14 \r\n|5.7&ndash;15 \r\n|7.1&ndash;15\r\n\r\n|-\r\n|Bulk density (g&middot;cm⁻&sup3;) \r\n|1.51&ndash;1.57 \r\n|1.13 \r\n|1.19&ndash;1.37 \r\n|1.0&ndash;1.12 \r\n|1.30&ndash;1.36 \r\n|1.14&ndash;1.22 \r\n|1.03&ndash;1.36 \r\n|1.05&ndash;1.19\r\n\r\n|-\r\n|pH spectra [based on diatomes]\r\n|5.9&ndash;6.4 \r\n|. . \r\n|5.9&ndash;6.8 \r\n|. . \r\n|6.7&ndash;6.9 \r\n|. . \r\n|6.9&ndash;7.4 \r\n|. .\r\n\r\n|-\r\n|Head capsules, 10⁻&sup3;&middot;m⁻&sup2;&middot;a⁻&sup1;\r\n|1.1&ndash;2.2 \r\n|25 \r\n|12&ndash;17 \r\n|24&ndash;87 \r\n|8.2&ndash;20 \r\n|27&ndash;34 \r\n|10&ndash;19 \r\n|17&ndash;60\r\n\r\n|-\r\n|Key species in chironomids \r\n|Hesu \r\n|Micr Stro \r\n|Micr Stro Seco \r\n|Chan Micr Stro\r\n|Chan Stro \r\n|Chan \r\n|Chan Chpl \r\n|Chan Chpl\r\n\r\n|-\r\n|BQI \r\n|4.4&ndash;4.6 \r\n|3.7 \r\n|3.2&ndash;3.5 \r\n|2.4&ndash;3.4 \r\n|2.0&ndash;3.3 \r\n|2.0&ndash;2.2 \r\n|2.2&ndash;2.5 \r\n|1.6&ndash;1.8\r\n\r\n|-\r\n&lt;td colspan=''9''&gt;Chan~=~Chironomus anthracinus gr., Chpl~=~Chironomus plumosus, Hesu~=~Heterotrissocladius subpilosus, Micr~=~Micropsectra spp., Seco~=~Sergentia coracina, Stro~=~Stictochironomus rosenscholdi.&lt;/td&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n\r\n{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic of profundal chironomids in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n&lt;/thead&gt;\r\n\r\n|-\r\n|Stictochironomus rosenschoeldi (Zett.) &lt;!-- taxon --&gt; ||x &lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; ||&lt;u&gt;*****&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||***** ||***** ||***** ||***** ||&middot;&middot;&middot;&middot;&middot; ||&middot;&middot;&middot;&middot;&middot; || || || || ||&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt;&middot;&lt;u&gt;&middot;&lt;/u&gt; &lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n&lt;/tbody&gt;\r\n|}\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(856, 1659, NULL, NULL, NULL, '==Temperature==\r\n\r\nParakiefferiella triquetra cf. reported by {citeID|516|Korhola et al. 2002} as warm adapted taxa based on {citeID|517|Olander et al. 1999}.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(857, 1660, NULL, NULL, NULL, '==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Heterotrissocladius brundini  and other taxa: 11&deg;C &plusmn; 2.7, n=31 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(858, 1661, NULL, NULL, 1, '{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for transfer functions): &laquo;Some taxa, e.g. Dicrotendipes pulsus type, Pagastiella orophila and Ablabesmyia monilis type, showed very even distributions among the lakes.&raquo;\r\n\r\n==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff-Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Pagastiella orophila  and other taxa: 13.9&deg;C &plusmn; 1.3, n=21 (unimodal Template:HOF:unimodal). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(859, 1662, NULL, NULL, 1, '==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Constempellina brevicosta  and other taxa: 14.7&gt; &deg;C, n=12 (sigmoidal increasing Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalNotUpperRight). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(860, 1663, NULL, NULL, 1, '==Temperature==\r\n\r\n{citeID|518|Larocque et al. 2001} calculated Huisman-Olff- Fresco (HOF) models ({citeID|519|Huisman et al. 1993}) for T Jul air temperature for taxon Micropsectra insignilobus  and other taxa: 10&deg;C &plusmn; 3.1, n=44 (no statistical relationship). Further details &lt;a target=''chirokey_larvae'' href=''chirokey.php?id_characters=853&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1658#HOF%20models''&gt;see HOF models&lt;/a&gt; on page of Chironomus anthracinus.\r\n\r\n{citeID|521|Porinchu et al. 2002} state for 57 lakes in the central, eastern Sierra Nevada of California (America): As well, Micropsectra insignilobus type has a broader temperature tolerance than Micropsectra radialis type. \r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type, Micropsectra insignilobus type [most abundant in &lt; 13&deg;C &amp; 13-14&deg;C], Protanypus, Tanytarsus lugens type, Hydrobaenus, Heterotrissocladius grimshawi type, Corynocera ambigua and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(862, 1665, NULL, NULL, 1, '==Temperature==\r\n\r\n{citeID|520|Porinchu and Cwynar 2002} reports cold-water chironomid taxa, such as Paracladius, Hydrobaenus/Oliveridia, Abiskomyia, and Parakiefferiella nigra from a tundra site near the lower Lena River, Northeast Siberia.\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Of the individual taxa, Micropsectra radialis type, Heterotrissocladius maeaeri type, Corynocera oliveri type, Psectrocladius (Monopsectrocladius) calcaratus type, Parakiefferiella nigra type [most abundant in &lt; 13&deg;C &amp; 13-14&deg;C], Micropsectra insignilobus type, Protanypus, Tanytarsus lugens type, Hydrobaenus, Heterotrissocladius grimshawi type, Corynocera ambigua and Sergentia coracina type had the lowest temperature optima in the present dataset.&raquo;\r\n\r\n\r\n==Oxygen==\r\n\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen. The RDA is based on 42 lakes and 45 chironomid taxa (numbers) in the Southeastern Ontario calibration set with forward selected environmental variables represented by arrows:&lt;br&gt;\r\nTemplate:RDA:oxygen:Little2001\r\n{| style=''border:1px solid;'' class=''sortable'' id=''sortone''\r\n\r\n!| No\r\n!| Taxon name\r\n!im90|Number of Occurrence\r\n!im90|N2 (effective Occurrence)\r\n!im90|Maximum\r\n\r\n|-\r\n| 1\r\n| Tanytarsus s. lat.\r\n| 40\r\n| 34.41\r\n| 31.58\r\n\r\n|-\r\n| 2\r\n| Cladotanytarsus cf. mancus\r\n| 21\r\n| 16.44\r\n| 7.06\r\n\r\n|-\r\n| 3\r\n| Cladotanytarsus sp. grp. A\r\n| 7\r\n| 5.72\r\n| 3.77\r\n\r\n|-\r\n| 4\r\n| Micropsectra type\r\n| 23\r\n| 15.69\r\n| 29.52\r\n\r\n|-\r\n| 5\r\n| Stempellina/Zavreliella\r\n| 6\r\n| 4.35\r\n| 2.78\r\n\r\n|-\r\n| 6\r\n| Stempelinella\r\n| 17\r\n| 14.09\r\n| 3.36\r\n\r\n|-\r\n| 7\r\n| Tanytarsus cf. glabrescens\r\n| 8\r\n| 6.33\r\n| 4.65\r\n\r\n|-\r\n| 8\r\n| Tanytarsus cf. coffmanni\r\n| 12\r\n| 6.26\r\n| 8.33\r\n\r\n|-\r\n| 9\r\n| Tanytarsus cf. chinyensis\r\n| 5\r\n| 3.74\r\n| 4.55\r\n\r\n|-\r\n| 10\r\n| Corynocera nr. oliveri\r\n| 23\r\n| 14.02\r\n| 13.48\r\n\r\n|-\r\n| 11\r\n| Tanytarsus cf. lugens\r\n| 11\r\n| 8.81\r\n| 4.17\r\n\r\n|-\r\n| 12\r\n| Pseudochironomus\r\n| 27\r\n| 21.4\r\n| 4.26\r\n\r\n|-\r\n| 13\r\n| Chironomus\r\n| 35\r\n| 25.09\r\n| 25.88\r\n\r\n|-\r\n| 14\r\n| Chironomini sp.1\r\n| 24\r\n| 17.4\r\n| 10.42\r\n\r\n|-\r\n| 15\r\n| Cladopelma\r\n| 22\r\n| 12.53\r\n| 11.29\r\n\r\n|-\r\n| 16\r\n| Cryptotendipes\r\n| 11\r\n| 8.3\r\n| 5.04\r\n\r\n|-\r\n| 17\r\n| Cyphomella/Harnischia\r\n| 5\r\n| 4.37\r\n| 3.64\r\n\r\n|-\r\n| 18\r\n| Dicrotendipes\r\n| 39\r\n| 27.34\r\n| 18.82\r\n\r\n|-\r\n| 19\r\n| Endochironomus\r\n| 16\r\n| 12.51\r\n| 6.09\r\n\r\n|-\r\n| 20\r\n| Glyptotendipes\r\n| 16\r\n| 9.28\r\n| 8\r\n\r\n|-\r\n| 21\r\n| Lauterborniella\r\n| 14\r\n| 9.03\r\n| 7.06\r\n\r\n|-\r\n| 22\r\n| Microtendipes\r\n| 20\r\n| 13.34\r\n| 8.14\r\n\r\n|-\r\n| 23\r\n| Parachironomus\r\n| 24\r\n| 16.65\r\n| 6.98\r\n\r\n|-\r\n| 24\r\n| Paratendipes\r\n| 9\r\n| 7.1\r\n| 5.32\r\n\r\n|-\r\n| 25\r\n| Polypedilum\r\n| 33\r\n| 22.42\r\n| 10.92\r\n\r\n|-\r\n| 26\r\n| Sergentia\r\n| 23\r\n| 12.21\r\n| 24.05\r\n\r\n|-\r\n| 27\r\n| Stenochironomus\r\n| 5\r\n| 4.84\r\n| 2.35\r\n\r\n|-\r\n| 28\r\n| Tribelos\r\n| 7\r\n| 5.69\r\n| 4.71\r\n\r\n|-\r\n| 29\r\n| Procladius\r\n| 33\r\n| 18.43\r\n| 27.27\r\n\r\n|-\r\n| 30\r\n| Pentaneurini\r\n| 37\r\n| 30.74\r\n| 17.31\r\n\r\n|-\r\n| 31\r\n| Labrundinia\r\n| 19\r\n| 12.43\r\n| 9.62\r\n\r\n|-\r\n| 32\r\n| Corynoneura/Thienemanniella\r\n| 36\r\n| 24.8\r\n| 14.68\r\n\r\n|-\r\n| 33\r\n| Cricotopus/Orthocladius\r\n| 29\r\n| 21.37\r\n| 9.09\r\n\r\n|-\r\n| 34\r\n| Heterotrissocladius grp. marcidus\r\n| 17\r\n| 9.83\r\n| 14.29\r\n\r\n|-\r\n| 35\r\n| Heterotrissocladius grp. grimshawii\r\n| 12\r\n| 3.63\r\n| 24\r\n\r\n|-\r\n| 36\r\n| Heterotrissocladius grp. subpilosus\r\n| 6\r\n| 4.85\r\n| 2.13\r\n\r\n|-\r\n| 37\r\n| Nanocladius\r\n| 16\r\n| 12.56\r\n| 4.44\r\n\r\n|-\r\n| 38\r\n| Parakiefferiella cf. bathophila\r\n| 28\r\n| 20.18\r\n| 8.26\r\n\r\n|-\r\n| 39\r\n| Parakiefferiella nigra\r\n| 12\r\n| 9.24\r\n| 5\r\n\r\n|-\r\n| 40\r\n| Parametriocnemus\r\n| 3\r\n| 2.84\r\n| 2.08\r\n\r\n|-\r\n| 41\r\n| Psectrocladius (Monopsectrocladius)\r\n| 22\r\n| 13.39\r\n| 8.11\r\n\r\n|-\r\n| 42\r\n| Psectrocladius (Psectrocladius)\r\n| 26\r\n| 19.83\r\n| 8.02\r\n\r\n|-\r\n| 43\r\n| Psectrocladius (Septentrionalis)\r\n| 12\r\n| 9.51\r\n| 4.82\r\n\r\n|-\r\n| 44\r\n| Synorthocladius\r\n| 19\r\n| 15.12\r\n| 4.32\r\n\r\n|-\r\n| 45\r\n| Zalutschia\r\n| 22\r\n| 14.02\r\n| 5.5\r\n\r\n|}\r\n\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(863, 1666, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|533|Little and Smol 2001} report relationships concerning oxygen with an RDA for Tanytarsus cf. coffmanni (n=12, Template:explained:N2:HillsDiversity=6.26, n&lt;sub&gt;max&lt;/sub&gt;=8.33) and other taxa in 42 lakes of in the southeastern Ontario (Canada/USA). further details &lt;a href=''chirokey.php?id_characters=862&amp;morph_attrib_id=%60names_subfamily%60.%60morph_attrib_id%60&amp;show=specimen&amp;valid_id=1665#Oxygen''&gt;see here&lt;/a&gt; with taxon''s number: 8.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(864, 1462, NULL, NULL, NULL, '==Temperature==\r\n\r\n{citeID|534|Luoto 2009} reports from a 1000km transect in Finland (training data set for TJul transfer function): &laquo;Among the chironomids, Micropsectra radialis type, Heterotrissocladius maeaeri type and Corynocera oliveri type, for example, were restricted to the northern and cold lakes, while Microchironomus tener type and Einfeldia pagna type were restricted to the warmest lakes.&raquo; [..] &laquo;Endochironomus impar type, Chironomus plumosus type, Nanocladius rectinervis type, Endochironomus albipennis type , Glyptotendipes pallens type, Einfeldia pagana type and Microchironomus tener type [most abundant in &gt;16&deg;C] had the highest temperature optima.&raquo;\r\n\r\n==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Microchironomus tener (Diptera) as l(el)~= &laquo;(limnic, euryhaline-limnic) freshwater taxa that tolerate salinity below 5%&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~7-freshwater (&lt;0.5&permil;)&lt;br&gt;~~3-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(865, 1535, NULL, '{citeID|321|Makarchenko and Makarchenko 2000} reports Pagastia sp. 1 for the 1st time: Material: 18 larvae, Middle Asia, Kirgizstan, Turgen River, 20.08.1984 (N. Petrova leg.). Larva of 4th instar. Body length 11.0-12.4 mm (n=2). Head capsule with dorsal and dorsolateral dark markings (Fig. 8-9). Head head width 0.70-0.80 mm (n=2); head length/head width 1.2. Eye spot consists of 2 parts. SI tapering, similar to leaf-shaped (Fig. 1). Premandible with 12-13 teeth; lateral spine length 52-57n,m (Fig. 2). Antenna length/mandible length 0.5 (n=2); two ring organs (diameter 6.0 n,m) on basal 1/3 of first segment; blade extending to level of end of fourth segment (Fig. 4); AR=2.5-2.7 (n=8). Mandible with apical tooth which is shorter than combined width of inner teeth; seta interna with 8-10 simple branches; seta subdentalis long and sabreform (Fig. 3). Mentum with 6-7 pairs of lateral teeth, middle tooth with several apexes (Fig. 5-7). Procercus with 8 anal setae. Adults and pupa are unknown. Distribution. Middle Asia.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(866, 1667, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Ablabesmyia pulchripennis (Lundbeck 1898) in lake Skaelverdam (West Greenland) an oxygen consumption of 3.59 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 30.9 in % is in group {overlib|C|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  0.5~ha (lake area); 67.00037&deg;N; 50.80578&deg;W; 2,552~&micro;S~&middot; cm⁻&sup1;; ?&deg;C; max. depth: 8~m.\r\n\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(867, 1668, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Procladius paragretis Roback 1971:\r\n*in lake Store Salts&oslash; (West Greenland) an oxygen consumption of 2.61 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 32.4 in % is in group {overlib|C|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  31~ha (lake area); 66.99&deg;N; 50.59833&deg;W; 2,798~&micro;S~&middot; cm⁻&sup1;; 14.0&deg;C (July 2002); max. depth: 11~m.\r\n*in lake Lake SS2 (West Greenland) an oxygen consumption of 2.43 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 31.2 in % is in group {overlib|C|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. The lake was characterised by:  37~ha (lake area); 66.99667&deg;N; 50.97000&deg;W; 293~&micro;S~&middot; cm⁻&sup1;; 15.3&deg;C (July 2002); max. depth: 11~m.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(868, 1669, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Hydrobaenus fusistylus (Goetghebuer 1933) in lake Glacier Lake 1 (West Greenland) an oxygen consumption of \r\n*6.02/5.6 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 38.4/35 in % is in group {overlib|B/B|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. \r\nThe lake was characterised by:  40~ha (lake area); 67.13521&deg;N; 50.12833&deg;W; 2~&micro;S~&middot; cm⁻&sup1;; 4-7&deg;C (July 2002); max. depth: 22~m. With an experimental temperature of 15&deg;C in the same lake the following measuring was done: oxygen consumption of \r\n*8.03/6.21 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of 42.3/37.1 in % groups also to group {overlib|B|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators}\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(869, 1670, NULL, NULL, 1, '==Oxygen==\r\n\r\n{citeID|492|Brodersen et al. 2004} report for Dircrotendipes cf. modestus (Say 1823) in lake Store Salts&oslash; (West Greenland) an oxygen consumption of \r\n*2.02/2.52 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of \r\n*17.9/26.3 in % is in group {overlib|E/D|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} and at experimental temperature: 10&deg;C. \r\nThe lake was characterised by:  31~ha (lake area); 66.99&deg;N; 50.59833&deg;W; 2,798~&micro;S~&middot; cm⁻&sup1;; 14.0&deg;C (July 2002); max. depth: 11~m. In lake Suger Loaf Pond N. (West Greenland) at experimental temperature of 15&deg;C an oxygen consumption of \r\n*6.38 in ㎎ O₂ &middot; mg⁻&sup1; &middot; h⁻&sup1; with a critical limit of \r\n*31.3 in % is in group {overlib|C|Groups A&ndash;E: &lt;br&gt;~~(A) taxa were oxy-conformers&lt;br&gt;~~(B) taxa were oxy-conformers&lt;br&gt;~~(C) taxa had intermediate oxy-regulatory capacity&lt;br&gt;~~(D) taxa between C and E&lt;br&gt;~~(E) taxa were strong oxy-regulators} was determined.\r\nThe lake was characterised by:  6~ha (lake area); 67.04782&deg;N; 50.52082&deg;W; 423~&micro;S~&middot; cm⁻&sup1;; ?&deg;C (July 2002); max. depth: ?~m.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(870, 1671, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Corynoneura edwardsi in Alpine running waters of 11.29&micro;S &middot; cm⁻&sup1; &plusmn;~7.55 (min-max: 4-117, n=61).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Corynoneura edwardsi in Alpine running waters of 5.5&deg;C &plusmn;~1.71 (min-max: 0.3-9.81, n=77).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Corynoneura edwardsi in Alpine running waters of 6.46 &plusmn;~0.37 (min-max: 5.27-8.1, n=68).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(871, 1672, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa dampfi in Alpine running waters of 274.13&micro;S &middot; cm⁻&sup1; &plusmn;~177.13 (min-max: 8-479, n=26).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa dampfi in Alpine running waters of 3.83&deg;C &plusmn;~1.45 (min-max: 0.5-8.4, n=38).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa dampfi in Alpine running waters of 8.67 &plusmn;~0.56 (min-max: 5.91-9.3, n=11).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(872, 1673, NULL, NULL, 1, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa incallida in Alpine running waters of 5.35&deg;C &plusmn;~0.94 (min-max: 3-7, n=13).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(873, 1674, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Diamesa latitarsis in Alpine running waters of 84.17&micro;S &middot; cm⁻&sup1; &plusmn;~122.21 (min-max: 4-474, n=194).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Diamesa latitarsis in Alpine running waters of 2.76&deg;C &plusmn;~1.96 (min-max: -0.1-12, n=240).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Diamesa latitarsis in Alpine running waters of 7.68 &plusmn;~1.38 (min-max: 4.5-9.5, n=177).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(874, 1675, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Orthocaldius (Eudactylocladius) fuscimanus. Denoted in the article as ''''''Eudactylocladius fuscimanus''''''.\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Orthocaldius (Eudactylocladius) fuscimanus. Denoted in the article as ''''''Eudactylocladius fuscimanus''''''.\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Orthocaldius (Eudactylocladius) fuscimanus. Denoted in the article as ''''''Eudactylocladius fuscimanus''''''.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(875, 1676, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Macropelopia nebulosa in Alpine running waters of 77.49&micro;S &middot; cm⁻&sup1; &plusmn;~51.22 (min-max: 23-230, n=13).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Macropelopia nebulosa in Alpine running waters of 10.32&deg;C &plusmn;~5.31 (min-max: 0.3-21, n=29).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(876, 1677, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Parorthocladius nudipennis in Alpine running waters of 33.19&micro;S &middot; cm⁻&sup1; &plusmn;~31.75 (min-max: 5-252, n=53).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Parorthocladius nudipennis in Alpine running waters of 4&deg;C &plusmn;~1.32 (min-max: 0.01-8.1, n=58).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Parorthocladius nudipennis in Alpine running waters of 6.54 &plusmn;~0.64 (min-max: 5.33-8.9, n=40).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(877, 1488, NULL, NULL, NULL, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Pseudodiamesa branickii in Alpine running waters of 76.03&micro;S &middot; cm⁻&sup1; &plusmn;~133.07 (min-max: 6-425, n=91).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Pseudodiamesa branickii in Alpine running waters of 4.9&deg;C &plusmn;~1.88 (min-max: 0.3-21, n=112).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Pseudodiamesa branickii in Alpine running waters of 6.82 &plusmn;~1.09 (min-max: 5.11-9.9, n=77).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(878, 1490, NULL, NULL, NULL, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Pseudodiamesa nivosa in Alpine running waters of 4.45&deg;C &plusmn;~4.42 (min-max: 0.3-16, n=11).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(879, 1678, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Pseudokiefferiella parva in Alpine running waters of 20.05&micro;S &middot; cm⁻&sup1; &plusmn;~53.21 (min-max: 4-395, n=108).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Pseudokiefferiella parva in Alpine running waters of 3.66&deg;C &plusmn;~2.06 (min-max: -0.1-12, n=128).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Pseudokiefferiella parva in Alpine running waters of 5.91 &plusmn;~0.92 (min-max: 4.5-9.9, n=103).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(880, 1679, NULL, NULL, 1, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Tokunagaia tonollii in Alpine running waters of 227.23&micro;S &middot; cm⁻&sup1; &plusmn;~122.36 (min-max: 70-479, n=14).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Tokunagaia tonollii in Alpine running waters of 4.47&deg;C &plusmn;~1.76 (min-max: 1.9-6.5, n=19).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Tokunagaia tonollii in Alpine running waters of 8.79 &plusmn;~0.44 (min-max: 7.7-9.5, n=11).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(881, 1680, NULL, NULL, 1, '==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Zavrelimyia hirtimana in Alpine running waters of 6.4&deg;C &plusmn;~4.3 (min-max: 0.3-10, n=12).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Zavrelimyia hirtimana in Alpine running waters of 8.02 &plusmn;~0.31 (min-max: 7.6-8.3, n=12).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(882, 1681, NULL, NULL, NULL, '==Conductivity==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a conductivity for Zavrelimyia punctatissima in Alpine running waters of 21.83&micro;S &middot; cm⁻&sup1; &plusmn;~8.12 (min-max: 6-69, n=14).\r\n\r\n==Temperature==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a H₂O temperature for Zavrelimyia punctatissima in Alpine running waters of 8.16&deg;C &plusmn;~2.15 (min-max: 3.74-19, n=17).\r\n\r\n==pH value==\r\n\r\n{citeID|536|Rossaro et al. 2004}, {citeID|489|Rossaro et al. 2006} report a pH value for Zavrelimyia punctatissima in Alpine running waters of 6.67 &plusmn;~0.45 (min-max: 5.68-8.4, n=15).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(885, 1529, NULL, NULL, NULL, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Glyptotendipes barbipes (Diptera) as el~= &laquo;euryhaline-limnic taxa, i.e. freshwater taxa that tolerate salinity up to 10% (even higher salinity for a short time)&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~6-freshwater (&lt;0.5&permil;)&lt;br&gt;~~2-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~2-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(886, 1684, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Harnischia curtilamellata (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(887, 1685, NULL, NULL, 1, 'Living in soil: Limnophyes minimus see {citeID|475|Delettre 2000}.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(888, 1686, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Odontomesa fulva (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(889, 1687, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Parachironomus arcuatus-Gr. (Diptera) as el~= &laquo;euryhaline-limnic taxa, i.e. freshwater taxa that tolerate salinity up to 10% (even higher salinity for a short time)&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~6-freshwater (&lt;0.5&permil;)&lt;br&gt;~~2-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~2-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(890, 1688, NULL, NULL, 1, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Parachironomus frequens-Gr. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(891, 1690, NULL, NULL, NULL, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Parachironomus varus (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(892, 1548, NULL, NULL, NULL, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Polypedilum albicorne (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(893, 1691, NULL, NULL, 1, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  2.0&ndash;11.0.\r\n\r\n\r\n===Salinity===\r\n\r\n{textciteID|490|Wolf et al. 2009} classifies taxon Polypedilum bicrenatum (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {textciteID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(894, 1549, NULL, NULL, NULL, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Polypedilum cultellatum (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(895, 1481, NULL, NULL, NULL, '==Salinity==\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Polypedilum scalaenum-Gr. (Diptera) as l~= &laquo;(limnic) freshwater taxa that do not tolerate even low salinity&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~10-freshwater (&lt;0.5&permil;)&lt;br&gt;~~0-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~0-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(896, 1692, NULL, '==History==\r\n\r\nTaxon moved: A.Plank named it wrong Psectrotanypus varipes -&gt; Psectrotanypus varius (Fabricius 1787) (2009-06-28 09:59:42)', 1, '===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  7.0-8.5.\r\n\r\n\r\n===Salinity===\r\n\r\n{citeID|490|Wolf et al. 2009} classifies taxon Psectrotanypus varius (Diptera) as el~= &laquo;euryhaline-limnic taxa, i.e. freshwater taxa that tolerate salinity up to 10% (even higher salinity for a short time)&raquo;. After a classifying system for brackish water bodies following {citeID|539|Caspers 1959} with weights 1-10 (but with &sum; categories=10) it classifies in categories:&lt;br&gt;~~6-freshwater (&lt;0.5&permil;)&lt;br&gt;~~2-oligohaline (0.5 - &lt;5&permil;)&lt;br&gt;~~2-mesohaline (5 - &lt;18&permil;)&lt;br&gt;~~0-polyhaline (18 - &lt; 30&permil;)&lt;br&gt;~~0-euhaline (30 &ndash; 40&permil;).\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(897, 1693, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(898, 1606, NULL, 'See also Stilocladius, some are similar.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(899, 623, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(900, 1694, NULL, 'Is similar to C.zavreli {textciteID|550|Szadziewski and Hirvenoja 1981} in all stages ({citeID|543|Zinchenko et al. 2009}).', NULL, '{textciteID|543|Zinchenko et al. 2009}: Larvae were captured in April, August and September 2006-2008 yr. in salt waters of the rivers Solyanka [Солянка], Jara [Хара], Chernyavka [Чернявка], Lantsug [Ланцуг] with mineralisation levels from 9,0 to 29,5 g/l at depths to 50cm. Locally, at places of mass development, they live together with larvae of the dipteran family Ceratopogonidae and Chironomus salinarius  Kieffer. The greatest number and biomass of larvae in associated macro-zoobenthos was captured in river Solyanka [Солянка] (13.08.2008) with a water salinity of 28,5&permil;; 10880 exhuviae/m^2, 10 g/m^2.\r\n\r\n\r\n&lt;!-- {{openLayer|1|\r\n(46.693835$49.13081$Lake El''ton$C.salinophilus Zinchenko et al. 2009)\r\n}}\r\n --&gt;\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(901, 1605, NULL, NULL, NULL, '==Autecology==\r\n\r\n{textciteID|559|Rosenberg 1992}: &laquo;Of 11 studies reviewed in table 4.7 of JOHNSON et al. (1993), only one used Chironomidae: DARVILLE and WlLHM (1984) reported effects of naphthalene on O₂ consumption rates of Chironomus attenuatus and Tanytarsus dissimilis [Paratanytarsus dissimilis].&raquo; [..] &laquo;Tanytarsus dissimilis [Paratanytarsus dissimilis]: stressor: Cd, Cu, Pb, Zn; life-history endpoint: growth (as head capsule width); effect: &lt; indicated once LC50 of Cd and Zn exceeded, even though survival dramatically reduced; reference: ANDERSON et al. (1980)&raquo;\r\n\r\nSee for further details on tests {textciteID|559|Rosenberg 1992} and refereneces there.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(902, 1503, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(903, 1695, NULL, NULL, 1, '==Biotops==\r\n\r\n{textciteID|560|Malo et al. 1998}: &laquo;Virgatanytarsus albisutus (Santos-Abreu), cited previously from Morocco and Algeria (Laville &amp; Reiss 1992) and the Canary Islands (Cranston &amp; Armitage 1988) has a widespread distribution in the Seda, Xevora, Valverde, Xarrama and Ardila streams.&raquo;\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(904, 1696, NULL, NULL, 1, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  2.0&ndash;11.0.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(906, 0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(907, 0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(908, 0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(909, 0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(910, 0, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(911, 1698, NULL, NULL, 1, '==Biotops==\r\n\r\n{textciteID|477|Vallenduuk and Moller-Pillot 1999} translated with [[http://de.babelfish.yahoo.com/translate_txt BabelFish]]: &laquo;Based on the determination of C.annularius imagines they were found everywhere commonly more or less in Europe, especially in smaller water bodies. According to research of {textciteID|570|Krebs and Moller-Pillot n.d.} the type in the delta area is very general, both and in narrow closed in something larger water bodies. A preference seems to exist for lakes with a low detritus amount on the bottom. Species endure considerably clogging. The larvae live especially in fresh waters and in slightly brackish water with chloride contents to approximately 5,000 mg/l. Cytological data of examined material confirm this.&raquo;\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  6.0-11.0.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(912, 1528, NULL, NULL, NULL, '===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with tolerances of  6.0-11.0.\r\n\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(913, 1699, NULL, NULL, 1, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with I: 9.01&ndash;9.73,  II: 8.05&ndash;8.65, III: 5.02&ndash;5.95, IV: 4.09&ndash;4.98.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(914, 1626, NULL, NULL, NULL, '==Biotops==\r\n\r\n===pH===\r\n\r\n{textciteID|561|Berezina 2001}: occoured in experimental mesocosmos with II: 8.05&ndash;8.65, III: 5.02&ndash;5.95, IV: 4.09&ndash;4.98.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(915, 1527, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(916, 1700, NULL, NULL, 1, '==Biotops==\r\n\r\n{textciteID|8|Vallenduuk 1997}: common in whole Europe in lentic and lotic waters. Only a few data have beeen checked based on cytological investigations.\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `characters` (`id`, `names_valid_id`, `names_authors_id`, `notes`, `genus_info`, `ecology`, `similar`, `usertimestamp`, `ant_segments`, `ant_ratio_mean`, `ant_spur`, `ant_spur_note`, `ant_ratio_variation`, `ant_ratio_n`, `ant_ratio_note`, `ant_ring-organ_ratio_mean`, `ant_ring-organ_ratio_variation`, `ant_ring-organ_ratio_n`, `ant_ring-organ_notes`, `ant_blade_ratio_mean`, `ant_blade_ratio_variation`, `ant_blade_ratio_n`, `ant_blade_ratio_note`, `ant_lauterborn_organ`, `ant_pedestal`, `ant_pedestal_ratio_mean`, `ant_pedestal_ratio_variation`, `ant_pedestal_ratio_n`, `ant_pedestal_notes`, `ant_note`, `head_ratio_mean`, `head_ratio_variation`, `head_ratio_n`, `head_notes`, `head_color`, `head_postoccipital_plate`, `head_postoccipital_margin`, `head_pattern`, `men_middle_tooth`, `men_middle_pattern`, `men_lateral_teeth`, `men_lateral_pattern`, `men_ventromental_plates`, `men_middle_tooth_ratio_mean`, `men_middle_tooth_ratio_variation`, `men_middle_tooth_ratio_n`, `men_middle-1stlat_tooth_ratio_mean`, `men_middle-1stlat_tooth_ratio_variance`, `men_middle-1stlat_tooth_ratio_n`, `men_s-submenti_v-plates-relation`, `men_s-submenti_men-lat-tooth_position_mean`, `men_s-submenti_men-lat-tooth_position_variation`, `men_s-submenti_note`, `men_beard`, `men_vmplates_note`, `man_inner`, `man_apical`, `man_outer`, `man_surface`, `man_notes`, `man_margin_engraved`, `man_tooth_ratio_mean`, `man_tooth_ratio_min`, `man_tooth_ratio_max`, `man_tooth_ratio_n`, `man_pattern`, `man_s-interna`, `man_s-interna_note`, `man_s-subdentalis`, `man_s-subdentalis_note`, `max_palp`, `max_lacinal_chetae`, `max_pecten_galearis`, `max_galea_lamellae`, `lab_s1`, `lab_s1_note`, `lab_s2`, `lab_s2_note`, `lab_s3`, `lab_s4`, `lab_s_note`, `lab_n-preman_mean`, `lab_n-preman_min`, `lab_n-preman_max`, `lab_n-preman_n`, `lab_preman_brush`, `lab_preman_notes`, `lab_pecten_epipharyngis`, `lab_ligula`, `abd_parapods`, `abd_lateral_setae`, `abd_procerus_color`, `abd_procerus_ratio`, `abd_procerus_n-setae`, `abd_procerus_n-setae_note`, `abd_procerus_n-subapical-setae`, `abd_procerus_n-subapical-setae_note`, `abd_anal_papillae`, `abd_color`, `length_min`, `length_max`, `length_mean`, `length_n`) VALUES
(917, 1701, NULL, NULL, 1, '{| style=''border:1px solid;font-family:monospace;font-size:8pt'' class=''table-autofilter table-autosort''\r\n&lt;caption style=''font-family: "Verdana [microsoft]";''&gt;Table modified from {textciteID|577|S&aelig;ther 1979}: Characteristic sublittoral and littoral chironomids of habitats in Nearctic (&lt;span style=''font-family:monospace;''&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;u&gt;~~~~~&lt;/u&gt;&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;~&lt;u&gt;~&lt;/u&gt;&lt;/span&gt;) and Palaearctic (&lt;span style=''font-family:monospace;''&gt;&middot;&middot;&middot;&middot;&middot;*****&middot;&middot;&middot;&middot;&middot;&lt;/span&gt;) lakes. Fully drawn lines and asterisks: Distribution under good to excellent conditions. Broken underlines and dots: Maximum range or single findings.&lt;/caption&gt;\r\n&lt;thead&gt;\r\n\r\n|-\r\n!|\r\n! colspan=2 | Europe\r\n! colspan=6 style=''background-color:#4A75BD;''| oligotrophic\r\n! colspan=3 style=''background-color:#FFEA00;''| mesotrophic\r\n! colspan=6 style=''background-color:#DE5500;''| eutrophic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#A49941;'' |mesohumic\r\n!im90 rowspan=2 class=''table-sortable:default '' style=''background-color:#733018;color:white;'' |polyhumic\r\n\r\n\r\n|-\r\n! class=''table-sortable:default ''|Taxon\r\n!im90 class=''table-sortable:default ''|alpine\r\n!im90 class=''table-sortable:default ''|boreal\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&alpha;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&beta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&gamma;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&delta;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&epsilon;\r\n! class=''table-sortable:default '' style=''background-color:#4A75BD;''|&zeta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&eta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&theta;\r\n! class=''table-sortable:default '' style=''background-color:#FFEA00;''|&iota;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&kappa;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&lambda;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&mu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&nu;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&xi;\r\n! class=''table-sortable:default '' style=''background-color:#DE5500;''|&omicron;\r\n\r\n\r\n|-\r\n!|&lt;input name=''filterTaxon0'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterAlpine1'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n!|&lt;input name=''filterBoreal2'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterAlpha3'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterBeta4'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterGamma5'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterDelta6'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterEpsilon7'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#4A75BD;''|&lt;input name=''filterZeta8'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterEta9'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterTheta10'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#FFEA00;''|&lt;input name=''filterIota11'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterKappa12'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterLambda13'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterMu14'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterNu15'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterXi16'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#DE5500;''|&lt;input name=''filterO17'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#A49941;''|&lt;input name=''filterMesohumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n! style=''background-color:#733018;''|&lt;input name=''filterPolyhumic'' size=''2'' onkeyup=''Table.filter(this,this)''&gt;\r\n\r\n\r\n&lt;/thead&gt;\r\n&lt;tbody&gt;\r\n\r\n|-\r\n|Abiskomyia virgo Edw. &lt;!-- taxon --&gt; ||&lt;!-- alpine --&gt; ||x &lt;!-- boreal --&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; ||&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt;*&lt;u&gt;*&lt;/u&gt; || || || || || || || || || || || || || ||&lt;!-- mesohumic --&gt; ||&lt;!-- polyhumic --&gt;\r\n\r\n  &lt;/tbody&gt;\r\n|}\r\n', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(918, 1702, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `images`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:44 AM
-- Last check: Dec 15, 2009 at 10:44 AM
--

DROP TABLE IF EXISTS `images`;
CREATE TABLE IF NOT EXISTS `images` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'automatic ID',
  `filename` varchar(40) NOT NULL COMMENT 'automatic filename from upload.php',
  `annote` text COMMENT 'some annotations',
  `time_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `time_modified` timestamp NULL DEFAULT NULL,
  `morph_id` smallint(5) unsigned DEFAULT NULL COMMENT 'which morphological structure',
  `names_authors_id` smallint(5) unsigned DEFAULT NULL COMMENT 'reference',
  `names_valid_id` smallint(5) unsigned DEFAULT NULL COMMENT 'valid name',
  `license` enum('only private usage','Creative Commons Noncommercial Share Alike','Author provides usage (journals not checked)') NOT NULL DEFAULT 'only private usage' COMMENT 'license provided by the author',
  `license_memo` text COMMENT 'license annotations',
  `users_id` smallint(4) unsigned NOT NULL COMMENT 'user',
  PRIMARY KEY (`id`),
  UNIQUE KEY `filename` (`filename`),
  KEY `users_id` (`users_id`),
  KEY `morph_id` (`morph_id`),
  KEY `names_authors_id` (`names_authors_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='images' AUTO_INCREMENT=4127 ;

--
-- RELATIONS FOR TABLE `images`:
--   `morph_id`
--       `morph_attrib` -> `id`
--   `names_authors_id`
--       `names_authors` -> `id`
--   `names_valid_id`
--       `names_valid` -> `id`
--   `users_id`
--       `users` -> `id`
--

--
-- Dumping data for table `images`
--

INSERT INTO `images` (`id`, `filename`, `annote`, `time_added`, `time_modified`, `morph_id`, `names_authors_id`, `names_valid_id`, `license`, `license_memo`, `users_id`) VALUES
(87, 'Beci_teth_ant_Sae1977_r.gif', NULL, '2007-02-10 17:35:51', NULL, 5, 26, 749, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(88, 'Beci_teth_lab_Sae1977_r.gif', NULL, '2007-02-10 17:35:51', NULL, 6, 26, 749, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(89, 'Beci_teth_man_Sae1977_r.gif', NULL, '2007-02-10 17:35:51', NULL, 1, 26, 749, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(90, 'Beci_teth_map_Sae1977_r.gif', NULL, '2007-02-10 17:35:51', NULL, 2, 26, 749, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(91, 'Beci_teth_men_Sae1977_r.gif', NULL, '2007-02-10 17:35:51', NULL, 7, 26, 749, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(236, 'Cher_orbi_ane_Sae1976_r.gif', NULL, '2007-02-10 17:35:52', NULL, 10, 10, 459, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(237, 'Cher_orbi_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:52', NULL, 5, 10, 459, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(238, 'Cher_orbi_lbs_Sae1976_r.gif', NULL, '2007-02-10 17:35:52', NULL, 48, 10, 459, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(239, 'Cher_orbi_map_Sae1976_r.gif', NULL, '2007-02-10 17:35:52', NULL, 2, 10, 459, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(240, 'Cher_orbi_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:52', NULL, 7, 10, 459, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(879, 'Cyph_spec_ant_Sae1977_r.gif', NULL, '2007-02-10 17:35:56', NULL, 5, 26, 35, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(880, 'Cyph_spec_lab_Sae1977_r.gif', NULL, '2007-02-10 17:35:56', NULL, 6, 26, 35, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(881, 'Cyph_spec_man_Sae1977_r.gif', NULL, '2007-02-10 17:35:56', NULL, 1, 26, 35, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(882, 'Cyph_spec_map_Sae1977_r.gif', NULL, '2007-02-10 17:35:56', NULL, 2, 26, 35, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(883, 'Cyph_spec_men_Sae1977_r.gif', NULL, '2007-02-10 17:35:56', NULL, 7, 26, 35, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(884, 'Cyph_spec_pre_Sae1977_r.gif', NULL, '2007-02-10 17:35:56', NULL, 4, 26, 35, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(901, 'Demi_cune_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:56', NULL, 5, 10, 507, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(902, 'Demi_cune_lab_Sae1976_r.gif', NULL, '2007-02-10 17:35:56', NULL, 6, 10, 507, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(903, 'Demi_cune_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:56', NULL, 1, 10, 507, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(904, 'Demi_cune_map_Sae1976_r.gif', NULL, '2007-02-10 17:35:56', NULL, 2, 10, 507, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(905, 'Demi_cune_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:56', NULL, 82, 10, 507, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(906, 'Demi_cune_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:56', NULL, 7, 10, 507, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1263, 'Gilo_alvi_ant_Sae1977_r.gif', NULL, '2007-02-10 17:35:58', NULL, 5, 26, 1432, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1264, 'Gilo_alvi_lab_Sae1977_r.gif', NULL, '2007-02-10 17:35:58', NULL, 6, 26, 1432, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1265, 'Gilo_alvi_man_Sae1977_r.gif', NULL, '2007-02-10 17:35:58', NULL, 1, 26, 1432, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1266, 'Gilo_alvi_max_Sae1977_r.gif', NULL, '2007-02-10 17:35:58', NULL, 82, 26, 1432, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1267, 'Gilo_alvi_men_Sae1977_r.gif', NULL, '2007-02-10 17:35:58', NULL, 7, 26, 1432, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1268, 'Gilo_alvi_pre_Sae1977_r.gif', NULL, '2007-02-10 17:35:58', NULL, 4, 26, 1432, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1378, 'Hetr_chan_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 451, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1380, 'Hetr_chan_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 451, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1381, 'Hetr_chan_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 451, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1382, 'Hetr_grim_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 442, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1384, 'Hetr_grim_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 442, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1386, 'Hetr_grim_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 442, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1387, 'Hetr_hirt_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 450, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1389, 'Hetr_hirt_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 450, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1390, 'Hetr_hirt_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 450, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1391, 'Hetr_lati_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 1425, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1392, 'Hetr_lati_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 1425, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1393, 'Hetr_lati_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 1425, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1394, 'Hetr_maea_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 447, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1397, 'Hetr_maea_pre_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 31, 447, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1405, 'Hetr_marc_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 453, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1407, 'Hetr_marc_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 453, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1412, 'Hetr_oliv_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 452, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1416, 'Hetr_oliv_men1_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 96, 31, 452, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1417, 'Hetr_oliv_men2_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 97, 31, 452, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1419, 'Hetr_oliv_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 452, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1420, 'Hetr_scut_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 446, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1424, 'Hetr_scut_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 446, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1428, 'Hetr_specA_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 454, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1429, 'Hetr_specA_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 454, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1430, 'Hetr_specB_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 448, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1431, 'Hetr_specC_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 443, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1432, 'Hetr_specC_man_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 31, 443, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1433, 'Hetr_specC_se2_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 76, 31, 443, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1435, 'Hetr_specD_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 445, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1436, 'Hetr_specD_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 445, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1437, 'Hetr_specE_men_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 31, 444, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1438, 'Hetr_specE_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 444, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1440, 'Hetr_subp_ant_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 31, 455, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1441, 'Hetr_subp_lab_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 6, 31, 455, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1442, 'Hetr_subp_man_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 31, 455, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1443, 'Hetr_subp_men1_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 96, 31, 455, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1444, 'Hetr_subp_men2_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 97, 31, 455, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1446, 'Hetr_subp_set_Sae1975_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 31, 455, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1455, 'Hydr_dist_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 737, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1456, 'Hydr_dist_lab_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 6, 10, 737, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1457, 'Hydr_dist_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 737, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1458, 'Hydr_dist_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 737, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1459, 'Hydr_dist_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 737, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1460, 'Hydr_dist_pre_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 10, 737, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1461, 'Hydr_fusc_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 741, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1462, 'Hydr_fusc_apm_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 51, 10, 741, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1463, 'Hydr_fusc_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 741, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1464, 'Hydr_fusc_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 741, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1465, 'Hydr_fusc_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 741, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1466, 'Hydr_fusc_pre_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 10, 741, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1467, 'Hydr_fusc_set_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 10, 741, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1468, 'Hydr_huds_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 746, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1469, 'Hydr_huds_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 746, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1470, 'Hydr_huds_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 746, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1471, 'Hydr_huds_set_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 10, 746, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1473, 'Hydr_joha_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 743, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1475, 'Hydr_joha_apm_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 51, 10, 743, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1476, 'Hydr_joha_lab_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 6, 10, 743, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1478, 'Hydr_joha_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 743, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1480, 'Hydr_joha_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 743, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1482, 'Hydr_joha_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 743, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1484, 'Hydr_joha_pre_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 10, 743, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1485, 'Hydr_lugu_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 742, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1486, 'Hydr_lugu_apm_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 51, 10, 742, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1487, 'Hydr_lugu_lab_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 6, 10, 742, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1488, 'Hydr_lugu_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 742, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1489, 'Hydr_lugu_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 742, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1490, 'Hydr_lugu_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 742, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1491, 'Hydr_lugu_pre_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 10, 742, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1493, 'Hydr_lunz_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 739, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1494, 'Hydr_lunz_apm_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 51, 10, 739, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1495, 'Hydr_lunz_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 739, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1496, 'Hydr_lunz_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 739, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1497, 'Hydr_lunz_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 739, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1498, 'Hydr_lunz_pre_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 10, 739, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1499, 'Hydr_lunz_set_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 10, 739, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1500, 'Hydr_mart_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 738, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1501, 'Hydr_mart_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 738, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1502, 'Hydr_mart_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 738, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1503, 'Hydr_mart_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 738, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1504, 'Hydr_pipe_men1_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 96, 10, 745, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1505, 'Hydr_pipe_men2_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 97, 10, 745, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1506, 'Hydr_pipe_menL3_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 141, 10, 745, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1507, 'Hydr_pipe_pre_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 10, 745, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1508, 'Hydr_pipe_set_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 10, 745, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1509, 'Hydr_pipo_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 744, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1510, 'Hydr_pipo_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 744, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1511, 'Hydr_pipo_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 744, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1512, 'Hydr_pipo_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 744, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1513, 'Hydr_pipo_set_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 10, 744, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1514, 'Hydr_rufu_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 747, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1515, 'Hydr_rufu_lab_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 6, 10, 747, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1516, 'Hydr_rufu_man_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 1, 10, 747, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1517, 'Hydr_rufu_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 747, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1518, 'Hydr_rufu_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 747, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1519, 'Hydr_scap_ant_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 5, 10, 740, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1520, 'Hydr_scap_apm_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 51, 10, 740, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1521, 'Hydr_scap_max_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 82, 10, 740, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1522, 'Hydr_scap_men_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 7, 10, 740, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1523, 'Hydr_scap_pre_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 4, 10, 740, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(1524, 'Hydr_scap_set_Sae1976_r.gif', NULL, '2007-02-10 17:35:59', NULL, 8, 10, 740, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2058, 'Paco_dori_ane_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 10, 26, 411, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2059, 'Paco_dori_ant_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 5, 26, 411, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2060, 'Paco_dori_lab_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 6, 26, 411, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2061, 'Paco_dori_map_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 2, 26, 411, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2062, 'Paco_dori_men_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 7, 26, 411, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2063, 'Paco_roll_ane_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 10, 26, 1470, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2064, 'Paco_roll_ant_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 5, 26, 1470, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2065, 'Paco_roll_lab_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 6, 26, 1470, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2066, 'Paco_roll_man_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 1, 26, 1470, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2067, 'Paco_roll_map_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 2, 26, 1470, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2068, 'Paco_roll_men_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 7, 26, 1470, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2069, 'Paco_roll_pre_Sae1977_r.gif', NULL, '2007-02-10 17:37:13', NULL, 4, 26, 1470, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2584, 'Rhcr_glab_ane_Sae1985_r.gif', NULL, '2007-02-10 17:37:16', NULL, 10, 269, 1491, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2585, 'Rhcr_glab_ant_Sae1985_r.gif', NULL, '2007-02-10 17:37:16', NULL, 5, 269, 1491, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2586, 'Rhcr_glab_lab_Sae1985_r.gif', NULL, '2007-02-10 17:37:16', NULL, 6, 269, 1491, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2587, 'Rhcr_glab_man_Sae1985_r.gif', NULL, '2007-02-10 17:37:16', NULL, 1, 269, 1491, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2588, 'Rhcr_glab_max_Sae1985_r.gif', NULL, '2007-02-10 17:37:16', NULL, 82, 269, 1491, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2589, 'Rhcr_glab_men_Sae1985_r.gif', NULL, '2007-02-10 17:37:16', NULL, 7, 269, 1491, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2615, 'Roba_deme_ane_Pla2003_r.gif', NULL, '2007-02-10 17:37:16', NULL, 10, 23, 251, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(2616, 'Roba_deme_ant_Pla2003_r.gif', NULL, '2007-02-10 17:37:16', NULL, 5, 23, 251, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(2617, 'Roba_deme_men_Pla2003_r.gif', NULL, '2007-02-10 17:37:16', NULL, 7, 23, 251, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(2863, 'Tany_bphu_ant_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 5, 16, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2865, 'Tany_bphu_man_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 1, 16, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2868, 'Tany_bphu_men_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 7, 16, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2871, 'Tany_bphu_pop_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 17, 16, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2873, 'Tany_bphu_pre_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 4, 16, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2924, 'Tany_form_ant_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 5, 16, 553, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2925, 'Tany_form_man_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 1, 16, 553, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2926, 'Tany_form_men_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 7, 16, 553, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2927, 'Tany_form_pre_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 4, 16, 553, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2977, 'Tany_mend_ant_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 5, 16, 532, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2983, 'Tany_mend_man_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 1, 16, 532, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2986, 'Tany_mend_men_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 7, 16, 532, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2990, 'Tany_mend_pop_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 17, 16, 532, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(2991, 'Tany_mend_pre_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 4, 16, 532, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3000, 'Tany_oyam_ant_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 5, 16, 1499, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3002, 'Tany_oyam_man_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 1, 16, 1499, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3004, 'Tany_oyam_men_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 7, 16, 1499, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3006, 'Tany_oyam_pop_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 17, 16, 1499, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3007, 'Tany_oyam_pre_Ekr2002_r.gif', NULL, '2007-02-10 17:37:18', NULL, 4, 16, 1499, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3041, 'Tany_urai_ant_Ekr2002_r.gif', NULL, '2007-02-10 17:37:19', NULL, 5, 16, 1500, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3042, 'Tany_urai_man_Ekr2002_r.gif', NULL, '2007-02-10 17:37:19', NULL, 1, 16, 1500, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3043, 'Tany_urai_men_Ekr2002_r.gif', NULL, '2007-02-10 17:37:19', NULL, 7, 16, 1500, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3044, 'Tany_urai_pre_Ekr2002_r.gif', NULL, '2007-02-10 17:37:19', NULL, 4, 16, 1500, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3271, 'Tany_bphu_ant_Ekr2004_r.gif', NULL, '2007-09-25 12:34:32', NULL, 5, 310, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3272, 'Tany_bphu_man_Ekr2004_r.gif', NULL, '2007-09-25 12:34:50', NULL, 1, 310, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3273, 'Tany_bphu_pre_Ekr2004_r.gif', NULL, '2007-09-25 12:36:43', NULL, 4, 310, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3274, 'Tany_bphu_men_Ekr2004_r.gif', NULL, '2007-09-25 12:38:03', NULL, 7, 310, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3275, 'Tany_bphu_pop_Ekr2004_r.gif', NULL, '2007-09-25 12:43:56', NULL, 17, 310, 537, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3276, 'Tany_dibr_ant_Ekr2004_r.gif', NULL, '2007-09-25 12:46:49', NULL, 5, 310, 528, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3277, 'Tany_dibr_man_Ekr2004_r.gif', NULL, '2007-09-25 12:51:11', NULL, 1, 310, 528, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3278, 'Tany_dibr_pre_Ekr2004_r.gif', NULL, '2007-09-25 12:52:28', NULL, 4, 310, 528, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3279, 'Tany_dibr_men_Ekr2004_r.gif', NULL, '2007-09-25 12:53:23', NULL, 7, 310, 528, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3280, 'Tany_dibr_pop_Ekr2004_r.gif', NULL, '2007-09-25 12:54:19', NULL, 17, 310, 528, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3281, 'Tany_ejun_ant_Ekr2004_r.gif', NULL, '2007-09-25 13:05:09', NULL, 5, 310, 546, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3282, 'Tany_ejun_man_Ekr2004_r.gif', NULL, '2007-09-25 13:08:39', NULL, 1, 310, 546, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3283, 'Tany_ejun_pre_Ekr2004_r.gif', NULL, '2007-09-25 13:09:25', NULL, 4, 310, 546, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3284, 'Tany_ejun_se2_Ekr2004_r.gif', NULL, '2007-09-25 13:10:25', NULL, 76, 310, 546, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3285, 'Tany_ejun_men_Ekr2004_r.gif', NULL, '2007-09-25 13:11:43', NULL, 7, 310, 546, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3286, 'Tany_emin_ant_Ekr2004_r.gif', NULL, '2007-09-25 13:13:37', NULL, 5, 310, 529, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3287, 'Tany_emin_man_Ekr2004_r.gif', NULL, '2007-09-25 13:14:48', NULL, 1, 310, 529, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3288, 'Tany_emin_pre_Ekr2004_r.gif', NULL, '2007-09-25 13:18:33', NULL, 4, 310, 529, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3289, 'Tany_emin_se2_Ekr2004_r.gif', NULL, '2007-09-25 13:53:17', NULL, 76, 310, 529, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3290, 'Tany_emin_men_Ekr2004_r.gif', NULL, '2007-09-25 13:54:04', NULL, 7, 310, 529, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3291, 'Tany_emin_pop_Ekr2004_r.gif', NULL, '2007-09-25 13:55:08', NULL, 17, 310, 529, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3292, 'Tany_grin_ant_Ekr2004_r.gif', NULL, '2007-09-25 14:05:31', NULL, 5, 310, 1518, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3293, 'Tany_grin_man_Ekr2004_r.gif', NULL, '2007-09-25 14:06:23', NULL, 1, 310, 1518, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3294, 'Tany_grin_se2_Ekr2004_r.gif', NULL, '2007-09-25 14:07:43', NULL, 76, 310, 1518, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3295, 'Tany_grin_men_Ekr2004_r.gif', NULL, '2007-09-25 14:08:35', NULL, 7, 310, 1518, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3296, 'Tany_grin_pom_Ekr2004_r.gif', NULL, '2007-09-25 14:09:35', NULL, 18, 310, 1518, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3297, 'Tany_lest_ant_Ekr2004_r.gif', NULL, '2007-09-25 14:17:31', NULL, 5, 310, 540, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3298, 'Tany_lest_man_Ekr2004_r.gif', NULL, '2007-09-25 14:19:00', NULL, 1, 310, 540, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3299, 'Tany_lest_pre_Ekr2004_r.gif', NULL, '2007-09-25 14:19:33', NULL, 4, 310, 540, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3300, 'Tany_lest_men_Ekr2004_r.gif', NULL, '2007-09-25 14:20:31', NULL, 7, 310, 540, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3301, 'Tany_lest_pop_Ekr2004_r.gif', NULL, '2007-09-25 14:28:21', NULL, 17, 310, 540, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3302, 'Tany_luge_ant_Ekr2004_r.gif', NULL, '2007-09-25 14:29:52', NULL, 5, 310, 557, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3303, 'Tany_luge_man_Ekr2004_r.gif', NULL, '2007-09-25 14:30:59', NULL, 1, 310, 557, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3304, 'Tany_luge_pre_Ekr2004_r.gif', NULL, '2007-09-25 14:31:48', NULL, 4, 310, 557, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3305, 'Tany_luge_max_Ekr2004_r.gif', NULL, '2007-09-25 14:32:50', NULL, 82, 310, 557, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3306, 'Tany_luge_lab_Ekr2004_r.gif', NULL, '2007-09-25 14:34:09', NULL, 6, 310, 557, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3307, 'Tany_luge_men_Ekr2004_r.gif', NULL, '2007-09-25 14:35:10', NULL, 7, 310, 557, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3308, 'Tany_masp_ant_Ekr2004_r.gif', NULL, '2007-09-25 14:36:50', NULL, 5, 310, 1519, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3309, 'Tany_masp_man_Ekr2004_r.gif', NULL, '2007-09-25 14:42:36', NULL, 1, 310, 1519, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3310, 'Tany_masp_pre_Ekr2004_r.gif', NULL, '2007-09-25 14:43:27', NULL, 4, 310, 1519, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3311, 'Tany_masp_men_Ekr2004_r.gif', NULL, '2007-09-25 14:44:25', NULL, 7, 310, 1519, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3312, 'Tany_masp_pop_Ekr2004_r.gif', NULL, '2007-09-25 14:45:34', NULL, 17, 310, 1519, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3313, 'Tany_medi_ant_Ekr2004_r.gif', NULL, '2007-09-25 15:34:13', NULL, 5, 310, 533, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3314, 'Tany_medi_man_Ekr2004_r.gif', NULL, '2007-09-25 15:34:32', NULL, 1, 310, 533, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3315, 'Tany_medi_pre_Ekr2004_r.gif', NULL, '2007-09-25 15:35:45', NULL, 4, 310, 533, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3316, 'Tany_medi_prm_Ekr2004_r.gif', NULL, '2007-09-25 15:43:19', NULL, 92, 310, 533, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3317, 'Tany_medi_chb_Ekr2004_r.gif', NULL, '2007-09-25 15:44:31', NULL, 156, 310, 533, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3318, 'Tany_medi_men_Ekr2004_r.gif', NULL, '2007-09-25 15:45:28', NULL, 7, 310, 533, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3319, 'Tany_medi_pop_Ekr2004_r.gif', NULL, '2007-09-25 15:46:20', NULL, 17, 310, 533, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3320, 'Tany_occu_ant_Ekr2004_r.gif', NULL, '2007-09-25 15:50:49', NULL, 5, 310, 538, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3321, 'Tany_occu_men_Ekr2004_r.gif', NULL, '2007-09-25 15:51:41', NULL, 7, 310, 538, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3322, 'Tany_occu_pop_Ekr2004_r.gif', NULL, '2007-09-25 15:52:40', NULL, 17, 310, 538, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3323, 'Tany_psle_ant_Ekr2004_r.gif', NULL, '2007-09-25 15:55:39', NULL, 5, 310, 1520, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3324, 'Tany_psle_man_Ekr2004_r.gif', NULL, '2007-09-25 15:56:11', NULL, 1, 310, 1520, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3325, 'Tany_psle_men_Ekr2004_r.gif', NULL, '2007-09-25 15:56:53', NULL, 7, 310, 1520, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3326, 'Tany_psle_pop_Ekr2004_r.gif', NULL, '2007-09-25 15:57:49', NULL, 17, 310, 1520, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3327, 'Tany_stia_ant_Ekr2004_r.gif', NULL, '2007-09-25 15:59:37', NULL, 5, 310, 1521, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3328, 'Tany_stia_se2_Ekr2004_r.gif', NULL, '2007-09-25 16:00:14', NULL, 76, 310, 1521, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3329, 'Tany_stia_man_Ekr2004_r.gif', NULL, '2007-09-25 16:01:02', NULL, 1, 310, 1521, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3330, 'Tany_stia_pre_Ekr2004_r.gif', NULL, '2007-09-25 16:01:48', NULL, 4, 310, 1521, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3331, 'Tany_stia_men_Ekr2004_r.gif', NULL, '2007-09-25 16:02:41', NULL, 7, 310, 1521, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3332, 'Tany_stia_pop_Ekr2004_r.gif', NULL, '2007-09-25 16:03:34', NULL, 17, 310, 1521, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3333, 'Tany_telm_ant_Ekr2004_r.gif', NULL, '2007-09-26 10:52:32', NULL, 5, 310, 556, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3334, 'Tany_telm_man_Ekr2004_r.gif', NULL, '2007-09-26 10:52:43', NULL, 1, 310, 556, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3335, 'Tany_telm_pre_Ekr2004_r.gif', NULL, '2007-09-26 10:53:24', NULL, 4, 310, 556, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3336, 'Tany_telm_se2_Ekr2004_r.gif', NULL, '2007-09-26 10:54:06', NULL, 76, 310, 556, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3337, 'Tany_telm_men_Ekr2004_r.gif', NULL, '2007-09-26 10:55:08', NULL, 7, 310, 556, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3338, 'Tany_telm_pop_Ekr2004_r.gif', NULL, '2007-09-26 10:55:59', NULL, 17, 310, 556, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3339, 'Tany_volg_ant_Ekr2004_r.gif', NULL, '2007-09-26 10:59:06', NULL, 5, 310, 549, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3340, 'Tany_volg_man_Ekr2004_r.gif', NULL, '2007-09-26 11:00:12', NULL, 1, 310, 549, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3341, 'Tany_volg_pre_Ekr2004_r.gif', NULL, '2007-09-26 11:01:03', NULL, 4, 310, 549, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3342, 'Tany_volg_men_Ekr2004_r.gif', NULL, '2007-09-26 11:03:17', NULL, 7, 310, 549, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3343, 'Tany_volg_pop_Ekr2004_r.gif', NULL, '2007-09-26 11:04:26', NULL, 17, 310, 549, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3351, 'Eurh_cili_hve_NHMLond_r.jpeg', NULL, '2007-10-12 22:16:24', NULL, 94, 314, 518, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3352, 'Eurh_cili_ant_NHMLond_r.jpeg', NULL, '2007-10-12 22:16:52', NULL, 5, 314, 518, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3353, 'Eurh_cili_fap_NHMLond_r.jpeg', NULL, '2007-10-13 20:21:38', NULL, 45, 314, 518, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3354, 'Eurh_cili_man_NHMLond_r.jpeg', NULL, '2007-10-13 20:27:47', NULL, 1, 314, 518, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3355, 'Eurh_cili_max_NHMLond_r.jpeg', NULL, '2007-10-13 20:32:01', NULL, 82, 314, 518, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3356, 'Eurh_cili_men_NHMLond_r.jpeg', NULL, '2007-10-13 20:34:02', NULL, 7, 314, 518, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3357, 'Eurh_cili_pom_NHMLond_r.jpeg', NULL, '2007-10-13 20:37:04', NULL, 18, 314, 518, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3358, 'Bril_bifi_ant_NHMLond_r.jpeg', 'same antenna', '2007-10-13 21:08:45', '2007-10-13 21:09:16', 5, 314, 358, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3359, 'Bril_bifi_fap_NHMLond_r.jpeg', NULL, '2007-10-13 21:09:33', NULL, 45, 314, 358, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3360, 'Bril_bifi_hve_NHMLond_r.jpeg', NULL, '2007-10-13 21:10:53', NULL, 94, 314, 358, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3361, 'Bril_bifi_man_NHMLond_r.jpeg', NULL, '2007-10-13 21:11:05', NULL, 1, 314, 358, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3362, 'Bril_bifi_max_NHMLond_r.jpeg', NULL, '2007-10-13 21:11:23', NULL, 82, 314, 358, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3363, 'Bril_bifi_men_NHMLond_r.jpeg', NULL, '2007-10-13 21:11:44', NULL, 7, 314, 358, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3364, 'Bril_bifi_pom_NHMLond_r.jpeg', NULL, '2007-10-13 21:12:36', NULL, 18, 314, 358, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3365, 'Bril_lofu_hve_NHMLond_r.jpeg', 'original view', '2007-10-13 21:14:51', NULL, 94, 314, 1524, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3366, 'Bril_lofu_men_NHMLond_r.jpeg', 'right broken part: rotated', '2007-10-13 21:16:03', NULL, 7, 314, 1524, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3367, 'Bril_lofu_pom_NHMLond_r.jpeg', 'right broken part rotated', '2007-10-13 21:18:02', NULL, 18, 314, 1524, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3368, 'Bril_lofu_ant_NHMLond_r.jpeg', NULL, '2007-10-13 21:28:25', NULL, 5, 314, 1524, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3369, 'Bril_lofu_max_NHMLond_r.jpeg', NULL, '2007-10-13 21:28:45', NULL, 82, 314, 1524, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3370, 'Einf_dide_hve_NHMLond_r.jpeg', NULL, '2007-10-13 21:47:44', NULL, 94, 314, 418, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3371, 'Einf_dide_men_NHMLond_r.jpeg', NULL, '2007-10-13 21:48:00', NULL, 7, 314, 418, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3372, 'Einf_dide_man_NHMLond_r.jpeg', NULL, '2007-10-13 22:00:09', NULL, 1, 314, 418, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3373, 'Einf_dide_eph_NHMLond_r.jpeg', NULL, '2007-10-13 22:00:36', NULL, 58, 314, 418, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3374, 'Einf_dide_ant_NHMLond_r.jpeg', NULL, '2007-10-13 22:13:02', NULL, 5, 314, 418, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3375, 'Cone_coro_ant_NHMLond_r.jpeg', 'det P.S.Cranston 1978', '2007-10-17 22:35:23', NULL, 5, 314, 757, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3376, 'Cone_coro_hed_NHMLond_r.jpeg', 'det P.S.Cranston 1978', '2007-10-17 22:36:15', NULL, 11, 314, 757, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3377, 'Cone_coro_man_NHMLond_r.jpeg', 'only lateral view', '2007-10-17 22:39:42', NULL, 1, 314, 757, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3378, 'Cone_coro_pah_NHMLond_r.jpeg', 'scale like pattern (det P.S.Cranston 1978)', '2007-10-17 22:40:09', NULL, 157, 314, 757, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3379, 'Cone_coro_men_NHMLond_r.jpeg', 'det P.S.Cranston 1978', '2007-10-17 22:41:58', NULL, 7, 314, 757, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3380, 'Cone_coro_eph_NHMLond_r.jpeg', 'det P.S.Cranston 1978', '2007-10-17 22:42:16', NULL, 58, 314, 757, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3381, 'Cric_triu_ant_NHMLond_r.jpeg', 'left and right', '2007-10-17 22:43:41', NULL, 5, 314, 623, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3382, 'Cric_triu_eph_NHMLond_r.jpeg', NULL, '2007-10-17 22:44:15', NULL, 58, 314, 623, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3383, 'Cric_triu_hed_NHMLond_r.jpeg', NULL, '2007-10-17 22:44:31', NULL, 11, 314, 623, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3384, 'Cric_triu_man_NHMLond_r.jpeg', NULL, '2007-10-17 22:45:00', NULL, 1, 314, 623, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3385, 'Cric_triu_max_NHMLond_r.jpeg', NULL, '2007-10-17 22:45:13', NULL, 82, 314, 623, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3394, 'Cone_arti_hed_PlaXXXX_r.jpeg', 'arctica type', '2007-10-18 22:21:26', '2008-05-27 12:06:30', 11, 296, 1527, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3395, 'Cone_arti_man_PlaXXXX_r.jpeg', 'arctica-type', '2007-10-18 22:21:54', NULL, 1, 296, 1527, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3396, 'Cone_arti_men_PlaXXXX_r.jpeg', 'arctica-type', '2007-10-18 22:22:14', NULL, 7, 296, 1527, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3397, 'Cone_arti_pah_PlaXXXX_r.jpeg', 'arctica-type (ventral view)', '2007-10-18 22:22:56', NULL, 157, 296, 1527, 'Creative Commons Noncommercial Share Alike', '2008-05-27', 1),
(3772, 'OrthSy_anne_pre_Sae2003_r.gif', 'with brush', '2008-01-04 16:10:14', NULL, 4, 374, 669, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3773, 'OrthSy_schn_lab_Sae2003_r.gif', 'premandible with weak brush', '2008-01-04 16:11:47', NULL, 6, 374, 1586, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3774, 'OrthSy_schn_ant_Sae2003_r.gif', NULL, '2008-01-04 16:13:35', NULL, 5, 374, 1586, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3775, 'OrthSy_schn_max_Sae2003_r.gif', 'with pecten galearis (weak)', '2008-01-04 16:21:56', NULL, 82, 374, 1586, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3776, 'OrthSy_schn_man_Sae2003_r.gif', NULL, '2008-01-04 16:22:21', NULL, 1, 374, 1586, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3777, 'OrthSy_schn_men_Sae2003_r.gif', NULL, '2008-01-04 16:22:42', NULL, 7, 374, 1586, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3778, 'OrthSy_hosa_ant_Sae2003_r.gif', 'AR: 1.87&ndash;2.36\r\nblade ratio:0.85\r\nRO ratio: 0.14', '2008-01-04 16:29:10', NULL, 5, 374, 1587, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3781, 'OrthSy_hosa_pre_Sae2003_r.gif', 'with pecten epipharyngis', '2008-01-04 16:30:41', NULL, 4, 374, 1587, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3782, 'OrthSy_halv_ant_Sae2003_r.gif', 'AR: 1.42\r\nblade ratio: 1.27\r\nRO ratio: 0.31', '2008-01-04 16:34:54', NULL, 5, 374, 1588, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3783, 'OrthSy_halv_man_Sae2003_r.gif', NULL, '2008-01-04 16:35:11', NULL, 1, 374, 1588, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3784, 'OrthSy_halv_men_Sae2003_r.gif', 'middle TR: 2.08\r\nmiddle to 1st-lat TR: 6', '2008-01-04 16:35:27', NULL, 7, 374, 1588, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3785, 'OrthSy_halv_pre_Sae2003_r.gif', 'weak brush', '2008-01-04 16:36:05', NULL, 4, 374, 1588, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3895, 'Metr_brus_ant_Sae1989_r.gif', NULL, '2008-01-31 17:46:12', NULL, 5, 405, 1608, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3896, 'Metr_brus_lab_Sae1989_r.gif', NULL, '2008-01-31 17:46:45', NULL, 6, 405, 1608, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3897, 'Metr_brus_man_Sae1989_r.gif', NULL, '2008-01-31 17:47:01', NULL, 1, 405, 1608, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3898, 'Metr_brus_max_Sae1989_r.gif', NULL, '2008-01-31 17:47:15', NULL, 82, 405, 1608, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3899, 'Metr_brus_men_Sae1989_r.gif', NULL, '2008-01-31 17:47:36', NULL, 7, 405, 1608, 'Author provides usage (journals not checked)', '2008-05-27', 1),
(3900, 'Metr_brus_prc_Sae1989_r.gif', NULL, '2008-01-31 17:47:48', NULL, 80, 405, 1608, 'Author provides usage (journals not checked)', '2008-05-27', 1);

-- --------------------------------------------------------

--
-- Table structure for table `morph_attrib`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `morph_attrib`;
CREATE TABLE IF NOT EXISTS `morph_attrib` (
  `id` smallint(4) unsigned NOT NULL AUTO_INCREMENT COMMENT 'automatic ID',
  `morph_short` varchar(7) NOT NULL COMMENT 'at least 3 characters (at 3rd position of the file name)',
  `morph_long` varchar(150) NOT NULL COMMENT 'morphological term',
  `morph_select` enum('0','1') NOT NULL DEFAULT '0' COMMENT 'morphological structure, that can be selected seperately in the menue',
  `img_width_default` smallint(3) unsigned NOT NULL DEFAULT '150' COMMENT 'default image wight',
  PRIMARY KEY (`id`),
  UNIQUE KEY `morph_short_2` (`morph_short`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='abbreviated morphoogical characters and attributes' AUTO_INCREMENT=171 ;

--
-- Dumping data for table `morph_attrib`
--

INSERT INTO `morph_attrib` (`id`, `morph_short`, `morph_long`, `morph_select`, `img_width_default`) VALUES
(1, 'man', 'mandible', '1', 100),
(2, 'map', 'maxillar palp', '0', 60),
(3, 'vep', 'ventromantal plate', '0', 150),
(4, 'pre', 'premandible', '1', 50),
(5, 'ant', 'antenna', '1', 60),
(6, 'lab', 'labro-epipharyngeal region', '1', 150),
(7, 'men', 'mentum', '1', 200),
(8, 'set', 'setae S1, ...', '0', 50),
(10, 'ane', 'anal end', '0', 100),
(11, 'hed', 'head capsule', '1', 150),
(12, 'cpp', 'claws posterior parapods', '0', 80),
(13, 'cap', 'claws of anterior parapods', '0', 80),
(14, 'peh', 'pecten hypopharyngis', '0', 80),
(15, 'pee', 'pecten epipharyngis', '0', 80),
(16, 'lig', 'ligula', '1', 80),
(17, 'pop', 'postoccipital plate', '1', 100),
(18, 'pom', 'postoccipital margin', '1', 100),
(20, 'las', 'lateral setae', '0', 40),
(21, 'abd', 'abdomen', '0', 100),
(28, 'ltu', 'lateral tubuli', '0', 80),
(29, 'atu', 'anal tubuli', '0', 80),
(31, 'vtu', 'ventral tubuli', '0', 80),
(37, 'gul', 'gula', '0', 100),
(39, 'lar', 'larvae (eg. whith cocon)', '0', 100),
(44, 'hel', 'head lateral', '0', 100),
(45, 'fap', 'fronto clypeaus/apoptom', '0', 100),
(47, 'prt', 'prothorax', '0', 100),
(48, 'lbs', 'labral sensillum', '0', 50),
(49, 'ouh', 'outer hooks', '0', 80),
(50, 'abl', 'abdomen lateral', '0', 100),
(51, 'apm', 'apex of prementum', '0', 80),
(52, 'pal', 'palatum', '0', 100),
(53, 'anp', 'antennal pedestal', '0', 100),
(54, 'se3', 'seta S3', '0', 50),
(55, 'dor', 'dorsal structure', '0', 40),
(56, 'hyp', 'hypopharynx', '0', 100),
(57, 'cly', 'clypaeus', '0', 100),
(58, 'eph', 'epipharynx', '0', 100),
(59, 'lac', 'anterior lacinial chaeta on mandible', '0', 50),
(75, 'se1', 'seta S1', '0', 40),
(76, 'se2', 'seta S2', '0', 40),
(77, 'lal', 'labral lamella', '0', 50),
(78, 'ssd', 'seta subdentalis', '0', 50),
(79, 'eye', 'eye spot', '0', 80),
(80, 'prc', 'procerus', '0', 50),
(81, 'bru', 'brush', '0', 50),
(82, 'max', 'maxilla', '0', 100),
(83, 'hds', 'head dorsal', '0', 150),
(84, 'mad', 'mandible (dorsal)', '0', 100),
(85, 'hes', 'head setation <br>ventral - dorsal <br>left - right', '1', 200),
(86, 'abs', 'abdominal segment(s)', '0', 80),
(87, 'aan', 'apex of antenna', '0', 80),
(88, 'spp', 'spin on posterior parapods', '0', 80),
(90, 'phc', 'premento-hypopharyngeal-complex', '0', 80),
(91, 'lpt', 'larval pupal tube', '0', 80),
(92, 'prm', 'praementum', '0', 80),
(93, 'abs11', 'abdominal segment 11', '0', 100),
(94, 'hve', 'head ventral', '0', 150),
(95, 'prd', 'procerci dorsal', '0', 90),
(96, 'men1', 'mentum 1', '0', 200),
(97, 'men2', 'mentum 2', '0', 200),
(98, 'hev', 'head setation ventral', '0', 200),
(99, 'hdo', 'head setation dorsal', '0', 200),
(102, 'hds1', 'head dorsal 1', '0', 150),
(103, 'hve1', 'head ventral 1', '0', 150),
(104, 'hds2', 'head dorsal 2', '0', 150),
(105, 'hve2', 'head ventral 2', '0', 150),
(106, 'spr', 'seta premandibularis', '0', 50),
(107, 'pom2', 'postoccipital margin 2', '0', 100),
(108, 'pom1', 'postoccipital margin 1', '0', 100),
(109, 'abs1', 'abdominal segment 1', '0', 100),
(110, 'abs2', 'abdominal segment 2', '0', 100),
(111, 'abs3', 'abdominal segment 3', '0', 100),
(112, 'abs4', 'abdominal segment 4', '0', 100),
(113, 'abs5', 'abdominal segment 5', '0', 100),
(114, 'abs6', 'abdominal segment 6', '0', 100),
(115, 'abs7', 'abdominal segment 7', '0', 100),
(116, 'abs8', 'abdominal segment 8', '0', 100),
(117, 'abs9', 'abdominal segment 9', '0', 100),
(118, 'abs10', 'abdominal segment 10', '0', 100),
(119, 'hel1', 'head lateral 1', '0', 100),
(120, 'hel2', 'head lateral 2', '0', 100),
(121, 'las1', 'lateral setae 1', '0', 40),
(122, 'las2', 'lateral setae 2', '0', 40),
(123, 'las3', 'lateral setae 3', '0', 40),
(124, 'las4', 'lateral setae 4', '0', 40),
(125, 'las5', 'lateral setae 5', '0', 40),
(126, 'las6', 'lateral setae 6', '0', 40),
(127, 'las7', 'lateral setae 7', '0', 40),
(128, 'las8', 'lateral setae 8', '0', 40),
(129, 'las9', 'lateral setae 9', '0', 40),
(130, 'las10', 'lateral setae 10', '0', 40),
(131, 'sei', 'seta interna (mandible)', '0', 80),
(132, 'chl', 'chaetula laterales', '0', 50),
(133, 'chl1', '1st chaetula laterales', '0', 50),
(134, 'pli', 'paraligula', '0', 100),
(135, 'map-', 'maxillar palp?', '0', 60),
(136, 'laba', 'labro-epipharyngeal region (a)', '0', 150),
(137, 'labb', 'labro-epipharyngeal region (b)', '0', 150),
(141, 'menL3', 'mentum (L3)', '0', 200),
(142, 'pop1', 'postoccipital plate (speciemen 1)', '0', 100),
(143, 'pop2', 'postoccipital plate (speciemen 2)', '0', 100),
(144, 'men3', 'mentum 3', '0', 200),
(145, 'anp1', 'antennal pedestal 1', '0', 100),
(146, 'anp2', 'antennal pedestal 2', '0', 100),
(147, 'man1', 'mandible 1', '0', 100),
(148, 'man2', 'mandible 2', '0', 100),
(149, 'hed1', 'head capsule 1', '0', 150),
(150, 'hed2', 'head capsule 2', '0', 150),
(151, 'menL1', 'mentum (L1)', '0', 200),
(152, 'menL2', 'mentum (L2)', '0', 200),
(153, 'antL1', 'antenna (L1)', '0', 60),
(154, 'antL2', 'antenna (L2)', '0', 60),
(155, 'antL3', 'antenna (L3)', '0', 60),
(156, 'chb', 'chaetulae basalis', '0', 50),
(157, 'pah', 'pattern on head', '0', 50),
(158, 'stv', 'striae on ventromental plates', '0', 50),
(159, 'hya', 'hypopharynx (appendage)', '0', 80),
(160, 'mab', 'maxillar palp (basal segment)', '0', 50),
(161, 'mea', 'mentum with M appendage', '0', 150),
(162, 'lav', 'labrum ventral', '0', 150),
(163, 'lad', 'labrum dorsal', '0', 150),
(164, 'maa', 'maxillar palp (apical)', '0', 80),
(165, 'ant1', 'antennal segment 1', '0', 60),
(166, 'cop', 'claws of parapods', '0', 80),
(167, 'mandet', 'mandible detail (eg. apical part)', '0', 100),
(168, 'ubs', 'ungula basal sclerite', '0', 100),
(169, 'manw', 'mandible (worn)', '0', 100),
(170, 'menw', 'mentum (worn)', '0', 200);

-- --------------------------------------------------------

--
-- Table structure for table `names_authors`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:44 AM
-- Last check: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_authors`;
CREATE TABLE IF NOT EXISTS `names_authors` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'automatic id number',
  `authors_short` varchar(40) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'shown in popups<br>>2 authors eg.: Heiri et al. 2004<br><3 authors: Pinder and Reiss 1983',
  `literal` varchar(1) NOT NULL COMMENT 'automatic literal a, b ... of year',
  `author_filename` varchar(11) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'automatic filename',
  `author_names` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT 'all author names abbreviated:<br>Geiger, H. J., Ryser H.M. and Scholl, A.',
  `year` int(4) NOT NULL COMMENT 'eg.: 1999 or 0 if no year can be given',
  `author_mail` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'authors mail <br> the @-sign is changed to '' at '' automatically',
  `author_address` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'address of author',
  `editor_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'editor''s name',
  `edition` varchar(2) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'edition',
  `publisher_name` varchar(255) DEFAULT NULL COMMENT 'publisher''s name',
  `title` text CHARACTER SET utf8 COLLATE utf8_unicode_ci COMMENT 'full title',
  `journal` varchar(250) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'journal, booktitle, school, series ...',
  `journal_url` varchar(200) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'weblink to literature source',
  `volume` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `number` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `page` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'pages: eg. 234-246 or 324',
  `month` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci DEFAULT NULL,
  `abstract` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  `note` text CHARACTER SET utf8 COLLATE utf8_unicode_ci COMMENT 'annotations',
  `keywords` text COMMENT 'comma separated keywords for  categorizing ',
  `entry_type` enum('no entry type given','article','book','booklet','conference','inbook','incollection','inproceedings','manual','mastersthesis','misc','phdthesis','proceedings','techreport','unpublished','online') DEFAULT 'no entry type given' COMMENT 'entry type as in BibTeX/biblatex-package',
  PRIMARY KEY (`id`),
  UNIQUE KEY `author_filename` (`author_filename`),
  FULLTEXT KEY `note` (`note`),
  FULLTEXT KEY `abstract` (`abstract`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='bibliography' AUTO_INCREMENT=584 ;

--
-- Dumping data for table `names_authors`
--

INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(1, 'Heiri et al. 2004', '', 'Hei2004', 'Heiri, O., Ekrem, T. and Willassen, E.', 2004, NULL, NULL, NULL, NULL, NULL, 'Larval head capsules of European Micropsectra, Paratanytarsus and Tanytarsus (Diptera: Chironomidae: Tanytarsini) version 1.0', NULL, 'http://www3.bio.uu.nl/palaeo/Chironomids/Tanytarsini/intro.htm', NULL, NULL, NULL, '24. August', NULL, NULL, 'Tanytarsini, Micropsectra aristata, Micropsectra atrofasciata, Micropsectra bidentata, Micropsectra contracta, Micropsectra groenlandica, Micropsectra junci, Micropsectra pharetrophora, Micropsectra radialis, Micropsectra seguyi, Paratanytarsus austriacus, Paratanytarsus bituberculatus, Paratanytarsus penicillatus, Tanytarsus bathophilus, Tanytarsus brundini, Tanytarsus buchonius, Tanytarsus chinyensis, Tanytarsus dibranchius, Tanytarsus ejuncidus, Tanytarsus eminulus, Tanytarsus formosanus, Tanytarsus gibbosiceps, Tanytarsus gracilentus, Tanytarsus gregarius/inaequalis, Tanytarsus lactescens, Tanytarsus lapponicus, Tanytarsus lestagei, Tanytarsus lugens, Tanytarsus mancospinosus, Tanytarsus medius, Tanytarsus mendax, Tanytarsus nemorosus, Tanytarsus occultus, Tanytarsus pseudolestagei, Tanytarsus signatus, Tanytarsus striatulus, Tanytarsus telmaticus, Tanytarsus usmaensis, Tanytarsus volgensis, Tanytarsus sp. C, Constempellina brevicosta, Rheotanytarsus pentapoda, Cladotanytarsus pallidus', 'article'),
(2, 'Pinder and Reiss 1983', '', 'WCh1983', 'Pinder, L. C. V. and Reiss, F.', 1983, NULL, NULL, 'Wiederholm, T.', NULL, NULL, 'The larvae of Chironominae (Diptera: Chironomidae) of the Holarctic region', 'Chironomidae of Holarctic region - Keys and diagnoses (Part 1 - Larvae), Entomologica Scandinavica Supplement', NULL, '19', NULL, '293-436', NULL, NULL, NULL, 'determination key, larvae', 'incollection'),
(3, 'Soponis 1977', '', 'Sop1977', 'Soponis, A. R.', 1977, NULL, NULL, NULL, NULL, NULL, 'A revision of the nearctic species of Orthocladius (Orthocladius) van der Wulp (Diptera: Chironomidae)', 'Memoirs of the entomological society of Canada', NULL, '102', NULL, '1-187', NULL, NULL, NULL, '', 'no entry type given'),
(4, 'Oliver and Roussel 1983', '', 'Oli1983', 'Oliver, D. R. and Roussel, M. E.', 1983, NULL, NULL, NULL, NULL, NULL, 'The Genera of Larval Midges of Canada. Diptera: Chironomidae', 'In: The Insects and Arachnids of Canada. Biosystematics Research Institute Ottawa, Ontario. Publication 1746', NULL, '11', NULL, '263', NULL, NULL, NULL, NULL, 'book'),
(5, 'Candle Lake n.d.', '', 'CLa', 'Candle Lake', 0, NULL, NULL, NULL, NULL, NULL, 'A taxonomic guide to some macroinvertebrates collected from Candle Lake, Saskatchewan', NULL, 'http://www.usask.ca/biology/skabugs/index.html', NULL, NULL, NULL, NULL, NULL, NULL, 'determination guide', 'online'),
(6, 'Epler 2001', '', 'Epl2001', 'Epler, J. H.', 2001, NULL, NULL, NULL, NULL, NULL, 'Identification manual for the larval Chironomidae (Diptera) of North and South Carolina (PhD)', NULL, 'http://www.esb.enr.state.nc.us/BAUwww/Chironomid.htm', NULL, NULL, NULL, '27. September', NULL, NULL, 'determination key', 'manual'),
(7, 'Morozova 2000', '', 'Mo2000', 'Morozova, E. E.', 2000, NULL, NULL, NULL, NULL, NULL, 'The volga region species of <EM>Cryptochironomus</EM> ex gr. <EM>defectus</EM> Kieffer (Diptera, Chironomidae): problems of diagostics', 'Late 20th century research on Chironomidae: An Anthology from the 13th International Symposion on Chironomidae (Shaker Verlag, Aachen)', NULL, NULL, NULL, '193 - 196', NULL, 'with OCR: While realising the diagnostics of Cryptochironomus Kieffer species the most difficult is to\r\nidentify Cryptochironomus ex gr. defectus larva, pupa and image, which differ from each other\r\nrather well in a number of attributes (Lenz 1921, Hamisch 1924, Pagast 1931, Goetghebuer\r\n1937, Shilova 1965, 1966, Reiss 1968, Rodova 1978, Langton 1984). Morphological and\r\nkaryotypic comparative analysis of the Volga region species of Cryptochironomus ex gr.\r\ndefectus has made it possible to single out seven species of this group: C. obreptans Walk., C.\r\nsupplicans Meig., C. albofasciatus Staeg., C. psittacinus Meig., C. redekei Krus., C. defectus\r\nKieff., C. sp.', NULL, '', 'no entry type given'),
(8, 'Vallenduuk et al. 1997', '', 'Val1997', 'Vallenduuk, H. J., Moller-Pillot, H. K. M., van der Velde, J. A., Wiersma, S. M. and bij de Vaate, A.', 1997, NULL, NULL, NULL, NULL, NULL, 'Bijdrag tot de kennis der Nederlandse Chironomidae (vedermuggen): de larven van het genus Chironomus', 'Lelystad, Rijksinstituut voor Integraal Zoetwaterbeheer &#038; Afvalwaterbehandeling, rapport nr. 97.053, ISBN 9036951003', NULL, NULL, NULL, '1-38', NULL, NULL, 'Vallenduuk 1997 -> Vallenduuk et al. 1997 (Mo Dec 14 2009)', 'Chironomus aberratus, Chironomus acidophilus, Chironomus acutiventris, Chironomus agilis, Chironomus annularius, Chironomus anthracinus, Chironomus aprilinus, Chironomus baltonicus, Chironomus bernensis, Chironomus cingulatus, Chironomus commutatus, Chironomus crassimanus, Chironomus dorsalis, Chironomus holomelas, Chironomus lacunarius, Chironomus longipes, Chironomus luridus, Chironomus melanescens, Chironomus melanotus, Chironomus muratensis, Chironomus nudiventris, Chironomus obtusidens, Chironomus pallidivittatus, Chironomus piger, Chironomus plumosus, Chironomus pseudothummi, Chironomus riihimakiensis, Chironomus riparius, Chironomus salinarius, Chironomus saxatilis, Chironomus sororius, Chironomus striatus, Chironomus tentans, Chironomus uliginosus', 'article'),
(9, 'Geiger et al. 1978', '', 'Gei1978', 'Geiger, H. J., Ryser, H. M. and Scholl, A.', 1978, NULL, NULL, NULL, NULL, NULL, 'Bestimmungsschlüssel für die Larven von 18 Zuckmückenarten der Gattung Chironomus Meigen (Diptera, Chironomidae) [Determination guide for 18 species of chironomids of genus Chironomus Meig. (Dipt., Chir.)]', 'Mitteilungen der Naturforschenden Gesellschaft in Bern', NULL, 'N.F. 35', NULL, '89-106', NULL, NULL, 'ISSN 0077-6130, cited from {citeID|8|Vallenduuk 1997}, ?in German', 'Chironomus, determination guide', 'article'),
(10, 'Sæther 1976', '', 'Sae1976', 'Sæther, O. A.', 1976, NULL, NULL, NULL, NULL, NULL, 'Revision of Hydrobaenus Fries, Trissocladius Kieffer, Zalutschia Lipina, Paratrissocladius Zavrel and some related genera (Diptera: Chironomidae)', 'Bulletin of the Fisheries Research Board of Canada', NULL, '195', NULL, '1-287', NULL, NULL, NULL, '', 'no entry type given'),
(11, 'Guo 1994', '', 'Guo1994', 'Guo, X.', 1994, '', '', NULL, '', NULL, 'Chinese records of chironomid larvae from south lake, Wuhan; China', 'J. Huazhong. agric. Univ.', '', '13', '6', '621-624', '', NULL, NULL, '', 'no entry type given'),
(12, 'Klink and Moller-Pillot 2003', '', 'Kli2003', 'Klink, A. G. and Moller-Pillot, H. K. M.', 2003, '', '', NULL, '', NULL, 'Chironomidae Larvae - Key to the Higher Taxa and Species of the Lowlands of Northwestern Europe. Version: 1.0. CD-Key', 'ISBN: 90-75000-58-8', 'http://www.eti.uva.nl/', NULL, NULL, NULL, '', NULL, NULL, '', 'no entry type given'),
(13, 'Chartiers Creek 1999', '', 'Cha1999', 'Charters Creek', 1999, '', '', NULL, '', NULL, 'Stream Macroinvertebrates in the Chartiers Creek Watershed January 1999 Pictures (W &#038; J Student captured pictures)', '', 'http://www.washjeff.edu/Chartiers/Chartier/RunningWaters/InsectPics.html', NULL, NULL, NULL, '', NULL, NULL, '', 'no entry type given'),
(14, 'Klink 1983', '', 'Kli1983', 'Klink, A. G.', 1983, NULL, NULL, NULL, NULL, NULL, 'Key to the dutch larvae of Paratanytarsus Thienemann & Bause with a note on the ecology and the phylogenetic relations', 'Orgaan van Hydrobiologisch Adviesburo ir. A.G. Klink, Medeklinker Nr.3, juni 1983', NULL, NULL, NULL, '1-36', NULL, 'A key to the Dutch larvae of Paratanytarsus Thienemann & Bause is presented, in which the following taxa are described: P. austriacus, P. confusus, P. inopertus, P. intricatus, P. lauterborni, P. tenellulus, P. tenuis aggregate, P. spec. 1. A note is made on the ecology and the phylogenetic relationships of these taxa are discussed, by means of an argumentation scheme of preliminary nature.', NULL, 'Paratanytarsus  austriacus, Paratanytarsus  confusus, Paratanytarsus  inopertus, Paratanytarsus  intricatus, Paratanytarsus  lauterborni, Paratanytarsus  tenellulus, Paratanytarsus  tenuis aggregate, Paratanytarsus  sp. 1, determination key', 'booklet'),
(15, 'Rieradevall and Brooks 2001', '', 'Rie2001', 'Rieradevall, M. and Brooks, S. J.', 2001, NULL, NULL, NULL, NULL, NULL, 'An identification guide to subfossil Tanypodinae larvae (Insecta: Diptera: Chironomidae) based on cephalic setation', 'Journal of Paleolimnology', NULL, '25', NULL, '81-99', NULL, NULL, NULL, 'Ablabesmyia (Ablabesmyia) monilis, Ablabesmyia longistyla, Ablabesmyia phatta, Apsectrotanypus trifascipennis, Arctopelopia griseipennis, Brundiniella eumorpha, Clinotanypus pinguis, Coelotanypus concinnus, Conchapelopia melanops, Derotanypus sp, determination key, Djalmabatista pulcher, Guttipelopia guttipennis, Hayesomyia senata, Hudsonimyia karelena, identification, Krenopelopia sp, Labrundinia longipalpis, Larsia sp, Macropelopia adaucta, Monopelopia tenuicalar, Natarsia punctata, Nilotanypus dubius, Paramerina divisa, Paramerina ignobilis, Paramerina sp, Pentaneura sp, Pentaneurella katerjokki, Procladius choreus, Psectrotanypus varipes, Rheopelopia perda, Tanypodinae, Tanypus punctipennis, Telmatopelopia nemorum, Telopelopia okoboji, Thienemannimyia geijskesi, Thienemannimyia northumbrica, Thienemannimyia pseudothummi, Trissopelopia longimana, Xenopelopia falcigera, Zavrelimyia barbimanus, Zavrelimyia melanura, Zavrelimyia punctatissima, Zavrelimyia punctipennis, Zavrelimyia sp', 'article'),
(16, 'Ekrem 2002', '', 'Ekr2002', 'Ekrem, T.', 2002, NULL, NULL, NULL, NULL, NULL, 'A review of selected South- and East Asian Tanytarsus v.d. Wulp (Diptera: Chironomidae)', 'Hydrobiologia', NULL, '255', NULL, '1-39', NULL, 'Male and pupa of Tanytarsus calorifontis sp. n. are described. Diagnoses, hypopygium drawings for the examined species and distribution are given for: Tanytarsus akantertius Sasa and Kamimura, T. angulatus Kawai, T. atagoensis Tokunaga, T. bathophilus Kieffer, T. boninensis Tokunaga, T. formosae (Kieffer), T. formosanus Kieffer, T. infundibulus Chaudhuri and Datta, T. kikuchii Sasa, Kawai and Ueno, T. konishii Sasa and Kawai, T. mcmillani Freeman, T. mendax Kieffer, T. miyakobrevis Sasa and Hasegawa, T. monstrosus Chaudhuri et al., T. ogasaquartus Sasa and Suzuki, T. ogasatertius Sasa and Suzuki, T. okuboi Sasa and Kikuchi, T. oscillans Johannsen, T. ovatus Johannsen, T. oyamai Sasa, T. pollexus Chaudhuri and Datta, T. shouautumnalis Sasa, T. shoudigitatus Sasa, T. takahashii Kawai and Sasa, T. tamaundecimus Sasa, T. tonebeceus Sasa and Tanaka, T. tusimatneous Sasa and Suzuki, T. unagiseptimus Sasa, T. uraiensis Tokunaga, T. yakuheius Sasa and Suzuki and T. yunosecundus Sasa. Tanytarsus ikiefeus Sasa and Suzuki is a new junior synonym of T. konishii. Tanytarsus ikifegeus Sasa and Suzuki, T. miyakoflavus Sasa and Hasegawa, T. oyabepallidus Sasa, Kawai and Ueno, T. simantoopeus Sasa et al. and T. tusimatheius Sasa and Suzuki are new junior synonyms of T. okuboi. Tanytarsus nippogregarius Sasa and Kamimura is a new junior synonym of T. bathophilus. Tanytarsus cultellus Chaudhuri and Datta and T. sibafegeus Sasa et al. are new junior synonyms of T. oscillans. Tanytarsus insulus (Guha et al., 1985) is a new junior synonym of T. ovatus. Tanytarsus sakishimanus Sasa and Hasegawa, T. vinculus Chaudhuri et al., T. parvistylus Chaudhuri and Datta, T. fusciabdominalis Guha et al. and T. euformosanus Kikuchi and Sasa are new junior synonyms of T. formosanus. Tanytarsus tsutaprimus Sasa, T. tokarajekeus Sasa and Suzuki, T. tusimatlemeus Sasa and Suzuki, T. tusimatopeus Sasa and Suzuki and T. yakugeheuus Sasa and Suzuki are new junior synonyms of T. shouautumnalis. Tanytarsus togasiroidus Sasa and Okazawa is a new junior synonym of T. shoudigitatus. Tanytarsus tusimatjekeus Sasa and Suzuki and T. tusimatkeleus Sasa and Suzuki are new junior synonyms of T. akantertius, and Tanytarsus tusimatpequeus Sasa and Suzuki is a new junior synonym of T. tusimatneous. Virgatanytarsus toganiveus (Sasa and Okazawa), Cladotanytarsus utonaiquartus (Sasa) and Zavrelia tusimatijeus (Sasa and Suzuki), all previously placed in Tanytarsus, are new combinations.', NULL, 'Asia, Cladotanytarsus utonaiquartus, Corynocera ambigua, Corynocera oliveri, description new species, Tanytarsus, Tanytarsus akantertius, Tanytarsus angulatus, Tanytarsus atagoensis, Tanytarsus bathophilus, Tanytarsus boninensis, Tanytarsus calorifontis, Tanytarsus cultellus, Tanytarsus euformosanus, Tanytarsus formosae, Tanytarsus formosanus, Tanytarsus fusciabdominalis, Tanytarsus ikiefeus, Tanytarsus ikifegeus, Tanytarsus infundibulus, Tanytarsus insulus, Tanytarsus kikuchii, Tanytarsus konishii, Tanytarsus mcmillani, Tanytarsus mendax, Tanytarsus miyakobrevis, Tanytarsus miyakoflavus, Tanytarsus monstrosus, Tanytarsus nippogregarius, Tanytarsus ogasaquartus, Tanytarsus ogasatertius, Tanytarsus okuboi, Tanytarsus oscillans, Tanytarsus ovatus, Tanytarsus oyabepallidus, Tanytarsus oyamai, Tanytarsus parvistylus, Tanytarsus pollexus, Tanytarsus sakishimanus, Tanytarsus shouautumnalis, Tanytarsus shoudigitatus, Tanytarsus sibafegeus, Tanytarsus simantoopeus, Tanytarsus takahashii, Tanytarsus tamaundecimus, Tanytarsus togasiroidus, Tanytarsus tokarajekeus, Tanytarsus tonebeceus, Tanytarsus tsutaprimus, Tanytarsus tusimatheius, Tanytarsus tusimatjekeus, Tanytarsus tusimatkeleus, Tanytarsus tusimatlemeus, Tanytarsus tusimatneous, Tanytarsus tusimatopeus, Tanytarsus tusimatpequeus, Tanytarsus unagiseptimus, Tanytarsus uraiensis, Tanytarsus vinculus, Tanytarsus yakugeheuus, Tanytarsus yakuheius, Tanytarsus yunosecundus, Virgatanytarsus toganiveus, Zavrelia tusimatijeus', 'article'),
(17, 'Moller-Pillot and Goddeeris 2001', '', 'Mol2001', 'Moller-Pillot, H. K. M. and Goddeeris, B. R.', 2001, NULL, NULL, NULL, NULL, NULL, 'Identificatiesleutel voor Tanytarsus larven van Nederland en Belgi&#235;', 'Script of determination course (3.-6.9.2002 Bad Bevensen - Germany).', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Tanytarsus, Tanytarsus gracilentus', 'unpublished'),
(18, 'Internet n.d.', '', 'web', 'Internet', 0, NULL, NULL, NULL, NULL, NULL, 'from Internet', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'no entry type given'),
(19, 'Moller-Pillot and Wiersma 1997', '', 'Mol1997', 'Moller-Pillot, H. K. M. and Wiersma, S. M.', 1997, '', '', NULL, '', NULL, 'De larven van het geslacht Einfeldia Kieffer, 1924: nomenclatuur en tabel tot de soorten (Diptera: Chironomidae)', 'Nederlandse Faunistische Mededelingen', '', '7', NULL, '11-17', '', NULL, NULL, '', 'no entry type given'),
(20, 'Schmid 1993', '', 'Sch1993', 'Schmid, P. E.', 1993, NULL, NULL, NULL, NULL, NULL, 'A Key to the larval Chironomidae and their instars from Austrian Danube Region streams and rivers, Part I, Diamesinae, Prodiamesinae and Orthocladinae', 'ISBN: 3-900672-92-X', NULL, NULL, NULL, '1-513', NULL, NULL, NULL, 'Austria, determination key, Diamesinae, Orthocladiinae, Prodiamesinae', 'book'),
(21, 'Cranston et al. 1983', '', 'WOr1983', 'Cranston, P. S., Oliver, D. R. and Sæther, O. A.', 1983, NULL, NULL, 'Wiederholm, T.', NULL, NULL, 'The Larvae of Orthocladiinae  (Diptera: Chironomiadae) of the Holarctic region - Keys and diagnoses', 'Chironomidae of Holarctic region - Keys and diagnoses (Part 1 - Larvae), Entomologica Scandinavica Supplement', NULL, '19', NULL, '149-292', NULL, NULL, NULL, 'determination key', 'no entry type given'),
(22, 'Makarchenko 1999', '', 'Tsa1999', 'Makarchenko, E. A.', 1999, NULL, NULL, 'Tsalolikhin, S.J.', NULL, NULL, 'Key to freshwater invertebrates of Russia and adjacent lands', 'St. Petersburg, Zool. Inst. Russian Academy of Sciences', NULL, '4', NULL, '1-998', NULL, NULL, NULL, 'determination key, Psectrocladius barbimanus, systematic literature', 'book'),
(23, 'Plank 2003', '', 'Pla2003', 'Plank, A.', 0, 'andreas.plank@web.de', 'FU Berlin, Institut f. Geologische Wissenschaften, FB Palaeontologie, Malteserstr. 74-100, Haus D, 12249 Berlin, Germany', NULL, NULL, NULL, 'Photos from Robackia (from river Elbe - Germany)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(24, 'Langdon (www)', '', 'Langdonwww', 'Langdon, P. G.', 0, NULL, NULL, NULL, NULL, NULL, 'Icelandic subfossil chironomids', NULL, 'http://www.ex.ac.uk/geography/research/chironomids/chironomids.html', NULL, NULL, NULL, NULL, NULL, 'seems deleted', NULL, 'online'),
(25, 'Walker 2000', '', 'Wal2000', 'Walker, I.', 2000, NULL, NULL, NULL, NULL, NULL, 'The WWW Field Guide to Subfossil Midges', NULL, 'http://www.paleolab.ca/wwwguide/index.html', NULL, NULL, NULL, NULL, NULL, 'actual key is 2007', 'determination key, fossil midges', 'online'),
(26, 'Sæther 1977', '', 'Sae1977', 'Sæther, O. A.', 1977, NULL, NULL, NULL, NULL, NULL, 'Taxonomic studies on Chironomidae: Nanocladius, Pseudochironomus and the Harnischia complex', 'Bulletin of the Fisheries Research Board of Canada', NULL, '196', NULL, '1-143', NULL, NULL, NULL, '', 'no entry type given'),
(27, 'Cranston 2000', 'b', 'Cra2000', 'Cranston, P. S.', 2000, NULL, NULL, NULL, NULL, NULL, 'Parapsectrocladius: a new genus of Orthocladiinae Chironomidae (Diptera) from Patagonia, the southern Andes', NULL, 'http://www.science.uts.edu.au/sasb/chiropage/parapse.pdf', NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(28, 'Zelentsov  1992', '', 'Zel1992', 'Zelentsov, N. I., Petrova, N. A.  and Erbaeva, E. A.', 1992, NULL, NULL, NULL, NULL, NULL, 'Morphology and karyotype of Acricotopus lucens Zett. (Diptera, Chironomidae) from Mongolia', 'Entomological Review (English Translation of Entomologicheskoye Obozreniye ISSN 0367-1445)', NULL, '71', '2', '295-301', NULL, 'For the first time a description of all of the developmental stages and the karyotype of A. lucens from Mongolia are presented. A comparative analysis of the morphological parameters showed that A. lucens is closely related to A. longipalpus, although the two species can be differentiated in all stages of development.', 'in Russian', 'Acricotopus lucens, larval description, Mongolia, Acricotopus longipalpus, karyotypes', 'article'),
(29, 'Hirvenoja 1973', '', 'Hir1973', 'Hirvenoja', 1973, NULL, NULL, NULL, NULL, NULL, 'Revision der Gattung Cricotopus van der vulp und ihrer Verwandten (Diptera, Chironomidae)', 'Annales Zoologici Fennici', NULL, '10', NULL, '1-363', NULL, '[transcribed from a blured photo] A taxonomic revision of the species of the genus Cricotopus van der Vulp and its closest relatives from the western part of Palaearctic region is presented, and the data on the distribution and habits of the different species are discussed. To evaluate the numerous characters studied, the adult, pupal and larval morphology of the Chironomidae has been reviewed. The aim has been to find the most suitable names and assess the homologies of many important structures in the different subgroups of the Chironomidae and in some other Nematocera. It is suggested that a strictly monophyletic group consitst of the genus Cricotopus (with subgen. Cricotopus s.str. and Isocladius Kieffer status n.) and its nearest relatives, the genera Acricotopus Kieffer, Paratrichocladius Santos Abreu (syn. Syncricotopus Brundin, syn. n.), Paracladius Hirvenoja (nom. nov. for Paratrichocladius Thienamann) and Halocladius Hirvenoja gen. n. (with subgen. Psammocladius Hirvenoja subgen. n. and Halocladius s.str. subgen. n.). About 50 species from the western part of the Palaearctic region have been redescribed, mostly from new material. As far as possible, the descriptions are based on all stages (larva, pupal exuviae and adult). In addition, the following 21 new species are described: Paracladius quadrinodosus, Halocladius (H.) mediterraneus, Cricotopus (C.) pilidorsum, C. (C.) pirifer, C. (C.) magus, C. (C.) septentrionalis, C. (C.) claripes, C. (C.) tristis, C. (C.) beckeri, C. (C.) patens, C. (C.) coronatus, C. (C.) guttatus, C. (C.) cadueus, C. (I.) laetus, C. (I.) pilicauda, C. (I.) relucens, C. (I.) suspiciosus, C. (I.) reversus, C. (I.) aureatus, C. (I.) obtusus and , C. (I.) reductus. In addition to these, C. (C.) lokunagai Hirvenoja is the new name for C. bituberculatus Tokunaga, which is a secondary homonym of Trichocladius bituberculatus Goetghebuer, and C. meunieri Hirvenoja is the new name for C. parvulus Meunier, which is a primary homonym of C. parvulus Kieffer. In the light of present knowledge, an attempt has been made to place the species from all different parts of the world that have been ascribed to the genus Cricotopus up to 1970 in the genera to which they probably belong. In addition, it is suggested that a number of names existing in the literature should be regarded as nomina dubia. Keys to the males, females, pupal exuviae and larvae are presented, as far as possible down to species level. Several hundreds of new figures of taxonomically important characteristics are presented.', NULL, 'Acricotopus lucens, adult male, Cricotopus, Cricotopus aureatus, Cricotopus  beckeri, Cricotopus bituberculatus, Cricotopus  cadueus, Cricotopus  claripes, Cricotopus  coronatus, Cricotopus  guttatus, Cricotopus laetus, Cricotopus  lokunagai, Cricotopus  magus, Cricotopus meunieri, Cricotopus obtusus and, Cricotopus parvulus, Cricotopus  patens, Cricotopus pilicauda, Cricotopus  pilidorsum, Cricotopus  pirifer, Cricotopus reductus, Cricotopus relucens, Cricotopus reversus, Cricotopus  septentrionalis, Cricotopus suspiciosus, Cricotopus  tristis, determination key, females, Halocladius (H.) variablilis, Halocladius (H.) varians, Halocladius (Psammocladius) braunsi, Halocladius mediterraneus, larvae, Paracladius alpicola, Paracladius conversus, Paracladius quadrinodosus, pupal exuviae, revision, Trichocladius bituberculatus', 'article'),
(30, 'Soponis 1990', '', 'Sop1990', 'Soponis, A. R.', 1990, NULL, NULL, NULL, NULL, NULL, 'A Revision of the Holarctic Species of Orthocladius (Euorthocladius) (Diptera: Chironomidae)', 'Spixiana Supplement', NULL, '13', NULL, '1-68', NULL, NULL, NULL, '', 'no entry type given'),
(31, 'Sæther 1975', '', 'Sae1975', 'Sæther, O. A.', 1975, NULL, NULL, NULL, NULL, NULL, 'Nearctic and palaearctic Heterotrissocladius (Diptera: Chironomidae)', 'Bulletin of the Fisheries Research Board of Canada', NULL, '193', NULL, '67', NULL, NULL, NULL, 'description, Heterotrissocladius', 'article'),
(32, 'Makarchenko 2003', '', 'Mak2003', 'Makarchenko, E. A.', 2003, NULL, NULL, NULL, NULL, NULL, 'A new species of Psectrocladius Kieffer (Diptera, Chironomidae, Orthocladiinae) from the south of Russian Far East', 'Euroasian Entomological Journal', 'http://www.tendipes.febras.ru/makar3.pdf', '2', '1', '61-66', NULL, NULL, NULL, 'Psectrocladius zelentzovi, Russian Far East', 'article'),
(33, 'Verschuren (www)', '', 'Verwww', 'Verschuren, D.', 0, 'dirk.verschuren@rug.ac.be', '', NULL, '', NULL, 'Chironomids', '', 'http://www.geo.uib.no/Forskning/Euro-Ideal/chironomids.html', NULL, NULL, NULL, '', NULL, NULL, '', 'no entry type given'),
(34, 'Moller-Pillot 1984', 'a', 'MPa1984', 'Moller-Pillot, H. K. M.', 1984, NULL, NULL, NULL, NULL, NULL, 'De larven der Nederlandse Chironomidae (Diptera) (Inleiding, Tanypodinae &amp; Chironomini)', 'Nederlandse Faunistische Mededelingen', NULL, '1A', NULL, '1-277', NULL, NULL, NULL, '', 'no entry type given'),
(35, 'Moller-Pillot 1984', 'b', 'MPb1984', 'Moller-Pillot, H. K. M.', 1984, NULL, NULL, NULL, NULL, NULL, 'De larven van de Nederlandse Chironomidae (Diptera) (Orthocladiinae sensu lato)', 'Nederlandse Faunistische Mededelingen', NULL, '1B', NULL, NULL, NULL, NULL, NULL, 'determination key, ecology, Europe: Netherlands', 'book'),
(36, 'Proviz and Proviz 1999', '', 'Pro1999', 'Proviz, V. I.  and Proviz, L. I.', 1999, '', '', NULL, '', NULL, 'Guide and key to chironomid larvae of the genus Sergentia from lake Baikal', 'Guides and keys to identification of fauna and flora of lake Baikal (ISBN 5-7692-0263-7)', '', NULL, NULL, NULL, '', NULL, NULL, '', 'no entry type given'),
(37, 'Oliver 1983', '', 'WDi1983', 'Oliver, D. R.', 1983, '', '', 'Wiederholm, T.', '', NULL, 'The larvae of Diamesinae (Diptera:Chironomidae) of the Holarctic region', 'Chironomidae of Holarctic region - Keys and diagnoses (Part 1 - Larvae), Entomologica Scandinavica Supplement', '', '1', NULL, '115-140', '', NULL, NULL, '', 'no entry type given'),
(38, 'Wang and Zhang 1987', '', 'WJL1987', 'Wang, J. and  Zhang, P.', 1987, '', '', NULL, '', NULL, 'The resarch on chironomid larvae in the Liupan mountain natural reserve', 'Acta Biologica Plateau Sinica', '', '7', NULL, '109-126', '', NULL, NULL, '', 'no entry type given'),
(39, 'Wang, Ji. 1987', '', 'WJi1987', 'Wang, J.', 1987, '', '', NULL, '', NULL, 'Studies on Chironomidae larvae in mainstream tributary and attached water of Yellow River within Qinghai Province', 'Acta Biologica Plateau Sinica', '', '11', '7', '127-140', '', NULL, NULL, '', 'no entry type given'),
(40, 'Wang and Wang 1991', '', 'WSD1991', 'Wang, S. and Wang, J.', 1991, NULL, NULL, NULL, NULL, NULL, 'Studies on Chironmidae larvae of Liaoning Province', 'Acta Hydrobiologica Sinica', NULL, '15', NULL, '36-44', NULL, NULL, NULL, 'China, distribution Chironomidae, ecology Chironomidae, new records', 'article'),
(41, 'Yan et al. 1982', '', 'Yan1982', 'Yan, J., and Wang, J.', 1982, NULL, NULL, NULL, NULL, NULL, 'The new records of chironomid midge of China from Huang Shui River of Qinghai Province', 'Entomotaxonomia', NULL, '4', NULL, '233-238', NULL, NULL, 'in Chinese', NULL, 'no entry type given'),
(42, 'Ye and Wang 1982', '', 'Ye1982', 'Ye, C. and Wang, J.', 1982, NULL, NULL, NULL, NULL, NULL, 'Studies on Chironomidae larvae of Qinhai Province', 'Acta Biologica Plateau Sinica', NULL, NULL, '1', '101-110', NULL, NULL, NULL, 'China, Psectrocladius barbimanus, Qinhai Province China', 'article'),
(43, 'Ye 1984', '', 'Ye1984', 'Ye, C.', 1984, NULL, NULL, NULL, NULL, NULL, 'The larvae of some Tendipedidae midge from Qinghai Lake and its river system', 'Acta Biologica Plateau Sinica', NULL, NULL, '2', '67-74', NULL, NULL, NULL, NULL, 'no entry type given'),
(44, 'Zorina 2004', '', 'Zor2004', 'Zorina, O. V.', 2004, NULL, NULL, NULL, NULL, NULL, 'Chironomids of the genus Paratendipes Kieffer (Diptera, Chironomidae, Chironominae) of the Russian Far East', 'Euroasian Entomological Journal', 'http://www.tendipes.febras.ru/zorina1.pdf', '3', '4', '318-324', NULL, NULL, NULL, '', 'no entry type given'),
(45, 'Hazra et al. 2002', '', 'Haz2002', 'Hazra, N., Saha, G. K. and Chaudhuri, P. K.', 2002, NULL, NULL, NULL, NULL, NULL, 'Records of Orthoclad species from the Darjeeling-Sikkim Himalayas of India (Diptera: Chironomidae), with notes on their ecology', 'Hydrobiologia', NULL, '474', NULL, '41-55', NULL, NULL, NULL, NULL, 'no entry type given'),
(46, 'Simpson et al. 1983', '', 'Sim1983', 'Simpson, K. W., Bode, R. W. and Albu, P.', 1983, NULL, NULL, NULL, NULL, NULL, 'Key for the genus Cricotopus adapted from "Revision der Gattung Cricotopus van der Wulp und ihrer Verwandten (Diptera, Chironomidae)" by M-Hirvenoja', 'New York State Museum, Bulletin', NULL, NULL, '450', '1-131', NULL, NULL, NULL, '', 'no entry type given'),
(247, 'Edwards 1938', '', 'Edw1938', 'Edwards', 1938, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(248, 'Enderlein 1912', '', 'End1912', 'Enderlein', 1912, '', '', NULL, '', NULL, NULL, '', '', NULL, NULL, NULL, '', NULL, NULL, '', 'no entry type given'),
(249, 'Fittkau 1955', '', 'Fit1955', 'Fittkau, E. J.', 1955, NULL, NULL, NULL, NULL, NULL, 'Buchonomyia thienemanni n.gen. n.sp. Chironomidenstudien IV (Diptera: Chironomidae)', 'Beitraege zur Entomologie', NULL, '5', NULL, '403-414', NULL, NULL, NULL, '', 'no entry type given'),
(250, 'Fittkau 1957', '', 'Fit1957', 'Fittkau, E. J.', 1957, '', '', NULL, '', NULL, 'Thienemannimyia und Conchapelopia, zwei neue Gattungen innerhalb der Ablabesmyia-costalis-Gruppe (Diptera, Chironomidae). (Chironomidenstudien VII)', 'Archiv für Hydrobiologie', '', '53', NULL, '313-322', '', NULL, NULL, '', 'no entry type given'),
(251, 'Fittkau 1962', '', 'Fit1962', 'Fittkau, E. J.', 1962, NULL, NULL, NULL, NULL, NULL, 'Die Tanypodinae (Diptera: Chironomidae). (Die Tribus Anatopyniini, Macropelopiini und Pentaneurini)', 'Abh. Larvalsyst. Ins.', NULL, '6', NULL, '1-453', NULL, NULL, NULL, '', 'no entry type given'),
(252, 'Fittkau and Murray 1983', '', 'FiM1983', 'Fittkau E. J. and Murray', 1983, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(253, 'Fries 1830', '', 'Fri1830', 'Fries', 1830, '', '', NULL, '', NULL, NULL, '', '', NULL, NULL, NULL, '', NULL, NULL, '', 'no entry type given'),
(254, 'Goetghebuer 1922', '', 'Goe1922', 'Goetghebuer, M. E. M.', 1922, NULL, NULL, NULL, NULL, NULL, 'Dipteres. Chironomidae', 'Faune de France', NULL, 'IV', NULL, NULL, NULL, NULL, 'correct citation? Cited from [[http://www.springerlink.com/content/g56r6g46271u3258/]]', '', 'no entry type given'),
(255, 'Goetghebuer 1928', '', 'Goe1928', 'Goetghebuer, M. E. M.', 1928, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(246, 'Edwards 1937', '', 'Edw1937', 'Edwards', 1937, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(245, 'Eaton 1875', '', 'Eat1875', 'Eaton', 1875, '', '', NULL, '', NULL, NULL, '', '', NULL, NULL, NULL, '', NULL, NULL, '', 'no entry type given'),
(244, 'Cranston 1982', '', 'Cra1982', 'Cranston, P. S.', 1982, NULL, NULL, NULL, NULL, NULL, 'A key to the larvae of British Orthocladiinae (Chironomidae)', 'Freshwater Biological Association, Scientific Publication', NULL, NULL, '45', '1-152', NULL, NULL, NULL, 'determination key, ecology, Psectrocladius limbatellus, systematic literature', 'book'),
(243, 'Brundin 1966', '', 'Bru1966', 'Brundin, L.', 1966, NULL, NULL, NULL, NULL, NULL, 'Transarctic relationships and their significance, as evidenced by chironomid midges, with a monograph of the subfamilies Podonominae and Aphroteniinae and the austral Heptagyiae', 'Kungl. Svenska Vetenskapsakad. Handl.', NULL, '4', '11(1)', '1-471', NULL, NULL, 'not checked "Brundin 1966" for e.g. Tribe Boreoheptagyiini Brundin, 1966', 'Aphroteniinae, Australia, Boreoheptagyiini, Heptagyiae, Podonominae', 'article'),
(242, 'Brundin 1956', '', 'Bru1956', 'Brundin, L.', 1956, NULL, NULL, NULL, NULL, NULL, 'Zur Systematik der Orthocladiinae (Dipt. Chironomidae)', 'Institute of Freshwater Research. Report. Drottningholm', NULL, '37', NULL, '5-185', NULL, NULL, 'not checked "Brundin 1956" for e.g. Orthocladius wetterensis', 'Orthocladius wetterensis', 'article'),
(241, 'Brundin 1949', '', 'Bru1949', 'Brundin, L.', 1949, NULL, NULL, NULL, NULL, NULL, 'Chironomiden und andere Bodentiere der südschwedischen Urgebirgsseen', 'Institute of Freshwater Research. Report. Drottningholm', NULL, '30', NULL, '1-914', NULL, NULL, 'not checked for Zalutschia mucronata (Brundin 1949)', 'Zalutschia mucronata', 'no entry type given'),
(240, 'Brundin 1947', '', 'Bru1947', 'Brundin, L.', 1947, NULL, NULL, NULL, NULL, NULL, 'Zur Kenntnis der schwedischen Chironomiden', 'Arkiv för Zoologi', NULL, '39A', '3', '1-95', NULL, NULL, 'not checked "Brundin 1947" for e.g. Orthocladius (Orthocladius) dentifer ', 'Orthocladius dentifer', 'article'),
(256, 'Ashe and Cranston 1991', '', 'Ash1991', 'Ashe, P. and Cranston, P. S.', 1991, NULL, NULL, 'Soós, Á. & Papp, L.', NULL, NULL, 'Chironomidae. Psychodidae-Chironomidae.', 'Catalogue of Palaearctic Diptera', NULL, '2', NULL, '113-355', NULL, NULL, NULL, 'Catalogue, Checklist, Palaearctic Chironomidae, Taxalist', 'book'),
(257, 'Millet 2002', '', 'Mil2002', 'Millet, L.', 2002, NULL, NULL, NULL, NULL, NULL, 'Photographies de chironomes', NULL, 'http://chrono-eco.univ-fcomte.fr/Public/Cours/Millet_Laurent/Chironomes/', NULL, NULL, NULL, 'Décembre', NULL, NULL, '', 'no entry type given'),
(258, 'Linné 1758', '', 'Lin1758', 'Linné, C.', 1758, NULL, NULL, NULL, NULL, NULL, 'Systema naturæ per regna tria naturæ, secundum classes, ordines, genera, species, cum characteribus, differentiis, synonymis, locis', 'Tomus I. Editio decima, reformata. Holmiæ. (Laurentii Salvii).', NULL, NULL, NULL, '1-824', NULL, NULL, 'not checked for Ablabesmyia monilis', 'first description', 'book'),
(259, 'Egger 1863', '', 'Egg1863', 'Egger', 1863, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not checked for e.g. Ablabesmyia phatta', NULL, 'no entry type given'),
(260, 'Edwards 1932', '', 'Edw1932', 'Edwards', 1932, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(261, 'Stur and Fittkau 1997', '', 'Stu1997', 'Stur, E. and Fittkau, E. J.', 1997, NULL, NULL, NULL, NULL, NULL, 'Diagnostic characters distinguishing the larvae of Ablabesmyia and Paramerina, and first record of Paramerina in Brazil (Insecta, Diptera, Chironomidae)', 'Spixiana', NULL, '20', '2', '161-165', NULL, NULL, NULL, '', 'no entry type given'),
(262, 'Makarchenko and Makarchenko 2003', 'b', 'MaM2003', 'Makarchenko, E. A. and Makarchenko, M. A.', 2003, 'emakar@ibss.dvo.ru', 'Биолого-почвенный институт ДВО РАН, пр. 100 лет Владивостоку, 159, Владивосток, 690022, Россия', NULL, NULL, NULL, 'A new and little-known species of chironomids (Diptera, Chironomidae) from the Russian far east', 'ЧТЕНИЯ ПАМЯТИ ВЛАДИМИРА ЯКОВЛЕВИЧА ЛЕВАНИДОВА (Vladimir Ya. Levanidov''s Biennial Memorial Meetings)', 'http://www.tendipes.febras.ru/makar7.pdf', NULL, NULL, '204-216', NULL, NULL, NULL, '', 'no entry type given'),
(263, 'Holmgren 1869', '', 'Hol1869', 'Holmgren, A. E.', 1869, NULL, NULL, NULL, NULL, NULL, 'Bidrag till kännedomen om Beeren Eilands och Spetsbergens insekt-fauna', 'Kungl. Svenska Vetenskapsakad. Handl.', NULL, '8', '8', '1-56 [47]', NULL, '', 'correct citation ??? ', '', 'no entry type given'),
(264, 'Spies 2006', '', 'Spi2006', 'Spies, M.', 2006, 'spies@zi.biologie.uni-muenchen.de', 'Martin Spies c/o Zoologische Staatssammlung München, Münchhausenstr. 21, D-81247 München, Germany', NULL, NULL, NULL, 'Pseudorthocladius Goetghebuer, 1943 and Mesosmittia Brundin, 1956 (Insecta, Diptera, CHIRONOMIDAE): proposed conservation of the generic names', 'Bulletin of Zoological Nomenclature', NULL, '63', '2', '122-126', NULL, NULL, NULL, '', 'no entry type given'),
(265, 'Adam and Sæther 1999', '', 'AdS1999', 'Adam, J. I. and Sæther, O. A.', 1999, NULL, NULL, NULL, NULL, NULL, 'Revision of the genus Nilothauma Kieffer, 1921 (Diptera: Chironomidae)', 'Entomologica Scandinavica Supplement', NULL, '56', NULL, '1-107', NULL, NULL, NULL, 'Chironomidae, Nilothauma, Revision', 'incollection'),
(266, 'Ashe and O''Connor 2000', '', 'AsC2000', 'Ashe, P. and O''Connor, J. P.', 2000, NULL, NULL, 'Odwin Hofrichter', NULL, NULL, 'Metriocnemus (Crymaleomyia) brunneri n. subgen., n. sp., from glacial melt-water in the Karakorum Mountains, Pakistan (Insecta:diptera: Chironomidae: Orthocladiinae)', 'Late 20th century research on Chironomidae: An Anthology from the 13th International Symposion on Chironomidae (Shaker Verlag, Aachen)', NULL, NULL, NULL, '25-34', NULL, NULL, NULL, 'Metriocnemus brunneri, Metriocnemus', 'article'),
(267, 'Contreras-Lichtenberg and Kiknadze 2000', '', 'CLK2000', 'Contreras-Lichtenberg, R. and Kiknadze, I. I.', 2000, NULL, NULL, NULL, NULL, NULL, 'Glyptotendipes ospeli, a new species from The Netherland (Diptera, Nematocera: Chironomidae)', 'Entomologische Berichten (Amsterdam)', NULL, '60', '2', '1-60', NULL, NULL, NULL, '', 'no entry type given'),
(268, 'Wang and Gou 2004', '', 'WaG2004', 'Wang, X. and Guo, Y.', 2004, 'xhwang@nankai.edu.cn', 'Life Science College, Nankai University, Tianjin 300071, China', NULL, NULL, NULL, 'A review of the genus Cladotanytarsus Kieffer from China, with the description of three new species (Diptera: Chironomidae: Tanytarsini)', 'Zootaxa', 'http://www.mapress.com/zootaxa/', '750', NULL, '1-19', NULL, NULL, 'only adults', '', 'no entry type given'),
(269, 'Sæther 1985', '', 'Sae1985', 'Sæther, O. A.', 1985, NULL, NULL, NULL, NULL, NULL, 'A review of the genus Rheocricotopus Thienemann & Harnisch, 1932, with the description of  three new species (Diptera, Chironomidae)', 'Spixiana Supplement', NULL, '11', NULL, '59-108', NULL, NULL, NULL, '', 'no entry type given'),
(270, 'Wang and Sæther 2001', '', 'WaS2001', 'Wang, X. and Sæther, O. A.', 2001, NULL, NULL, NULL, NULL, NULL, 'The Larvae of Propsilocerus sinicus Sæther et Wang and P. paradoxus (Lundström) (Diptera: Chironomidae)', 'Aquatic Insects', NULL, '23', '2', '141-145', 'April', NULL, NULL, '', 'no entry type given'),
(271, 'Makarchenko and Makarchenko 2005', '', 'MaM2005', 'Makarchenko, E. A. and Makarchenko, M. A.', 2005, NULL, NULL, NULL, NULL, NULL, 'Chironomids of the genus Rheocricotopus Thienemann et Harnisch, 1932 (Diptera, Chironomidae, Orthocladiinae) of the Russian Far East', 'Euroasian Entomological Journal', 'http://www.tendipes.febras.ru/makar12.pdf', '4', '2', '125–136', NULL, NULL, NULL, '', 'no entry type given'),
(272, 'Malloch 1915', '', 'Mal1915', 'Malloch, J. R.', 1915, NULL, NULL, NULL, NULL, NULL, 'The Chironomidae, or midges of Illinois, with particular reference to the species occurring in the Illinois River', 'Bull. Ill. State Lab. Nat. Hist.', NULL, '10', NULL, '277-543', NULL, NULL, 'cited from {citeID|327|Curry 1958}', '', 'no entry type given'),
(273, 'Hazra et al. 1998', '', 'Haz1998', 'Hazra, N., Som, D. K. and Chaudhuri, P. K.', 1998, NULL, NULL, NULL, NULL, NULL, 'Limnophyes Eaton: new record and immatures of Indian species from Darjeeling Himalayas (Diptera: Chironomidae)', 'Studia Dipterologica', NULL, '5', '1', '33-46', NULL, NULL, NULL, '', 'no entry type given');
INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(274, 'Dettinger-Klemm 2003', '', 'DeK2003', 'Dettinger-Klemm, P. M. A.', 2003, NULL, NULL, NULL, NULL, NULL, 'Chironomids (Diptera, Nematocera) of Temporary Pools - an Ecological Case Study', 'Thesis, University Marburg', 'http://archiv.ub.uni-marburg.de/diss/z2004/0076/', NULL, NULL, '1-372', NULL, 'The main aim of the present study was to determine how Chironomidae cope with the environmental changes to which temporary pools are exposed. Are the species specifically adapted to the habitat or opportunistic? The problem was approached by:\r\n(a) an emergence study done in the Lahnberge mountain range (Marburg, Hesse, Germany) on three pools that were subjected to different lengths of drought (two of which were really temporary and one semipermanent);\r\n(b) an emergence study done in order to investigate the dispersal ability of Chironomus dorsalis (colonizing experiment) in ten experimental pools that had been exposed in the field in 1998 and that mimicked spatially unstable pools;\r\n(c) laboratory investigations of some fundamental biological characteristics (role of temperature, photoperiod and density in growth and development, drought tolerance and parthenogenesis) of the four principal temporary pool dwellers Limnophyes asquamatus, Paralimnophyes hydrophilus, C. dorsalis and Polypedilum tritum.\r\nThe natural habitats investigated in this study were numbered pool 1, 2 and 3 and can be characterized as:\r\n* pool 1, an autumn-summer pool on the forest’s edge (variation of drought period: 7-157; 71 d (n = 8 years); onset of drought between end of May to end of August, usually in July);\r\n* pool 2, a semi permanent pool on the forest’s edge (variation of drought period 0-130; 34 d (n = 8 years); onset of drought in July); and\r\n* pool 3, a temporary winter-vernal woodland pool (variation of drought period 109-502; 221 d (n = 8 years); onset of drought between mid-May and end of June, usually in the second half of May/first half of June).\r\n\r\nSince the temporary pools investigated were dry during the warmest period of the year, temperatures (recorded by data loggers) available for development of aquatic animals are relatively low compared to other permanent shallow lentic water bodies.\r\n\r\nChironomid communities of pools 1, 2 and 3 were counted 33 (n = 8250 individuals), 33 (n = 3543 individuals) and 23 species (n = 26376 individuals), respectively. The proportions of semiaquatic-terrestrial and truly terrestrial individuals within an annual crop ranged between 27 % (pool 1), 39-69 % (pool 2) and 79-96 % (pool 3). The pool communities of aquatic/semiaquatic chironomids were mainly determined by the average lentic water permanence LWPav = 1 /(1 + (average duration of drought at deepest site)/(average min imum soil moisture at deepest site)), LWPprev of the previous year and by the month in which drought occurred. The proportion of individuals that could be defined as aestivators (= species surviving at least several months of drought concealed by substrates with water contents of 20-40 % of total soil weight) was negatively correlated with the LWPav and LWPprev. The proportion of colonizers strongly depended on the month in which drought occurred. The temporary pools and 3 were usually predominated by one to three aquatic/semiaquatic aestivator species (65.5 % of the community in pool 1 and 100 % in pool 3 on average). These were L. asquamatus, P. hydrophilus and P. tritum. The average proportion of aquatic/semiaquatic aestivator species emerging from the semi permanent pool 2 was comparatively low (17.4 %).\r\n\r\nTwenty one species of chironomid (n = 7482 individuals) and 2 mosquito species (n = 2771 individuals) were encountered in the experimental boxes of the colonizing experiment. The midge communities of the experimental pools were very similar, and distance to the closest aquatic habitat (up to 700 m) did not result in regular colonization patterns. The dispersal abilities of all species were therefore quite high and only distances up to several kilometres would produce regular colonization patterns in such an experiment. The most dominant colonizers were Chironomus dorsalis (40.0 %), Culex torrentium (20.4 %), Chironomus piger/riparius (16.7 %), Tanytarsus buchonius (9.8 %) and Culex pipiens (9.6 %). Colonizing efficiency (measured as time from exposure until first emergence, presence (number of boxes from which a species had emerged) and abundance) was highest in C. dorsalis and consecutively lower in Chironomus piger/riparius, Tanytarsus buchonius and Corynoneura scutellata. The dispersing strategy used by C. dorsalis is probably a combination of actively searched passive downwind transport (for wide-range dispersal) and of the active selection of oviposition sites. The first ovipositing females arrived between 2-7 days after exposure of the experimental puddles. Low values of the aspect ratio (wing length/wing width) and the thorax ratio (wing length/thorax length) seem to be good morphological surrogates for a chironomids’ ability for active dispersal. These morphological parameters also confirmed that C. dorsalis was an expert invader.\r\n\r\nMorphological features of the egg masses, larvae, pupae and adults of the four principal temporary pool species’ were presented and partly illustrated. Taking into account the separation characters currently available, it was not possible to separate P. tritum from P. uncinatum. It is therefore likely that P. uncinatum is a junior synonym of P. tritum; this conclusion however awaits investigation of the type material. Nevertheless, the present study used P. tritum instead of the more accurate term P. uncinatum/tritum.\r\n\r\nAn extensive morphological-taxonomical analysis of the larva, pupa and the adult female of the parthenogenetic and bisexual ecotypes of L. asquamatus was carried out. The distinction into two species was not morphologically backed up. Using two morphological characteristics (presence of lanceolate prescutellars, number of preepisternals) most individuals of the obligatory bisexual reproducing females (L. asquamatus forma asquamatus) could be separated from the parthenogenetic ecotype L. asquamatus forma aquaticus. It turned out that the bisexual forma asquamatus clearly prefers wet soils and should be called terrestrial/semiterrestrial whereas the parthenogenetic ecotype aquaticus was predominantly aquatic/semiaquatic. However, during a wide range comparison of parthenogenetic females, including material from The Netherlands and Eastern Germany, a second parthenogenetic ecotype (L. asquamatus forma limosus) was discovered which is not separable from the obligatory bisexual females and probably occupies a similar (terrestrial) microhabitat. It still remains unclear whether males actually mate with parthenogenetic females and how often parthenogenetic clones arise from the obligatory bisexual parental ecotype. The ecological significance of parthenogenesis in the Chironomidae seems to be the occupation of new niches combined with the advantage of asexual reproduction in colonizing transient habitats. The larva of L. asquamatus was described for the first time. While searching for characteristics that separate larvae of L. asquamatus from other species of the genus, a comparison with larvae of the L. minimuscomplex and L. natalensis was undertaken. It turned out that SÆTHER (1990) had not described the larva of L. natalensis but of another species and thus the larva of L. natalensis was also described for the first time. The larval and pupal keys in SÆTHER (1990) were accordingly amended.\r\n\r\nThe temperature dependence of development from oviposition to adulthood was studied intensively for P. hydrophilus, C. dorsalis and P. tritum. The development of these species was influenced as follows by temperature:\r\n* lower/upper lethal limit for development from oviposition to adulthood: <4.5 °C/between 25.0 and 29.1 °C (P. hydrophilus), between 4.5 and 9.5 °C/between 31.1 and 33.5 °C (C. dorsalis), between 4.5 and 9.5 °C/± 30.2 °C (P. tritum);\r\n* developmental zero: 3.1 °C (P. hydrophilus), 4.6 °C (C. dorsalis), 5.2 °C (P. tritum);\r\n* cue temperature of oligopause: only in C. dorsalis an developmental stop in the instar IV at temperatures 9.5 and 13.8 °C ( cue ~ 12 °C);\r\n* favourable temperatures for total development: 9-19 °C (psycrophilic-eurythermous, P. hydrophilus), ~12-27 °C (thermophilous, C. dorsalis), 10-25 °C (eurythermous-thermophilous, P. tritum);\r\n* thermal constants (cumulated degree-days above the developmental zero) for development from oviposition until first-/50 %-/last emergence: 347/443/560 (P. hydrophilus), 308/344/406 (C. dorsalis), 339/416/503 (P. tritum). Thermal constants necessary to complete each developmental stage (egg, instar I, II, III, IV, pupa) were accordingly provided;\r\n* P. hydrophilus presents high thermal coefficients (Q10-values between 4 and 6) over a wide range of temperatures (5-15 °C), which might be an adaptation to daily fluctuations of temperatures in shallow waters;\r\n* the adult body size is negatively correlated with temperature;\r\n* males emerge before females.\r\n\r\nThe laboratory study showed that the temperature characteristics of the temporary pool species did not differ to those of many other permanent water Chironomidae. These attributes are therefore of preadaptive nature (with the possible exception of thermal coefficients in P. hydrophilus). For comparative reasons, the following species were also included in the investigation program: Acricotopus lucens, L. asquamatus, Limnophyes minimus s. str., Parametriocnemus stylatus, Chironomus annularius, Chironomus luridus, Chironomus cf. nuditarsis, Chironomus plumosus-agg., Dicrotendipes notatus, Glyptotendipes foliicola, Glyptotendipes pallens and Paratanytarsus grimmii. An intensive literature research was additionally carried out.\r\n\r\nThe impact of the photoperiod on the development of C. dorsalis, P. tritum and of the permanent water species Chironomus annularius was studied. Short-days (8h/16h) induced an oligopause in the instar IV of the first two species. Field data imply that this is also the case for P. hydrophilus. If possible, the critical thresholds of day length were estimated from the field data; these lay between .3 and 14.3 h (P. tritum) and 11.0 and 12.4 h (P. hydrophilus). Larvae that had been undertaken an oligopause produced the largest adults (feeding and growth during oligopause). Oligopauses induced by short-days are widespread amongst the Chironomidae. Long days delayed the development of Chironomus annularius, which is the first such record for Chironomidae.\r\n\r\nFood shortage induced a nutritive quiescence in P. tritum.\r\n\r\nPreliminary results of a pilot experiment on interspecific competition indicated that large larvae were the better competitors. The competitive ability of the permanent water species (C. plumosusagg. and C. annularius) was higher than in the temporary pool species (C. dorsalis and P. tritum).\r\n\r\nIncreasing larval densities prolonged the total development time of C. dorsalis and accelerated development in P. tritum. Acceleration of development is probably an adaptation to temporary pools as larvae are likely to accumulate when the water body shrinks.\r\n\r\nA pilot experiment showed that geophilous dragonfly larvae preyed effectively upon the tube- and mud-dwelling larvae of C. dorsalis and P. tritum. Analysis of the field data also indicated that predation was an important factor in determining the species communities and that temporary pools provide a haven from predation.\r\n\r\nExperiments revealed that larvae of L. asquamatus, P. hydrophilus and P. tritum were drought tolerant. Drought tolerance was defined as the ability to survive at least several months of drought concealed by substrates with water contents (% water of total soil weight) of 20-40 %. Larvae normally did not survive a reduction of the soil moisture below 20 %, in some cases some larvae survived these low soil moisture contents for a few days. The laboratory experiments showed that all instars were drought tolerant but that the degree of tolerance increased with larval size. Survival of the larvae depended strongly on soil moisture and on the duration of drought. Field data showed that all three species survived the 502 days of drought to which the temporary woodland pool 3 was subjected in 1995/96. However, emergence data obtained after this unusual long period of drought indicated very high mortalities. C. dorsalis and C. plumosus-agg. were included into the investigation for comparative reasons. These larvae were not drought tolerant. Such species, however, survive about one month concealed in substrates with soil moisture contents of 20-60 % or up to several months in substrates with moisture contents exceeding 60 %. Such an ability to survive ‘desiccation’ seems to be quite common in permanent water Chironomidae. The experiments showed that L. asquamatus, P. hydrophilus and Polypedilum tritum were particularly adapted to surviving periods of drought. It is likely that the ability of instars IV to moult into the pupa and then to emerge as adults after desiccation (terrestrial eclosion) is also an adaptation to temporary pools. Terrestrial eclosion (up to 61 % of instars IV) was observed in P. hydrophilus, P. tritum and C. dorsalis.\r\n\r\nThe most important results of the autecological analysis of the field data were the following:\r\n\r\n* first date- /last date of emergence/number of possible generations: 27.3./end of October/up to seven (L. asquamatus); 27.3./begin of October/up to seven (P. hydrophilus), begin of May/begin of October/~five (C. dorsalis); 20.4./16.9./three (up to four?) (P. tritum);\r\n* in accordance with the laboratory data, individuals of the first spring generation were the largest;\r\n* predicted generations using the laboratory data of temperature dependence of development and the water temperatures in the natural habitats corresponded very well with the observed emergence patterns of P. hydrophilus and P. tritum in the field;\r\n* laboratory data of temperature dependence of development in L. asquamatus were only fragmentary and did not fit very well with the field data. ‘Degree-days’ (cumulated daily means above 0°C since the developmental zero is not known) necessary from oviposition until the first(~350 ‘degree-days’), mean- (~450 ‘degree-days’) and last emergence (~550 ‘degree-days’) were therefore determined from the field data;\r\n* P. hydrophilus and to a lesser extent P. tritum were virtually bivoltine. The number of adults emerging after generation two was quite small. In addition, individuals that emerged after generation two were all very small (dwarfs). Although the adult body size in the field was strongly correlated with temperature, comparison with the laboratory data indicated that temperature was not responsible for these dwarfs. Oxygen is a strong correlate of temperature and is of high physiological significance. Measurements showed that oxygen was an important stressor for the chironomid larvae since during day runs its values did not exceed 2 mg/l and averaged (daily means) from 0.1-1.0 mg/l. Oxygen contents were therefore likely to impede growth and development and subsequently produce small adults;\r\n\r\n* in some years, larvae of P. hydrophilus and P. tritum fell into dormancy after the eclosion of generation 1 or 2. It is discussed that low oxygen levels induced these dormancies;\r\n\r\n* intense drought periods (very long and/or strong reduction of soil moisture content) can strongly reduce the populations of aestivating drought-tolerant larvae. The populations of aestivator species therefore often depend on the recruitment of a second generation that fills up the stock of the aestivating larvae and ensures high population levels in the following year;\r\n\r\n* populations of Chironomus dorsalis ‘overshoot’ after the initial colonization, which probably caused the observed decrease in the adult body size with time. The presence of a density induced dormancy is discussed.\r\n\r\nThe present study showed that the responses of temporary pool species to environmental changes in their habitats are opportunistic. Beside physiological plasticity, it is facultative dormancy induced by various cues (drought, day length, nutrition, density (?), oxygen (?)) that leads to the high plasticity in the species’ life histories. Specific adaptations to drought (such as drought tolerance, terrestrial eclosion, acceleration of development) evolved. In the case of C. dorsalis, these adaptations also include dispersal. Temporary pools that are spatially stable are more suited for aestivators, (here L. asquamatus, P. hydrophilus and P. tritum) whereas spatially unstable pools (puddles) are colonized by expert invaders (here C. dorsalis).', NULL, 'Ablabesmyia cf. mollochi, Ablabesmyia longistyla, Ablabesmyia monilis, Ablabesmyia sp., Acricotopus lucens, Acricotopus nitidellus, Allotrissocladius amphibius, Apedilum elachistus, Apsectrotanypus trifascipennis, autecology, Beardius sp., Cardiocladius sp., Chaetocladius dentiforceps, Chaetocladius dentiforceps agg., Chaetocladius gr. vitellinus, Chaetocladius perennis, Chaetocladius piger agg., Chaetocladius sp., Chironomus aberratus, Chironomus alternans, Chironomus annularius, Chironomus aprilinus, Chironomus attenuatus, Chironomus cingulatus, Chironomus conjunctus, Chironomus curtivalva, Chironomus decorus, Chironomus dorsalis, Chironomus heterodentatus, Chironomus imicola, Chironomus kiiensis, Chironomus lacunarius, Chironomus longipes, Chironomus lugubris/piger/riparius, Chironomus luridus, Chironomus pallidivittatus, Chironomus plumosus, Chironomus plumosus agg., Chironomus pseudothummi agg., Chironomus pulcher, Chironomus riparius, Chironomus salinarius, Chironomus sp., Chironomus staegeri, Chironomus stigmaterus, Chironomus tentans, Chironomus tepperi, Chironomus tuxis, Chironomus zealandicus, Cladopelma sp., Cladotanytarsus atridorsum, Cladotanytarsus mancus agg., Cladotanytarsus sp., Clinotanypus nervosus, Clinotanypus sp., Coelopynia pruinosa, Coelotanypus sp., Conchapelopia melanops, Conchapelopia pallidula, Corynoneura brundini, Corynoneura coronata, Corynoneura edwardsi, Corynoneura lobata, Corynoneura scutellata, Corynoneura scutellata agg., Corynoneura sp., Cricotopus albitibia, Cricotopus algarum, Cricotopus algorum, Cricotopus annulator, Cricotopus bicinctus, Cricotopus cf. polaris, Cricotopus flavocinctus, Cricotopus fuscus, Cricotopus gr. cylindraceus, Cricotopus intersectus, Cricotopus ornatus, Cricotopus sp., Cricotopus sylvestris, Cricotopus tibialis, Cricotopus triannulatus, Cricotopus trifasciatus, Cryptochironomus defectus, Cryptochironomus rostratus, Cryptochironomus sp., Cryptochironomus supplicans, Cryptocladophelma laccophila agg, Cryptocladophelma virescens, Demeijerera brachialis, developemental zero, Dicrotendipes cf. lucifer, Dicrotendipes cf. thanatogratus, Dicrotendipes cf. tritomus, Dicrotendipes leucoscelis, Dicrotendipes lobiger, Dicrotendipes modestus, Dicrotendipes nervosus, Dicrotendipes nervosus/agg, Dicrotendipes notatus, Dicrotendipes sp., Diplocladius cultriger, Diplocladius sp., Djalmabatista sp., ecology, Einfeldia dissidens, Einfeldia pagana, Einfeldia sp., Endochironomus albipennis, Endochironomus nigricans, Endochironomus sp., Endochironomus tendens, Eukiefferiella sp., Glyptochironomus barbipes, Glyptotendipes dreisbachi, Glyptotendipes gripekoveni, Glyptotendipes lobiferus, Glyptotendipes pallens, Glyptotendipes paripes, Glyptotendipes sp., Glyptotendipes tokunagai, Glyptotendipes unacus, Goeldichironomus holoprasinus, Goeldichironomus sp., Guttipelopia guttipennis, Guttipelopia sp., Harnischia sp., Harnischia viriduala, Harrisonia petricola, Heleniella ornaticollis, Hetterotrissocladius marcidus, Hydrobaenus cf. distylus 28, Hydrobaenus kondoi, Hydrobaenus lugubris, Hydrobaenus pilipes, Hydrobaenus sp., Kiefferulus dux, Kiefferulus martini, Kiefferulus tendipediformis, Krenopelopia sp., Krenosmittia sp., Labrundinia neopilosella, Labrundinia sp., Lapposmittia parvibarba, Larsia curticalcar, Larsia sp., Lasiodiamesa gracilis, Lasiodiamesa sp., Lauterborniella sp., Limnophyes asquamatus, Limnophyes mechthildae, Limnophyes pentaplastus, Limnophyes pumilio, Macropelopia goetghebueri, Macropelopia nebulosa, Macropelopia notata, Macropelopia sp., Metriocnemus albolineatus, Metriocnemus corticalis, Metriocnemus eurynotus, Metriocnemus fuscipes, Metriocnemus hirticollis, Metriocnemus hirticollis agg., Metriocnemus hygropetricus agg., Metriocnemus inopinatus, Metriocnemus inopinatus agg., Metriocnemus sp., Metriocnemus tristellus agg., Microchironomus deribae, Microchironomus sp., Microcricotopus bicolor, Micropsectra apposita, Micropsectra atrofasciata, Micropsectra bidentata, Micropsectra fusca, Micropsectra groenlandica, Micropsectra junci, Micropsectra lindrothi, Micropsectra notescens, Micropsectra reoseiventris, Micropsectra sp., Microtendipes chloris, Microtendipes chloris agg, Microtendipes sp.,Microtendipes pedellus, Monomelopia sp., Monopelopia tenuicalar, Nanocladius bicolor, Nanocladius cf. rectinervis, Nanocladius sp., Natarsia punctata, Natarsia sp., Omisus pica, Orthocladius lignicola, Orthocladius oblidens, Orthocladius obumbratus, Orthocladius rivulorum, Orthocladius rubicundus, Orthocladius sp., Orthocladius wetterensis, Paraborniella sp., Paraborniella tonnoiri, Parachironomus arcuatus, Parachironomus biannulatu, Parachironomus biannulatus, Parachironomus digitalis, Parachironomus parilis, Parachironomus sp., Paracladopelma laminata agg., Parakiefferiella sp., Paralimnophyes albibasis, Paralimnophyes hydrophilu, Paralimnophyes hydrophilus, Paramerina sp., Parametriocnemus sp., Parametriocnemus stylatus, Paratanytarsus austriacus, Paratanytarsus boiemicus, Paratanytarsus cf. laccophilus, Paratanytarsus confusus, Paratanytarsus grimmii, Paratanytarsus inopertus, Paratanytarsus intricatus, Paratanytarsus laetipes, Paratanytarsus lauterborni, Paratanytarsus penicillatus, Paratanytarsus sp., Paratanytarsus tenellulus, Paratanytarsus tenuis, Paratendipes albimanus, Paratendipes albimanus/plebeius, Paratendipes sp., Paratrichocladius rufiventris, Paratrichocladius sp., Pentaneura sp., Phaenopsectra flavipes, Phaenopsectra mortensoni, Phaenopsectra pilicellata, Phaenopsectra profusa, Phaenopsectra punctipes, Phaenopsectra sp., Polypedilum arundinetum, Polypedilum cf. dewulfi, Polypedilum convictum, Polypedilum cultellatum, Polypedilum flavicorne, Polypedilum gr. fallax, Polypedilum gr. nubeculosum, Polypedilum leei, Polypedilum leucopum, Polypedilum nubeculosum, Polypedilum nubifer, Polypedilum oresitrophus, Polypedilum pedestre agg., Polypedilum sordens, Polypedilum sordens agg., Polypedilum sp., Polypedilum trigonus, Polypedilum tritum, Polypedilum tritum/uncinatum, Polypedilum uncinatum agg., Polypedilum vanderplanki, Potthastia longimanus, Procladius bellus, Procladius cf. freemani, Procladius choreus, Procladius choreus-agg, Procladius crassinervis, Procladius culiciformis, Procladius flavifrons, Procladius paludicola, Procladius signatus, Procladius sp., Prodiamesa olivacea, Prodiamesa sp., Psectrocladius (Allopsectrocladius) sp., Psectrocladius barbimanus, Psectrocladius gr. psilopterus, Psectrocladius limbatellus, Psectrocladius obvius, Psectrocladius platypus, Psectrocladius sordidellus, Psectrocladius sordidellus agg., Psectrocladius sp., Psectrotanypus dyari, Psectrotanypus guttularis, Psectrotanypus johnsoni, Psectrotanypus sp., Psectrotanypus varius, Pseudochironomus middlekauffi, Reomyia sp., Rheocricotopus chalybeatus, Rheocricotopus effusus agg., Rheocricotopus fuscipes, Rheocricotopus sp., Rheopelopia sp., Rheotanytarsus photophilus, Rheotanytarsus sp., Stempellina sp., Stenochironomus cinctus, Stenochironomus sp., Stictichironomus sp., Synendotendipes impar, Synendotendipes lepidus, Synendotendipes sp., Synorthocladius semivirens, Tanypus kraatzi, Tanypus punctipennis, Tanytarsus brundini, Tanytarsus buchonius, Tanytarsus debilis, Tanytarsus ejuncidus, Tanytarsus eminulus, Tanytarsus fuscithorax, Tanytarsus glabrescens, Tanytarsus lestagei-agg., Tanytarsus oyamai, Tanytarsus palidicornis, Tanytarsus semibarbitarsus, Tanytarsus sp., Tanytarsus usmaensis, Telmatopelopia nemorum, Telopelopia fascigera, temporary pools, Thienemaniella sp., Thienemanniella cf. obscura, Thienemannimyia vitellina, Tribelos ater, Tribelos sp., Trichotanypus posticalis, Trichotanypus sp., Trissocladius brevipalpis, Trissocladius sp., Tvetenia calvescens, Virgatanytarsus sp., Wirthiella sp., Xenopelopia falcigera, Xenopelopia nigricans, Xenopelopia sp., Zalutschia humphriesiae, Zalutschia sp., Zalutschia tatrica, Zavreliella marmorata, Zavrelimyia melanura, Zavrelimyia nubila/barbatipes, Zavrelimyia signatipennis, Zavrelimyia sinuosa, Zavrelimyia sp.', 'phdthesis'),
(573, 'Jónasson and Kristiansen 1967', '', 'Joa1967', 'Jónasson, P. M. and Kristiansen, J.', 1967, NULL, NULL, NULL, NULL, NULL, 'Primary and Secondary Production in Lake Esrom. Growth of <i>Chironomus anthracinus</i> in Relation to Seasonal Cycles of Phytoplankton and Dissolved Oxygen', 'Internationale Revue der gesamten Hydrobiologie und Hydrographie', 'http://dx.doi.org/10.1002/iroh.19670520203', '52', '2', '163--217', NULL, NULL, NULL, 'Chironomus anthracinus, lake Esrom (Denmark), oxygen regime, phytoplancton', 'article'),
(275, 'Kieffer 1922', '', 'Kie1922', 'Kieffer, J. J.', 1922, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(276, 'Edwards 1929', '', 'Edw1929', 'Edwards', 1929, NULL, NULL, NULL, NULL, NULL, 'British Non-biting Midges (Chironomidae)', 'Transactions of the Entomological Society of London', NULL, '77', NULL, '279–438', NULL, NULL, 'cited from [[http://www.springerlink.com/content/g56r6g46271u3258/]], {citeID|439|Pinder 1976b}, {citeID|357|Yan 2005a} ', 'Chironomidae, Psectrocladius barbimanus, UK', 'article'),
(277, 'Meigen 1838', '', 'Mei1838', 'Meigen, J. W.', 1838, NULL, NULL, NULL, NULL, NULL, 'Systematische Beschreibung der bekannten europäischen zweiflugeligen Insekten', 'Siebenter Theil oder Supplementband. Schultz, Hamm', NULL, '7', NULL, 'I-XII [= 1-12], 1-434', NULL, NULL, 'cited from [[http://www.animalbase.uni-goettingen.de/zooweb/servlet/AnimalBase/search]]', '', 'no entry type given'),
(278, 'Hofmann 1971', '', 'Hof1971', 'Hofmann, W.', 1971, NULL, NULL, NULL, NULL, NULL, 'Zur Taxonomie und Paläoökologie subfossiler Chironomiden (Dipt.) in Seesedimenten', 'Archiv für Hydrobiologie', 'http://www.schweizerbart.de/j/archiv-hydrobiologie/', '6', NULL, '1-50', NULL, NULL, 'in German', 'palaeoecology, subfossil chironomids, larvae\r\n', 'article'),
(279, 'Wang 2000', '', 'Wan2000', 'Wang, X.', 2000, 'xhang@nankai.edu.cn', 'Department of Biology, Nankai University, Tianjin, 300071, China', 'Odwin Hofrichter', NULL, NULL, 'A revised checklist of chironomids from China (Diptera)', 'Late 20th century research on Chironomidae: An Anthology from the 13th International Symposion on Chironomidae (Shaker Verlag, Aachen)', NULL, NULL, NULL, '629-652', NULL, 'A checklist of Chinese chironomids is given. It includes 459 species belonging to 136 genera and 7 subfamilies with their distribution in China, life stages known, original authors, and previously erroneous identification or placement. 34 genera and 137 species are new records.', NULL, 'checklist, China, Chironomidae, fauna records', 'article'),
(280, 'Stur and Ekrem 2006', '', 'StE2006', 'Stur, E. and Ekrem, T.', 2006, NULL, 'Museum of Natural History and Archaeology, Norwegian University of Science and Technology, NO-7491 Trondheim, Norway', NULL, NULL, NULL, 'A revision of West Palaearctic species of the Micropsectra atrofasciata species group (Diptera: Chironomidae)', 'Zoological Journal of the Linnean Society', 'http://doi.wiley.com/10.1111/j.1096-3642.2006.00198.x', '146', '2', '165–225', 'April', 'Phylogenetic relations among selected Micropsectra (Diptera: Chironomidae) species are inferred using mitochondrial COII gene sequences and morphological characters. Both maximum parsimony and Bayesian analyses indicate a monophyletic atrofasciata species group. However, some species morphologically similar to M. atrofasciata (Kieffer) in the adult male, i.e. M. appendica sp. nov. and M. logani (Johannsen), are placed outside the atrofasciata group in the gene trees. The phylogenetic hypotheses based on parsimony analyses of the combined molecular and morphological data sets weakly support a monophyletic atrofasciata group including M. appendica sp. nov. and M. logani if third positions in the COII gene sequences are excluded. In the taxonomic part of this study, adult males, pupae and larvae of Micropsectra aristata Pinder, M. atrofasciata, M. bavarica sp. nov., M. klinki sp. nov., M. logani, M. pallidula (Meigen) and M. schrankelae sp. nov., and adult males and pupae of M. appendica sp. nov. and M. sofiae sp. nov. as well as adult males of M. andalusiaca Marcuzzi, M. calcifontis sp. nov., M. freyi Storå, M. longicrista sp. nov., M. robusta sp. nov., and M. zernyi Marcuzzi are described and diagnosed. Micropsectra bidentata (Goetghebuer), M. jokaquarta Sasa & Ogata, M. miki Marcuzzi, M. pallida Goetghebuer, M. subnitens Goetghebuer, M. suecica (Kieffer) and M. shouharasima Sasa are new junior synonyms of M. atrofasciata; Micropsectra groenlandica Andersen and M. utonaitertia Sasa are new junior synonyms of M. logani; Micropsectra candida Chaudhuri & Datta, M. franzi Goetghebuer and M. viridiscutellata Goetghebuer are new junior synonyms of M. pallidula. Comments on the ecology, distribution and systematics of each species are provided. Keys to all known life stages are presented, as well as an annotated list of species morphologically similar to species in the atrofasciata group and nomina dubia in the atrofasciata group. Chironomus mimulus Holmgren is transferred to the genus Micropsectra. © 2006 The Linnean Society of London, Zoological Journal of the Linnean Society, 2006, 146, 165–225.', 'many numeric measurements concerning adults, pupae and larvae', 'adult male, COII, distribution, ecology, larvae, Micropsectra andalusiaca, Micropsectra appendica, Micropsectra aristata, Micropsectra atrofasciata, Micropsectra atrofasciata,, Micropsectra bavarica, Micropsectra bidentata, Micropsectra calcifontis, Micropsectra candida, Micropsectra franzi, Micropsectra freyi, Micropsectra groenlandica, Micropsectra jokaquarta, Micropsectra klinki, Micropsectra logani, Micropsectra longicrista, Micropsectra miki, Micropsectra pallida, Micropsectra pallidula, Micropsectra robusta, Micropsectra schrankelae, Micropsectra shouharasima, Micropsectra sofiae, Micropsectra subnitens, Micropsectra suecica, Micropsectra utonaitertia, Micropsectra viridiscutellata, Micropsectra zernyi, parsimony, phylogenetic relations, pupae, revision determination key, systematics', 'article'),
(281, 'Klink 1982', '', 'Kli1982', 'Klink, A. G.', 1982, NULL, NULL, NULL, NULL, NULL, 'Het Genus Micropsectra Kieffer. Een Taxonomische-en oekologische Studie', 'Medeklinker', NULL, '2', NULL, '1–59', NULL, NULL, 'cited from {citeID|280|Stur and Ekrem 2006}', '', 'no entry type given'),
(282, 'Pinder 1976', 'a', 'Pin1976', 'Pinder, L. C. V.', 1976, NULL, NULL, NULL, NULL, NULL, 'Micropsectra aristata, a new species of chironomid (Dipt. Nematocera) from southern England', 'Hydrobiologia', NULL, '51', NULL, '275–280', NULL, NULL, 'cited from {citeID|280|Stur and Ekrem 2006}', '', 'no entry type given'),
(283, 'Fittkau and Reiss 1998', '', 'FiR1998', 'Fittkau E. J. and Reiss F.', 1998, NULL, NULL, NULL, NULL, NULL, 'Micropsectra pharetrophora, a new species of Tanytarsini (Diptera, Chironomidae) constructing portable larval cases', 'Journal of the Kansas Entomological Society', NULL, '71', NULL, '226–233', NULL, NULL, '(distributed in 1999.) cited from {citeID|280|Stur and Ekrem 2006}', '', 'no entry type given'),
(284, 'Tang et al. 2004', '', 'Tan2004', 'Tang, H., Guo, Y., Wang, X. and Sæther, O. A.', 2004, 'xhwang@nankai.edu.cn', 'to Xinhua Wang, Department of Biology, Life Science College, Nankai University, Tianjin 300071, China', NULL, NULL, NULL, 'The pupa and larvae of Propsilocerus taihuensis (Wen, Zhou & Rong) (Diptera: Chironomidae), with comlete keys to all immatures of the genus Propsilocerus', 'Aquatic Insects', NULL, '26', '3/4', '265-272', NULL, NULL, NULL, NULL, 'no entry type given'),
(285, 'Kiknadze et al. 2005', '', 'Kik2005', 'Kiknadze, I. I., Wang, X., Istomina, A. G. and Gunderina, L. I.', 2005, 'xhwang@nankai.edu.cn', 'to Xinhua Wang, Department of Biology, Life Science College, Nankai University, Tianjin 300071, China', NULL, NULL, NULL, 'An new Chironomus species of the plumosus sibiling-group (Diptera, Chironomidae) from China', 'Aquatic Insects', NULL, '27', '3', '199-211', NULL, 'Chironomus sinicus sp. n. is described from China. The new species was referred to previously as C. plumosus (L.). Study of the karyotype has shown strong karyological difference between C. sinicus and the true C. plumosus. Five of the seven chromosomal arms (B, C, D, F, G) have different species- specific banding sequences in C. sinicus in comparison with C. plumosus. Two chromosomal arms (A and E) are identical in both species. Despite of the karyological differences indicated, the general pattern of banding sequences in C. sinicus is related closely to C. plumosus and other members of the plumosus sibling group. Larva, pupa and adult morphology of C. sinicus are very similar to C. plumosus. The larva, however, have ventral tubules of the semireductus type. The pupa has shagreen on sternite III – IV.', '"Kiknadze 2005" -> "Kiknadze et al. 2005" (Su Dec 13 2009)', 'China, Chironomus plumosus, Chironomus sinicus, description, karyotypes, new species, original description', 'article'),
(286, 'Yan et al. 2005', 'c', 'Yan2005', 'Yan, C., Tang, H. and Wang, X.', 2005, 'xhwang@nankai.edu.cn', 'to Xinhua Wang, Department of Biology, Life Science College, Nankai University, Tianjin 300071, China', NULL, NULL, NULL, 'Nilothauma Kieffer from China (Diptera: Chironomidae)', 'Aquatic Insects', NULL, '27', '3', '213-220', NULL, NULL, NULL, '', 'no entry type given'),
(287, 'Oliver et al. 1978', '', 'Oli1978', 'Oliver, D. R., McClymont, D. and Roussel, M. E.', 1978, NULL, NULL, NULL, NULL, NULL, 'A key to some larvae of Chironomidae (Diptera) from the Mackenzie and Porcupine River Watersheds', 'Fisheries and Marine Service, Technical Report', NULL, '791', NULL, '1-73', 'August', NULL, NULL, '', 'no entry type given'),
(288, 'Fittkau and Roback 1983', '', 'FiR1983', 'Fittkau, E. J. and Roback, S. S.', 1983, NULL, NULL, 'T.Wiederholm', NULL, NULL, 'The larvae of Tanypodinae - Keys and diagnoses. In: Chironomidae of the Holarctic region. Keys and diagnoses. Part 1 - Larvae', 'Entomologica Scandinavica Supplement', NULL, '19', NULL, '33-110', NULL, NULL, 'ISSN 0105-3574', NULL, 'incollection'),
(289, 'Epler 1988', 'a', 'Epl1988', 'Epler, J. H.', 1988, NULL, NULL, NULL, NULL, NULL, 'A reconsideration of the genus Apedilum Townes, 1945 (Diptera: Chironomidae: Chironominae)', 'Spixiana Supplement', NULL, '14', NULL, '105-116', NULL, NULL, 'cited from {citeID|6|Epler 2001}', '', 'no entry type given'),
(290, 'Hudson et al. 1990', '', 'Hud1990', 'Hudson, P. L., Lenat, D. R., Caldwell, B. A. and Smith, D.', 1990, NULL, NULL, NULL, NULL, NULL, 'Chironomidae of the Southeastern United States: A checklist of species and notes on biology, distribution, and habitat', 'Fish and Wildlife Research, ISSN 1040-2411', 'http://handle.dtic.mil/100.2/ADA322803', '7', NULL, '1-46', NULL, 'We provide a current listing of the species of midges (Diptera:Chironomidae) in the southeastern United States (Alabama, Florida, Georgia, North Carolina, South Carolina, and Tennessee). This checklist should aid in research on this group of insects, which have often proved useful in the assessment of water quality. We document each species distribution and general habitat and provide the best taxonomic reference to facilitate the identification or description of species in that genus. Changes in nomenclature, unique ecological traits, bibliographic sources, or other items of information are summarized in a paragraph on each genus. Regional distribution of the principal subfamilies indicated that the species of Chironominae and Tanypodinae were concentrated in the coastal region, whereas the Orthocladiinae were evenly distributed from the coast to the mountains. Considering the major habitats (lakes, rivers, and streams), Tanypodinae were about evenly distributed; Orthocladiinae were more predominant in streams and Chironominae in lakes.', NULL, '', 'no entry type given'),
(291, 'Townes 1945', '', 'Tow1945', 'Townes, H. K.', 1945, NULL, NULL, NULL, NULL, NULL, 'The nearctic species of Tendipedini (Diptera: Tendipedidae (=Chironomidae))', 'American Midland Naturalist', NULL, '34', NULL, '1-206', NULL, NULL, 'cited from {citeID|6|Epler 2001} {citeID|357|Yan et.al 2005a}', '', 'no entry type given'),
(292, 'Jackson 1977', '', 'Jac1977', 'Jackson, G. A.', 1977, NULL, NULL, NULL, NULL, NULL, 'Nearctic and Palaearctic Paracladopelma Harnisch and Saetheria n. gen. (Diptera: Chironomidae)', 'Journal of the Fisheries Research Board of Canada', NULL, '34', NULL, '1321-1359', NULL, NULL, 'cited from {citeID|6|Epler 2001}', '', 'no entry type given'),
(293, 'Thienemann 1951', '', 'Thi1951', 'Thienemann, A.', 1951, NULL, NULL, NULL, NULL, NULL, 'Tanytarsus-Studien II. Die Subsectio Paratanytarsus. Auf grund der nachgelassenen Papiere Friedrich Wilh. Carl Krüger''s', 'Archiv für Hydrobiologie, Supplement', NULL, '18', NULL, '595-632', NULL, NULL, 'citet from {citeID|2|Pinder and Reiss 1983}', '', 'no entry type given'),
(294, 'Wang 1994', '', 'WaS1994', 'Wang, S.', 1994, NULL, 'Institute of Hydrobiology, Academia Sinica, Wuhan, Hubei 430072', NULL, NULL, NULL, 'New and little-known Chironomidae (Diptera) from the southern provinces of China', 'Entomotaxonomia', NULL, '16', '2', '135-148', 'June', NULL, NULL, 'Ablabesmyia phatta, Apsectrotanypus trifascipennis, Conchapelopia melanops, Cricotopus tremulus, Guizhou, Hubei, Hunan, Pseudorthocladius, Sætheria, Sergentia, Smittia aterrima, Sympotthastia repentina, Tanypus chinensis, Yunnan', 'article'),
(295, 'Yan and Ye 1977', '', 'YaY1977', 'Yan, J. and Ye, C.¹', 1977, NULL, '¹ Northwest Plateau Institut of Biology, Academia Sinca, Xining, 81000, China.', NULL, NULL, NULL, 'Notes on the Larvae of some chironomid midge (Diptera: Tendipedidae) and two new species from Bai-Yang-Dian Lake in Hopei Province', 'Acta Entomologica Sinica', NULL, '20', NULL, '183-198', NULL, NULL, 'in chinese', NULL, 'no entry type given'),
(296, 'Plank (annote)', '', 'PlaXXXX', 'Plank, A.', 0, 'andreas.plank@web.de', 'Free University Belin, Malteserstraße 74-100, House D, 12249 Berlin', NULL, NULL, NULL, 'Pictures, Annotations in this program and characteristics of chironomidae', 'This program', NULL, NULL, NULL, NULL, NULL, NULL, 'mostly you will see the timestamp', '', 'no entry type given'),
(297, 'Laville 1971', '', 'Lav1971', 'Laville, H.', 1971, NULL, NULL, NULL, NULL, NULL, 'Recherches sur les chironomides (Diptera)     lacustres du Massif de Néouvielle (Hautes-Pyrénées)', 'Annales de Limnologie', NULL, '7', NULL, '173-332', NULL, NULL, NULL, '', 'no entry type given'),
(298, 'Moller-Pillot et al. 1997', '', 'MoP2000', 'Moller-Pillot, H. K. M., Vallenduuk, H. J. and bij de Vaate, A.', 1997, NULL, NULL, NULL, NULL, NULL, 'Bijdrage tot den kennis over de Nederlandse Chironomidae (vedermuggen): de larven van het genus Glyptotendipes in West-Europa', 'Lelystad, Rijksinstituut voor Integraal Zoetwaterbeheer &#038; Afvalwaterbehandeling, rapport nr. 97.053, ISBN 9036951003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(299, 'Heyn 1992', '', 'Hey1992', 'Heyn, M. W.', 1992, NULL, NULL, NULL, NULL, NULL, 'A review of systematic position of the North American species of the genus Glyptotendipes', 'Netherlands Journal of Aquatic Ecology', NULL, '26', NULL, '129-137', NULL, NULL, 'cited from {citeID|298|Moller-Pillot et.al. 1997}', 'review, Glyptotendipes, North America', 'article'),
(300, 'Kalugina 1963', '', 'Kal1963', 'Kalugina, N. S.', 1963, NULL, NULL, NULL, NULL, NULL, 'Systematics and developement of Glyptotendipes glaucus Mg. and G. gripekonveni Kieff. (Diptera Chironomidae)', 'Entomologicheskoe Obozrenie', NULL, '42', NULL, '889-908', NULL, NULL, 'cited from {citeID|298|Moller-Pillot et.al. 1997} (Russian)', '', 'no entry type given'),
(301, 'Kalugina 1979', '', 'Kal1979', 'Kalugina, N. S.', 1979, NULL, NULL, 'Nartshuk ed., Leningrad', NULL, NULL, 'Morpho-ecological groups of the genus Glyptotendipes Kieffer (Diptera Chironomidae) - Ecological and morphological principles of Diptera systematics', 'Zool.Inst.Acad Nauk SSSR', NULL, NULL, NULL, NULL, NULL, NULL, 'cited from {citeID|298|Moller-Pillot et.al. 1997} (Russian)', '', 'no entry type given'),
(302, 'Brooks et al. 2007', '', 'Bro2007', 'Brooks, S. J., Langdon, P. G. and Heiri, O.', 2007, 's.brooks@nhm.ac.uk p.g.langdon@soton.ac.uk o.heiri@bio.uu.nl', NULL, NULL, NULL, NULL, 'The identification and use of palaearctic Chironomidae larvae in Palaeoecology', 'Quarternary Research Association, Techincal Guide', NULL, NULL, '10', '276', NULL, NULL, 'ISBN 0907 780 717', 'determination key, subfossil larvae', 'book'),
(303, 'Walker 1991', '', 'Wal1991', 'Walker, I. R.', 1991, NULL, 'Biology Dept., Queen''s Univ., Kingston, Ontario, K7L 3N6, Canada', NULL, NULL, NULL, 'Modern assemblages of arctic and alpine Chironomidae as analogues for late-glacial communities', 'Hydrobiologia', 'http://www.springerlink.com/content/100271/', '214', '1', '223-227', 'May', NULL, NULL, '', 'no entry type given'),
(304, 'Spies and Sæther 2004', '', 'SpS2004', 'Spies, M. and Sæther, O. A.', 2004, 'spies@zi.biologie.uni-muenchen.de ole.sather@zmb.uib.no', 'c/o Zoologische Staatssammlung München, Münchhausenstr. 21, D-81247 München, Germany;Museum of Zoology, University of Bergen, Muséplass 3, N-5007 Bergen, Norway;', NULL, NULL, NULL, 'Notes and recommendations on taxonomy and nomenclature of Chironomidae (Diptera)', 'Zootaxa', 'http://www.mapress.com/zootaxa/2004f/z00752f.pdf', '752', NULL, '1–90', NULL, NULL, 'ISSN 1175-5326 (print edition) ISSN 1175-5334 (online edition)', '', 'no entry type given'),
(305, 'Borkent 1984', '', 'Bor1984', 'Borkent, A.', 1984, NULL, NULL, 'Stephen M. Smith', NULL, NULL, 'The systematics and phylogeny of the Stenochironomus complex (Xestochironomus, Harrisius, and Stenochironomus)(Diptera: Chironomidae)', 'Memoirs of the Entomological Society of Canada', NULL, '128', NULL, '1-269', NULL, 'from OCR: The Stenochironomus complex contains all those species which exhibit the highly modified, mining larval form previously recognized as typical of only the genus Stenochironomus Kieffer: larvae with a dorsoventrally compressed head capsule, expanded thoracic segments and a long, flaccid abdomen. The complex includes members of Xestochironomus Sublette & Wirth (New World), Harrisius Freeman (Australian Region), Stenochironomus (cosmopolitan) and two larval forms, one from New Zealand and the other from Africa. This revision provides analysis of 12 species of Xestochironomus (live new), four species of Harrisius, and 54 species of Neotropical and Holarctic Stenochironomus (32 new named species, two new species not named, and four new combinations: S. innacuus (Williston), S. semifumosus (Edwards), S. longilobatus (Tokunaga) and S. gracilivalva (Kieffer)). Of these species, the pupae and fourth instar larvae are described for two species of Xestochironomus, Harrisius pallidus Freeman and 24 of the named species of Stenochironomus. Descriptions, diagnoses, keys, and distribution maps are provided for all species in each available stage. Stenochironomus taeniapennis (Coquillett, 1901), S. zonopterus (Mitchell, 1908), and S. exquisitus (Mitchell, 1908) are newly recognized as junior synonyms of S. hilaris (Walker, 1848). A cladistic analysis of all these species suggests that the Stenochironomus complex is monophyletic. The African larval form is the sister group of all other members; Xestochironomus is the sister group of Harrisius, the New Zealand larval form and Stenochironomus; and Stenochironomus is the sister group of Harrisius plus the New Zealand larval form. These relationships suggest possible southem continental affinities. Stenochironomus is composed of two monophyletic species groups, the subgenus · Stenochironomus s. str. with species whose larvae mine wood and the new subgenus Petalopholeus (type-species, S. cinctus Townes) with species whose larvae mine leaves. Cladistic patterns show that Caribbean species are related to other New World species, and that North American species are related to Neotropical or Palaearctic species. Larval food type and ecological differences are analyzed using cladistic relationships. The plesiotypic habitat for species of the Stenochironomus complex is running waters. The phylogenetic relationships of Stenochironomus species and their mite parasites are compared and show little congruence.', 'ISSN 0071-075X', 'Chironomidae systematics, cladistic species analysis, descriptions, determination key, distribution maps, Harrisius Freeman, Harrisius pallidus Freeman, mite parasites, Petalopholeus, revision, Stenochironomus cinctus Townes, Stenochironomus complex, Stenochironomus exquisitus (Mitchell 1908), Stenochironomus gracilivalva (Kieffer), Stenochironomus hilaris (Walker 1848), Stenochironomus innacuus (Williston), Stenochironomus longilobatus (Tokunaga), Stenochironomus semifumosus (Edwards), Stenochironomus taeniapennis (Coquillett 1901), Stenochironomus zonopterus (Mitchell 1908), Xestochironomus Sublette & Wirth', 'article'),
(306, 'Cranston 2007', '', 'Cra2007', 'Cranston, P. S.', 2007, NULL, NULL, NULL, NULL, NULL, 'The Chironomidae larvae associated with the Tsunami-impacted waterbodies of the coastal plain of Southwestern Thailand', 'The Raffles Bulletin of Zoology', 'http://rmbr.nus.edu.sg/rbz/biblio/55/55rbz231-244.pdf', '55', '2', '231-244', NULL, NULL, NULL, '', 'no entry type given'),
(307, 'Kieffer 1916', '', 'Kie1916', 'Kieffer, J. J.', 1916, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(308, 'Soponis and Russell 1982', '', 'Sop1982', 'Soponis, A. R. and Russell, C. L.', 1981, NULL, NULL, NULL, NULL, NULL, 'Identification of instars and species in some larval Polypedilum (Polypedilum) (Diptera: Chironomidae)', 'Hydrobiologia', 'http://www.springerlink.com/content/p20n280030146tv3/', '94', '1', '25-32', 'August', NULL, NULL, '', 'no entry type given'),
(309, 'Walker 1856', '', 'Wal1856', 'Walker', 1856, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(310, 'Ekrem 2004', '', 'Ekr2004', 'Ekrem, T.', 2004, NULL, NULL, NULL, NULL, NULL, 'Immature stages of European Tanytarsus species I. The eminulus-, gregarius-, lugens-   and mendax species groups (Diptera: Chironomidae)', 'Deutsche entomologische Zeitschrift', NULL, '51', '1', '97–146', NULL, NULL, NULL, 'description, keys, larvae, Palaearctic, Paratanytarsus, pupae, Tanytarsus, Tanytarsus aberrans P, Tanytarsus aculeatus P, Tanytarsus bathophilus, Tanytarsus bathophilus P L, Tanytarsus decipiens P L, Tanytarsus dibranchius P L, Tanytarsus dispar, Tanytarsus ejuncidus P L, Tanytarsus eminulus P L, Tanytarsus fimbriatus, Tanytarsus formosanus P L, Tanytarsus gregarius P L, Tanytarsus inaequalis, Tanytarsus inaequalis P L, Tanytarsus latiforceps, Tanytarsus lestagei P L, Tanytarsus longitarsis P, Tanytarsus lugens P L, Tanytarsus mancospinosus P L, Tanytarsus medius P L, Tanytarsus mendax P L, Tanytarsus multipunctatus P, Tanytarsus occultus P L, Tanytarsus palmeni P L, Tanytarsus profundorum, Tanytarsus pseudolestagei P L, Tanytarsus pseudotenellulus, Tanytarsus simulans, Tanytarsus smolandicus P, Tanytarsus socialis, Tanytarsus striatulus P L, Tanytarsus telmaticus, Tanytarsus telmaticus P L, Tanytarsus tika P, Tanytarsus tokunagai, Tanytarsus verticillatus, Tanytarsus volgensis, Tanytarsus volgensis P L, taxonomic literature', 'article'),
(311, 'Morozova 2004', '', 'Mor2004', 'Morozova, E. E.', 2004, NULL, NULL, NULL, NULL, NULL, 'A Review of Larvae and Pupae of the Midge Genus Cryptochironomus Kieffer (Diptera, Chironomidae)', 'Entomological Review (English Translation of Entomologicheskoye Obozreniye ISSN 0367-1445)', 'http://www.springerlink.com/openurl.asp?genre=journal&issn=0013-8738', '84', '6', '696-703', NULL, 'Larvae and pupae of 8 species of the midge genus Cryptochironomus Kieffer from Saratov Province and the Netherlands have been examined. A key to species is given for these phases.', NULL, '', 'no entry type given'),
(313, 'Sæther and Wang 1995', '', 'Sae1995', 'Sæther, O. A. and Wang, X.', 1995, NULL, NULL, NULL, NULL, NULL, 'Revision of the genus Paraphaenocladius Thienemann, 1924 of the world (Diptera: Chironomidae, Orthocladiinae)', 'Entomologica Scandinavica Supplement', NULL, '48', NULL, '3–69', NULL, NULL, NULL, '', 'no entry type given');
INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(314, 'NHM Collection (London)', '', 'NHMLond', 'NHM Collection: different authors', 0, NULL, NULL, NULL, NULL, NULL, 'Chironomidae Collection', 'Natural History Museum (London) at S.Brooks', NULL, NULL, NULL, NULL, NULL, NULL, 'pictures from visitation Oct 2007', '', 'no entry type given'),
(315, 'Meigen 1818', '', 'Mei1818', 'Meigen, J. W.', 1818, NULL, NULL, NULL, NULL, NULL, 'Systematische Beschreibung der bekannten europäischen zweiflügeligen Insekten', 'Aachen. (Forstmann).', NULL, '1', NULL, 'I-XXXVI [= 1-36], 1-324', NULL, NULL, 'Erster Theil mit elf Kupfertafeln. Cited from [[http://www.animalbase.uni-goettingen.de/zooweb/servlet/AnimalBase/search]]', '', 'no entry type given'),
(317, 'Straeger 1839', '', 'Sta1839', 'Staeger, C.', 1839, NULL, NULL, NULL, NULL, NULL, 'Systematisk fortegnelse over di i Danmark hidtil fundne Diptera', 'Naturhist. Tidsskr.', NULL, '2', NULL, '549-600', NULL, NULL, '"Steager 1839" not checked for Glyptotendipes barbipes, Cricotopus (Isocladius) intersectus, Cryptochironomus albofasciatus, Dicrotendipes nervosus', 'Glyptotendipes barbipes, Cricotopus intersectus, Criptochironomus albofasciatus, Dicrotendipes nervosus', 'article'),
(318, 'Fabricius 1794', '', 'Fab1794', 'Fabricius, J. C.', 1794, NULL, NULL, NULL, NULL, NULL, 'Entomologica systematica emendata at auca.', NULL, NULL, 'IV', NULL, '472', NULL, NULL, 'Hafniae', '', 'no entry type given'),
(319, 'Zetterstedt 1850', '', 'Zet1850', 'Zetterstedt, J. W.', 1850, NULL, NULL, NULL, NULL, NULL, 'Diptera Scandinaviae', NULL, NULL, 'IX', NULL, '3367-3710', NULL, NULL, 'Lundae', '', 'no entry type given'),
(320, 'Oliver 1959', '', 'Olo1959', 'Oliver, D. R.', 1959, NULL, NULL, NULL, NULL, NULL, 'Some Diamesini from the Nearctic and Palaearctic', 'Entomologisk Tidskrift', NULL, '80', NULL, '48-64', NULL, NULL, NULL, NULL, 'no entry type given'),
(321, 'Makarchenko and Makarchenko 2000', '', 'Mak2000', 'Makarchenko, E. A. and Makarchenko, M. A.', 2000, NULL, NULL, 'Odwin Hoffrichter', NULL, NULL, 'Revision of Pagastia Oliver, 1959 (Diptera, Chironomidae) of the holarctic region', 'Late 20th century research on Chironomidae: An Anthology from the 13th International Symposion on Chironomidae (Shaker Verlag, Aachen)', NULL, NULL, NULL, '171-176', NULL, NULL, NULL, '', 'no entry type given'),
(322, 'Edwards 1924', '', 'Edw1924', 'Edwards', 1924, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(323, 'Makarchenko 1982', '', 'Mak1982', 'Makarchenko, E. A.', 1982, NULL, NULL, NULL, NULL, NULL, 'Хирономиды рода Protanypus Kieffer (Diptera, Chironomidae) Дальнего Востока СССР [Chironomids of the genus Protanypus Kieffer (Diptera, Chironomidae) from the far east of the USSR]', 'Там же', 'http://www.biosoil.ru/tendipes/biogr.htm#makar', NULL, NULL, '124-144', NULL, NULL, NULL, '', 'no entry type given'),
(324, 'Makarchenko and Makarchenko 2006', '', 'Mak2006', 'Makarchenko, E. A. and Makarchenko, M. A.', 2006, 'emakar@ibss.dvo.ru', NULL, NULL, NULL, NULL, 'A new species of Orthcladius van der Wulp, 1874 (Diptera, Chironomidae) of Russian Far East', 'Euroasian Entomological Journal', 'http://www.biosoil.ru/tendipes/makar12.pdf', '5', '1', '57-67', NULL, NULL, NULL, '', 'no entry type given'),
(325, 'Bíró 1981', '', 'Bia1981', 'Bíró, K.', 1981, NULL, NULL, NULL, NULL, NULL, 'Az Àrvaszúnyog-Lárvák Kishatározója', 'Vízügyi Hidrobiológia', NULL, '11', NULL, NULL, NULL, NULL, 'ISSN 0133-3003, ISBN 963 602 240 2; origianl in Czech, German translation 1988: Kleiner Bestimmungsschlüssel für Zuckmückenlarven (Diptera: Chironoidae), ISBN 3-900672-90-3', 'determination key', 'book'),
(326, 'Kieffer 1906', '', 'Kie1906', 'Kieffer, J. J.', 1906, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(327, 'Curry 1958', '', 'Cur1958', 'Curry, L. L.', 1958, NULL, NULL, NULL, NULL, NULL, 'Larvae and Pupae of the Species of Cryptochironomus (Diptera) in Michigan', 'Limnology and Oceanography', 'http://www.aslo.org/lo/toc/vol_3/issue_4/0427.pdf', '3', '4', '427-442', NULL, 'Collections from several diversified habitats in Michigan yielded larvae belonging to the genus Cryptochironomus. Subsequent collections were made to obtain the immature forms for laboratory cultures from which the adult midge was obtained. The reared adults were then associated with their respective immature forms. Information obtained\r\nfrom the associated specimens and museum specimens of other investigators formed the basis of a key for the Michigan species. Thus, the larval and pupal stages for C . sorex, C .fulvus, C . blarina, C . digitatus, and one new provisional species are given. In addition to the larval and pupal morphology, other pertinent facts regarding the biology of the species are given when known.\r\n', NULL, '', 'no entry type given'),
(328, 'Johannsen 1905', '', 'Joh1905', 'Johannsen, O. A.', 1905, NULL, NULL, NULL, NULL, NULL, 'Aquatic nematocerous Diptera II. In Needham, J. G., Morton, K. J. & Johannsen, O. A., May flies and midges of New York. Third report on aquatic insects.', 'New York State Museum, Bulletin', NULL, '86', NULL, '76-331', NULL, NULL, 'cited from [[http://www.catalogueoflife.org/]]', '', 'no entry type given'),
(329, 'Sæther 1990', '', 'Sae1990', 'Sæther, O. A.', 1990, NULL, NULL, NULL, NULL, NULL, 'A review of the genus Limnophyes Eaton from the Holarctic and Afrotropical regions (Diptera: Chironomidae, Orthocladiinae)', 'Entomologica Scandinavica Supplement', NULL, '35', NULL, '1-135', NULL, 'Generic diagnoses to all stages of the genus Limnophyes Eaton, 1875 are given. A synapomorphic diagram showing Limnophyes as the sistergroup of Compterosmittia Saether plus Parlimnophyes Brundin, and Heleniella Serra-Tosio as the sistergroup of all these, is presented. Within the genus Limnophyes, L. asquamatus Andersen form the sister species of the remaining species combined, which can be divided into two monophyletic groups, the barchytomus group and the minimus group. Keys to male and female imagines, pupae an larvae are given . Type material of 50 species assigned to Limnophyes or to Camptocladius v.d. Wulp belonging to 14 museums have been reexamined, lectotypes designated, and new combinations and synonyms given. Thirtynine species are treated, 15 of which are new, 14 are completely redescribed or previously unknown stages described, and additional descriptions or comments are given on the remaining species. L. edwardsi sp. n. is described in both sexes and all stages; L. schnelli sp. n. is described as male, female and pupa; L. bidumus sp. n. as male and female imago; L. spinigus as male and pupa; and L. doughmani sp. n., L. lobiscus sp. n., L. bubo sp. n., L prolatus sp. n., L. torulus sp. n., L. anderseni sp. n., L. madeirae sp. n., L. aagaardi sp. n., L. angelicae sp. n., L.cranstoni sp. n. and L. gelasinus sp. n. as male imagines. Errors in previous publications are corrected, remarks on variation given, and the systematics and phylogenetic position of species occurring outside the Holarctic and Afrotropical regions discussed. The genus as a whole appear to have had a northern Holarctic origin with possibly only one main vicariance event, the splitting into the primarily Nearctic brachytomus group and the mostly Palaearctic minimus group. Facultative parthenogenesis and dispersal along mountain ranges explain most of the dispersal to southern continents. A number of species pairs or triplets indicate postglacial or interglacial vicariance events.', NULL, '', 'no entry type given'),
(330, 'Walley 1925', '', 'Wal1925', 'Walley', 1925, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(331, 'Roback 1959', '', 'Rob1959', 'Roback, S. S.', 1959, NULL, NULL, NULL, NULL, NULL, 'The subgenus Ablabesmyia of Pentaneura (Diptera, Tendipedidae, Pelopiinae) ', 'Transactions of the American Entomological Society, Philadelphia', NULL, '85', NULL, '113-135', NULL, NULL, NULL, '', 'no entry type given'),
(332, 'Say 1823', '', 'Say1823', 'Say', 1823, NULL, NULL, NULL, NULL, NULL, 'Descriptions of dipterous insects of the United States', 'Journal of the Academy of Natural Sciences Philadelphia', NULL, '3', NULL, NULL, NULL, NULL, 'cited from internet', '', 'no entry type given'),
(333, 'Roback 1985', '', 'Rob1985', 'Roback, S. S.', 1985, NULL, NULL, NULL, NULL, NULL, 'The Immature Chironomids of the Eastern United States VI. Pentaneurini-Genus Ablabesmyia', 'Proceedings of the Academy of Natural Sciences of Philadelphia', NULL, '137', '2', '153-212', NULL, NULL, NULL, '', 'no entry type given'),
(334, 'Zhang and Wang 2004', '', 'Zha2004', 'Zhang, R. and Wang*, X.', 2004, NULL, '*College of Life Science, Nankai University, Tianjiin 300071, China', NULL, NULL, NULL, 'A revision of the genus Acricotopus Kieffer (Diptera: Chironomidae) in China', 'Entomologica Sinica', NULL, '11', '4', '285-291', NULL, 'The genus Acricotopus Kieffer including three species from China is reviewed. Acricotopus lucens (Zetterstedt) is reexamined. Two species A. simplex sp. nov. and A. zhalingensis sp. nov. are described as male imagines. Acricotopus simplex sp. nov. was collected from Xizang, Sichuan and Qinghai Provinces; the species differs from others of the genus by the absence of hind tibial comb, temporal and clypeal seta. Acricotopus zhalingensis sp. nov. was collected from Qinghai Province; the species is recognized by a combination of characters: the larger body size; the clypeus without setae; anal lobe strongly produced, nearly hemispherical shape; inferior volsella triangular, strongly sclerotized; gonostylus with 13 very long setae. A key to the world males of the genus is presented. The generic diagnosis is emended. All the types described in this paper are deposited in Department of Biology, Nankai University, China (BDN).', NULL, '', 'no entry type given'),
(335, 'Wang 1990', '', 'Wan1990', 'Wang, S.', 1990, NULL, NULL, NULL, NULL, NULL, 'Pseudosmittia aizaiensis new species Orthocladiinae Diptera Chironomidae from Hunan province of China', 'Chinese Journal of Oceanology and Limnology', NULL, '8', '3', '273-279', 'March', 'Male and female adult midges of Pseudosmittia aizaiensis sp. n. are described and illustrated with figures of morphological characters. The inferior volsella of gonocoxite with large lobes, the long but equal with gonostylus, and the small projection in basal part of outer margin are the characters that may separate this species from others. One larvae of this genus is purely aquatic in habitat and is associated with Cricotopus bicinctus, Cardiocladius capucinus and Polypedilum sp. in the same algae debris (Spirogyra sp.) of the Dunghe River. Further, the larvas very short SI and SII bifids, its 5 pairs of lateral teeth on mentum and its absence of premandible brush are the characters that may also separate this species from any known species of this genus.', NULL, '', 'no entry type given'),
(336, 'Roback 1982', '', 'Rob1982', 'Roback, S. S.', 1982, NULL, NULL, NULL, NULL, NULL, 'The identity of Ablabesmyia sp. Roback, Bereza, and Vidrine (1980) (Diptera: Chironomidae)', 'Entomological News', NULL, '93', NULL, '1315', NULL, NULL, NULL, '', 'no entry type given'),
(337, 'Meigen 1804', '', 'Mei1804', 'Meigen, J. W.', 1804, NULL, NULL, NULL, NULL, NULL, 'Klassifikazion und Beschreibung der europäischen zweiflügligen Insekten. (Diptera Linn.)', 'Braunschweig. (Reichard).', NULL, '1', '1', 'I-XXVIII, 1-152', NULL, NULL, 'Erster Band, erste Abtheilung, mit VIII Kupfertafeln, cited from [[http://www.animalbase.uni-goettingen.de/zooweb/servlet/AnimalBase/home/reference?id=2092]]', '', 'no entry type given'),
(338, 'Skuse 1889', '', 'Sku1889', 'Skuse, F. A. A.', 1889, NULL, NULL, NULL, NULL, NULL, 'Diptera of Australia. The Chironomidae', 'Proceedings of the Linnean Society of New South Wales (Ser. 2)', NULL, 'VI', NULL, '215-311', NULL, NULL, 'cited from [[http://www.genetics.unimelb.edu.au/Martin/AustChironfile/AustRef.htm#S]]', '', 'no entry type given'),
(339, 'Wulp 1874', '', 'Wul1874', 'Wulp, F. M. van der', 1874, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(340, 'Rossaro 1985', '', 'Ros1985', 'Rossaro, B.', 1985, NULL, NULL, NULL, NULL, NULL, 'Revision of the genus Polypedilum Kieffer, 1912. I. Key to adults, pupae and larvae of the species known to occur in Italy', 'Memorie della Società Entomologica Italiana', NULL, '62/63', NULL, '3-23', NULL, 'This is the first contribution to a revision of the genus Polypedilum Kieffer, 14 species are examined, 98 of which in all stages. Keys are provided for adult males, pupae and larvae. All species are figured. Quantitative characters are summarized in tables.', NULL, '', 'no entry type given'),
(341, 'Strobl 1900', '', 'Str1900', 'Strobl', 1900, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(342, 'Goetghebuer 1931', '', 'Goe1931', 'Goetghebuer, M. E. M.', 1931, NULL, NULL, NULL, NULL, NULL, 'Ceratopogonidae et Chironomidae nouveaux d''Europe', 'Bulletin et Annales de la Société royale belge d ''Entomologie', NULL, '71', NULL, '211–218', NULL, NULL, NULL, '', 'no entry type given'),
(343, 'Goetghebuer et al. 1948', '', 'Goe1948', 'Goetghebuer, M. E. M., Humphries, C. F., FritzGerald, A. M.', 1948, NULL, NULL, NULL, NULL, NULL, 'Metamorphosis of the Chironomidae I. A description of the larvae, pupae and imagines of some members of the genus Eukiefferiella (Kieff.); of the larva of Orthocladius crassicornis (Goetgh.) and of the imago of Orthocladius flaveolus (Goetgh.)', 'Hydrobiologia', 'http://www.springerlink.com/content/424067177158p010/', '1', '1-4', '410 - 424', 'March', NULL, 'print error with name FritzGerald?', '', 'no entry type given'),
(344, 'Goetghebuer 1937', 'b', 'Goe1937', 'Goetghebuer, M. E. M.', 1937, NULL, NULL, NULL, NULL, NULL, 'Tendipedidae-Tendipedinae (Chironomidae-Chironominae). A. Die Imagines.', 'In: Lindner, Erwin: Die Fliegen der Paläarktischen Region, Band III / 2', NULL, '3', '2', '1-48', NULL, NULL, 'part 13c; volume incompete see: [[http://www.schweizerbart.de/pubs/books/es/lindnerdie-132070320-desc.html]]; citet from [[http://www.catalogueoflife.org/]]', '', 'no entry type given'),
(345, 'Hayashi 1998', '', 'Hay1998', 'Hayashi, F.', 1998, NULL, NULL, NULL, NULL, NULL, 'Nanocladius (Plecopteracoluthus) asiaticus sp. n. (Diptera: Chironomidae) Phoretic on Dobsonfly and Fishfly Larvae (Megaloptera: Corydalidae)', 'Aquatic Insects', NULL, '20', '4', '215-229', NULL, 'The adult male, adult female, pupa, and larva of Nanocladius (Plecopteracoluthus) asiaticus sp. n. (Diptera: Chironomidae) are described and illustrated. Larvae live in coarse silken nets which usually are attached to the ventral side of the mesothorax of larval dobsonflies and fishflies (Megaloptera: Corydalidae) dwelling in stream riffles. The host species are Protohermes grandis and Parachauliodes continentalis in Japan, Protohermes costalis and Neochauliodes sinensis in Taiwan, and Neurhermes maculipennis in the Malay Peninsula. Larvae are not parasitic but may have a commensal relationship with their hosts; they feed on algae and detrital material caught on their silken nets, or on the body surface of their hosts. Pupation occurs in the fine silken net fixed to the lateral side of host thoracic regions, or occasionally to the undersides of hind legs.', NULL, '', 'no entry type given'),
(346, 'Reiss 1988', '', 'Rei1988', 'Reiss, F.', 1988, NULL, NULL, NULL, NULL, NULL, 'Die Gattung Kloosia Krusemann, 1933, mit der Neubeschreibung zweier Arten (Diptera, Chironomidae)', 'Spixiana Supplement', NULL, '14', NULL, '35-44', NULL, NULL, NULL, 'Kloosia', 'no entry type given'),
(347, 'Kobayashi 2007', '', 'Kob2007', 'Kobayashi, T.', 2007, NULL, NULL, NULL, NULL, NULL, 'Kloosia Kruseman, Chernovskiia Sæther, Robackia Sæther, and Sætheria Jackson (Chironomidae: Chironominae) in Japan', 'Zootaxa', NULL, '1527', NULL, '1-15', NULL, 'Kloosia koreana Reiss, 1988 is recorded from Japan for the first time and redescribed. Japanese material of other little known genera within the Harnischia complex are reexamined and identified. Beckidia sp. is assigned to the genus Kloosia; Chernovskiia orbicus (Townes, 1945) is reconfirmed based on the larvae; Robackia sp. is allotted to R. pilicauda (Sæther, 1977), and the presumed larva described for the first time; and Saetheria sp. is allotted to S. tylus (Townes, 1945).', NULL, '', 'no entry type given'),
(348, 'Kitagawa 2003', '', 'Kit2003', 'Kitagawa, N.', 2003, NULL, NULL, NULL, NULL, NULL, 'Taxonomic studies on Chironomid larvae (5)', 'Tansuiseibutsu', NULL, '88', NULL, '1-155', NULL, NULL, 'in Japanese', '', 'no entry type given'),
(349, 'Kitagawa 2004', '', 'Kit2004', 'Kitagawa, N.', 2004, NULL, NULL, NULL, NULL, NULL, 'Taxonomic studies on Chironomid larvae (6)', 'Tansuiseibutsu', NULL, '89', NULL, '1-124', NULL, NULL, 'in Japanese', '', 'no entry type given'),
(350, 'Akhorov 1977', '', 'Akh1977', 'Akhorov, F. (Ахоров, Ф.)', 1977, NULL, NULL, NULL, NULL, NULL, 'New species of the genus Psectrocladius (Diptera, Chironomidae) from Pamir and their metamorphosis', 'Zoologicheskii Journal (Зоологически Журнал)', NULL, '56', '7', '538-549', NULL, 'Larvae, pupae and imago are described for 10 new species of Chironomids. The material was obtained by rearing the IV instar larvae till the imago stage.', 'in Russian', 'Chironomidae, Psectrocladius', 'article'),
(351, 'Makarchenko 1983', '', 'Mak1983', 'Makarchenko, E. A.', 1983, NULL, NULL, NULL, NULL, NULL, 'Arctodiamesa gen.nov. ─ a new genus of Diamesinae (Diptera, Chironomidae)', 'Proceedings of the 10th Syposium of the Biological Problems of the North. Part 2. Magadan, Russia', NULL, NULL, NULL, '264', NULL, NULL, 'in Russian', '', 'no entry type given'),
(352, 'Makarchenko 2005', '', 'Mak2005', 'Makarchenko, E. A.', 2005, NULL, NULL, NULL, NULL, NULL, 'A new species of Arctodiamesa Makarchenko (Diptera: Chironomidae: Diamesinae) from the Russian Far East, with key to known species of the genus', 'Zootaxa', NULL, '1084', NULL, '59-64', NULL, 'The male, pupa, and larva of a new species, Arctodiamesa marinae, from the Russian Far East are\r\n  described and figured. Keys to males, pupae, and fourth-instar larvae of known species of the genus\r\n  are presented.', NULL, '', 'no entry type given'),
(353, 'Cranston 1979', '', 'Cra1979', 'Cranston, P. S.', 1979, NULL, NULL, NULL, NULL, NULL, 'The development stages of Limnophyes globifer (Lundström) (Diptera: Chironomidae)', 'Hydrobiologia', NULL, '67', '1', '19-25', NULL, 'The larva, pupa and adult female of Limnophyes globifer (Lundström) are described for the first time, and the adult male is redescribed from material from a greater geographic range than hitherto. A lectotype is designated for L. globifer and it is suggested that Limnophytes folliculatus Saether is a junior synonym of L. globifer.', NULL, 'Limnophyes globifer (L-P-A),\r\ntaxonomic literature', 'article'),
(354, 'Lundström 1915', '', 'Lun1915', 'Lundström, C.', 1915, NULL, NULL, NULL, NULL, NULL, 'Diptera Nematocera aus den arctischen Gegenden Sibiriens', 'Zap. Imp. Akad. Nauk.', NULL, '29', NULL, '1 - 33', NULL, NULL, NULL, '', 'no entry type given'),
(355, 'Zetterstedt 1838', '', 'Zet1938', 'Zetterstedt, J. W.', 1838, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not checked for Corynocera  ambigua', 'Corynocera  ambigua, original description', 'article'),
(356, 'Yan et al. 2005', 'b', 'Yan2005a', 'Yan, C., Tang, H. and Wang, X.', 2005, NULL, NULL, NULL, NULL, NULL, 'Demicryptochironomus Lenz from China (Diptera: Chironomidae)', 'Zootaxa', NULL, '910', NULL, '1-31', NULL, 'The genus Demicryptochironomus Lenz 1941 from China is revised. The males of six new species are described: D. (Demicryptochironomus) antennarius sp. n., D. (D.) minus sp. n., D. (D.) pannus sp. n., D. (D.) yui sp. n., D. (Irmakia) concavus sp. n., D. (I.) constrictus sp. n. Demicryptochironomus (I.) neglectus Reiss 1988 is new to China. Demicryptochironomus (D.) vulneratus (Zetterstedt 1838) and D. (I.) spatulatus Wang \\& Zheng 1994 are redescribed. The larva of D. (D.) vulneratus is described from China for the first time, and an unplaced larva is described. Keys to males and known larvae of the genus are presented. An emended generic diagnosis is given and the systematics discussed.', NULL, NULL, 'article'),
(357, 'Yan et al. 2005', 'a', 'Yan2005b', 'Yan, C., Tang, H. and Wang, X.', 2005, NULL, NULL, NULL, NULL, NULL, 'A review of the genus Cryptotendipes Lenz (Diptera: Chironomidae) from China', 'Zootaxa', NULL, '1086', NULL, '1-24', NULL, 'The genus Cryptotendipes Lenz from China is reviewed. Two new species, C. nodus and C. parallelus, are described and illustrated from males. Cryptotendipes lenzi Zorina is a new record for China. The male of C. casuarius ( Townes) from China is redescribed. Unassociated larvae of four unnamed species also are presented. Cryptotendipes sibaabeus Sasa, Sumita & Suzuki is transferred to the genus Cladopelma as a new combination. The generic diagnosis for males and larvae is emended. Keys to known males and larvae in the world are given.', NULL, '', 'no entry type given'),
(358, 'Makarchenko 1985', '', 'Mak1985', 'Makarchenko', 1985, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(359, 'Johannsen 1921', '', 'Joh1921', 'Johannsen', 1921, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(360, 'Samietz 1999', '', 'Sam1999', 'Samietz, R.', 1999, NULL, NULL, 'Schumann, H., Bährmann, R. and Stark, A.', NULL, NULL, 'Chironomidae. In: Entomofauna Germanica 2 Checkliste der Dipteren Deutschlands', 'Studia Dipterologica Supplement', NULL, '2', NULL, '354', NULL, NULL, NULL, '', 'no entry type given'),
(361, 'Goetghebuer 1936', '', 'Goe1936', 'Goetghebuer, M. E. M.', 1936, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(362, 'Pankratova 1968', '', 'Pan1968', 'Pankratova', 1968, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(363, 'Goetghebuer 1934', '', 'Goe1934', 'Goetghebuer, M. E. M.', 1934, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(364, 'Chernovskyj 1949', '', 'Che1949', 'Chernovskyj, A. A.', 1949, NULL, NULL, NULL, NULL, NULL, 'Identifikation of larvae of the midge family Tendipedidae', 'Zoological Institute Acad. Sci. USSR, Leningrad, Nauka (Identification books of the USSR fauna)', NULL, '31', NULL, '1-185', NULL, NULL, 'cited from {citeID|321|Makarchenko, E.A and Makarchenko M.A.}, in Russian', NULL, 'article'),
(365, 'Goetghebuer 1939', '', 'Goe1939', 'Goetghebuer, M. E. M.', 1939, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(366, 'Kieffer 1911', '', 'Kie1911', 'Kieffer, J. J.', 1911, NULL, NULL, NULL, NULL, NULL, NULL, 'Bulletin de la Societe Entomologique de France', NULL, NULL, NULL, NULL, NULL, NULL, 'Reference for Chaetocladius from [[http://www.ubio.org/NZ/]]', '', 'no entry type given'),
(367, 'Kieffer 1923', '', 'Kie1923', 'Kieffer, J. J.', 1923, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'multiple references are given by [[http://www.catalogueoflife.org/annual-checklist/2007/show_reference_details.php?record_id=466572]]', '', 'no entry type given'),
(368, 'Kieffer 1926', '', 'Kie1926', 'Kieffer, J. J.', 1926, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(369, 'Goetghebuer 1940', '', 'Goe1940', 'Goetghebuer, M. E. M.', 1940, NULL, NULL, NULL, NULL, NULL, 'Tendipedidae-Orthocladiinae (Chironomidae-Orthocladiinae). 13g', 'Die Fliegen der paläarktischen Region', NULL, '3', '2', '137', NULL, NULL, 'cited from [[http://www.catalogueoflife.org/annual-checklist/show_reference_details.php?record_id=466780]]', '', 'no entry type given'),
(370, 'Goetghebuer 1938', '', 'Goe1938', 'Goetghebuer, M. E. M.', 1938, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(371, 'Meigen 1830', '', 'Mei1830', 'Meigen, J. W.', 1830, NULL, NULL, NULL, NULL, NULL, 'Systematische Beschreibung der bekannten europäischen zweiflügeligen Insekten. Sechster Theil mit zwölf Kupfertafeln. Hamm. (Schulz)', NULL, NULL, '6', NULL, '1-401', NULL, NULL, 'citet from [[http://www.animalbase.uni-goettingen.de/]]', '', 'no entry type given'),
(372, 'Langton and Cranston 1991', '', 'Lan1991', 'Langton, P. H., and Cranston, P. S.', 1991, NULL, NULL, NULL, NULL, NULL, 'Pupae in nomenclature and identiﬁcation: West Palaearctic Orthocladius s. str. (Diptera: Chironomidae) revised', 'Systematic Entomology', 'http://entomology.ucdavis.edu/chiropage/SystEnt16.pdf', '16', NULL, '239 – 252', NULL, NULL, NULL, '', 'no entry type given'),
(373, 'Kieffer in Potthast 1915', '', 'Kie1915', 'Kieffer, J. J.', 1915, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(374, 'Sæther 2003', '', 'Sae2003', 'Sæther, O. A.', 2003, NULL, NULL, NULL, NULL, NULL, 'A review of Orthocladius subgen. Symposiocladius Cranston (Diptera: Chironomidae)', 'Aquatic Insects', NULL, '25', '4', '281-317', NULL, NULL, 'somen figure numbers are wrong', '', 'no entry type given'),
(375, 'Sæther 1969', '', 'Sae1969', 'Sæther, O. A.', 1969, NULL, NULL, NULL, NULL, NULL, 'Some Nearctic Podonominae, Diamesinae and Orthocladiinae (Diptera: Chironomidae)', 'Bulletin of the Fisheries Research Board of Canada', NULL, '170', NULL, '1-154', NULL, 'with OCR: New descriptions and redescriptions including descriptions of the immatures of most of\r\nthe species, new synonyms, new combinations, and new distribution records are given for\r\n4 species of the Podonominae, 5 species of the Diamesinae, and 47 species of the Orthocladiinae.\r\nThe morphological variation of acrostichal, dorsocentral, and squamal bristles, annular organs\r\nof wings, tibial combs and spurs, tarsal spurs, claws, pulvilli, and the hypopygial values and\r\nratios are discussed. One new genus, Psilometriocnemus, is described and the subgenus\r\nParachaetocladius of Chactocladius is raised to generic status. Thirty—three new species are\r\ndescribed: Lasiodiamcsa brusti, Diamesa fonticolo, Diamesa spinacies, Cardiocladius albiplumus,\r\nBrillia retzfinis, Trissocladius hamiltoni, Eukiefferiella paucurzca, Eukiefferiella vitracies,\r\nAdactylocladius rowerzsis, Adactylocladius unicalcar, Orthocladius annectens, Orthocladius\r\nbreviseta, Orthocladius manitobensis, Orthocladius wiensi, Syncricotopusfontinalis, Psectrocladius\r\nsemicirculatus, Rheocricotopus emincllobus, Rheocricotopus kerzorensis, Rheocricotopuspauciseta,\r\nChaetocladius oliveri, Parachaetocladius hirtipectus, Limnophyes hamiltoni, Limnophyes\r\nimmucronatus, Psilometriocnemus triannulatus, Parametriocrzemus eoclivus, Parametriocnemus\r\nvespertirzus, Paraphaenocladius nasthecus, Pseudorthocladius dumicaudus, Gymnometriocnemus\r\nmarionensis, Heleniella curtistila, Heleniella hirta, Parakiejferiella torulata, and Pseudosmittia\r\nsetavena. Five new generic combinations are given: Trissocladius domus (Subl.) [Orthocladius\r\ndomus (Subl.)]; Trissocladius johaunseni (Subl.) [Orthocladius johannseni Subl.]; Adactylocladius\r\nkibunensis (Tok.) [Sparziotoma (Orthocladius) kibunensis (Tok.)]; Parachaetocladius abnobeus\r\n(Wulk.) [Chaetocladius (Parachactocladius) ahnobeus (Wulk.)]; and Epoicocladiusflavens (Mall.)\r\n[Srnittia flaveus (Mall.)]. Three new synonyms are given: Lasiodiamesa tenebrosa (Coq.) [syn.\r\nLasiodiamesa nearctica Brund.]; Parametriocuemus lundbecki [syn. Parametriocnemus innocuus\r\n(Curr.)]; and Epoicocladius flavens (Mall.) [syn. Epoicocladius ephemerae (Kiefl`.)]. Five genera\r\nare emended: Cardiocladius, Trissocladius, Rheocricotopus, Heleniella, and Parakieyferiella.\r\nThe zoogeography and relationships of Nearctic and Palearctic genera and species of the\r\nPodonominae, Diamesinae, and Orthocladiinae are discussed.\r\n', NULL, '', 'no entry type given'),
(376, 'Goetghebuer 1937', 'a', 'Goe1937a', 'Goetghebuer, M. E. M.', 1937, NULL, NULL, NULL, NULL, NULL, 'Quatre chironomides nouveaux d''Allemagne', 'Archiv für Hydrobiologie', 'http://www.ingentaconnect.com/content/schweiz/afh', '31', NULL, '508-510', NULL, NULL, 'cited from {citeID|374|Sæther 2003}', '', 'no entry type given'),
(377, 'Dettinger-Klemm 2001', '', 'Det2001', 'Dettinger-Klemm, P. M. A.', 2001, NULL, NULL, NULL, NULL, NULL, 'The Metamorphosis of Orthocladius (Symposiocladius) holsatus Goetghebuer, 1937, with the Description of Orthocladius (Symposiocladius) lunzensis sp. n. (Diptera: Chironomidae)', 'Aquatic Insects', NULL, '23', '1', '45–62', NULL, 'While the holotype male of Orthocladius holsatus Goetghebuer, 1937 must be assumed lost and the original description does not allow deﬁnitive identiﬁcation, a pupal exuviae at the Zoologische Staatssammlung München is newly shown to constitute part of the holotype. On that basis the species was redescribed (larva, pupa, female, male) and redeﬁned based on material reared from an egg mass collected on Lake Borken (Hesse, Germany). The investigation of the ‘holsatus-material’ from the Thienemann collection located at the Zoologische Staatssammlung München led to the conclusion that the material from Lunzer Mittersee (Lower Austria) belongs to a new species, here described as Orthocladius lunzenis sp. n.', NULL, '', 'no entry type given'),
(378, 'Thienemann 1942', '', 'Thi1942', 'Thienemann, A.', 1942, NULL, NULL, NULL, NULL, NULL, 'Paratrichocladius holsatus Goetgh. usw., eine eigentümliche Mosaikart der Orthocladiinen. (Chironomiden aus dem Lunzer Seengebiet VI)', 'Zool Anz', NULL, '139', '11/12', '201-208', NULL, NULL, 'cited fro Dettinger-Klemm 2001', '', 'no entry type given'),
(379, 'Roback and Coﬀman 1987', '', 'Rob1987', 'Roback, S. S., Coffman, W. P.', 1987, NULL, NULL, NULL, NULL, NULL, 'Results of the Nepal Alpine Zone Research Project, Chironomidae (Diptera)', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281987%29139%3A1%3C87%3AROTNAZ%3E2.0.CO%3B2-8', '139', '1', '87-158', NULL, 'The 97 species of Chironomidae collected from 69 stations in the Nepal Himalaya were primarily a Holarctic assemblage. The Orthocladiinae (50 species) was the dominant subfamily followed by the Chironominae (28 species). Within the Chironominae, the Tanytarsini (23 species) predominated. The genus Micropsectra dominated the Tanytarsini fauna. The Tanypodinae (10 species), Diamesinae (9 species) and the Chironomini (5 species) were more sparsely represented. No Podonominae were collected. The genus Neopodonomus Chaudhuri and Ghosh (1981), described from the central Himalaya is believed to belong to the Diamesinae genus Boreoheptagyia Brundin. Comparison is made with the Chironomidae collected on the Catherwood Bolivian-Peruvian Altiplano Expedition and the Northern European material reported by Thienemann (1941).\r\n', NULL, 'Arctopelopia? sp., Boreoheptagyia sp., Brillia flavifrons gr. sp, Brillia modesta gr. sp., Brillia sp., Chaetocladius dentiforceps gr. sp., Chaetocladius vitellinus gr. sp., Chironomidae, Chironomus sp., Conchapelopia sp., Constempellina sp., Corynoneura cf. lobata, Cricotopus bicinctus gr. cf. vierriensis, Cricotopus tremulus gr. cf. curtus, Diamesa cf. aberrata, Diamesa sp. 1, Diamesa sp. 2, Diamesa sp. 3, ecology larvae, Eukiefferiella brehmi gr. sp., Eukiefferiella claripennis gr. sp., Eukiefferiella devonica gr. sp., Eukiefferiella gracei gr. cf. gracei, Eukiefferiella rectangularis gr. sp., Eukiefferiella sp., Heleniella sp., Krenosmittia sp., larval gut content, Limnophyes sp., Macropelopia (Apsectrotanypus) sp., Metriocnemus hygropetricus gr. sp., Micropsectra sp. 1, Micropsectra sp. 2, Micropsectra sp. 3, Micropsectra sp. 4, Micropsectra sp. 4A, Micropsectra sp. 5, Micropsectra sp. 6, Micropsectra sp. 7, Micropsectra sp. 8, Micropsectra sp. 8A, Micropsectra sp. 9, Micropsectra sp. 10, Micropsectra sp. 11, Microtendipes sp., Nanocladius (Plecopteracoluthus) sp., Nanocladius  parvulus gr. sp., Nepal Alpine Zone, Nilotanypus sp. 1, Nilotanypus sp. 2, Orthocladiinae sp. 1, Orthocladius (Eudactylocladius) sp., Orthocladius (Euorthocladius) poss. rivulo rum gr. sp., Orthocladius (Euorthocladius) sp. 1, Orthocladius (Euorthocladius) sp. 2, Orthocladius cf. frigidus, Orthocladius cf. saxicola, Pagastia sp. 1, Pagastia sp. 2, Paracricotopus sp., Paramerina sp., Parametriocnemus sp. 1, Parametriocnemus sp. 2, Parametriocnemus sp. 3, Parametriocnemus sp. 4, Parametriocnemus sp. A, Parametriocnemus sp. B, Paraphaenocladiuscf. pseudirritus, Paratrichocladius sp., Parorthocladius sp., Polypedilum sp. 1, Polypedilum sp. 2, Polypedilum sp. 3, Procladius sp., Psectrocladius (P.) sordidellus gr. sp., Pseudodiamesa nepalensis, Pseudodiamesa sp. 1, Pseudosmittia sp., Rheocricotopus (Psilocricotopus) sp. 2, Rheocricotopus (Psilocricotpus) sp. 1, Rheocricotopus (Rheocricotopus) sp., Rheotanytarsus sp. 1, Rheotanytarsus sp. 2, Rheotanytarsus sp. 3, Smittia sp., Stempellinella sp., Symposiocladius cf. lignicola, Synorthocladius cf. semivirens, Tanypodinae, Tanytarsus sp.  , Thienemanniella acuticornis, Thienemanniella cf. clavicronis, Thienemanniella sp. 1, Thienemannimyia sp., Trissopelopia sp., Tvetenia bavarica gr. sp., Tvetenia discoloripes gr. sp., Zavrelimyia sp. (near Zavrelimyia)', 'article'),
(380, 'Cranston 2000', 'a', 'Cra2000a', 'Cranston, P. S.', 2000, 'pscranston@ucdavis.edu', NULL, NULL, NULL, NULL, 'Electronic Guide to The Chironomidae of Australia - Version 1.1', NULL, 'http://www.science.uts.edu.au/sasb/chiropage/', NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(381, 'Kieffer 1912', '', 'Kie1912', 'Kieffer, J. J.', 1912, NULL, NULL, NULL, NULL, NULL, 'Tendipedidae (Chironomidae) [Dipt]', 'Formaosa Ausbeute. Supplta. ent.', NULL, '1', NULL, NULL, NULL, NULL, 'cited from {citeID|289|Epler 1988}', '', 'no entry type given'),
(382, 'Becker 1908', '', 'Bec1908', 'Becker, T.', 1908, NULL, NULL, NULL, NULL, NULL, 'Dipteren der Kanarischen Inseln', 'Mitteilungen aus dem Zoologischen Museum in Berlin', NULL, '4', NULL, '1-180', NULL, NULL, 'cited from {citeID|289|Epler 1988}', 'Diptera, Canary Islands', 'no entry type given'),
(383, 'Coquillett 1902', '', 'Coq1902', 'Coquillett, D. W.', 1902, NULL, NULL, NULL, NULL, NULL, 'Three new species of nematocerous Diptera', 'Entomological News', NULL, '13', NULL, '84-85', NULL, NULL, NULL, '', 'no entry type given'),
(384, 'Roback 1978', '', 'Rob1978', 'Roback, S. S.', 1978, NULL, NULL, NULL, NULL, NULL, 'The Immature Chironomids of the Eastern United States III. Tanypodinae-  Anatopyniini, Macropelopiini and Natarsiini', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281977%29129%3C151%3ATICOTE%3E2.0.CO%3B2-L', '129', '11', '151 – 202', NULL, 'Morphology, diagnoses and keys are given for the genera, subgenera and species of the known immature stages of the North American members of the tribes Macropelopiini and Natarsiini. A diagnosis of the European tribe Anatopyniini is included for comparative purposes. A new genus, Brundinia, is described in the Macropelopiini. Water quality parameters and other ecological data are given for some species. The species included in this paper are Macropelopia (Macropelopia) decedens, Macropelopia (Macropelopia) species A, Macropelopia (Alotanypus) venusta, Macropelopia (Alotanypus) possibly aris; Macropelopia (Alotanypus) species A, Macropelopia (Apsectrotanypus) johnsoni, Macropelopia (Apsectrotanypus) near johnsoni, Brundinia eumorpha, Brundinia? species, Psectrotanypus (Psectrotanypus) dyari, Psectrotanypus (Psectrotanypus) near dyari, Psectrotanypus (Psectrotanypus) discolor, Psectrotanypus (Derotanypus) alaskensis, Psectrotanypus (Derotanypus) possibly aclines, Psectrotanypus (Derotanypus) near aclines, Natarsia baltimoreus, and Natarsia species A.', NULL, '', 'no entry type given'),
(385, 'Roback 1977', '', 'Rob1977', 'Roback, S. S.', 1977, NULL, NULL, NULL, NULL, NULL, 'The Immature Chironomids of the Eastern United States II. Tanypodinae: Tanypodini', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281976%29128%3C55%3ATICOTE%3E2.0.CO%3B2-T', '128', '5', NULL, NULL, 'The immature stages of the eastern species of the genus Tanypus are described and all the North American species available are keyed. The morphology of the genus, especially the mentum, is discussed and some ecological and biological data are given. Evolution within Tanypus is discussed.', NULL, '', 'no entry type given'),
(386, 'Linné 1767', '', 'Lin1767', 'Linné, C.', 1767, NULL, NULL, NULL, NULL, NULL, 'Systema naturæ, Tom. I. Pars II.', 'Editio duodecima reformata. Holmiæ. (Laur. Salvii)', '1?', '2?', NULL, '533-1327', NULL, NULL, 'cited from [[http://www.animalbase.uni-goettingen.de/]]', '', 'no entry type given'),
(387, 'Roback 1980', '', 'Rob1980', 'Roback, S. S.', 1980, NULL, NULL, NULL, NULL, NULL, 'The Immature Chironomids of the Eastern United States IV. Tanypodinae-Procladiini', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281980%29132%3C1%3ATICOTE%3E2.0.CO%3B2-8', '132', NULL, '1-63', NULL, 'Morphology, keys and descriptions are given for the North American species of the genus Procladius. Some new terminology for parts of the adult genitalia are proposed. Two South American Djalmabatista larvae are keyed and briefly described for comparative purposes. Numerical taxonomic analyses of the subgenus Psilotanypus, subgenus Procladius (P. freemani and P. sublettei groups), and the tribe Procladiini are presented. New species groups are proposed for P. vesus Roback and P. prolongatus Roback and a new species P. (Pr.) johnsoni is described. Water quality parameters and other ecological data are given for some species. The larva and/or pupa of the following species are described: P. (Ps.) bellus; P. (Pr.) freemani; P. (Pr.) sublettei; P. (Pr.) denticulatus; P. (Pr.) wihlmi; P. (Pr.) culiciformis; P. (Pr.) vesus; P. (Pr.) dentus (pupa); P. (Pr.) abetus; P. (Pr.) ruris; P. (Pr.) poss. ruris var. grandis; P. (Pr.) prolongatus; P. (Pr.) poss. prolongatus (larva); P. (Pr.) paragretis?; and several unknown forms.', NULL, '', 'no entry type given'),
(388, 'Johannsen 1932', '', 'Joh1932', 'Johannsen, O. A.', 1932, NULL, NULL, NULL, NULL, NULL, 'Chironominae of the Malayan Subregion of the Dutch East Indies', 'Archiv fur Hydrobiologie, Supplement', NULL, '11', NULL, '503-552', NULL, NULL, 'cited from {citeID|306|Cranston 2007}', '', 'no entry type given'),
(389, 'Cranston 2004', '', 'Cra2004', 'Cranston, P. S.', 2004, NULL, NULL, 'C.M. Yule and H.S. Yong', NULL, NULL, 'Chironomidae, in "The Freshwater Invertebrates of Malaysia and Singapore"', 'Academy of Sciences, Malaysia', NULL, NULL, NULL, '1-44', NULL, NULL, NULL, '', 'no entry type given'),
(390, 'Klink et al. 2002', '', 'Kli2002', 'Klink, A. G., Moller-Pillot, H. K. M. and Vallenduuk, H. J.', 2002, NULL, NULL, NULL, NULL, NULL, 'Determinatiesleutel voor de larven van de in Nederland voorkomende soorten Polypedilum', 'Utrecht : STOWA, ISBN: 9057731606', 'http://library.wur.nl/ebooks/STOWArapporten/1660460.pdf', NULL, '06', '18', NULL, NULL, NULL, NULL, 'no entry type given'),
(391, 'Schrank 1803', '', 'Sch1803', 'Schrank, F. von Paula', 1803, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(392, 'Roback 1975', 'a', 'Rob1975', 'Roback, S. S.', 1975, NULL, NULL, NULL, NULL, NULL, 'A New Subgenus and Species of the Genus Tanytarsus (Chironomidae: Chironominae: Tanytarsini)', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281975%29127%3C71%3AANSASO%3E2.0.CO%3B2-Y', '127', NULL, '71-80', NULL, 'A new subgenus and a new species of the genus Tanytarsus are described. The pupa and larvae are described and some ecological and biological data are given.', NULL, '', 'no entry type given'),
(393, 'Moller-Pillot 1990', '', 'Mol1990', 'Moller-Pillot, H. K. M.', 1990, NULL, NULL, NULL, NULL, NULL, 'Key to larvae of Paratanytarsus, encountered in the Netherlands by A.Klink (1983), revised by H.Moller-Pillot (1990)', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'a paper sheet in {citeID|14|Klink 1983}', 'determination key, Paratanytarsus austriacus, Paratanytarsus confusus, Paratanytarsus dissimilis aggregate, Paratanytarsus grimmii, Paratanytarsus inopertus, Paratanytarsus intricatus, Paratanytarsus lauterborni, Paratanytarsus tenellulus, Paratanytarsus tenuis aggregate', 'misc'),
(394, 'Qi and  Wang 2006', '', 'QiX2006', 'Qi, X. and  Wang, X.', 2006, 'xhwang@nankai.edu.cn', 'College of Life Science, Nankai University, Tianjin 300071, China. Correspondence Xinhua Wang', NULL, NULL, NULL, 'A review of Microtendipes Kieffer from China  (Diptera: Chironomidae)', 'Zootaxa', NULL, '1108', NULL, '37 – 51', NULL, 'Five new species of Microtendipes Kieffer from China are described and illustrated as males: M.\r\nangustus, M. quasicaducus, M. tuberosus, M. yaanensis, and M. zhamensis. In addition, M. britteni\r\n(Edwards), M. confines (Meigen), M. pedellus (De Geer), and M. truncatus Kawai and Sasa are\r\nrecorded from China; the record of M. confines (Meigen) is the first for China. A key to the males\r\nof Microtendipes in China is given.', NULL, '', 'no entry type given'),
(397, 'Sæther and Schnell 1988', '', 'Sae1988', 'Sæther, O. A. and Schnell, Ø. A.', 1988, NULL, NULL, NULL, NULL, NULL, 'Two new species of the Rheocricotopus (R.) effusus group (Diptera, Chironomidae)', 'Spixiana Supplement', NULL, '14', NULL, '65-74', NULL, NULL, 'cited from [[http://insects.ummz.lsa.umich.edu/~ethanbr/chiro/Books-Bibs/saethref.html]]', '', 'no entry type given'),
(398, 'Wang and Zheng 1991', '', 'Wan1991', 'Wang, X. and Zheng, L.', 1991, NULL, NULL, NULL, NULL, NULL, 'Note on genus Rheocricotopus from China (Diptera: Chironomidae)', 'Acta zootax. sin.', NULL, '15', NULL, '99-105', NULL, NULL, 'cited from {citeID|279|Wang 2000} (Checklist)', '', 'no entry type given'),
(399, 'Wang 1998', '', 'Wan1998', 'Wang, X.', 1998, NULL, NULL, NULL, NULL, NULL, 'Description of a new species of Stilocladius from China (Diptera, Chironomidae)', 'Studia Dipterologica', NULL, '5', NULL, '81-83', NULL, NULL, 'cited from {citeID|279|Wang 2000} (Checklist)', '', 'no entry type given'),
(400, 'Sæther and Wang 1993', '', 'Sae1993', 'Sæther, O. A. and Wang, X.', 1993, NULL, NULL, NULL, NULL, NULL, 'Xiaomyia, Shangomyia and Zhouomyia, three new and unusual genera of Chironomini from Oriental China (Diptera: Chironomidae)', 'Entomologica Scandinavica', 'http://www.zmuc.dk/EntoWeb/InSysEvol/', '24', NULL, '185-195', NULL, 'Xiaomyia aequipedes gen. and sp. n. from Guandong in Oriental China, Shangomyia impectinata gen. and sp. n. from Hainan in Oriental China and Burma, and Zhouomyia plauta gen. and sp. n. from Hainan are described as male imagines. Xiaomyia plus Shangomyia in most features appear to form a separate tribe within the subfamily Chironominae, while a few characters indicate a placement in the Harnischia group of genera. They are preliminary placed at the base of the Chironomini. They are unique in having apical scales with 1-2 spines on all tibiae, but no combs; no dorsomedian eye extension; extended costa; leg ratios of all legs higher than 1.5; and inferior volsella fused to the gonocoxite. Zhouomyia is a typical plesiomorphic Chironomini either related to Apedilum Townes, Paralauterborniella Lenz, Lauterborniella Thienemann and Bause, and Pagastiella Brundin, or to the Endochironomws group of genera.', NULL, '', 'no entry type given'),
(401, 'Cranston 2003', '', 'Cra2003', 'Cranston, P. S.', 2003, NULL, NULL, NULL, NULL, NULL, 'The oriental genus Shangomyia Sæther & Wang (Chironomidae: Diptera): immature stages, biology, putative relationships and the evolution of wood mining in chironomid larvae', 'The Raffles Bulletin of Zoology', 'http://rmbr.nus.edu.sg/rbz/biblio/51/51rbz179-186.pdf', ' 51', '2', '179-186', NULL, 'The enigmatic chironomid (Diptera: Chironomidae) genus Shangomyia Sæther & Wang,\r\npreviously known from the adult alone, is associated newly with its pupa and larva. The distribution of the\r\npupal exuviae, previously unassociated but described as ‘Taxon 1’ by Coffman and colleagues, provides\r\nevidence for a rather widespread distribution of a single species, Shangomyia impectinata Sæther & Wang,\r\nthroughout oriental Asia. The larva, which mines in allochthonous aquatic immersed wood, has a\r\nventromental plate with spines and creases, as seen elsewhere in Stenochironomus Kieffer and Harrisius\r\nFreeman (subfamily Chironominae). Support for a relationship to these genera comes from phylogenetic\r\nanalyses of morphological data from all life history stages. Thus this taxon, whose classification has been\r\nunder debate for the adult and especially the pupa, evidently lies in the tribe Chironomini of the subfamily\r\nChironominae, in a clade with mining larvae. Morphological modifications of the wood-mining\r\nChironomidae are reviewed briefly in the light of this finding. Two alternative hypotheses for the origin of\r\nwood mining habit early in the cladogenesis of Chironomidae are examined.\r\n', NULL, '', 'no entry type given'),
(402, 'Macquart 1834', '', 'Mac1834', 'Macquart, J.', 1834, NULL, NULL, NULL, NULL, NULL, 'Histoire naturelle des insectes: Diptères', 'Roret', NULL, NULL, NULL, NULL, NULL, NULL, 'cited from [[http://scholar.google.de/]]', '', 'no entry type given'),
(403, 'Holmgren 1883', '', 'Hol1883', 'Holmgren, A. E.', 1883, NULL, NULL, NULL, NULL, NULL, 'Diptera. Pp. 162-190. In Holmgren, A. E., and Aurivillius, C., Insecta a viris doctissimis Nordenskiold illun ducem sequentibus in insulis Waigatsch et Novaja Semlia anno 1875 collecta', 'Entomologisk Tidskrift', NULL, '4', NULL, '139-194', NULL, NULL, 'cited from [[http://www.catalogueoflife.org/annual-checklist/show_reference_details.php?record_id=467331]], not checked for Tanytarsus gracilentus', 'Tanytarsus gracilentus', 'no entry type given'),
(404, 'Paasivirta 1972', '', 'Paa1972', 'Paasivirta, L.', 1972, NULL, NULL, NULL, NULL, NULL, 'Taxonomy, ecology and swarming behaviour of Tanytarsus gracilentus Holmgr.(Diptera, Chironomidae) in Valassaaret, Gulf of Bothnia, Finland', 'Annales Zoologici Fennici', NULL, '9', NULL, '255-264', NULL, 'The holarctic-circumpolar Chironomid species Tanytarsus gracilentus Holmgr.\r\nswarms abundantly in May — June and in August in Valassaaret, a group of islands in the Gulf of Bothnia. A description of the adult, exuviae and larva is given. The wing length, the number of dl and sc bristles and anal point spinules, and the antennal ratio\r\nwere found to decrease and the leg ratios to increase with increasing temperature of the larval and pupal environment. The effects of environmental factors upon the\r\nmorphological characters are discussed.\r\nIn the population of the study area the variation of the characters measured was\r\nfound to be as wide as in other populations studied. ln order to separate variation caused by genetic and environmental factors it is thus necessary to study the temporal\r\nand spatial variation in each population. In the study area the larvae of T. gracilentus occur only in the gently sloping oozebeds of bays and ponds and most abundantly in beds frozen in winter.\r\nThe seasonal and diel emergence, sex ratio and accompanying Chironomid species were studied with the aid of emergence traps. The swarming, mating and egg-laying flight are described.\r\nIt is suggested that T. gracilentus is a pioneer species in the arctic regions. It can tolerate interspecific competition in southern areas in waters which are wholly frozen in winter and have a tendency to high conductivity.', NULL, 'Tanytarsus gracilentus, description adult, description exuviae, description larva, swarming behaviour, autecology', 'article');
INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(405, 'Sæther 1989', '', 'Sae1989', 'Sæther, O. A.', 1989, NULL, NULL, NULL, NULL, NULL, 'Metriocnemus van der Wulp: a new species and revision of species described by Meigen, Zetterstedt, Stæger, Lundström and Strenzke (Diptera, Chironomidae)', 'Entomologica Scandinavica', NULL, '19', NULL, '393-430', NULL, 'The congenerity of Dolichopelma Lundstrom, 1915 and Chasmatocladius Kieffer, 1911 with Metriocneumus v.d. Wulp, 1874 is confirmed. Types from the Meigen Collection in Paris, the Holmgren Collection in Stockholm, the Zetterstedt Collection in Lund, the Staeger Collection in Copenhagen, and the Thienemann Collection in Munich have been examined. M. albolineatus (Meigen, 1818) is a senior synonym of M. atratulus (Zetterstedt,1850) and probably of M. 4hirticollis (Staeger, 1839); M. obscuripes (Holmgren, 1869) a senior synonym of M. eurynotus (Holmgren, 1883), M. transgressus (Holmgren, 1883), M. ripicola (Holmgren, 1883), and M. hygropetricus Kieffer, 1912, M. brevinervis (Holmgren, 1869) is a senior synonym of Paraphaenocladius despectus (Kieffer, 1926). M. atratulus subsp. corticalis Strenzke, 1950a is raised to the species level. M. atriclava sensu Edwards 1929 is probably not identical to M. atriclava Kieffer, 1921. A diagnosis for the genus is given. M. brusti sp.n. is described as male imago, female and pupa, and a possible variety of M. obscuripes as female imago, pupa and larva. M. obscuripes and M. ursinus (Holmgren, 1869) are described in all stages and both sexes; M. albolineatus and M. fuscipes (Meigen, 1818) as male imago, pupa and larva; M. hirticollis as female imago; M. corticalis as male imago and pupa; and M. longipennis (Holmgren, 1883) and M. atriclava sensu Edwards as male imago. The importance of including extensive morphometric descriptions when doing revisionary studies is shown.', NULL, '', 'no entry type given'),
(406, 'Sæther 2005', '', 'Sae2005', 'Sæther, O. A.', 2005, NULL, NULL, NULL, NULL, NULL, 'A new subgenus and new species of Orthocladius van der Wulp,  with a phylogenetic evaluation of the validity of the subgenera of  the genus (Diptera: Chironomidae)', 'Zootaxa', NULL, '974', NULL, '1-56', NULL, 'A new subgenus, Mesorthocladius, of the genus Orthocladius v. d. Wulp is erected and diagnoses\r\nare provided for all stages and both sexes. Orthocladius (Mesorthocladius) lamellatus sp. n. and O.\r\n(Mesorthocladius) nimidens sp. n. are described in both sexes and all stages. Orthocladius (Euorthocladius) annellae sp. n. is described in both sexes and the pupa. The females of O. (Euorthocladius) rivicola Kieffer, O. (Eurthocladius) ashei Soponis, and O. (Orthocladius) dentifer Brundin are described for the first time. The larva of O. (Orthocladius) nitidoscutellatus Lundström (syn.\r\nOrthocladius trigonolabis Edwards) is described for the first time. A parsimony analysis of all species of Orthocladius with known pupae and male imagines is performed. The subgenera Eudactylocladius Thienemann and Euorthocladius Thienemann are always monophyletic, while\r\nSymposiocladius Cranston is paraphyletic before successive reweighting, but monophyletic after;\r\nMesorthocladius is monophyletic before reweighting, but paraphyletic after; and Orthocladius s.\r\nstr. is polyphyletic before reweighting and monophyletic after. Keys to subgenera for both sexes\r\nand all stages are given.', NULL, '', 'no entry type given'),
(407, 'Caldwell 1998', '', 'Cal1998', 'Caldwell B. A.', 1998, NULL, '1035 Lewis Ridge Circle, Lawrenceville, GA, 30045, USA', NULL, NULL, NULL, 'Description of the adult male and larva of Orthocladius (Orthocladius) vaillanti (Diptera: Chironomidae)', 'Journal of the Kansas Entomological Society', NULL, '71', '3', '234-240', NULL, 'The adult male and larva of Orthocladius vaillanti Langton and Cranston are described based upon specimens from Georgia and North Carolina, USA, including a reared male. Diagnoses are presented for the adult male, pupa, and larva to allow separation from congeneric species; O. vaillanti is quite similar to O. frigidus (Zetterstedt) in the adult male and larval stages. The description of the pupa is emended, including further details of the structure of the pupal thoracic horn. Placement of O. vaillanti in previous identification keys is discussed, and information is provided on larval habitat and distribution.', NULL, 'Orthocladius vaillanti', 'no entry type given'),
(408, 'Hirvenoja and Hirvenoja 1988', '', 'Hir1988', 'Hirvenoja, M. and Hirvenoja, E.', 1988, NULL, NULL, NULL, NULL, NULL, 'Corynoneura brundini spec. nov. Ein Beitrag zur Systematik der Gattung Corynoneura (Diptera, Chironomidae)', 'Spixiana Supplement', NULL, '14', NULL, '213-238', NULL, NULL, 'German', '', 'no entry type given'),
(409, 'Potthast 1914', '', 'Pot1914', 'Potthast, A.', 1914, NULL, NULL, NULL, NULL, NULL, 'Über die Metamorphose der Orthocladius-Gruppe. Ein Beitrag zur Kenntnis der Chironomiden', 'Archiv für Hydrobiologie, Supplement', NULL, '2', NULL, '243-376', NULL, NULL, NULL, '', 'no entry type given'),
(410, 'Bode 1983', '', 'Bod1983', 'Bode, R. W.', 1983, NULL, NULL, NULL, NULL, NULL, 'Larvae of North American Eukiefferiella and Tvetenia (Diptera: Chironomidae)', 'University of the State of New York, State Education Dept. Bulletin', NULL, NULL, '452', NULL, NULL, 'The larvae of North American Eukiefferiella and Tvetenia (Diptera: Chironomidae) are classified into 12 spp. groups (i.e., groups of similar species) [T. discoloripes, T. bavarica, E. devonica, E. similis, E. brehmi, E. gracei, E. cyanea, E. pseudomontana, E. brevicalar, e. claripennis, E. rectangularis and E. coerulescens.] Larvae of these 2 closely related genera commonly are found in running waters and often are reported in biological water-quality surveys. Although there are an estimated 40 North American species in these genera, the fauna is poorly known, with only 3 spp. formally described to date. The 12 spp. groups described in the present study are believed to include almost all North American species in these genera. The species groups are based on Palearctic species and species groups. Most species were reared or associated with pupae and/or adults and were correlated with species described in the European literature. Pupae provided the most satisfactory generic diagnoses and are the most useful stage for separating species and species groups. For each species group, photographs and distinguishing characters are provided to allow positive group identification of the larvae. The most useful larval characters are abdominal setation, size and shape of the mentum and ventromental plates, antennal characters and relative size of the procerci and anal parapods. Taxonomic and ecological discussions are provided for each species group. These include pertinent information from the literature in addition to data gathered in the present study. The larvae exhibited marked ecological differences at the group level; some groups were very tolerant of pollutional stresses. A cladogram based on larval characters is provided to illustrate possible phylogenetic relationships among the species groups. The species group concept is considered to be the best interim measure for identification of the poorly known North American fauna and will provide a framework for future research in these 2 genera.', NULL, 'America, Eukiefferielle, North America, Tvetenia', 'no entry type given'),
(411, 'Kobayashi 1994', '', 'Kob1994', 'Kobayashi, T.', 1994, NULL, NULL, NULL, NULL, NULL, 'Synonymic notes on a genus and a species of the Orthocladiinae (Diptera, Chironomidae) from Japan', 'Japanese Journal of Entomology', 'http://ci.nii.ac.jp/naid/110004022333/en/', '62', '4', '745-746', NULL, NULL, 'Pseudobrillia komorii is a synonym of Neobrillia longistyla', '', 'no entry type given'),
(412, 'Niitsuma 1991', '', 'Nii1991', 'Niitsuma, H.', 1991, NULL, NULL, NULL, NULL, NULL, 'A new genus and species of the primitive Orthocladiinae (Diptera, Chironomidae) from Japan', 'Japanese Journal of Entomology', 'http://ci.nii.ac.jp/naid/110004022019/en/', '59', '4', '707-716', NULL, 'The adults, male and female, immature forms, pupa and larva, of a new genus and species found in Japan of a primitive group of the subfamily Orthocladiinae, Pseudobrillia komorii, are herein described and illustrated. The new genus is unique in its combination of the presence of simple and long gonostyli in the male hypopygium, strongly divided tergite IX in the female genitalia, 4 pairs of scutal tubercles on the pupal thorax, and lateral fringes of 4 setal tufts on the larval body segments V-X.', NULL, '', 'no entry type given'),
(413, 'Kawai 1991', '', 'Kaw1991', 'Kawai, K.', 1991, NULL, NULL, NULL, NULL, NULL, 'Seven new chironomid species (Diptera, Chironomidae) from Japan', 'Japanese Journal of Limnology', NULL, '52', NULL, '161--171', NULL, NULL, NULL, '', 'no entry type given'),
(414, 'Wang and Sæther 1997', '', 'Wan1997', 'Wang, X. and Sæther, O. A.', 1997, NULL, NULL, NULL, NULL, NULL, 'Qiniella, a new orthoclad genus from China (Diptera: Chironomidae)', 'Hydrobiologia', 'http://www.springerlink.com/content/xk8434742p33n30q/', '362', '1-3', '103-106', NULL, 'Quiniella lii gen. nov., sp. nov. from China is described as male imago. The genus share bare eyes, wing and squama and extended costa with most members of the Parakiefferiella group sensu Sæther (1983), and the absence of a scutal tubercle, hump or microtrichial tuft and strongly developed virga with Krenosmittia Thienemann & Krüger, but is among other distinguished by a unique trifid gonostylus.', NULL, '', 'no entry type given'),
(415, 'Wang and Sæther 2002', 'b', 'Wan2002', 'Wang, X. and Sæther, O. A.', 2002, NULL, NULL, NULL, NULL, NULL, 'Hanocladius, a new orthoclad genus from China (Diptera: Chironomidae)', 'Hydrobiologia', 'http://www.springerlink.com/content/9xp77lg7fvpbubk7/', '468', '1-3', '181-183', 'January', 'Hanocladius longipes gen. nov., sp. nov. from Oriental China is described from the male imago. The long metatarsus, the very broad, scale-like virga and the conspicuously scalpellate acrostichals distinguish the genus from all of the known genera in Orthocladiinae.', NULL, '', 'no entry type given'),
(416, 'Cranston and Dimitriadis 2005', '', 'Cra2005', 'Cranston, P. S. and Dimitriadis, S.', 2005, NULL, NULL, NULL, NULL, NULL, 'Semiocladius Sublette and Wirth: taxonomy and ecology of an estuarine midge (Diptera: Chironomidae: Orthocladiinae)', 'Australian Journal of Entomology', 'http://entomology.ucdavis.edu/chiropage/Semiocladius.pdf', '44', NULL, '252–256', NULL, 'Semiocladius Sublette and Wirth, described from adult midges from south-western Paciﬁc Ocean\r\nshores, has the Australian Camptocladius crassipennis Skuse as its type. Immature stages previously\r\nknown only from Semiocladius kuscheli Sublette and Wirth from sub-Antarctic New Zealand were\r\nassociated tentatively, by co-occurrence. For the ﬁrst time, the immature stages for the Australian\r\nspecies are associated deﬁnitively by rearing. Larvae rear to a pupa identical to a speculatively\r\nassociated exuviae of Semiocladius from Lord Howe Island. Adults conform to the described\r\nS. crassipennis. Larval Semiocladius are distinctive and previous diagnoses are conﬁrmed. In contrast,\r\nthe putatively associated pupa of S. kuscheli is indistinguishable from that of the marine intertidal\r\nThalassosmittia Strenke and Remmert, whereas the newly associated S. crassipennis pupa is distinct.\r\nThe pupa of S. kuscheli may have been misassociated. Semiocladius live in the mesohaline of the\r\nsalinity gradient of the Clyde River estuary, south-east Australia and the genus appears to be a\r\ndistinctive western Paciﬁc saline/mesohaline taxon.', 'only Semiocladius crassipennis {citeID|338|Skuse 1889} as larvae', 'salinity, Semiocladius crassipennis, systematic literature', 'article'),
(418, 'Roback and Tennessen 1978', '', 'Rob1978a', 'Roback, S. S. and Tennessen, K. J.', 1978, NULL, NULL, NULL, NULL, NULL, 'The Immature Stages of Djalmabatista pulcher [= Procladius (Calotanypus) pulcher (Job.)]', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281978%29130%3C11%3ATISODP%3E2.0.CO%3B2-T', '130', NULL, '11-20', NULL, 'The associated larva and pupa of Procladius (Calotanypus) pulcher are described. Procladius (C.) maculatus is synonymized with P. pulcher, which is placed in the genus Djalmabatista Fittkau (1968). Procladius (Calotanypus) Roback (1971) is considered a synonym of Djalmabatista. The genus Djalmabatista is placed in the tribe Procladiini of the Tanypodinae. Some water chemistry parameters and ecological data are given.', NULL, '', 'no entry type given'),
(419, 'Roback 1989', '', 'Rob1989', 'Roback, S. S.', 1989, NULL, NULL, NULL, NULL, NULL, 'The Larval Development of Djalmabatista pulcher (Joh.) (Diptera: Chironomidae: Tanypodinae)', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281989%29141%3C73%3ATLDODP%3E2.0.CO%3B2-7', '141', NULL, '73-84', NULL, 'The changes in structure and size of the head, its appendages, setae and internal structures from larval instar I-IV are discussed and figured. The body and its projections are similarly treated. The greatest changes in morphology (especially the mandible, mentum and maxilla) take place between instars I and II. The most positive allometric growth occurs in antennal segment 1 and the width of the mentum. Comparison is made with instar I (larvula) structure in Holotanypus and Psilotanypus.', NULL, '', 'no entry type given'),
(420, 'Johannsen 1908', '', 'Joh1908', 'Johannsen, O. A.', 1908, NULL, NULL, NULL, NULL, NULL, 'New North American Chironomidae', 'In: E. P. Felt (ed.), 23rd report of the State Entomologist on injurious and other insects of the State New York, 1907. N.Y. St. Mus. Bull', NULL, '124', NULL, '5-541', NULL, NULL, 'cited from Internet', '', 'no entry type given'),
(421, 'Roback 1975', 'b', 'Rob1975a', 'Roback, S. S.', 1975, NULL, NULL, NULL, NULL, NULL, 'The Immature Chironomids of the Eastern United States I. Introduction and Tanypodinae-Coelotanypodini', 'Proceedings of the Academy of Natural Sciences of Philadelphia', 'http://links.jstor.org/sici?sici=0097-3157%281975%29127%3C147%3ATICOTE%3E2.0.CO%3B2-M', '127', NULL, '147-201', NULL, 'The location of the 145 stations (Maine to Florida) collected are given. The stations are briefly described and some chemical and physical parameters are given. The collecting, rearing and mounting techniques are described and the results of the rearings are presented. The subfamilies of the Chironomidae (larvae and pupae) and the tribes of Tanypodinae are keyed and the immature stages of the genus Clinotanypus are described. Some ecological data are given on the immatures and the variation of C. pinguis is analyzed.', 'Clinotanypus pinguis and C.aureus are described', '', 'no entry type given'),
(422, 'Pankratova 1983', '', 'Pan1983', 'Pankratova, V. Y.', 1983, NULL, NULL, NULL, NULL, NULL, 'Larvae and pupae of non-biting midges of the subfamily Chironominae (Diptera, Chironomidae-Tendipedidae) of the USSR fauna.', 'Opredeliteli po faune SSSR', NULL, '134', NULL, '1-295', NULL, NULL, 'in Russian cited from {citeID|298|Moller-Pillot et.al. 1997}', '', 'no entry type given'),
(426, 'Loew 1866', '', 'Loe1866', 'Loew, H.', 1866, NULL, NULL, NULL, NULL, NULL, 'Diptera Americae Septentrionalis indigena Centuria septima', 'Berlin Entomologische Zeitschrift', NULL, '10', NULL, '1-54', NULL, NULL, 'cited from {citeID|387|Roback 1980}', '', 'no entry type given'),
(423, 'Kalugina 1975', '', 'Kal1975', 'Kalugina, N. S.', 1975, NULL, NULL, NULL, NULL, NULL, 'A key to the genus Glyptotendipes (Diptera, Chironomidae) in water bodies of the Moscow district)', 'Zoologicheskii Journal (Зоологически Журнал)', NULL, '54', NULL, '1820-1837', NULL, NULL, 'cited from {citeID|298|Moller-Pillot et.al. 1997}', '', 'no entry type given'),
(424, 'Johannsen 1937', '', 'Joh1937', 'Johannsen, O. A.', 1937, NULL, NULL, NULL, NULL, NULL, 'Aquatic Diptera. Part III. Chironomidae: Subfamilies Tanypodinae, Diamesinae and Orthocladiinae', 'Memoir Cornell Agricultural Experiment Station', NULL, '205', NULL, '3-84', NULL, NULL, NULL, '', 'no entry type given'),
(425, 'Wang and Sæther 2002', 'a', 'Wan2002a', 'Wang, X. and Sæther, O. A.', 2002, NULL, NULL, NULL, NULL, NULL, 'First Oriental Record of the Orthoclad Genus Paralimnophyes Brundin with Emendations to the Diagnosis of the Genus (Diptera: Chironomidae)', 'Aquatic Insects', 'http://search.ebscohost.com/login.aspx?direct=true&db=aph&AN=7735001&site=ehost-live', '24', '4', '325-330', 'December', 'Paralimnophyes jii sp. n. from southern China (Oriental region) is described as male imago. A key to male imagines of the known species of Paralimnophyes Brundin is presented. An emended generic diagnosis is given', NULL, '', 'no entry type given'),
(427, 'Thienemann 1937', '', 'Thi1937', 'Thienemann, A.', 1937, NULL, NULL, NULL, NULL, NULL, 'Arktische Chironomidenlarven und -puppen aus dem Zoologischen Museum, Oslo', 'Norsk Entomologisk Tidsskrift', 'http://www.nhm.uio.no/entomologi/journals/nje/old/V5/NET_05_01_1937.pdf', 'V', '1', '1-7', NULL, '[not abstract but introdution] Herr Konservator L. R. NATVIG übersandte mir auf meine Bitte in freundlicher Weise die im Zoologischen Museum in Oslo vorhandenen arktischen Chironolmidenlarven und -puppen zur Untersuchung. Das Material stammt von HOELS Gronland-Expeditionen 1928, 1929, 1930, 1931, 1932 (Sammler N. KNABEN, P. LBYNING), der Hopen Insel 1924 (Sammler TH. IVERSEN von Jan Mayen (1930). Ein Teil des Materials hat M. GOETGHEBUER bei seiner Bearbeitung der Chironomidenimagines dieser Expedition schon vorgelegen (vergl. GOETGHEBUER 1933 p. 30-31). Obgleich naturgemäß nur ein kleiner Teil der Larven genauer bestlimmt werden konnte, hat die Untersuchung doch einige Ergebnisse gehabt, die eine Veroffentliohung lohnen. Für die Anfertigung der Abbildungen bin ich Herrn Dr. FR. KRÜGER, Plon, zu Dank verpflichtet.', NULL, 'Arctic Region, determination key, Greenland, Psectrocladius barbimanus, Psectrocladius uentricosus, Trichotanypus posticalis Lundbeck', 'article'),
(428, 'Armitage et al. 1995', '', 'Arm1995', 'Armitage, P. D., Cranston, P. S. and Pinder,  L. C. V.', 1995, NULL, NULL, NULL, NULL, NULL, 'The Chironomidae: Biology and Ecology of Non-Biting Midges', 'Springer', 'http://books.google.com/books?id=bQyvnx4x6toC', NULL, NULL, NULL, NULL, 'The dipteran family Chironomidae is the most widely distributed and frequently the most abundant group of insects in freshwater with representatives in both terrestrial and marine environments. This book provides a state-of-the-art account of the family including both pure and applied aspects of research.', 'ISBN 041245260X', 'biology, ecology, downloads', 'no entry type given'),
(0, 'No reference given', '', '', 'No reference given', 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'no entry type given'),
(430, 'Schmidl et al. 2008', '', 'Sch2008', 'Schmidl, J., Sulzer, P. and Kitching, R. L.', 2008, NULL, NULL, NULL, NULL, NULL, 'The insect assemblage in water filled tree-holes in a European temperate deciduous forest: community composition reflects structural, trophic and physicochemical factors', 'Hydrobiologia', NULL, '598', '1', '285-303', 'February', '(1) A study of the metazoan community occurring in water-filled tree-holes in southern Germany has been performed to determine the relationships among the key species of arthropods found within the community and a range of structural, physical and chemical factors, using multivariate techniques. (2) Four animal species were sufficiently common to allow identification of the preferred environments for their larvae. The aedine mosquito, Aedes geniculatus, prefers shallow open tree-holes with relatively little leaf litter even though these may represent less permanent water-bodies. The scirtid beetle, Prionocyhon serricornis, occurs in larger, deeper holes with greater amounts of leaf litter and a more predictable aquatic environment, although open water is not a requisite. Larvae of the orthocladiine chironomid, Metriocnemus cavicola, favours shallow more open tree-holes with higher litter content but with sufficient open water to ensure an adequate oxygen supply. The eristaline syrphid, Myatropa florea, favours shallow, open tree-holes with low litter content. (3) There is no evidence that interspecific interactions affect the distribution or abundance of any of these species. (4) The autecological results are discussed in light of those available for phytotelm dwellers elsewhere. The food-web overall may be interpreted as so simple that it is driven by ‘bottom-up’ environmental factors with no part played by those community-level ‘top-down’ processes that may be adduced for more complex, multi-trophic level webs occurring elsewhere. No “processing chain commensalism” could be found in the arthropod community of the temperate German deciduous tree-hole dwellers.', NULL, '', 'no entry type given'),
(431, 'Schnell et al. 1999', '', 'Sch1999', 'Schnell, Ø. A., Rieradevall, M., Granados, I., Hanssen, O.', 1999, NULL, NULL, NULL, NULL, NULL, 'A chironomid taxa coding system for use in ecological and palaeoecological databases', 'NIVA (Norway), Technical Report ', NULL, NULL, '3710-97', NULL, NULL, NULL, 'ISBN 82-577-3276-1', '', 'no entry type given'),
(432, 'Sasa 1979', '', 'Sas1979', 'Sasa, M.', 1979, NULL, NULL, NULL, NULL, NULL, 'A morphological study of adults and immature stages of 20 Japanese species of the family Chironomidae (Diptera)', 'Research Report from the National Institute for Environmental Studies', NULL, '7', NULL, '148', NULL, NULL, NULL, '', 'no entry type given'),
(433, 'Tokunaga 1939', '', 'Tok1939', 'Tokunaga, M.', 1939, NULL, NULL, NULL, NULL, NULL, 'Chironomidae from Japan (Diptera), XI. New or little-known midges, with special reference to the metamorphoses of torrential species.', 'Philippine Journal of Science', NULL, '69', NULL, '297-345', NULL, NULL, NULL, 'Orthocladius kanii, Japan', 'article'),
(434, 'White and Lichtwardt 2004', '', 'Whi2004', 'White, M. M. and Lichtwardt, R. W.', 2004, NULL, NULL, NULL, NULL, NULL, 'Fungal symbionts (Harpellales) in Norwegian aquatic insect larvae', 'Mycologia', NULL, '96', '4', '891-910', NULL, 'Collections of aquatic insect larvae in Norway, over a 40 d period in May and Aug 2002, resulted in finding more than 25 species and one new genus of Harpellales (Trichomycetes). Nine new fungal symbionts are described and named: Ephemerellomyces aquilonius (a new monotypic genus), Glotzia stenospora and Legeriosimilis europaeus in mayfly nymphs (Ephemeroptera); Genistelloides amplispora and G. communis in stonefly nymphs (Plecoptera); and Smittium biforme, Sm. precipitiorum, Stachylina acutibasilaris and St. lentica in midge larvae (Diptera: Chironomidae). Two possibly new species of Smittium in Chironomidae larvae are described but not formally named. New hosts and biogeographical distributions are recorded for 14 previously described species, including the rare occurrence of Smittium simulii in mosquito larvae.', NULL, '', 'no entry type given'),
(435, 'Tokunaga 1936', 'a', 'Tok1936', 'Tokunaga, M.', 1936, NULL, NULL, NULL, NULL, NULL, 'Chironomidae from Japan (Diptera), VII. New species and a new variety of the genus Chironomus Meigen', 'Philippine Journal of Science', NULL, '60', NULL, '71-84', NULL, NULL, 'cited ffrom [[http://www.catalogueoflife.org/]]', '', 'no entry type given'),
(436, 'Tokunaga 1960', '', 'Tok1960', 'Tokunaga, M.', 1960, NULL, NULL, NULL, NULL, NULL, 'Notes on biting midges I', 'Akitu (Transactions of the Kyoto Entomological Society)', NULL, '9', NULL, '72-77', NULL, NULL, 'cited from [[http://www.catalogueoflife.org/]]', '', 'no entry type given'),
(437, 'Makarchenko and Kobayashi 1997', '', 'Mak1997', 'Makarchenko, E. A. and Kobayashi, T.', 1997, NULL, NULL, NULL, NULL, NULL, 'Diamesa amanoi sp. п., a new species of Diamesinae (Diptera Chironomidae) from Nepal, with notes on taxonomy and distribution of some Diamesa Meigen', 'Med. Entomol. Zool.', 'http://www.biosoil.ru/tendipes/makar5.pdf', '48', '1', ' 45-48', NULL, 'A new species, Diamesa amanoi sp. п., from Mera La (alt. 5,050 m),\r\nNepal is described. The present new species is most closely related to D. subletti\r\nMakarchenko from North America. Diamesa plumicornis Tokunaga which had been\r\nregarded as Japanese endemic species is newly recorded from South Korea, and D.\r\npankratovae Makarchenko et Bulgakov is recognized as a new synonym of D. filicauda\r\nTokunaga.\r\n', NULL, '', 'no entry type given'),
(438, 'Kieffer 1909', '', 'Kie1909', 'Kieffer, J. J.', 1909, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not checked for eg. 		\r\nThienemannia gracilis Kieffer 1909', NULL, 'no entry type given'),
(439, 'Pinder 1976', 'b', 'Pin1976a', 'Pinder, L. C. V.', 1976, NULL, NULL, NULL, NULL, NULL, 'Morphology of adult and juvenile stages of Microtendipes rydalensis (Edw) comb-nov (Diptera, Chironomidae)', 'Hydrobiologia', NULL, '48', '2', '179-184', NULL, 'The adult male of Polypedilum rydalensis (Edw.) is described in greater detail than hitherto and the female, pupa and larva are all described for the first time. On the basis of the morphology of the adult and immature stages rydalensis is placed in the genus Microtendipes Kieffer.', NULL, '', 'no entry type given'),
(440, 'Kieffer 1915', '', 'Kie1915a', 'Kieffer, J. J.', 1915, NULL, NULL, NULL, NULL, NULL, NULL, 'Brotéria', NULL, '13', NULL, '70', NULL, NULL, 'cited from [[http://www.ubio.org/NZ/search.php]]', '', 'no entry type given'),
(441, 'Tokunaga 1936', 'b', 'Tok1936a', 'Tokunaga, M.', 1936, NULL, NULL, NULL, NULL, NULL, 'Chironomidae from Japan. VI. Diamesinae.', 'Philippine Journal of Science', NULL, '59', NULL, '525-552', NULL, NULL, 'cited from {citeID|321|Makarchenko and Makarchenko 2000}', '', 'no entry type given'),
(442, 'Epler 1988', 'b', 'Epl1988a', 'Epler, J. H.', 1988, NULL, NULL, NULL, NULL, NULL, 'Biosystematics of the genus Dicrotendipes Kieffer, 1913 (Diptera: Chironomidae: Chironominae) of the world', 'Memoirs of the American Entomological Society', NULL, '36', NULL, '1--214', NULL, 'recognized with an OCR: The taxonomy, zoogeography and phylogeny of the genus Dicrotendzpes Kieffer, 1913 (Diptera: Chironomidae) are reviewed on a world-wide basis. Data from a previous study\r\nof the Nearctic fauna (Epler 1983, 1987a) are supplemented by studies of the Holarctic, Neotropical, Afrotropical, Oriental, Australian and Oceanian faunas. Seventy—two species names are recognized; the type-species of the genus is Chironomus septemmaculatus Becker, 1908.\r\nNotes on the Holarctic fauna are provided; 25 species are recognized from the area. Dicrotendipes incurvus (Sublette, 1964) is considered a junior synonym of D. tritomus (Kieffer, 1916). Keys\r\nfor the adult males, pupae and larvae of the Dicrotendipes of the Holarctic region are included.\r\nThe taxonomy of 14 species recognized from the Afrotropical -region is reviewed; these are: D. bredoi (Goetghebuer, 1936), D. chambiensis (Goetghebuer, 1936),D. collarti (Goetghebuer, 1936),\r\nD. cordatus Kieffer, 1922, D. ealae (Freeman, 1957), D. freemani [nom. nov. for D. binotatus\r\n(Kieffer, 191 1)] , D. fusccnotatus (Kieffer, 1922), D. kribiicola (Kieffer, 1923), D. leucolabzls Kieffer,\r\n1922, D. nigrolineatus (Freeman, 1957), D. peringueyanus Kieffer, 1924, D. schoutedeni (Goetghebuer, 1936), D. septemmaculatus (Becker, 1908) and D. sudanicus (Freeman, 1957). The larvae\r\nand pupae of D. fusconotatus, D. kribiicola, D. septemmaculatus and D. sudanicus, and the pupa\r\nof D. cordatus are described. New junior synonyms for D. septemmaculatus are: D. formosanus\r\nKieffer, 1916, D. frontalxs Kieffer, 1916, Chironomus hirtitarsis Johannsen, 1932, and D. rajasthan! Singh & Kulshrestha, 1977; Ch. punctatipenruls Kieffer, 1910 is considered a probable junior\r\nsynonym. A key to adult males is provided. Nineteen species are recorded from the Neotropical region. Previously described species discussed include: D. aethiops (Townes, 1945), D. alsinensis (Paggi, 1975), D. calybrnicus (Johannsen, 1905), D. crypticus Epler, 1987, D. embalsenszs Paggi, 1987, D. nestori Paggi, 1978, D.obrienorum Epler, 1987, D. pellegriniensis Paggi, 1987 and D. sinoposus Epler, 1987. The adult males of 10 new species are described: D. amazonicus, D. dasylabidus, D. demissus, D. jittkaui,\r\nD. palearivillosus, D. paradasylabidus, D. paterjohni, D. radinovskyi, D. reissi and D. soccus;\r\nadult females are described for D. amazonicus and D. demzssus; and pupae are described for D.\r\nfittkaui and D. rezlssi. A key is provided to identify Neotropical adult males.\r\nA total of 19 species are recognized from the combined Oriental, Australian and Oceanian re-\r\ngions. Three species previously considered to be Dicrotendipes are removed: Ch. blandellus Kieffer,\r\n19()6, D. paxillus Guha, Chaudhuri & Nandi, 1982, and D. socionotus Guha, Chaudhuri & Nandi,\r\n1982. New species and stages described are: D. balciunasi (adult male), D. cumberlandensis (adult\r\nmale and female, pupa, larva), D. jobetus (adult male), D. jonmartini (adult male, pupa, larva),\r\nD. lindae (adult male), D. pseudoconjunctus (adult male, pupa, larva) and D. sarinae (adult male\r\nand female, pupa, larva). The adult males and females are redescribed, and pupae and larvae\r\ndescribed, for: D. candidibaszs (Edwards, 1924), D. conjunctus (Walker, 1856) and D. pelochlorzs\r\n(Kieffer, 1912); adult males are redescribed for D. bilobatus Kieffer, 1917 and D. tenuybrceps\r\n(Kieffer, 1913). The pupa and larva of D. flexus (Johannsen, 1932) are redescribed, and the tax-\r\nonomy of D. Ieei (Freeman, 1961) and D. taylori (Freeman, 1961) is reviewed; D. semiviridis is\r\nconsidered a species inquirenda. New synonyms include: Ch. melanocnemis Edwards, 1928 (junior\r\nsynonym of D. candidibasis); Limnochironomus niveicauda Kieffer, 1921 , Ch. inferior J ohannsen,\r\n1932, Ch. (D.) wirthi Freeman, 1961, Xenochironomus loripes Guha & Chaudhuri, 1981, Kimius\r\nhoonsooi Ree, 1981 (junior synonyms of D. pelochlorrs) and Ch. (D.) inmsfailensis Freeman, 1961\r\n(junior synonym of D. tenuiforceps); D. bilobatus is removed from synonymy with D. conjunctus.\r\nKeys are provided for adult males, pupae and larvae.\r\nDistributions of selected species are discussed and distribution maps provided for D. aethiops,\r\nD. californicus complex, D. jlexus, D. lobigen D. modestus, D. nervosus, D. pelochloras, D. septemmaculatus, D. sincposus, D. tenuybrceps and D. tritomus.\r\nThe phylogeny of Dicrotendipes species known in all 3 life stages is analyzed cladistically. Results\r\nindicate that 3 major lineages occur within the genus, with at least 9 species groups.\r\n', NULL, '', 'no entry type given'),
(443, 'Wang and Sæther 1993', '', 'Wan1993', 'Wang, X. and Sæther, O. A.', 1993, NULL, NULL, NULL, NULL, NULL, 'Limnophyes Eaton from China, with the description of 5 new species (Diptera, Chironomidae)', 'Entomologica Scandinavica', NULL, '24', '2', '215-226', NULL, 'Limnophyes palleocestus sp. n., L. verpus sp. n. and L. bullus sp. n. are described as male and female imago; L. orbicristatus sp. n., and L. opimus sp. n. as male imago. The new species all belong in the minimus group. L. orbicristatus occurs in the Oriental region, L. opimus in the Palaearctic region, while the other species are present in both regions with L. verpus recorded also from North Korea. New records are given for L. asquamatus Andersen, L. brachytomus (Kieffer), L. minimus (Meigen) (with a new record from Burma), and L. difficilis Brundin.', 'cited from Chironomus Newsletter 15', '', 'no entry type given'),
(444, 'Sæther 1980', '', 'Sae1980', 'Sæther, O. A.', 1980, NULL, NULL, NULL, NULL, NULL, 'Glossary of chironomid morphology terminology (Diptera: Chironomidae)', 'Entomologica Scandinavica Supplement', NULL, '14', NULL, '1-51', NULL, 'A glossary divided in parts for imagines, pupae, and larvae, and including synonyms an\r\nproposed standardized abbreviations is given. Controversies as to correct terminologies are\r\nbriefly discussed. Usage of the Tillyard modifications of the Comstock—Needham’s win\r\nvenationsystem, inferior, superiorand median volsellae is proposed for the imagines. For the larvae the terms paraligula, premandible and mentum are prefered. A list of abbreviations is given and most of the different terms illustrated.', 'ISSN 0105-3574', '', 'no entry type given'),
(445, 'Sergeyeva 1996', '', 'Ser1996', 'Sergeyeva, I. V.', 1996, NULL, NULL, NULL, NULL, NULL, 'Revision of Tanypodinae (Diptera, Chironomidae) from the Volga River. I. Morphokaryotype analysis of Procladius choreus', 'Entomological Review (English Translation of Entomologicheskoye Obozreniye ISSN 0367-1445)', NULL, '75', '5', '65-74', NULL, 'with OCR: A complete morphological description of all developmental stages of Procladius choreus Meigen, 1804 from the Volga River and its tributaries is given.\r\nThe female karyotype is described for the first time; 2n = 14. Six pairs of chromosomes are acrocentric, the seventh pair is represented by a pointed chromosome.\r\nPolytene chromosomes from the salivary glands are conjugated by telomeres forming a chromocenter.', NULL, '', 'no entry type given'),
(446, 'Sæther 1982', '', 'Sae1982', 'Sæther, O. A.', 1982, NULL, NULL, NULL, NULL, NULL, 'Orthocladiinae (Diptera: Chironomidae) from SE USA, with descriptions of Plhudsonia, Unniella and Platysmittia n. genera and Atelopodella n. subgen.', 'Entomologica Scandinavica', NULL, '13', '4', '465-510', NULL, NULL, 'Psilometriocnemus cristatus (Chironomidae): Sp-nov, South-Carolina, P.-480, fig''d-;', '', 'no entry type given'),
(447, 'Goetghebuer 1923', '', 'Goe1923', 'Goetghebuer, M. E. M.', 1923, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 'no entry type given'),
(448, 'Makarchenko 2006', '', 'Mak2006a', 'Makarchenko, E. A.', 2006, NULL, NULL, 'Лелей, А. С. (Leleij, A. C.)', NULL, NULL, 'In: Key to the insects of Russian Far East. Diptera and Siphonaptera. Pt. 4. (Определитель насекомых Дальнего Востока России)', 'ISBN 5-8044-0686-8', NULL, 'VI', NULL, '934', NULL, 'The fourth book of volume VI includes 11 families and addition to three family of Diptera. Many of them are\r\nknown as bioindicators of water as well as fodder objects for many species of fishes (Chironomidae), parasites of invertebrates or injurious for the man and animals (Calliphoridae, Sarcophagidae) and 6 families of order Siphonaptera.\r\nTotally 345 genera and 1141 species from the Russian Far East and adjacent territories are treated in the book. Diagnoses of families and genera and keys to the genera and species are given. The distribution, biological data and economic\r\nimportance as the morphological characters and synonyms are given for each species. The book is provided by small Russian-English dictionary of used abbreviations and special terms throughout the text and by Latin index of the insects and illustrated by 653 plates of figures and one map.', 'in Russian', '', 'no entry type given'),
(449, 'Zelentsov and Makarchenko 1988', '', 'Zel1988', 'Zelentsov, N. I. and Makarchenko, E. A.', 1988, NULL, NULL, NULL, NULL, NULL, 'Chironomids of the genus Psectrocladius Kieff. (Diptera, Chironomidae) from the extreme north-east of the USSR', 'in Fauna, sistematika i biologiya presnovodnykh bespozvonochnykh. [Fauna, systematics and biology of freshwater invertebrates.]', NULL, NULL, NULL, '40-51', NULL, 'some notes: description of P.(P) sokolovae sp.n. (A, P, L), P.(P) fennicus (A, P, L), P. aff.sordidellus (larvae). Differntial characters are given', 'in Russian', '', 'no entry type given'),
(450, 'Storå 1939', '', 'Sto1939', 'Storå, R.', 1939, NULL, NULL, NULL, NULL, NULL, 'Mitteilungen über die Nematoceren Finnlands II', 'Notulae Entomologicae', NULL, '19', NULL, '16-30', NULL, NULL, 'cited from {citeID|449|Zelentsov and Makarchenko 1988}', '', 'no entry type given'),
(451, 'Trond 2007', '', 'Tro2007', 'Trond, A. (Editor)', 2007, NULL, NULL, 'Andersen, Trond', NULL, NULL, 'Contributions to the systematics and ecology of aquatic Diptera: a tribute to Ole A. Sæther', 'Columbus, Ohio : Caddis Press', NULL, NULL, NULL, '358', NULL, 'In order to congratulate Ole A. Sæther on his 70th birthday and for 46\r\nprosperous years of scientific studies in freshwater biology and insect\r\nsystematics, colleagues from around the world contributed 35 papers\r\non the ecology and systematics of Ceratopogonidae, Chaoboridae,\r\nChironomidae, and Psychodidae. Eight new genera and nearly 50 new\r\nspecies are described in this book which comprises more than 350\r\npages. All articles were peer-reviewed before publication.\r\n<ul>\r\n<li>Ekrem, T. and T. Andersen: Professor Ole Anton Sæther 70 years: four decades of chironomid research.</li>\r\n<li>Andersen, T. and H. F. Mendes: Five enigmatic new orthoclad genera from Brazil (Diptera: Chironomidae, Orthocladiinae). </li>\r\n<li>Ashe, P. and J. P. O’Connor: A new genus and species of Orthocladiinae (Diptera: Chironomidae) from Sulawesi, Indonesia. </li>\r\n<li>Brodersen, K. P.: Chironomids (Diptera) from sub-saline lakes in West Greenland: diversity, assemblage structure and respiratory adaptation. </li>\r\n<li>Caldwell, B. A.: Morphological variation, additional distribution records, and notes on ecology of Pagastia orthogonia Oliver (Diptera: Chironomidae). </li>\r\n<li>Cranston, P. S., G. M. Benigno and M. C. Dominguez: Hydrobaenus saetheri Cranston, new species, an aestivating, winter-emerging chironomid (Diptera: Chironomidae) from California. </li>\r\n<li>Ekrem, T. and G. A. Halvorsen: Taxonomy of Tanytarsus lapponicus Lindeberg, 1970, a species with larval mandible of ‘lugens-type’ (Diptera: Chironomidae). </li>\r\n<li>Ekrem, T. and E. Stur: Description of Tanytarsus hjulorum, new species, with notes and DNA barcodes of some South African Tanytarsus (Diptera: Chironomidae). </li>\r\n<li>Endo, K., E. A. Makarchenko and E. Willassen: On the systematics of Linevitshia Makarchenko, 1987 (Diptera: Chironomidae, Diamesinae), with the description of L. yezoensis Endo, new species. </li>\r\n<li>Ferrington, L. C. Jr.: Hibernal emergence patterns of Chironomidae in lotic habitats of Kansas versus substrate composition. </li>\r\n<li>Giłka, W. and L. Paasivirta: Two new species of the genus Tanytarsus van der Wulp (Diptera: Chironomidae) from Fennoscandia. </li>\r\n<li>Goddeeris, B., K. Hermans and H. Hampel: Experimental termination of diapause in three Chaoborus species (Diptera: Chaoboridae) from a Belgian lowland pond. </li>\r\n<li>Hirabayashi, K., G. Kimura, Y. Fukunaga and M. Yamamoto: Distribution pattern of chironomid midges (Diptera: Chironomidae) in the upper and middle reaches of the Shinano River in Central Japan. </li>\r\n<li>Jacobsen, R. E.: Orthocladius (Orthocladius) saetheri new species, from the Appalachian Mountains (Diptera: Chironomidae). </li>\r\n<li>Jacobsen, R. E. and B. Bilyj: An unusual new Cladotanytarsus from oligotrophic Florida Everglades marshes (Diptera: Chironomidae). </li>\r\n<li>Kobayash i, T., R. Nakazato and M. Higo: The identity of Japanese Lipiniella Shilova species (Diptera: Chironomidae). </li>\r\n<li>Lencioni, V., B. Rossaro and B. Maiolini: Alpine chironomid distribution: a mere question of altitude? </li>\r\n<li>Makarchenko, E. A. and M. A. Makarchenko: A review of Tokunagaia Sæther (Diptera: Chironomidae) from the Russian Far East, with the description of four new species. </li>\r\n<li>Martin, J., A. Blinov, E. Alieva and K. Hirabayashi: A molecular phylogenetic investigation of the genera closely related to Chironomus Meigen (Diptera: Chironomidae). </li>\r\n<li>Moubayed-Breil, J.: Polypedilum (Cerobregma) lotensis new species, and P. (C.) saetheri new species, from lowland streams and rivers in France (Diptera: Chironomidae). </li>\r\n<li>Murray, D. A.: Limnophyes platystylus new species (Diptera: Chironomidae, Orthocladiinae) from Ireland. </li>\r\n<li>Niitsuma, H.: Saetheromyia, a new genus of Tanypodinae from Japan (Diptera: Chironomidae). </li>\r\n<li>Oyewo, E. A. and R. E. Jacobsen: Polypedilum (Pentapedilum) epleri, a new species from the eastern USA (Diptera: Chironomidae). </li>\r\n<li>Paasivirta, L.: Chironomid species in Finnish springs and their surroundings. </li>\r\n<li>Paggi, A. C.: A new Neotropical species of the genus Thienemanniella Kieffer, 1911 (Diptera: Chironomidae, Orthocladiinae). </li>\r\n<li>Roque, F. O. and S. Trivinho-Strixino: Spatial distribution of chironomid larvae in low-order streams in southeastern Brazilian Atlantic Forest, a multiple scale approach. </li>\r\n<li>Sanseverino, A. M. and E. J. Fittkau: Taxonomy of Caladomyia alata (Paggi, 1992) comb. n. and Caladomyia tuberculata (Reiss, 1972) comb. n. (Diptera: Chironomidae). </li>\r\n<li>Szadziewski, R., W. Giłka and P. Dominiak: A redescription of Forcipomyia squamigera Kieffer, 1916 in all stages (Diptera: Ceratopogonidae). </li>\r\n<li>Trivinho-Strixino, S. and T. Siqueira: New species of Beardius Reiss and Sublette, 1985 (Diptera: Chironomidae) from Southeastern Brazil. </li>\r\n<li>Wagner, R. and T. Andersen: Psychodidae (Diptera: Nematocera) from the West Usambara Mountains, Tanzania. </li>\r\n<li>Wang, X., Y. Liu and L. Paasivirta: A new species of Propsilocerus Kieffer from Finland (Diptera: Chironomidae, Orthocladiinae). </li>\r\n<li>Willassen, E.: Sasayusurika aenigmata Makarchenko (Diptera: Chironomidae, Diamesinae) - a Japanese endemic discovered in the Indian Himalaya. </li>\r\n<li>Wülker, W. F.: Two new Chironomus species with fluviatilis-type larvae from the near-shore sandy sediments of Lake Michigan (Diptera: Chironomidae). </li>\r\n<li>Yamamoto, M., K. Hirabayashi and M. Matsuzawa: The Korean species Hanochironomus tumerestylus Ree, 1992 taken on Ishigaki Island, Japan (Diptera: Chironomidae). </li>\r\n<li>Zorina, O. V.: Olecryptotendipes, a new genus in the Harnischia complex (Diptera: Chironomidae) from the Russian Far East.</li>\r\n</ul>', 'ISBN 0-9667982-3-6', 'Tanytarsus lapponicus, ecology, systematic', 'book'),
(452, 'Zelentsov 1989', '', 'Zel1989', 'Zelentsov, N. I.', 1989, NULL, NULL, NULL, NULL, NULL, 'A new species of Orthocladiinae of the genus <em>Cricotopus</em> v.d. Wulp and metamorphosis of <em>Acricotopus longipalpus</em> Reiss (Diptera, Chironomidae) from the Pamir.', 'Trudy Instituta Biologii Vnutrennikh Vod [Труды институт биологии внутренних вод]', NULL, '56', '59', '215-249', NULL, 'Acricotopus longipalpus Reiss 1968 (Chironomidae ): description , egg and pupa, first time described, p. 237;\r\nCricotopus shilovae Zelentzov 1989 (Chironomidae ): Sp nov, Tajikistan , P. 215, fig’d ', 'ISSN: 0320-3557, in Russian', 'Acricotopus longipalpus, Acricotopus lucens, Asia, Cricotopus shilovae, description, Eurasia, Eurasian Region, land zones, new taxa, nomenclature, Palaearctic Region, Pamir, systematic, systematic literature', 'article'),
(453, 'Reiss 1968', 'a', 'Rei1968', 'Reiss, F.', 1968, NULL, NULL, NULL, NULL, NULL, 'Neue Chironomiden-Arten (Diptera) aus Nepal.', 'Khumbu Himal (former named Ergebnisse des Forschungsunternehmens Nepal Himalaya)', NULL, '3', NULL, '55-73', NULL, '<ul>\r\n<li>Acricotopus longipalpus (Chironomidae ): Sp nov, p. 63, Nepal , fig ;</li>\r\n<li>Asclerina  (Chironomidae ): Gen nov, p. 65, type sp., Asclerina nudiclypeata, sp. nov., p. 66, Nepal , [Sp nov];</li>\r\n<li>Asclerina nudiclypeata (Chironomidae ): Sp nov;</li>\r\n<li>Diamesa lofferi (Chironomidae ): Sp nov, p. 56, Tshola Tso, Namche Bazar, Nepal , fig. ;</li>\r\n<li>Diamesa planistyla (Chironomidae ): Sp nov, p. 57, Tshola Tso, Namchc Bazar Nepal, fig. ;</li>\r\n<li>Helenietta asiatica (Chironomidae ): Sp nov, p. 69, Tshola Tso, Nepal ;</li>\r\n<li>Micropsectra tuberosa (Chironomidae ): Sp nov, p. 70, Nepal ;</li>\r\n<li>Pseudodiamesa nepalensis (Chironomidae ): Sp nov, p. 60, Nepal , fig.</li>\r\n</ul>\r\n', 'cited from {textciteID|452|Zelentsov 1989} due to description of Acricotopus longipalpus', 'Acricotopus longipalpus, Asclerina, Asclerina nudiclypeata, Diamesa lofferi, Diamesa planistyla, Helenietta asiatica, Micropsectra tuberosa, Pseudodiamesa nepalensis', 'article'),
(454, 'Wang et al. 1994', '', 'Wan1994', 'Wang, X., Zheng, L. and Ji, B.', 1994, NULL, NULL, NULL, NULL, NULL, 'A taxonomic study on Orthocladiinae (Diptera: Chironomidae) of China: II. Genus Brillia Kieffer', 'Acta Entomologica Sinica', NULL, '37', '3', '359--363', NULL, 'In this paper two new species of genus Brillia Kieffer from China are described. Type specimens are preserved in Biology Department of Nankai University. Brillia bifasciata sp. nov. (figs. 1-4) Imago mate: Total length 4.33mm. AR 0.45, Temporals 22, Clypeals 31. Palpi length: 0.08, 0.22, 0.22, 0.24mm. Tentorium as in fig. 1. Ground color of thorax yellowish green, antepronotum pale green, with brown to dark brown scutal stripe, pleural sclerites, preepisernum, postnitum and a part of scutellum (fig. 2). Antepronotals 27, dorsocentrals 58 in 3-4 rows, scutellaris 18, prealars 24 in 3 rows. Wing length 2.76mm. C extension 70-mu-m. RM long and oblique. Squama with 34 fringed setae. LR1 0.78, LR2 0.49, LR3 0.46. Abdominal tergites 1, IV, V and fore 2/3 of 11 pale green, the other dark brown (fig. 3). Hypopygium (fig. 4) darkbrown, tergite IX bears a group of 22 setae at each side. Anal point absent. Gonocoxite with a mesal protuberance bearing several setae. Superior volsella developed. Gonostylus bifurcate, subapical lobe about l/2 as long as apical lobe. Transverse sternapodeine shouldered laterally. Holtype male , Ningxia Autonomous Region (MT. Liu-pan 35.6 degree N, 106.1 degree E). The present species is very closely related to the known species of the flavifrons group in genitalia structure. (B. flavifrons, B. laculata, B. sera (Nearctic), B. longifurca (Palaearctic) and B. japonica (Japan), But differs in having a -very low AR and unique abdominal coloration. The species is also nearly identical to B. brevicornis sp. nov. from China, but differs in size, the coloration of abdominal tergites and tentorium. Brillia brevicornis sp. nov. (figs. 5-7) Imago male: Total length 3.5mm. AR 0.42. Temporals 26, clypeals 22 in 3 transverse rows. Palpi length 0.057, 0.15, 0.16, 0.155mm. Tentorium as in fig. 5. Thoracic color generally yellowish green, scutal stripes, supraalar callus, pleural sclecrites, ventral half of preepisternum, postnotum, a part of scutellum and dorsal mergin of amtepronotum brown. Antepronotals 20, dorsocentrals 50, scutellaris 20, prealars 15. Wing length 2.0mm, anal lobe weakly developed, O extension about 50-mu-m. R-2+3 near R-1 Squama fringed setae 26. LRI 0.86, LR2 0.51, LR3 0.55. Abdominal tergites as in fig. 6. Hypopygium as in fig. 7. Holotype male , Sichuan Province (Mt. Jin-fo, 29.0 degree N, 107.1 degree E). Very close to B. bifasciata in lower AR, thoracic color and Hypopygium, but differs in size, tentorium and abdominal coloration.', 'in Chinese', 'Brillia bifasciata, Brillia brevicornis, description new species', 'article'),
(455, 'Brundin 1983', '', 'Bru1983', 'Brundin, L.', 1983, NULL, NULL, NULL, NULL, NULL, 'The Larvae of Podonominae (Diptera: Chironomiadae) of the Holarctic region - Keys and diagnoses', 'Chironomidae of Holarctic region - Keys and diagnoses (Part 1 - Larvae), Entomologica Scandinavica Supplement', NULL, '19', NULL, '21-31', NULL, NULL, NULL, 'Podonominae, Holarctic Region', 'inbook'),
(456, 'Kuhl and Giardina 1982', '', 'Kuh1982', 'Kuhl, F. P. and Giardina, C. R.', 1982, NULL, NULL, NULL, NULL, NULL, 'Elliptic Fourier features of a closed contour', NULL, NULL, '18', '3', '236-258', NULL, 'A direct procedure for obtaining the Fourier coefficients of a chain-encoded contour is presented. Advantages of the procedure are that it does not require integration or the use of fast Fourier transform techniques, and that bounds on the accuracy of the image contour reconstruction are easy to specify. Elliptic properties of the Fourier coefficients are shown and used for a convenient and intuitively pleasing procedure of normalizing a Fourier contour representation. Extension of the contour representation to arbitrary objects at arbitrary aspect angle is discussed. The procedures have direct application to a variety of pattern recognition problems that involve analysis of well-defined image contours', NULL, 'contour, Fourier Analysis, outlines', 'article');
INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(457, 'Ekrem and Stur 2009', '', 'Ekr2009', 'Ekrem, T. and Stur, E.', 2009, 'torbjorn.ekrem@vm.ntnu.no, elisabeth.stur@vm.ntnu.no', 'Norwegian University of Science and Technology, Museum of Natural History and Archaeology, NO-7491 Trondheim, Norway', NULL, NULL, NULL, 'A review of the genus <em>Zavrelia</em> (Diptera: Chironomidae)', 'European Journal of Entomology', 'http://www.eje.cz/scripts/viewabstract.php?abstract=1433', '106', '1', '119–144', NULL, 'In this paper we review the taxonomy of the genus <I>Zavrelia</I> Kieffer, Thienemann &amp; Bause and present emended generic diagnoses of all major life stages. Illustrated keys to larvae, pupae, adult males and females are presented as well as descriptions of four species new to science. <I>Zavrelia</I> species are only recorded from the northern hemisphere and comprise in total ten small to minute species. The following life stages and species are described: Larva, pupa, adult male and adult female of <I>Zavrelia aristata</I> sp. n., <I>Zavrelia hudsoni</I> sp. n., <I>Zavrelia pentatoma</I> Kieffer &amp; Bause and <I>Zavrelia sinica</I> sp. n.; pupa and adult male of <I>Zavrelia casasi</I> sp. n.; and adult males of <I>Zavrelia clinovolsella</I> Guo &amp; Wang and <I>Zavrelia tusimatijea</I> (Sasa &amp; Suzuki). <I>Zavrelia atrofasciata</I> Kieffer and <I>Stempellina paludosa</I> Goetghebuer are proposed as new junior synonyms of <I>Zavrelia pentatoma</I> and lectotypes of <I>Zavrelia nigritula</I>,<I> Zavrelia pentatoma</I> and <I>Stempellina paludosa</I> are designated.', NULL, 'determination key, generic diagnosis, immature stages, Revision, taxonomy, Zavrelia', 'article'),
(458, 'Webb and Scholl 1985', '', 'Web1985', 'Webb, C.J., Scholl, A.', 1985, NULL, NULL, NULL, NULL, NULL, 'Identification of larvae of European species of Chironomus Meigen (Dipt.: Chir.) by morphological characters', 'Systematic Entomology', NULL, '10', NULL, '353-372', NULL, NULL, 'cited from {citeID|8|Vallenduuk 1997}', 'Chironomus,  taxonomy, determination', 'article'),
(459, 'Webb and Scholl 1987', '', 'Web1987', 'Webb, C.J., Scholl, A.', 1987, NULL, NULL, NULL, NULL, NULL, 'Comparative morphology of the larval ventromental plates of European species of Einfeldia Kieffer and Chironomus Meigen (subgen. Lobochir. and Camptochir.) (Dipt. Chir.)', 'Entomologica Scandinavica Supplement', NULL, '29', NULL, '75-86', NULL, NULL, 'cited from {citeID|8|Vallenduuk 1997}', 'Chironomus, taxonomy, Einfeldia', 'article'),
(460, 'Webb et al. 1985', '', 'Web1985a', 'Webb, C.J., Scholl, A., Ryser, H.M.', 1985, NULL, NULL, NULL, NULL, NULL, 'Comparative morphology of the larval ventromental plates of European species of Chironomus Meigen (Dipt.: Chir.)', 'Systematic Entomology', NULL, '10', NULL, '373-385', NULL, NULL, 'cited from {citeID|8|Vallenduuk 1997}', 'Chironomus, taxonomy', 'article'),
(461, 'Johnson and Pejler 1978', '', 'Joh1978', 'Johnson, R.K. and Pejler, B.', 1978, NULL, NULL, NULL, NULL, NULL, 'Life histories and coexistance of the two profundal Chironomus species in lage Erken, Sweden', 'Entomologica Scandinavica Supplement', NULL, '29', NULL, '233-238', NULL, NULL, 'cited from {citeID|8|Vallenduuk 1997}', 'Chironomus, Sweden, life history', 'article'),
(462, 'Kiknadze et al. 1991', '', 'Kik1991', 'Kiknadze, I. I., Shilova, A.I., Kerkis, I.E., Shobanov, N.A., Zelentsov, N.I., Grebenyuk, L.P., Istomina, A.G., Prasolov, V.A.', 1991, NULL, NULL, NULL, NULL, NULL, 'Кариотип и морфология личинок трибы Chironomini. Атлас. (The karyotypes and morphology of larvae of tribi Chironimini. Atlas.)', 'Наука. Новосибирск. (Nauka. Novosibirsk.)', NULL, NULL, NULL, '115', NULL, NULL, 'cited from {citeID|8|Vallenduuk 1997}', 'karyotypes, Chironomus, Chironomini, morphology', 'book'),
(463, 'Shilova 1980', '', 'Shi1980', 'Shilova, A.I.', 1980, NULL, NULL, NULL, NULL, NULL, 'K sistematike roda Einfeldia Kieff. (Diptera, Chironomidae) [To the systematic of genus Einfeldia Kieff.]', 'Trudy Instituta Biologii Vnutrennikh Vod [Труды институт биологии внутренних вод] ', NULL, '41', NULL, '162-191', NULL, NULL, 'cited from {citeID|8|Vallenduuk 1997}', 'Einfeldia', 'article'),
(465, 'Webb and Scholl 1988', '', 'Web1988', 'Webb, C.J., Scholl, A.', 1988, NULL, NULL, NULL, NULL, NULL, 'Ultrastructure of the larval ventromental plates of Chironomus balatonicus Dévai Wülker and Scholl (Diptera, Chironomidae)', 'Mitteilungen der Schweizerischen Entomologischen Gesellschaft', 'http://seg.scnatweb.ch/html/publikationen.html', '61', '1-2', '113-122', NULL, 'The micro-architecture of larval ventromental plates of C. balatonicus, DEVAI, WUELKER and SCHOLL has been studied by scanning electron microscopy. The plates of this species are shown to have a number of ultrastructural features previously observed amongst European Chironomus only in C. plumosus L. and the closely related C. muratensis RYSER et al., and C. nudiventris RYSER et al. The taxonomic implications of these findings are discussed.', 'cited from {citeID|8|Vallenduuk 1997}, ISSN 0036-7575', 'Chironomus plumosus, Chironomus muratensis, Chironomus nudiventris, taxonomy, scanning electron microscopy', 'article'),
(466, 'Shobanov 1989', '', 'Sho1989', 'Shobanov, N.A.', 1989, NULL, NULL, NULL, NULL, NULL, 'The morphological differentiation of Chironomus species of plumosus group (Diptera, Chironomidae). Larvae', 'Acta Biologica Debrecina Oecologica Hungarica', NULL, '2', NULL, '335-344', NULL, NULL, 'cited from {citeID|8|Vallenduuk 1997}', 'Chironomus plumosus', 'article'),
(467, 'Lindeberg 1970', '', 'Lin1970', 'Lindeberg', 1970, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'reference for Corynocera  oliveri', 'Corynocera oliveri', 'article'),
(468, 'Lipina 1939', '', 'Lip1939', 'Lipina', 1939, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not checked for Zalutschia zalutschicola Lipina 1939', NULL, 'article'),
(469, 'Hofmann 1984', 'a', 'Hof1984', 'Hofmann, W.', 1984, NULL, NULL, NULL, NULL, NULL, 'A subfossil record of the presumed larva of Corynocera oliveri Lindeberg from the Lobsigensee (Swiss Plateau). Studies in the Late-Quaternary of Lobsigensee 8', 'Spixiana', NULL, '7', '2', '211-214', NULL, 'Having some morphological features in common with Corynocera ambigua Zetterstedt and occuring simultaneously with subfossil male hypopygia of C. oliveri Lindeberg, a subfossil Tanytarsini larva from late glacial sediments of the Lobsigensee (Swiss Plateau) is presumed to belong to Corynocera oliveri. C. oliveri and C. ambigua coexisted in the Lobsigensee during the Oldest Dryas period until about 13000 B.P. This is the first record of both species from the alpine region.', 'ISSN 0341-8391. See also thread at Chironomidae discussion list: [[http://lists.vm.ntnu.no/pipermail/chironomidae/2009-March/000097.html]]', 'Corynocera ambigua, Corynocera oliveri, description larva, Alpine lakes, subfossil larvae', 'article'),
(470, 'Andersen 1937', '', 'And1937', 'Andersen, F. S.', 1937, NULL, NULL, NULL, NULL, NULL, 'Ueber die Metamorphose der Ceratopogoniden und Chironomiden Nordostgrönlands', 'Meddelelser om Grønland', NULL, '116', NULL, '2–94', NULL, NULL, 'cited from {citeID|280|Stur and Ekrem 2006}; Micropsectra groenlandica regarded as synonym to M. logani, but M. groenlandica is designated as lectotype', 'Micropsectra groenlandica', 'article'),
(471, 'Johannsen 1928', '', 'Joh1928', 'Johannsen, O. A.', 1928, NULL, NULL, NULL, NULL, NULL, 'Two new species of western chironomids', 'Journal of Entomology and Zoology', NULL, '20', NULL, '33–35', NULL, '\r\n', 'cited from {citeID|280|Stur and Ekrem 2006}', 'Micropsectra logani, first description', 'article'),
(472, 'Linevich 1977', '', 'Lin1977', 'Linevich, A.A.', 1977, NULL, NULL, NULL, NULL, NULL, 'Хирономиды Байкала и Прибайкалья и положение Diamesinae в системе семейства. [Chironomidae of Lake Baikal and the surrounding area and position of Diamesinae in the family system]', 'In: Систематика и эволюция двукрылых насекомых. [Systematics and evolution of Diptera (Insecta)] Zoological Institute Acad. Sci. USSR, Leningrad, Nauka (Identification books of the USSR fauna)', NULL, NULL, NULL, '52-57', NULL, NULL, 'cited from {citeID|2|Pinder and Reiss 1983} not checked for Sergentia', 'Baicalosergentia, Sergentia', 'inbook'),
(473, 'Kieffer 1921', 'a', 'Kie1921', 'Kieffer, J. J.', 1921, NULL, NULL, NULL, NULL, NULL, NULL, 'Bull. Soc. H. n. Moselle', NULL, '29', NULL, '90', NULL, NULL, 'not checked for Acricotopus see [[http://www.ubio.org/NZ/search.php]]', 'Acricotopus, first description', 'article'),
(474, 'Tang 2006', '', 'Tan2006', 'Tang, H.', 2006, NULL, NULL, NULL, NULL, NULL, 'Biosystematic study on the chironomid larvae in China (Diptera: Chironomidae)', 'Lab of Chironomidology, College of Life Sciences, Nankai University, China', NULL, NULL, NULL, '945', 'October', NULL, 'in Chinese, 250 plates, 14 tables (Title in Chinese: 唐红渠，2006，中国摇蚊科幼虫生物系统学研究(双翅目: 摇蚊科), 南开大学, 天津, 中国, 300071)', 'Chironomidae China, Psectrocladius barbimanus, review, systematic literature', 'phdthesis'),
(475, 'Delettre 2000', '', 'Del2000', 'Delettre, Y. R.', 2000, NULL, NULL, NULL, NULL, NULL, 'Larvae of terrestrial Chironomidae (Diptera) colonize the vegetation layer during the rainy season', 'Pedobiologia', NULL, '44', '5', '622--626', NULL, 'Several qualitative observations show that larvae of terrestrial Chironomidae (Diptera) are able to colonize the vegetation above the soil surface on heathlands in Brittany (France). In winter, during rainy periods, larvae of several species move into the thick layer of lichens on which they feed. This behaviour, previously unknown, expands food resources which can be used by species. Its occurrence only in winter is related to ecophysiological requirements, mainly drought avoidance. It is discussed in a cost-benefit perspective.', NULL, 'Bryophaenocladius subvernalis (Edw.), competition, drought avoidance, ecology, feeding behaviour, Limnophyes minimus (Mg.), Pseudosmittia longicrus (K.), Smittia celtica Rossaro & Delettre (1992), Smittia pratorum G., terrestrial Chironomidae', 'article'),
(476, 'Rossaro and Delettre 1992', '', 'Ros1992', 'Rossaro, B., Delettre, Y.R.', 1992, NULL, NULL, NULL, NULL, NULL, 'Description of Smittia celtica, n. sp. (Diptera, Chironomidae)', 'Annales de la Société Entomologique de France', NULL, '28', NULL, '365–370', NULL, NULL, 'cited from {citeID|475|Delettre 2000}', 'Smittia celtica, description, terrestrial Chironomidae', 'article'),
(477, 'Vallenduuk and Moller-Pillot 1999', '', 'Val1999', 'Vallenduuk, H. J. and Moller-Pillot, H. K. M.', 1999, NULL, 'Vallenduuk, 5482 GR Schijndel (The Netherlands)', NULL, '2', NULL, 'Key to the larvae of Chironomus in Western Europe', NULL, NULL, NULL, NULL, '23', NULL, NULL, 'Revised edition. Cited from {citeID|274|Dettinger-Klemm 2003}', 'Chironomus, taxonomic literature, determination', 'article'),
(478, 'Lehmann 1973', '', 'Leh1973', 'Lehmann, J.', 1973, NULL, NULL, NULL, NULL, NULL, 'Systematische and phylogenetische Studie über die Gattungen Thienemanniola Kieffer and Corynocera Zetterstedt (Diptera, Chironomidae)', 'Hydrobiologia', NULL, '43', NULL, '381-414', NULL, 'In the preceding paper, a revision of the species of the genus Thienemanniola KIEFFER is presented . The species Th. longipennis KIEFFER and Th . brevitarsis KIEFFER are declared to be synonymous to Th . ploenensis KIEFFER . All three stages of the metamorphosis of Th . ploenensis are described and figured ; ecological notes are also given . The species Corynocera ambigua ZETTERSTEDT and Corynocera oliveri LINDEBERG are briefly characterized and figured. Finally, the systematical classification of the genera Corynocera and Thienemanniola into the family Chironomidae and the degree of relationship between the genera Corynocera and Thienemanniola are discussed .', 'In German', 'Thienemanniola longipennis Kieffer, Thienemanniola brevitarsis Kieffer, Thienemanniola ploenensis Kieffer L P A, Corynocera ambigua Zetterstedt, Corynocera oliveri Lindeberg, systematic literature', 'article'),
(479, 'Kieffer 1921', 'b', 'Kie1921a', 'Kieffer, J. J.', 1921, NULL, NULL, NULL, NULL, NULL, 'Notes sur quelques Chironomides etranges habitant les lacs de Schleswig-Holstein', 'Assoc. franc. p. l''avancement des sciences (1920)', NULL, NULL, NULL, '327-331', NULL, NULL, 'not checked for Thienemanniola ploenensis KIEFFER 1921: 328-329', 'Thienemanniola ploenensis', 'article'),
(480, 'Hirvenoja 1961', '', 'Hir1961', 'Hirvenoja, M.', 1961, NULL, NULL, NULL, NULL, NULL, 'Description of the larva of Corynocera ambigua ZETT. (Dipt . Chironomidae) and its relation to the subfossil species Dryadotanytarsus edentulus ANDERS. and D. duffi DEEVEY', 'Suom. hyont. Aikak.', NULL, '27', NULL, '105-110', NULL, NULL, 'cited from {citeID|478|Lehmann 1973}', 'Corynocera ambigua Zetterstedt, Dryadotanytarsus edentulus, Dryadotanytarsus duffy', 'article'),
(481, 'Buskens and Moller-Pillot 1992', '', 'Bus1992', 'Buskens, R. F. M. and Moller-Pillot, H. K. M.', 1992, NULL, NULL, NULL, NULL, NULL, 'The Netherlands as an environment for chironomid fauna', 'Aquatic Ecology', NULL, '26', '6', '223--228', NULL, 'Commonness and distributional patterns of Chironomidae in The Netherlands are discussed with respect to the occurrence in different water types and the role of some environmental factors. At least 205 taxa were present in The Netherlands. Nine of them became extinct. Lowest numbers of species were recorded in the zone with coastal dunes and in the brackish area. Most species are present in the Pleistocene area with sandy soils and variation in relief. The number of species of Iotic water are extending those of lentic water. Species wide-spread in The Netherlands are mainly living in eutrophic water. Many species tolerate hypertrophic conditions, especially in running water. Only twenty percent of the species of Iotic and lentic water are acid-tolerant. Nowadays species of non-acid, oligotrophic or mesotrophic waters are rare. Oxygen regime in connection with the presence of specific microhabitats are important factors regulating chironomid fauna.', NULL, 'Acamptocladius submontanus, Chaetocladius melaleucus agg., Chaetocladius sp. Herkenbosch, Chaetoctadius dentiforceps agg., chironomid larvae, Chironomus aprilinus, Chironomus salinarius, Clunio marinus, commonness, Dicrotendipes pallidicornis, distribution Chironomidae, environmental factors, Heleniella cf. ornaticollis, Heterotanytarsus apicalis, Hydrobaenus distylus, Hydrobaenus pilipes, Kloosia pusilla, Labrundinia longipalpis, Lasiodiamesa sp., Macropelopia notata, Microchironomus deribae, Nanocladius balticus, Orthocladius frigidus, Orthocladius rivulorum, Pagastiella orophila, Paracladopelma laminata agg., Paracladopelma nigfitula, Paracricotopus niger, Parametriocnemus stylatus, Paratendipes gr. albimanus, Prodiamesa rufovittata, Rheocricotopus atripes, Rheopelopia ornata, Robackia demeijerei, Sergentia coracina, Symposiocladius lignicola, Tanypus vilipennis, Telmatogeton sp., Thienemanniella acuticornis agg., Thienemanniella flaviforceps agg., Trissopelopia longimanus, watertypes, Zalutschia humphriesiae, Zavrelimyia barbatipes, Zavrelimyia melanura', 'article'),
(482, 'Pinder 1986', '', 'Pin1986', 'Pinder, L. C. V.', 1986, NULL, NULL, NULL, NULL, NULL, 'Biology of freshwater Chironomidae', 'Annual Review of Entomology', NULL, '31', NULL, '1-23', NULL, 'The family Chironomidae is the most widely distributed and frequently the most abundant group of insects in freshwater environments. An enormous amount has been written about their biology (51, 69), and yet the detailed ecology and life cycles of the great majority of species are unknown and most general faunistic works either ignore the Chironomidae or deal with them superficially (146). The primary reason for such deficiencies is the lack readily available ”keywords” for their identification, coupled with the large number of species frequently encountered within even a small water body. The recent generic diagnoses and keywords to larvae and pupae of the Holarctic region (214, 215), which will shortly be followed by a similar treatment of adult males, should do much to remedy this situation. The first attempt to summarize the ecology of the Chironomidae was by Thienemann (189), and there have been two, more recent, reviews that provide useful summaries of the natural history of the group (136, 149).', NULL, 'Chironomidae: biology, ecology, review, Paratendipes albimanus', 'article'),
(483, 'Mackey 1977', '', 'Mac1977', 'Mackey, A. P.', 1977, NULL, NULL, NULL, NULL, NULL, 'Growth and development of larval Chironomidae', 'Oikos', NULL, '28', NULL, '270-275', NULL, NULL, 'cited from {citeID|482|Pinder 1986}', 'larval developement, Cricotopus bicinctus', 'article'),
(484, 'Hirabayashi and Wotton 1999', '', 'Hir1999', 'Hirabayashi, K. and Wotton, R. S.', 1999, NULL, NULL, NULL, NULL, NULL, 'Organic matter processing by chironomid larvae (Diptera: Chironomidae)', 'Hydrobiologia', NULL, '382', NULL, '151-159', NULL, 'In laboratory experiments, we used ﬂuorescent dye markers to investigate processing of organic matter by larvae of Psectrocladius limbatellus (Holm.) (Diptera: Chironomidae). 59% of the organic matter used was incorporated into tubes, 39% was present in faecal pellets (both after 24 h), and 2% was found in the larval gut at the end of experiments. Ingested matter passed through the gut rapidly, resulting in the gut being emptied more than 20 times each day. Further 24-h experiments using dye-marked faecal pellets showed that 6% of pellets produced were reingested and 12% were incorporated into tubes. There was no preference for conditioned faecal pellets as food over those that had recently been egested and tubes also provided a food reserve on which larvae feed. Chironomid larvae recycle organic matter resulting in its mineralization and their ‘engineering’ has a dramatic effect on the substratum.', NULL, 'Cricotopus bicinctus, Psectrocladius limbatellus', 'article'),
(485, 'Wiley and Warren 1992', '', 'Wil1992', 'Wiley, M. J. and Warren, G. L.', 1992, NULL, NULL, NULL, NULL, NULL, 'Territory abandonment, theft, and recycling by a lotic grazed: a foraging strategy for hard times', 'Oikos', NULL, '63', NULL, '495–505', NULL, NULL, 'cited from {citeID|484|Hirabayashi and Wotton 1999}', 'ecology, lifecycle', 'article'),
(486, 'Lawton and Jones 1995', '', 'Law1995', 'Lawton, J. H. and Jones, C. G.', 1995, NULL, NULL, 'Jones C. G. and Lawton, J. H.', NULL, 'Chapman & Hall, London', 'Linking species and ecosystems: organisms as ecosystem engineers', 'In: Linking Species and Ecosystems', NULL, NULL, NULL, '141–150', NULL, NULL, NULL, 'ecology, ecosystem engineering', 'incollection'),
(487, 'Langton and Jesús 1999', '', 'Lan1999', 'Langton, Peter H. and Jesús, C.', 1999, NULL, NULL, NULL, NULL, NULL, 'Changes in chironomid assemblage composition in two Mediterranean mountain streams over a period of extreme hydrological conditions', 'Hydrobiologia', NULL, '390', NULL, '37-49', NULL, 'An opportunity to test Coffman’s (1989) proposal that ecological heterogeneity is one of the main factors for chironomid species richness occurred when prolonged drought in southern Spain was broken by heavy rain. Chironomid assemblage composition was studied in two Mediterranean mountain ﬁrst-order streams, one permanent and the other temporary. Samples were collected in the permanent stream over extreme hydrological conditions: 1991–95 with relatively low and stable ﬂow, and 1996–97 with relatively high and unstable ﬂow. The temporary\r\nstream ﬂowed, and therefore was sampled, only during the second period. In the permanent stream, spate events resulted in a notable increase in species richness due to the arrival of 32 species and to the permanence of 81% of the species resident over the prespate period. This relatively high percentage suggests that chironomids, as a group, have important resilience properties. However, some species disappeared from the permanent stream after the spates and the considerable decrease in abundance of other species, shows that, at the species level, resilience may vary greatly within the Chironomidae. Most of the species that appeared in the temporary stream were the\r\nsame as those of the permanent stream during the fast ﬂow period despite the great ecological differences between the two streams under study, suggesting the key role of discharge in structuring chironomid assemblages. The outstanding exception was the fugitive species Orthocladius calvus, the most abundant species in the temporary stream during the initial successional stages but never collected in the permanent stream.', NULL, 'Ablabesmyia longistyla, Ablabesmyia monilis, Boreoheptagyia monticola, Brillia flavifrons, Brillia modesta, Bryophaenocladius muscicola, Cardiocladius fuscus, Chaetocladius algericus, Chaetocladius melaleucus, Chaetocladius perennis, Chironomidae: stream ecology, Chironomus riparius, Cladotanytarsus pallidus, Cladotanytarsus vanderwulpi, Conchapelopia pallidula, Corynoneura celtica, Corynoneura fittkaui, Corynoneura gratias, Corynoneura lacustris, Corynoneura lobata, Cricotopus annulator, Cricotopus beckeri, Cricotopus bicinctus, Cricotopus levantinus, Cricotopus Pe 16, Cricotopus similis, Demicryptochironomus vulneratus, Diamesa aberrata, Diamesa bertrami, Diamesa insignipes, Diamesa veletensis, discharge ﬂuctuations, Eukiefferiella brehmi, Eukiefferiella claripennis, Eukiefferiella clypeata, Eukiefferiella coerulescens, Eukiefferiella cyanea, Eukiefferiella devonica, Eukiefferiella lobifera, Eukiefferiella minor/fittkaui, Eukiefferiella similis, Eukiefferiella tirolensis, Europe: Spain, Heleniella ornaticollis, Heleniella serratosioi, Hydrobaenus distylus, Krenosmittia camptophleps, Krenosmittia halvorseni, Larsia curticalcar, Limnophyes edwarsi, Limnophyes ninae, Limnophyes pentaplastus, Limnophyes punctipennis, Limnophyes spp., Lithotanytarsus dadesi, Macropelopia nebulosa, Mediterranean mountain streams, Micropsectra atrofasciata, Micropsectra bidentata, Micropsectra junci, Micropsectra lindrothi, Microtendipes Pe 1, Microtendipes rydalensis, Nanocladius rectinervis, Nilotanypus dubius, Odontomesa fulva, Orthocladiinae gen.? sp.? Pe1, Orthocladiinaegen.? sp.? Pe1, Orthocladius (Eud.) fuscimanus, Orthocladius (Euorthocladius) calvus, Orthocladius (Euorthocladius) luteipes, Orthocladius (Euorthocladius) rivicola, Orthocladius (Euorthocladius) rivulorum, Orthocladius (Euorthocladius) thienemanni, Orthocladius (O.) pedestris, Orthocladius (O.) rubicundus, Orthocladius (O.) ruffoi, Paracladopelma laminata, Paracladopelma mikiana, Paracladopelma nigritula, Paracricotopus niger, Paracricotopus sp. 1, Parakiefferiella wuelkeri, Paramerina cingulata, Paramerina divisa, Parametriocnemus Pe 1, Parametriocnemus Pe 4, Parametriocnemus sp. 1, Parametriocnemus stylatus, Paraphaenocladius pseudoirritus, Paratanytarsus lauterborni, Paratendipes albimanus, Paratendipes Pe 1, Paratrichocladius micans, Paratrichocladius rufiventris, Paratrissocladius excerptus, Phaenopsectra Pe 1, Polypedilum (Pol.) convictum, Polypedilum (Pol.) cultellatum, Polypedilum (Pol.) laetum, Polypedilum (Pol.) nubeculosum, Polypedilum (T.) scalaenum/quad., Polypedilum sp. 1, Potthastia gaedii, Procladius choreus, Prodiamesa olivacea, Prodiamesinae, PRODIAMESINAE, Psectrocladius obvius, Pseudorthocladius filiformis, Pseudosmittia recta, Rheocricotopus (Psil.) atripes, Rheocricotopus (Psil.) chalybeatus, Rheocricotopus (Psil.) effusus, Rheocricotopus (Psil.) glabricollis, Rheocricotopus (Psil.) tirolus, Rheopelopia maculipennis, Rheotanytarsus pentapoda, Rheotanytarsus reissi, Rheotanytarsus rhenanus, Stempellina bausei, stream: permanent-temporary, stream ecology, Sympotthastia zavreli, Synorthocladius semivirens, Tanytarsus brundini, Tanytarsus ejuncidus, Tanytarsus heusdensis, Thienemanniella acuticornis, Thienemanniella Pe 1b, Thienemanniella Pe 2a, Thienemannimyia fusciceps, Thienemannimyia laeta, Trissopelopia longimana, Tvetenia calvescens, Tvetenia verralli, Virgatanytarsus Pe 1, Zavrelimyia barbatipes', 'article'),
(503, 'Walker et al. 1995', '', 'Wal1995', 'Walker, I. R., Wilson, S. E. and Smol, J. P.', 1995, NULL, NULL, NULL, NULL, NULL, 'Chironomidae (Diptera): quantitative palaeosalinity indicators for lakes of western Canada', 'Canadian Journal of Fisheries and Aquatic Sciences (Can J Fish Aquat Sci)', NULL, '52', NULL, '950-960', NULL, NULL, 'cited from {citeID|502|Zhang et al. 2007}', 'America: Canada, palaeosalinity, salinity', 'article'),
(488, 'Kravtsova 2007', '', 'Kra2007', 'Kravtsova, L.', 2007, NULL, NULL, NULL, NULL, NULL, 'Chironomid communities in the littoral zone on the western coast of the southern Baikal basin (structure, distribution, seasona dynamics)', 'CHIRONOMUS Newsletter on Chironomidae Research', NULL, NULL, '20', '24-29', 'November', 'The spatial distribution of chironomid communities in the littoral zone (0-20 m) of the western coast of the southern Baikal basin is investigated. The fauna is composed of 16 species and forms of chironomid larvae, comprising 10 communities. It has been found that the communities are characterized by rather poor species diversity; Shannon’s index varies from 0.7 to 2.1 bit. Their distribution is affected by hydro-lithodynamic conditions, type of bottom sediments and macrophyte development. The peak of maximal biomass of chironomid larvae on the facies of non-rounded rock debris near Berezovy Cape is recorded in spring.', 'ISSN 0172-1941', 'Lake Baikal, Baikal, Orthocladius gr. thienemanni, Orthocladius gr. olivaceus, Orthocladius frigidus, Orthocladius nitidoscutellatus, Cricotopus bicinctus, Paratanytarsus baicalensis, Sergentia baicalensis, Sergentia nebulosa, Sergentia sp., Bolshye Koty Bay (Baikal), littoral zone, community structure, diversity measure', 'article'),
(489, 'Rossaro et al. 2006', '', 'Ros2006', 'Rossaro, B.,  Lencioni, V., Boggero, A. and Marziali, L.', 2006, NULL, NULL, NULL, NULL, NULL, 'Chironomids from southern Alpine running waters: ecology, biogeography', 'Hydrobiologia', NULL, '562', '1', '231-246', NULL, 'The chironomid fauna living in running waters in the Southern Alps was investigated from an ecological and biogeographical point of view: 202 species were identified (not including terrestrial species). It must be emphasised that species identification is tentative within some genera, especially those awaiting revision (e.g., Boreoheptagyia, Chaetocladius). Although much taxonomic work was done in the past on the chironomid Alpine fauna, there are still many unsolved problems. Most of the species found are widespread in the Palearctic Region, with no evidence of bio-geographical barriers separating different Alpine sectors. Really a relatively high number of species reported from the northern and western side (France, Switzerland, Austria) of the Alps was not captured on the southern side (Italy), whereas most species found on the southern side are also present on the northern one. Very few species are reported from southern side only. Lack of sampling, imperfect taxonomic knowledge and different environmental conditions between the northern and southern sides may be responsible of this result. A comparison of the fauna of the southern Alps with the fauna of the Apennines suggests that the differences are probably more related to ecological conditions (lack of glaciers in the Apennines) than to biogeographical barriers. Different chironomid assemblages colonise manifold habitat types: strict cold-stenothermal species tolerating high current velocity (e.g., Diamesa latitarsis steinboecki group) are almost the sole inhabitants of kryal biotopes, while other cold-stenothermal species are restricted to cold springs (Diamesa dampfi, D. incallida, Tokunagaia rectangularis, T. tonollii), there are also species characteristic of hygropetric habitats (Syndiamesa edwardsi, S. nigra) or restricted to lacustrine habitats (Corynoneura lacustris, Paratanytarsus austriacus). It must be emphasised that different responses to environmental factors can be observed between species belonging to the same genus (e.g., Diamesa, Eukiefferiella, Orthocladius , Paratrichocladius), so species identification is really needed for a good ecological work. Water temperature, current velocity, substrate type are the most critical factors, sometime chironomid species appear to be rather opportunistic and their presence or absence cannot be clearly related to a well defined range of values of environmental variables: be it a lack of knowledge or a real datum will be the task of future studies. The waters of the Alps are still relatively unpolluted, but hydraulic stress due to river damming and canalization is a serious problem for macrofauna conservation, and as the glaciers retreat, the species confined to the glacial snouts are at risk of extinction, some of them possibly even before their existence be discovered.\r\n', NULL, 'Allopsectrocladius obvius, Alps, Arctopelopia griseipennis, biogeography, Boreoheptagyia legeri, Boreoheptagyia rugosa, Boreoheptagyia sp. 3, Brillia bifida, Brillia longifurca, Cardiocladius capucinus, Cardiocladius fuscus, Chaetocladius acuticornis, Chaetocladius dentiforceps, Chaetocladius dissipatus, Chaetocladius gelidus, Chaetocladius laminatus, Chaetocladius maeaeri, Chaetocladius melaleucus, Chaetocladius perennis, Chaetocladius sp., Chaetocladius suecicus, Chaetocladius vitellinus, Chironomus plumosus, Chironomus riparius, Cladopelma edwardsi, Cladotanytarsus atridorsum, Conchapelopia pallidula, conductivity, Corynoneura edwardsi, Corynoneura fittkaui, Corynoneura lacustris, Corynoneura lobata, Corynoneura scutellata, Cricotopus algarum, Cricotopus annulator, Cricotopus bicinctus, Cricotopus curtus, Cricotopus fuscus, Cricotopus pulchripes, Cricotopus tibialis, Cricotopus tremulus, Cricotopus triannulatus, Cricotopus trifascia, Cricotopus tristis, Cryptochironomus albofasciatus, Diamesa aberrata, Diamesa bertrami, Diamesa cinerella, Diamesa dampfi, Diamesa goetghebueri, Diamesa incallida, Diamesa laticauda, Diamesa latitarsis, Diamesa lindrothi, Diamesa longipes, Diamesa permacra, Diamesa steinboecki, Diamesa tonsa, Diamesa vaillanti, Diamesa zernyi, Diamesa zernyi Edwards, Dicrotendipes lobiger, Diplocladius cultriger, ecology, Einfeldia longipes, Epoicocladius flavens, Eudactylocladius fuscimanus, Eudactylocladius gelidus, Eudactylocladius olivaceus, Eukiefferiella brevicalcar, Eukiefferiella claripennis, Eukiefferiella clypeata, Eukiefferiella coerulescens, Eukiefferiella cyanea, Eukiefferiella devonica, Eukiefferiella dittmari, Eukiefferiella fittkaui, Eukiefferiella fuldensis, Eukiefferiella gracei, Eukiefferiella ilkleyensis, Eukiefferiella lobifera, Eukiefferiella minor, Eukiefferiella pseudomontana, Eukiefferiella tirolensis, Euorthocladius ashei, Euorthocladius luteipes, Euorthocladius rivicola, Euorthocladius rivulorum, Euorthocladius saxosus, Euorthocladius thienemanni, Eurthocladius frigidus, habitat structure, Harnischia fuscimana, Heleniella serra-tosioi, Heleniella serratosio, Heterotanytarsus apicalis, Heterotanytarsus sp. A, Heterotrissocladius marcidus, Hydrobaenus distylus, Isocladius glacialis, Isocladius intersectus, Isocladius sylvestris, Krenopelopia binotata, Krenopsectra fallax, Krenosmittia boreoalpina, Krenosmittia camptophleps, Krenosmittia sp A cfr hispanica, Macropelopia fittkaui, Macropelopia nebulosa, Metriocnemus hirticollis, Metriocnemus hygropetricus, Microchironomus tener, Micropsectra atrofasciata, Micropsectra attenuata, Micropsectra bidentata, Micropsectra contracta, Micropsectra lindrothi, Micropsectra notescens, Micropsectra radialis, Microtendipes chloris, Microtendipes pedellus, Nanocladius bicolor, Nanocladius rectinervis, Neozavrelia fuldensis, Nilotanypus dubius, Orthocladius excavatus, Orthocladius frigidus, Orthocladius oblidens, Orthocladius rhyacobius, Orthocladius rubicundus, Orthocladius ruffoi, Orthocladius vaillanti, Orthocladius wetterensis, Pagastia partica, Parachaetocladius abnobaenus, Paracladius alpicola, Paracladius conversus, Paracladopelma camptolabis, Paracricotopus niger, Parakiefferiella bathophila, Parakiefferiella gracillima, Paramerina cingulata, Parametriocnemus boreoalpinus, Parametriocnemus stylatus, Parapsectra nana, Paratanytarsus austriacus, Paratanytarsus natvigi, Paratendipes nudisquama, Paratrichocladius nivalis, Paratrichocladius rufiventris, Paratrichocladius skirwithensis, Parorthocladius nudipennis, pH, Phaenopsectra flavipes, Polypedilum albicorne, Polypedilum convictum, Polypedilum laetum, Polypedilum nubeculosum, Potthastia gaedii, Potthastia longimanus, Procladius choreus, Prodiamesa olivacea, Psectrocladius limbatellus, Psectrocladius octomaculatus, Psectrocladius psilopterus, Psectrocladius schlienzi, Psectrocladius sordidellus, Pseudodiamesa branickii, Pseudodiamesa nivosa, Pseudokiefferiella parva, Rheocricotopus atripes, Rheocricotopus chalybeatus, Rheocricotopus effusus, Rheocricotopus fuscipes, Rheocricotopus gallicus, Rheocricotopus glabricollis, Rheopelopia ornata, Rheotanytarsus photophilus, Smittia, Stilocladius montanus, Symposiocladius lignicola, Sympotthastia spinifera, Syndiamesa edwardsi, Syndiamesa nigra, Synorthocladius semivirens, Tanytarsus bathophilus, Tanytarsus fimbriatus, Tanytarsus gracilentus, Tanytarsus lestagei, Tanytarsus lugens, Tanytarsus nemorosus, Telmatopelopia nemorum, Telopelopia fascigera, Thienemaniella clavicornis, Thienemaniella morosa, Thienemaniella partita, Thienemanniella partita, Thienemannimyia carnea, Thienemannimyia woodi, Tokunagaia rectangularis, Tokunagaia tonollii, Tribelos dispar, Tripodura scalaenum, Trissopelopia longimana, Tvetenia bavarica, Tvetenia calvescens, Tvetenia discoloripes, Tvetenia verralli, Xenopelopia falcigera, Zalutschia tatrica, Zavrelimyia barbatipes, Zavrelimyia hirtimana, Zavrelimyia melanura, Zavrelimyia nubila, Zavrelimyia punctatissima', 'article'),
(502, 'Zhang et al. 2007', '', 'Zha2007', 'Zhang, E., Jones, R., Bedford, A., Langton, P. H. and Tang, H.', 2007, NULL, NULL, NULL, NULL, NULL, 'A chironomid-based salinity inference model from lakes on the Tibetan Plateau', 'Journal of Paleolimnology', 'http://dx.doi.org/10.1007/s10933-006-9080-z', '38', '4', '477-491', NULL, 'Previous studies have shown chironomids to be excellent indicators of environmental change and training sets have been developed in order to allow these changes to be reconstructed quantitatively from subfossil sequences. Here we present the results of an investigation into the relationships between surface sediment subfossil chironomid distribution and lake environmental variables from 42 lakes on the Tibetan Plateau. Canonical correspondence analysis (CCA) revealed that of the 11 measured environmental variables, salinity (measured as total dissolved solids TDS) was most important, accounting for 10.5\\% of the variance in the chironomid data. This variable was significant enough to allow the development of quantitative inference models. A range of TDS inference models were developed using Weighted Averaging (WA), Partial Least Squares (PLS), Weighted Averaging-Partial Least Squares (WA-PLS), Maximum Likelihood (ML), Modern Analogues Technique (MAT) and Modern Analogues Techniques weighted by similarity (WMAT). Evaluation of the site data indicated that four lakes were major outliers, and after omitting these from the training set the models produced jack-knifed coefficients of determination (r 2) between 0.60 and 0.80, and root-mean-squared errors of prediction (RMSEP) between 0.29 and 0.44 log10 TDS. The best performing model was the two-component WA-PLS model with r 2 jack = 0.80 and RMSEPjack = 0.29 log10 TDS. The model results were similar to other chironomid-salinity models developed in different regions, and they also showed similar ecological groupings along the salinity gradient with respect to freshwater/salinity thresholds and community diversity. These results therefore indicate that similar processes may be controlling chironomid distribution across salinity gradients irrespective of biogeographical constraints. The performance of the transfer functions illustrates that chironomid assemblages from the Tibetan Plateau lakes are clearly sensitive indicators of salinity. The models will therefore allow the quantification of long-term records of past water salinity for lacustrine sites across the Tibetan Plateau, which has important implications for future hydrological research in the region.', NULL, 'Ablabesmyia, assemblages, Chironomidae, Chironomus dorsalis, Chironomus spp., Cladotanytarsus mancus-type, climate change, Corynocera oliveri, Corynoneura lacustris type, Cricotopus sylvestris-type, Cryptochironomus, diatoms, Diptera, environmental changes, Euryhapsis, fossil midges, Glyptotendipes, hydrological balance, indication Chironomidae, inference models, lakes, Nanocladius, Orthocladius/Cricotopus, paleosalinity, Paracladius, Paratanytarsus, PLS, Polypedilum, Procladius, progress, Psectrocladius barbimanus type, Psectrocladius calcaratus type, Psectrocladius sordidellus type, Psectrocladius sp3, quantitative reconstruction, Rheocricotopus, salinity, Tanytarsus spp., tibetan plateau, total dissolved salts (tds), transfer functions, WA-PLS, Zalutschia', 'article'),
(490, 'Wolf et al. 2009', '', 'Wol2009', 'Wolf, B., Kiel, E., Hagge, A., Krieg, H.-J. and Feld, C.', 2009, NULL, NULL, NULL, NULL, NULL, 'Using the salinity preferences of benthic macroinvertebrates to classify running waters in brackish marshes in Germany', 'Ecological Indicators', NULL, '9', '5', '837-847', NULL, 'Marshland streams along European coastlines are typically located in the transition zone from limnic to brackish conditions. They constitute a distinct and important stream type within the German stream typology, which is predominantly characterised by tidal influence and salinity. According to the Water Framework Directive (WFD) the basis for the abiotic classification of European transitional and coastal waters is the ’Venice System’ (Weber, M., 2005. Ergebnisse der Bestandsaufnahme 2004 zur Umsetzung der europäischen Wasserrahmenrichtlinie (WRRL) in den Küstengewässern Mecklenburg-Vorpommerns. Rostocker Meeresbiol. Beitr. 14, 7-15). However, the extreme spatial and temporal variability in salinity and tidal influence determines and controls the macroinvertebrate communities of marshland river and stream ecosystems and hampers the application of the ’Venice System’. Earlier, purely biotic classifications of brackish waters typically classify different brackish water zones, each with a specific macroinvertebrate community, and often yield unsatisfactory results due to the extensively dynamic abiotic factors found in marshland streams. In practice, the permanent impact of tidal charge means that stable salinity zones do not exist. This effect can than be intensified by freshwater discharges after heavy rainfall or high tides in combination with strong winds that hinder discharge into the open sea. To overcome the restricted applicability of abiotic and biotic classification systems, we present a scoring system for marshland streams that combines the abiotic salinity classes of the ’Venice System’ with the salinity preferences of the macroinvertebrate community. This proposal is based on literature data for macroinvertebrate salinity tolerances and preferences. According to the 137 references that were evaluated, 151 macroinvertebrate taxa were classified into six salinity groups. In a second step, we applied this scoring scheme to empirical data from two official quality assessment surveys. These surveys had been carried out in ten estuary tributaries of German marshland areas in Lower Saxony and Schleswig-Holstein in order to implement the WFD. Applying the scoring system to these data revealed a clear (and expected) gradient that was not expressed in the abiotic data. Thus we conclude that the biotic salinity preferences of benthic macroinvertebrates are a useful baseline metric for the ecological assessment of marshland streams and other transitional waters. Regional revision and adaptation of taxonomic salinity preferences would broaden the applicability of this assessment to transitional waters worldwide.', NULL, 'Ablabesmyia monilis/phatta, Amphichaeta leydigii, Amphichaeta sannio, Apocorophium lacustre, Apsectrotanypus trifascipennis, Arctopelopia sp., Asellus aquaticus, Aulodrilus pluriseta, Baetis sp., Bathyporeia sp., Bithynia tentaculata, Branchiura sowerbyi, Brillia ﬂavifrons, Caenis horaria, Caenis pseudorivulorum, Centroptilum luteolum, Ceratopogonidae Gen. sp., Chaetocladius sp., Chaetogaster diaphanus, Chaetogaster diastrophus, Chaetogaster setosus, Chaoborus sp., Chelicocorophium curvispinum, Chironominae Gen. sp., Chironomini Gen. sp., Chironomus bernensis, Chironomus nudiventris, Chironomus plumosus-Gr., Chironomus plumosus group, Chironomus sp., Cladotanytarsus sp., Classification system, Cloeon dipterum, Cloeon simile, Clunio marinus, Conchapelopia melanops, Conchapelopia sp., Corbicula ﬂuminea, Cordylophora caspia, Corixidae Gen. sp., Corophium multisetosum, Corophium volutator, Corynoneura sp., Crangon crangon, Cricotopus bicinctus, Cricotopus sp., Cricotopus sylvestris-Gr., Cricotopus sylvestris group, Cricotopus tremulus-Gr., Cricotopus tremulus group, Cryptochironomus sp., Dero sp., Dicrotendipes nervosus, Dicrotendipes sp., Dreissena polymorpha, Ecnomus tenellus, Einfeldia carbonaria, Eiseniella tetraedra, Enchytraeidae Gen. sp., Enchytraeus albidus, Enchytraeus buchholzii, Enchytraeus sp., Endochironomus sp., Eriocheir sinensis, Erpobdella octoculata, Gammarus sp., Gammarus tigrinus, Gammarus zaddachi, Glyptotendipes barbipes, Glyptotendipes pallens, Glyptotendipes sp., Gyraulus albus, Harnischia curtilamellata, Harnischia sp., Helobdella stagnalis, Helophorus granularis Ad., Helophorus minutus, Helophorus sp. Ad., Heptagenia sulphurea, Heterochaeta costata, Heterotrissocladius marcidus, Hyalinella punctata, Hydrachnidia Gen. sp., Hydraena palustris Ad., Hydraena testacea Ad., Hydra sp., Hydropsyche bulgaromanorum, Hydropsyche contubernalis, Hydropsyche incognita, Hydroptila sp., Ilybius sp. Lv., Ilyodrilus templetoni, Isoperla sp., Leuctra nigra, Limnephilus decipiens, Limnodrilus claparedeanus, Limnodrilus hoffmeisteri, Limnodrilus sp., Limnodrilus udekemianus, Limnophyes sp., Lumbricillus lineatus, Lumbriculus variegatus, Lymnaeidae Gen. sp., Macrozoobenthos, Manayunkia aestuarina, Marenzelleria viridis, Marionina argentea, Marshland streams, Microchironomus sp., Microchironomus tener, Micropsectra sp., Microtendipes pedellus-Gr., Microtendipes pedellus group, Monodiamesa sp., Monopelopia sp., Mysidae Gen. sp., Mystacides azurea, Mystacides longicornis/nigra, Nais alpina, Nais bretscheri, Nais communis/variabilis, Nais elinguis, Nais pardalis, Nais sp., Nanocladius sp., Natarsia punctata, Neomysis integer, Nereis diversicolor, Nereis sp., Niphargus cf. fontanus, Odontomesa fulva, Ophidonais serpentina, Orthocladiinae Gen. sp., Orthocladius sp., Oulimnius sp. Lv., Palaemonetes longirostris, Paludicella sp., Parachaetocladius sp., Parachironomus arcuatus-Gr., Parachironomus frequens-Gr., Parachironomus varus, Paracladopelma laminata-Agg., Paraleptophlebia submarginata, Paraleptophlebia werneri, Paralimnophyes hydrophilus, Paranais frici, Paranais litoralis, Paratanytarsus austriacus, Paratanytarsus sp., Paratendipes sp., Phaenopsectra sp., Physa fontinalis, Piscicola geometra, Pisidium sp., Polycentropus ﬂavomaculatus, Polychaeta Gen. sp., Polypedilum albicorne, Polypedilum bicrenatum, Polypedilum cultellatum, Polypedilum nubeculosum, Polypedilum scalaenum-Gr., Polypedilum sordens-Gr., Polypedilum sp., Potamopyrgus antipodarum, Potamothrix hammoniensis, Potamothrix moldaviensis, Potamothrix sp., Potamothrix vejdovskyi, Potthastia longimana-Gr., Pristina longiseta, Pristina rosea, Pristinella sp., Proasellus coxalis, Procladius sp., Prodiamesa olivacea, Propappus volki, Psammoryctides barbatus, Psectrotanypus varius, Pseudochironomus sp., Radix balthica, Rheocricotopus sp., Rheotanytarsus sp., Saetheria sp., salinity, Salinity preferences, Sialis sp., Sigara falleni, Sigara iactans, Sigara lateralis, Sigara semistriata, Sigara striata, Simuliidae Gen. sp., Slavina appendiculata, Specaria josinae, Sphaerium sp., Spionidae Gen. sp., Spirosperma sp., Stagnicola sp., Stempellinella sp., Stictochironomus sp., Stylaria lacustris, Synorthocladius sp., Tanypodinae Gen. sp., Tanypus sp., Tanytarsini Gen. sp., Tanytarsus pallidicornis-Gr., Tanytarsus sp., Telmatoscopus sp., Thalassosmittia sp., Thienemanniella sp., Thienemannimyia sp., Tubiﬁcidae Gen. sp., Tubiﬁcoides benedii, Tubifex ignotus, Tubifex pseudogaster, Tubifex sp., Tubifex tubifex, Turbellaria Gen. sp., Uncinais uncinata, Vejdovskyella comata, Xenopelopia sp., Zavrelimyia sp., Zygoptera Gen. sp.', 'article'),
(491, 'Bisthoven and Gerhardt 2003', '', 'Bis2003', 'Bisthoven, L. J. de and Gerhardt, A.', 2003, NULL, NULL, NULL, NULL, NULL, 'Chironomidae (Diptera, Nematocera) fauna in three small streams of Skania, Sweden', 'Environmental Monitoring and Assessmen', NULL, NULL, '83', '89-102', NULL, 'Two unpolluted streams and one chemically and thermally polluted stream in Skania, Sweden, were investigated in summer 1995 for their temporary chironomid fauna and the occurrence of buccal deformities. The unpolluted streams ’Övedsan’ and ’Skäralidbäcken’ each contained, respectively, 13 and 16 taxa, with a dominance of Microtendipes pedellus group and Micropsectra spp., respectively. Most taxa were found in the pebbles and the submerged vegetation. Deformities were insignificant. The degraded stream Ybbarpsan in Perstorp contained 5 taxa, dominated by Procladius choreus. This species had 14% deformed larvae, interpreted as an effect of the chemical pollution. Shannon H and equitability J reflected the differences in chironomid community structure between the two unpolluted and the polluted sites. The Belgian Biotic Index scored maximally ’10’ in Skäralid, however only ’6’ in Öved and ’5’ in Perstorp. The combination of rapid assessment of macrobenthos and description of communities of Chironomidae, with mention of deformed larvae, adds a bonus of information about the temporary state of a stream.', NULL, 'biomonitoring, Chironomidae: deformities, community, eutrophication, pollution, Procladius, stream pollution, Sweden', 'article');
INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(492, 'Brodersen et al. 2004', '', 'Bro2004', 'Brodersen, K. P., Pedersen, O., Lindegaard, C. and Hamburger, K.', 2004, NULL, NULL, NULL, NULL, NULL, 'Chironomids (Diptera) and oxy-regulatory capacity: an experimental approach to paleolimnological interpretation', 'Limnology and Oceanography', NULL, '49', '5', '1549-1559', NULL, 'We measured the ability to regulate oxygen uptake of 16 chironomid taxa from lakes in low-arctic West Greenland by means of oxygen microelectrodes in custom-made respiration chambers. The respiration patterns were modeled using piecewise linear regression with break-point and simple hyperbolic functions. The mathematical constants obtained from the controlled laboratory experiments were good ecophysiological indicators of species-specific “oxyregulatory capacity.” The oxy-regulatory capacity of different chironomid communities was calculated for subfossil assemblages collected from 52 lakes in West Greenland. The overall assemblage structure was expressed using detrended correspondence analysis (DCA). The oxy-regulatory capacity was as strongly correlated to DCA axis 1 (r = 0.72-0.86, p < 0.001), as were surface water temperature (r = 0.82, p < 0.001) and nutrients (r < 0.47-0.86, p < 0.001). Warm-water chironomid assemblages characterized by taxa such as Chironomus, Dicrotendipes, Ablabesmyia, and Procladius had a high oxy-regulatory capacity. Cold-water assemblages were dominated by oxyconformers such as Heterotrissocladius, Micropsectra, Hydrobaenus, and Diamesa. An expression of the oxyregulatory capacity of a given chironomid assemblage can be directly inferred from a simple model using weighted averaging of the ecophysiological mathematical constants. The autecological information from controlled experiments provides important additional information for interpretations in chironomid paleolimnology. The results can also be used to identify secondary changes or mismatches in multiproxy down-core paleoclimate studies.', 'Journal abbreviation was actually ''Limnol. Oceanogr.''', 'Ablabesmyla pulchripennis (Lundbeck 1898), Chironomidae: area, Chironomidae: conductivity, Chironomidae: depth, Chironomidae: oxygen, Chironomidae: temperature, Chironomidae: temperature experiments, Chironomus cf. riparius, Chironomus cf. riparius Meigen 1804, Chironomus hyperboreus, Chironomus hyperboreus Staeger 1845, conductivity, depth, Diamesa spp., Dircrotendipes cf. modestus, Dircrotendipes cf. modestus (Say 1823), experiments: Chironomidae, Heterotrissocladius cf. oliveri, Heterotrissocladius cf. oliveri Saether 1975, Heterotrissocladius marcidus group, Hydrobaenus fusistylus, Hydrobaenus fusistylus (Goetghebuer 1933), lake area, Lumbriculus variegatus (Muller 1774), Micropsectra sp., oxygen experiments, paleolimnological interpretation, Paracladopelma sp., Procladius paragretis, Procladius paragretis Roback 1971, Psectrocladius barbimanus, Psectrocladius sordidellus/limbatellus group, Psectrocladius sp., Tanytarsus gracilentus, Tanytarsus sp., temperature, Uncinais uncinata (Ørstedt 1842)', 'article'),
(493, 'Einarsson et al. 2002', '', 'Ein2002', 'Einarsson, A., Gardarsson, A., Gislason, G. M. and Ives, A. R.', 2002, NULL, NULL, NULL, NULL, NULL, 'Consumer-resource interactions and cyclic population dynamics of <em>Tanytarsus gracilentus</em> (Diptera: Chironomidae)', 'J. Animal Ecol.', NULL, '71', NULL, '832-845', NULL, NULL, 'cited from {citeID|492|Brodersen et al. 2004}', 'autecology, ecology, Tanytarsus gracilentus', 'article'),
(494, 'Brodersen and Anderson 2002', '', 'Bro2002', 'Brodersen, K. P. and Anderson, N. J.', 2002, NULL, NULL, NULL, NULL, NULL, 'Distribution of chironomids (Diptera) in low arctic West Greenland lakes: Trophic conditions, temperature and environmental reconstruction', 'Freshw. Biol.', NULL, '47', NULL, '1137-1157', NULL, NULL, 'cited from {citeID|492|Brodersen et al. 2004}', 'ecology, environmental reconstruction, low arctic lakes, temperature, trophic conditions, West Greenland', 'article'),
(495, 'Ingvason et al. 2006', '', 'Ing2006', 'Ingvason, H. R., Olafsson, J. S., Gardarsson, A. and Jonsdottir, R.', 2006, NULL, NULL, NULL, NULL, NULL, 'Diapause and fat condition of <em>Tanytarsus gracilentus</em> larvae in a sub-arctzic lake', 'Verh. int. Verein. theor. angew. Limnol.', NULL, '29', NULL, '1316-1320', NULL, NULL, 'cited from {citeID|496|Hoffrichter 2007}', 'subarctic lakes, Tanytarsus gracilentus', 'article'),
(496, 'Hoffrichter 2007', '', 'Hof2007', 'Hoffrichter, O.', 2007, NULL, NULL, NULL, NULL, NULL, 'Current bibliography: 1 Jan. 2006 - 30 Sep. 2007', 'CHIRONOMUS Newsletter on Chironomidae Research', NULL, '20', NULL, NULL, NULL, 'This listing is different from what has been presented in earlier issues: In order to justify the epithet ”current”,\r\nand due to the fact that nearly 300 titles for 2007 are already saved, all of the most actual titles hitherto collected\r\nare listed, preceded by the - hopefully almost complete - year 2006 and by supplements to the two preceding\r\nyears. The compilation was achieved, as usual, from many sources: databases, tables of contents of journals,\r\nreferences and citations of papers, autopsy of many periodicals, lists provided by authors (thanks to you!). In\r\nparticular, publisher issued search alerts proved to be rich in results. Only printed titles are reported here with the\r\noccasional exception of online-only journals (PLoS or BioMed journals e.g.). Titles announced, even with\r\navailable DOI numbers, are not considered before printing. In general, online publications should be retrieved\r\nelsewhere, best check the chironomid home page for eventual references regularly.', 'ISSN 0172-1941', 'bibliography lists', 'article'),
(497, 'Ólafsson et al. 2003', '', 'Oac2003', 'Ólafsson, J. S., Einarsson, A., Gardarsson, A., Halldórsdóttir, A.  and Snorrason, S, S.', 2003, NULL, NULL, 'Ferrington, Leonard C. Jr.', NULL, NULL, 'Chironomid larve and the green algae Cladophorales; a tale from a sub-arctic lake', 'In: XV International Symposion on Chironomidae, University Minesota (Abstracts)', NULL, NULL, NULL, '57', NULL, 'The chironomid, Tanytarsus gracilentus and Chironomus islandicus are among the most\r\nabundant macroinvertebrate in Lake Mývatn, northern Iceland. These species as well as\r\nsome Orthocladiinae and Tanypodinae species comprise the bulk of the lake benthos.\r\nTwo species of the green algae, Cladophorales, Aegagropila linnae and Cladophora\r\nglomerata characterise the benthos to a great extent in this shallow lake.\r\nBoth chironomids and algae show severe fluctuation in abundance and distribution\r\nbetween years. The distribution of the green algae is most prominent within the west\r\nand the south-west areas of the lake, at a depth of 2 - 3.5 m. The aim of this\r\npresentation is to demonstrate the spatial distribution of chironomid larvae in relations to\r\nthe characteristics of the various benthic habitats though with special reference to the\r\ngreen algae.', NULL, 'Aegagropila linnae, Chironomus islandicus, Cladophora glomerata, Cladophorales, Island, Tanytarsus gracilentus', 'inproceedings'),
(498, 'Gardarsson et al. 2004', '', 'Gar2004', 'Gardarsson, A., Einarsson, Á., Gíslason, G. M., Hrafnsdóttir, T., Ingvason, H. R., Jónsson, E. and Ólafsson, J. S.', 2004, NULL, NULL, NULL, NULL, NULL, 'Population fluctuations of chironomid and simuliid Diptera at Myvatn in 1977-1996', 'Aquatic Insects', NULL, '38', NULL, '209-217', NULL, 'Aquatic dipterans dominate the macrozoobenthos of Lake Myvatn and the River Lax and are important in the food web. As benthic sampling is time-consuming and expensive, a window trap was developed in order to facilitate the monitoring of the zoobenthos resource. Four window traps were operated at Myvatn and Lax during 1977–1996. The results yielded population indices for about 20 species of chironomids and one simuliid. Numbers of the most abundant midge species showed close correlations between 2 trap sites on the lake shore, 5 km apart; Cricotopus tibialis did not show such synchrony. At the River Lax, the dominant blackfly (Simulium vittatum) showed correlation between 2 trap sites, at the outlet and 3 km downstream; while the chironomids, apart from Micropsectra atrofasciata, did not. The dominant midge of Lake Myvatn, Tanytarsus gracilentus showed 3 cyclic oscillations during the 20-year period. The fluctuations were tracked by Micropsectra lindrothi, Procladius islandicus, Orthocladius consobrinus, Psectrocladius barbimanus and Chironomus islandicus. A group of non-cyclic species included Cricotopus sylvestris and Orthocladius oblidens.', NULL, 'Ablabesmyia monilis, Arctopelopia griseipennis, Chironomus islandicus, Chironomus sp., Cricotopus pilosellus, Cricotopus sylvestris, Cricotopus tibialis, Diamesa bohemani, Diamesa latitarsis, Diamesa zernyi, Eukiefferiella claripennis, Eukiefferiella minor, freshwater biomonitoring, Heterotrissocladius grimshawi, insect population cycles, insect traps, Island, Macropelopia nebulosa, macrozoobenthos, Metriocnemus obscuripes, Micropsectra atrofasciata, Micropsectra lindrothi, Micropsectra recurvata, Orthocladius consobrinus, Orthocladius frigidus, Orthocladius fuscimanus, Orthocladius oblidens, Paracladopelma laminata, Paraphenocladius impensus, Procladius islandicus, Psectrocladius barbimanus, Psectrocladius limbatellus, Smittia aterrima, Tanytarsus gracilentus, Thienemanniella sp.', 'article'),
(542, 'Makarchenko and Makarchenko 2003', 'a', 'Mak2003a', 'Makarchenko, E. A. and Makarchenko, M. A.', 2003, NULL, NULL, NULL, NULL, NULL, 'A new and little known species of <em>Stilocladius</em> Rossaro, 1979 (Diptera, Chironomidae, Orthocladiinae) from the Russian Far East', 'Euroasian Entomological Journal', 'http://www.biosoil.ru/tendipes/makar4.pdf', '2', '2', '135-140', NULL, 'A new species, Stilocladius orientalis sp.n., is described by male imago, pupa and larva from south part of Primorskii Krai. A new species for Rus- sia, S. intermedius Wang, is recorded and described by male and pupa from south part of Primorskii Krai, Sakhalin Island and Magadan Oblast’ (Russian Far East). Description of S. intermedius pupa is adduced for the first time. Stilocladius orientalis sp.n. is close related to West Palaearctic species S. montanus Rossaro and can be separate from this one by shape of inferior volsella and by shorter anal point of male hypopygium. A new version of keywords for known species of Slilocladius by males, pupae and larvae is given.', 'the presence in China is probably', 'Chironomidae, new and little known species, Orthocladiinae, Russian Far East, Stilocladius intermedius, Stilocladius orientalis', 'article'),
(499, 'Olafsson 1990', '', 'Ola1990', 'Olafsson, J. S.', 1990, NULL, NULL, NULL, NULL, NULL, 'Food of Chironomidae (Diptera) larvae in Lake Myvatn', 'Nature Conservation Council, Reykjavik, Iceland. Report', NULL, NULL, '23', NULL, NULL, NULL, 'In Icelandic, English summary, cited from {citeID|498|Gardarsson et al. 2004}', 'Island', 'article'),
(500, 'Lindegaard 1979', '', 'Lin1979', 'Lindegaard, C', 1979, NULL, NULL, NULL, NULL, NULL, 'The invertebrate fauna of Lake Myvatn, Iceland', 'Oikos', NULL, NULL, '32', '151-161', NULL, NULL, 'cited from {citeID|498|Gardarsson et al. 2004}', 'Island', 'article'),
(501, 'Ingvason et al. 2002', '', 'Ing2002', 'Ingvason, H. R., Olafsson, J. S. and Gardarsson, A.', 2002, NULL, NULL, NULL, NULL, NULL, 'Temporal pattern in resource utilisation of <em>Tanytarsus gracilentus</em> larvae (Diptera: Chironomidae)', 'Verh Int Verein Limmol', NULL, '28', NULL, '1041-1045', NULL, NULL, 'cited from {citeID|498|Gardarsson et al. 2004}', 'autecology, Tanytarsus gracilentus', 'article'),
(504, 'Bigler et al. 2003', '', 'Big2003', 'Bigler, C., Grahn, E., Larocque, I., Jeziorski, A. and Hall, R.', 2003, NULL, NULL, NULL, NULL, NULL, 'Holocene environmental change at Lake Njulla (999 m a.s.l.), northern Sweden: a comparison with four small nearby lakes along an altitudinal gradient', 'Journal of Paleolimnology', NULL, '29', NULL, '13--29', NULL, 'We assess Holocene environmental change at alpine Lake Njulla (68°22’N, 18°42’E, 999 m a.s.l.) in northernmost Sweden using sedimentary remains of chironomid head capsules and diatoms.We apply regional calibration sets to quantitatively reconstruct mean July air temperature (using chironomids and diatoms) and lake-water pH (using diatoms). Both chironomids and diatoms infer highest temperatures (1.7-2.3°C above present-day estimates, including a correction for glacio-isostatic land up-lift by 0.6°C) during the early Holocene (c .9,500-8,500 cal. yrs BP). Diatoms suggest a decreasing lake-water pH trend (c .0.6 pH units) since the early Holocene. Using detrended canonical correspondence analysis (DCCA), we compare the Holocene development of diatom communities in Lake Njulla with four other nearby lakes (Lake 850, Lake Tibetanus, Vuoskkujavri,Vuolep Njakajaure) located along an altitudinal gradient. All five lakes show similar initial DCCA scores after deglaciation, suggesting that similar environmental processes such as high erosion rates and low light availability associated with high summer temperature appear to have regulated the diatom community, favouring high abundances of Fragilaria species. Subsequently, the diatom assemblages develop in a directional manner, but timing and scale of development differ substantially between lakes. This is attributed primarily to differences in the local geology, which is controlling the lake-water pH. Imposed on the basic geological setting, site-specific processes such as vegetation development, climate, hydrological setting and in-lake processes appear to control lake development in northern Sweden.', NULL, 'Abisko, Chironomidae, Corynocera oliveri, Diatoms, lake-water pH, lake development, mean July air temperature, plant macrofossils, quantitative reconstruction, sediment core: Sweden, subarctic lakes, vegetation change', 'article'),
(505, 'Gandouin and Franquet 2002', '', 'uin2002', 'Gandouin, E. and Franquet, E.', 2002, NULL, NULL, NULL, NULL, NULL, 'Late Glacial and Holocene chironomid assemblages in ''Lac Long Inférieur'' (southern France, 2090 m): palaeoenvironmental and palaeoclimatic implications', 'Journal of Paleolimnology', NULL, '28', NULL, '317-328', NULL, 'Changes in lake water temperature and trophic states were inferred using chironomid fossil assemblages from ‘Lac Long Inférieur’ (Southern Alps, France). In the Late Glacial, a colder period, possibly analogous to the Younger Dryas, is characterised by a peak in Micropsectra, a cold stenothermic taxon. The increase in temperatures during the Late Glacial interstadial is indicated by a decrease in the percentages of cold stenothermic taxa (Tanytarsus lugens /Corynocera oliveri grp.) and by an increase in taxa linked to the development of vegetation in the littoral zone. The beginning of the Holocene is marked by the presence of taxa adapted to warmer and more eutrophic waters. During the Holocene, the progressive warming of the climate and increase in lake trophic status were indicated by the increase of eutrophic and warmer water indicators. An increase in tributary inﬂow into ‘Lac Long Inférieur’ was also inferred by the increase in rheophilous taxa, reﬂecting increased snowmelt. During the Subatlantic, the composition of the chironomid spectra suggests a re-cooling of the climate and / or a decrease in lake trophic status.', NULL, 'Alpine lakes, aquatic ecosystem reconstruction, Chironomids, France, Gyttja, Palaeolimnology, sediment core, trophic status', 'article'),
(506, 'Lotter et al. 1997', '', 'Lot1997', 'Lotter, A. F., Birks, H. J. B., Hofman, W. and Marchetto, A.', 1997, NULL, NULL, NULL, NULL, NULL, 'Modern diatom, cladocera, chironomid, and chrysophyte cyst assemblages as quantitative indicators for the reconstruction of past environmental conditions in the Alps. I. Climate', 'Journal of Paleolimnology', NULL, NULL, '18', '395-420', NULL, 'Diatom, chrysophyte cyst, benthic cladocera, planktonic cladocera, and chironomid assemblages were studied in the surface sediments of 68 small lakes along an altitudinal gradient from 300 to 2350 m in Switzerland. In addition, 43 environmental variables relating to the physical limnology, geography, catchment characteristics, climate, and water chemistry were recorded or measured for each lake. The explanatory power of each of these predictor variables for the different biological data-sets was estimated by a series of canonical correspondence\r\nanalyses (CCA) and the statistical signiﬁcance of each model was assessed by Monte Carlo permutation tests. A minimal set of environmental variables was found for each biological data-set by a forward-selection procedure within CCA. The unique, independent explanatory power of each set of environmental variables was estimated by a series of CCAs and partial CCAs. Inference models or transfer functions for mean summer (June, July, August) air temperature were developed for each biological data-set using weighted-averaging partial least squares or partial least squares. The ﬁnal transfer functions, after data screening, have root mean squared errors of prediction, as assessed by leave-one-out cross-validation, of 1.37 °C (chironomids), 1.60 °C (benthic cladocera), 1.62 °C (diatoms), 1.77 °C (planktonic cladocera), and 2.23 °C (chrysophyte cysts).', 'TP gradient for chironomids', 'Chironomidae, chrysophytes, Cladocera, diatoms, modern training-sets, summer temperatures, surface sediments, Switzerland, TP, TP gradient, transfer functions, WAPLS, weighted-averaging partial-least-squares', 'article'),
(507, 'Brooks and Birks 2000', '', 'Bro2000', 'Brooks, S. J. and Birks, H. J. B.', 2000, NULL, NULL, NULL, NULL, NULL, 'Chironomid-inferred late-glacial and early-Holocene mean July air temperatures for Kråkenes Lake, western Norway', 'Journal of Paleolimnology', NULL, '23', '1', '77--89', 'January', 'A chironomid data-set calibrated to July air temperatures, based on 44 lakes in western Norway, is used to reconstruct mean July air temperatures from late-glacial and early-Holocene fossil chironomid assemblages at Kråkenes Lake. The calibration function is based on Weighted Averaging Partial Least Squares regression and has a root mean square error of prediction (RMSEP) of 1.13 °C, a r<sup>2</sup> of 0.69, and a maximum bias of 2.66 °C. All these statistics are based on leave-one-out cross-validation. A calibration function based on summer surface-water temperatures has a poorer performance (RMSEP = 2.22 °C, r<span style=”vertical-align:super”>2</span> = 0.30, maximum bias = 5.29 °C). The reconstructed July air temperatures at Kråkenes rise to 10.5 °C soon after deglaciation, are about 11.5 °C in the Allerød, decrease to 9.5-10 °C in the Younger Dryas, and rise rapidly within 15 yrs to 11.5 °C at the onset of the Holocene. There is a two-step rise to 13 °C or more in the early-Holocene. The likely over-estimation of Younger Dryas temperatures and under-estimation of early-Holocene temperatures probably result from the limited temperature range represented by the existing calibration set. The data set is currently being expanded to include lakes with warmer air temperatures (&gt; 14 °C) and with colder air temperatures (&lt; 8 °C)', '<ul type="disc"><li>44 surface samples wirh n&gt;10 chironomids WAPLS-2 R<span style="vertical-align:super">2</span>=0.688, PMSEP<span style="vertical-align:sub">jack</span>=1.110°C with given figure as WA-image, ecology of chironomids</li>\r\n<li>11 with significant symmetric unimodal Template:HOF:unimodal: Ablabesmyia, Arctopelopia, Cladopelma, Heterotanytarsus apicalis, Macropelopia, Pagastiella, Polypedilum, Psectrocladius sordidellus-group, Pseudorthocladius, Tanytarsus pallidicornis-group Zalutschia zalutschicola </li>\r\n<li>5 statistically significant (sigmoidal Template:HOF:sigmoidalNotUpperLeft Template:HOF:sigmoidalUpperLeft) thus optima beyond sampled 5.7 °C: Heterotrissocladius subpilosus, Micropsectra radialis, Tanytarsina group B, Tanytarsus lugens/Corynocera oliveri, and unidentified Tanytarsini </li>\r\n<li>8 have statistically significant (sigmoidal Template:HOF:sigmoidalNotUpperRight Template:HOF:sigmoidalUpperRight) thus the optima beyond sampled 14 °C: Thienemanniella, Parametriocnemus, Paratanytarsus, Zavrelia, Orthocladius cf. clarki, Parakiefferiella bathophila, Limnophyes, Pseudosmittia </li>\r\n<li><span style="color:#0000ff">cold water</span> Pseudodiamesa arctica, Diamesinae, Paracladius alpicola, Heterotrissocladius subpilosus, Heterotrissocladius grimshawi, Micropsectra radialis, Corynocera oliveri/Tanytarsus lugens, Arctopelopia, Sergentia coracina </li>\r\n<li><span style="color:#ff0000">warm water</span> Cricotopus sp., Procladius, Chironomus anthracinus-group, Dicrotendipes, Microtendipes chloris, Polypedilum cf. nebeculosum </li>\r\n<li>acidophil Psectrocladius sordidellus-group, Psectrocladius septentrionalis-group, Heterotanytarsus apicalis</li></ul>', 'Allerød, calibration, chironomids, climate reconstruction, Kråenes, late glacial, transfer functions, WA-PLS, Younger Dryas', 'article'),
(508, 'Meriläinen et al. 2000', '', 'Mer2000', 'Meriläinen, J. J., Hynynen, J., Teppo, A., Palomäki, A., Granberg, K. and Reinikainen, P.', 2000, NULL, NULL, NULL, NULL, NULL, 'Importance of diffuse nutrient loading and lake level changes to the eutrophication of an originally oligotrophic boreal lake: a palaeolimnological diatom and chironomid analysis', 'Journal of Paleolimnology', NULL, '24', NULL, '251-270', NULL, 'The recent environmental history of Lake Lappajärvi in western Finland (63°00’ N, 23°30’ E, area 149 km2), a humic, brown water lake with an average phosphorus content of ca. 20 µg l–1, was studied from short core sediment samples taken from the two main basins of the lake. Based on the stratigraphy of diatoms and chironomids and the sediment quality it was possible to distinguish four developmental stages during the past century: (1) a pre-industrial stage covering the time up to about 1935; (2) a stage of increasing nutrient loading (ca. 1936–1960); (3) a\r\nstage of pronounced erosion from lake level regulation and extensive ditching of the catchment area (ca. 1960-1970); and (4) a meso-eutrophic stage from ca. 1970 onwards. Acidophilous Aulacoseira distans coll. and other species typical of dystrophic, nutrient-poor lakes character-\r\nized the diatom assemblages during the first stage, and the profundal zoobenthic assemblages, characterized by Heterotrissocladius subpilosus and Micropsectra, indicated good hypolimnetic oxygen conditions and a low sedimentation of organic matter (approximately less than 50 g m–2 a–1). The increased loading rapidly led to changes both in diatoms and chironomids (e.g., to an early extinction of H. subpilosus in the 1950s). The process finally led to eutrophication with a successive proliferation of diatom species such as Asterionella formosa followed by Aulacoseira ambigua, Fragilaria crotonensis, and finally Melosira varians. The relative proportion of alkaliphilous species reached a maximum in the final stage and the original profundal chironomid fauna was replaced by Chironomus anthracinus gr. and C. plumosus which are typical of profundal areas suffering from temporal oxygen deficit. It is notable that the considerable decrease in waste water loading from the point sources (80–86%) during the past two decades has not led to a recovery in the lake. This highlights the importance of diffuse loading from agriculture, forestry and other human activities even to this comparatively large lake.', NULL, 'benthic quality index, boreal lake, chironomids, Chironomus anthracinus gr., Chironomus plumosus, diatoms, diffuse loading, Europe: Finland, eutrophication, Heterotrissocladius subpilosus, Micropsectra sp., palaeolimnology, sediment core, Sergentia coracina, Stictochironomus rosenscholdi, trophic state', 'article'),
(509, 'Renberg and Hellberg 1982', '', 'Ren1982', 'Renberg, I. and Hellberg, T.', 1982, NULL, NULL, NULL, NULL, NULL, 'The pH history of lakes in southwestern Sweden, as calculated from the subfossil diatom flora of the sediment', 'Ambio', NULL, '11', NULL, '30–33', NULL, NULL, 'cited from {citeID|508|Meriläinen et al. 2000}', 'diatoms, Europe: Sweden, palaeoecology, pH', 'article'),
(510, 'Wiederholm 1980', '', 'Wie1980', 'Wiederholm, T.', 1980, NULL, NULL, NULL, NULL, NULL, 'Use of benthos in lake monitoring', 'J. Wat. Pollut. Cont. Fed.', NULL, '52', NULL, '537–547', NULL, NULL, 'cited from {citeID|508|Meriläinen et al. 2000}', 'benthic quality index', 'article'),
(511, 'Brooks 2006', '', 'Bro2006', 'Brooks, S. J.', 2006, NULL, NULL, NULL, NULL, NULL, 'Fossil midges (Diptera: Chironomidae) as palaeoclimatic indicators for the Eurasian region', 'Quaternary Science Reviews', NULL, '25', NULL, '1894--1910', NULL, 'Chironomids (non-biting midges) have been used in palaeoenvironmental studies in Eurasia since the 1920s. Initially changes in chironomid assemblages were largely interpreted as a response to changes in trophic status or water depth. It was only with the advent of chironomid-temperature inference models in the early 1990s that their potential as palaeoclimatic indicators was fully exploited. This paper provides a brief review of the pioneering studies but focuses on the most recent advances. Better taxonomic resolution of fossil midges, expansion of modern training sets, use of air temperature data derived from meteorological stations rather than surface-water temperature data, and Bayesian statistical approaches have lead to improvements in the performance of chironomid-temperature transfer functions. Applications of these transfer functions to derive chironomid-inferred temperature estimates from Lateglacial (ca 15,000–11,200 cal. yr BP) and Holocene (11,200 cal. yr BP to Present) sequences from throughout Eurasia are reviewed in this paper. Chironomid-inferred Lateglacial reconstructions closely reflect oxygen isotope records from Greenland ice cores. Holocene reconstructions are less consistent. Some closely follow instrumental records or corroborate other proxy data, while other reconstructions are less successful. As a result of soil development during the Holocene, changes in pH, nutrients, DO and DOC had a greater influence than temperature on the composition of some midge assemblages. One way to mitigate this is through consensus temperature reconstructions from several sites in the same region. The challenge for future workers is for further improvement in taxonomic resolution of sub-fossil chironomid larvae, to improve further the performance of chironomid-temperature inference models, to develop training sets for southern Europe and Russia and to improve our understanding of the ecological responses of chironomids.', NULL, 'climate reconstruction, Eurasian Region, indication Chironomidae, nutrients, palaeo-environments, paleoclimate, review, sediment core, subfossil chironomids', 'no entry type given'),
(512, 'Bunbury and Gajewski 2008', '', 'Bun2008', 'Bunbury, J. and Gajewski, K.', 2008, NULL, NULL, NULL, NULL, NULL, 'Does a one point sample adequately characterize the lake environment for paleoenvironmental calibration studies?', 'Journal of Paleolimnology', NULL, '39', '4', '511--531', 'May', 'A major goal of paleolimnological studies is the quantification of past environmental conditions. This is accomplished by computing transfer functions relating organism assemblages to environmental factors. The environmental data are typically comprised of a point sample of water chemistry and other environmental parameters that are collected at the same time as a surface sediment sample. We explore whether the year of sampling of the environmental variables affects the parameterization of organism-environment relations, in particular chironomids, ostracodes and diatoms. Canonical correspondence analyses revealed that the year of sampling is of secondary importance when relating the organism assemblages to environmental variables, but only with the major explanatory variables. A chironomid-inferred bottom water temperature partial least squares transfer function revealed similar performance statistics between the years. Taxon optima and tolerances were computed for both years using weighted averaging, and the results are comparable. A paired t-test computed on the proxy-inferred bottom water temperature values indicated that the results between the 2 years are not statistically different. The results of this study provide guarded optimism that the methodology of estimating transfer functions as currently applied is not entirely determined by the particular year when the data were collected, although more case studies are needed. [41 lakes in Yukon Northamerica, CCA with variables: Depth, Alk, Cond, Mg, Tb, K, LOI, TP, DOC, Mg/Ca, Alk/Ca, Carb, Elev, TKN, Area, Si, Na, Fe, Mn, DOb, Ts, SO4, Mo]', NULL, 'alkalinity, alkalinity/Ca, area, calibration sets, canonical correspondence analysis, carbonate, Chironomidae: alkalinity, Chironomidae: alkalinity/Ca, Chironomidae: area, Chironomidae: carbonate, Chironomidae: conductivity, Chironomidae: depth, Chironomidae: DOb, Chironomidae: DOC, Chironomidae: elevation, Chironomidae: Fe, Chironomidae: K, Chironomidae: LOI, Chironomidae: Mg, Chironomidae: Mg/Ca, Chironomidae: Mn, Chironomidae: Mo, Chironomidae: Na, Chironomidae: P total, Chironomidae: Si, Chironomidae: SO4, Chironomidae: Tb (°C bottom), Chironomidae: TKN (total Kjeldahl nitrogen), Chironomidae: Ts (°C surface), conductivity, depth, DOb, DOC, elevation, Fe, K, limnology, LOI, Mg, Mg/Ca, Mn, Mo, Na, paleolimnology, P total, sample size, Si, SO4, Southwest Yukon, Tb (°C bottom), TKN (total Kjeldahl nitrogen), transfer functions, Ts (°C surface)', 'article'),
(513, 'Walker 1988', '', 'Wal1988', 'Walker, I. R.', 1988, NULL, NULL, NULL, NULL, NULL, 'Late-Quaternary Palaeoecology of Chironomidae (Diptera:Insecta) from Lake  Sediments in British Columbia', 'Ph.D. thesis, Simon Fraser University, Burnaby', NULL, NULL, NULL, NULL, NULL, NULL, 'cited from {citeID|512|Bunbury and Gajewski 2008}', 'Parakiefferiella cf.sp. B', 'phdthesis'),
(514, 'Hill 1973', '', 'Hil1973', 'Hill, M. O.', 1973, NULL, NULL, NULL, NULL, NULL, 'Diversity and evenness: A unifying notation and its consequences', 'Ecology', NULL, '54', '2', '427-432', NULL, 'Three commonly used measures of diversity, Simpson’s index, Shannon’s entropy, and the total number of species, are related to Renyi’s definition of a generalized entropy. A unified concept of diversity is presented, according to which there is a continuum of possible diversity measures. In a sense which becomes apparent, these measures provide estimates of the effective number of species present, and differ only in their tendency to include or to ignore the relatively rarer species. The notion of the diversity of a community as opposed to that of a sample is examined, and is related to the asymptotic form of the species—abundance curve. A new and plausible definition of evenness is derived. [first description of Hills diversity with so-called Hill-numbers N1, N2...]', NULL, 'diversity measure, evenness, similarity', 'article'),
(515, 'Korhola et al. 2000', '', 'Kor2000', 'Korhola, A., Olander, H. and Blom, T.', 2000, NULL, NULL, NULL, NULL, NULL, 'Cladoceran and chironomid assemblages as quantitative indicators of water depth in subarctic Fennoscandian lakes', 'Journal of Paleolimnology', NULL, '24', NULL, '43--54', NULL, 'The relationship between surface-sediment cladoceran and chironomid communities to lake depth was analysed in 53 lakes distributed across timberline in northern Fennoscandia using multivariate statistical approaches. The study sites are small and bathymerically simple, with water depth ranging from 0.85 27.0 m (mean 6.36 m). Maximum lake depth was the most important factor in explaining the cladoceran distributions and the second most important factor in explaining the chironomid distributions in these subarctic lakes, as assessed on the basis of a series of constrained RDAs, Monte Carlo permutation tests, and variance partitioning. Quantitative inference models for maximum lake depth were created for both groups of animals. Well-performing calibration functions for predicting lake depth were obtained in each case using linear partial least squares (PLS) regression and calibration, weighted averaging (WA) with an inverse deshrinking regression, and weighted averaging partial least squares (WA-PLS). Quantitative reconstructions of lake level fluctuations should be possible from cladoceran and chironomid core data with a root mean squared error of prediction (RMSEP), as estimated by jack-knifing, of about 1.6 3.0 m.', NULL, 'calibration models, Chironomidae, Cladocera, lake level, northern Fennoscandia, palaeohydrological proxies, subarctic lakes', 'article'),
(516, 'Korhola et al. 2002', '', 'Kor2002', 'Korhola, A., Vasko, K., Toivonen, H. T. T. and Olander, H.', 2002, NULL, NULL, NULL, NULL, NULL, 'Holocene temperature changes in northern Fennoscandia reconstructed from chironomids using Bayesian modelling', 'Quaternary Science Reviews', NULL, '21', NULL, '1841-1860', NULL, 'The recently developed Bayesian multinomial calibration model, Bummer, was applied to the fossil chironomid assemblages of a lake situated at the present tree-line in northern Fennoscandia to reconstruct patterns in Holocene climates. The results are compared with inferences derived using non-Bayesian weighted averaging partial least-squares regression. The reconstruction exhibits both long-term trends as well as a series of shorter-term oscillations. Abrupt climatic excursions were particularly characteristic for the early Holocene period, with cooling episodes around 9200, 8600 and 8200 cal yr BP. The interval from ca 8000 to 5800 cal yr BP appeared to be warm and stable, but was followed by a pronounced climatic cooling around 5800 cal yr BP leading to a relatively long-lasting mid-Holocene temperature minimum between ca 5800 and 4000 cal yr BP. The reconstruction during the latter part of the Holocene is relatively featureless, which may partly be due to gradual shallowing of the lake by sedimentation that may have affected chironomid compositions, thereby masking the climate signal. The major climatic patterns in our reconstruction agree well with inferences from Greenland ice and marine sediments and are also in line with the previous reconstructions based on diatoms and pollen from the same core, although the finer-scale variations reflected by the three proxies do not always match. The overall results provide evidence for climatic complexity during the Holocene epoch and demonstrate that Bayesian modelling is highly suitable for reconstruction purposes.', NULL, 'Bayesian statistics, Bummer, chironomids, Holocene, inference models, temperature, transfer functions', 'article'),
(517, 'Olander et al. 1999', '', 'OrH1999', 'Olander, H.,  Birks, H. J. B., Korhola, A. and Blom, T.', 1999, NULL, NULL, NULL, NULL, NULL, 'An expanded calibration model for inferring lakewater and air temperatures from fossil chironomid assemblages in northern Fennoscandia', 'The Holocene', NULL, '9', '3', '279-294', NULL, 'Chironomid-temperature inference models based on an expanded data set of surface-sediment and limnological data from 53 Subarctic lakes in northern Fennoscandia have been developed using eight different numerical techniques, each based on slightly different underlying statistical models or ecological assumptions. The study sites are mostly small, shallow, bathymetrically simple, oligotrophic lakes, with a pH range from 5.0 to 7.8, a total organic carbon range from 2.5 to 12.6 mg l- 1, a mean July lakewater temperature ranging from 6.1 to 15.4°C, and a mean July air temperature ranging from 8.5 to 14.9°C. A series of redundancy analyses (RDA) identified sediment organic content, maximum lake depth, and lakewater temperature as being the most important explanatory variables. Variance partitioning by partial RDAs further suggested that each of these variables accounted for a significant fraction of variance independent from each other. Different cali bration models were assessed on the basis of their statistical performance, with particular reference to prediction errors and the amount of bias along the temperature gradient. Of the eight calibration models, modern analogue techniques, weighted averaging partial least squares, simple weighted averaging with an inverse’ deshrinking regression, and linear partial least squares consistently performed best. These methods can all be used to develop transfer functions for surface-water and air July temperatures with a root mean squared error of predic tion (RMSEP) of about 1.5-1.6°C (water temperature) and 0.8-1.1°C (air temperature), as assessed by leave-one-out cross-validation. The resulting models do, however, have relatively high maximum biases (up to 3.9°C) in the lowest segments of the air and water temperature gradients, highlighting the need for enlarging and expanding the calibration data set to include lower temperatures. [with taxalist July inferred air temperature: figure cold (top) -> warm (bottom) p. 286, ecology]', NULL, 'calibration, calibration models, Chironomidae, Holocene, lakes: alkalinity, lakes: altitude, lakes: Ca, lakes: catchment area, lakes: DBT, lakes: Fe, lakes: K, lakes: lake perimeter, lakes: LOI, lakes: longitude, lakes: Maximum depth, lakes: Mg, lakes: mire, lakes: Na, lakes: pH, lakes: temperature, lakes: TOC, lakes: Water, lake water, northern Fennoscandia, ordination, palaeoclimate, Subarctic, summer temperature, transfer functions', 'article'),
(518, 'Larocque et al. 2001', '', 'Lar2001', 'Larocque, I., Hall, R. I. and Grahn, E.', 2001, NULL, NULL, NULL, NULL, NULL, 'Chironomids as Indicators of Climate Change: A 100-Lake Training Set from a Subarctic Region of Northern Sweden (Lapland)', 'Journal of Paleolimnology', NULL, '26', NULL, '307--322', NULL, 'Multivariate numerical analyses (DCA, CCA) were used to study the distribution of chironomids from surface sediments of 100 lakes spanning broad eco-climatic conditions in northern Swedish Lapland. The study sites range from boreal forest to alpine tundra and are located in a region of relatively low human impact. Of the 19 environmental variables measured, ordination by CCA identified mean July air temperature as one of the most significant variables explaining the distribution and the abundance of chironomids. Loss-on-ignition (LOI), maximum lake depth and mean January air temperature also accounted for significant variation in chironomid assemblages. A quantitative transfer function was created to estimate mean July air temperature from sedimentary chironomid assemblages using weighted-averaging partial least squares regression (WA-PLS). The coefficient of determination was relatively high (r2 = 0.65) with root mean squared error of prediction (RMSEP, based on jack-knifing) of 1.13 °C and maximum bias of 2.1 °C, indicating that chironomids can provide useful quantitative estimates of past changes in mean July air temperature. The paper focuses mainly on the relationship between chironomid composition and July air temperature, but the relationship to LOI and depth are also discussed.', NULL, 'Abisko, Canonical Correspondence Analysis, Chironomidae, Climate Change, Europe: Sweden, Lapland, Ordination, Temperature, transfer functions', 'no entry type given'),
(519, 'Huisman et al. 1993', '', 'Hui1993', 'Huisman, J., Olff, H. and Fresco, L. F. M.', 1993, NULL, NULL, NULL, NULL, NULL, 'A hierarchical set of models for species response analysis', 'Journal Of Vegetation Science', NULL, '4', '1', '37-46', 'February', 'Variation in the abundance of species in space and/or time can be caused by a wide range of underlying processes. Before such causes can be analysed we need simple mathematical models which can describe the observed response patterns. For this purpose a hierarchical set of models is presented. These models are applicable to positive data with an upper bound, like relative frequencies and percentages. The models are fitted to the observations by means of logistic and non-linear regression techniques. Working with models of increasing complexity allows us to choose for the simplest possible model which sufficiently explains the observed pattern. The models are particularly suited for description of responses in time or over major environmental gradients. Deviations from these temporal or spatial trends may be statistically ascribed to, for example, climatic fluctuations or small-scale spatial heterogeneity. The applicability of this approach is illustrated by examples from recent research. A combination of simple, descriptive models like those presented in this paper and causal models as developed by several others, is advocated as a powerful tool towards a fuller understanding of the dynamics and patterns of vegetational change.', '\r\n*Model I: no significant trend in space or time Template:HOF:noDistribution\r\n*Model II: an increasing or decreasing trend where the maximum is equal to the upper bound M Template:HOF:sigmoidalUpperRight Template:HOF:sigmoidalUpperLeft\r\n*Model III: an increasing or decreasing trend where the maximum is below the upper bound M Template:HOF:sigmoidalNotUpperRight Template:HOF:sigmoidalNotUpperLeft\r\n*Model IV: increase and decrease by the same rate: symmetrical response curve Template:HOF:unimodal\r\n*Model V: increase and decrease by different rates: skewed response curve. Template:HOF:skewedRight Template:HOF:skewedLeft\r\n', 'direct gradient analysis, fluctuation, HOF (Huisman-Olff-Fresco models), Huisman-Olff-Fresco models, logistic regression, nonlinear regression, response curve, succession', 'article'),
(520, 'Porinchu and Cwynar 2002', '', 'Por2002', 'Porinchu, D. F. and Cwynar, L. C.', 2002, NULL, NULL, NULL, NULL, NULL, 'Late-Quaternary history of midge communities and climate from a tundra site near the lower Lena River, Northeast Siberia', 'Journal of Paleolimnology', NULL, '27', NULL, '59-69', NULL, 'Analysis of midge remains in late-Quaternary sediment, recovered from a lake situated north of treeline in north-east Siberia, indicates the occurrence of notable climatic fluctuations during the last 12 ka. The onset of late-glacial warming was disrupted by a marked cooling event – possibly correlative with the Younger Dryas – that occurred between 11,000 and 10,000 yrs BP. Increases in the relative abundance of taxa typically found in tundra lakes, such as Hydrobaenus/Oliveridia and Parakiefferiella nigra, and the concurrent decrease in temperate taxa, such as Microtendipes and Corynocera ambigua, suggest climatic deterioration occurred during this interval. At approximately 10,000 yrs BP there was a large increase in temperate taxa such as Microtendipes and C. ambigua, and a decline of essentially all cold-water taxa. This suggests that climate was warmer than present since the modern distribution of both Microtendipes and C. ambigua is limited to forested sites in this region. This warm interval lasted until approximately 6000 yrs BP when there was a precipitous decline in temperate chironomid taxa and\r\nan increase in cold-water chironomid taxa, such as Paracladius, Hydrobaenus/Oliveridia, Abiskomyia, and Parakiefferiella nigra. This cooling continued through the late-Holocene and the modern tundra chironomid assemblage developed by approximately 1400 yrs BP.', NULL, 'Abiskomyia, Allopsectrocladius/Mesopsectrocladius, Asia: Siberia, chironomids, Chironomus, climate, Corynocera ambigua, Corynocera oliveri, Corynoneura/Thienemanniella, Cricotopus/Orthocladius, Dicrotendipes, Heterotrissocladius, Holocene, Hydrobaenus/Oliveridia, Micropsectra, Microtendipes, Paracladius, Parakiefferiella cf. bathophila, Parakiefferiella nigra, Pentanneurini (Other), Procladius, Psectrocladius, Psectrocladius subgenus Monopsectrocladius, Psectrocladius subgenus Psectrocladius, sediment core, sediment core: Abiskomyia, sediment core: Allopsectrocladius/Mesopsectrocladius, sediment core: Chironomus, sediment core: Corynocera ambigua, sediment core: Corynocera oliveri, sediment core: Corynoneura/Thienemanniella, sediment core: Cricotopus/Orthocladius, sediment core: Dicrotendipes, sediment core: Heterotrissocladius, sediment core: Hydrobaenus/Oliveridia, sediment core: Micropsectra, sediment core: Microtendipes, sediment core: Paracladius, sediment core: Parakiefferiella cf. bathophila, sediment core: Parakiefferiella nigra, sediment core: Pentanneurini (Other), sediment core: Procladius, sediment core: Psectrocladius, sediment core: Psectrocladius subgenus Monopsectrocladius, sediment core: Psectrocladius subgenus Psectrocladius, sediment core: Sergentia, sediment core: Stempellinella/Zavrelia, sediment core: Stictochironomus, sediment core: Tanytarsina, sediment core: Zalutschia zalutschicola, Sergentia, Stempellinella/Zavrelia, Stictochironomus, Tanytarsina, treeline, Younger Dryas, Zalutschia zalutschicola', 'article'),
(521, 'Porinchu et al. 2002', '', 'Por2002a', 'Porinchu, D. F., MacDonald, G. M., Bloom, A. M. and Moser, K. A.', 2002, NULL, NULL, NULL, NULL, NULL, 'The modern distribution of chironomid sub-fossils (Insecta: Diptera) in the Sierra Nevada, California: Potential for paleoclimatic reconstructions', 'Journal of Paleolimnology', NULL, '28', '355-375', NULL, NULL, 'Surface lake sediment was recovered from 57 lakes along an elevation gradient in the central, eastern Sierra Nevada of California. The surface sediment was analysed for subfossil chironomid remains in order to assess the modern distribution of chironomids in the region. The lakes sampled for the calibration dataset were between 2.0 and 40.0 m in depth, spanned an altitudinal gradient of 1360 m and a surface water temperature gradient of approximately 14 °C. Redundancy analysis (RDA) identiﬁed that ﬁve of the measured environmental variables – surface water temperature, elevation, depth, strontium, particulate organic carbon – accounted for a statistically signiﬁcant amount of the variance in chironomid community composition. Quantitative transfer functions, based on weighted-averaging (WA), partial least squares (PLS) and weighted-averaging partial least squares (WA-PLS), were developed to estimate surface water temperature from the chironomid assemblages. The best model was a WA model with classical deshrinking, which had a relatively high coefﬁcient of determination (r² =5 0.73), low root mean square error of prediction (RMSEP=1.2 °C) and a low maximum bias (0.90 °C). The results from this study suggest that robust quantitative estimates of past surface water temperature can be derived from the application of these models to fossil chironomid assemblages preserved in late-Quaternary lake sediment in this region.', NULL, 'Al, Alpine lakes, America: California, Ba, Ca, chironomids, Chl a, Cl, DIC, DOC, elevation, Fe, K, lake depth, Li, LOI, Mg, Na, NH3, NO2, NO3, ordination, paleolimnology, partial least squares, pH, PLS, PN, POC, salinity, Sierra Nevada, SiO2, SO4, speciﬁc conductivity, Sr, SRP, surface water temperature, TKN, TP, TP-F, transfer functions, transfer function: comparison, WA, WA-PLS, weighted-averaging, weighted-averaging partial least squares', 'no entry type given'),
(522, 'Oliver 1976', '', 'Oli1976', 'Oliver, D. R.', 1976, NULL, NULL, NULL, NULL, NULL, 'Chironomidae (Diptera) of Char Lake, Cornwallis Island, N.W.T., with descriptions of two new species', 'Can. Ent.', NULL, '108', NULL, '1053-1064', NULL, NULL, 'cited from {citeID|521|Porinchu et al. 2002}', NULL, 'article'),
(523, 'Porinchu and Cwynar 2000', '', 'Por2000', 'Porinchu, D. F. and Cwynar, L. C.', 2000, NULL, NULL, NULL, NULL, NULL, 'The distribution of freshwater Chironomidae (Insecta: Diptera) across treeline near the lower Lena River, northeast Siberia', 'Arct. Antarct. Alp. Res.', NULL, '32', NULL, '429-437', NULL, NULL, 'cited from {citeID|521|Porinchu et al. 2002}', NULL, 'article'),
(524, 'Walker and Mathewes 1989', '', 'Wal1989', 'Walker, I. R. and Mathewes, R.W.', 1989, NULL, NULL, NULL, NULL, NULL, 'Chironomidae (Diptera) remains in surficial lake sediments from the Canadian Cordillera: analysis of the fauna across an altitudinal gradient', 'Journal of Paleolimnology', NULL, '2', NULL, '61-80', NULL, NULL, 'cited from {citeID|521|Porinchu et al. 2002}', NULL, 'article');
INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(525, 'Walker et al. 1997', '', 'Wal1997', 'Walker, I.R., Levesque, A.F., Cwynar, L.C. and Lotter, A.F', 1997, NULL, NULL, NULL, NULL, NULL, 'An expanded surface-water paleotemperature inference model for use with fossil midges in eastern Canada', 'Journal of Paleolimnology', NULL, '18', NULL, '165-178', NULL, 'Using an expanded surface sample data set, representing lakes distributed across a transect from southernmost Canada to the Canadian High Arctic, a revised midge-palaeotemperature inference model was developed for eastern Canada. Modelling trials with weighted averaging (with classical and inverse deshrinking; with and without tolerance downweighting) and weighted averaging partial least squares (WA-PLS) regression, with and without square-root transformation of the species data, were used to identify the best model. Comparison of measured and predicted temperatures revealed that a 2 component WA-PLS model for square-root transformed percentage species data provided the model with the highest explained variance (r2 = 0.88) and the lowest error estimate jack (RMSEPjack = 2.26 °C). Comparison of temperature inferences based on the new and old models indicates that the original model may have seriously under-estimated the magnitude of late-glacial temperature oscillations in Atlantic Canada. The new inferences suggest that summer surface water temperatures in Splan Pond, New Brunswick were approximately 10 to 12 °C immediately following deglaciation and during the Younger Dryas. During the Allerød and early Holocene, surface water temperatures of 20 to 24 °C were attained. The new model thus provides the basis for more accurate palaeotemperature reconstructions throughout easternmost Canada.', NULL, 'Ceratopogonidae, Chaoborus, Chironomidae, error estimation, late glacial, palaeoclimate, temperature optima, tolerance downweighting, WA, WA-PLS, weighted averaging, weighted averaging partial least squares, Younger Dryas', 'article'),
(526, 'Hofmann 2001', '', 'Hof2001', 'Hofmann, W', 2001, NULL, NULL, NULL, NULL, NULL, 'Late-Glacial/Holocene succession of the chironomid and cladoceran fauna of the Soppensee (Central Switzerland)', 'Journal of Paleolimnology', NULL, '25', NULL, '411-420', NULL, 'Remains of chironomids and cladocerans were studied in a profundal sediment core, which covered a time period since the Oldest Dryas. The aim was to observe long-term variability in the structure of the aquatic fauna. The most dramatic change in the chironomid fauna occurred at the end of the Younger Dryas when the predominating coldstenothermal Sergentia coracina disappeared due to both climatic amelioration and eutrophic conditions. The chydorids showed a distinct response to the changing temperature at the end of the Oldest Dryas as evidenced by an increase in species diversity, whereas no effect was discernible in the Younger Dryas. A decrease in the proportion of ‘clear water species’ occurred in the Boreal. In the planktonic Cladocera, Bosmina longispina became extinct in the Atlantic and two Eubosmina morphs of uncertain taxonomic state very recently invaded the lake.', NULL, 'Chironomidae, Cladocera, climate, Europe: Switzerland, Holocene, Late-Glacial, sediment analysis, sediment core, trophy', 'article'),
(527, 'Velle et al. 2005', 'a', 'Vel2005', 'Velle, G., Brooks, S. J., Birks, H. J. B. and Willassen, E.', 2005, NULL, NULL, NULL, NULL, NULL, 'Chironomids as a tool for inferring Holocene climate: an assessment based on six sites in southern Scandinavia', 'Quaternary Science Reviews', NULL, '24', NULL, '1429-1462', 'July', 'Chironomid subfossil assemblages from six low-alpine and sub-alpine Holocene stratigraphies are presented and compared. They are from five lakes in mid-southern and western Norway and one in central Sweden. When comparing the chironomid-inferred July air temperatures, there are many time segments with a poor among-lake fit in inferred temperatures. Possible environmental variables influencing the fossil chironomid assemblages are discussed using a modern Norwegian calibration data set to indicate taxon–environment relationships. These analyses indicate that local changes in pH, water chemistry, and productivity at times may have overridden the regional temperature signal. In addition, other causes of poor among-site temperature fit are discussed, in particular those related to chronological uncertainties. Holocene temperature inferences from single cores based on chironomids may not always be able to provide a reliable regional temperature signal, but can act as a guide from which hypotheses about past environmental conditions can be tested with the aid of chironomid-inferred temperatures from several sites and from other environmental proxies. We have obtained a regional picture of Holocene summer temperature change by developing a consensus reconstruction based on the overall temperature signal from all six sites. This consensus is developed by fitting a smoother through all 330 site-specific temperature-deviations from the Holocene mean. The consensus temperature deviations vary from -0.8 °C at 8800 cal years BP to +0.8 °C at 6500 cal years BP.', NULL, 'Chironomidae, climate change, Holocene, July air temperature, Scandinavia, sediment core', 'no entry type given'),
(528, 'Bjune 2004', '', 'Bju2004', 'Bjune, A. E.', 2004, NULL, NULL, NULL, NULL, NULL, 'Holocene vegetational and climate history at or near tree-line in contrasting areas of Norway inferred from pollen and plant macrofossils in lake sediments', 'Doctor Scient Thesis,  University of Bergen', NULL, NULL, NULL, NULL, NULL, NULL, 'cited from {citeID|527|Velle et al. 2005}', 'climate history, pollen record', 'phdthesis'),
(529, 'Velle et al. 2005', 'b', 'Vel2005a', 'Velle, G., Larsen, J., Eide, W., Peglar, S., Birks, H.J.B.', 2005, NULL, NULL, NULL, NULL, NULL, 'Holocene environmental history and climate of Råtåsjøen, a lowalpine lake in central Norway', 'Journal of Paleolimnology', NULL, NULL, NULL, NULL, NULL, NULL, 'cited from {citeID|527|Velle et al. 2005}, check year again!!', 'Europe: Norway, Holocene climate, Holocene history', 'article'),
(530, 'Brodersen and Lindegaard 1999', '', 'Bro1999', 'Brodersen, K. P. and Lindegaard, C.', 1999, NULL, NULL, NULL, NULL, NULL, 'Mass occurrence and sporadic distribution of <em>Corynocera ambigua</em> Zetterstedt (Diptera, Chironomidae) in Danish lakes. Neo- and palaeolimnological records', 'Journal of Paleolimnology', NULL, '22', NULL, '41--52', NULL, 'The chironomid Corynocera ambigua (Tanytarsini) is commonly reported as a cold-stenothermal species living in shallow lakes in arctic and subarctic regions. In palaeoecological studies of temperate lakes, larval remains of C. ambigua are usually found in late-glacial sediments from the Allerø d and Younger Dryas periods, and often in association with subfossil Chara oospores. During a surface sampling program of chironomid head-capsules in 41 Danish temperate lakes, C. ambigua was found to comprise 25% of the chironomid assemblages in two lakes, and was sporadically found in 8 other lakes (0.5?10%). A 70 cm palaeo-stratigraphy from the shallow (max depth 1.2 m) and eutrophic (total phosphorus = 150 µg P l?1) Lake Stigsholm showed that C. ambigua has been abundant in the last 4?5 centuries. At a sediment level of 25 cm ( year 1925, 210Pb dating), C. ambigua began to decrease in frequency while Chironomus plumosus, Procladius sp., Cladotanytarsus gr. mancus and Tanytarsus spp. increased, suggesting an increased nutrient loading and an approach to eutrophic conditions. In 1995 C. ambigua was still very abundant in Lake Stigsholm but in early March 1997 no living larvae were found. An extremely heavy growth of Elodea, Enteromorpha and filamentous algae in the summers of 1995 and 1996, with following degradation in the fall, might have influenced the invertebrate population dynamics. No significant distinguishing characteristics were found for the lakes supporting C. ambigua. Its occurrence in warm (~20°C) Danish lakes brings into question the perception of the species as being cold-stenothermal.', NULL, 'Charophytes, Chironomidae, Corynocera ambigua, Denmark, late glacial, Palaeolimnology, Zoobenthos', 'article'),
(531, 'Walker and Mathewes 1988', '', 'Wal1988a', 'Walker, I. R. and Mathewes, R.W.', 1988, NULL, NULL, NULL, NULL, NULL, 'Late-Quaternary fossil Chironomidae (Diptera) from Hippa lake, Queen Charlotte Islands, British Columbia, with special reference to Corynocera Zett.', 'Canadian Entomologist', NULL, '120', NULL, '739-751', NULL, NULL, 'cited from {citeID|527|Velle et al. 2005a}', 'Corynocera', 'article'),
(532, 'Brooks 2000', '', 'Bro2000a', 'Brooks, S. J.', 2000, NULL, NULL, NULL, NULL, NULL, 'Late-glacial fossil midge stratigraphies (Insecta: Diptera: Chironomidae) from the Swiss Alps', 'Palaeogeography, Palaeoclimatology, Palaeoecology', NULL, '159', NULL, '261--279', NULL, 'Chironomid midges ( Insecta: Diptera: Chironomidae) are sensitive indicators of environmental change, but relatively few studies have been made of the response of European midge faunas to the high amplitude climatic oscillations of the late-glacial. In this study, late-glacial assemblages of chironomid midges from four Swiss lakes, or former lakes, [ Gerzensee ( 603 m) , Leysin ( 1230 m) , Regenmoos ( 1260 m) and Heremence ( 2300 m)] were compared and contrasted. The study focused on the response of chironomid assemblages to the beginning and end of the Younger Dryas cold interval (c. 12 690 – 11 485 cal. yr BP ) and to minor cold climatic fluctuations (Gerzensee Oscillation, c.13200 – 12800 cal. yr BP, and Preboreal Oscillation, c. 113 65 – 11 100 cal. yr BP ) . The durations of these climatic fluctuations were defined climato-stratigraphically based on oxygen isotope boundaries and the chronology was derived by correlation with GRIP oxygen isotope records. Major di?erences in the composition of the four lakes’ chironomid assemblages reflected di?erences in altitude and local environmental conditions. Nevertheless, each lake fauna showed a marked response to the major and minor climatic oscillations, demonstrating that large-scale temperature change had an overriding influence on the distribution of chironomid midges. ', NULL, 'Alpine lakes, biotic response, Chironomidae, climate change, Gerzensee Oscillation, palaeoecology, palaeolimnology, Preboreal Oscillation, proxy indictors, Younger Dryas', 'article'),
(533, 'Little and Smol 2001', '', 'Lit2001', 'Little, J. L. and Smol, J. P.', 2001, NULL, NULL, NULL, NULL, NULL, 'A chironomid--based model for inferring late---summer hypolimnetic oxygen in southeastern Ontario lakes', 'Journal of Paleolimnology', NULL, '26', '3', '259--270', NULL, 'Hypolimnetic oxygen depletion has been accelerated in many lakes due to cultural eutrophication. However, the extent and magnitude of environmental change is difficult to ascertain due to the lack of historical records. Larval Chironomidae (Diptera) are useful proxy indicators of oxygen, as they show a wide range of tolerances to oxygen conditions and their chitinous head capsules preserve well in lake sediments. Using paleolimnological techniques, chironomid assemblages from the surface sediments of 42 southeastern Ontario lakes were related to environmental conditions. Hypolimnetic oxygen conditions, measured as the average end-of-summer hypolimnetic dissolved oxygen (AvgDO(Summ)), explained the most variation in the chironomid assemblages, whereas dissolved inorganic carbon, the Anoxic Factor, max. depth and total phosphorus concentrations were also correlated with assemblage composition. Based on the relative abundances of 45 chironomid taxa, a robust, partial least squares (PLS) regression transfer function for AvgDO(Summer) was constructed (r2 = 0.74, r2(jack) = 0.58, n = 40). This new transfer function should allow paleolimnologists to directly track past trends in hypolimnetic oxygen levels.', NULL, 'anoxia, Chironomidae, ecology, eutrophication, hypolimnion, oxygen, paleolimnology', 'article'),
(534, 'Luoto 2009', '', 'Luo2009', 'Luoto, T. P.', 2009, NULL, NULL, NULL, NULL, NULL, 'Subfossil Chironomidae (Insecta: Diptera) along a latitudinal gradient in Finland: development of a new temperature inference model', 'Journal of Quaternary Science', NULL, '24', NULL, '150--158', NULL, 'Numerical techniques were used to study chironomid distribution and abundance in lakes from a 1000 km transect in Finland, with special interest on the effect of local summer air temperatures on chironomid assemblages. The ﬁnal aim of the study was to develop a chironomid- based palaeotemperature inference model. The dataset consisted of 82 lakes (of which 77 were used in the model after deletion of outliers), with catchments spanning from boreal coniferous forests to mountain birch woodland and tundra vegetation. Numerical analysis showed that the mean July air temperature was the most signiﬁcant variable explaining the distribution and abundance of chironomids in Finnish lakes. Weighted-averaging partial least squares techniques were used to develop a palaeotemperature inference model for mean July air temperature reconstructions. The model performance statistics were favourable, with cross-validated coefﬁcient of determination (r²) of 0.78, root mean squared error of prediction of 0.721°C and maximum bias of 0.794°C. Based on these values, the transfer function is a valid means of performing quantitative palaeotemperature estimates in downcore studies.', 'ISSN 0267-8179', 'chironomids, Europe: Finnland, lake sediments, palaeoclimatology, training set, transfer functions', 'article'),
(535, 'Birks et al. 2000', '', 'Bir2000', 'Birks, H. H. and Battarbee, R. W. and Birks, H. J. B.', 2000, NULL, NULL, NULL, NULL, NULL, 'The development of the aquatic ecosystem at Kråkenes Lake, western Norway, during the late-glacial and early-Holocene─a synthesis', 'Journal of Paleolimnology', NULL, '23', NULL, '91--114', NULL, 'This paper synthesises the palaeoecological reconstructions, including palaeoclimatic inferences, based on the available fossil record of plants (pollen, macrofossils, mosses, diatoms) and animals (chironomids, Cladocera, Coleoptera, Trichoptera, oribatid mites) in the late-glacial and early-Holocene sediments of Kråkenes Lake, western Norway, with special emphasis on changes in the aquatic ecosystem. New percentage and influx pollen diagrams for selected taxa provide insights into the terrestrial setting. The information from all the proxies is collated in a stratigraphical chart, and the inferred changes in the lake and its catchment are discussed. The individual fossil sequences are summarised by detrended correspondence analysis (DCA), and sample scores on the first DCA axes are plotted against an estimated calendar-year timescale for comparison of the timing and magnitude of changes in assemblage composition. The DCA plots show that the large late-glacial biotic changes were synchronous, and were driven by the overriding forcing factor of temperature. During the early Holocene, however, the changes in different groups were more gradual and were independent of each other, showing that other factors were important and interactive, such as the inwash of dissolved and particulate material from the catchment, the base and nutrient status of the lake-water, and the internal processes of ecosystem succession and sediment accumulation. This multi- disciplinary study, with proxies for changes in the lake and in the catchment, highlights the dependence of lake biota and processes not only on regional climatic changes but also on changes in the lake catchment and on internal processes within the lake. Rates of change for each group are also estimated and compared. The reaction times to the sharp temperature changes at the start and end of the Younger Dryas were very rapid and occurred within a decade of the temperature change. Aquatic organisms tracked the temperature and environmental changes very closely, and are probably the best recorders of late-glacial climatic change in the fossil record.', '[p 105 correct?] whereas the more warmth-adapted taxa like Corynocera oliveri/Tanytarsus lugens, Sergentia coracina, and Arctopelopia which were previously abundant in the Allerød but were absent from the Younger Dryas, expanded rapidly (Brooks, 1997). The expansion of these taxa together with some warmwater chironomids such as Cricotopus, Paracladius, Tanytarsus sp. B, and Corynoneura scutellata agg. slightly before the Younger Dryas boundary may be an expression of the start of warming (Brooks, 1997)', 'didactics: schema lake ecosystem, Holocene, Kråenes, late glacial, northern Fennoscandia', 'article'),
(536, 'Rossaro et al. 2004', '', 'Ros2004', 'Rossaro, B.,  Lencioni, V., Boggero, A. and Marziali, L.', 2004, NULL, NULL, NULL, NULL, NULL, 'Chironomids from running waters of southern Alps: notes on taxonomy, ecology, biogeography', NULL, 'http://users.unimi.it/~roma1999/122Ross_Bogg_Lenc.pdf', NULL, NULL, '1--38', NULL, NULL, 'This paper has not been submitted elsewhere in identical or similar form, nor will it be during the first three months after its submission to Hydrobiologia. Measurements with given minimum + maximum.', 'Alpine region, autecology, biogeography, Chironomidae, high altitude streams, Southern Alps, taxonomy', 'article'),
(537, 'Ekrem 2003', '', 'Ekr2003', 'Ekrem, T.', 2003, NULL, NULL, NULL, NULL, NULL, 'Towards a phylogeny of <em>Tanytarsus</em> van der Wulp (Diptera: Chironomidae). Is morphology alone sufficient to reconstruct the genealogical relationship?', 'Insect Systematics and Evolution', NULL, '34', NULL, '199-219', NULL, NULL, 'cited from {citeID|310|Ekrem 2004}', 'Tanytarsus', 'article'),
(538, 'Lindegaard and Jónasson 1975', '', 'Lin1975', 'Lindegaard, C. and Jónasson, P. M.', 1975, NULL, NULL, NULL, NULL, NULL, 'Life cycles of <em>Chironomus hyperboreus</em> Staeger and <em>Tanytarsus gracilentus</em> (Holmgren) (Chironomidae, Diptera) Lake Mývatn, Northern Iceland', 'Verh. int. Verein. theor. angew. Limnol.', NULL, '19', NULL, '3155-3163', NULL, NULL, 'cited from {citeID|482|Pinder 1986}', 'autecology, Chironomus hyperboreus, life cycle, Tanytarsus gracilentus', 'article'),
(539, 'Caspers 1959', '', 'Cas1959', 'Caspers, H.', 1959, NULL, NULL, NULL, NULL, NULL, 'Vorschläge einer Brackwassernomenklatur (“The Venice System”)', 'Internationale Revue der gesamten Hydrobiologie', NULL, '44', NULL, '312-315', NULL, NULL, 'cited from {citeID|490|Wolf et al. 2009}. In German', 'brackish water classification, classification invertebrates, Invertebrata, Venic System', 'article'),
(540, 'Fabricius 1787', '', 'Fab1787', 'Fabricius, J. C.', 1787, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'not checked for Psectrotanypus varius', 'Psectrotanypus varius', 'no entry type given'),
(541, 'Kurek and Cwynar 2009', '', 'Kur2009', 'Kurek, J. and Cwynar, L.', 2009, NULL, NULL, NULL, NULL, NULL, 'The potential of site-specific and local chironomid-based inference models for reconstructing past lake levels', 'Journal of Paleolimnology', NULL, '42', '1', '37--50', NULL, 'We examined the relationship between three key environmental variables (water depth, loss-on-ignition, and bottom-water temperature) and fossil chironomid distributions sampled from within-lake gradients in three small, moderately deep (18-35 m), maar lakes on St Michael Island, western Alaska. Site-specific (one lake, 29 samples) and local (three lakes, 87 samples) inference models for reconstructing water depth were developed using partial least squares regression and calibration. These models and a previously published regional model (136 lakes, one central-lake sample from each) are used to infer water depths from 78 fossil samples spanning the last ~30,000 ¹⁴C years B.P. at Zagoskin Lake. Although the site-specific [r² boot = 0.90, root mean square error of prediction (RMSEP) = 1.76] and local (r² boot = 0.68, RMSEP = 4.36) inference models have better performance statistics than the regional model, few clear trends among all three models exist in the lake-level reconstruction. We propose that multiple, within-lake sampling of gradients can be used to improve the performance statistics of water-depth transfer functions and ultimately reconstruct paleohydrology in regions known to exhibit large fluctuations in moisture balance through time given that: (1) adequate analogs are established and (2) taphonomic processes important to benthic invertebrate remains are more fully understood.', NULL, 'Alaska, Fossil remains, Keywords Chironomids, Lake level, transfer functions, Water depth', 'article'),
(543, 'Zinchenko et al. 2009', '', 'Zin2009', 'Zinchenko, T. D. and Makarchenko, M. A. and Makarchenko, E. A.', 2009, NULL, NULL, NULL, NULL, NULL, 'A new species of <em>Cricotopus</em> van der Wulp (Diptera, Chironomidae) from a saline river of the El’ton Lake basin (Volgograd Region, Russia)', 'Euroasian Entomological Journal', NULL, '8', '1', '83-88', NULL, 'A new species, Cricotopus salinophilus sp.n., is described and illustrated by male imagines, pupa and larva from the saline Solianka River of the El’ton Lake basin (Volgograd Region, Russia) with water mineralization from 9.0 to 29.5 g/l. The new species, by all stages, is closely related to C. zavreli Szadziewski et Hirvenoja, 1981 from the Ciechocinek saline area in Poland. Ecological data and methodology for raising adults of C. salinophilus sp.n. from larvae in the laboratory are provided.', NULL, 'Chironomidae, Cricotopus salinophilus, Diptera, El’ton Lake basin, lake El''ton, new species', 'article'),
(544, 'Spänhoff et al. 2005', '', 'Spa2005', 'Spänhoff, B., Kaschek, N. and Meyer, E.', 2005, NULL, NULL, NULL, NULL, NULL, 'Laboratory investigation on community composition, emergence patterns and biomass of wood-inhabiting Chironomidae (Diptera) from a sandy lowland stream in Central Europe (Germany)', 'Aquatic Ecology', NULL, '38', '4', '547--560', NULL, 'Wood-inhabiting chironomid communities were investigated from June 1998 to July 1999 by laboratory rearing of randomly collected submerged branches from a headwater and mid-reach site of a sandy lowland stream, separated by an impoundment used for fishery purposes. Total annual emergence (males and females) from headwater samples was higher (2551 ind m⁻² y⁻¹) compared to the mid-reach (1576 ind m⁻² y⁻¹), which could be due to disturbances caused by frequent impoundment openings resulting in high discharge events. Chironomid community from branches comprised three subfamilies, with Orthocladiinae (18 species, 2189 ind m⁻² y⁻¹) clearly predominating at the headwater (total of 36 species). Mid-reach samples (total of 48 species) showed similar emergent numbers of Orthocladiinae (19 species, 786 ind m⁻² y⁻¹) and Chironominae (26 species, 764 ind m⁻² y⁻¹). Tanypodinae were caught very rarely in the laboratory emergence (12 ind m⁻² y⁻¹ at both sites). Shannon-Wiener diversity index for the mid-reach chironomid community was higher (2.52) than for the headwater community (1.68). Chironomid species composition on woody debris was similar between stream sites, with a Sørensen index of 0.75, but showed different dominance structures indicated by a Wainstein index of 0.26. Total adult biomass (in the manner of dry mass) during the study period was higher for wood-dwelling chironomids from the headwater (158.2 mg m⁻² y⁻¹) compared to the mid-reach (123.8 mg m⁻² y⁻¹), but individual biomass was higher for mid-reach chironomids (0.079 mg ind⁻¹ vs. 0.062 mg ind⁻¹ at the headwater), indicating the predominance of larger species. Total biomass of wood-inhabiting chironomids in the investigated lowland stream was low compared to other field emergence studies, which could be attributed to the laboratory approach for investigating the emergence from a single substrate type (submerged wood) instead of the integrative field surveys where chironomids from all habitats were caught. Main reason for the lack of chironomid species closely associated to wood in this sandy lowland stream could be infrequent but episodic disurbances caused by the anthropogenic induced highly fluctuating discharge regime of the downstream study site.', NULL, 'emergence Chironomidae,community composition,chironomid biomass,individual biomass,laboratory emergence,stream impoundment,woody debris', 'article'),
(545, 'Vallenduuk and Moller-Pillot 2007', '', 'Val2007', 'Vallenduuk, H. J. and Moller-Pillot, H. K. M.', 2007, NULL, NULL, NULL, NULL, 'KNNV Publishing, Zeist', 'Chironomidae Larvae of the Netherlands and Adjacent Lowlands. General ecology and Tanypodinae', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'ISBN: 978-90-5011-259-8', 'autecology, determination guide, Tanypodinae', 'book'),
(546, 'Ree and Yum 2006', '', 'Ree2006', 'Ree, H.-I. and Yum, J.-H.', 2006, NULL, NULL, NULL, NULL, NULL, 'Redescription of <i>Chironomus salinarius</i> (Diptera: Chironomidae), nuisance midges that emerged in brackish water of Jinhae-man (Bay), Kyongsangnam-do, Korea', 'The Korean Journal of Parasitology', NULL, '44', '1', '63-66', 'March', 'Huge numbers of non-biting midges emerged from brackish water which were made at the harbor construction field in Jinhae City, Kyongsangnam-do, Korea in late summer in 2005, and caused a serious nuisance to villagers. The midges were collected and identified as <span style=”font-style:italic”>Chironomus salinarius</span> (Kieffer, 1921). Although this species was recorded in Korea for the first time in 1998, the morphological descriptions were so brief and simple. A full redescription is made with detailed illustrations for ecological and control workers of this nuisance midge.', NULL, 'adult male, Chironomus salinarius, redescription, taxonomic literature', 'article'),
(547, 'Walker 1987', '', 'Wal1987', 'Walker, I. R.', 1987, NULL, NULL, NULL, NULL, NULL, 'Chironomidae (Diptera) in paleoecology', 'Quaternary Science Reviews', NULL, '6', '1', '29 - 40', NULL, 'A comprehensive review of chironomid paleoecology is provided, with a discussion of relevant aspects of chironomid biology. The systematics, ecology, morphology, and taphonomy of chironomids are specifically addressed, as is the application of chironomid remains in investigations of lake ontogeny, anthropogenic eutrophication and acidification, paleosalinity, and paleoclimate.', NULL, 'palaeoecology,Chironomidae indicators,didactics: life cycle Chironomidae,review,Chironomidae methodology,methodology', 'article'),
(548, 'Leman and Chebanova 2005', '', 'Lem2005', 'Leman, V. N. and Chebanova, V. V.', 2005, NULL, NULL, NULL, NULL, NULL, 'Response of lithophilic zoobenthos to changes in the granulometric composition of grounds in the metarithral zone of a small river in the foothills of southwestern kamchatka', 'Russian Journal of Ecology', NULL, '63', '2', '103-108', NULL, 'Data on the species composition, abundance, and biomass of macrozoobenthos in the rapids of a small river flowing in the foothills of the southwestern Kamchatka Peninsula are considered along with the results of quantitative analysis of structural rearrangements in the lithophilic community under the effects of changes in the granulometric composition of bottom sediments. Groups of lithophilic and pelophilic invertebrates typical of the metarithral of such rivers (e.g., chironomids of subfamilies Diamesinae and Prodiamesinae) are identified.', NULL, 'bottom sediments, granulometric composition, lithophilic and pelophilic invertebrates, species diversity', 'article'),
(549, 'Larocque 2008', '', 'Lar2008', 'Larocque, I.', 2008, NULL, NULL, NULL, NULL, NULL, 'Nouvelle fonction de transfert pour reconstruire la température à l''aide des chironomides préservés dans les sédiments lacustres', 'Rapport de recherche. Centre - Eau Terre Environnement (Institut National de la Recherche Scientifique)', 'http://www.ete.inrs.ca/pub/R1032_2008.pdf', NULL, 'R1032', NULL, NULL, NULL, NULL, NULL, 'techreport'),
(550, 'Szadziewski and Hirvenoja 1981', '', 'Sza1981', 'Szadziewski, R. and Hirvenoja, M.', 1981, NULL, NULL, NULL, NULL, NULL, '<em>Cricotopus zavreli</em> sp.n. (Diptera, Chironomidae), a halobiontic non-biting midge from Poland', 'Annales Zoologici Fennici', NULL, '47', NULL, '111-118', NULL, NULL, 'Is similar to <em>C.salinophilus</em> in all stages ({citeID|543|Zinchenko et al. 2009})', 'saline habitats,autecology,Cricotopus zavreli', 'article'),
(551, 'Ekrem and Halvorsen 2007', '', 'Ekr2007', 'Ekrem, T. and Halvorsen, G. A.', 2007, NULL, NULL, 'Trond Andersen', NULL, 'Columbus, Ohio: Caddis Press', 'Taxonomy of <em>Tanytarsus lapponicus</em> Lindeberg, 1970, a species with larval mandible of ''lugens-type'' (Diptera: Chironomidae)', 'Contributions to the systematics and ecology of aquatic Diptera: a tribute to Ole A. Sæther', NULL, NULL, NULL, '81-86', NULL, NULL, 'ISBN 0-9667982-3-6', 'Tanytarsus lapponicus', 'inbook'),
(552, 'Aagaard 1978', '', 'Aag1978', 'Aagaard, K.', 1978, NULL, NULL, NULL, NULL, NULL, 'The Chironomidae of the exposed zone of Øvre Heimdalsvatn', 'Holarctic Ecology', NULL, '1', NULL, '261-265', NULL, 'A total of 67 species of chironomids were caught in emergence traps placed at the shoreline. Additional larval records increase the number of species to be at least 75, a high number of species possibly explained by the exposed nature of the lake, which also provides habitats for lotic forms. The species composition and relative abundance of the four main groups of Chironomidae indicate that Ovre Heimdalsvatn is a subarctic lake, with a strong oligotrophic character. The emergence period starts in mid-June and lasts to mid-September. Diversity studies show similarity with mountain lakes in France and with the Bodensee, but the equitability in Ovre Heimdalsvatn is lower. The chironomid faunal composition of Ovre Heimdalsvatn seems to be determined by abiotic ecological factors and not the history of distribution.', NULL, 'emergence behavior, lake Øvre Heimdalsvatn, mountain lakes, Subalpine freshwater system', 'article'),
(553, 'Brooks et al. 2001', '', 'Bro2001', 'Brooks, S. J., Bennion, H., Birks, H. J. B.', 2001, NULL, NULL, NULL, NULL, NULL, 'Tracing lake trophic history with a chironomid-total phosphorus inference model', 'Freshwater Biology', NULL, '46', '4', '513--533', NULL, '<ol><li>In the absence of historical water chemistry data, predictive biological indicator groups preserved in lake sediments can be employed to reconstruct the history of lake eutrophication. Diatoms are well established in this role, but to augment diatom-based inferences of nutrient status we investigate the potential use of chironomid midges (Insecta: Chironomidae).</li>\r\n<li>Canonical correspondence analysis (CCA) of modern chironomid assemblages in surface sediments from 44 lakes in the English Midlands and Wales, U.K., shows that five environmental variables (total phosphorus (TP), bottom dissolved oxygen, maximum lake depth, Secchi depth and surface water temperature) make a statistically significant (<span style=”font-style:italic”>P</span> &lt; 0.05)</li>\r\n<li>The relationship is used to develop a series of weighted averaging (WA) and partial least squares (PLS), (WA-PLS) models to infer log<span style=”vertical-align:sub”>10</span>TP. The models are evaluated by leaveone-out (jack-knifing) cross-validation. The simplest minimal adequate model is provided by WA with unweighted inverse deshrinking of root mean square error of prediction (RMSEP<span style=”vertical-align:sub”>jack</span> = 0.34 and R<span style=”vertical-align:super”>2</span><span style=”vertical-align:sub”>jack</span> = 0.60).</li>\r\n<li>Using this model, the trophic history of Betton Pool, Shropshire, U.K., is reconstructed from the mid-19th century to the present day and the results from the chironomid-TP model are compared with inferences from a diatom-TP model (Bennion, Juggins &amp; Anderson, 1996). Both reconstructions suggest that <span style=”font-weight:600”>there was a gradual rise in TP since 1850 AD until about 1974</span>, followed by a more pronounced and rapid increase that has continued until the present. Inferred TP values from the WA chironomid inference model agree with diatom-inferred values.</li>\r\n<li>The study demonstrates that fossil chironomid assemblages can be used to investigate quantitatively the trophic history of lakes.</li></ol>', NULL, 'Arthropoda, biological indicator, Chironomidae, community structure, Diptera, England, Europe, eutrophication, fossil, freshwater environment, Great Britain, Insecta, interspecific comparison, Invertebrata, lakes, larvae, limnology, models: trophic status, sediments, transfer functions, trophic status, United Kingdom, vertical distribution, wales', 'article'),
(554, 'Ilyashuk and Ilyashuk 2001', '', 'Ily2001', 'Ilyashuk, B. P. and Ilyashuk, E. A.', 2001, NULL, NULL, NULL, NULL, NULL, 'Response of alpine chironomid communities (Lake Chuna, Kola Peninsula, northwestern Russia) to atmospheric contamination', 'Journal of Paleolimnology', NULL, '25', NULL, '467-475', NULL, 'A short sediment core from the deepest part of an alpine lake (Lake Chuna, Kola Peninsula, northwestern Russia), covering about the past 200 yrs of sediment accumulation, was analysed for chironomid head capsule remains. The lake has been receiving acidic precipitation and heavy metals loading from the atmosphere since the 1940’s. A total of 22 chironomid taxa were recorded. The most important taxa were typical elements of oligotrophic lakes, i.e. Micropsectra insignilobus, Paratanytarsus penicillatus, Stictochironomus spp. and Heterotrissocladius marcidus. Based on the cluster analyses results for the reconstructed environmental variables and chironomid communities, three developmental stages were distinguished from the lake history: (1) Natural ontogeny stage (before ~1945); (2) Initial stage of anthropogenic ontogeny (~1945–~1982); and (3) Anthropogenic ontogeny stage (~1982–~1996). During the first period, the changes in the chironomid fauna were characterized as an anthropogenically undisturbed community, with M. insignilobus dominating (46–66%). The changes during the second period reflected the initial phase of anthropogenic succession associated with the beginning of acidification and heavy metal pollution. The\r\nmain species showed opposite distributional patterns in this period; the abundance of the group M. insignilobus/Stictochironomus spp. decreased, whereas the abundance of P. penicillatus/H. marcidus increased. The third period was characterized by a major shift in the faunal assemblages, from M. insignilobus to other dominant species including P. penicillatus (19–30%). The increases of Orthocladiinae relative abundance and total organic content in the uppermost sediment layers may be explained by a decrease in lake productivity. The decreases of cold-stenothermal taxa Stictochironomus spp. and M. insignilobus in the uppermost sediment layers can be explained by the global warming during the 20th century. The lake ecosystem is likely to be affected by both inputs of airborne contaminants and climate changes.', NULL, 'Chironomidae,palaeolimnology,atmospheric contamination,Alpine lakes,climatic changes,Russia,sediment core,acidic precipitation,heavy metals', 'article'),
(555, 'Ilyashuk et al. 2005', '', 'Ily2005', 'Ilyashuk, E.A., Ilyashuk, B.P., Hammarlund, D. and Larocque, I.', 2005, NULL, NULL, NULL, NULL, NULL, 'Holocene climatic and environmental changes inferred from midge records (Diptera: Chironomidae, Chaoboridae, Ceratopogonidae) at Lake Berkut, southern Kola Peninsula, Russia', 'The Holocene', NULL, '15', '6', '897-914', NULL, 'A radiocarbon-dated sediment sequence from Lake Berkut in the southern part of the Kola Peninsula, northwest Russia, was investigated by means of midge analysis in order to reconstruct the Holocene climatic and environmental history of the region. Past mean July air temperatures at the study site and hypolimnetic oxygen contents of the lake water were inferred from chironomid-based transfer functions. The early Holocene (c. 10 100-8400 cal. yr BP) is characterized by summer temperatures and hypolimnetic oxygen concentrations broadly similar to present-day conditions. The midge records give evidence of a lake-level fall at c. 7000 cal. yr BP, resulting in weakened thermal stratification of the lake water, and improvement of the hypolimnetic oxygen conditions. After c. 4000 cal. yr BP midge assemblages suggest a lake-level rise related to increased effective moisture. A secondary mid-Holocene climatic optimum with inferred mean July air temperatures of c. 12.1 °C was recorded between 6000 and 4400 cal. yr BP, followed by minimum values (c. 11.3°C) between 3500 and 1500 cal. yr BP, accompanied by the onset of natural acidification of the lake. The late-Holocene midge assemblages suggest weakly acidic conditions, low hypolimnetic oxygen contents and a general warming trend during the last c. 1500 years, although paludification and natural acidification may have influenced the temperature reconstruction at this stage. However, the modern chironomid-inferred mean July air temperature (12.5°C) is consistent with meteorological data from a nearby station. In general, the midge records reflect relatively warm and moist conditions at Lake Berkut before c. 7000 cal. yr BP, a relatively warm and dry climate at c. 7000- 4000 cal. yr BP, and a shift to cooler and wetter climatic conditions in the region after c. 4000 cal. yr BP.', NULL, 'palaeoclimate,lake sediments,insect remains,Diptera,July air temperature,effective moisture,polimnetic oxygen content,Kola Peninsula,Russia,Holocene', 'article'),
(556, 'Ilyashuk et al. 2007', '', 'Ily2007', 'Ilyashuk, B. P. and Ilyashuk, E. A.', 2007, NULL, NULL, NULL, NULL, NULL, 'Chironomid record of Late Quaternary climatic and environmental changes from two sites in Central Asia (Tuva Republic, Russia)~-- local, regional or global causes?', 'Quaternary Science Reviews', NULL, '26', NULL, '705-731', NULL, 'Sediment cores from two mountain lakes (Lake Grusha at 2413 m a.s.l. and Ak-Khol at 2204 m a.s.l.) situated in the Tuva Republic (southern Siberia, Russia), just north of Mongolia, were studied for chironomid fossils in order to infer post-glacial climatic changes and to investigate responses of the lake ecosystems to these changes. The results show that chironomids are responding both to temperature and to changing lake depth, which is regarded as a sensitive proxy of regional effective moisture. The post-glacial history of this mountain region in Central Asia can be divided into seven successive climatic phases: the progressive warming during the last glacial–interglacial transition (ca 15.8–14.6 cal kyr BP), the warm and moist Bølling-Allerød-like interval (ca 14.6–13.1 cal kyr BP), the cool and dry Younger Dryas-like event (ca 13.1–12.1 cal kyr BP), warmer and wetter conditions during ca 12.1–8.5 cal kyr BP, a warm and dry phase ca 8.5–5.9 cal kyr BP, cold and wet conditions during ca 5.9–1.8 cal kyr BP, as well as cold and dry climate within the last 1800 years. The chironomid records reveal patterns of climatic variability during the Late-glacial and Holocene, which can be correlated with abrupt climatic events in the North Atlantic and the Asian monsoon-dominated regimes. Apparently, the water balance of the studied lakes is controlled by the interrelation between the dominant westerly system and the changing influence of the summer monsoon, as well as the influence of alpine glacier meltwater supply. It is possible that monsoon tracks could have reached the southwest Tuva, resulting in an increase in precipitation at ca 14.6–13.1 and ca 12.1–8.5 cal kyr BP, whereas cyclonic westerlies from the North Atlantic were likely responsible for considerable moisture transport accompanying the global Neoglacial cooling at ca 5.9–1.8 cal kyr BP. These events suggest the changes of the regional pattern of atmospheric circulation, which could be in turn induced by the global climatic shifts. Some discrepancies compared with other reconstructions from Central Asia may be associated with regional (spatial) differences between the changing predominant circulation mechanisms and with local differences in uplift and descent of air masses within the complicated mountain landscape. In this paper, we also discuss the possibilities and perspectives for using chironomids in reconstructions of past temperatures and climate-induced changes in water depth of lakes in Central Asia.', NULL, 'climate reconstruction, Mongolia, paleoclimate, paleoenvironment, transfer functions', 'article'),
(557, 'Gandouin et al. 2006', '', 'uin2006', 'Gandouin, E., Maasri, A., van Vliet-Lanoé, B.  and Franquet, E.', 2006, NULL, NULL, NULL, NULL, NULL, 'Chironomid (Insecta: Diptera) assemblages from a gradient of lotic and lentic waterbodies in river floodplains of France: a methodological tool for paleoecological applications', 'Journal of Paleolimnology', NULL, '35', NULL, '149-166', NULL, 'The chironomid species inhabiting a natural dead arm (the Pilet dead Arm), two artificial backwaters (the Saxy Dyke field and the Ranchier Dyke Field) and the main channel of the lower Rhône River (South of France) were studied. A between-class (between-station) Correspondence Analysis (CA) showed that, on the scale of the alluvial plain, habitat is a major factor influencing the species assemblages. The assemblage composition on the transversal floodplain gradient was compared with existing data on assemblages from the main channel of the Garonne River (South of France) and three of its floodplain waters (two side arms and one oxbow lake). In order to work at the level of taxonomic determination commonly used in paleoecological studies, the overall dataset (lower Rho? ne + Garonne) was analyzed to the genus level. The genus level analysis confirmed that chironomid assemblages can be used to characterize the connectivity of small waterbodies with the main river channel and 44 chironomid genera were classified according to their hydrological preferences (lentic habitat taxa, ubiquitous taxa and lotic habitat taxa). This classification was then applied to a paleoecological dataset from the Saint-Omer basin (North of France) in order to test the potential of chironomids for paleoecological studies on fluvial environments. The results presented here highlighted this potential and indicate that river chironomid assemblages can be used as descriptors for alluvial habitats, and allow researchers to evaluate the level of connectivity of these habitats with the main river channel during floods. River chironomid assemblages are a promising tool for reconstructing past hydrological changes and for obtaining information on paleoflood periodicity.', NULL, 'Aa River, Ablabesmyia longistyla, Brillia flavifrons, Brillia modesta, Cardiocladius fuscus, Chircnomus Pe 17, Chironomidae, Chironomus annularius, Chironomus bernensis, Chironomus luridus, Chironomus nuditarsis, Chironomus Pe4, Chironomus Pe17, Chironomus plumosus, Chironomus pseudothummi, Chironomus riparius, Cladopelma virescens, Cladotanytarsus mancus, Conchapelopia Pe 1, Cricotopus annulator, Cricotopus bicinctus, Cricotopus curtus, Cricotopus sylvestris, Cricotopus triannulatus, Cricotopus trifascia, Cricotopus vierriensis, Cryptochironomus rostratus, Cryptochironomus supplicans, Cryptotendipes usmaensis, Cunchapelopia Pe1, Demicryptochironomus (irmakia) sp. 3, Dicrotendipes nervosus, Dicrotendipes notatus, didactics: sheme lotic-lentic species, Endochironomus albipennis, Eukiefferiella claripennis, Eukiefferiella clypeata, Eukiefferiella ilkleyensis, Eukiefferiella lobifera, floodplain, Garonne River, Glyptotendipes pallens, Glyptotendipes signatus, habitats, Harnischia curtilamellata, Hayesomyia tripunctata, Heleniella serratosioi, Kiefferulus tendipediformis, Kloosia pussila, lentic species, Limnophyes sp., Lipiniella araenicola, Lipiniella arenicola, lotic species, Micochironomus tener, Microchironomus tener, Micropsectra atrofasciata, Microtendipes chloris, Nanocladius bicolor, Nanocladius distinctus, Nanocladius rectinervis, Orthocladius ashei, Orthocladius oblidens, Orthocladius pedestris, Orthocladius rivulorum, Orthocladius rubicundus, paleoecology, Parachironomus arcuatus, Parachironomus frequens, Paracladius conversus, Paracladius conversusl, Paracladopelma mikiana, Parakiefferiella smolandica, Parakiefferiella wulkeri, Paralauterborniella nigrohalteralis, Paratanytarsus dissimilis, Paratendipes albimanus, Paratrichocladius rufiventris, Phaenopsectra flavipes, Phaenospectra flavipes, Polypedilum aegyptium, Polypedilum cultellatum, Polypedilum nubeculosum, Polypedilum nubifer, Polypedilum pedestre, Polypedilum quadriguttatum, Polypedilum sordens, Potthastia longimanus, Procladius choreus, Procladius sagittalis, Prodiamesa olivacea, Psectrocladius brehmi, Rhône River, Rheocricotcpus atripes, Rheocricotopus atripes, Rheocricotopus fucipes, Rheorthocladius ruffoi, Rheotanytarsus photophilus, Rheotanytarsus rhenanus, Stenochircnomus gibbus, Stenochironomus gibbus, Stictochironomus maculipennis, Synorthocladius semivirens, Tanypus punctipennis, Tanytarsus brundini, Tanytarsus ejuncidus, Tanytarsus eminulus, Tanytarsus heusdensis, Tanytarsus mendax, Tanytarsus pallidicornis, Thienemanniella sp., Tvetenia calvescens, Tvetenia verralli, Virgatanytarsus arduennensis, Xenochironomus xenolabis', 'article'),
(558, 'Oliver et al. 1990', '', 'Oli1990', 'Oliver, D.R., Dillon, M.E. and Cranston, P.S.', 1990, NULL, NULL, NULL, NULL, 'Canadian Government Publishing Centre, Ottawa, Canada', 'A Catalog of Nearctic Chironomidae: Publication 1857/B', NULL, NULL, NULL, NULL, '89', NULL, NULL, 'ISBN: 0-660-55839-4; Tanytarsus dissimilis as Synonym for Paratanytarsus dissimilis ([[http://www.itis.gov/servlet/SingleRpt/SingleRpt?search_topic=TSN&search_value=129990 ITIS]])', 'Catalog Chironomidae, Nearctic Chironomidae', 'book'),
(559, 'Rosenberg 1992', '', 'Ros1992a', 'Rosenberg, D. M.', 1992, NULL, NULL, NULL, NULL, NULL, 'Freshwater biomonitoring and Chironomidae', 'Aquatic Ecology', NULL, '26', '2-4', '101-122', 'July', 'The use of Chironomidae in the biomonitoring of fresh waters is reviewed. Examples are given for levels of organization from organism to ecosystem, and a separate consideration is devoted to toxicity studies. Morphological deformities and life-history responses of Chironomidae to contaminants are common organism-level indicators. At the species-assemblage level, the classic lake trophic classification scheme, its contemporary derivatives, and paleolimnological approaches have been used extensively. Chironomidae also are essential components of quantitative and qualitative (rapid assessment) community approaches to biomonitoring. Examples of chironomids as components of ecosystem-level studies are rare, but even the few studies done show their value for this purpose. In toxicity testing, Chironomidae frequently are used in single species acute, single species chronic, and multispecies tests for a variety of stressors; Chironomidae could be used profitably in any expansion of toxicity testing involving macroinvertebrates. The review indicated that more emphasis on Chironomidae is required in studies of biochemical and physiological indicators of contaminants (organism level), and on Chironomidae as sentinel organisms (population level). Extensive use of Chironomidae in biomonitoring of fresh waters is consistent with the abundance and taxa richness of this group in natural habitats.', NULL, 'autecology, community, ecosystem, organism, population, review, toxicity studies', 'article');
INSERT INTO `names_authors` (`id`, `authors_short`, `literal`, `author_filename`, `author_names`, `year`, `author_mail`, `author_address`, `editor_name`, `edition`, `publisher_name`, `title`, `journal`, `journal_url`, `volume`, `number`, `page`, `month`, `abstract`, `note`, `keywords`, `entry_type`) VALUES
(560, 'Malo et al. 1998', '', 'Mal1998', 'Malo, J., Morais, M. and Pinto, P.', 1998, NULL, NULL, NULL, NULL, NULL, 'A contribution to the knowledge of the chironomid fauna (Diptera) in southern Portugal', 'Annales de Limnologie', NULL, '34', '2', '165-170', NULL, 'For the first time, a faunal list of 89 species of Chironomidae is presented for the South of Portugal, using data from drift samples taken in 12 rivers and streams. 35 species of Chironomidae are new for Portugal. The more important biogeographic result is the appearance of various mediterranean species -as Paramerina spec. Griechenland, Tanytarsus Pe23 Langton 1991 and Virgatanytarsus albisutus-; this last specie was not previously known from the Iberian Peninsula.', NULL, 'Ablabesmyia longistyla, Ablabesmyia monilis, Brillia modesta, Bryophaenocladius ictericus, Cardiocladius fuscus, chironomid fauna, Conchapelopia melanops, Corynoneura lobata, Cricotopus annulator, Cricotopus bicinctus, Cricotopus festivellus, Cricotopus ornatus, Cricotopus sylvestris, Cricotopus tibialis, Cricotopus tricinctus, Cricotopus trifascia, Cricotopus trifasciatus, Eukiefferiella brevicalcar, Eukiefferiella clypeata, Limnophyes minimus, Macropelopia adaucta, Macropelopia nebulosa, Nanocladius rectinervis, Nilotanypus dubius, Orthocladius fuscimanus, Orthocladius rivicola, Orthocladius rivulorum, Parakiefferiella bathophila, Paramerina divisa, Paramerina sp. Griechenland, Paramerina sp. Griechenland, Parametriocnemus stylatus, Paratrichocladius rufiventris, Portugal, Potthastia gaedii, Procladius choreus, Prodiamesa olivacea, Psectrocladius limbatellus, Psectrocladius obvius, Psectrocladius sordidellus, Rheocricotopus atripes, Rheocricotopus chalybeatus, Synorthocladius semivirens, Tanypus punctipennis, Tanytarsus Pe23 Langton 1991, Thienemanniella clavicornis, Virgatanytarsus albisutus', 'article'),
(561, 'Berezina 2001', '', 'Ber2001', 'Berezina, N. A.', 2001, NULL, NULL, NULL, NULL, NULL, 'Influence of ambient pH on freshwater invertebrates under experimental conditions', NULL, NULL, '32', '5', '343-351', NULL, 'In experimental mesocosms differing in water pH, the communities of macroinvertebrates demonstrated marked differences in their species composition and the quantitative ratios between the main groups of members (oligochaetes, chironomids, mollusks, etc.). The highest species diversity was recorded at pH 4.09-8.65. It proved to decrease at pH below 4 and above 9. In experiments on determining tolerance to water pH, seven groups of invertebrates differing in their adaptive potential were distinguished among 40 species found en masse in the freshwater zoobenthos and zooperiphyton of the Upper Volga basin.', 'Translated from Ekologiya, No. 5, 2001, pp. 372-381', 'macroinvertebrates, pH ,experimental mesocosms ,tolerance', 'article'),
(562, 'Palmén 1960', '', 'Pal1960', 'Palmén, E.', 1960, NULL, NULL, NULL, NULL, NULL, '<em>Paratanytarsus</em>-Arten (Diptera, Chironomidae) aus dem mesohalinen und oligohalinen Brackwasser der finnischen Meerbusens [sic]', 'Ann. ent. Fenn.', NULL, '26', NULL, '280-291', NULL, NULL, 'cited from {textciteID|14|Klink 1983}', 'brackish water, Finnland, Paratanytrasus', 'article'),
(563, 'Reiss 1968', 'b', 'Rei1968a', 'Reiss, F.', 1968, NULL, NULL, NULL, NULL, NULL, 'Ökologische und systematische Untersuchungen an Chironomiden des Bodensees [Ecological and systematic investigations on chironomids from lake Bodensee]', 'Archiv für Hydrobiologie', NULL, '64', NULL, '176-323', NULL, NULL, 'in German, cited from {textciteID|14|Klink 1983}', 'ecological studies, systematic studies', 'article'),
(564, 'Lehmann 1971', '', 'Leh1971', 'Lehmann, J.', 1971, NULL, NULL, NULL, NULL, NULL, 'Die Chironomiden der Fulda [The chironomids of the river Fulda]', 'Archiv für Hydrobiologie, Supplement', NULL, '37', NULL, '466-555', NULL, NULL, 'cited from {textciteID|14|Klink 1983}', NULL, 'article'),
(565, 'Bitušík et al. 2006', '', 'Bit2006', 'Bitušík, P., Svitok, M., Kološta, P., Hubková, M.', 2006, NULL, NULL, NULL, NULL, NULL, 'Classification of the Tatra Mountain lakes (Slovakia) using Chironomids (Diptera, Chironomidae)', 'Biologia Supplement', NULL, '61', '18', '191-201', NULL, 'Chironomid assemblages in thirty-three mountain lakes situated above tree line in the Slovakian part of the Tatra Mountains were studied during 2000–2002. Chironomid species/taxa, collected as pupal exuviae, were correlated with physical, chemical, and lake morphometry variables of 22 lakes. Two-way indicator species analysis (TWINSPAN) was used to classify the lakes into four distinct groups: higher situated alpine lakes, lower situated alpine lakes, subalpine lakes and acidified lakes. Presence/absence of eight taxa was identified as indicative for this classification. In discriminant function analysis, pH, dissolved organic carbon, altitude and lake area were the most significant variables reflecting differences among groups of lakes. This model of four variables allowed 77% success in the prediction of group membership. A multiple regression model with lake area, concentration of magnesium and total phosphorus accounted for 37% of the variance in taxa richness. Lakes with greater area contained more chironomid taxa than smaller ones. Lakes with higher alkalinity and higher trophic status tend to support more taxa. Canonical correspondence analysis (CCA) indicated that most variation in the composition of chironomid assemblages was related to pH and to altitude. The results can be used as reference data for long-term monitoring of the Tatra lakes, especially in connection with a recovery from acidification and global climatic change.', NULL, 'Chironomidae, classification, heigh altitude, indication, mountain lakes, pupal exuviae, Slovakia, Tatra Mountains', 'article'),
(566, 'Moller-Pillot and Buskens 1990', '', 'Mol1990a', 'Moller-Pillot, H. K. M. and Buskens, R.F.M.', 1990, NULL, NULL, NULL, NULL, NULL, 'De larven ven der NEderlandse Chironomidae (Diptera). Deel C: Autekologie en verspreiding [The larvae of the Netherlands Chironomidae (Diptera). Part C: Autecology and distribution]', 'Nederlandse Faunistische Mededelingen', NULL, '1', 'C', '1-85', NULL, NULL, NULL, 'autecology', 'article'),
(567, 'Brodin 1986', '', 'Bro1986', 'Brodin, Y.W.', 1986, NULL, NULL, NULL, NULL, NULL, 'The postglacial history of Lake Flarken, southern Sweden, interpreted from subfossil insects remains', 'Internationale Revue der gesamten Hydrobiologie', NULL, '71', '3', '371-432', NULL, 'A correlation of changes in the composition of chironomid and chaoborid remains and changes in sediment chemical composition, floristic, and other faunistic information indicate that a decreasing productivity and an increasing humic level characterized the development of the small Lake Flarken, Southern Sweden, during the postglacial period. Pronounced changes in the fauna were correlated with fluctuations of the water level in the lake, which was caused by changes in the humidity of the climate. Significant human influence on the lake has only occurred in recent years, during which a rapid acidification has caused the most dramatic change in the fauna, by far, in the whole history of the lake.', NULL, 'Chironomidae, climatic change, diversity - stability, eutrophy - oligotrophy, lake development, postglacial', 'article'),
(568, 'Ilyashuk and Ilyashuk 2000', '', 'Ily2000', 'Ilyashuk, B. P. and Ilyashuk, E. A.', 2000, NULL, NULL, NULL, NULL, NULL, 'Palaeoecological analysis of chironomid assemblages of a mountain lake as a source of information for biomonitoring', 'Russian Journal of Ecology', NULL, '31', NULL, '353-358', NULL, 'The results of paleoecological analysis of chironomid remains in bottom sediments of a mountain lake exposed to atmospheric pollution with acidifying compounds and heavy metals are described. With consideration of the reconstructed chironomid assemblages, it is demonstrated that the course of natural lake ontogeny has been tending to change since the beginning of industrial development in the region. Chironomid taxa promising as indicators for biological monitoring are discussed.', NULL, 'acidification, Chironomidae, heavy metals, mountain lake, paleolimnology', 'article'),
(569, 'Uutala 1986', '', 'Uut1986', 'Uutala, A.J.', 1986, NULL, NULL, NULL, NULL, NULL, 'Palaeolimnological assessment of the effects of lake acidifikation on Chironomidae (Diptera) assemblages in the Adirondack region of New York', 'PhD thesis. State University of NEw York College of Environmental Science and Forestry, Syracuse, N.Y.', NULL, NULL, NULL, '156', NULL, NULL, 'cited from {textciteID|302|Brooks et al. 2007}', NULL, 'phdthesis'),
(570, 'Krebs and Moller-Pillot n.d.', '', 'Kren.d.', 'Krebs, B. P. M. and Moller-Pillot, H. K. M.', 0, NULL, NULL, NULL, NULL, NULL, 'Influence of some environmental factors on the abundance of Chironomidae in a predominantly brackish water area', 'Part of description of main species ecology', NULL, NULL, NULL, NULL, NULL, NULL, 'Unpublished. Netherlands Institute of Ecology, Centre for Estuarine and Coastal Ecology, Yerseke, Netherlands (cited from {citeID|477|Vallenduuk and Moller-Pillot 1999})', NULL, 'unpublished'),
(571, 'Henrikson et al. 1982', '', 'Hen1982', 'Henrikson, L., Olofsson, J. B., Oscarson, H. G.', 1982, NULL, NULL, NULL, NULL, NULL, 'he impact of acidification on Chironomidae (Diptera) as indicated by subfossil stratification', 'Hydrobiologia', NULL, '86', '3', '223--229', NULL, 'The impact of acidification on the chironomid profundal fauna was studied by comparing chironomid head capsule deposits from different sediment layers. The 14–15 cm level was regarded as relatively unaffected by acid precipitation and therefore used as a control. The total number of capsules decreased, especially the number of Tanytarsinii capsules, from deeper to more superficial layers. <span style=”font-style:italic”>Phaenopsectra</span> and <span style=”font-style:italic”>Psectrocladius</span> showed a relative increase towards the surface level of the sediment. Probable causes for these changes are discussed.', NULL, 'acidification, cosmopolitanism, Ephemeroporus, Florida, indication Chironomidae, Louisiana, species groups', 'article'),
(572, 'Konstantinov 1971', '', 'Kon1971', 'Konstantinov, A. S.', 1971, NULL, NULL, NULL, NULL, NULL, 'Ecological factors affecting respiration in chironomid larvae', 'Limnologica', NULL, '8', NULL, '127--134', NULL, NULL, 'cited in {textciteID|482|Pinder 1986}', 'indication: Chironomids, respiration', 'article'),
(574, 'Heinis 1993', '', 'Hei1993', 'Heinis, F.', 1993, NULL, NULL, NULL, NULL, NULL, 'Oxygen as afactor controllinmg occurence and distribution of chironomid larvae', 'Thesis, Amsterdam', NULL, NULL, NULL, '155+16pp', NULL, NULL, 'cited from {textciteID|8|Vallenduuk 1997}', 'Chironomidae: biology, distribution Chironomidae, oxygen regime', 'phdthesis'),
(575, 'Hofmann 1984', 'b', 'Hof1984a', 'Hofmann, W', 1984, NULL, NULL, NULL, NULL, NULL, 'Stratigraphie subfossiler Cladoceren (Crustacea) und Chironomidae (Diptera) in zwei Sedimentprofilen des Meerfelder Maares', 'Courier Forschungs Institut Senckenberg', NULL, '65', NULL, '67-80', NULL, NULL, 'cited from {textciteID|302|Brooks et al. 2007}', 'stratigraphy, subfossil chironomids', 'article'),
(576, 'Kansanen 1985', '', 'Kan1985', 'Kansanen, P.H.', 1985, NULL, NULL, NULL, NULL, NULL, 'Assessment of pollution history from recent sediments in Lake Vanajavesi, southern Finland. II. Changes in the Chironomidae, Chaoboridae and Ceratopogonidae (Diptera) fauna.', 'Annales Zoologici Fennici', NULL, '22', '1', '57-90', NULL, 'The subfossil remains of chironomids, chaoborids and ceratopogonids were analyzed from four short sediment profiles with the object of using them as palaeolimnological indicators of the development of Lake Vanajavesi during the industrial period of its history in the 19th and 20th centuries. A succession from an oligotrophic Microspectra - Monodiamesa community, through a eutrophic Chironomus anthracinus community, to a Chironomus plumosus community, was detected. A redeposition of shallow-water fauna on the deepwater bottoms was the most important factor affecting the composition and abundance of the subfossil fauna in the profiles. In this case the midge analysis indicates conditions in the littoral zone. The increase in numbers of littoral chironomids such as Limnophyes spp. was connected with the artificial lowering of lake water levels in the 18th and 19th centuries. Midge analysis was found to be a useful palaeolimnological technqiue for indicating not only the typological development of the lake but also the past water level changes in the lake basin.', 'cited from {textciteID|302|Brooks et al. 2007}', 'bioindicators, Ceratopogonidae, Chaoboridae, Chironomidae, community composition, Diptera, ecological succession, ecology, freshwater pollution, historical ecology, indicator species, limnology, paleolimnology, pollution effects, water pollution', 'article'),
(577, 'Sæther 1979', '', 'Sae1979', 'Sæther, O. A.', 1979, NULL, NULL, NULL, NULL, NULL, 'Chironomid communities as water quality indicators', 'Holarctic Ecology', 'http://doi.wiley.com/10.1111/j.1600-0587.1979.tb00683.x', '2', NULL, '65-74', NULL, 'Recent mathematical indices summarizing biological communities of indicators are recapitulated. Improvements of these indices based on weighting according to width of trophic ranges of each species are suggested. Their principle deficiencies, however, are pointed out. Revised lists of characteristic profundal as well as littoral and sublittoral chironomids in Nearctic and Palearctic lakes show that at least 15 characteristic chironomid species communities can be delineated, 6 in each of the oligotrophic and the eutrophic ranges and 3 in the mesotrophic range. It is proposed that these communities be lettered consecutively in the Greek alphabet from α (alpha) to ο (omikron). A key to the 15 divisions based on the species associations in the profundal zone of harmonic lakes is put forward. There is very good correlation between the 15 divisions and the ratios of average total phosphorus to mean lake depth and average chlorophyll a to mean lake depth. The ratio of chironomids to oligochaetes and the distribution patterns of single species have proven useful in pin-pointing localized areas of pollution. The primary mechanism governing the distribution of chironomid communities in oligotrophic and mesotrophic lakes appears to be the availability of food materials rather than the annual hypolimnetic oxygen concentration. In eutrophic lakes the relationships between organic matter accumulation and oxygen levels are so interdependent as to be inseparable.', NULL, 'Chironomidae indicators, community structure, water quality', 'article'),
(578, 'Langdon et al. 2006', '', 'Lan2006', 'Langdon, P. G., Ruiz, Z., Brodersen, K. P. and Foster, I. D. L.', 2006, NULL, NULL, NULL, NULL, NULL, 'Assessing lake eutrophication using chironomids: understanding the nature of community response in different lake types', 'Freshwater Biology', NULL, '51', '3', '562--577', NULL, '1. Total phosphorus (TP) and chlorophyll a (Chl a) chironomid inference models ( Brodersen & Lindegaard, 1999; Brooks, Bennion & Birks, 2001) were used in an attempt to reconstruct changes in nutrients from three very different lake types. Both training sets were expanded, particularly at the low end of the nutrient gradient, using contemporary chironomid assemblages and environmental parameters from 12 British lakes, although this had little improvement on the model performances. \r\n\r\n2. Dissimilarity analyses showed that the historic chironomid assemblages did not have good analogues in the original calibration or extended datasets. However, since the transfer functions are based on weighted averages of the trophic optima for the taxa present and not on community similarities, reasonable downcore inferences were produced. Ordination analyses also showed that the lakes retain their `identity’ over time, as the sample dissimilarities within lakes were less than the dissimilarities between lakes.\r\n\r\n3. Analysis of the three historic lake profiles showed a range of chironomid community responses to lake development. Chironomids from a shallow lake, Slapton Ley, responded indirectly to nutrient enrichment (TP), probably through altered substrate, macrophyte and fish conditions, rather than directly to primary productivity (Chl a). A stratified lake, Old Mill Reservoir, showed a loss of the profundal chironomid fauna due to increasing primary productivity (Chl a) coupled with increasing hypoxia. A response to nutrients (TP or total nitrogen (TN) ) at this site is also indirect, and the TP reconstruction therefore cannot be reliably interpreted. The third lake, March Ghyll Reservoir has little change in historic chironomid communities, suggesting that this well mixed, relatively unproductive lake has changed less than the other lakes. \r\n\r\n4. Using chironomids to reconstruct nutrient histories does not follow a simple scheme. The response to changes in nutrients may be direct, but mediated through other ecosystem components. As alternative stable states are possible at a given level of TP it is also likely that alternative chironomid communities exist under similar nutrient conditions. Changes in biological communities can thus occur over thresholds, and it is only biological proxies that can reflect such ecosystem switches within palaeoenvironmental investigations.', NULL, 'chironomids, chlorophyll a, eutrophication, indication Chironomidae, lake types, total phosphorus, transfer functions', 'article'),
(579, 'Heiri 2001', '', 'Hei2001', 'Heiri, O.', 2001, NULL, NULL, NULL, NULL, NULL, 'Holocene palaeolimnology of Swiss mountain lakes reconstructed using subfossil chironomid remains: past climate and prehistoric human impact on lake ecosystems', 'PhD thesis. University of Bern.', NULL, NULL, NULL, '113', NULL, NULL, 'cited from {textciteID|302|Brooks et al. 2007}', 'Alpine lakes, mountain lakes, transfer functions, transfer functions: Chironomidae, transfer functions: temperature', 'phdthesis'),
(580, 'Brooks and Birks 2001', '', 'Bro2001a', 'Brooks, S. J. and Birks, H. J. B.', 2001, NULL, NULL, NULL, NULL, NULL, 'Chironomid-inferred air temperatures from Lateglacial and Holocene sites in north-west Europe: progress and problems', 'Quaternary Science Reviews', NULL, '20', '16-17', '1723-1741', 'October-November', 'Non-biting midges (Insecta: Diptera: Chironomidae) are now widely recognised as powerful biological proxies for inferring past climatic change. In this paper the response of chironomid assemblages to Lateglacial and Holocene climatic change from sites in Scotland and Norway is discussed. Analyses have shown that midge assemblages have responded to major and minor climatic fluctuations during the last 15,000 yr, such as the Aegelsee Oscillation, Gerzensee Oscillation and Younger Dryas in the Lateglacial, and the thermal optimum, “Little Ice Age” and cooling events at 8.2 and 2.0 cal ka BP in the Holocene. In an attempt to quantify these and other climatic fluctuations a chironomid-mean July air temperature inference model, based on a modern calibration set of 109 lakes in Norway and Svalbard, has been developed. The 3-component weighted averaging partial least squares inference model performs well with a root mean squared error of prediction of 0.90°C and a maximum bias of 0.59°C (both based on leave-one-out cross-validation) which is lower than chironomid-temperature inference models developed in Canada, Switzerland and Finland. However, while temperature-inference models perform well in the Lateglacial, the more subtle climatic changes of the Holocene are more difficult to reconstruct because the likely temperature changes are close to the limits of the prediction errors of the existing models. To address this problem, future work is required to refine and develop the calibration set by further improving taxonomic resolution, by adding more lakes to the calibration set and by investigating the influence of other environmental variables on chironomid distributions and abundances.', NULL, 'air temperatures, Holocene, inferred air temperatures, Lateglacial, review', 'article'),
(581, 'Dettinger-Klemm 2000', '', 'Det2000', 'Dettinger-Klemm, P.-M. A.', 2000, NULL, NULL, 'Hoffrichter, O.', NULL, 'Schaker (Aachen)', 'Influence of temperature and photoperiod on development in three species of Chironomidae (Diptera) – <i>Chironomus dorsalis</i> Meigen, 1818, <i>Polypedilum uncinatum</i> (Goetghebuer, 1921) and <i>Paralimnophyes hydrophilus</i>, (Goetghebuer, 1921) - living in temporary pool', 'In: Late 20th Century research on Chironomidae. An antology from the 13th International Symposium on Chironomidae', NULL, NULL, NULL, '295-312', NULL, NULL, NULL, 'Chironomus dorsalis, Paralimnophyes hydrophilus, Polypedilum uncinatum, temporary pools', 'article'),
(582, 'Strenzke 1959', '', 'Str1959', 'Strenzke, K.', 1959, NULL, NULL, NULL, NULL, NULL, 'Revision der Gattung <i>Chironomus</i> Meig. I. Die Imagines von 15 norddeutschen Arten und Unterarten [Revision of the genus <i>Chironomus</i> Meig. I. The imagines of 15 northern German species and subspecies]', 'Archiv für Hydrobiologie', NULL, '56', NULL, '1-42', NULL, NULL, 'cited from {textciteID|8|Vallenduuk et al. 1997}', 'Chironomus sp., imagines, revision', 'article');

-- --------------------------------------------------------

--
-- Table structure for table `names_genera`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_genera`;
CREATE TABLE IF NOT EXISTS `names_genera` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID is set automatically',
  `name` varchar(60) NOT NULL COMMENT 'unique genus name',
  `name_short` varchar(7) NOT NULL COMMENT 'unique short genus name 4 letters (optional +[X[X[X]]] letters)',
  `tacosy` varchar(4) DEFAULT NULL COMMENT 'can be NULL: short name of Taxa Coding System (Schnell et.al. 1999)',
  `redundant` tinyint(2) DEFAULT NULL COMMENT 'can be NULL: old invalid names',
  PRIMARY KEY (`id`),
  UNIQUE KEY `genus_short` (`name_short`),
  UNIQUE KEY `genus` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='all genera names' AUTO_INCREMENT=276 ;

--
-- Dumping data for table `names_genera`
--

INSERT INTO `names_genera` (`id`, `name`, `name_short`, `tacosy`, `redundant`) VALUES
(1, 'Abiskomyia', 'Abis', NULL, NULL),
(2, 'Ablabesmyia', 'Abla', NULL, NULL),
(3, 'Acamptocladius', 'Acam', NULL, NULL),
(4, 'Acricotopus', 'Acri', NULL, NULL),
(6, 'Anatopynia', 'Anat', NULL, NULL),
(7, 'Apsectrotanypus', 'Apse', NULL, NULL),
(8, 'Arctopelopia', 'Arct', NULL, NULL),
(9, 'Axarus', 'Axar', NULL, NULL),
(10, 'Boreochlus', 'Boch', 'Boro', NULL),
(11, 'Boreoheptagyia', 'Borh', NULL, NULL),
(12, 'Boreosmittia', 'Bosm', 'Bore', NULL),
(13, 'Brillia', 'Bril', NULL, NULL),
(15, 'Bryophaenocladius', 'Bryo', NULL, NULL),
(16, 'Buchonomyia', 'Buch', NULL, NULL),
(17, 'Camptocladius', 'Cacl', 'Camp', NULL),
(18, 'Cardiocladius', 'Card', NULL, NULL),
(19, 'Chaetocladius', 'Chae', NULL, NULL),
(20, 'Chironomus', 'Chir', NULL, NULL),
(22, 'Cladopelma', 'Clpe', 'Clad', NULL),
(23, 'Cladotanytarsus', 'Clta', 'Clat', NULL),
(24, 'Clinotanypus', 'Clin', NULL, NULL),
(25, 'Clunio', 'Clun', NULL, NULL),
(26, 'Conchapelopia', 'Coch', 'Conc', NULL),
(27, 'Constempellina', 'Cost', 'Cons', NULL),
(28, 'Corynocera', 'Coce', 'Cory', NULL),
(29, 'Corynoneura', 'Cone', 'Cory', NULL),
(31, 'Cricotopus', 'Cric', NULL, NULL),
(33, 'Cryptochironomus', 'Crch', 'Cryp', NULL),
(34, 'Cryptotendipes', 'Crte', 'Cryp', NULL),
(35, 'Cyphomella', 'Cyph', NULL, NULL),
(36, 'Demeijerea', 'Deme', NULL, NULL),
(37, 'Demicryptochironomus', 'Demi', NULL, NULL),
(38, 'Diamesa', 'Diam', NULL, NULL),
(39, 'Dicrotendipes', 'Dicr', NULL, NULL),
(40, 'Diplocladius', 'Dipl', NULL, NULL),
(41, 'Doncricotopus', 'Donc', NULL, NULL),
(42, 'Dratnalia', 'Drat', NULL, NULL),
(43, 'Einfeldia', 'Einf', NULL, NULL),
(44, 'Endochironomus', 'Ench', 'Endo', NULL),
(45, 'Epoicocladius', 'Epoi', NULL, NULL),
(46, 'Eukiefferiella', 'Euki', NULL, NULL),
(48, 'Eurycnemus', 'Eurc', NULL, NULL),
(49, 'Euryhapsis', 'Eurh', NULL, NULL),
(51, 'Fleuria', 'Fleu', NULL, NULL),
(53, 'Glyptotendipes', 'Glyp', NULL, NULL),
(55, 'Guttipelopia', 'Gutt', NULL, NULL),
(56, 'Gymnometriocnemus', 'Gymn', NULL, NULL),
(58, 'Halocladius', 'Halo', NULL, NULL),
(59, 'Harnischia', 'Harn', NULL, NULL),
(60, 'Hayesomyia', 'Haye', NULL, NULL),
(61, 'Heleniella', 'Hele', NULL, NULL),
(63, 'Heterotanytarsus', 'Heta', 'Hett', NULL),
(64, 'Heterotrissocladius', 'Hetr', 'Hete', NULL),
(65, 'Hydrobaenus', 'Hydr', NULL, NULL),
(67, 'Kiefferulus', 'Kief', NULL, NULL),
(68, 'Kloosia', 'Kloo', NULL, NULL),
(69, 'Krenopelopia', 'Krpe', 'Kren', NULL),
(70, 'Krenopsectra', 'Krps', 'Kren', NULL),
(71, 'Krenosmittia', 'Krsm', 'Kren', NULL),
(72, 'Labrundinia', 'Labr', NULL, NULL),
(73, 'Lappodiamesa', 'Ladi', 'Lapd', NULL),
(75, 'Lapposmittia', 'Lasm', 'Laps', NULL),
(76, 'Larsia', 'Lars', NULL, NULL),
(77, 'Lasiodiamesa', 'Lasi', NULL, NULL),
(78, 'Lauterborniella', 'Laut', NULL, NULL),
(79, 'Limnophyes', 'Limn', NULL, NULL),
(81, 'Lipiniella', 'Lipi', NULL, NULL),
(83, 'Macropelopia', 'Mape', 'Macr', NULL),
(84, 'Mesocricotopus', 'Mecr', 'Mesc', NULL),
(85, 'Mesosmittia', 'Mesm', 'Mess', NULL),
(86, 'Metriocnemus', 'Metr', NULL, NULL),
(87, 'Microchironomus', 'Mich', 'Micc', NULL),
(88, 'Micropsectra', 'Mips', 'Micr', NULL),
(90, 'Microtendipes', 'Mite', 'Mict', NULL),
(91, 'Monodiamesa', 'Modi', 'Mond', NULL),
(92, 'Monopelopia', 'Mope', 'Monp', NULL),
(93, 'Nanocladius', 'Nano', NULL, NULL),
(94, 'Natarsia', 'Nata', NULL, NULL),
(95, 'Neostempellina', 'Nest', 'Neos', NULL),
(96, 'Neozavrelia', 'Neza', 'Neoz', NULL),
(97, 'Nilotanypus', 'Nita', 'Nilt', NULL),
(98, 'Nilothauma', 'Nith', 'Nilo', NULL),
(99, 'Odontomesa', 'Odon', NULL, NULL),
(100, 'Oliveridia', 'Oliv', NULL, NULL),
(101, 'Omisus', 'Omis', NULL, NULL),
(103, 'Orthocladius', 'Orth', NULL, NULL),
(104, 'Pagastiella', 'Paga', NULL, NULL),
(105, 'Paraboreochlus', 'Pabo', 'Para', NULL),
(106, 'Parachaetocladius', 'Pcha', 'Para', NULL),
(107, 'Parachironomus', 'Pchi', 'Parc', NULL),
(108, 'Paracladius', 'Pacl', 'Parl', NULL),
(109, 'Paracladopelma', 'Paco', 'Pard', NULL),
(110, 'Paracricotopus', 'Pcri', 'Parr', NULL),
(111, 'Parakiefferiella', 'Paki', 'Park', NULL),
(113, 'Paralimnophyes', 'Pali', 'Pary', NULL),
(115, 'Parametriocnemus', 'Pame', 'Pare', NULL),
(116, 'Paraphaenocladius', 'Paph', 'Parh', NULL),
(118, 'Parasmittia', 'Pasm', 'Pars', NULL),
(119, 'Paratanytarsus', 'Pata', 'Part', NULL),
(121, 'Paratendipes', 'Pate', 'Patd', NULL),
(122, 'Paratrichocladius', 'Patc', 'Patr', NULL),
(123, 'Paratrissocladius', 'Pats', NULL, NULL),
(125, 'Parorthocladius', 'Paor', NULL, NULL),
(130, 'Procladius', 'Prcl', 'Proc', NULL),
(132, 'Propsilocerus', 'Prps', 'Prop', NULL),
(134, 'Protanypus', 'Prta', 'Prot', NULL),
(135, 'Psectrocladius', 'Pscl', 'Psec', NULL),
(140, 'Pseudokiefferiella', 'Pski', 'Psek', NULL),
(141, 'Pseudorthocladius', 'Psor', 'Pseo', NULL),
(142, 'Pseudosmittia', 'Pssm', 'Pses', NULL),
(143, 'Psilometriocnemus', 'Psme', NULL, NULL),
(147, 'Rheocricotopus', 'Rhcr', 'Rheo', NULL),
(148, 'Rheopelopia', 'Rhpe', 'Rhep', NULL),
(149, 'Rheosmittia', 'Rhsm', 'Rhes', NULL),
(150, 'Rheotanytarsus', 'Rhta', 'Rhet', NULL),
(151, 'Robackia', 'Roba', NULL, NULL),
(152, 'Sætheria', 'Saet', NULL, NULL),
(153, 'Schineriella', 'Schi', NULL, NULL),
(154, 'Sergentia', 'Serg', NULL, NULL),
(155, 'Smittia', 'Smit', NULL, NULL),
(156, 'Stempellina', 'Stem', NULL, NULL),
(158, 'Stenochironomus', 'Stec', 'Sten', NULL),
(159, 'Stictochironomus', 'Stic', NULL, NULL),
(160, 'Stilocladius', 'Stcl', 'Stil', NULL),
(161, 'Symbiocladius', 'Sybi', 'Symb', NULL),
(162, 'Symposiocladius', 'Sypo', 'Symp', NULL),
(163, 'Sympotthastia', 'Syph', 'Symp', NULL),
(164, 'Syndiamesa', 'Synd', NULL, NULL),
(166, 'Synorthocladius', 'Syno', NULL, NULL),
(168, 'Tanypus', 'Tanp', NULL, NULL),
(170, 'Tanytarsus', 'Tany', NULL, NULL),
(172, 'Telmatogeton', 'Tege', NULL, NULL),
(173, 'Telmatopelopia', 'Telm', 'Telp', NULL),
(174, 'Telopelopia', 'Telo', NULL, NULL),
(175, 'Thalassomya', 'Tham', 'Thal', NULL),
(176, 'Thalassosmittia', 'Thal', NULL, NULL),
(177, 'Thienemannia', 'Thma', 'Thie', NULL),
(178, 'Thienemanniella', 'Thme', 'Thil', NULL),
(179, 'Thienemannimyia', 'Thmm', 'Thiy', NULL),
(180, 'Thienemanniola', 'Thmo', 'Thio', NULL),
(181, 'Tokunagaia', 'Toia', 'Toku', NULL),
(182, 'Tribelos', 'Trib', NULL, NULL),
(183, 'Trichotanypus', 'Trta', 'Tric', NULL),
(184, 'Trissocladius', 'Trcl', 'Tris', NULL),
(185, 'Trissopelopia', 'Trpe', 'Tris', NULL),
(186, 'Tvetenia', 'Tvet', NULL, NULL),
(189, 'Xenochironomus', 'Xech', 'Xeno', NULL),
(190, 'Xenopelopia', 'Xepe', 'Xenp', NULL),
(191, 'Zalutschia', 'Zalu', NULL, NULL),
(192, 'Zavrelia', 'Zavr', NULL, NULL),
(193, 'Zavreliella', 'Zavl', NULL, NULL),
(194, 'Zavrelimyia', 'Zavm', 'Zavy', NULL),
(195, 'Antillocladius', 'Anti', NULL, NULL),
(196, 'Baeoctenus', 'Baec', NULL, NULL),
(197, 'Goeldichironomus', 'Goel', NULL, NULL),
(199, 'Chernovskiia', 'Cher', NULL, NULL),
(200, 'Diothrix', 'Diot', NULL, NULL),
(202, 'Georthocladius', 'Geor', NULL, NULL),
(203, 'Lopescladius', 'Lope', NULL, NULL),
(204, 'Stackelbergina', 'Stac', NULL, NULL),
(205, 'Tethymyia', 'Teth', NULL, NULL),
(206, 'Tokunagayusurika', 'Toyu', NULL, NULL),
(207, 'Virgatanytarsus', 'Virg', NULL, NULL),
(208, 'Xylotopus', 'Xylo', NULL, NULL),
(209, 'Apedilum', 'Aped', NULL, NULL),
(210, 'Parapsectrocladius', 'Paps', NULL, NULL),
(212, 'Brundiniella', 'Brun', NULL, NULL),
(213, 'Coelotanypus', 'Cota', NULL, NULL),
(214, 'Derotanypus', 'Deta', NULL, NULL),
(215, 'Djalmabatista', 'Djal', NULL, NULL),
(216, 'Hudsonimyia', 'Huds', NULL, NULL),
(217, 'Parmerina', 'Parm', NULL, NULL),
(218, 'Pentaneurella', 'Pene', 'Pent', NULL),
(219, 'Pentaneura', 'Pena', NULL, NULL),
(220, 'Psectrotanypus', 'Psta', 'Pset', NULL),
(223, 'Phaenopsectra', 'Phps', 'Phae', NULL),
(224, 'Pseudochironomus', 'Psch', 'Pseu', NULL),
(225, 'Pseudodiamesa', 'Psdi', 'Psed', NULL),
(227, 'Polypedilum', 'Pope', 'Poly', NULL),
(228, 'Prodiamesa', 'Prdi', 'Prod', NULL),
(239, 'Beckidia', 'Beci', 'Beck', NULL),
(244, 'Oliveridia/Hydrobaenus', 'Oliv-Hy', NULL, 1),
(245, 'Paramerina', 'Pami', NULL, NULL),
(246, 'Gillotia', 'Gilo', NULL, NULL),
(247, 'Potthastia', 'Pott', NULL, NULL),
(250, 'Paralauterborniella', 'Pala', NULL, NULL),
(251, 'Parapsectra', 'Parp', NULL, NULL),
(252, 'Lithotanytarsus', 'Lith', 'Lith', NULL),
(253, 'Sublettea', 'Subl', NULL, NULL),
(254, 'Pagastia', 'Pags', NULL, NULL),
(255, 'Arctodiamesa', 'Ardi', NULL, NULL),
(256, 'Nilodorum', 'Nilo', NULL, NULL),
(257, 'Shangomyia', 'Shan', NULL, NULL),
(258, 'Deropelopia', 'Dero', NULL, NULL),
(259, 'Meropelopia', 'Mero', NULL, NULL),
(260, 'Linevitshia', 'Line', NULL, NULL),
(261, 'Compterosmittia', 'Comp', NULL, NULL),
(262, 'Neobrillia', 'Neob', NULL, NULL),
(263, 'Pseudobrillia', 'Psbr', NULL, NULL),
(264, 'Qiniella', 'Qini', NULL, NULL),
(265, 'Hanocladius', 'Hano', NULL, NULL),
(266, 'Semiocladius', 'Semi', NULL, NULL),
(267, 'Tokyobrillia', 'Toky', NULL, NULL),
(268, 'Tsudayusurika', 'Tsud', NULL, NULL),
(269, 'Biwatendipes', 'Biwa', NULL, NULL),
(270, 'Stempellinella', 'Stel', NULL, NULL),
(271, 'Zhouomyia', 'Zhou', NULL, NULL),
(272, 'Xiaomyia', 'Xiao', NULL, NULL),
(273, 'Baicalosergentia', 'Baic', NULL, NULL),
(274, 'Heptagia', 'Hept', NULL, NULL),
(275, 'Cryptocladopelma', 'Crcl', NULL, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `names_species`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_species`;
CREATE TABLE IF NOT EXISTS `names_species` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'primary key is set automatically',
  `name` varchar(60) NOT NULL COMMENT 'unique species name',
  `name_short` varchar(6) NOT NULL COMMENT 'unique short name: 4 letters (optional + [x[x]] letters) for writing filenames',
  PRIMARY KEY (`id`),
  UNIQUE KEY `species` (`name`),
  UNIQUE KEY `species_short` (`name_short`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='all species names' AUTO_INCREMENT=978 ;

--
-- Dumping data for table `names_species`
--

INSERT INTO `names_species` (`id`, `name`, `name_short`) VALUES
(1, 'aberratus', 'aber'),
(2, 'acidophilus', 'acph'),
(3, 'acuticornis', 'acuc'),
(4, 'acutiventris', 'acuv'),
(5, 'agilis', 'agil'),
(6, 'albiforceps', 'alfo'),
(7, 'albimanus', 'alma'),
(8, 'albolineatus', 'alli'),
(9, 'alpicola', 'alpi'),
(10, 'ambigua', 'ambi'),
(11, 'angusta', 'angu'),
(12, 'annularius', 'anlr'),
(13, 'annulator', 'anlt'),
(14, 'antennalis', 'ante'),
(15, 'anthracinus', 'anth'),
(16, 'aprilinus', 'apri'),
(17, 'arenaria', 'aren'),
(18, 'ashei', 'ashe'),
(20, 'austriacus', 'autr'),
(22, 'baltonicus', 'balt'),
(23, 'barbimanus', 'barb'),
(24, 'bathophila', 'bpha'),
(25, 'bathophilus', 'bphu'),
(26, 'bavarica', 'bava'),
(27, 'bernensis', 'bern'),
(28, 'bertrami', 'bert'),
(29, 'bicinctus', 'bici'),
(30, 'bicolor', 'bico'),
(31, 'boreoalpinus', 'boal'),
(32, 'branickii', 'bran'),
(33, 'brevicalcar', 'brca'),
(34, 'brevipalpis gr.', 'brpagr'),
(35, 'brundini', 'brun'),
(36, 'calvescens', 'calv'),
(37, 'camptophleps', 'caph'),
(38, 'capucinus', 'capu'),
(40, 'chalybeatus', 'chal'),
(41, 'choreus', 'chor'),
(42, 'cinerella', 'cine'),
(43, 'cingulata', 'ciga'),
(44, 'cingulatus', 'cigu'),
(45, 'claripennis', 'clar'),
(46, 'clavicornis', 'clav'),
(47, 'clypeata', 'clyp'),
(49, 'coerulescens', 'coer'),
(50, 'commutatus', 'comm'),
(51, 'conversus', 'conv'),
(52, 'coronata gr.', 'corogr'),
(53, 'crassimanus', 'crass'),
(54, 'cultriger', 'cult'),
(55, 'curtistylus', 'cuti'),
(56, 'curtus', 'cutu'),
(57, 'dampfi', 'damp'),
(58, 'delphinensis', 'delp'),
(59, 'demeijerei', 'deme'),
(60, 'dentiforceps', 'dent'),
(61, 'devonica', 'devo'),
(62, 'discoloripes', 'disc'),
(63, 'divisa', 'divi'),
(64, 'doris', 'dori'),
(65, 'dorsalis', 'dors'),
(66, 'dubius', 'dubi'),
(67, 'effusus', 'effu'),
(68, 'excavatus', 'exca'),
(69, 'excerptus', 'exce'),
(70, 'exiguus', 'exig'),
(71, 'festivellus', 'fest'),
(72, 'fittkaui', 'fitt'),
(73, 'flaviforceps', 'flfo'),
(74, 'frigidus', 'frig'),
(75, 'fuldensis', 'fuld'),
(76, 'fulva', 'fulv'),
(77, 'fuscipes', 'fuci'),
(78, 'fuscus', 'fucu'),
(79, 'gaedii', 'gaed'),
(80, 'glabricollis', 'glab'),
(81, 'goetghebueri', 'goet'),
(83, 'gracei', 'grce'),
(84, 'gracilis', 'grci'),
(85, 'gracillima', 'grcm'),
(86, 'grimshawi', 'gris'),
(87, 'gurgicola', 'gurg'),
(88, 'guttipennis', 'gutt'),
(89, 'hamaticornis', 'hama'),
(90, 'holoprasinatus', 'holo'),
(91, 'holsata', 'hols'),
(92, 'hygropetricus', 'hype'),
(94, 'ilkleyensis', 'ilkl'),
(95, 'impensus', 'impe'),
(96, 'insignipes', 'insi'),
(97, 'intersectus', 'insc'),
(98, 'ishimicus', 'ishi'),
(99, 'knabi', 'knab'),
(101, 'lacunarius', 'lacu'),
(102, 'laetum', 'laet'),
(103, 'laminatus', 'lami'),
(104, 'laricomalis gr.', 'larigr'),
(105, 'lignicola', 'lign'),
(106, 'lobata', 'loba'),
(108, 'lobifera', 'lobi'),
(109, 'longialpis', 'loal'),
(110, 'longifurca', 'lofu'),
(111, 'longimana', 'loma'),
(112, 'longimanus', 'lomu'),
(113, 'longipes', 'logp'),
(114, 'longistyla', 'lost'),
(353, 'lugubris', 'lugu'),
(117, 'luridus agg.', 'luriag'),
(118, 'luteipes', 'lute'),
(119, 'majuscula', 'maju'),
(120, 'marcidus', 'marc'),
(121, 'medius', 'medi'),
(122, 'melanescens', 'mees'),
(123, 'melanops', 'meop'),
(124, 'melanotus', 'meot'),
(125, 'mendax', 'mend'),
(126, 'mendax gr.', 'mendgr'),
(127, 'minor', 'mino'),
(128, 'modesta', 'mode'),
(129, 'monilis', 'moni'),
(130, 'montanus', 'mont'),
(131, 'muratensis', 'mura'),
(132, 'muscicola', 'musc'),
(133, 'nemorum', 'nemo'),
(134, 'niger', 'nige'),
(135, 'nitida', 'nita'),
(136, 'nivalis', 'niva'),
(137, 'nivosa', 'nivo'),
(386, 'nostocicola', 'nost'),
(139, 'nudipennis', 'nupe'),
(140, 'nudisquama', 'nusq'),
(141, 'nuditaris', 'nuta'),
(142, 'nudiventris', 'nuve'),
(143, 'obnixus gr.', 'obni'),
(144, 'obscuripes', 'obsc'),
(145, 'obtusidens', 'obtu'),
(146, 'obumbratus', 'obum'),
(148, 'octomaculatus', 'octo'),
(149, 'olivera', 'oliv'),
(150, 'ornata', 'orta'),
(151, 'ornaticollis', 'orti'),
(152, 'pagna', 'pagn'),
(153, 'pallidivittatus', 'pavi'),
(154, 'pallidicornis', 'paco'),
(155, 'paranudipennis', 'panu'),
(156, 'partita', 'part'),
(157, 'parva', 'parv'),
(158, 'pedellus gr.', 'pedegr'),
(159, 'permacer', 'perm'),
(160, 'piger', 'pige'),
(161, 'plumosus', 'plum'),
(162, 'plumosus gr.', 'plumgr'),
(163, 'pseudirritus', 'psir'),
(164, 'pseudolestagei', 'psle'),
(165, 'radialis type', 'radity'),
(166, 'rectinervis', 'rect'),
(167, 'reductus', 'redu'),
(168, 'rhithrogenae', 'rhit'),
(170, 'riparius', 'ripa'),
(171, 'rivicola', 'rivi'),
(172, 'rivulorum', 'rivu'),
(173, 'rubicundus', 'rubi'),
(174, 'rufiventris', 'rufi'),
(175, 'rufovittata', 'ruvi'),
(176, 'ruttneri', 'rutt'),
(177, 'rydalensis', 'ryda'),
(178, 'salinarius', 'sali'),
(179, 'saxatilis', 'saxa'),
(180, 'saxicola', 'saxi'),
(181, 'saxosus', 'saxo'),
(182, 'scutellata gr.', 'scutgr'),
(183, 'scutellata', 'scut'),
(184, 'semivirens', 'sevi'),
(185, 'serratosioi', 'serr'),
(186, 'similis', 'simi'),
(188, 'skirwithensis', 'skir'),
(189, 'sordellus gr.', 'soelgr'),
(190, 'sordidellus', 'soid'),
(191, 'sorius', 'sori'),
(192, 'sp', 'spec'),
(200, 'sp. A', 'specA'),
(202, 'sp. B', 'specB'),
(203, 'spinicornis', 'spin'),
(204, 'steinboecki', 'stei'),
(205, 'striatus', 'stri'),
(206, 'stylatus', 'styl'),
(208, 'subviridis', 'suvi'),
(209, 'sylvestris gr.', 'sylvgr'),
(210, 'tentans', 'teta'),
(211, 'tenuicalar', 'teca'),
(212, 'terrester', 'teer'),
(213, 'terrestris', 'teri'),
(214, 'thienemanni', 'thni'),
(215, 'tirolensis', 'tiro'),
(216, 'tonsa', 'tono'),
(217, 'tremulus', 'trem'),
(218, 'trifascia', 'tria'),
(219, 'trifasciatus', 'triu'),
(220, 'trilobata', 'tril'),
(221, 'usmaensis', 'usma'),
(222, 'vaillanti', 'vail'),
(223, 'verralli', 'verr'),
(224, 'vier', 'vier'),
(225, 'virgo', 'virg'),
(226, 'vittata', 'vitt'),
(227, 'vitellinus gr.', 'vitegr'),
(228, 'wetterensis', 'wett'),
(231, 'xanthogyne', 'xant'),
(232, 'zerny', 'zern'),
(233, 'fusca', 'fuca'),
(234, 'adaucta', 'adau'),
(235, 'akamusi', 'akam'),
(236, 'stagnorum', 'stag'),
(237, 'variabilis', 'varb'),
(238, 'varians', 'varn'),
(239, 'ventricosus', 'veco'),
(240, 'affinis', 'affi'),
(241, 'assimilis', 'assi'),
(242, 'baicalensis', 'baic'),
(243, 'baueri', 'baue'),
(244, 'electa', 'elec'),
(245, 'flavodentata', 'flde'),
(246, 'intermedia', 'inme'),
(247, 'koschowi', 'kosc'),
(248, 'nebulosa', 'nebu'),
(249, 'prima', 'prim'),
(250, 'rara', 'rara'),
(251, 'rynocephala', 'ryno'),
(252, 'flavipes', 'flav'),
(253, 'intextus', 'itex'),
(254, 'albipennis', 'alpe'),
(255, 'tendens', 'tede'),
(256, 'impar', 'impa'),
(257, 'sp. C', 'specC'),
(258, 'sp. D', 'specD'),
(259, 'sp. E', 'specE'),
(260, 'sp. 1', 'spec1'),
(261, 'sp. 2', 'spec2'),
(262, 'artica', 'arti'),
(263, 'pertinax', 'pert'),
(264, 'steinboecki cf.', 'steicf'),
(265, 'branickii gr.', 'brangr'),
(266, 'nivosa gr.', 'nivogr'),
(267, 'amplexivirillia', 'ampl'),
(268, 'decedens', 'dece'),
(269, 'johannseni', 'joha'),
(270, 'longilobus', 'lobu'),
(271, 'plumosus f.reductus', 'plumfr'),
(272, 'pinguis', 'ping'),
(273, 'johnsoni', 'john'),
(274, 'flavifrons', 'flfr'),
(275, 'stellatus', 'stell'),
(276, 'vernalis', 'vern'),
(277, 'insignipes gr.', 'insigr'),
(278, 'vitellinus', 'vite'),
(279, 'fugax', 'fuga'),
(280, 'nitidellus', 'nitu'),
(281, 'gregarius', 'greg'),
(282, 'gregarius gr.', 'greggr'),
(283, 'lobatifrons', 'lobf'),
(284, 'viridiventris', 'vive'),
(285, 'zabolotzkii gr.', 'zabogr'),
(286, 'nervosus', 'nerv'),
(287, 'julva', 'julv'),
(288, 'lentiginosa', 'lent'),
(289, 'vilipennis', 'vill'),
(290, 'pacificus', 'paci'),
(291, 'limbatellus', 'limb'),
(292, 'octomaculatus cf.', 'octocf'),
(293, 'majuscula cf.', 'majucf'),
(294, 'transcaucasicus', 'trca'),
(295, 'mixtus', 'mixt'),
(296, 'potomophilus', 'poto'),
(297, 'inserpens', 'inse'),
(298, 'sexdentatus', 'sexd'),
(299, 'fridmanae', 'frid'),
(300, 'chloris', 'chlo'),
(301, 'grimmii', 'grim'),
(302, 'kyotoensis', 'kyot'),
(303, 'akizukii', 'akiz'),
(304, 'rivulorum gr.', 'rivugr'),
(305, 'lobifera cf.', 'lobicf'),
(306, 'tentoriola', 'teto'),
(307, 'tenuis', 'teis'),
(308, 'tenellus', 'tene'),
(309, 'triannulatus', 'tran'),
(310, 'pallidus', 'padu'),
(311, 'pallens', 'paen'),
(312, 'pax', 'pax'),
(313, 'coronata', 'coro'),
(314, 'gracillima cf.', 'grcmcf'),
(315, 'comptolabis', 'comp'),
(316, 'comptolabis gr.', 'compgr'),
(317, 'rolli', 'roll'),
(318, 'camptolabris', 'cala'),
(319, 'camptolabris gr.', 'calagr'),
(320, 'fallax', 'fall'),
(321, 'laetum gr.', 'laetgr'),
(322, 'punctipennis', 'punc'),
(323, 'moniliformis', 'mofo'),
(324, 'bathyphila', 'bphy'),
(325, 'nivoriunda', 'nivu'),
(326, 'obscurus', 'oscu'),
(327, 'inaequalis', 'inae'),
(328, 'nigronitens', 'nite'),
(329, 'flavicingulus', 'flci'),
(330, 'hyperboreus', 'hybo'),
(331, 'minima', 'mini'),
(332, 'minima gr.', 'minigr'),
(333, 'olivacea', 'olce'),
(334, 'mucronata', 'mucr'),
(335, 'lucens', 'luce'),
(336, 'obvius', 'obvi'),
(337, 'longipalpus', 'lopa'),
(338, 'carbonaria', 'carb'),
(339, 'dissidens', 'dide'),
(340, 'litofilus', 'lifi'),
(342, 'exiguus cf.', 'exigcf'),
(343, 'pancratovae', 'panc'),
(344, 'flavocinctus', 'flcn'),
(345, 'sp. tremulus', 'tremsp'),
(346, 'clarki', 'clak'),
(347, 'consobrinus', 'coso'),
(348, 'carlatus', 'carl'),
(349, 'robacki', 'roba'),
(350, 'wiensi', 'wien'),
(351, 'abiskoensis', 'abis'),
(352, 'roussellae', 'rous'),
(354, 'vulneratus', 'vuln'),
(355, 'laricomalis', 'lari'),
(356, 'annectens', 'anne'),
(357, 'curtiseta', 'cuts'),
(358, 'dentifer', 'denf'),
(359, 'nigritus', 'nigr'),
(360, 'manitobensis', 'mani'),
(361, 'dorenus', 'dore'),
(362, 'lapponicus', 'lapo'),
(363, 'mallochi', 'mall'),
(364, 'charensis', 'char'),
(365, 'ornaticornis', 'ornc'),
(366, 'impensus albusalatus', 'imal'),
(367, 'saxosus 1', 'saxo1'),
(368, 'saxosus 2', 'saxo2'),
(369, 'algarum', 'alga'),
(370, 'annulator ?', 'anltc-'),
(371, 'laetus', 'laeu'),
(372, 'ornatus', 'ortu'),
(373, 'patens', 'pate'),
(374, 'pirifer', 'piri'),
(375, 'reversus', 'revu'),
(376, 'suspiciosus', 'sspi'),
(377, 'tricinctus', 'tric'),
(378, 'cylindraceus', 'cyli'),
(379, 'pulchripes', 'pulc'),
(380, 'tibialis', 'tibi'),
(381, 'vierriensis', 'virr'),
(382, 'vierriensis cf.', 'virrcf'),
(383, 'sylvestris', 'sylv'),
(384, 'elegans', 'eleg'),
(385, 'coracina', 'cora'),
(387, 'mari', 'marinu'),
(388, 'crassipes', 'cras'),
(389, 'cilium', 'cili'),
(390, 'retifinis', 'reti'),
(391, 'balatonicus', 'bala'),
(392, 'luridus', 'luri'),
(393, 'macropodus?', 'macr'),
(394, 'pseudothummi', 'pseu'),
(395, 'sororius', 'soro'),
(396, 'notatus', 'nota'),
(397, 'pulsus', 'puls'),
(398, 'tritomus', 'trit'),
(399, 'severini?', 'seve-'),
(400, 'varipes', 'vari'),
(401, 'atrimana', 'atri'),
(402, 'brachialis', 'brac'),
(403, 'phatta', 'phat'),
(404, 'trifascipennis', 'trif'),
(405, 'griseipennis', 'grip'),
(406, 'tethys', 'teth'),
(407, 'brevitarsis', 'brev'),
(408, 'eumorpha', 'eumo'),
(409, 'subvernalis', 'subv'),
(410, 'curticornis', 'curt'),
(411, 'calcaratus', 'calc'),
(412, 'septentrionalis', 'sept'),
(413, 'simulans', 'simu'),
(727, 'makabensis', 'maka'),
(415, 'delatoris', 'dela'),
(416, 'fennicus', 'fenn'),
(417, 'semicirculatus', 'semi'),
(418, 'dissipatus', 'diss'),
(419, 'minutissimus', 'minu'),
(420, 'pereennis', 'pere'),
(421, 'setosipennis', 'seto'),
(422, 'suecicus', 'suec'),
(423, 'orbicus', 'orbi'),
(424, 'mancus', 'manc'),
(425, 'sp. 1a', 'spec1a'),
(426, 'sp. 1b', 'spec1b'),
(427, 'sp. 3', 'spec3'),
(428, 'pseudomancus', 'psma'),
(429, 'aristata', 'aris'),
(430, 'atrofasciata', 'atro'),
(431, 'bidentata', 'bide'),
(432, 'contracta', 'cont'),
(433, 'groenlandica', 'groe'),
(434, 'junci', 'junc'),
(435, 'pharetrophora', 'phar'),
(436, 'radialis', 'radi'),
(437, 'seguyi', 'segu'),
(438, 'marinus', 'mari'),
(439, 'concinnus', 'conc'),
(440, 'ambigua 2', 'ambi2'),
(441, 'obreptans', 'obre'),
(442, 'ussouriensis', 'usso'),
(443, 'cuneatus', 'cune'),
(444, 'parcivillosa', 'parc'),
(445, 'pulcher', 'puch'),
(446, 'bicaudatus', 'bica'),
(447, 'potamophylaxi', 'pota'),
(448, 'amazonicus', 'amaz'),
(449, 'brehmi gr.', 'brehgr'),
(450, 'cyanea gr.', 'cyangr'),
(451, 'devonica gr.', 'devogr'),
(452, 'coerulescens gr.', 'coergr'),
(453, 'gracei gr.', 'grcegr'),
(454, 'clypeata gr.', 'clypgr'),
(455, 'stercorarius', 'ster'),
(456, 'brumalis ?', 'brum-'),
(457, 'fuscicola', 'fusc'),
(458, 'braunsi', 'brau'),
(459, 'senata', 'sena'),
(460, 'nudalis ?', 'nuda-'),
(461, 'changi', 'chan'),
(462, 'hirtapex', 'hirt'),
(463, 'maeaeri', 'maea'),
(464, 'subpilosus', 'subp'),
(465, 'karelena', 'kare'),
(466, 'distylus', 'dist'),
(467, 'hudsoni', 'huds'),
(468, 'lunzensis', 'lunz'),
(469, 'martini', 'mart'),
(470, 'pilipes', 'pipe'),
(471, 'pilipodex', 'pipo'),
(472, 'rufus', 'rufu'),
(473, 'scapulapilosus', 'scap'),
(474, 'boreoalpina', 'bore'),
(475, 'longipalpis', 'long'),
(476, 'globifer', 'glob'),
(477, 'flexuella', 'flex'),
(478, 'atratulus', 'atra'),
(479, 'ursinus', 'ursi'),
(480, 'punctata', 'puta'),
(481, 'cinctipes', 'cinc'),
(482, 'dasyopsis', 'dasy'),
(483, 'legeri', 'lege'),
(484, 'rugosa', 'rugo'),
(485, 'caledonicus', 'cale'),
(486, 'hydrophilus', 'hydr'),
(487, 'carinata', 'cari'),
(488, 'bituberculatus', 'bitu'),
(489, 'confusus', 'conf'),
(490, 'inopertus', 'inop'),
(491, 'intricatus', 'intr'),
(492, 'lauterborni', 'laut'),
(493, 'penicillatus type', 'penity'),
(494, 'siderophila', 'side'),
(495, 'laticollus', 'laco'),
(496, 'torulata', 'toru'),
(497, 'graminicola', 'gram'),
(498, 'lundbecki', 'lund'),
(499, 'nasthecus', 'nast'),
(500, 'ignobilis', 'igno'),
(501, 'ignobilis ?', 'igno-'),
(502, 'katerjokki', 'kate'),
(503, 'bellus', 'bell'),
(504, 'lusatiensis', 'lusa'),
(505, 'bisetus', 'bise'),
(506, 'fabricus', 'fabr'),
(507, 'nevalis', 'neva'),
(508, 'versatilis', 'vers'),
(509, 'zetterstedti', 'zett'),
(510, 'zelentzovi', 'zele'),
(511, 'cristatus', 'cris'),
(512, 'tuberculatus', 'tube'),
(513, 'perda', 'perd'),
(514, 'pentapoda', 'pent'),
(515, 'praeclara', 'prae'),
(516, 'clinopecten', 'clin'),
(517, 'equitans', 'equi'),
(518, 'buchonius', 'buch'),
(519, 'chinyensis', 'chin'),
(520, 'dibranchius', 'dibr'),
(521, 'ejuncidus', 'ejun'),
(522, 'eminulus', 'emin'),
(523, 'gibbosiceps', 'gibb'),
(524, 'gracilentus', 'grac'),
(525, 'lactescens', 'lact'),
(526, 'lestagei', 'lest'),
(527, 'lugens', 'luge'),
(528, 'formosanus', 'form'),
(529, 'occultus', 'occu'),
(531, 'signatus', 'sign'),
(532, 'telmaticus', 'telm'),
(533, 'type C', 'typc'),
(534, 'volgensis', 'volg'),
(535, 'okoboji', 'okob'),
(536, 'aptena', 'apte'),
(537, 'geijskesi', 'geij'),
(538, 'northumbrica', 'nort'),
(539, 'kibunensis', 'kibu'),
(540, 'paucunca', 'pauc'),
(541, 'falcigera', 'falc'),
(542, 'par', 'par'),
(543, 'zalutschicola', 'zalu'),
(544, 'lingulata pauca', 'lipa'),
(545, 'melanura', 'mela'),
(546, 'submontanus', 'sumo'),
(547, 'carbonaria?', 'carb-'),
(548, 'severini', 'seve'),
(549, 'amplus?', 'ampu-'),
(550, 'amplus', 'ampu'),
(551, 'varipes?', 'vari-'),
(552, 'debilis', 'debi'),
(553, 'oyamai', 'oyam'),
(554, 'uraiensis', 'urai'),
(555, 'latilaminus', 'lati'),
(558, 'conformis', 'cofo'),
(559, 'brevipalpis', 'brpa'),
(560, 'asquamatus', 'asqu'),
(561, 'japonicum', 'japo'),
(562, 'brunneri', 'brui'),
(563, 'ospeli', 'ospe'),
(564, 'nubeculosum', 'nube'),
(565, 'pedestre', 'pede'),
(566, 'convictum', 'covi'),
(567, 'scalaenum', 'scal'),
(568, 'nubifer', 'nubi'),
(569, 'braseniae', 'bras'),
(570, 'tuberculum', 'tubc'),
(572, 'ontario', 'onta'),
(573, 'sordens', 'sord'),
(574, 'nemorosus', 'nemu'),
(575, 'penicillatus', 'peni'),
(576, 'sinicus', 'sini'),
(577, 'lacustris', 'lacs'),
(578, 'paradoxus', 'pado'),
(579, 'alboviridis', 'alvi'),
(580, 'magnus', 'magn'),
(581, 'nigripes', 'nigp'),
(582, 'montium', 'moti'),
(583, 'jacutis', 'jacu'),
(584, 'taihuensis', 'taih'),
(585, 'dilatus', 'dila'),
(586, 'paratridorsum', 'padi'),
(587, 'acre', 'acre'),
(588, 'nojirimaculatum', 'noji'),
(589, 'pankratovae', 'pank'),
(590, 'sokolovae', 'soko'),
(591, 'defectus', 'defe'),
(592, 'digitatus', 'digi'),
(593, 'fulvus', 'fulu'),
(594, 'sauter', 'saut'),
(595, 'supplicans', 'supp'),
(596, 'rostratus', 'rost'),
(599, 'spatulatus', 'spat'),
(601, 'nitens', 'nien'),
(602, 'polyannulatus', 'poan'),
(603, 'taiwanus', 'taiw'),
(604, 'triannulus', 'trlu'),
(605, 'tristis', 'tris'),
(606, 'logani', 'loga'),
(607, 'pallidula', 'pall'),
(608, 'schrankelae', 'schr'),
(609, 'pseudomontana', 'psmo'),
(610, 'boevensis', 'boev'),
(611, 'quadridentata', 'qude'),
(612, 'takahashi', 'taka'),
(613, 'contractus', 'cotr'),
(614, 'exagitans', 'exag'),
(615, 'nashthecus', 'nash'),
(616, 'triangulus', 'trin'),
(617, 'exilicaudatum', 'exil'),
(618, 'convexum', 'cove'),
(619, 'tritum', 'trim'),
(620, 'acutum', 'acut'),
(621, 'albicorne', 'albi'),
(622, 'apfelbecki', 'apfe'),
(623, 'asakawaense', 'asak'),
(624, 'benokiense', 'beno'),
(625, 'bisetosum', 'bist'),
(626, 'fuscum', 'fusu'),
(627, 'henicurum', 'heni'),
(628, 'illinoense', 'illi'),
(629, 'lichuanensis', 'lich'),
(630, 'masudai', 'masu'),
(631, 'medivittatum', 'medv'),
(633, 'shanguiensis', 'shan'),
(634, 'tamanigrum', 'tama'),
(635, 'pullum', 'pull'),
(636, 'cultellatum', 'cule'),
(637, 'aculeatus', 'acul'),
(638, 'brusti', 'brus'),
(639, 'dentipalpus', 'depa'),
(640, 'eurynotus', 'euno'),
(641, 'picipes', 'pici'),
(642, 'unilinearis', 'unil'),
(643, 'wangi', 'wang'),
(644, 'veralli', 'vera'),
(645, 'celtica', 'celt'),
(646, 'yashimurai', 'yash'),
(647, 'notescens', 'note'),
(648, 'apposita', 'appo'),
(649, 'recurvata', 'recu'),
(650, 'lindrothi', 'lind'),
(651, 'roseiventris', 'rose'),
(652, 'klinki', 'klin'),
(653, 'andalusiaca', 'anda'),
(654, 'appendica', 'appe'),
(655, 'attenuata', 'atte'),
(656, 'auvergnensis', 'auve'),
(657, 'bodanica', 'boda'),
(658, 'borealis', 'bora'),
(659, 'calcifontis', 'cali'),
(660, 'clastrieri', 'clas'),
(661, 'insignilobus', 'insg'),
(662, 'lindebergi', 'linb'),
(663, 'longicrista', 'locr'),
(664, 'rilensis', 'rile'),
(665, 'robusta', 'robu'),
(666, 'sofiae', 'sofi'),
(667, 'zernyi', 'zery'),
(668, 'longipennis', 'lope'),
(669, 'flavens', 'flve'),
(670, 'aizaiensis', 'aiza'),
(671, 'duplicata', 'dupl'),
(672, 'forcipata', 'forc'),
(673, 'mathilda', 'math'),
(674, 'recta', 'reca'),
(675, 'aterrima', 'ater'),
(676, 'contingens', 'coge'),
(677, 'edwardsi', 'edwa'),
(678, 'leucopogon', 'leuc'),
(679, 'niitakana', 'niit'),
(680, 'pratorum', 'prat'),
(681, 'rostrata', 'rotr'),
(682, 'truncatocauda', 'trun'),
(683, 'digitalis', 'digt'),
(684, 'frontalis', 'frta'),
(685, 'nigrovittatus', 'nivi'),
(686, 'palmatus', 'palm'),
(687, 'parvus', 'pavu'),
(688, 'vanderwulpi', 'vand'),
(689, 'yunnanensis', 'yunn'),
(690, 'crassinervis', 'crne'),
(691, 'culiciformis', 'culi'),
(692, 'denticulatus', 'decu'),
(693, 'insularis', 'insu'),
(694, 'iris', 'iris'),
(695, 'lacteiclava', 'lacl'),
(696, 'nipponicus', 'nipp'),
(697, 'sagittalis', 'sagi'),
(698, 'dissimilis', 'disi'),
(699, 'tenellulus', 'telu'),
(700, 'bausellus', 'baus'),
(701, 'boemicus', 'boem'),
(702, 'chlorogyne', 'chro'),
(703, 'dimorphis', 'dimo'),
(704, 'inquilinus', 'inqu'),
(705, 'laccophilus', 'lacc'),
(706, 'laetipes', 'ltip'),
(707, 'luteola', 'luto'),
(708, 'mediterraneus', 'mete'),
(709, 'natvigi', 'natv'),
(710, 'setosimanus', 'sesi'),
(711, 'lateralis', 'late'),
(712, 'laccophila', 'laph'),
(713, 'virescens', 'vire'),
(714, 'viridula', 'viri'),
(715, 'deribae', 'deri'),
(716, 'tener', 'tenr'),
(717, 'obscura', 'obcu'),
(718, 'camptolabis', 'camp'),
(719, 'nigritula', 'niri'),
(720, 'holsatus', 'hosa'),
(721, 'pflugfelderi ?', 'pflu-'),
(722, 'pflugfelderi', 'pflu'),
(723, 'casuarius', 'casu'),
(724, 'elachistum', 'elac'),
(725, 'subcinctum', 'subc'),
(726, 'nigrohalteralis', 'niha'),
(728, 'solivaga', 'soli'),
(729, 'yugashimaensis', 'yuga'),
(730, 'kanii', 'kani'),
(731, 'chinensis', 'chne'),
(732, 'repentina', 'repe'),
(733, 'microtrichos', 'micr'),
(734, 'nigricans', 'nica'),
(735, 'fuscimanus', 'fuma'),
(736, 'lobiferus', 'lofe'),
(737, 'attenuatus', 'atus'),
(738, 'dives', 'dive'),
(739, 'acerbus', 'acer'),
(740, 'aestuarius', 'aest'),
(741, 'tamaquartus', 'tamq'),
(742, 'dissimilis agg.', 'dissag'),
(743, 'fuscipropes', 'fupr'),
(744, 'ploenensis', 'ploe'),
(745, 'arduennensis', 'ardu'),
(746, 'imbecilis', 'imbe'),
(747, 'gripekonveni', 'grpe'),
(748, 'viridis', 'vidi'),
(749, 'mancunianus', 'macu'),
(750, 'bilobatus', 'bilo'),
(751, 'grimmi', 'grii'),
(752, 'bifida', 'bifi'),
(753, 'albofasciatus', 'albo'),
(754, 'redekei', 'rede'),
(755, 'psittacinus', 'psit'),
(756, 'gibbus', 'gibu'),
(757, 'hilaris', 'hila'),
(758, 'pulchripennis', 'pupe'),
(759, 'parisiensis', 'pari'),
(760, 'nelumbus', 'nelu'),
(761, 'nubilipennis', 'nubl'),
(762, 'satorui', 'sato'),
(763, 'takahashii', 'taha'),
(764, 'poecilopterus', 'poec'),
(765, 'crassiforceps', 'crfo'),
(766, 'glauciventris', 'glau'),
(767, 'tendipediformis', 'tend'),
(768, 'mancospinosus', 'masp'),
(769, 'striatulus', 'stia'),
(770, 'gregarius-inaequalis', 'grin'),
(771, 'natchitocheae', 'natc'),
(772, 'arctica', 'arct'),
(773, 'caulicola', 'caul'),
(774, 'inopterus', 'inpt'),
(775, 'parthenogeneticus', 'path'),
(776, 'sinensis', 'sine'),
(777, 'glaucus', 'glauc'),
(778, 'barbipes', 'babi'),
(779, 'calvus', 'calu'),
(780, 'suspensus', 'susp'),
(781, 'prasinatus', 'pras'),
(782, 'caudatus', 'caud'),
(783, 'pseudomorio', 'psmr'),
(784, 'longiventris', 'love'),
(785, 'eminellobus', 'emne'),
(786, 'atripes', 'atrp'),
(787, 'bifasciatus', 'bifa'),
(788, 'brachypus', 'brpu'),
(789, 'emeiensis', 'emei'),
(790, 'nigrus', 'nigu'),
(791, 'baishanzua', 'bais'),
(792, 'orientalis', 'orie'),
(793, 'defensus', 'defn'),
(794, 'psiliopterus', 'psil'),
(795, 'janta', 'jant'),
(796, 'aspera', 'aspe'),
(797, 'annulata', 'anla'),
(798, 'simplex', 'simp'),
(799, 'zhalingensis', 'zhal'),
(800, 'sticticus', 'stic'),
(801, 'connectens', 'conn'),
(802, 'acifer', 'acif'),
(803, 'bifasciata', 'bita'),
(804, 'brevicornis', 'brco'),
(805, 'lutethorax', 'luth'),
(806, 'stylifer', 'stfe'),
(807, 'crassicornis', 'crco'),
(808, 'asiaticus', 'asia'),
(809, 'koreana', 'kore'),
(810, 'pallicauda', 'paca'),
(811, 'sp. SE', 'spSE'),
(812, 'sp. SG', 'spSG'),
(813, 'tylus', 'tylu'),
(814, 'marinae', 'marn'),
(815, 'appendiculata', 'apdi'),
(816, 'sp. 4', 'spec4'),
(817, 'takatensis', 'tate'),
(818, 'hirticollis', 'hico'),
(819, 'inopinatus', 'inna'),
(820, 'tshernovskii', 'tshe'),
(821, 'alpestris', 'alps'),
(822, 'oliveri', 'olie'),
(823, 'schnelli', 'schn'),
(824, 'halvorseini', 'halv'),
(825, 'nivis', 'nivs'),
(826, 'partica', 'pati'),
(827, 'lanceolata', 'lanc'),
(828, 'orthogonia', 'orth'),
(829, 'altaica', 'alta'),
(830, 'sequax', 'sequ'),
(831, 'ater', 'ate1'),
(832, 'hamatus', 'hamt'),
(833, 'longiventris gr.', 'love-'),
(834, 'rosenscholdi', 'rosc'),
(835, 'intermedius', 'inmu'),
(836, 'flexus', 'flxu'),
(837, 'pelochloris', 'pelo'),
(838, 'septemmaculatus', 'sema'),
(839, 'tamaviridis', 'tavi'),
(840, 'lobiger', 'loge'),
(841, 'dyari', 'dya'),
(842, 'carolinensis', 'caro'),
(843, 'bullus', 'bull'),
(844, 'brachytomus', 'brto'),
(845, 'difficilis', 'dici'),
(846, 'fuscipygmus', 'fupy'),
(847, 'habilis', 'habi'),
(848, 'minimus', 'mimu'),
(849, 'opimus', 'opim'),
(850, 'orbicristatus', 'orbc'),
(851, 'palleocestus', 'pace'),
(852, 'pentaplastus', 'pepl'),
(853, 'natalensis', 'nata'),
(854, 'pumilio', 'pumi'),
(855, 'triangularis', 'trag'),
(856, 'verpus', 'verp'),
(857, 'uncinatum', 'unic'),
(858, 'osarumaculata', 'osar'),
(859, 'curtistila', 'cust'),
(860, 'cuneiformis', 'cufo'),
(861, 'propinquus', 'prop'),
(862, 'scanicus', 'scan'),
(863, 'bifurcus', 'bifu'),
(864, 'fimbriatus', 'fimb'),
(865, 'holochlorus', 'hoch'),
(866, 'pectus', 'pect'),
(867, 'takahshii', 'takh'),
(868, 'tamaotoi', 'tamo'),
(869, 'trichoproctos', 'trch'),
(870, 'coffmani', 'coff'),
(871, 'viator', 'viat'),
(872, 'britteni', 'brit'),
(873, 'diffinis', 'diff'),
(874, 'pedellus', 'pedl'),
(875, 'trunctus', 'truc'),
(876, 'paripes', 'parp'),
(877, 'foliicola', 'foli'),
(878, 'aequalis', 'aequ'),
(879, 'subnitens', 'subn'),
(880, 'nepalensis', 'nepa'),
(881, 'paucisetosa', 'pase'),
(882, 'glabrescens', 'glre'),
(883, 'unidentatus', 'unid'),
(884, 'baishanensis', 'bash'),
(885, 'carriana', 'carr'),
(886, 'gratias', 'grat'),
(887, 'clavaticornis', 'claa'),
(888, 'brehmi', 'breh'),
(889, 'rectangularis', 'rean'),
(890, 'brevicalar', 'brec'),
(891, 'cyanea', 'cyan'),
(892, 'komorii', 'komo'),
(893, 'endocladiae', 'endo'),
(894, 'motoharui', 'moto'),
(895, 'cladopsila', 'clad'),
(896, 'multiannulata', 'mult'),
(897, 'bausei', 'base'),
(898, 'plauta', 'plau'),
(899, 'aequipedes', 'aeq'),
(900, 'impectinata', 'impc'),
(901, 'lii', 'lii'),
(902, 'villosa', 'vilo'),
(903, 'carinatus', 'catu'),
(904, 'grodhausi', 'grod'),
(905, 'decempunctatus', 'decem'),
(906, 'formosae', 'formo'),
(907, 'immaculatus', 'imma'),
(908, 'lampronotus', 'lamp'),
(909, 'microtrichus', 'micro'),
(910, 'sugiyamai', 'sugi'),
(911, 'aureus', 'aure'),
(912, 'notata', 'notat'),
(913, 'hirtimana', 'hirti'),
(914, 'sinuosa', 'sinu'),
(915, 'pauciseta', 'paus'),
(916, 'pekanus', 'peka'),
(917, 'jii', 'jii'),
(918, 'albibasis', 'albib'),
(919, 'cavicola', 'cavi'),
(920, 'nigrofasciatus', 'nigf'),
(921, 'punctulata', 'punct'),
(922, 'aberrata', 'abea'),
(923, 'alpina', 'alpn'),
(924, 'gregsoni', 'grso'),
(925, 'kaszabi', 'kasz'),
(926, 'leona', 'leon'),
(927, 'filicauda', 'fili'),
(928, 'tsutsuii', 'tsut'),
(929, 'veletensis', 'vele'),
(930, 'leucoscelis', 'leco'),
(931, 'thanatogratus', 'than'),
(932, 'fusconotatus', 'fuco'),
(933, 'crypticus', 'crypt'),
(934, 'simpsoni', 'simps'),
(935, 'neomodestus', 'neom'),
(936, 'lobus', 'lobus'),
(937, 'lucifer', 'luci'),
(938, 'fumidus', 'fumi'),
(939, 'californicus', 'calif'),
(940, 'modestus', 'mods'),
(941, 'adnilus', 'adni'),
(942, 'acalcar', 'acal'),
(943, 'pseudotener', 'pste'),
(944, 'emorsus', 'emor'),
(945, 'shilovae', 'shil'),
(946, 'islandicus', 'island'),
(947, 'longicrus', 'longic'),
(948, 'apicalis', 'apical'),
(949, 'triquetra', 'trique'),
(950, 'orophila', 'orophi'),
(951, 'brevicosta', 'brevic'),
(952, 'nigra', 'nigra'),
(953, 'arcuatus', 'arcuat'),
(954, 'primitivus', 'primit'),
(955, 'varus', 'varus'),
(956, 'paragretis', 'paragr'),
(957, 'fusistylus', 'fusist'),
(958, 'incallida', 'incall'),
(959, 'latitarsis', 'latita'),
(960, 'tonollii', 'tonoll'),
(961, 'punctatissima', 'puncta'),
(962, 'curtilamellata', 'curtil'),
(963, 'frequens', 'freque'),
(964, 'vitiosus', 'vitios'),
(965, 'laminata', 'lamina'),
(966, 'bicrenatum', 'bicren'),
(967, 'varius', 'varius'),
(968, 'ariel', 'ariel'),
(969, 'salinophilus', 'sano'),
(970, 'zavreli', 'zavr'),
(971, 'albisutus', 'albs'),
(972, 'uliginosus', 'ulig'),
(973, 'lucidus', 'lucd'),
(974, 'celeripes', 'cele'),
(975, 'macropodus', 'macp'),
(976, 'quadrinodosus', 'quadri'),
(977, 'longistylus', 'longis');

-- --------------------------------------------------------

--
-- Table structure for table `names_subfamily`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
-- Last check: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_subfamily`;
CREATE TABLE IF NOT EXISTS `names_subfamily` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT 'automatic ID',
  `name` varchar(30) NOT NULL COMMENT 'subfamily name',
  `name_short` varchar(2) NOT NULL COMMENT 'short name (2 letters)',
  `notes` text COMMENT 'notes',
  `morph_attrib_id` varchar(30) NOT NULL DEFAULT '0' COMMENT 'has to be set!!: which default morphological structure',
  PRIMARY KEY (`id`),
  UNIQUE KEY `fam_short` (`name_short`),
  FULLTEXT KEY `fam_ann` (`notes`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='all subfamily names' AUTO_INCREMENT=9 ;

--
-- Dumping data for table `names_subfamily`
--

INSERT INTO `names_subfamily` (`id`, `name`, `name_short`, `notes`, `morph_attrib_id`) VALUES
(1, 'Orthocladiinae', 'Or', NULL, '97,96,161,144,152,141,151,7'),
(2, 'Chironominae', 'Ch', NULL, '97,96,161,144,152,141,151,7'),
(3, 'Tanypodinae', 'Ta', NULL, '85,98,99'),
(4, 'Diamesinae', 'Di', NULL, '97,96,161,144,152,141,151,7'),
(5, 'Podonominae', 'Po', NULL, '97,96,161,144,152,141,151,7'),
(6, 'Prodiamesinae', 'Pr', NULL, '97,96,161,144,152,141,151,7'),
(7, 'Buchonomyiinae', 'Bu', NULL, '97,96,161,144,152,141,151,7'),
(8, 'Telmatogetoninae', 'Te', NULL, '97,96,161,144,152,141,151,7');

-- --------------------------------------------------------

--
-- Table structure for table `names_subgenus`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_subgenus`;
CREATE TABLE IF NOT EXISTS `names_subgenus` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'automatic ID',
  `name` varchar(70) NOT NULL COMMENT 'name of subgenus',
  `name_short` varchar(2) NOT NULL COMMENT 'short name of subgenus (2 letters)',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='all subgenus names' AUTO_INCREMENT=33 ;

--
-- Dumping data for table `names_subgenus`
--

INSERT INTO `names_subgenus` (`id`, `name`, `name_short`) VALUES
(1, 'Isocladius', 'Is'),
(2, 'Nostococladius', 'No'),
(3, 'Eudactylocladius', 'Eu'),
(4, 'Cricotopus', 'Cr'),
(5, 'Pseudocricotopus', 'Ps'),
(6, 'Allopsectrocladius', 'Al'),
(7, 'Monopsectrocladius', 'Mo'),
(8, 'Mesopsectrocladius', 'Me'),
(9, 'Psectrocladius', 'Ps'),
(10, 'Euorthocladius', 'Eu'),
(11, 'Orthocladius', 'Or'),
(12, 'Pogonocladius', 'Po'),
(14, 'Psammocladius', 'Ps'),
(15, 'Polypedilum', 'Po'),
(16, 'Asayia', 'As'),
(17, 'Ablabesmyia', 'Ab'),
(18, 'Pentapedilum', 'Pe'),
(19, 'Tripodura', 'Tr'),
(20, 'Urespedilum', 'Ur'),
(21, 'Plecopteracoluthus', 'Pl'),
(22, 'Demicryptochironomus', 'De'),
(23, 'Symposiocladius', 'Sy'),
(24, 'Psectrotanypus', 'Ps'),
(25, 'Procladius', 'Pr'),
(26, 'Caulochironomus', 'Ca'),
(27, 'Glyptotendipes', 'Gl'),
(28, 'Psilotanypus', 'Ps'),
(29, 'Camptochironomus', 'Ca'),
(30, 'Chironomus', 'Ch'),
(31, 'Holotanypus', 'Ho'),
(32, 'Lobochironomus', 'Lo');

-- --------------------------------------------------------

--
-- Table structure for table `names_subtribe`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
-- Last check: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_subtribe`;
CREATE TABLE IF NOT EXISTS `names_subtribe` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT 'automatic ID',
  `name` varchar(30) NOT NULL COMMENT 'name of subtribe',
  `notes` text NOT NULL COMMENT 'additional notes',
  PRIMARY KEY (`id`),
  FULLTEXT KEY `fam_ann` (`notes`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='all subtribe names' AUTO_INCREMENT=3 ;

--
-- Dumping data for table `names_subtribe`
--

INSERT INTO `names_subtribe` (`id`, `name`, `notes`) VALUES
(1, 'Anatopyniina', '3'),
(2, 'Macropelopiina', '3');

-- --------------------------------------------------------

--
-- Table structure for table `names_synonyms`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
-- Last check: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_synonyms`;
CREATE TABLE IF NOT EXISTS `names_synonyms` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'primary key',
  `valid_name_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_valid',
  `genus_name_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_genera',
  `species_name_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_subfamily',
  `author_name_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_author',
  `subfamily_name_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_subfamily',
  `note` text COMMENT 'annotations',
  PRIMARY KEY (`id`),
  KEY `specimen_name` (`genus_name_id`,`species_name_id`,`author_name_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='synonym_names' AUTO_INCREMENT=1606 ;

--
-- RELATIONS FOR TABLE `names_synonyms`:
--   `author_name_id`
--       `names_authors` -> `id`
--   `genus_name_id`
--       `names_genera` -> `id`
--   `species_name_id`
--       `names_species` -> `id`
--   `subfamily_name_id`
--       `names_subfamily` -> `id`
--   `valid_name_id`
--       `names_valid` -> `id`
--

--
-- Dumping data for table `names_synonyms`
--

INSERT INTO `names_synonyms` (`id`, `valid_name_id`, `genus_name_id`, `species_name_id`, `author_name_id`, `subfamily_name_id`, `note`) VALUES
(1, 401, 46, 62, 0, 1, 'Eukiefferiella discoloripes invalid after [[http://www.faunaeur.org/full_results.php?id=283435]]'),
(2, 698, 122, 297, 309, 1, NULL),
(3, 1625, 53, 548, 447, 2, 'is synonym after {citeID|298|Moller-Pillot et.al. 1997}'),
(4, 578, 143, 511, 446, 1, 'after [[http://www.itis.gov/servlet/SingleRpt/SingleRpt?search_topic=Scientific_Name&search_kingdom=Animal&search_span=containing&search_value=Psilometriocnemus%20cristatus&Go=Search&categories=All&source=html&search_credRating=All http://www.itis.gov/]]'),
(5, 1638, 86, 478, 319, 1, 'as synonym see Fauna Europaea and {citeID|20|Schmid 1993}'),
(6, 1571, 86, 144, 263, 1, ' described as M.obscuripes Holmgren 1869 (invalid [[http://www.faunaeur.org/full_results.php?id=283993]])'),
(7, 1571, 86, 92, 381, 1, ' described as M.hygropetricus Kieffer 1912 (invalid [[http://www.faunaeur.org/full_results.php?id=283993]])'),
(8, 1524, 13, 113, 0, 1, ' A.Plank: I named B.longiforceps wrong from {citeID|20|Schmid 1993}'),
(10, 1647, 29, 101, 322, 1, ' was wrong saved as C.lacunarius'),
(11, 1649, 28, 149, 467, 2, ' named wrongly from {citeID|25|Walker 2000}'),
(12, 1664, 170, 257, 278, 2, ' Tanytarsus sp. C {citeID|278|Hofmann 1971} is T. glabrescens see {citeID|302|Brooks et al. 2007}'),
(13, 296, 20, 271, 11, 2, ' Added a note C.plumosus &rsquo;f.reductus&rsquo;'),
(15, 1692, 220, 400, 540, 3, ' A.Plank named it wrong Psectrotanypus varipes (Fabricius 1787) -> Psectrotanypus varius (Fabricius 1787)'),
(16, 310, 46, 453, 276, 1, ' moved from group level to species level Eukiefferiella gracei gr. No reference given -> Eukiefferiella gracei (Edwards 1929)'),
(17, 1471, 119, 493, 1, 2, ' species type fused to P.penicillatus Paratanytarsus penicillatus type No reference given -> Paratanytarsus penicillatus No reference given'),
(18, 1605, 170, 698, 0, 2, 'Tanytarsus dissimilis as Synonym for Paratanytarsus dissimilis ([[http://www.itis.gov/servlet/SingleRpt/SingleRpt?search_topic=TSN&search_value=129990 ITIS]])');

-- --------------------------------------------------------

--
-- Table structure for table `names_tribe`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
-- Last check: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_tribe`;
CREATE TABLE IF NOT EXISTS `names_tribe` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT 'automatic ID',
  `name` varchar(30) NOT NULL COMMENT 'name of tribus',
  `notes` text COMMENT 'additional notes',
  PRIMARY KEY (`id`),
  FULLTEXT KEY `fam_ann` (`notes`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='all tribe names' AUTO_INCREMENT=13 ;

--
-- Dumping data for table `names_tribe`
--

INSERT INTO `names_tribe` (`id`, `name`, `notes`) VALUES
(1, 'Boreochlini', ''),
(2, 'Boreoheptagyiini', ''),
(3, 'Chironomini', ''),
(4, 'Coelotanypodini', ''),
(5, 'Diamesini', ''),
(6, 'Macropelopiini', ''),
(7, 'Pentaneurini', ''),
(8, 'Procladiini', ''),
(9, 'Protanypodini', ''),
(10, 'Tanypodini', ''),
(11, 'Tanytarsini', ''),
(12, 'Pseudochironomini', '');

-- --------------------------------------------------------

--
-- Table structure for table `names_valid`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
-- Last check: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `names_valid`;
CREATE TABLE IF NOT EXISTS `names_valid` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'primary key',
  `genus_name_id` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_genera',
  `species_name_id` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT 'id from tale names_species',
  `descriptor_name_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_author',
  `subfamily_name_id` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'id from table names_subfamily',
  `in_brackets` tinyint(2) DEFAULT NULL COMMENT 'author in brackets?',
  `tribe_name_id` smallint(3) DEFAULT NULL,
  `subtribe_name_id` smallint(3) DEFAULT NULL,
  `subgenus_name_id` smallint(3) unsigned DEFAULT NULL,
  `notes` text COMMENT 'sytematic notes',
  PRIMARY KEY (`id`),
  UNIQUE KEY `specimen` (`genus_name_id`,`species_name_id`,`subgenus_name_id`),
  KEY `subgenus_name_id` (`subgenus_name_id`),
  KEY `species_name_id` (`species_name_id`),
  KEY `subfamily_name_id` (`subfamily_name_id`),
  KEY `descriptor_name_id` (`descriptor_name_id`),
  KEY `tribe_name_id` (`tribe_name_id`),
  KEY `subtribe_name_id` (`subtribe_name_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='valid names (to insert new species add first ''Genus sp.'')' AUTO_INCREMENT=1703 ;

--
-- RELATIONS FOR TABLE `names_valid`:
--   `descriptor_name_id`
--       `names_authors` -> `id`
--   `genus_name_id`
--       `names_genera` -> `id`
--   `species_name_id`
--       `names_species` -> `id`
--   `subfamily_name_id`
--       `names_subfamily` -> `id`
--   `subgenus_name_id`
--       `names_subgenus` -> `id`
--   `subtribe_name_id`
--       `names_subtribe` -> `id`
--   `tribe_name_id`
--       `names_tribe` -> `id`
--

--
-- Dumping data for table `names_valid`
--

INSERT INTO `names_valid` (`id`, `genus_name_id`, `species_name_id`, `descriptor_name_id`, `subfamily_name_id`, `in_brackets`, `tribe_name_id`, `subtribe_name_id`, `subgenus_name_id`, `notes`) VALUES
(1, 1, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(2, 2, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(3, 3, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(4, 4, 192, 0, 1, 0, NULL, NULL, NULL, NULL),
(6, 6, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(7, 7, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(8, 8, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(9, 9, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(10, 10, 192, 0, 5, NULL, NULL, NULL, NULL, NULL),
(11, 11, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(12, 12, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(13, 13, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(15, 15, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(16, 16, 192, 0, 7, NULL, NULL, NULL, NULL, NULL),
(17, 17, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(18, 18, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(19, 19, 192, 366, 1, NULL, NULL, NULL, NULL, 'reference from http://www.ubio.org/NZ/'),
(20, 20, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(22, 22, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(23, 23, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(24, 24, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(25, 25, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(26, 26, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(27, 27, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(28, 28, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(29, 29, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(31, 31, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(33, 33, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(34, 34, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(35, 35, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(36, 36, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(37, 37, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(38, 38, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(39, 39, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(40, 40, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(41, 41, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(42, 42, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(43, 43, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(44, 44, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(45, 45, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(46, 46, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(48, 48, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(49, 49, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(51, 51, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(53, 53, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(55, 55, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(56, 56, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(58, 58, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(59, 59, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(60, 60, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(61, 61, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(63, 63, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(64, 64, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(65, 65, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(67, 67, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(68, 68, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(69, 69, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(70, 70, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(71, 71, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(72, 72, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(73, 73, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(75, 75, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(76, 76, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(77, 77, 192, 0, 5, NULL, NULL, NULL, NULL, NULL),
(78, 78, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(79, 79, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(81, 81, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(83, 83, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(84, 84, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(85, 85, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(86, 86, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(87, 87, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(88, 88, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(90, 90, 192, 440, 2, 0, NULL, NULL, NULL, 'cited from http://www.ubio.org/NZ/search.php'),
(91, 91, 192, 0, 6, NULL, NULL, NULL, NULL, NULL),
(92, 92, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(93, 93, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(94, 94, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(95, 95, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(96, 96, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(97, 97, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(98, 98, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(99, 99, 192, 0, 6, NULL, NULL, NULL, NULL, NULL),
(100, 100, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(101, 101, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(104, 104, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(105, 105, 192, 0, 5, NULL, NULL, NULL, NULL, NULL),
(106, 106, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(107, 107, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(108, 108, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(109, 109, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(110, 110, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(111, 111, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(113, 113, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(115, 115, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(116, 116, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(118, 118, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(119, 119, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(121, 121, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(122, 122, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(123, 123, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(125, 125, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(130, 130, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(132, 132, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(134, 134, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(135, 135, 192, 0, 1, NULL, NULL, NULL, 8, NULL),
(140, 140, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(141, 141, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(142, 142, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(143, 143, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(147, 147, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(148, 148, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(149, 149, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(150, 150, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(151, 151, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(152, 152, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(153, 153, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(154, 154, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(155, 155, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(156, 156, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(158, 158, 192, 0, 2, NULL, 3, NULL, NULL, NULL),
(159, 159, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(160, 160, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(161, 161, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(162, 162, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(163, 163, 192, 37, 4, 0, NULL, NULL, NULL, NULL),
(164, 164, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(166, 166, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(168, 168, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(170, 170, 192, 0, 2, NULL, 11, NULL, NULL, NULL),
(172, 172, 192, 0, 8, NULL, NULL, NULL, NULL, NULL),
(173, 173, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(174, 174, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(175, 175, 192, 0, 8, NULL, NULL, NULL, NULL, NULL),
(176, 176, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(177, 177, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(178, 178, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(179, 179, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(180, 180, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(181, 181, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(182, 182, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(183, 183, 192, 0, 5, NULL, NULL, NULL, NULL, NULL),
(184, 184, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(185, 185, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(186, 186, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(189, 189, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(190, 190, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(191, 191, 192, 468, 1, 0, NULL, NULL, NULL, NULL),
(192, 192, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(193, 193, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(194, 194, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(195, 195, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(196, 196, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(197, 197, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(199, 199, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(200, 200, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(202, 202, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(203, 203, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(204, 204, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(205, 205, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(206, 206, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(207, 207, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(208, 208, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(209, 209, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(210, 210, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(212, 212, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(213, 213, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(214, 214, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(215, 215, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(216, 216, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(217, 245, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(218, 218, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(219, 219, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(220, 220, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(223, 223, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(224, 224, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(225, 225, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(227, 227, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(228, 228, 192, 0, 6, NULL, NULL, NULL, NULL, NULL),
(230, 135, 192, 0, 1, NULL, NULL, NULL, 6, NULL),
(231, 135, 192, 0, 1, NULL, NULL, NULL, 7, NULL),
(232, 135, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(233, 135, 192, 0, 1, NULL, NULL, NULL, 9, NULL),
(234, 31, 192, 0, 1, NULL, NULL, NULL, 1, NULL),
(235, 31, 192, 0, 1, NULL, NULL, NULL, 4, NULL),
(236, 31, 192, 0, 1, NULL, NULL, NULL, 2, NULL),
(237, 31, 192, 0, 1, NULL, NULL, NULL, 5, NULL),
(238, 103, 192, 0, 1, NULL, NULL, NULL, 10, NULL),
(239, 239, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(240, 103, 192, 0, 1, NULL, NULL, NULL, 11, NULL),
(241, 103, 192, 0, 1, NULL, NULL, NULL, 12, NULL),
(242, 103, 192, 0, 1, NULL, NULL, NULL, 3, NULL),
(243, 103, 192, 0, 1, NULL, NULL, NULL, 14, NULL),
(248, 25, 438, 0, 1, NULL, NULL, NULL, NULL, NULL),
(247, 25, 290, 0, 1, NULL, NULL, NULL, NULL, NULL),
(246, 103, 105, 373, 1, 1, NULL, NULL, 23, NULL),
(245, 215, 445, 420, 3, 1, NULL, NULL, NULL, NULL),
(249, 245, 501, 0, 3, NULL, NULL, NULL, NULL, NULL),
(250, 245, 63, 0, 3, NULL, NULL, NULL, NULL, NULL),
(251, 151, 59, 0, 2, NULL, NULL, NULL, NULL, NULL),
(252, 75, 157, 0, 1, NULL, NULL, NULL, NULL, NULL),
(253, 194, 322, 0, 3, NULL, NULL, NULL, NULL, NULL),
(254, 194, 23, 0, 3, NULL, NULL, NULL, NULL, NULL),
(255, 194, 545, 0, 3, NULL, NULL, NULL, NULL, NULL),
(256, 181, 539, 0, 1, NULL, NULL, NULL, NULL, NULL),
(257, 85, 477, 0, 1, NULL, NULL, NULL, NULL, NULL),
(258, 227, 320, 328, 2, 1, NULL, NULL, NULL, NULL),
(259, 227, 102, 315, 2, 1, NULL, NULL, 15, NULL),
(260, 92, 211, 0, 3, NULL, NULL, NULL, NULL, NULL),
(261, 123, 69, 0, 1, NULL, NULL, NULL, NULL, NULL),
(262, 24, 272, 0, 3, NULL, NULL, NULL, NULL, NULL),
(263, 24, 286, 0, 3, NULL, NULL, NULL, NULL, NULL),
(264, 184, 407, 0, 1, NULL, NULL, NULL, NULL, NULL),
(265, 116, 366, 0, 1, NULL, NULL, NULL, NULL, NULL),
(266, 116, 499, 0, 1, NULL, NULL, NULL, NULL, NULL),
(267, 39, 840, 0, 2, NULL, NULL, NULL, NULL, NULL),
(268, 39, 396, 0, 2, NULL, NULL, NULL, NULL, NULL),
(269, 39, 286, 0, 2, NULL, NULL, NULL, NULL, NULL),
(270, 39, 397, 0, 2, NULL, NULL, NULL, NULL, NULL),
(271, 39, 398, 307, 2, 0, NULL, NULL, NULL, NULL),
(272, 36, 174, 0, 2, NULL, NULL, NULL, NULL, NULL),
(273, 36, 401, 0, 2, NULL, NULL, NULL, NULL, NULL),
(274, 36, 402, 0, 2, NULL, NULL, NULL, NULL, NULL),
(275, 147, 67, 0, 1, NULL, NULL, NULL, NULL, NULL),
(276, 147, 40, 0, 1, NULL, NULL, NULL, NULL, NULL),
(277, 147, 233, 0, 1, NULL, NULL, NULL, NULL, NULL),
(278, 147, 77, 0, 1, NULL, NULL, NULL, NULL, NULL),
(279, 147, 512, 0, 1, NULL, NULL, NULL, NULL, NULL),
(280, 173, 133, 0, 3, NULL, NULL, NULL, NULL, NULL),
(281, 213, 439, 0, 3, NULL, NULL, NULL, NULL, NULL),
(282, 67, 270, 307, 2, 0, 3, NULL, NULL, NULL),
(283, 20, 131, 0, 2, NULL, NULL, NULL, NULL, NULL),
(284, 20, 160, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1684, 59, 962, 0, 2, NULL, 3, NULL, NULL, NULL),
(286, 20, 353, 0, 2, NULL, NULL, NULL, NULL, NULL),
(287, 20, 210, 0, 2, NULL, NULL, NULL, 29, NULL),
(288, 20, 330, 0, 2, NULL, NULL, NULL, NULL, NULL),
(289, 20, 391, 0, 2, NULL, NULL, NULL, NULL, NULL),
(290, 20, 393, 0, 2, NULL, NULL, NULL, NULL, NULL),
(291, 20, 394, 0, 2, NULL, NULL, NULL, NULL, NULL),
(292, 20, 170, 0, 2, NULL, NULL, NULL, 30, NULL),
(293, 20, 178, 0, 2, NULL, NULL, NULL, 30, NULL),
(294, 20, 5, 0, 2, NULL, NULL, NULL, NULL, NULL),
(295, 20, 142, 0, 2, NULL, NULL, NULL, NULL, NULL),
(296, 20, 161, 0, 2, NULL, NULL, NULL, 30, NULL),
(297, 20, 145, 0, 2, NULL, NULL, NULL, NULL, NULL),
(298, 20, 392, 0, 2, NULL, NULL, NULL, NULL, NULL),
(299, 20, 1, 0, 2, NULL, NULL, NULL, NULL, NULL),
(300, 20, 65, 0, 2, NULL, NULL, NULL, NULL, NULL),
(301, 20, 153, 0, 2, NULL, NULL, NULL, 29, NULL),
(302, 20, 124, 0, 2, NULL, NULL, NULL, NULL, NULL),
(303, 20, 395, 0, 2, NULL, NULL, NULL, NULL, NULL),
(304, 20, 122, 0, 2, NULL, NULL, NULL, NULL, NULL),
(305, 101, 485, 0, 2, NULL, NULL, NULL, NULL, NULL),
(306, 46, 127, 0, 1, NULL, NULL, NULL, NULL, NULL),
(307, 46, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(308, 46, 47, 367, 1, 1, NULL, NULL, NULL, NULL),
(309, 46, 215, 0, 1, NULL, NULL, NULL, NULL, NULL),
(310, 46, 83, 276, 1, 1, NULL, NULL, NULL, NULL),
(311, 46, 45, 0, 1, NULL, NULL, NULL, NULL, NULL),
(312, 46, 108, 0, 1, NULL, NULL, NULL, NULL, NULL),
(313, 46, 75, 0, 1, NULL, NULL, NULL, NULL, NULL),
(314, 46, 61, 0, 1, NULL, NULL, NULL, NULL, NULL),
(315, 46, 72, 0, 1, NULL, NULL, NULL, NULL, NULL),
(316, 46, 94, 0, 1, NULL, NULL, NULL, NULL, NULL),
(317, 46, 186, 365, 1, 0, NULL, NULL, NULL, NULL),
(318, 46, 49, 368, 1, 1, NULL, NULL, NULL, NULL),
(319, 46, 407, 0, 1, NULL, NULL, NULL, NULL, NULL),
(320, 46, 305, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1693, 160, 792, 542, 1, 0, NULL, NULL, NULL, NULL),
(322, 46, 306, 0, 1, NULL, NULL, NULL, NULL, NULL),
(323, 46, 454, 0, 1, NULL, NULL, NULL, NULL, NULL),
(324, 46, 451, 0, 1, NULL, NULL, NULL, NULL, NULL),
(325, 46, 452, 0, 1, NULL, NULL, NULL, NULL, NULL),
(326, 46, 450, 0, 1, NULL, NULL, NULL, NULL, NULL),
(327, 46, 449, 0, 1, NULL, NULL, NULL, NULL, NULL),
(328, 118, 487, 0, 1, NULL, NULL, NULL, NULL, NULL),
(329, 197, 448, 0, 2, NULL, NULL, NULL, NULL, NULL),
(330, 197, 90, 0, 2, NULL, NULL, NULL, NULL, NULL),
(331, 225, 266, 0, 4, NULL, NULL, NULL, NULL, NULL),
(332, 55, 88, 0, 3, NULL, NULL, NULL, NULL, NULL),
(333, 60, 459, 0, 3, NULL, NULL, NULL, NULL, NULL),
(334, 135, 336, 309, 1, 1, NULL, NULL, 6, NULL),
(335, 135, 190, 0, 1, NULL, NULL, NULL, 9, NULL),
(336, 135, 417, 0, 1, NULL, NULL, NULL, 9, NULL),
(337, 135, 343, 350, 1, 0, NULL, NULL, 9, NULL),
(338, 135, 510, 32, 1, 0, NULL, NULL, 9, NULL),
(339, 135, 292, 0, 1, NULL, NULL, NULL, 9, NULL),
(340, 135, 506, 0, 1, NULL, NULL, NULL, 9, NULL),
(341, 135, 413, 0, 1, NULL, NULL, NULL, 9, NULL),
(342, 135, 340, 0, 1, NULL, NULL, NULL, 9, NULL),
(343, 135, 412, 0, 1, NULL, NULL, NULL, 7, NULL),
(344, 135, 590, 449, 1, 0, NULL, NULL, 9, NULL),
(345, 135, 23, 0, 1, NULL, NULL, NULL, 9, NULL),
(346, 135, 415, 0, 1, NULL, NULL, NULL, 9, NULL),
(347, 135, 416, 450, 1, 0, NULL, NULL, 9, NULL),
(348, 135, 239, 0, 1, NULL, NULL, NULL, 9, NULL),
(349, 135, 98, 0, 1, NULL, NULL, NULL, 9, NULL),
(350, 135, 291, 263, 1, 1, NULL, NULL, 9, NULL),
(351, 135, 508, 0, 1, NULL, NULL, NULL, 9, NULL),
(352, 135, 411, 0, 1, NULL, NULL, NULL, 7, NULL),
(353, 135, 252, 0, 1, NULL, NULL, NULL, NULL, NULL),
(354, 135, 509, 0, 1, NULL, NULL, NULL, 9, NULL),
(355, 135, 505, 0, 1, NULL, NULL, NULL, 9, NULL),
(356, 135, 507, 0, 1, NULL, NULL, NULL, 9, NULL),
(358, 13, 752, 0, 1, NULL, NULL, NULL, NULL, NULL),
(359, 13, 390, 0, 1, NULL, NULL, NULL, NULL, NULL),
(360, 13, 542, 0, 1, NULL, NULL, NULL, NULL, NULL),
(361, 4, 337, 453, 1, 0, NULL, NULL, NULL, NULL),
(362, 4, 335, 0, 1, NULL, NULL, NULL, NULL, NULL),
(363, 4, 280, 272, 1, 1, NULL, NULL, NULL, NULL),
(364, 119, 20, 0, 2, NULL, 3, NULL, NULL, NULL),
(365, 119, 308, 0, 2, NULL, NULL, NULL, NULL, NULL),
(366, 119, 260, 0, 2, NULL, NULL, NULL, NULL, NULL),
(367, 119, 491, 0, 2, NULL, NULL, NULL, NULL, NULL),
(368, 119, 307, 0, 2, NULL, NULL, NULL, NULL, NULL),
(369, 119, 488, 0, 2, NULL, NULL, NULL, NULL, NULL),
(370, 119, 494, 0, 2, NULL, NULL, NULL, NULL, NULL),
(371, 119, 490, 0, 2, NULL, NULL, NULL, NULL, NULL),
(372, 119, 492, 0, 2, NULL, NULL, NULL, NULL, NULL),
(373, 119, 489, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1695, 207, 971, 0, 2, NULL, NULL, NULL, NULL, NULL),
(375, 119, 242, 0, 2, NULL, NULL, NULL, NULL, NULL),
(376, 119, 301, 0, 2, NULL, NULL, NULL, NULL, NULL),
(377, 71, 474, 0, 1, NULL, NULL, NULL, NULL, NULL),
(378, 71, 37, 0, 1, NULL, NULL, NULL, NULL, NULL),
(379, 191, 543, 468, 1, 0, NULL, NULL, NULL, NULL),
(380, 191, 334, 241, 1, 1, NULL, NULL, NULL, NULL),
(381, 191, 544, 0, 1, NULL, NULL, NULL, NULL, NULL),
(382, 212, 408, 0, 3, NULL, NULL, NULL, NULL, NULL),
(383, 178, 46, 0, 1, NULL, NULL, NULL, NULL, NULL),
(384, 178, 3, 0, 1, NULL, NULL, NULL, NULL, NULL),
(385, 178, 226, 0, 1, NULL, NULL, NULL, NULL, NULL),
(386, 178, 259, 0, 1, NULL, NULL, NULL, NULL, NULL),
(387, 178, 293, 0, 1, NULL, NULL, NULL, NULL, NULL),
(388, 178, 156, 0, 1, NULL, NULL, NULL, NULL, NULL),
(389, 178, 119, 0, 1, NULL, NULL, NULL, NULL, NULL),
(390, 178, 258, 0, 1, NULL, NULL, NULL, NULL, NULL),
(391, 178, 457, 0, 1, NULL, NULL, NULL, NULL, NULL),
(392, 179, 537, 0, 3, NULL, NULL, NULL, NULL, NULL),
(393, 179, 288, 0, 3, NULL, NULL, NULL, NULL, NULL),
(394, 179, 538, 0, 3, NULL, NULL, NULL, NULL, NULL),
(395, 179, 394, 0, 3, NULL, NULL, NULL, NULL, NULL),
(396, 40, 54, 0, 1, NULL, NULL, NULL, NULL, NULL),
(397, 186, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(398, 186, 223, 0, 1, NULL, NULL, NULL, NULL, NULL),
(399, 186, 26, 363, 1, 1, NULL, NULL, NULL, 'itis and fauna europea'),
(400, 186, 36, 0, 1, NULL, NULL, NULL, NULL, NULL),
(401, 186, 62, 361, 1, 1, NULL, NULL, NULL, 'Tvetenia discoloripes invalid (ITIS) and valid from http://www.faunaeur.org'),
(402, 186, 540, 0, 1, NULL, NULL, NULL, NULL, NULL),
(403, 7, 273, 0, 3, NULL, NULL, NULL, NULL, NULL),
(404, 7, 404, 0, 3, NULL, NULL, NULL, NULL, NULL),
(405, 90, 300, 0, 2, NULL, NULL, NULL, NULL, NULL),
(406, 111, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(407, 111, 24, 0, 1, NULL, NULL, NULL, NULL, NULL),
(408, 111, 313, 0, 1, NULL, NULL, NULL, NULL, NULL),
(409, 111, 314, 0, 1, NULL, NULL, NULL, NULL, NULL),
(410, 111, 496, 0, 1, NULL, NULL, NULL, NULL, NULL),
(411, 109, 64, 0, 2, NULL, NULL, NULL, NULL, NULL),
(412, 109, 319, 0, 2, NULL, NULL, NULL, NULL, NULL),
(413, 17, 455, 0, 1, NULL, NULL, NULL, NULL, NULL),
(414, 91, 324, 0, 6, NULL, NULL, NULL, NULL, NULL),
(415, 43, 113, 0, 2, NULL, NULL, NULL, NULL, NULL),
(416, 43, 152, 0, 2, NULL, NULL, NULL, NULL, NULL),
(417, 43, 338, 0, 2, NULL, NULL, NULL, NULL, NULL),
(418, 43, 339, 0, 2, NULL, 3, NULL, NULL, NULL),
(419, 206, 235, 0, 1, NULL, NULL, NULL, NULL, NULL),
(420, 115, 498, 0, 1, NULL, NULL, NULL, NULL, NULL),
(421, 115, 206, 0, 1, NULL, NULL, NULL, NULL, NULL),
(422, 115, 365, 0, 1, NULL, NULL, NULL, NULL, NULL),
(423, 115, 497, 0, 1, NULL, NULL, NULL, NULL, NULL),
(424, 115, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(425, 63, 460, 0, 1, NULL, NULL, NULL, NULL, NULL),
(426, 38, 81, 0, 4, NULL, NULL, NULL, NULL, NULL),
(427, 38, 267, 0, 4, NULL, NULL, NULL, NULL, NULL),
(428, 38, 204, 0, 4, NULL, NULL, NULL, NULL, NULL),
(429, 38, 216, 0, 4, NULL, NULL, NULL, NULL, NULL),
(430, 38, 42, 0, 4, NULL, NULL, NULL, NULL, NULL),
(431, 38, 276, 0, 4, NULL, NULL, NULL, NULL, NULL),
(432, 38, 28, 0, 4, NULL, NULL, NULL, NULL, NULL),
(433, 38, 89, 0, 4, NULL, NULL, NULL, NULL, NULL),
(434, 38, 96, 0, 4, NULL, NULL, NULL, NULL, NULL),
(435, 38, 159, 0, 4, NULL, NULL, NULL, NULL, NULL),
(436, 38, 232, 0, 4, NULL, NULL, NULL, NULL, NULL),
(437, 38, 222, 0, 4, NULL, NULL, NULL, NULL, NULL),
(438, 38, 264, 0, 4, NULL, NULL, NULL, NULL, NULL),
(439, 38, 200, 0, 4, NULL, NULL, NULL, NULL, NULL),
(440, 38, 325, 0, 4, NULL, NULL, NULL, NULL, NULL),
(441, 38, 277, 0, 4, NULL, NULL, NULL, NULL, NULL),
(442, 64, 301, 0, 1, NULL, NULL, NULL, NULL, NULL),
(443, 64, 257, 0, 1, NULL, NULL, NULL, NULL, NULL),
(444, 64, 259, 0, 1, NULL, NULL, NULL, NULL, NULL),
(445, 64, 258, 0, 1, NULL, NULL, NULL, NULL, NULL),
(446, 64, 183, 0, 1, NULL, NULL, NULL, NULL, NULL),
(447, 64, 463, 0, 1, NULL, NULL, NULL, NULL, NULL),
(448, 64, 202, 0, 1, NULL, NULL, NULL, NULL, NULL),
(449, 64, 424, 0, 1, NULL, NULL, NULL, NULL, NULL),
(450, 64, 462, 0, 1, NULL, NULL, NULL, NULL, NULL),
(451, 64, 461, 0, 1, NULL, NULL, NULL, NULL, NULL),
(452, 64, 149, 0, 1, NULL, NULL, NULL, NULL, NULL),
(453, 64, 120, 0, 1, NULL, NULL, NULL, NULL, NULL),
(454, 64, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(455, 64, 464, 0, 1, NULL, NULL, NULL, NULL, NULL),
(456, 83, 269, 0, 3, NULL, NULL, NULL, NULL, NULL),
(457, 83, 268, 0, 3, NULL, NULL, NULL, NULL, NULL),
(458, 83, 234, 0, 3, NULL, NULL, NULL, NULL, NULL),
(459, 199, 423, 291, 2, 0, NULL, NULL, NULL, NULL),
(460, 2, 114, 251, 3, 0, NULL, NULL, NULL, NULL),
(461, 2, 323, 0, 3, NULL, NULL, NULL, NULL, NULL),
(462, 2, 403, 259, 3, 0, NULL, NULL, NULL, NULL),
(463, 2, 129, 258, 3, 0, NULL, NULL, 17, NULL),
(464, 204, 515, 0, 1, NULL, NULL, NULL, NULL, NULL),
(465, 44, 255, 0, 2, NULL, NULL, NULL, NULL, NULL),
(466, 44, 256, 0, 2, NULL, NULL, NULL, NULL, NULL),
(467, 44, 254, 0, 2, NULL, NULL, NULL, NULL, NULL),
(468, 174, 535, 0, 3, NULL, NULL, NULL, NULL, NULL),
(469, 48, 388, 0, 1, NULL, NULL, NULL, NULL, NULL),
(470, 19, 60, 0, 1, NULL, NULL, NULL, NULL, NULL),
(471, 19, 418, 0, 1, NULL, NULL, NULL, NULL, NULL),
(472, 19, 419, 0, 1, NULL, NULL, NULL, NULL, NULL),
(473, 19, 422, 0, 1, NULL, NULL, NULL, NULL, NULL),
(474, 19, 200, 20, 1, 0, NULL, NULL, NULL, NULL),
(475, 19, 160, 0, 1, NULL, NULL, NULL, NULL, NULL),
(476, 19, 421, 0, 1, NULL, NULL, NULL, NULL, NULL),
(477, 19, 260, 0, 1, NULL, NULL, NULL, NULL, NULL),
(478, 19, 227, 0, 1, NULL, NULL, NULL, NULL, NULL),
(479, 19, 261, 0, 1, NULL, NULL, NULL, NULL, NULL),
(480, 19, 420, 0, 1, NULL, NULL, NULL, NULL, NULL),
(481, 142, 91, 0, 1, NULL, NULL, NULL, NULL, NULL),
(482, 142, 176, 0, 1, NULL, NULL, NULL, NULL, NULL),
(483, 142, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(484, 142, 225, 0, 1, NULL, NULL, NULL, NULL, NULL),
(485, 18, 38, 0, 1, NULL, NULL, NULL, NULL, NULL),
(486, 18, 326, 0, 1, NULL, NULL, NULL, NULL, NULL),
(487, 110, 80, 0, 1, NULL, NULL, NULL, NULL, NULL),
(488, 110, 134, 0, 1, NULL, NULL, NULL, NULL, NULL),
(489, 110, 203, 0, 1, NULL, NULL, NULL, NULL, NULL),
(490, 161, 517, 0, 1, NULL, NULL, NULL, NULL, NULL),
(491, 161, 184, 0, 1, NULL, NULL, NULL, NULL, NULL),
(492, 113, 486, 0, 1, NULL, NULL, NULL, NULL, NULL),
(493, 93, 166, 0, 1, NULL, NULL, NULL, NULL, NULL),
(494, 93, 32, 0, 1, NULL, NULL, NULL, NULL, NULL),
(495, 93, 22, 0, 1, NULL, NULL, NULL, NULL, NULL),
(496, 15, 409, 0, 1, NULL, NULL, NULL, NULL, NULL),
(497, 15, 231, 0, 1, NULL, NULL, NULL, NULL, NULL),
(498, 15, 132, 0, 1, NULL, NULL, NULL, NULL, NULL),
(499, 11, 407, 0, 4, NULL, NULL, NULL, NULL, NULL),
(500, 11, 482, 0, 4, NULL, NULL, NULL, NULL, NULL),
(501, 11, 481, 0, 4, NULL, NULL, NULL, NULL, NULL),
(502, 11, 392, 0, 4, NULL, NULL, NULL, NULL, NULL),
(503, 11, 130, 0, 4, NULL, NULL, NULL, NULL, NULL),
(504, 11, 483, 0, 4, NULL, NULL, NULL, NULL, NULL),
(505, 11, 484, 0, 4, NULL, NULL, NULL, NULL, NULL),
(506, 37, 354, 355, 2, 1, NULL, NULL, 22, NULL),
(507, 37, 443, 0, 2, NULL, NULL, NULL, NULL, NULL),
(508, 88, 436, 0, 2, NULL, NULL, NULL, NULL, NULL),
(509, 88, 430, 0, 2, NULL, NULL, NULL, NULL, NULL),
(510, 88, 435, 0, 2, NULL, NULL, NULL, NULL, NULL),
(511, 88, 434, 0, 2, NULL, NULL, NULL, NULL, NULL),
(512, 88, 437, 0, 2, NULL, NULL, NULL, NULL, NULL),
(513, 88, 429, 0, 2, NULL, NULL, NULL, NULL, NULL),
(514, 88, 432, 0, 2, NULL, NULL, NULL, NULL, NULL),
(515, 88, 431, 0, 2, NULL, NULL, NULL, NULL, NULL),
(516, 88, 433, 0, 2, NULL, NULL, NULL, NULL, NULL),
(517, 132, 504, 0, 1, NULL, NULL, NULL, NULL, NULL),
(518, 49, 389, 0, 1, NULL, NULL, NULL, NULL, NULL),
(519, 49, 208, 0, 1, NULL, NULL, NULL, NULL, NULL),
(520, 56, 456, 0, 1, NULL, NULL, NULL, NULL, NULL),
(521, 56, 202, 0, 1, NULL, NULL, NULL, NULL, NULL),
(522, 56, 213, 0, 1, NULL, NULL, NULL, NULL, NULL),
(523, 56, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(524, 205, 536, 0, 1, NULL, NULL, NULL, NULL, NULL),
(525, 190, 541, 0, 3, NULL, NULL, NULL, NULL, NULL),
(526, 170, 154, 0, 2, NULL, 11, NULL, NULL, NULL),
(527, 170, 519, 0, 2, NULL, 11, NULL, NULL, NULL),
(528, 170, 520, 0, 2, NULL, 11, NULL, NULL, NULL),
(529, 170, 522, 0, 2, NULL, 11, NULL, NULL, NULL),
(530, 170, 90, 0, 2, NULL, 11, NULL, NULL, NULL),
(531, 170, 35, 0, 2, NULL, 11, NULL, NULL, NULL),
(532, 170, 125, 0, 2, NULL, 11, NULL, NULL, NULL),
(533, 170, 121, 0, 2, NULL, 11, NULL, NULL, NULL),
(534, 170, 518, 0, 2, NULL, 11, NULL, NULL, NULL),
(535, 170, 525, 0, 2, NULL, 11, NULL, NULL, NULL),
(536, 170, 523, 0, 2, NULL, 11, NULL, NULL, NULL),
(537, 170, 25, 0, 2, NULL, 11, NULL, NULL, NULL),
(538, 170, 529, 0, 2, NULL, 11, NULL, NULL, NULL),
(539, 170, 394, 0, 2, NULL, 11, NULL, NULL, NULL),
(540, 170, 526, 0, 2, NULL, 11, NULL, NULL, NULL),
(541, 170, 282, 0, 2, NULL, 11, NULL, NULL, NULL),
(542, 170, 221, 0, 2, NULL, 11, NULL, NULL, NULL),
(1665, 111, 952, 0, 1, NULL, NULL, NULL, NULL, NULL),
(544, 170, 424, 0, 2, NULL, 11, NULL, NULL, NULL),
(545, 170, 362, 0, 2, NULL, 11, NULL, NULL, NULL),
(546, 170, 521, 0, 2, NULL, 11, NULL, NULL, NULL),
(547, 170, 531, 0, 2, NULL, 11, NULL, NULL, NULL),
(548, 170, 133, 0, 2, NULL, 11, NULL, NULL, NULL),
(549, 170, 534, 0, 2, NULL, 11, NULL, NULL, NULL),
(550, 170, 68, 0, 2, NULL, 11, NULL, NULL, NULL),
(551, 170, 524, 403, 2, 0, 11, NULL, NULL, NULL),
(552, 170, 223, 0, 2, NULL, 11, NULL, NULL, NULL),
(553, 170, 528, 0, 2, NULL, 11, NULL, NULL, NULL),
(554, 170, 283, 0, 2, NULL, 11, NULL, NULL, NULL),
(555, 170, 383, 0, 2, NULL, 11, NULL, NULL, NULL),
(556, 170, 532, 0, 2, NULL, 11, NULL, NULL, NULL),
(557, 170, 527, 0, 2, NULL, 11, NULL, NULL, NULL),
(558, 141, 410, 0, 1, NULL, NULL, NULL, NULL, NULL),
(559, 61, 151, 0, 1, NULL, NULL, NULL, NULL, NULL),
(560, 61, 185, 0, 1, NULL, NULL, NULL, NULL, NULL),
(561, 42, 447, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1692, 220, 967, 540, 3, 1, NULL, NULL, NULL, NULL),
(563, 130, 503, 426, 3, 1, NULL, NULL, 28, NULL),
(564, 130, 41, 337, 3, 1, NULL, NULL, NULL, NULL),
(565, 218, 502, 0, 3, NULL, NULL, NULL, NULL, NULL),
(566, 160, 516, 0, 1, NULL, NULL, NULL, NULL, NULL),
(567, 159, 329, 0, 2, NULL, NULL, NULL, NULL, NULL),
(568, 159, 260, 0, 2, NULL, NULL, NULL, NULL, NULL),
(569, 159, 261, 0, 2, NULL, NULL, NULL, NULL, NULL),
(570, 159, 303, 0, 2, NULL, NULL, NULL, NULL, NULL),
(571, 8, 405, 0, 3, NULL, NULL, NULL, NULL, NULL),
(573, 28, 10, 355, 2, 0, 11, NULL, NULL, NULL),
(574, 28, 440, 0, 2, NULL, NULL, NULL, NULL, NULL),
(575, 22, 299, 0, 2, NULL, NULL, NULL, NULL, NULL),
(576, 22, 260, 0, 2, NULL, NULL, NULL, NULL, NULL),
(577, 22, 261, 0, 2, NULL, NULL, NULL, NULL, NULL),
(578, 143, 309, 375, 1, NULL, NULL, NULL, NULL, NULL),
(579, 33, 441, 0, 2, NULL, 3, NULL, NULL, NULL),
(580, 33, 442, 0, 2, NULL, NULL, NULL, NULL, NULL),
(581, 34, 328, 0, 2, NULL, NULL, NULL, NULL, NULL),
(582, 154, 251, 0, 2, NULL, NULL, NULL, NULL, NULL),
(583, 154, 385, 0, 2, NULL, NULL, NULL, NULL, NULL),
(584, 154, 250, 0, 2, NULL, NULL, NULL, NULL, NULL),
(585, 154, 240, 0, 2, NULL, NULL, NULL, NULL, NULL),
(586, 154, 244, 0, 2, NULL, NULL, NULL, NULL, NULL),
(587, 154, 249, 0, 2, NULL, NULL, NULL, NULL, NULL),
(588, 154, 242, 0, 2, NULL, NULL, NULL, NULL, NULL),
(589, 154, 241, 0, 2, NULL, NULL, NULL, NULL, NULL),
(590, 154, 245, 0, 2, NULL, NULL, NULL, NULL, NULL),
(591, 154, 246, 0, 2, NULL, NULL, NULL, NULL, NULL),
(592, 154, 247, 0, 2, NULL, NULL, NULL, NULL, NULL),
(593, 154, 248, 0, 2, NULL, NULL, NULL, NULL, NULL),
(594, 154, 243, 0, 2, NULL, NULL, NULL, NULL, NULL),
(595, 168, 322, 0, 3, NULL, NULL, NULL, NULL, NULL),
(596, 168, 275, 0, 3, NULL, NULL, NULL, NULL, NULL),
(597, 168, 289, 0, 3, NULL, NULL, NULL, NULL, NULL),
(598, 122, 188, 276, 1, 0, NULL, NULL, NULL, NULL),
(600, 122, 136, 370, 1, 1, NULL, NULL, NULL, NULL),
(601, 155, 155, 0, 1, NULL, NULL, NULL, NULL, NULL),
(602, 155, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(603, 155, 202, 0, 1, NULL, NULL, NULL, NULL, NULL),
(604, 155, 432, 0, 1, NULL, NULL, NULL, NULL, NULL),
(605, 176, 46, 0, 1, NULL, NULL, NULL, NULL, NULL),
(606, 176, 438, 0, 1, NULL, NULL, NULL, NULL, NULL),
(607, 202, 410, 0, 1, NULL, NULL, NULL, NULL, NULL),
(608, 202, 118, 0, 1, NULL, NULL, NULL, NULL, NULL),
(609, 228, 137, 0, 6, NULL, NULL, NULL, NULL, NULL),
(610, 228, 333, 0, 6, NULL, NULL, NULL, NULL, NULL),
(611, 228, 32, 0, 6, NULL, NULL, NULL, NULL, NULL),
(612, 97, 66, 0, 3, NULL, NULL, NULL, NULL, NULL),
(613, 216, 465, 0, 3, NULL, NULL, NULL, NULL, NULL),
(614, 177, 84, 438, 1, 0, NULL, NULL, NULL, NULL),
(615, 51, 101, 0, 2, NULL, NULL, NULL, NULL, NULL),
(616, 72, 475, 0, 3, NULL, NULL, NULL, NULL, NULL),
(617, 148, 322, 0, 3, NULL, NULL, NULL, NULL, NULL),
(618, 148, 513, 0, 3, NULL, NULL, NULL, NULL, NULL),
(619, 94, 480, 0, 3, NULL, NULL, NULL, NULL, NULL),
(620, 31, 381, 0, 1, NULL, NULL, NULL, 4, NULL),
(621, 31, 355, 0, 1, NULL, NULL, NULL, 1, NULL),
(622, 31, 375, 0, 1, NULL, NULL, NULL, 1, NULL),
(623, 31, 219, 0, 1, NULL, NULL, NULL, NULL, NULL),
(624, 31, 378, 0, 1, NULL, NULL, NULL, 4, NULL),
(625, 31, 97, 0, 1, NULL, NULL, NULL, 1, NULL),
(626, 31, 374, 0, 1, NULL, NULL, NULL, 4, NULL),
(627, 31, 383, 318, 1, 1, NULL, NULL, 1, NULL),
(628, 31, 373, 0, 1, NULL, NULL, NULL, 4, NULL),
(629, 31, 384, 0, 1, NULL, NULL, NULL, 1, NULL),
(630, 31, 369, 0, 1, NULL, NULL, NULL, 4, NULL),
(631, 31, 29, 0, 1, NULL, NULL, NULL, 4, NULL),
(632, 31, 380, 0, 1, NULL, NULL, NULL, 4, NULL),
(633, 31, 218, 0, 1, NULL, NULL, NULL, 4, NULL),
(634, 31, 377, 0, 1, NULL, NULL, NULL, 1, NULL),
(635, 31, 345, 0, 1, NULL, NULL, NULL, 4, NULL),
(636, 31, 344, 0, 1, NULL, NULL, NULL, 4, NULL),
(637, 31, 370, 0, 1, NULL, NULL, NULL, 4, NULL),
(638, 31, 71, 0, 1, NULL, NULL, NULL, 4, NULL),
(639, 31, 309, 0, 1, NULL, NULL, NULL, 4, NULL),
(640, 31, 78, 0, 1, NULL, NULL, NULL, 4, NULL),
(641, 31, 13, 0, 1, NULL, NULL, NULL, 4, NULL),
(642, 31, 372, 0, 1, NULL, NULL, NULL, 1, NULL),
(643, 31, 56, 29, 1, 0, NULL, NULL, 4, NULL),
(644, 31, 217, 258, 1, 1, NULL, NULL, 4, NULL),
(645, 31, 371, 0, 1, NULL, NULL, NULL, 1, NULL),
(646, 31, 143, 0, 1, NULL, NULL, NULL, 1, NULL),
(647, 31, 6, 0, 1, NULL, NULL, NULL, 4, NULL),
(648, 31, 34, 0, 1, NULL, NULL, NULL, 1, NULL),
(649, 31, 376, 0, 1, NULL, NULL, NULL, 1, NULL),
(650, 31, 379, 0, 1, NULL, NULL, NULL, 4, NULL),
(651, 31, 386, 0, 1, NULL, NULL, NULL, 2, NULL),
(652, 31, 279, 0, 1, NULL, NULL, NULL, 4, NULL),
(653, 208, 542, 0, 1, NULL, NULL, NULL, NULL, NULL),
(654, 79, 342, 0, 1, NULL, NULL, NULL, NULL, NULL),
(655, 79, 87, 0, 1, NULL, NULL, NULL, NULL, NULL),
(656, 79, 294, 0, 1, NULL, NULL, NULL, NULL, NULL),
(657, 79, 476, 354, 1, 0, NULL, NULL, NULL, NULL),
(658, 182, 253, 0, 2, NULL, NULL, NULL, NULL, NULL),
(659, 103, 347, 0, 1, NULL, NULL, NULL, 12, NULL),
(660, 103, 364, 0, 1, NULL, NULL, NULL, 11, NULL),
(661, 103, 363, 0, 1, NULL, NULL, NULL, 11, NULL),
(662, 103, 171, 0, 1, NULL, NULL, NULL, 10, NULL),
(663, 103, 118, 0, 1, NULL, NULL, NULL, 10, NULL),
(664, 103, 258, 0, 1, NULL, NULL, NULL, NULL, NULL),
(665, 103, 181, 0, 1, NULL, NULL, NULL, 10, NULL),
(666, 103, 357, 0, 1, NULL, NULL, NULL, 11, NULL),
(667, 103, 360, 0, 1, NULL, NULL, NULL, 11, NULL),
(668, 103, 304, 0, 1, NULL, NULL, NULL, 10, NULL),
(669, 103, 356, 375, 1, 0, NULL, NULL, 23, NULL),
(670, 103, 180, 0, 1, NULL, NULL, NULL, NULL, NULL),
(671, 103, 228, 242, 1, 0, NULL, NULL, 11, NULL),
(672, 103, 358, 0, 1, NULL, NULL, NULL, 11, NULL),
(673, 103, 202, 0, 1, NULL, NULL, NULL, NULL, NULL),
(674, 103, 257, 0, 1, NULL, NULL, NULL, NULL, NULL),
(675, 103, 214, 0, 1, NULL, NULL, NULL, 10, NULL),
(676, 103, 362, 369, 1, 0, NULL, NULL, 11, NULL),
(677, 103, 822, 3, 1, 0, NULL, NULL, 11, NULL),
(678, 103, 68, 0, 1, NULL, NULL, NULL, NULL, NULL),
(679, 103, 351, 0, 1, NULL, NULL, NULL, 10, NULL),
(680, 103, 359, 0, 1, NULL, NULL, NULL, 11, NULL),
(681, 103, 352, 0, 1, NULL, NULL, NULL, 10, NULL),
(682, 103, 74, 355, 1, 1, NULL, NULL, 11, NULL),
(683, 103, 172, 0, 1, NULL, NULL, NULL, 10, NULL),
(684, 103, 349, 0, 1, NULL, NULL, NULL, 11, NULL),
(685, 103, 18, 0, 1, NULL, NULL, NULL, 10, NULL),
(686, 103, 367, 0, 1, NULL, NULL, NULL, 10, NULL),
(687, 103, 295, 0, 1, NULL, NULL, NULL, NULL, NULL),
(688, 103, 146, 328, 1, 0, NULL, NULL, 11, NULL),
(690, 103, 346, 0, 1, NULL, NULL, NULL, 11, NULL),
(691, 103, 361, 0, 1, NULL, NULL, NULL, 11, NULL),
(692, 103, 350, 0, 1, NULL, NULL, NULL, 11, NULL),
(693, 103, 348, 0, 1, NULL, NULL, NULL, 11, NULL),
(694, 103, 368, 0, 1, NULL, NULL, NULL, 10, NULL),
(695, 164, 263, 0, 4, NULL, NULL, NULL, NULL, NULL),
(696, 108, 9, 0, 1, NULL, NULL, NULL, NULL, NULL),
(697, 108, 327, 0, 1, NULL, NULL, NULL, NULL, NULL),
(698, 108, 51, 309, 1, 1, NULL, NULL, NULL, 'after [[http://www.itis.gov/servlet/SingleRpt/SingleRpt?search_topic=TSN&search_value=128959 http://www.itis.gov/]]'),
(699, 23, 424, 0, 2, NULL, NULL, NULL, NULL, NULL),
(700, 23, 298, 0, 2, NULL, NULL, NULL, NULL, NULL),
(701, 23, 284, 0, 2, NULL, NULL, NULL, NULL, NULL),
(702, 23, 425, 0, 2, NULL, NULL, NULL, NULL, NULL),
(703, 23, 427, 0, 2, NULL, NULL, NULL, NULL, NULL),
(704, 23, 310, 0, 2, NULL, NULL, NULL, NULL, NULL),
(705, 23, 426, 0, 2, NULL, NULL, NULL, NULL, NULL),
(706, 23, 428, 0, 2, NULL, NULL, NULL, NULL, NULL),
(707, 219, 332, 0, 3, NULL, NULL, NULL, NULL, NULL),
(708, 219, 274, 0, 3, NULL, NULL, NULL, NULL, NULL),
(709, 219, 287, 0, 3, NULL, NULL, NULL, NULL, NULL),
(710, 121, 495, 0, 2, NULL, NULL, NULL, NULL, NULL),
(711, 121, 7, 0, 2, NULL, NULL, NULL, NULL, NULL),
(712, 121, 140, 0, 2, NULL, NULL, NULL, NULL, NULL),
(713, 100, 377, 0, 1, NULL, NULL, NULL, NULL, NULL),
(714, 45, 252, 0, 1, NULL, NULL, NULL, NULL, NULL),
(715, 185, 111, 0, 3, NULL, NULL, NULL, NULL, NULL),
(716, 84, 214, 0, 1, NULL, NULL, NULL, NULL, NULL),
(717, 53, 311, 0, 2, NULL, NULL, NULL, NULL, NULL),
(718, 53, 399, 0, 2, NULL, NULL, NULL, NULL, NULL),
(719, 53, 400, 0, 2, NULL, NULL, NULL, NULL, NULL),
(720, 53, 267, 0, 2, NULL, NULL, NULL, NULL, NULL),
(721, 26, 123, 0, 3, NULL, NULL, NULL, NULL, NULL),
(722, 150, 410, 0, 2, NULL, NULL, NULL, NULL, NULL),
(723, 150, 514, 0, 2, NULL, NULL, NULL, NULL, NULL),
(724, 150, 302, 0, 2, NULL, NULL, NULL, NULL, NULL),
(725, 200, 902, 0, 1, NULL, NULL, NULL, NULL, NULL),
(726, 200, 444, 0, 1, NULL, NULL, NULL, NULL, NULL),
(727, 70, 320, 0, 2, NULL, NULL, NULL, NULL, NULL),
(728, 58, 457, 0, 1, NULL, NULL, NULL, NULL, NULL),
(729, 58, 458, 0, 1, NULL, NULL, NULL, 14, NULL),
(731, 86, 479, 263, 1, 1, NULL, NULL, NULL, NULL),
(733, 86, 77, 0, 1, NULL, NULL, NULL, NULL, NULL),
(734, 86, 212, 0, 1, NULL, NULL, NULL, NULL, NULL),
(737, 65, 466, 0, 1, NULL, NULL, NULL, NULL, NULL),
(738, 65, 469, 0, 1, NULL, NULL, NULL, NULL, NULL),
(739, 65, 468, 0, 1, NULL, NULL, NULL, NULL, NULL),
(740, 65, 473, 0, 1, NULL, NULL, NULL, NULL, NULL),
(741, 65, 457, 0, 1, NULL, NULL, NULL, NULL, NULL),
(742, 65, 353, 0, 1, NULL, NULL, NULL, NULL, NULL),
(743, 65, 269, 0, 1, NULL, NULL, NULL, NULL, NULL),
(744, 65, 471, 0, 1, NULL, NULL, NULL, NULL, NULL),
(745, 65, 470, 0, 1, NULL, NULL, NULL, NULL, NULL),
(746, 65, 467, 0, 1, NULL, NULL, NULL, NULL, NULL),
(747, 65, 472, 0, 1, NULL, NULL, NULL, NULL, NULL),
(748, 41, 446, 0, 1, NULL, NULL, NULL, NULL, NULL),
(749, 239, 406, 0, 2, NULL, NULL, NULL, NULL, NULL),
(750, 239, 285, 0, 2, NULL, NULL, NULL, NULL, NULL),
(751, 29, 106, 0, 1, NULL, NULL, NULL, NULL, NULL),
(752, 29, 14, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1648, 20, 576, 285, 2, 0, 3, NULL, 30, NULL),
(754, 29, 200, 0, 1, NULL, NULL, NULL, NULL, NULL),
(755, 29, 182, 0, 1, NULL, NULL, NULL, NULL, NULL),
(756, 29, 183, 0, 1, NULL, NULL, NULL, NULL, NULL),
(757, 29, 313, 0, 1, NULL, NULL, NULL, NULL, NULL),
(758, 163, 76, 359, 4, 1, NULL, NULL, NULL, NULL),
(1423, 3, 546, 260, 1, 1, NULL, NULL, NULL, NULL),
(1425, 64, 555, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1429, 19, 237, 262, 1, 0, NULL, NULL, NULL, NULL),
(1430, 65, 558, 263, 1, 0, NULL, NULL, NULL, NULL),
(1431, 246, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1432, 246, 579, 272, 2, 0, NULL, NULL, NULL, NULL),
(1433, 79, 580, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1434, 79, 581, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1435, 247, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1436, 247, 111, 275, 4, 1, NULL, NULL, NULL, NULL),
(1437, 247, 79, 277, 4, 1, NULL, NULL, NULL, NULL),
(1438, 247, 582, 276, 4, 1, NULL, NULL, NULL, NULL),
(1439, 250, 726, 0, 2, NULL, 3, NULL, NULL, NULL),
(1440, 250, 192, 0, 2, NULL, 3, NULL, NULL, NULL),
(1441, 59, 735, 0, 2, NULL, 3, NULL, NULL, NULL),
(1442, 1, 5, 0, 1, NULL, NULL, NULL, NULL, 'as Cryptochironomus fuscimanus in Yan and Ye 1977'),
(1443, 251, 192, 0, 2, NULL, 11, NULL, NULL, NULL),
(1444, 119, 742, 393, 2, 0, 11, NULL, NULL, NULL),
(1445, 209, 724, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1446, 20, 737, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1447, 20, 576, 285, 2, 0, NULL, NULL, NULL, NULL),
(1448, 22, 711, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1449, 24, 733, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1450, 33, 592, 272, 2, 1, NULL, NULL, NULL, NULL),
(1451, 22, 714, 0, 2, NULL, 3, NULL, NULL, NULL),
(1452, 34, 720, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1453, 34, 721, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1454, 43, 547, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1455, 44, 734, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1456, 53, 549, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1457, 53, 736, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1458, 53, 563, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1459, 53, 551, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1460, 79, 560, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1461, 86, 562, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1462, 87, 716, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1463, 88, 26, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1464, 88, 606, 471, 2, 1, 11, NULL, NULL, NULL),
(1465, 88, 607, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1466, 88, 608, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1467, 93, 30, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1468, 98, 561, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1469, 98, 260, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1470, 109, 317, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1471, 119, 575, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1472, 121, 7, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1473, 245, 500, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1474, 223, 252, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1475, 227, 569, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1476, 227, 566, 309, 2, 1, NULL, NULL, 15, NULL),
(1477, 227, 564, 337, 2, 0, NULL, NULL, 15, NULL),
(1478, 227, 568, 338, 2, 1, NULL, NULL, 18, NULL),
(1479, 227, 572, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1480, 227, 565, 371, 2, 1, NULL, NULL, 15, NULL),
(1481, 227, 567, 391, 2, 1, NULL, NULL, 19, NULL),
(1482, 227, 573, 339, 2, 1, 3, NULL, 18, NULL),
(1483, 227, 570, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1484, 132, 235, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1485, 132, 578, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1486, 132, 576, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1487, 132, 584, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1488, 225, 32, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1489, 225, 265, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1490, 225, 137, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1491, 147, 80, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1492, 152, 260, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1493, 155, 675, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1494, 160, 130, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1495, 163, 732, 358, 4, 0, NULL, NULL, NULL, NULL),
(1496, 168, 731, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1497, 170, 552, 0, 2, NULL, 11, NULL, NULL, NULL),
(1498, 170, 574, 0, 2, NULL, 11, NULL, NULL, NULL),
(1499, 170, 553, 0, 2, NULL, 11, NULL, NULL, NULL),
(1500, 170, 554, 0, 2, NULL, 11, NULL, NULL, NULL),
(1501, 180, 744, 479, 2, 0, 3, NULL, NULL, NULL),
(1502, 184, 559, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1503, 207, 745, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1505, 103, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1506, 252, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1507, 253, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1510, 33, 595, 0, 2, NULL, 3, NULL, NULL, NULL),
(1512, 33, 753, 0, 2, NULL, 3, NULL, NULL, NULL),
(1513, 33, 591, 0, 2, NULL, 3, NULL, NULL, NULL),
(1514, 33, 755, 0, 2, NULL, 3, NULL, NULL, NULL),
(1515, 33, 754, 0, 2, NULL, 3, NULL, NULL, NULL),
(1516, 158, 757, 0, 2, NULL, 3, NULL, NULL, NULL),
(1517, 227, 628, 272, 2, 1, 3, NULL, 15, NULL),
(1518, 170, 770, 0, 2, NULL, 11, NULL, NULL, NULL),
(1519, 170, 768, 0, 2, NULL, 11, NULL, NULL, NULL),
(1520, 170, 164, 0, 2, NULL, 11, NULL, NULL, NULL),
(1521, 170, 769, 0, 2, NULL, 11, NULL, NULL, NULL),
(1522, 33, 692, 0, 2, NULL, 3, NULL, NULL, NULL),
(1523, 33, 596, 0, 2, NULL, 3, NULL, NULL, NULL),
(1524, 13, 110, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1525, 53, 773, 0, 2, NULL, 3, NULL, NULL, NULL),
(1526, 53, 749, 0, 2, NULL, 3, NULL, NULL, NULL),
(1527, 29, 772, 367, 1, 0, NULL, NULL, NULL, NULL),
(1528, 53, 777, 315, 2, 0, 3, NULL, NULL, NULL),
(1529, 53, 778, 317, 2, 0, 3, NULL, NULL, NULL),
(1530, 224, 261, 0, 2, NULL, 12, NULL, NULL, NULL),
(1531, 224, 427, 0, 2, NULL, 12, NULL, NULL, NULL),
(1532, 224, 781, 0, 2, NULL, 12, NULL, NULL, NULL),
(1533, 104, 261, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1534, 254, 192, 320, 4, 0, NULL, NULL, NULL, NULL),
(1535, 254, 260, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1536, 134, 782, 322, 4, 0, NULL, NULL, NULL, NULL),
(1537, 134, 783, 323, 4, 0, NULL, NULL, NULL, NULL),
(1538, 103, 793, 324, 1, 0, NULL, NULL, 11, NULL),
(1539, 135, 794, 326, 1, 1, NULL, NULL, 9, NULL),
(1540, 33, 593, 328, 2, 0, NULL, NULL, NULL, NULL),
(1541, 2, 363, 330, 3, 0, NULL, NULL, 17, NULL),
(1542, 2, 795, 331, 3, 0, NULL, NULL, 17, NULL),
(1543, 2, 796, 331, 3, 0, NULL, NULL, 17, NULL),
(1544, 2, 797, 332, 3, 0, NULL, NULL, 16, NULL),
(1545, 227, 619, 309, 2, 0, 3, NULL, 18, NULL),
(1546, 227, 622, 341, 2, 0, NULL, NULL, 15, NULL),
(1547, 227, 802, 291, 2, 0, NULL, NULL, 19, NULL),
(1548, 227, 621, 277, 2, 1, NULL, NULL, 15, NULL),
(1549, 227, 636, 342, 2, 0, NULL, NULL, 20, NULL),
(1550, 170, 533, 278, 2, 0, 11, NULL, NULL, NULL),
(1551, 46, 805, 343, 1, 0, NULL, NULL, NULL, NULL),
(1552, 46, 806, 343, 1, 0, NULL, NULL, NULL, NULL),
(1553, 46, 252, 343, 1, 0, NULL, NULL, NULL, NULL),
(1554, 103, 807, 344, 1, 0, NULL, NULL, 11, NULL),
(1555, 93, 808, 345, 1, 0, NULL, NULL, 21, NULL),
(1556, 68, 809, 346, 2, 0, NULL, NULL, NULL, NULL),
(1557, 151, 810, 26, 2, 0, NULL, NULL, NULL, NULL),
(1558, 152, 811, 348, 2, 0, NULL, NULL, NULL, NULL),
(1559, 152, 812, 349, 2, 0, NULL, NULL, NULL, NULL),
(1560, 152, 813, 291, 2, 0, NULL, NULL, NULL, NULL),
(1562, 255, 814, 352, 4, 0, NULL, NULL, NULL, NULL),
(1563, 255, 815, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1564, 255, 192, 351, 4, 0, NULL, NULL, NULL, NULL),
(1565, 37, 260, 356, 2, 0, NULL, NULL, 22, NULL),
(1566, 34, 260, 357, 2, 0, NULL, NULL, NULL, NULL),
(1567, 34, 261, 357, 2, 0, NULL, NULL, NULL, NULL),
(1568, 34, 427, 357, 2, 0, NULL, NULL, NULL, NULL),
(1569, 34, 816, 357, 2, 0, NULL, NULL, NULL, NULL),
(1570, 155, 676, 309, 1, 1, NULL, NULL, NULL, NULL),
(1571, 86, 640, 403, 1, 1, NULL, NULL, NULL, NULL),
(1572, 86, 99, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1573, 86, 818, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1574, 86, 819, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1575, 86, 469, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1576, 142, 220, 276, 1, 1, NULL, NULL, NULL, NULL),
(1577, 46, 820, 362, 1, 0, NULL, NULL, NULL, NULL),
(1579, 46, 611, 364, 1, 0, NULL, NULL, NULL, NULL),
(1580, 46, 33, 366, 1, 1, NULL, NULL, NULL, NULL),
(1581, 46, 821, 363, 1, 1, NULL, NULL, NULL, NULL),
(1582, 122, 174, 371, 1, 1, NULL, NULL, NULL, NULL),
(1583, 122, 200, 20, 1, 0, NULL, NULL, NULL, NULL),
(1584, 122, 202, 20, 1, 0, NULL, NULL, NULL, NULL),
(1585, 103, 222, 372, 1, 0, NULL, NULL, 11, NULL),
(1586, 103, 823, 374, 1, 0, NULL, NULL, 23, NULL),
(1587, 103, 720, 376, 1, 0, NULL, NULL, 23, NULL),
(1588, 103, 824, 374, 1, 0, NULL, NULL, 23, NULL),
(1589, 103, 468, 377, 1, 0, NULL, NULL, 23, NULL),
(1590, 154, 833, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1591, 159, 765, 275, 2, 1, NULL, NULL, NULL, NULL),
(1592, 159, 834, 355, 2, 1, NULL, NULL, NULL, NULL),
(1593, 225, 772, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1594, 225, 263, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1595, 228, 263, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1596, 39, 836, 328, 2, 1, NULL, NULL, NULL, NULL),
(1597, 39, 837, 381, 2, 0, NULL, NULL, NULL, NULL),
(1598, 39, 838, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1599, 256, 192, 0, 2, NULL, 3, NULL, NULL, NULL),
(1600, 220, 841, 383, 3, 1, NULL, NULL, 24, NULL),
(1601, 130, 691, 386, 3, 1, NULL, NULL, 25, NULL),
(1602, 130, 692, 0, 3, NULL, NULL, NULL, 25, NULL),
(1603, 227, 618, 388, 2, 0, NULL, NULL, 18, NULL),
(1604, 227, 857, 0, 2, NULL, NULL, NULL, 18, NULL),
(1605, 119, 698, 328, 2, 1, 11, NULL, NULL, NULL),
(1606, 147, 883, 397, 1, NULL, NULL, NULL, NULL, NULL),
(1607, 257, 192, 400, 2, NULL, NULL, NULL, NULL, NULL),
(1608, 86, 638, 405, 1, 0, NULL, NULL, NULL, NULL),
(1609, 258, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1610, 259, 192, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1611, 260, 192, 0, 5, NULL, NULL, NULL, NULL, NULL),
(1612, 261, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1613, 262, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1614, 262, 114, 413, 1, 0, NULL, NULL, NULL, NULL),
(1615, 264, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1616, 265, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1617, 266, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1618, 267, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1619, 268, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1620, 269, 192, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1621, 270, 192, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1622, 271, 192, 0, 2, NULL, 3, NULL, NULL, NULL),
(1623, 272, 192, 0, 2, NULL, 3, NULL, NULL, NULL),
(1624, 257, 900, 400, 2, 0, 3, NULL, NULL, NULL),
(1625, 53, 746, 309, 2, 1, NULL, NULL, 26, NULL),
(1626, 53, 747, 0, 2, NULL, NULL, NULL, 27, NULL),
(1627, 53, 748, 0, 2, NULL, NULL, NULL, 26, NULL),
(1632, 274, 192, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1633, 274, 921, 0, 4, NULL, NULL, NULL, NULL, 'Goetghebuer, 1934'),
(1634, 38, 922, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1635, 38, 924, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1636, 38, 928, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1637, 38, 927, 436, 4, 0, NULL, NULL, NULL, NULL),
(1638, 86, 8, 315, 1, 1, NULL, NULL, NULL, 'Meigen 1818 not checked for Metriocnemus albolineatus'),
(1639, 90, 177, 276, 2, 1, NULL, NULL, NULL, NULL),
(1640, 254, 827, 441, 4, 1, NULL, NULL, NULL, NULL),
(1641, 254, 825, 441, 4, 1, NULL, NULL, NULL, NULL),
(1642, 254, 792, 364, 4, 1, NULL, NULL, NULL, NULL),
(1643, 103, 729, 432, 1, 0, NULL, NULL, 11, NULL),
(1644, 103, 730, 433, 1, 1, NULL, NULL, 10, NULL),
(1645, 31, 945, 452, 1, 0, NULL, NULL, NULL, NULL),
(1647, 29, 577, 322, 1, NULL, NULL, NULL, NULL, NULL),
(1649, 28, 822, 467, 2, 0, 11, NULL, NULL, NULL),
(1650, 130, 192, 0, 3, NULL, NULL, NULL, 31, NULL),
(1651, 90, 874, 0, 2, NULL, 3, NULL, NULL, NULL),
(1652, 88, 650, 0, 2, NULL, 11, NULL, NULL, NULL),
(1653, 130, 946, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1654, 20, 946, 0, 2, NULL, 3, NULL, NULL, NULL),
(1655, 63, 948, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1657, 64, 86, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1658, 20, 15, 0, 2, NULL, NULL, NULL, 30, NULL),
(1659, 111, 949, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1660, 64, 35, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1661, 104, 950, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1662, 27, 951, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1663, 88, 661, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1664, 170, 882, 0, 2, NULL, 11, NULL, NULL, NULL),
(1666, 170, 870, 0, 2, NULL, 11, NULL, NULL, NULL),
(1667, 2, 758, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1668, 130, 956, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1669, 65, 957, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1670, 39, 940, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1671, 29, 677, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1672, 38, 57, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1673, 38, 958, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1674, 38, 959, 0, 4, NULL, NULL, NULL, NULL, NULL),
(1675, 103, 735, 0, 1, NULL, NULL, NULL, 3, NULL),
(1676, 83, 248, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1677, 125, 139, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1678, 140, 157, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1679, 181, 960, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1680, 194, 913, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1681, 194, 961, 0, 3, NULL, NULL, NULL, NULL, NULL),
(1682, 13, 274, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1683, 20, 27, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1685, 79, 848, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1686, 99, 76, 0, 6, NULL, NULL, NULL, NULL, NULL),
(1687, 107, 953, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1688, 107, 963, 0, 2, NULL, 3, NULL, NULL, NULL),
(1689, 107, 964, 0, 2, NULL, 3, NULL, NULL, NULL),
(1690, 107, 955, 0, 2, NULL, 3, NULL, NULL, NULL),
(1691, 227, 966, 0, 2, NULL, 3, NULL, NULL, NULL),
(1694, 31, 969, 543, 1, 0, NULL, NULL, NULL, NULL),
(1696, 20, 972, 0, 2, NULL, NULL, NULL, NULL, NULL),
(1698, 20, 12, 0, 2, NULL, 3, NULL, 30, NULL),
(1699, 29, 974, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1700, 20, 44, 0, 2, NULL, 3, NULL, 30, NULL),
(1701, 1, 225, 0, 1, NULL, NULL, NULL, NULL, NULL),
(1702, 20, 113, 0, 2, NULL, NULL, NULL, 32, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `users`
--
-- Creation: Dec 15, 2009 at 10:35 AM
-- Last update: Dec 15, 2009 at 10:35 AM
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE IF NOT EXISTS `users` (
  `id` bigint(7) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(40) NOT NULL DEFAULT '',
  `ip` text NOT NULL,
  `mail` varchar(40) NOT NULL DEFAULT '',
  `firstname` varchar(70) NOT NULL DEFAULT '',
  `lastname` varchar(40) NOT NULL DEFAULT '',
  `street` varchar(50) NOT NULL DEFAULT '',
  `zipcode` int(10) unsigned NOT NULL DEFAULT '0',
  `country` varchar(40) NOT NULL DEFAULT '',
  `post_box` varchar(10) DEFAULT NULL,
  `phonenumber` varchar(40) DEFAULT NULL,
  `faxnumber` varchar(40) DEFAULT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `password` varchar(20) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `user` (`username`,`mail`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='user data' AUTO_INCREMENT=2 ;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`id`, `username`, `ip`, `mail`, `firstname`, `lastname`, `street`, `zipcode`, `country`, `post_box`, `phonenumber`, `faxnumber`, `timestamp`, `password`) VALUES
(1, 'Andreas Plank', '::1', 'andreas.plank@web.de', 'Andreas', 'Plank', 'Malteserstr. 74-100', 12249, 'Germany', '', '', '', '2008-03-31 12:18:14', '');
